-- MySQL dump 10.13  Distrib 5.1.66, for unknown-linux-gnu (x86_64)
--
-- Host: localhost    Database: project_j30_magazine_clean
-- ------------------------------------------------------
-- Server version	5.1.66-cll












--
-- Table structure for table `#__assets`
--



CREATE TABLE `#__assets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) unsigned NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_asset_name` (`name`),
  KEY `idx_lft_rgt` (`lft`,`rgt`),
  KEY `idx_parent_id` (`parent_id`)
) ENGINE=InnoDB AUTO_INCREMENT=65 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__assets`
--


INSERT INTO `#__assets` (`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES (1,0,1,127,0,'root.1','Root Asset','{\"core.login.site\":{\"6\":1,\"2\":1},\"core.login.admin\":{\"6\":1},\"core.login.offline\":{\"6\":1},\"core.admin\":{\"8\":1},\"core.manage\":{\"7\":1},\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(2,1,1,2,1,'com_admin','com_admin','{}'),(3,1,3,8,1,'com_banners','com_banners','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(4,1,9,10,1,'com_cache','com_cache','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),(5,1,11,12,1,'com_checkin','com_checkin','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),(6,1,13,14,1,'com_config','com_config','{}'),(7,1,15,22,1,'com_contact','com_contact','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(8,1,23,70,1,'com_content','com_content','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}'),(9,1,71,72,1,'com_cpanel','com_cpanel','{}'),(10,1,73,74,1,'com_installer','com_installer','{\"core.admin\":[],\"core.manage\":{\"7\":0},\"core.delete\":{\"7\":0},\"core.edit.state\":{\"7\":0}}'),(11,1,75,76,1,'com_languages','com_languages','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(12,1,77,78,1,'com_login','com_login','{}'),(13,1,79,80,1,'com_mailto','com_mailto','{}'),(14,1,81,82,1,'com_massmail','com_massmail','{}'),(15,1,83,84,1,'com_media','com_media','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":{\"5\":1}}'),(16,1,85,86,1,'com_menus','com_menus','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(17,1,87,88,1,'com_messages','com_messages','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),(18,1,89,90,1,'com_modules','com_modules','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(19,1,91,98,1,'com_newsfeeds','com_newsfeeds','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(20,1,99,100,1,'com_plugins','com_plugins','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(21,1,101,102,1,'com_redirect','com_redirect','{\"core.admin\":{\"7\":1},\"core.manage\":[]}'),(22,1,103,104,1,'com_search','com_search','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1}}'),(23,1,105,106,1,'com_templates','com_templates','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(24,1,107,110,1,'com_users','com_users','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(25,1,111,118,1,'com_weblinks','com_weblinks','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}'),(26,1,119,120,1,'com_wrapper','com_wrapper','{}'),(27,8,24,31,2,'com_content.category.2','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(28,3,4,5,2,'com_banners.category.3','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(29,7,16,17,2,'com_contact.category.4','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(30,19,92,93,2,'com_newsfeeds.category.5','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(31,25,112,113,2,'com_weblinks.category.6','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(32,24,108,109,1,'com_users.category.7','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(33,1,121,122,1,'com_finder','com_finder','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1}}'),(34,1,123,124,1,'com_joomlaupdate','com_joomlaupdate','{\"core.admin\":[],\"core.manage\":[],\"core.delete\":[],\"core.edit.state\":[]}'),(35,3,6,7,2,'com_banners.category.8','Demo','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(36,7,18,19,2,'com_contact.category.9','Sample category I','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(37,7,20,21,2,'com_contact.category.10','Sample category II','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(38,19,94,95,2,'com_newsfeeds.category.11','GavickPro','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(39,19,96,97,2,'com_newsfeeds.category.12','Joomla!','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(40,25,114,115,2,'com_weblinks.category.13','Joomla Weblink Category','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(41,25,116,117,2,'com_weblinks.category.14','GavickPro','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(42,8,32,45,2,'com_content.category.15','Template articles','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(43,8,46,47,2,'com_content.category.16','Layouts','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(44,8,48,69,2,'com_content.category.17','Demo content','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(45,44,49,52,3,'com_content.category.18','Subcategory I','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(46,44,53,54,3,'com_content.category.19','Subcategory II','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(47,42,33,34,3,'com_content.article.1','Typography','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(48,42,35,36,3,'com_content.article.2','Module positions','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(49,42,37,38,3,'com_content.article.3','Messages','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(50,42,39,40,3,'com_content.article.4','Module variations','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(51,42,41,42,3,'com_content.article.5','Page break example','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(52,42,43,44,3,'com_content.article.6','Page Break','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(53,44,55,56,3,'com_content.article.7','Lorem ipsum I','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(54,44,57,58,3,'com_content.article.8','Lorem ipsum II','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(55,44,59,60,3,'com_content.article.9','Which Windows is right for you?','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(56,44,61,62,3,'com_content.article.10','The New Apple iPad mini, 4th-generation iPad reach the FCC servers','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(57,44,63,64,3,'com_content.article.11','Which are Parents\' Choice to Evaluate Mobile Apps for Children','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(58,45,50,51,4,'com_content.article.12','Lorem ipsum subcategory','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(59,44,65,66,3,'com_content.article.13','MacNotebook Air or Pro on top list','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(60,44,67,68,3,'com_content.article.14','Acer does not do it for less: new S7 ultranotebooks as the best PC','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(61,1,125,126,1,'com_k2','com_k2','{\"core.admin\":[],\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(62,27,25,26,3,'com_content.article.15','Archive article I','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(63,27,27,28,3,'com_content.article.16','Archive article II','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(64,27,29,30,3,'com_content.article.17','Archive article III','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}');


--
-- Table structure for table `#__associations`
--



CREATE TABLE `#__associations` (
  `id` int(11) NOT NULL COMMENT 'A reference to the associated item.',
  `context` varchar(50) NOT NULL COMMENT 'The context of the associated item.',
  `key` char(32) NOT NULL COMMENT 'The key for the association computed from an md5 on associated ids.',
  PRIMARY KEY (`context`,`id`),
  KEY `idx_key` (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__associations`
--




--
-- Table structure for table `#__banner_clients`
--



CREATE TABLE `#__banner_clients` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `contact` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `extrainfo` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `metakey` text NOT NULL,
  `own_prefix` tinyint(4) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__banner_clients`
--




--
-- Table structure for table `#__banner_tracks`
--



CREATE TABLE `#__banner_tracks` (
  `track_date` datetime NOT NULL,
  `track_type` int(10) unsigned NOT NULL,
  `banner_id` int(10) unsigned NOT NULL,
  `count` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`track_date`,`track_type`,`banner_id`),
  KEY `idx_track_date` (`track_date`),
  KEY `idx_track_type` (`track_type`),
  KEY `idx_banner_id` (`banner_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__banner_tracks`
--




--
-- Table structure for table `#__banners`
--



CREATE TABLE `#__banners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `clickurl` varchar(200) NOT NULL DEFAULT '',
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `custombannercode` varchar(2048) NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `params` text NOT NULL,
  `own_prefix` tinyint(1) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reset` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `language` char(7) NOT NULL DEFAULT '',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `idx_state` (`state`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`),
  KEY `idx_banner_catid` (`catid`),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__banners`
--


INSERT INTO `#__banners` (`id`, `cid`, `type`, `name`, `alias`, `imptotal`, `impmade`, `clicks`, `clickurl`, `state`, `catid`, `description`, `custombannercode`, `sticky`, `ordering`, `metakey`, `params`, `own_prefix`, `metakey_prefix`, `purchase_type`, `track_clicks`, `track_impressions`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `reset`, `created`, `language`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `version`) VALUES (1,0,1,'Joomla!','joomla',0,24,0,'',1,3,'','<a href=\"{CLICKURL}\" target=\"_blank\">{NAME}</a>\r\n<br/>\r\nJoomla! The most popular and widely used Open Source CMS Project in the world.',0,1,'','{\"imageurl\":\"\",\"width\":\"\",\"height\":\"\",\"alt\":\"\"}',0,'',-1,0,0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','2012-11-06 11:08:54','*',0,'','0000-00-00 00:00:00',0,1),(2,0,1,'JoomlaCode','joomlacode',0,24,0,'',1,3,'','<a href=\"{CLICKURL}\" target=\"_blank\">{NAME}</a>\r\n<br/>\r\nJoomlaCode, development and distribution made easy.',0,2,'','{\"imageurl\":\"\",\"width\":\"\",\"height\":\"\",\"alt\":\"\"}',0,'',-1,0,0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','2012-11-06 11:09:30','*',0,'','0000-00-00 00:00:00',0,1),(3,0,1,'GavickPro','gavick',0,24,0,'http://gavick.com',1,3,'','<a href=\"{CLICKURL}\" target=\"_blank\">{NAME}</a>\r\n<br/>\r\nThe best Joomla! Templates.',0,3,'','{\"imageurl\":\"\",\"width\":\"\",\"height\":\"\",\"alt\":\"\"}',0,'',-1,0,0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','2012-11-06 11:10:18','*',0,'','0000-00-00 00:00:00',0,1),(4,0,1,'Tools','tools-gavickpro',0,24,0,'http://tools.gavick.com',1,3,'','<a href=\"{CLICKURL}\" target=\"_blank\">{NAME}</a>\r\n<br/>\r\nThe Best Joomla! Extensions',0,4,'','{\"imageurl\":\"\",\"width\":\"\",\"height\":\"\",\"alt\":\"\"}',0,'',-1,0,0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','2012-11-06 11:10:50','*',0,'','0000-00-00 00:00:00',0,1);


--
-- Table structure for table `#__categories`
--



CREATE TABLE `#__categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `extension` varchar(50) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`extension`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB AUTO_INCREMENT=20 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__categories`
--


INSERT INTO `#__categories` (`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`, `version`) VALUES (1,0,0,0,37,0,'','system','ROOT','root','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',42,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),(2,27,1,1,2,1,'uncategorised','com_content','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),(3,28,1,3,4,1,'uncategorised','com_banners','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\",\"foobar\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),(4,29,1,5,6,1,'uncategorised','com_contact','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),(5,30,1,7,8,1,'uncategorised','com_newsfeeds','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),(6,31,1,9,10,1,'uncategorised','com_weblinks','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),(7,32,1,11,12,1,'uncategorised','com_users','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),(8,35,1,13,14,1,'demo','com_banners','Demo','demo','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',381,'2012-11-06 11:07:32',0,'0000-00-00 00:00:00',0,'*',1),(9,36,1,15,16,1,'sample-category-i','com_contact','Sample category I','sample-category-i','','<p>Category description</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',381,'2012-11-06 11:11:59',0,'0000-00-00 00:00:00',0,'*',1),(10,37,1,17,18,1,'sample-category-ii','com_contact','Sample category II','sample-category-ii','','<p>Sample category description</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',381,'2012-11-06 11:12:32',0,'0000-00-00 00:00:00',0,'*',1),(11,38,1,19,20,1,'gavickpro','com_newsfeeds','GavickPro','gavickpro','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',381,'2012-11-06 11:26:39',0,'0000-00-00 00:00:00',0,'*',1),(12,39,1,21,22,1,'joomla','com_newsfeeds','Joomla!','joomla','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',381,'2012-11-06 11:27:05',0,'0000-00-00 00:00:00',0,'*',1),(13,40,1,23,24,1,'joomla-weblink-category','com_weblinks','Joomla Weblink Category','joomla-weblink-category','','<p>Simple category with Joomla links!</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',381,'2012-11-06 11:28:52',0,'0000-00-00 00:00:00',0,'*',1),(14,41,1,25,26,1,'gavick','com_weblinks','GavickPro','gavick','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',381,'2012-11-06 11:29:10',0,'0000-00-00 00:00:00',0,'*',1),(15,42,1,27,28,1,'template','com_content','Template articles','template','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',381,'2012-11-06 11:34:53',0,'0000-00-00 00:00:00',1,'*',1),(16,43,1,29,30,1,'layouts','com_content','Layouts','layouts','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',381,'2012-11-06 11:35:05',0,'0000-00-00 00:00:00',0,'*',1),(17,44,1,31,36,1,'demo-content','com_content','Demo content','demo-content','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut ac augue ac enim interdum interdum ut vitae tellus.</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',381,'2012-11-06 11:35:14',381,'2012-11-07 08:26:45',59,'*',1),(18,45,17,32,33,2,'demo-content/subcategory-i','com_content','Subcategory I','subcategory-i','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',381,'2012-11-06 11:35:34',0,'0000-00-00 00:00:00',0,'*',1),(19,46,17,34,35,2,'demo-content/subcategory-ii','com_content','Subcategory II','subcategory-ii','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',381,'2012-11-06 11:35:47',0,'0000-00-00 00:00:00',0,'*',1);


--
-- Table structure for table `#__contact_details`
--



CREATE TABLE `#__contact_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `con_position` varchar(255) DEFAULT NULL,
  `address` text,
  `suburb` varchar(100) DEFAULT NULL,
  `state` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `postcode` varchar(100) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `misc` mediumtext,
  `image` varchar(255) DEFAULT NULL,
  `email_to` varchar(255) DEFAULT NULL,
  `default_con` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `mobile` varchar(255) NOT NULL DEFAULT '',
  `webpage` varchar(255) NOT NULL DEFAULT '',
  `sortname1` varchar(255) NOT NULL,
  `sortname2` varchar(255) NOT NULL,
  `sortname3` varchar(255) NOT NULL,
  `language` char(7) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__contact_details`
--


INSERT INTO `#__contact_details` (`id`, `name`, `alias`, `con_position`, `address`, `suburb`, `state`, `country`, `postcode`, `telephone`, `fax`, `misc`, `image`, `email_to`, `default_con`, `published`, `checked_out`, `checked_out_time`, `ordering`, `params`, `user_id`, `catid`, `access`, `mobile`, `webpage`, `sortname1`, `sortname2`, `sortname3`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`, `version`, `hits`) VALUES (1,'ERIK Curd','erik-curd','','3635 Willie Green Rd\r\nLondon, KY(Kentucky) 40741-9233\r\n(606) 877-1749','','UK','','','','','','images/robert_2.jpg','test@test.com',0,1,0,'0000-00-00 00:00:00',1,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":null,\"linkb_name\":\"\",\"linkb\":null,\"linkc_name\":\"\",\"linkc\":null,\"linkd_name\":\"\",\"linkd\":null,\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}',0,10,1,'','','','','','*','2012-11-06 11:24:01',381,'','2013-02-05 15:33:16',572,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00',4,0),(2,'Our address','our-address','','B.S. Sound 25 Cromwell St, Glen Iris\r\n','Victoria','','Australia','00-000,','+49 5241 80-0 00','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam eget nisl eros. Suspendisse non sem leo. Suspendisse aliquet eros in erat commodo porttitor. Nam et tortor non enim ornare varius sit amet sed turpis.</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam eget nisl eros. Suspendisse non sem leo. Suspendisse aliquet eros in erat commodo porttitor. Nam et tortor non enim ornare varius sit amet sed turpis.</p>','','sample@mail.com',0,1,0,'0000-00-00 00:00:00',2,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":null,\"linkb_name\":\"\",\"linkb\":null,\"linkc_name\":\"\",\"linkc\":null,\"linkd_name\":\"\",\"linkd\":null,\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}',0,9,1,'','','','','','*','2012-11-06 11:25:46',381,'','0000-00-00 00:00:00',0,'','','{\"robots\":\"\",\"rights\":\"\"}',1,'','0000-00-00 00:00:00','0000-00-00 00:00:00',1,0);


--
-- Table structure for table `#__content`
--



CREATE TABLE `#__content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `attribs` varchar(5120) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `language` char(7) NOT NULL COMMENT 'The language code for the article.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=InnoDB AUTO_INCREMENT=18 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__content`
--


INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES (1,47,'Typography','typography','<p>It is possible with templates which have a typography page to show you how you can use e.g. headline tags in order to structure your content in a better way. Below, we present rebuilt and refreshed typographical aspects of Gavern Framework. In order to use it, you have to use a plug in which is delivered in a package with a template or use HTML code.</p>\r\n<div id=\"warnings\" class=\"demo-typoDiv typoDesc\">\r\n<h4 class=\"demo-typo\">Warnings</h4>\r\n<p class=\"gkInfo1\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum venenatis orci non tortor accumsan...</p>\r\n<p class=\"gkTips1\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum venenatis orci non tortor accumsan...</p>\r\n<p class=\"gkWarning1\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum venenatis orci non tortor accumsan...</p>\r\n</div>\r\n<div class=\"demo-typoDiv\">\r\n<h4 class=\"demo-typo\">Headings</h4>\r\n<div class=\"demo-typo_padd\">\r\n<h1>This is heading 1</h1>\r\n<h2>This is heading 2</h2>\r\n<h3>This is heading 3</h3>\r\n<h4>This is heading 4</h4>\r\n<h5>This is heading 5</h5>\r\n<h6>This is heading 6</h6>\r\n</div>\r\n</div>\r\n<div class=\"demo-typoDiv typoDesc\">\r\n<h4 class=\"demo-typo\">Icon set</h4>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<p class=\"gklink\"><strong>gklink</strong> message <br /> <small>Use &lt;p class=\"gklink\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkinfo\"><strong>gkinfo</strong> message <br /> <small>Use &lt;p class=\"gkinfo\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkpin\"><strong>gkpin</strong> message <br /> <small>Use &lt;p class=\"gkpin\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkfile1\"><strong>file1</strong> message <br /> <small>Use &lt;p class=\"gkfile1\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkfile2\"><strong>kfile2</strong> message <br /> <small>Use &lt;p class=\"gkfile2\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gksettings\"><strong>gksettings</strong> message <br /> <small>Use &lt;p class=\"gksettings\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<p class=\"gkmic\"><strong>gkmic</strong> message <br /> <small>Use &lt;p class=\"gkmic\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkvideo\"><strong>gkvideo</strong> message <br /> <small>Use &lt;p class=\"gkvideo\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkvoice\"><strong>gkvoice</strong> message <br /> <small>Use &lt;p class=\"gkvoice\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gklocked\"><strong>gklocked</strong> message <br /> <small>Use &lt;p class=\"gklocked\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkunlocked\"><strong>gkunlocked</strong> message <br /> <small>Use &lt;p class=\"gkunlocked\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkstats\"><strong>stats</strong> message <br /> <small>Use &lt;p class=\"gkstats\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<p class=\"gklocation\"><strong>location</strong> message <br /> <small>Use &lt;p class=\"gklocation\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkmap\"><strong>map</strong> message <br /> <small>Use &lt;p class=\"gkmap\"&gt;Txt...!&lt;/p&gt;</small>.</p>\r\n<p class=\"gktag\"><strong>tag</strong> message <br /> <small>Use &lt;p class=\"gktag\"&gt;Txt...!&lt;/p&gt;</small>.</p>\r\n<p class=\"gkcomment\"><strong>gkcomment</strong> message <br /> <small>Use &lt;p class=\"gkcomment\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkbook\"><strong>book</strong> message <br /> <small>Use &lt;p class=\"gkbook\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkalarm\"><strong>gkalarm</strong> message <br /> <small>Use &lt;p class=\"gkalarm\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typoDiv typoDesc \">\r\n<h4 class=\"demo-typo\">Highlights</h4>\r\n<div class=\"demo-typo-col2\">\r\n<div class=\"demo-typo_padd\">\r\n<p>This is a <span class=\"gkHighlight1\">highlight phrase</span>. <br /> <small>Use &lt;span class=\"gkHighlight1\"&gt;Your highlight phrase goes here!&lt;/span&gt;</small>.</p>\r\n<p>This is a <span class=\"gkHighlight2\">highlight phrase</span>. <br /> <small>Use &lt;span class=\"gkHighlight2\"&gt;Your highlight phrase goes here!&lt;/span&gt;</small>.</p>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col2\">\r\n<div class=\"demo-typo_padd\">\r\n<p>This is a <span class=\"gkHighlight3\">highlight phrase</span>. <br /> <small>Use &lt;span class=\"gkHighlight3\"&gt;Your highlight phrase goes here!&lt;/span&gt;</small>.</p>\r\n<p>This is a <span class=\"gkHighlight4\">highlight phrase</span>.<br /> <small>Use &lt;span class=\"gkHighlight4\"&gt;Your highlight phrase goes here!&lt;/span&gt;</small>.</p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typoDiv typoDesc\">\r\n<h4 class=\"demo-typo\">Code</h4>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<pre>#wrapper {<br />  position: relative;<br />  float: left;<br />  display: block;<br />}<br />\r\n</pre>\r\n<p><small>Use &lt;pre&gt; or &lt;div class=\"gkCode1\"&gt;Here goes your code&lt;/div&gt;</small></p>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<div class=\"gkCode2\">#wrapper {<br /> position: relative;<br /> float: left;<br /> display: block;<br /> }</div>\r\n<p><small>Use &lt;div class=\"gkCode2\"&gt;Here goes your code&lt;/div&gt;</small></p>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<div class=\"gkCode3\">\r\n<h4>File</h4>\r\n#wrapper {<br /> position: relative;<br /> float: left;<br /> display: block;<br /> }</div>\r\n<p><small>Use &lt;div class=\"gkCode3\"&gt;&lt;h4&gt;Name of your file&lt;/h4&gt;Here goes your code&lt;/div&gt;</small></p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typoDiv typoDesc\">\r\n<h4 class=\"demo-typo\">Unordered lists</h4>\r\n<div class=\"demo-typo-col4\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;ul class=\"gkBullet1\"&gt;</small></p>\r\n<ul class=\"gkBullet1\">\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col4\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;ul class=\"gkBullet2\"&gt;</small></p>\r\n<ul class=\"gkBullet2\">\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col4\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;ul class=\"gkBullet3\"&gt;</small></p>\r\n<ul class=\"gkBullet3\">\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col4\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;ul class=\"gkBullet4\"&gt;</small></p>\r\n<ul class=\"gkBullet4\">\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typoDiv typoDesc\">\r\n<h4 class=\"demo-typo\">numBlocks</h4>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;p class=\"numblocks num-1\"&gt;&lt;span&gt;here goes a number&lt;/span&gt;and here text of element&lt;/p&gt;</small></p>\r\n<p class=\"numblocks num-1\"><span>01</span> Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>\r\n<p class=\"numblocks num-1\"><span>02</span> Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;p class=\"numblocks num-2\"&gt;&lt;span&gt;here goes a number&lt;/span&gt;and here text of element&lt;/p&gt;</small></p>\r\n<p class=\"numblocks num-2\"><span>01</span> Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>\r\n<p class=\"numblocks num-2\"><span>02</span> Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;p class=\"numblocks num-3\"&gt;&lt;span&gt;here goes a number&lt;/span&gt;and here text of element&lt;/p&gt;</small></p>\r\n<p class=\"numblocks num-3\"><span>01</span> Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>\r\n<p class=\"numblocks num-3\"><span>02</span> Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typoDiv demo-typo-col2 typoDesc\">\r\n<div class=\"demo-typo_padd\">\r\n<h4 class=\"demo-typo\">Blocks</h4>\r\n<div class=\"gkblock-1\">Lorem ipsum dolor sit amet, consectetuer adipiscing.\r\n<p><small> Use &lt;div class=\"gkblock-1\"&gt;content here... &lt;/div&gt;</small></p>\r\n</div>\r\n<div class=\"gkblock-2\">Lorem ipsum dolor sit amet, consectetuer adipiscing.\r\n<p><small> Use &lt;div class=\"gkblock-2\"&gt;content here... &lt;/div&gt;</small></p>\r\n</div>\r\n<div class=\"gkblock-3\">Lorem ipsum dolor sit amet, consectetuer adipiscing.\r\n<p><small> Use &lt;div class=\"gkblock-3\"&gt;content here... &lt;/div&gt;</small></p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col2 typoDesc\">\r\n<div class=\"demo-typo_padd\">\r\n<h4 class=\"demo-typo\">Legends</h4>\r\n<div class=\"gkLegend1\">\r\n<h4>Legend</h4>\r\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit.</p>\r\n<p><small> Use &lt;div class=\"gkLegend1\"&gt; &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;and here text.&lt;/p&gt; &lt;/div&gt;</small></p>\r\n</div>\r\n<h4 class=\"demo-typo\">Bubbles</h4>\r\n<div class=\"bubble-1\">Lorem ipsum dolor sit amet, consectetuer adipiscing.\r\n<p><small>Use &lt;div class=\"bubble-1\"&gt;content here... &lt;cite&gt;Author name&lt;/cite&gt;&lt;/div&gt;</small></p>\r\n<cite>Robert Gavick</cite></div>\r\n<div class=\"bubble-2\">Lorem ipsum dolor sit amet, consectetuer adipiscing.\r\n<p><small>Use &lt;div class=\"bubble-2\"&gt;content here... &lt;cite&gt;Author name&lt;/cite&gt;&lt;/div&gt;</small></p>\r\n<cite>Robert Gavick</cite></div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typoDiv typoDesc\">\r\n<h4 class=\"demo-typo\">Blockquotes</h4>\r\n<div class=\"demo-typo-col2\">\r\n<div class=\"demo-typo_padd\">\r\n<blockquote>\r\n<div class=\"gkBlockquote1\">\r\n<div>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam rutrum blandit purus, vitae pharetra odio interdum sit amet.\r\n<p><small>Use &lt; blockquote&gt;&lt;div class=\"gkBlockquote1\"&gt;&lt;div&gt; Your quoted text goes here!&lt; /div&gt;&lt; /div&gt;&lt; /blockquote &gt;</small></p>\r\n</div>\r\n</div>\r\n</blockquote>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col2\">\r\n<div class=\"demo-typo_padd\">\r\n<blockquote>\r\n<div class=\"gkBlockquote2\">\r\n<div>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam rutrum blandit purus, vitae pharetra odio interdum sit amet.\r\n<p><small>Use &lt; blockquote&gt;&lt;div class=\"gkBlockquote2\"&gt;&lt;div&gt; Your quoted text goes here!&lt; /div&gt;&lt; /div&gt;&lt; /blockquote &gt;</small></p>\r\n</div>\r\n</div>\r\n</blockquote>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col2\">\r\n<div class=\"demo-typo_padd\">\r\n<blockquote>\r\n<div class=\"gkBlockquote3\">\r\n<div>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam rutrum blandit purus, vitae pharetra odio interdum sit amet.\r\n<p><small>Use &lt; blockquote&gt;&lt;div class=\"gkBlockquote3\"&gt;&lt;div&gt; Your quoted text goes here!&lt; /div&gt;&lt; /div&gt;&lt; /blockquote &gt;</small></p>\r\n</div>\r\n</div>\r\n</blockquote>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col2\">\r\n<div class=\"demo-typo_padd\">\r\n<blockquote>\r\n<div class=\"gkBlockquote4\">\r\n<div>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam rutrum blandit purus, vitae pharetra odio interdum sit amet.\r\n<p><small>Use &lt; blockquote&gt;&lt;div class=\"gkBlockquote4\"&gt;&lt;div&gt; Your quoted text goes here!&lt; /div&gt;&lt; /div&gt;&lt; /blockquote &gt;</small></p>\r\n</div>\r\n</div>\r\n</blockquote>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typoDiv typoDesc\">\r\n<h4 class=\"demo-typo\">Floated blocks</h4>\r\n<p><small>&lt;p&gt; Here goes main part of the text &lt;span class=\"gkBlockTextLeft\"&gt;Block of text&lt;/span&gt;rest of the text&lt;/p&gt; </small></p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend.<span class=\"gkBlockTextLeft\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue.</span>Donec eget dignissim augue. Donec ante felis, aliquam ut consequat eget, lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit. Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris lacinia eros, sed tempus leo lorem vitae purus.</p>\r\n<br /> <br />\r\n<p><small>&lt;p&gt; Here goes main part of the text &lt;span class=\"gkBlockTextRight\"&gt;Block of text&lt;/span&gt;rest of the text&lt;/p&gt; </small></p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend.<span class=\"gkBlockTextRight\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue.</span>Donec eget dignissim augue. Donec ante felis, aliquam ut consequat eget, lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit. Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris lacinia eros, sed tempus leo lorem vitae purus.</p>\r\n<br /> <br />\r\n<p><small>&lt;p&gt; Here goes main part of the text &lt;span class=\"gkBlockTextCenter\"&gt;Block of text&lt;/span&gt;rest of the text&lt;/p&gt; </small></p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend.<span class=\"gkBlockTextCenter\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue.</span>Donec eget dignissim augue. Donec ante felis, aliquam ut consequat eget, lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit. Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris lacinia eros, sed tempus leo lorem vitae purus. Nunc a malesuada felis. Cras ultrices sapien eu nisi elementum non blandit urna sodales.</p>\r\n</div>\r\n<h3>Special template typography elements</h3>\r\n<h4>Social icons</h4>\r\n<pre>&lt;a class=\"gkFb\" href=\"#\"&gt;Facebook&lt;/a&gt; \r\n&lt;a class=\"gkTwitter\" href=\"#\"&gt;Twitter&lt;/a&gt; \r\n&lt;a class=\"gkGplus\" href=\"#\"&gt;Google+&lt;/a&gt; \r\n&lt;a class=\"gkPinterest\" href=\"#\"&gt;Pinterest&lt;/a&gt;\r\n</pre>','',1,15,'2012-11-06 11:55:52',572,'','2013-02-04 07:30:51',572,0,'0000-00-00 00:00:00','2012-11-06 11:55:52','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"info_block_position\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_icons\":\"\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_vote\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',6,5,'','',1,16,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(2,48,'Module positions','module-positions','<p style=\"margin: 0 auto;\"><img src=\"images/demo/module_positions.png\" border=\"0\" alt=\"\" /></p>','',1,15,'2012-11-06 11:57:47',572,'','2013-02-04 07:32:00',572,0,'0000-00-00 00:00:00','2012-12-31 11:19:14','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',4,4,'','',1,6,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(3,49,'Messages','messages','<p>Joomla! offers three different types of messages. Creatings standard information about Joomla! system is presented depending on a message type as follows:</p>\r\n<p style=\"margin: 43px 0 0;\"> </p>\r\n<dl id=\"system-message\"><dt class=\"error\">Error</dt><dd class=\"message message fade\">\r\n<ul>\r\n<li>This is a sample message</li>\r\n</ul>\r\n</dd></dl><dl id=\"system-message\"><dt class=\"error\">Error</dt><dd class=\"notice message fade\">\r\n<ul>\r\n<li>This is a sample of notice message</li>\r\n</ul>\r\n</dd></dl><dl id=\"system-message\"><dt class=\"error\">Error</dt><dd class=\"error message fade\">\r\n<ul>\r\n<li>This is a sample of error message</li>\r\n</ul>\r\n</dd></dl>','',1,15,'2012-11-06 11:58:38',572,'','2013-01-03 11:50:40',572,0,'0000-00-00 00:00:00','2012-11-06 11:58:38','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"0\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,3,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(4,50,'Module variations','module-variations','<p>On this page you can see basic suffixes used in this template.</p>\r\n<p class=\"numblocks num-3\"><span>01</span>For the modules used on the <strong>top1-2</strong> and <strong>bottom1-2</strong> module positions we recommened to use only default module styles.</p>\r\n<p class=\"numblocks num-3\"><span>02</span>The <strong>clear</strong> suffix is very useful to create banners or images without additional borders, margins and paddings. The clear suffix is also very useful inside the <strong>mainbody</strong>, <strong>mainbody_top</strong> and <strong>mainbody_bottom</strong> module positions.</p>\r\n<p class=\"numblocks num-3\"><span>03</span>If you want to remove the top border from module in the <strong>Inset</strong> or <strong>Sidebar</strong> module position - please use the <strong>noborder</strong> suffix.</p>\r\n<p class=\"numblocks num-3\"><span>04</span>For NSP modules embed in the Tabs GK5 module, we recommend to add the <strong>mobilelayout</strong> suffix - it will help to better use blank spaces on the mobile devices.</p>\r\n<p class=\"numblocks num-3\"><span>05</span>The News Show Pro module has additional suffixes: <strong>nsphover</strong> - this suffix creates a NSP module with nice hover animation, <strong>headlines</strong> - this suffix is very usefull to create a nice arrow over the title on hover effect.</p>','',1,15,'2012-11-06 11:59:24',572,'','2013-02-07 11:34:16',572,0,'0000-00-00 00:00:00','2012-11-06 11:59:24','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"0\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',4,2,'','',1,26,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(5,51,'Page break example','page-break-example','<p>Ut dignissim aliquet nibh tristique hendrerit. Donec ullamcorper nulla quis metus vulputate id placerat augue eleifend. Aenean venenatis consectetur orci, sit amet ultricies magna sagittis vel. Nulla non diam nisi, ut ultrices massa. Pellentesque sed nisl metus. Praesent a mi vel ante molestie venenatis.</p>\r\n<p>Donec sed odio dui. Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Donec id elit non mi porta gravida at eget metus. Etiam porta sem malesuada magna mollis euismod. Cras justo odio, dapibus ac facilisis in, egestas eget quam.</p>\r\n<p>Mauris justo metus, ultrices id lobortis et, euismod sit amet metus. Maecenas sed nisl a arcu ultricies consectetur. Integer ut mollis elit. Nulla ultrices scelerisque mauris id commodo. Integer congue lectus et justo pellentesque sed semper lacus facilisis. Nunc tristique placerat odio eget rutrum.</p>\r\n','\r\n<p>Ut viverra erat id augue bibendum rutrum. Nam aliquet feugiat molestie. Maecenas tempus scelerisque tellus eu mattis. Aliquam dignissim aliquam posuere. Sed dignissim, ipsum sed sodales aliquam, erat dolor varius eros, in semper sem metus vel metus. Nullam est mauris, laoreet condimentum hendrerit et, euismod quis dolor. Nunc eleifend lacinia libero eget scelerisque. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae.</p>\r\n<p>Nulla vitae elit libero, a pharetra augue. Donec ullamcorper nulla non metus auctor fringilla. Nulla vitae elit libero, a pharetra augue. Aenean lacinia bibendum nulla sed consectetur. Donec id elit non mi porta gravida at eget metus.</p>\r\n<p>Vivamus eget est urna. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Vivamus mauris justo, fermentum quis mattis vel, auctor vitae metus. Maecenas non dolor ac risus faucibus luctus non id turpis. Morbi ante nibh, suscipit non adipiscing in, ornare in ipsum.</p>\r\n<hr title=\"First Page\" alt=\"first-page\" class=\"system-pagebreak\" />\r\n<p>Nullam ac odio orci, sed pretium velit. Integer sit amet justo faucibus lorem imperdiet sagittis. Proin egestas, risus in faucibus sodales, tortor turpis feugiat risus, varius laoreet dui turpis ac dolor. Nullam suscipit fringilla augue non rhoncus. Nullam ac nibh eu ipsum tristique ullamcorper. Nunc porttitor lorem id orci dapibus lacinia. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas.</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed posuere consectetur est at lobortis. Vestibulum id ligula porta felis euismod semper. Donec id elit non mi porta gravida at eget metus. Integer posuere erat a ante venenatis dapibus posuere velit aliquet.</p>\r\n<p>Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Maecenas sed diam eget risus varius blandit sit amet non magna. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>\r\n<hr title=\"Second Page\" alt=\"second-page\" class=\"system-pagebreak\" />\r\n<p>Donec sed odio dui. Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Donec id elit non mi porta gravida at eget metus. Etiam porta sem malesuada magna mollis euismod. Cras justo odio, dapibus ac facilisis in, egestas eget quam.</p>\r\n<p>Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Maecenas sed diam eget risus varius blandit sit amet non magna. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed posuere consectetur est at lobortis. Vestibulum id ligula porta felis euismod semper. Donec id elit non mi porta gravida at eget metus. Integer posuere erat a ante venenatis dapibus posuere velit aliquet.</p>\r\n<p>Nulla vitae elit libero, a pharetra augue. Donec ullamcorper nulla non metus auctor fringilla. Nulla vitae elit libero, a pharetra augue. Aenean lacinia bibendum nulla sed consectetur. Donec id elit non mi porta gravida at eget metus.</p>\r\n<hr title=\"Third Page\" alt=\"third-page\" class=\"system-pagebreak\" />\r\n<p>Maecenas faucibus mollis interdum. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Donec id elit non mi porta gravida at eget metus. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Praesent commodo cursus magna, vel scelerisque nisl consectetur et.</p>\r\n<p>Fusce id enim id erat sodales auctor. Duis tortor nisl, condimentum vel feugiat vel, venenatis ut dolor. Donec interdum ornare ligula, vitae adipiscing diam imperdiet at. Donec facilisis, nunc sit amet ultricies adipiscing, ligula justo congue lectus, sit amet vehicula enim lorem in neque. In ultrices bibendum justo ac vehicula. Nam tincidunt blandit consequat.</p>\r\n<p>Vestibulum id ligula porta felis euismod semper. Cras justo odio, dapibus ac facilisis in, egestas eget quam. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Donec id elit non mi porta gravida at eget metus.</p>\r\n<hr title=\"Fourth Page\" alt=\"fourth-page\" class=\"system-pagebreak\" />\r\n<p>Nullam quis risus eget urna mollis ornare vel eu leo. Sed posuere consectetur est at lobortis. Aenean lacinia bibendum nulla sed consectetur. Maecenas sed diam eget risus varius blandit sit amet non magna. Etiam porta sem malesuada magna mollis euismod.</p>\r\n<p>Nullam quis risus eget urna mollis ornare vel eu leo. Donec id elit non mi porta gravida at eget metus. Aenean lacinia bibendum nulla sed consectetur.</p>\r\n<p>Vestibulum id ligula porta felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus. Cras justo odio, dapibus ac facilisis in, egestas eget quam.</p>',1,15,'2012-11-06 12:02:31',572,'','2013-01-03 11:47:52',572,0,'0000-00-00 00:00:00','2012-11-06 12:02:31','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,1,'','',1,35,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(6,52,'Page Break','page-break','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin posuere nisi quis odio egestas non tempus est sollicitudin. Nulla facilisi. Pellentesque tempus suscipit nulla sed tempor. Phasellus et lorem id libero fermentum molestie sit amet sit amet mi. Quisque ultrices, neque et laoreet dictum, arcu sapien pulvinar odio, in aliquam mi dui eu leo. Nullam posuere, arcu et egestas fermentum, enim purus fermentum diam, quis porta mauris lectus ut odio. In tincidunt dapibus malesuada. Integer a lorem ligula. In tincidunt augue eget velit convallis nec pharetra eros tincidunt. Maecenas et tortor libero, vel malesuada est.</p>\r\n<p>Quisque magna tellus, condimentum a porttitor eu, fermentum nec enim. Aenean et erat nec lectus adipiscing auctor. Sed tellus sapien, condimentum eget tristique ac, faucibus sed nisi. Curabitur pretium porta pulvinar. Integer cursus venenatis dictum. Morbi massa est, ultricies ut ultrices vitae, hendrerit vitae tellus. Duis a nulla quis tellus lacinia tristique.</p>\r\n<hr title=\"Page 1\" alt=\"page1\" class=\"system-pagebreak\" />\r\n<p>Donec libero urna, cursus vitae sollicitudin sit amet, elementum et massa. Donec feugiat, turpis a dictum vulputate, dui diam faucibus nunc, ac sodales augue magna id augue. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Donec sit amet nisi felis. Morbi faucibus nunc id elit aliquam ac condimentum leo laoreet. Sed nec risus sed nulla mattis volutpat in eget diam. In leo nisl, eleifend vel lobortis vel, tincidunt a ligula. Nulla placerat gravida laoreet. In lobortis, ligula in sagittis pellentesque, orci magna venenatis neque, eu sagittis lacus ante et tellus. Morbi vel semper augue. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam erat volutpat.</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin posuere nisi quis odio egestas non tempus est sollicitudin. Nulla facilisi. Pellentesque tempus suscipit nulla sed tempor. Phasellus et lorem id libero fermentum molestie sit amet sit amet mi. Quisque ultrices, neque et laoreet dictum, arcu sapien pulvinar odio, in aliquam mi dui eu leo. Nullam posuere, arcu et egestas fermentum, enim purus fermentum diam, quis porta mauris lectus ut odio. In tincidunt dapibus malesuada. Integer a lorem ligula. In tincidunt augue eget velit convallis nec pharetra eros tincidunt. Maecenas et tortor libero, vel malesuada est.</p>\r\n<hr title=\"Page 2\" alt=\"page2\" class=\"system-pagebreak\" />\r\n<p>Quisque magna tellus, condimentum a porttitor eu, fermentum nec enim. Aenean et erat nec lectus adipiscing auctor. Sed tellus sapien, condimentum eget tristique ac, faucibus sed nisi. Curabitur pretium porta pulvinar. Integer cursus venenatis dictum. Morbi massa est, ultricies ut ultrices vitae, hendrerit vitae tellus. Duis a nulla quis tellus lacinia tristique.</p>\r\n<p>Donec libero urna, cursus vitae sollicitudin sit amet, elementum et massa. Donec feugiat, turpis a dictum vulputate, dui diam faucibus nunc, ac sodales augue magna id augue. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Donec sit amet nisi felis. Morbi faucibus nunc id elit aliquam ac condimentum leo laoreet. Sed nec risus sed nulla mattis volutpat in eget diam. In leo nisl, eleifend vel lobortis vel, tincidunt a ligula. Nulla placerat gravida laoreet. In lobortis, ligula in sagittis pellentesque, orci magna venenatis neque, eu sagittis lacus ante et tellus. Morbi vel semper augue. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam erat volutpat.</p>','',1,15,'2012-11-06 12:03:12',572,'','2013-01-03 11:51:24',572,0,'0000-00-00 00:00:00','2012-11-06 12:03:12','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(7,53,'Lorem ipsum I','lorem-ipsum-i','<p>Donec sed odio dui. Etiam porta sem malesuada magna mollis euismod. Sed posuere consectetur est at lobortis. </p>\r\n<p>Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. </p>\r\n<p>Vestibulum id ligula porta felis euismod semper. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Nulla vitae elit libero, a pharetra augue. </p>\r\n','\r\n<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vestibulum id ligula porta felis euismod semper. Cras mattis consectetur purus sit amet fermentum. Vestibulum id ligula porta felis euismod semper. Nullam quis risus eget urna mollis ornare vel eu leo. Lorem ipsum dolor sit amet, consectetur adipiscing elit. </p>\r\n<p>Maecenas faucibus mollis interdum. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Sed posuere consectetur est at lobortis. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Cras mattis consectetur purus sit amet fermentum. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Maecenas faucibus mollis interdum. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Sed posuere consectetur est at lobortis. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Etiam porta sem malesuada magna mollis euismod. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>',1,17,'2012-11-06 12:07:56',572,'','2013-01-03 11:50:00',572,0,'0000-00-00 00:00:00','2012-11-06 12:07:56','0000-00-00 00:00:00','{\"image_intro\":\"images\\/demo\\/blank_medium.png\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/demo\\/blank_big.png\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,7,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(8,54,'Lorem ipsum II','lorem-ipsum-ii','<p>Donec sed odio dui. Etiam porta sem malesuada magna mollis euismod. Sed posuere consectetur est at lobortis. </p>\r\n<p>Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. </p>\r\n<p>Vestibulum id ligula porta felis euismod semper. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Nulla vitae elit libero, a pharetra augue. </p>\r\n','\r\n<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vestibulum id ligula porta felis euismod semper. Cras mattis consectetur purus sit amet fermentum. Vestibulum id ligula porta felis euismod semper. Nullam quis risus eget urna mollis ornare vel eu leo. Lorem ipsum dolor sit amet, consectetur adipiscing elit. </p>\r\n<p>Maecenas faucibus mollis interdum. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Sed posuere consectetur est at lobortis. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Cras mattis consectetur purus sit amet fermentum. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Maecenas faucibus mollis interdum. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Sed posuere consectetur est at lobortis. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Etiam porta sem malesuada magna mollis euismod. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>',1,17,'2012-11-06 12:09:31',572,'','2013-01-03 11:50:13',572,0,'0000-00-00 00:00:00','2012-11-06 12:09:31','0000-00-00 00:00:00','{\"image_intro\":\"images\\/demo\\/blank_medium.png\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/demo\\/blank_big.png\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,6,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(9,55,'Which Windows is right for you?','which-windows-is-right-for-you','<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi.</p>\r\n','\r\n<p>Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. </p>\r\n<p>Vestibulum id ligula porta felis euismod semper. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Nulla vitae elit libero, a pharetra augue.</p>\r\n<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vestibulum id ligula porta felis euismod semper. Cras mattis consectetur purus sit amet fermentum. Vestibulum id ligula porta felis euismod semper. Nullam quis risus eget urna mollis ornare vel eu leo. Lorem ipsum dolor sit amet, consectetur adipiscing elit. </p>\r\n<p>Maecenas faucibus mollis interdum. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Sed posuere consectetur est at lobortis. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Cras mattis consectetur purus sit amet fermentum. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Maecenas faucibus mollis interdum. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Sed posuere consectetur est at lobortis. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Etiam porta sem malesuada magna mollis euismod. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>',1,17,'2012-11-06 12:10:54',572,'','2013-02-07 12:06:03',572,0,'0000-00-00 00:00:00','2012-11-06 12:10:54','0000-00-00 00:00:00','{\"image_intro\":\"images\\/demo\\/magazine_blog_2.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/demo\\/magazine_blog_2.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',5,4,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(10,56,'The New Apple iPad mini, 4th-generation iPad reach the FCC servers','the-new-apple-ipad-mini-4th-generation-ipad-reach-the-fcc-servers','<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula. </p>\r\n','\r\n<p>Vestibulum id ligula porta felis euismod semper. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Nulla vitae elit libero, a pharetra augue. </p>\r\n<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vestibulum id ligula porta felis euismod semper. Cras mattis consectetur purus sit amet fermentum. Vestibulum id ligula porta felis euismod semper. Nullam quis risus eget urna mollis ornare vel eu leo. Lorem ipsum dolor sit amet, consectetur adipiscing elit. </p>\r\n<p>Maecenas faucibus mollis interdum. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Sed posuere consectetur est at lobortis. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Cras mattis consectetur purus sit amet fermentum. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Maecenas faucibus mollis interdum. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Sed posuere consectetur est at lobortis. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Etiam porta sem malesuada magna mollis euismod. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>',1,17,'2012-11-06 12:12:09',572,'','2013-02-07 12:13:09',572,0,'0000-00-00 00:00:00','2012-11-06 12:12:09','0000-00-00 00:00:00','{\"image_intro\":\"images\\/demo\\/magazine_blog_2.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/demo\\/magazine_blog_2.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',6,5,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(11,57,'Which are Parents\' Choice to Evaluate Mobile Apps for Children','which-are-parents-choice-to-evaluate-mobile-apps-for-children','<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Nullam quis risus eget urna mollis ornare vel eu leo. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit.</p>\r\n<p>Vestibulum id ligula porta felis euismod semper. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Nulla vitae elit libero, a pharetra augue.</p>\r\n<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vestibulum id ligula porta felis euismod semper. Cras mattis consectetur purus sit amet fermentum. Vestibulum id ligula porta felis euismod semper. Nullam quis risus eget urna mollis ornare vel eu leo. Lorem ipsum dolor sit amet, consectetur adipiscing elit. </p>\r\n<p>Maecenas faucibus mollis interdum. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Sed posuere consectetur est at lobortis. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Cras mattis consectetur purus sit amet fermentum. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Maecenas faucibus mollis interdum. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Sed posuere consectetur est at lobortis. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Etiam porta sem malesuada magna mollis euismod. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>',1,17,'2012-11-06 12:14:08',572,'','2013-02-07 12:11:53',572,0,'0000-00-00 00:00:00','2012-11-06 12:14:08','0000-00-00 00:00:00','{\"image_intro\":\"images\\/demo\\/magazine_blog_1.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/demo\\/magazine_blog_1.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',9,1,'','',1,42,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(12,58,'Lorem ipsum subcategory','lorem-ipsum-subcategory','<p>Aenean lacinia bibendum nulla sed consectetur. Donec sed odio dui. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Cras justo odio, dapibus ac facilisis in, egestas eget quam. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor.</p>','',1,18,'2012-11-06 12:14:44',572,'','2013-01-03 11:50:27',572,0,'0000-00-00 00:00:00','2012-11-06 12:14:44','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(13,59,'MacNotebook Air or Pro on top list','macnotebook-air-or-pro-on-top-list','<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi.</p>\r\n','\r\n<p>Vestibulum id ligula porta felis euismod semper. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Nulla vitae elit libero, a pharetra augue.</p>\r\n<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vestibulum id ligula porta felis euismod semper. Cras mattis consectetur purus sit amet fermentum. Vestibulum id ligula porta felis euismod semper. Nullam quis risus eget urna mollis ornare vel eu leo. Lorem ipsum dolor sit amet, consectetur adipiscing elit. </p>\r\n<p>Maecenas faucibus mollis interdum. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Sed posuere consectetur est at lobortis. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Cras mattis consectetur purus sit amet fermentum. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Maecenas faucibus mollis interdum. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Sed posuere consectetur est at lobortis. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Etiam porta sem malesuada magna mollis euismod. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>',1,17,'2012-11-06 12:15:55',572,'','2013-02-07 12:12:19',572,0,'0000-00-00 00:00:00','2012-11-06 12:15:55','0000-00-00 00:00:00','{\"image_intro\":\"images\\/demo\\/magazine_blog_2.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/demo\\/magazine_blog_2.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',13,2,'','',1,5,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(14,60,'Acer does not do it for less: new S7 ultranotebooks as the best PC','acer-does-not-do-it-for-less-new-s7-ultranotebooks-as-the-best-pcs-of-all-time','<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula. </p>\r\n','\r\n<p>Vestibulum id ligula porta felis euismod semper. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Nulla vitae elit libero, a pharetra augue. </p>\r\n<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vestibulum id ligula porta felis euismod semper. Cras mattis consectetur purus sit amet fermentum. Vestibulum id ligula porta felis euismod semper. Nullam quis risus eget urna mollis ornare vel eu leo. Lorem ipsum dolor sit amet, consectetur adipiscing elit. </p>\r\n<p>Maecenas faucibus mollis interdum. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Sed posuere consectetur est at lobortis. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Cras mattis consectetur purus sit amet fermentum. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Maecenas faucibus mollis interdum. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Sed posuere consectetur est at lobortis. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Etiam porta sem malesuada magna mollis euismod. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>',1,17,'2012-11-06 12:17:45',572,'','2013-02-07 12:08:57',572,0,'0000-00-00 00:00:00','2012-11-06 12:17:45','0000-00-00 00:00:00','{\"image_intro\":\"images\\/demo\\/magazine_blog_1.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/demo\\/magazine_blog_1.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',5,3,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(15,62,'Archive article I','archive-article-i','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tortor metus, rhoncus id facilisis at, mattis eget nisi. Curabitur vel tortor felis. Sed mattis diam eu urna fermentum sed porta arcu auctor. Phasellus volutpat, sem feugiat malesuada cursus, magna dui adipiscing lectus, a pharetra leo enim quis lectus. Donec ornare magna a erat euismod egestas. Morbi non arcu sit amet diam dapibus aliquet vel nec massa. Aliquam fermentum sollicitudin lorem, auctor vehicula felis pellentesque a. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed risus magna, mollis sed ultricies ut, pellentesque a metus. Duis eu vestibulum nisl. Mauris blandit elit a turpis pellentesque semper. Integer eget urna erat, et hendrerit magna. In a quam urna, at sollicitudin tellus. <br /><br />Donec ipsum erat, gravida sit amet laoreet et, adipiscing nec nibh. Vivamus ultrices faucibus nulla ut rhoncus. Nunc non posuere sapien. Praesent nec elit vitae sem posuere elementum eget tincidunt lorem. Quisque ornare malesuada dui nec pretium. Ut in mauris sit amet nunc cursus vehicula at id dolor. In enim nisi, venenatis quis lacinia id, congue sed arcu. Morbi nec risus eget augue porttitor pulvinar. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam quis enim in lacus aliquam tempus eu nec enim. Phasellus adipiscing facilisis est, sit amet volutpat libero vehicula in. Phasellus tincidunt convallis nisl sit amet luctus. Donec leo quam, sollicitudin vel porttitor at, cursus sed tellus. Sed dapibus massa id leo faucibus tempor molestie purus placerat. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque tempor fringilla augue sit amet bibendum. Nam vitae hendrerit nulla.</p>','',2,2,'2012-11-07 08:10:49',381,'','2013-01-03 11:26:09',572,0,'0000-00-00 00:00:00','2012-11-07 08:10:49','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,2,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(16,63,'Archive article II','archive-article-ii','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tortor metus, rhoncus id facilisis at, mattis eget nisi. Curabitur vel tortor felis. Sed mattis diam eu urna fermentum sed porta arcu auctor. Phasellus volutpat, sem feugiat malesuada cursus, magna dui adipiscing lectus, a pharetra leo enim quis lectus. Donec ornare magna a erat euismod egestas. Morbi non arcu sit amet diam dapibus aliquet vel nec massa. Aliquam fermentum sollicitudin lorem, auctor vehicula felis pellentesque a. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed risus magna, mollis sed ultricies ut, pellentesque a metus. Duis eu vestibulum nisl. Mauris blandit elit a turpis pellentesque semper. Integer eget urna erat, et hendrerit magna. In a quam urna, at sollicitudin tellus. <br /><br />Donec ipsum erat, gravida sit amet laoreet et, adipiscing nec nibh. Vivamus ultrices faucibus nulla ut rhoncus. Nunc non posuere sapien. Praesent nec elit vitae sem posuere elementum eget tincidunt lorem. Quisque ornare malesuada dui nec pretium. Ut in mauris sit amet nunc cursus vehicula at id dolor. In enim nisi, venenatis quis lacinia id, congue sed arcu. Morbi nec risus eget augue porttitor pulvinar. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam quis enim in lacus aliquam tempus eu nec enim. Phasellus adipiscing facilisis est, sit amet volutpat libero vehicula in. Phasellus tincidunt convallis nisl sit amet luctus. Donec leo quam, sollicitudin vel porttitor at, cursus sed tellus. Sed dapibus massa id leo faucibus tempor molestie purus placerat. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque tempor fringilla augue sit amet bibendum. Nam vitae hendrerit nulla.</p>','',2,2,'2012-11-07 08:10:59',381,'','2013-01-03 11:26:18',572,0,'0000-00-00 00:00:00','2012-11-07 08:10:59','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,1,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(17,64,'Archive article III','archive-article-iii','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tortor metus, rhoncus id facilisis at, mattis eget nisi. Curabitur vel tortor felis. Sed mattis diam eu urna fermentum sed porta arcu auctor. Phasellus volutpat, sem feugiat malesuada cursus, magna dui adipiscing lectus, a pharetra leo enim quis lectus. Donec ornare magna a erat euismod egestas. Morbi non arcu sit amet diam dapibus aliquet vel nec massa. Aliquam fermentum sollicitudin lorem, auctor vehicula felis pellentesque a. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed risus magna, mollis sed ultricies ut, pellentesque a metus. Duis eu vestibulum nisl. Mauris blandit elit a turpis pellentesque semper. Integer eget urna erat, et hendrerit magna. In a quam urna, at sollicitudin tellus. <br /><br />Donec ipsum erat, gravida sit amet laoreet et, adipiscing nec nibh. Vivamus ultrices faucibus nulla ut rhoncus. Nunc non posuere sapien. Praesent nec elit vitae sem posuere elementum eget tincidunt lorem. Quisque ornare malesuada dui nec pretium. Ut in mauris sit amet nunc cursus vehicula at id dolor. In enim nisi, venenatis quis lacinia id, congue sed arcu. Morbi nec risus eget augue porttitor pulvinar. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam quis enim in lacus aliquam tempus eu nec enim. Phasellus adipiscing facilisis est, sit amet volutpat libero vehicula in. Phasellus tincidunt convallis nisl sit amet luctus. Donec leo quam, sollicitudin vel porttitor at, cursus sed tellus. Sed dapibus massa id leo faucibus tempor molestie purus placerat. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque tempor fringilla augue sit amet bibendum. Nam vitae hendrerit nulla.</p>','',2,2,'2012-11-07 08:11:08',381,'','2013-01-03 11:26:27',572,0,'0000-00-00 00:00:00','2012-11-07 08:11:08','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');


--
-- Table structure for table `#__content_frontpage`
--



CREATE TABLE `#__content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`content_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__content_frontpage`
--


INSERT INTO `#__content_frontpage` (`content_id`, `ordering`) VALUES (9,1),(11,2);


--
-- Table structure for table `#__content_rating`
--



CREATE TABLE `#__content_rating` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(10) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(10) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`content_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__content_rating`
--




--
-- Table structure for table `#__core_log_searches`
--



CREATE TABLE `#__core_log_searches` (
  `search_term` varchar(128) NOT NULL DEFAULT '',
  `hits` int(10) unsigned NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__core_log_searches`
--




--
-- Table structure for table `#__extensions`
--



CREATE TABLE `#__extensions` (
  `extension_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `type` varchar(20) NOT NULL,
  `element` varchar(100) NOT NULL,
  `folder` varchar(100) NOT NULL,
  `client_id` tinyint(3) NOT NULL,
  `enabled` tinyint(3) NOT NULL DEFAULT '1',
  `access` int(10) unsigned NOT NULL DEFAULT '1',
  `protected` tinyint(3) NOT NULL DEFAULT '0',
  `manifest_cache` text NOT NULL,
  `params` text NOT NULL,
  `custom_data` text NOT NULL,
  `system_data` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) DEFAULT '0',
  `state` int(11) DEFAULT '0',
  PRIMARY KEY (`extension_id`),
  KEY `element_clientid` (`element`,`client_id`),
  KEY `element_folder_clientid` (`element`,`folder`,`client_id`),
  KEY `extension` (`type`,`element`,`folder`,`client_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10029 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__extensions`
--


INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES (1,'com_mailto','component','com_mailto','',0,1,1,1,'{\"name\":\"com_mailto\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_MAILTO_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(2,'com_wrapper','component','com_wrapper','',0,1,1,1,'{\"name\":\"com_wrapper\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_WRAPPER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(3,'com_admin','component','com_admin','',1,1,1,1,'{\"name\":\"com_admin\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_ADMIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(4,'com_banners','component','com_banners','',1,1,1,0,'{\"name\":\"com_banners\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_BANNERS_XML_DESCRIPTION\",\"group\":\"\"}','{\"purchase_type\":\"3\",\"track_impressions\":\"0\",\"track_clicks\":\"0\",\"metakey_prefix\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),(5,'com_cache','component','com_cache','',1,1,1,1,'{\"name\":\"com_cache\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CACHE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(6,'com_categories','component','com_categories','',1,1,1,1,'{\"name\":\"com_categories\",\"type\":\"component\",\"creationDate\":\"December 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(7,'com_checkin','component','com_checkin','',1,1,1,1,'{\"name\":\"com_checkin\",\"type\":\"component\",\"creationDate\":\"Unknown\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2008 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CHECKIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(8,'com_contact','component','com_contact','',1,1,1,0,'{\"name\":\"com_contact\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CONTACT_XML_DESCRIPTION\",\"group\":\"\"}','{\"contact_layout\":\"_:default\",\"show_contact_category\":\"hide\",\"show_contact_list\":\"0\",\"presentation_style\":\"plain\",\"show_name\":\"1\",\"show_position\":\"1\",\"show_email\":\"0\",\"show_street_address\":\"1\",\"show_suburb\":\"1\",\"show_state\":\"1\",\"show_postcode\":\"1\",\"show_country\":\"1\",\"show_telephone\":\"1\",\"show_mobile\":\"1\",\"show_fax\":\"1\",\"show_webpage\":\"1\",\"show_misc\":\"1\",\"show_image\":\"1\",\"image\":\"\",\"allow_vcard\":\"0\",\"show_articles\":\"0\",\"show_profile\":\"0\",\"show_links\":\"0\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"contact_icons\":\"0\",\"icon_address\":\"\",\"icon_email\":\"\",\"icon_telephone\":\"\",\"icon_mobile\":\"\",\"icon_fax\":\"\",\"icon_misc\":\"\",\"category_layout\":\"_:default\",\"show_category_title\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"0\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"0\",\"show_subcat_desc\":\"1\",\"show_cat_items\":\"1\",\"show_base_description\":\"1\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_items_cat\":\"1\",\"show_pagination_limit\":\"1\",\"show_headings\":\"1\",\"show_position_headings\":\"1\",\"show_email_headings\":\"0\",\"show_telephone_headings\":\"1\",\"show_mobile_headings\":\"0\",\"show_fax_headings\":\"0\",\"show_suburb_headings\":\"1\",\"show_state_headings\":\"1\",\"show_country_headings\":\"1\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"initial_sort\":\"ordering\",\"captcha\":\"\",\"show_email_form\":\"1\",\"show_email_copy\":\"1\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"1\",\"custom_reply\":\"0\",\"redirect\":\"\",\"show_feed_link\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(9,'com_cpanel','component','com_cpanel','',1,1,1,1,'{\"name\":\"com_cpanel\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CPANEL_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(10,'com_installer','component','com_installer','',1,1,1,1,'{\"name\":\"com_installer\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_INSTALLER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(11,'com_languages','component','com_languages','',1,1,1,1,'{\"name\":\"com_languages\",\"type\":\"component\",\"creationDate\":\"2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_LANGUAGES_XML_DESCRIPTION\",\"group\":\"\"}','{\"administrator\":\"en-GB\",\"site\":\"en-GB\"}','','',0,'0000-00-00 00:00:00',0,0),(12,'com_login','component','com_login','',1,1,1,1,'{\"name\":\"com_login\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(13,'com_media','component','com_media','',1,1,0,1,'{\"name\":\"com_media\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_MEDIA_XML_DESCRIPTION\",\"group\":\"\"}','{\"upload_extensions\":\"bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS\",\"upload_maxsize\":\"10\",\"file_path\":\"images\",\"image_path\":\"images\",\"restrict_uploads\":\"1\",\"allowed_media_usergroup\":\"3\",\"check_mime\":\"1\",\"image_extensions\":\"bmp,gif,jpg,png\",\"ignore_extensions\":\"\",\"upload_mime\":\"image\\/jpeg,image\\/gif,image\\/png,image\\/bmp,application\\/x-shockwave-flash,application\\/msword,application\\/excel,application\\/pdf,application\\/powerpoint,text\\/plain,application\\/x-zip\",\"upload_mime_illegal\":\"text\\/html\",\"enable_flash\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(14,'com_menus','component','com_menus','',1,1,1,1,'{\"name\":\"com_menus\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_MENUS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(15,'com_messages','component','com_messages','',1,1,1,1,'{\"name\":\"com_messages\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_MESSAGES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(16,'com_modules','component','com_modules','',1,1,1,1,'{\"name\":\"com_modules\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_MODULES_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(17,'com_newsfeeds','component','com_newsfeeds','',1,1,1,0,'{\"name\":\"com_newsfeeds\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_feed_image\":\"1\",\"show_feed_description\":\"1\",\"show_item_description\":\"1\",\"feed_word_count\":\"0\",\"show_headings\":\"1\",\"show_name\":\"1\",\"show_articles\":\"0\",\"show_link\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"display_num\":\"\",\"show_pagination_limit\":\"1\",\"show_pagination\":\"1\",\"show_pagination_results\":\"1\",\"show_cat_items\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(18,'com_plugins','component','com_plugins','',1,1,1,1,'{\"name\":\"com_plugins\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_PLUGINS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(19,'com_search','component','com_search','',1,1,1,0,'{\"name\":\"com_search\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_SEARCH_XML_DESCRIPTION\",\"group\":\"\"}','{\"enabled\":\"0\",\"show_date\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(20,'com_templates','component','com_templates','',1,1,1,1,'{\"name\":\"com_templates\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_TEMPLATES_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(21,'com_weblinks','component','com_weblinks','',1,1,1,0,'{\"name\":\"com_weblinks\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_comp_description\":\"1\",\"comp_description\":\"\",\"show_link_hits\":\"1\",\"show_link_description\":\"1\",\"show_other_cats\":\"0\",\"show_headings\":\"0\",\"show_numbers\":\"0\",\"show_report\":\"1\",\"count_clicks\":\"1\",\"target\":\"0\",\"link_icons\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),(22,'com_content','component','com_content','',1,1,0,1,'{\"name\":\"com_content\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}','{\"article_layout\":\"_:default\",\"show_title\":\"1\",\"link_titles\":\"1\",\"show_intro\":\"1\",\"info_block_position\":\"0\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"1\",\"link_author\":\"0\",\"show_create_date\":\"1\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"1\",\"show_vote\":\"0\",\"show_readmore\":\"1\",\"show_readmore_title\":\"0\",\"readmore_limit\":\"100\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"1\",\"show_hits\":\"1\",\"show_noauth\":\"0\",\"urls_position\":\"1\",\"show_publishing_options\":\"1\",\"show_article_options\":\"1\",\"show_urls_images_frontend\":\"1\",\"show_urls_images_backend\":\"1\",\"targeta\":0,\"targetb\":0,\"targetc\":0,\"float_intro\":\"left\",\"float_fulltext\":\"left\",\"category_layout\":\"_:blog\",\"show_category_title\":\"0\",\"show_description\":\"0\",\"show_description_image\":\"0\",\"maxLevel\":\"1\",\"show_empty_categories\":\"0\",\"show_no_articles\":\"1\",\"show_subcat_desc\":\"1\",\"show_cat_num_articles\":\"0\",\"show_base_description\":\"1\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_num_articles_cat\":\"1\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"0\",\"show_subcategory_content\":\"0\",\"show_pagination_limit\":\"1\",\"filter_field\":\"hide\",\"show_headings\":\"1\",\"list_show_date\":\"0\",\"date_format\":\"\",\"list_show_hits\":\"1\",\"list_show_author\":\"1\",\"orderby_pri\":\"order\",\"orderby_sec\":\"rdate\",\"order_date\":\"published\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_feed_link\":\"1\",\"feed_summary\":\"0\",\"feed_show_readmore\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(23,'com_config','component','com_config','',1,1,0,1,'{\"name\":\"com_config\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CONFIG_XML_DESCRIPTION\",\"group\":\"\"}','{\"filters\":{\"1\":{\"filter_type\":\"NH\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"9\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"6\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"7\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"2\":{\"filter_type\":\"NH\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"3\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"4\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"5\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"8\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"}}}','','',0,'0000-00-00 00:00:00',0,0),(24,'com_redirect','component','com_redirect','',1,1,0,1,'{\"name\":\"com_redirect\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_REDIRECT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(25,'com_users','component','com_users','',1,1,0,1,'{\"name\":\"com_users\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_USERS_XML_DESCRIPTION\",\"group\":\"\"}','{\"allowUserRegistration\":\"1\",\"new_usertype\":\"2\",\"guest_usergroup\":\"9\",\"sendpassword\":\"1\",\"useractivation\":\"1\",\"mail_to_admin\":\"0\",\"captcha\":\"\",\"frontend_userparams\":\"1\",\"site_language\":\"0\",\"change_login_name\":\"0\",\"reset_count\":\"10\",\"reset_time\":\"1\",\"mailSubjectPrefix\":\"\",\"mailBodySuffix\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),(27,'com_finder','component','com_finder','',1,1,0,0,'{\"name\":\"com_finder\",\"type\":\"component\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_FINDER_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_description\":\"1\",\"description_length\":255,\"allow_empty_query\":\"0\",\"show_url\":\"1\",\"show_advanced\":\"1\",\"expand_advanced\":\"0\",\"show_date_filters\":\"0\",\"highlight_terms\":\"1\",\"opensearch_name\":\"\",\"opensearch_description\":\"\",\"batch_size\":\"50\",\"memory_table_limit\":30000,\"title_multiplier\":\"1.7\",\"text_multiplier\":\"0.7\",\"meta_multiplier\":\"1.2\",\"path_multiplier\":\"2.0\",\"misc_multiplier\":\"0.3\",\"stemmer\":\"snowball\"}','','',0,'0000-00-00 00:00:00',0,0),(28,'com_joomlaupdate','component','com_joomlaupdate','',1,1,0,1,'{\"name\":\"com_joomlaupdate\",\"type\":\"component\",\"creationDate\":\"February 2012\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_JOOMLAUPDATE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(100,'PHPMailer','library','phpmailer','',0,1,1,1,'{\"name\":\"PHPMailer\",\"type\":\"library\",\"creationDate\":\"2001\",\"author\":\"PHPMailer\",\"copyright\":\"(c) 2001-2003, Brent R. Matzelle, (c) 2004-2009, Andy Prevost. All Rights Reserved., (c) 2010-2012, Jim Jagielski. All Rights Reserved.\",\"authorEmail\":\"jimjag@gmail.com\",\"authorUrl\":\"https:\\/\\/code.google.com\\/a\\/apache-extras.org\\/p\\/phpmailer\\/\",\"version\":\"5.2.1\",\"description\":\"LIB_PHPMAILER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(101,'SimplePie','library','simplepie','',0,1,1,1,'{\"name\":\"SimplePie\",\"type\":\"library\",\"creationDate\":\"2004\",\"author\":\"SimplePie\",\"copyright\":\"Copyright (c) 2004-2009, Ryan Parman and Geoffrey Sneddon\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/simplepie.org\\/\",\"version\":\"1.2\",\"description\":\"LIB_SIMPLEPIE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(102,'phputf8','library','phputf8','',0,1,1,1,'{\"name\":\"phputf8\",\"type\":\"library\",\"creationDate\":\"2006\",\"author\":\"Harry Fuecks\",\"copyright\":\"Copyright various authors\",\"authorEmail\":\"hfuecks@gmail.com\",\"authorUrl\":\"http:\\/\\/sourceforge.net\\/projects\\/phputf8\",\"version\":\"0.5\",\"description\":\"LIB_PHPUTF8_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(103,'Joomla! Platform','library','joomla','',0,1,1,1,'{\"name\":\"Joomla! Platform\",\"type\":\"library\",\"creationDate\":\"2008\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"http:\\/\\/www.joomla.org\",\"version\":\"12.2\",\"description\":\"LIB_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(200,'mod_articles_archive','module','mod_articles_archive','',0,1,1,0,'{\"name\":\"mod_articles_archive\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters.\\n\\t\\tAll rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_ARTICLES_ARCHIVE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(201,'mod_articles_latest','module','mod_articles_latest','',0,1,1,0,'{\"name\":\"mod_articles_latest\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LATEST_NEWS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(202,'mod_articles_popular','module','mod_articles_popular','',0,1,1,0,'{\"name\":\"mod_articles_popular\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_POPULAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(203,'mod_banners','module','mod_banners','',0,1,1,0,'{\"name\":\"mod_banners\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_BANNERS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(204,'mod_breadcrumbs','module','mod_breadcrumbs','',0,1,1,1,'{\"name\":\"mod_breadcrumbs\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_BREADCRUMBS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(205,'mod_custom','module','mod_custom','',0,1,1,1,'{\"name\":\"mod_custom\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_CUSTOM_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(206,'mod_feed','module','mod_feed','',0,1,1,0,'{\"name\":\"mod_feed\",\"type\":\"module\",\"creationDate\":\"July 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_FEED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(207,'mod_footer','module','mod_footer','',0,1,1,0,'{\"name\":\"mod_footer\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_FOOTER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(208,'mod_login','module','mod_login','',0,1,1,1,'{\"name\":\"mod_login\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(209,'mod_menu','module','mod_menu','',0,1,1,1,'{\"name\":\"mod_menu\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_MENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(210,'mod_articles_news','module','mod_articles_news','',0,1,1,0,'{\"name\":\"mod_articles_news\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_ARTICLES_NEWS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(211,'mod_random_image','module','mod_random_image','',0,1,1,0,'{\"name\":\"mod_random_image\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_RANDOM_IMAGE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(212,'mod_related_items','module','mod_related_items','',0,1,1,0,'{\"name\":\"mod_related_items\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_RELATED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(213,'mod_search','module','mod_search','',0,1,1,0,'{\"name\":\"mod_search\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_SEARCH_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(214,'mod_stats','module','mod_stats','',0,1,1,0,'{\"name\":\"mod_stats\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_STATS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(215,'mod_syndicate','module','mod_syndicate','',0,1,1,1,'{\"name\":\"mod_syndicate\",\"type\":\"module\",\"creationDate\":\"May 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_SYNDICATE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(216,'mod_users_latest','module','mod_users_latest','',0,1,1,0,'{\"name\":\"mod_users_latest\",\"type\":\"module\",\"creationDate\":\"December 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_USERS_LATEST_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(217,'mod_weblinks','module','mod_weblinks','',0,1,1,0,'{\"name\":\"mod_weblinks\",\"type\":\"module\",\"creationDate\":\"July 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(218,'mod_whosonline','module','mod_whosonline','',0,1,1,0,'{\"name\":\"mod_whosonline\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_WHOSONLINE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(219,'mod_wrapper','module','mod_wrapper','',0,1,1,0,'{\"name\":\"mod_wrapper\",\"type\":\"module\",\"creationDate\":\"October 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_WRAPPER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(220,'mod_articles_category','module','mod_articles_category','',0,1,1,0,'{\"name\":\"mod_articles_category\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_ARTICLES_CATEGORY_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(221,'mod_articles_categories','module','mod_articles_categories','',0,1,1,0,'{\"name\":\"mod_articles_categories\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_ARTICLES_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(222,'mod_languages','module','mod_languages','',0,1,1,1,'{\"name\":\"mod_languages\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LANGUAGES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(223,'mod_finder','module','mod_finder','',0,1,0,0,'{\"name\":\"mod_finder\",\"type\":\"module\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_FINDER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(300,'mod_custom','module','mod_custom','',1,1,1,1,'{\"name\":\"mod_custom\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_CUSTOM_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(301,'mod_feed','module','mod_feed','',1,1,1,0,'{\"name\":\"mod_feed\",\"type\":\"module\",\"creationDate\":\"July 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_FEED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(302,'mod_latest','module','mod_latest','',1,1,1,0,'{\"name\":\"mod_latest\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LATEST_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(303,'mod_logged','module','mod_logged','',1,1,1,0,'{\"name\":\"mod_logged\",\"type\":\"module\",\"creationDate\":\"January 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LOGGED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(304,'mod_login','module','mod_login','',1,1,1,1,'{\"name\":\"mod_login\",\"type\":\"module\",\"creationDate\":\"March 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(305,'mod_menu','module','mod_menu','',1,1,1,0,'{\"name\":\"mod_menu\",\"type\":\"module\",\"creationDate\":\"March 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_MENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(307,'mod_popular','module','mod_popular','',1,1,1,0,'{\"name\":\"mod_popular\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_POPULAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(308,'mod_quickicon','module','mod_quickicon','',1,1,1,1,'{\"name\":\"mod_quickicon\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_QUICKICON_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(309,'mod_status','module','mod_status','',1,1,1,0,'{\"name\":\"mod_status\",\"type\":\"module\",\"creationDate\":\"Feb 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_STATUS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(310,'mod_submenu','module','mod_submenu','',1,1,1,0,'{\"name\":\"mod_submenu\",\"type\":\"module\",\"creationDate\":\"Feb 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_SUBMENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(311,'mod_title','module','mod_title','',1,1,1,0,'{\"name\":\"mod_title\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_TITLE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(312,'mod_toolbar','module','mod_toolbar','',1,1,1,1,'{\"name\":\"mod_toolbar\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_TOOLBAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(313,'mod_multilangstatus','module','mod_multilangstatus','',1,1,1,0,'{\"name\":\"mod_multilangstatus\",\"type\":\"module\",\"creationDate\":\"September 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_MULTILANGSTATUS_XML_DESCRIPTION\",\"group\":\"\"}','{\"cache\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(314,'mod_version','module','mod_version','',1,1,1,0,'{\"name\":\"mod_version\",\"type\":\"module\",\"creationDate\":\"January 2012\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_VERSION_XML_DESCRIPTION\",\"group\":\"\"}','{\"format\":\"short\",\"product\":\"1\",\"cache\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(315,'mod_stats_admin','module','mod_stats_admin','',1,1,1,0,'{\"name\":\"mod_stats_admin\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_STATS_XML_DESCRIPTION\",\"group\":\"\"}','{\"serverinfo\":\"0\",\"siteinfo\":\"0\",\"counter\":\"0\",\"increase\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}','','',0,'0000-00-00 00:00:00',0,0),(400,'plg_authentication_gmail','plugin','gmail','authentication',0,0,1,0,'{\"name\":\"plg_authentication_gmail\",\"type\":\"plugin\",\"creationDate\":\"February 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_GMAIL_XML_DESCRIPTION\",\"group\":\"\"}','{\"applysuffix\":\"0\",\"suffix\":\"\",\"verifypeer\":\"1\",\"user_blacklist\":\"\"}','','',0,'0000-00-00 00:00:00',1,0),(401,'plg_authentication_joomla','plugin','joomla','authentication',0,1,1,1,'{\"name\":\"plg_authentication_joomla\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_AUTH_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(402,'plg_authentication_ldap','plugin','ldap','authentication',0,0,1,0,'{\"name\":\"plg_authentication_ldap\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_LDAP_XML_DESCRIPTION\",\"group\":\"\"}','{\"host\":\"\",\"port\":\"389\",\"use_ldapV3\":\"0\",\"negotiate_tls\":\"0\",\"no_referrals\":\"0\",\"auth_method\":\"bind\",\"base_dn\":\"\",\"search_string\":\"\",\"users_dn\":\"\",\"username\":\"admin\",\"password\":\"bobby7\",\"ldap_fullname\":\"fullName\",\"ldap_email\":\"mail\",\"ldap_uid\":\"uid\"}','','',0,'0000-00-00 00:00:00',3,0),(404,'plg_content_emailcloak','plugin','emailcloak','content',0,1,1,0,'{\"name\":\"plg_content_emailcloak\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTENT_EMAILCLOAK_XML_DESCRIPTION\",\"group\":\"\"}','{\"mode\":\"1\"}','','',0,'0000-00-00 00:00:00',1,0),(405,'plg_content_geshi','plugin','geshi','content',0,0,1,0,'{\"name\":\"plg_content_geshi\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"qbnz.com\\/highlighter\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTENT_GESHI_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),(406,'plg_content_loadmodule','plugin','loadmodule','content',0,1,1,0,'{\"name\":\"plg_content_loadmodule\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_LOADMODULE_XML_DESCRIPTION\",\"group\":\"\"}','{\"style\":\"xhtml\"}','','',0,'2011-09-18 15:22:50',0,0),(407,'plg_content_pagebreak','plugin','pagebreak','content',0,1,1,0,'{\"name\":\"plg_content_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTENT_PAGEBREAK_XML_DESCRIPTION\",\"group\":\"\"}','{\"title\":\"1\",\"article_index\":\"1\",\"article_index_text\":\"Article Index\",\"multipage_toc\":\"1\",\"showall\":\"1\",\"style\":\"pages\"}','','',0,'0000-00-00 00:00:00',4,0),(408,'plg_content_pagenavigation','plugin','pagenavigation','content',0,0,1,0,'{\"name\":\"plg_content_pagenavigation\",\"type\":\"plugin\",\"creationDate\":\"January 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_PAGENAVIGATION_XML_DESCRIPTION\",\"group\":\"\"}','{\"position\":\"1\"}','','',0,'0000-00-00 00:00:00',5,0),(409,'plg_content_vote','plugin','vote','content',0,1,1,0,'{\"name\":\"plg_content_vote\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_VOTE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',6,0),(410,'plg_editors_codemirror','plugin','codemirror','editors',0,1,1,1,'{\"name\":\"plg_editors_codemirror\",\"type\":\"plugin\",\"creationDate\":\"28 March 2011\",\"author\":\"Marijn Haverbeke\",\"copyright\":\"\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"\",\"version\":\"1.0\",\"description\":\"PLG_CODEMIRROR_XML_DESCRIPTION\",\"group\":\"\"}','{\"linenumbers\":\"0\",\"tabmode\":\"indent\"}','','',0,'0000-00-00 00:00:00',1,0),(411,'plg_editors_none','plugin','none','editors',0,1,1,1,'{\"name\":\"plg_editors_none\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Unknown\",\"copyright\":\"\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"\",\"version\":\"3.0.0\",\"description\":\"PLG_NONE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),(412,'plg_editors_tinymce','plugin','tinymce','editors',0,1,1,0,'{\"name\":\"plg_editors_tinymce\",\"type\":\"plugin\",\"creationDate\":\"2005-2012\",\"author\":\"Moxiecode Systems AB\",\"copyright\":\"Moxiecode Systems AB\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"tinymce.moxiecode.com\\/\",\"version\":\"3.5.6\",\"description\":\"PLG_TINY_XML_DESCRIPTION\",\"group\":\"\"}','{\"mode\":\"1\",\"skin\":\"0\",\"entity_encoding\":\"raw\",\"lang_mode\":\"0\",\"lang_code\":\"en\",\"text_direction\":\"ltr\",\"content_css\":\"1\",\"content_css_custom\":\"\",\"relative_urls\":\"1\",\"newlines\":\"0\",\"invalid_elements\":\"script,applet,iframe\",\"extended_elements\":\"\",\"toolbar\":\"top\",\"toolbar_align\":\"left\",\"html_height\":\"550\",\"html_width\":\"750\",\"resizing\":\"true\",\"resize_horizontal\":\"false\",\"element_path\":\"1\",\"fonts\":\"1\",\"paste\":\"1\",\"searchreplace\":\"1\",\"insertdate\":\"1\",\"format_date\":\"%Y-%m-%d\",\"inserttime\":\"1\",\"format_time\":\"%H:%M:%S\",\"colors\":\"1\",\"table\":\"1\",\"smilies\":\"1\",\"media\":\"1\",\"hr\":\"1\",\"directionality\":\"1\",\"fullscreen\":\"1\",\"style\":\"1\",\"layer\":\"1\",\"xhtmlxtras\":\"1\",\"visualchars\":\"1\",\"nonbreaking\":\"1\",\"template\":\"1\",\"blockquote\":\"1\",\"wordcount\":\"1\",\"advimage\":\"1\",\"advlink\":\"1\",\"advlist\":\"1\",\"autosave\":\"1\",\"contextmenu\":\"1\",\"inlinepopups\":\"1\",\"custom_plugin\":\"\",\"custom_button\":\"\"}','','',0,'0000-00-00 00:00:00',3,0),(413,'plg_editors-xtd_article','plugin','article','editors-xtd',0,1,1,1,'{\"name\":\"plg_editors-xtd_article\",\"type\":\"plugin\",\"creationDate\":\"October 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_ARTICLE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),(414,'plg_editors-xtd_image','plugin','image','editors-xtd',0,1,1,0,'{\"name\":\"plg_editors-xtd_image\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_IMAGE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),(415,'plg_editors-xtd_pagebreak','plugin','pagebreak','editors-xtd',0,1,1,0,'{\"name\":\"plg_editors-xtd_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_EDITORSXTD_PAGEBREAK_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',3,0),(416,'plg_editors-xtd_readmore','plugin','readmore','editors-xtd',0,1,1,0,'{\"name\":\"plg_editors-xtd_readmore\",\"type\":\"plugin\",\"creationDate\":\"March 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_READMORE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',4,0),(417,'plg_search_categories','plugin','categories','search',0,1,1,0,'{\"name\":\"plg_search_categories\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(418,'plg_search_contacts','plugin','contacts','search',0,1,1,0,'{\"name\":\"plg_search_contacts\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_CONTACTS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(419,'plg_search_content','plugin','content','search',0,1,1,0,'{\"name\":\"plg_search_content\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(420,'plg_search_newsfeeds','plugin','newsfeeds','search',0,1,1,0,'{\"name\":\"plg_search_newsfeeds\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(421,'plg_search_weblinks','plugin','weblinks','search',0,1,1,0,'{\"name\":\"plg_search_weblinks\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(422,'plg_system_languagefilter','plugin','languagefilter','system',0,0,1,1,'{\"name\":\"plg_system_languagefilter\",\"type\":\"plugin\",\"creationDate\":\"July 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SYSTEM_LANGUAGEFILTER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),(423,'plg_system_p3p','plugin','p3p','system',0,1,1,0,'{\"name\":\"plg_system_p3p\",\"type\":\"plugin\",\"creationDate\":\"September 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_P3P_XML_DESCRIPTION\",\"group\":\"\"}','{\"headers\":\"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM\"}','','',0,'0000-00-00 00:00:00',2,0),(424,'plg_system_cache','plugin','cache','system',0,0,1,1,'{\"name\":\"plg_system_cache\",\"type\":\"plugin\",\"creationDate\":\"February 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CACHE_XML_DESCRIPTION\",\"group\":\"\"}','{\"browsercache\":\"0\",\"cachetime\":\"15\"}','','',0,'0000-00-00 00:00:00',9,0),(425,'plg_system_debug','plugin','debug','system',0,1,1,0,'{\"name\":\"plg_system_debug\",\"type\":\"plugin\",\"creationDate\":\"December 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_DEBUG_XML_DESCRIPTION\",\"group\":\"\"}','{\"profile\":\"1\",\"queries\":\"1\",\"memory\":\"1\",\"language_files\":\"1\",\"language_strings\":\"1\",\"strip-first\":\"1\",\"strip-prefix\":\"\",\"strip-suffix\":\"\"}','','',0,'0000-00-00 00:00:00',4,0),(426,'plg_system_log','plugin','log','system',0,1,1,1,'{\"name\":\"plg_system_log\",\"type\":\"plugin\",\"creationDate\":\"April 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_LOG_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',5,0),(427,'plg_system_redirect','plugin','redirect','system',0,1,1,1,'{\"name\":\"plg_system_redirect\",\"type\":\"plugin\",\"creationDate\":\"April 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_REDIRECT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',6,0),(428,'plg_system_remember','plugin','remember','system',0,1,1,1,'{\"name\":\"plg_system_remember\",\"type\":\"plugin\",\"creationDate\":\"April 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_REMEMBER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',7,0),(429,'plg_system_sef','plugin','sef','system',0,1,1,0,'{\"name\":\"plg_system_sef\",\"type\":\"plugin\",\"creationDate\":\"December 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEF_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',8,0),(430,'plg_system_logout','plugin','logout','system',0,1,1,1,'{\"name\":\"plg_system_logout\",\"type\":\"plugin\",\"creationDate\":\"April 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SYSTEM_LOGOUT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',3,0),(431,'plg_user_contactcreator','plugin','contactcreator','user',0,0,1,0,'{\"name\":\"plg_user_contactcreator\",\"type\":\"plugin\",\"creationDate\":\"August 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTACTCREATOR_XML_DESCRIPTION\",\"group\":\"\"}','{\"autowebpage\":\"\",\"category\":\"34\",\"autopublish\":\"0\"}','','',0,'0000-00-00 00:00:00',1,0),(432,'plg_user_joomla','plugin','joomla','user',0,1,1,0,'{\"name\":\"plg_user_joomla\",\"type\":\"plugin\",\"creationDate\":\"December 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2009 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_USER_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{\"autoregister\":\"1\"}','','',0,'0000-00-00 00:00:00',2,0),(433,'plg_user_profile','plugin','profile','user',0,0,1,0,'{\"name\":\"plg_user_profile\",\"type\":\"plugin\",\"creationDate\":\"January 2008\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_USER_PROFILE_XML_DESCRIPTION\",\"group\":\"\"}','{\"register-require_address1\":\"1\",\"register-require_address2\":\"1\",\"register-require_city\":\"1\",\"register-require_region\":\"1\",\"register-require_country\":\"1\",\"register-require_postal_code\":\"1\",\"register-require_phone\":\"1\",\"register-require_website\":\"1\",\"register-require_favoritebook\":\"1\",\"register-require_aboutme\":\"1\",\"register-require_tos\":\"1\",\"register-require_dob\":\"1\",\"profile-require_address1\":\"1\",\"profile-require_address2\":\"1\",\"profile-require_city\":\"1\",\"profile-require_region\":\"1\",\"profile-require_country\":\"1\",\"profile-require_postal_code\":\"1\",\"profile-require_phone\":\"1\",\"profile-require_website\":\"1\",\"profile-require_favoritebook\":\"1\",\"profile-require_aboutme\":\"1\",\"profile-require_tos\":\"1\",\"profile-require_dob\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(434,'plg_extension_joomla','plugin','joomla','extension',0,1,1,1,'{\"name\":\"plg_extension_joomla\",\"type\":\"plugin\",\"creationDate\":\"May 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_EXTENSION_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),(435,'plg_content_joomla','plugin','joomla','content',0,1,1,0,'{\"name\":\"plg_content_joomla\",\"type\":\"plugin\",\"creationDate\":\"November 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTENT_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(436,'plg_system_languagecode','plugin','languagecode','system',0,0,1,0,'{\"name\":\"plg_system_languagecode\",\"type\":\"plugin\",\"creationDate\":\"November 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SYSTEM_LANGUAGECODE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',10,0),(437,'plg_quickicon_joomlaupdate','plugin','joomlaupdate','quickicon',0,1,1,1,'{\"name\":\"plg_quickicon_joomlaupdate\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_QUICKICON_JOOMLAUPDATE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(438,'plg_quickicon_extensionupdate','plugin','extensionupdate','quickicon',0,1,1,1,'{\"name\":\"plg_quickicon_extensionupdate\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_QUICKICON_EXTENSIONUPDATE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(439,'plg_captcha_recaptcha','plugin','recaptcha','captcha',0,1,1,0,'{\"name\":\"plg_captcha_recaptcha\",\"type\":\"plugin\",\"creationDate\":\"December 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CAPTCHA_RECAPTCHA_XML_DESCRIPTION\",\"group\":\"\"}','{\"public_key\":\"\",\"private_key\":\"\",\"theme\":\"clean\"}','','',0,'0000-00-00 00:00:00',0,0),(440,'plg_system_highlight','plugin','highlight','system',0,1,1,0,'{\"name\":\"plg_system_highlight\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SYSTEM_HIGHLIGHT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',7,0),(441,'plg_content_finder','plugin','finder','content',0,0,1,0,'{\"name\":\"plg_content_finder\",\"type\":\"plugin\",\"creationDate\":\"December 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTENT_FINDER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(442,'plg_finder_categories','plugin','categories','finder',0,1,1,0,'{\"name\":\"plg_finder_categories\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),(443,'plg_finder_contacts','plugin','contacts','finder',0,1,1,0,'{\"name\":\"plg_finder_contacts\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_CONTACTS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),(444,'plg_finder_content','plugin','content','finder',0,1,1,0,'{\"name\":\"plg_finder_content\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',3,0),(445,'plg_finder_newsfeeds','plugin','newsfeeds','finder',0,1,1,0,'{\"name\":\"plg_finder_newsfeeds\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',4,0),(446,'plg_finder_weblinks','plugin','weblinks','finder',0,1,1,0,'{\"name\":\"plg_finder_weblinks\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',5,0),(503,'beez3','template','beez3','',0,1,1,0,'{\"name\":\"beez3\",\"type\":\"template\",\"creationDate\":\"25 November 2009\",\"author\":\"Angie Radtke\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"a.radtke@derauftritt.de\",\"authorUrl\":\"http:\\/\\/www.der-auftritt.de\",\"version\":\"3.0.0\",\"description\":\"TPL_BEEZ3_XML_DESCRIPTION\",\"group\":\"\"}','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"sitetitle\":\"\",\"sitedescription\":\"\",\"navposition\":\"center\",\"templatecolor\":\"nature\"}','','',0,'0000-00-00 00:00:00',0,0),(504,'hathor','template','hathor','',1,1,1,0,'{\"name\":\"hathor\",\"type\":\"template\",\"creationDate\":\"May 2010\",\"author\":\"Andrea Tarr\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"hathor@tarrconsulting.com\",\"authorUrl\":\"http:\\/\\/www.tarrconsulting.com\",\"version\":\"3.0.0\",\"description\":\"TPL_HATHOR_XML_DESCRIPTION\",\"group\":\"\"}','{\"showSiteName\":\"0\",\"colourChoice\":\"0\",\"boldText\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(506,'protostar','template','protostar','',0,1,1,0,'{\"name\":\"protostar\",\"type\":\"template\",\"creationDate\":\"4\\/30\\/2012\",\"author\":\"Kyle Ledbetter\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"\",\"version\":\"1.0\",\"description\":\"TPL_PROTOSTAR_XML_DESCRIPTION\",\"group\":\"\"}','{\"templateColor\":\"\",\"logoFile\":\"\",\"googleFont\":\"1\",\"googleFontName\":\"Open+Sans\",\"fluidContainer\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(507,'isis','template','isis','',1,1,1,0,'{\"name\":\"isis\",\"type\":\"template\",\"creationDate\":\"3\\/30\\/2012\",\"author\":\"Kyle Ledbetter\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"\",\"version\":\"1.0\",\"description\":\"TPL_ISIS_XML_DESCRIPTION\",\"group\":\"\"}','{\"templateColor\":\"\",\"logoFile\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),(600,'English (United Kingdom)','language','en-GB','',0,1,1,1,'{\"name\":\"English (United Kingdom)\",\"type\":\"language\",\"creationDate\":\"2008-03-15\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.3\",\"description\":\"en-GB site language\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(601,'English (United Kingdom)','language','en-GB','',1,1,1,1,'{\"name\":\"English (United Kingdom)\",\"type\":\"language\",\"creationDate\":\"2008-03-15\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.3\",\"description\":\"en-GB administrator language\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(700,'files_joomla','file','joomla','',0,1,1,1,'{\"name\":\"files_joomla\",\"type\":\"file\",\"creationDate\":\"February 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.3\",\"description\":\"FILES_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(10002,'mod_news_pro_gk4','module','mod_news_pro_gk4','',0,1,0,0,'{\"name\":\"mod_news_pro_gk4\",\"type\":\"module\",\"creationDate\":\"07\\/01\\/2013\",\"author\":\"Gavick.com\",\"copyright\":\"(C) 2009-2013 Gavick.com\",\"authorEmail\":\"info@gavick.com\",\"authorUrl\":\"www.gavick.com\",\"version\":\"GK4 3.3.6\",\"description\":\"\\n\\t\\t<style type=\'text\\/css\'>span.readonly { padding: 10px; font-family: Arial; font-size:13px !important; font-weight: normal !important; text-align: justify; color: #4d4d4d; line-height: 24px; } span.readonly h1 { clear:both; font-family: Georgia, sans-serif; font-size:38px; margin:30px 20px 23px; padding:0px 0px 24px 10px; color:#333; border-bottom: 1px solid #eee; font-weight: normal; } span.readonly p { margin: 0 26px 10px } span.readonly p a { color: #ab3f0a } span.readonly p.homepage { margin-top: 30px } span.readonly p.license { border-top: 1px solid #eee; font-size: 11px; margin: 30px 26px 0; padding: 6px 0; }<\\/style><span class=\'readonly\'><h1>News Show Pro GK4 <small>ver. 3.3.6<\\/small><\\/h1><p>GK4 is new generation of our extensions dedicated to Joomla 3.0.<\\/p><p>Basing on experiences gathered, we created probably the best tool to present articles for Joomla! Huge amount of options and possibilities of formatting causes News Show Pro GK4 is a complex tool in making www pages content attractive. News Show Pro is appropriate while preparing simple structures with an individual article, the same as, complex arrangements including few articles and a list of links.<\\/p> <p class=\'homepage\'><a href=\'http:\\/\\/tools.gavick.com\\/newshowpro.html\' target=\'_blank\'>Learn more at the NSP GK4 project website.<\\/a><\\/p><p class=\'license\'>News Show Pro GK4 is released under the <a target=\\\"_blank\\\" href=\\\"http:\\/\\/www.gnu.org\\/licenses\\/gpl-2.0.html\\\">GNU\\/GPL v2 license.<\\/a><\\/p><\\/span>\\n\\t\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"com_categories\",\"com_categories\":\"\",\"com_articles\":\"\",\"k2_categories\":\"\",\"k2_tags\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_portal_mode_5_amount\":\"10\",\"news_full_pages\":\"3\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"40\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"words\",\"news_limit\":\"30\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE %HITS %CATEGORY %AUTHOR\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"0\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 20px 20px 0\",\"news_header_order\":\"1\",\"news_header_enabled\":\"1\",\"news_image_order\":\"3\",\"news_image_enabled\":\"1\",\"news_text_order\":\"4\",\"news_text_enabled\":\"1\",\"news_info_order\":\"2\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"1\",\"news_content_readmore_pos\":\"right\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"3\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows_with_counter\",\"links_margin\":\"0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"words\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"words\",\"list_text_limit\":\"30\",\"responsive_images\":\"0\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"0\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"160\",\"img_height\":\"120\",\"img_margin\":\"6px 14px 0 0\",\"img_bg\":\"#000\",\"img_stretch\":\"0\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_editor\":\"\",\"simple_crop_top\":\"10\",\"simple_crop_bottom\":\"10\",\"simple_crop_left\":\"10\",\"simple_crop_right\":\"10\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"1\",\"useScript\":\"2\",\"useRTL\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(10003,'com_k2','component','com_k2','',1,1,0,0,'{\"name\":\"COM_K2\",\"type\":\"component\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"Thank you for installing K2 by JoomlaWorks, the powerful content extension for Joomla!\",\"group\":\"\"}','{\"enable_css\":\"1\",\"jQueryHandling\":\"1.8remote\",\"backendJQueryHandling\":\"remote\",\"userName\":\"1\",\"userImage\":\"1\",\"userDescription\":\"1\",\"userURL\":\"1\",\"userEmail\":\"0\",\"userFeedLink\":\"1\",\"userFeedIcon\":\"1\",\"userItemCount\":\"4\",\"userItemTitle\":\"1\",\"userItemTitleLinked\":\"1\",\"userItemDateCreated\":\"1\",\"userItemImage\":\"1\",\"userItemIntroText\":\"1\",\"userItemCategory\":\"1\",\"userItemTags\":\"0\",\"userItemCommentsAnchor\":\"1\",\"userItemReadMore\":\"1\",\"userItemK2Plugins\":\"1\",\"defaultUsersItemid\":\"\",\"tagItemCount\":\"3\",\"tagItemTitle\":\"1\",\"tagItemTitleLinked\":\"1\",\"tagItemDateCreated\":\"1\",\"tagItemImage\":\"1\",\"tagItemIntroText\":\"1\",\"tagItemCategory\":\"1\",\"tagItemReadMore\":\"1\",\"tagItemExtraFields\":\"0\",\"tagOrdering\":\"\",\"tagFeedLink\":\"1\",\"tagFeedIcon\":\"1\",\"defaultTagsItemid\":\"\",\"genericItemCount\":\"10\",\"genericItemTitle\":\"1\",\"genericItemTitleLinked\":\"1\",\"genericItemDateCreated\":\"1\",\"genericItemImage\":\"1\",\"genericItemIntroText\":\"1\",\"genericItemCategory\":\"1\",\"genericItemReadMore\":\"1\",\"genericItemExtraFields\":\"0\",\"genericFeedLink\":\"1\",\"genericFeedIcon\":\"1\",\"feedLimit\":\"10\",\"feedItemImage\":\"1\",\"feedImgSize\":\"L\",\"feedItemIntroText\":\"1\",\"feedTextWordLimit\":\"\",\"feedItemFullText\":\"1\",\"feedItemTags\":\"0\",\"feedItemVideo\":\"0\",\"feedItemGallery\":\"0\",\"feedItemAttachments\":\"0\",\"feedBogusEmail\":\"\",\"introTextCleanup\":\"0\",\"introTextCleanupExcludeTags\":\"\",\"introTextCleanupTagAttr\":\"\",\"fullTextCleanup\":\"0\",\"fullTextCleanupExcludeTags\":\"\",\"fullTextCleanupTagAttr\":\"\",\"xssFiltering\":\"0\",\"linkPopupWidth\":\"900\",\"linkPopupHeight\":\"600\",\"imagesQuality\":\"80\",\"itemImageXS\":\"100\",\"itemImageS\":\"200\",\"itemImageM\":\"746\",\"itemImageL\":\"700\",\"itemImageXL\":\"918\",\"itemImageGeneric\":\"659\",\"catImageWidth\":\"659\",\"catImageDefault\":\"1\",\"userImageWidth\":\"116\",\"userImageDefault\":\"1\",\"commenterImgWidth\":\"60\",\"onlineImageEditor\":\"splashup\",\"imageTimestamp\":\"0\",\"imageMemoryLimit\":\"\",\"socialButtonCode\":\"\",\"twitterUsername\":\"\",\"facebookImage\":\"Small\",\"comments\":\"1\",\"commentsOrdering\":\"DESC\",\"commentsLimit\":\"10\",\"commentsFormPosition\":\"below\",\"commentsPublishing\":\"1\",\"commentsReporting\":\"2\",\"commentsReportRecipient\":\"\",\"inlineCommentsModeration\":\"0\",\"gravatar\":\"1\",\"recaptcha\":\"0\",\"commentsFormNotes\":\"1\",\"commentsFormNotesText\":\"\",\"frontendEditing\":\"1\",\"showImageTab\":\"1\",\"showImageGalleryTab\":\"1\",\"showVideoTab\":\"1\",\"showExtraFieldsTab\":\"1\",\"showAttachmentsTab\":\"1\",\"showK2Plugins\":\"1\",\"sideBarDisplayFrontend\":\"0\",\"mergeEditors\":\"1\",\"sideBarDisplay\":\"1\",\"attachmentsFolder\":\"\",\"hideImportButton\":\"0\",\"taggingSystem\":\"1\",\"lockTags\":\"0\",\"showTagFilter\":\"0\",\"googleSearch\":\"0\",\"googleSearchContainer\":\"k2Container\",\"K2UserProfile\":\"0\",\"K2UserGroup\":\"1\",\"redirect\":\"101\",\"adminSearch\":\"simple\",\"cookieDomain\":\"\",\"recaptcha_public_key\":\"\",\"recaptcha_private_key\":\"\",\"recaptcha_theme\":\"clean\",\"recaptchaOnRegistration\":\"0\",\"stopForumSpam\":\"0\",\"stopForumSpamApiKey\":\"\",\"showItemsCounterAdmin\":\"1\",\"showChildCatItems\":\"1\",\"disableCompactOrdering\":\"0\",\"metaDescLimit\":\"150\",\"enforceSEFReplacements\":\"0\",\"SEFReplacements\":\"\\u00c5\\u00a0|S, \\u00c5\\u2019|O, \\u00c5\\u00bd|Z, \\u00c5\\u00a1|s, \\u00c5\\u201c|oe, \\u00c5\\u00be|z, \\u00c5\\u00b8|Y, \\u00c2\\u00a5|Y, \\u00c2\\u00b5|u, \\u00c3\\u20ac|A, \\u00c3\\ufffd|A, \\u00c3\\u201a|A, \\u00c3\\u0192|A, \\u00c3\\u201e|A, \\u00c3\\u2026|A, \\u00c3\\u2020|A, \\u00c3\\u2021|C, \\u00c3\\u02c6|E, \\u00c3\\u2030|E, \\u00c3\\u0160|E, \\u00c3\\u2039|E, \\u00c3\\u0152|I, \\u00c3\\ufffd|I, \\u00c3\\u017d|I, \\u00c3\\ufffd|I, \\u00c3\\ufffd|D, \\u00c3\\u2018|N, \\u00c3\\u2019|O, \\u00c3\\u201c|O, \\u00c3\\u201d|O, \\u00c3\\u2022|O, \\u00c3\\u2013|O, \\u00c3\\u02dc|O, \\u00c3\\u2122|U, \\u00c3\\u0161|U, \\u00c3\\u203a|U, \\u00c3\\u0153|U, \\u00c3\\ufffd|Y, \\u00c3\\u0178|s, \\u00c3\\u00a0|a, \\u00c3\\u00a1|a, \\u00c3\\u00a2|a, \\u00c3\\u00a3|a, \\u00c3\\u00a4|a, \\u00c3\\u00a5|a, \\u00c3\\u00a6|a, \\u00c3\\u00a7|c, \\u00c3\\u00a8|e, \\u00c3\\u00a9|e, \\u00c3\\u00aa|e, \\u00c3\\u00ab|e, \\u00c3\\u00ac|i, \\u00c3\\u00ad|i, \\u00c3\\u00ae|i, \\u00c3\\u00af|i, \\u00c3\\u00b0|o, \\u00c3\\u00b1|n, \\u00c3\\u00b2|o, \\u00c3\\u00b3|o, \\u00c3\\u00b4|o, \\u00c3\\u00b5|o, \\u00c3\\u00b6|o, \\u00c3\\u00b8|o, \\u00c3\\u00b9|u, \\u00c3\\u00ba|u, \\u00c3\\u00bb|u, \\u00c3\\u00bc|u, \\u00c3\\u00bd|y, \\u00c3\\u00bf|y, \\u00c3\\u0178|ss\",\"sh404SefLabelCat\":\"\",\"sh404SefLabelUser\":\"blog\",\"sh404SefLabelItem\":\"2\",\"sh404SefTitleAlias\":\"alias\",\"sh404SefModK2ContentFeedAlias\":\"feed\",\"sh404SefInsertItemId\":\"0\",\"sh404SefInsertUniqueItemId\":\"0\",\"cbIntegration\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(10004,'K2 Comments','module','mod_k2_comments','',0,1,0,0,'{\"name\":\"K2 Comments\",\"type\":\"module\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"MOD_K2_COMMENTS_DESCRIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"module_usage\":\"\",\"\":\"K2_TOP_COMMENTERS\",\"catfilter\":\"0\",\"category_id\":\"\",\"comments_limit\":\"5\",\"comments_word_limit\":\"10\",\"commenterName\":\"1\",\"commentAvatar\":\"1\",\"commentAvatarWidthSelect\":\"custom\",\"commentAvatarWidth\":\"50\",\"commentDate\":\"1\",\"commentDateFormat\":\"absolute\",\"commentLink\":\"1\",\"itemTitle\":\"1\",\"itemCategory\":\"1\",\"feed\":\"1\",\"commenters_limit\":\"5\",\"commenterNameOrUsername\":\"1\",\"commenterAvatar\":\"1\",\"commenterAvatarWidthSelect\":\"custom\",\"commenterAvatarWidth\":\"50\",\"commenterLink\":\"1\",\"commenterCommentsCounter\":\"1\",\"commenterLatestComment\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10005,'K2 Content','module','mod_k2_content','',0,1,0,0,'{\"name\":\"K2 Content\",\"type\":\"module\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"K2_MOD_K2_CONTENT_DESCRIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"getTemplate\":\"Default\",\"source\":\"filter\",\"\":\"K2_OTHER_OPTIONS\",\"catfilter\":\"0\",\"category_id\":\"\",\"getChildren\":\"0\",\"itemCount\":\"5\",\"itemsOrdering\":\"\",\"FeaturedItems\":\"1\",\"popularityRange\":\"\",\"videosOnly\":\"0\",\"item\":\"\",\"items\":\"\",\"itemTitle\":\"1\",\"itemAuthor\":\"1\",\"itemAuthorAvatar\":\"1\",\"itemAuthorAvatarWidthSelect\":\"custom\",\"itemAuthorAvatarWidth\":\"50\",\"userDescription\":\"1\",\"itemIntroText\":\"1\",\"itemIntroTextWordLimit\":\"\",\"itemImage\":\"1\",\"itemImgSize\":\"Small\",\"itemVideo\":\"1\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemAttachments\":\"1\",\"itemTags\":\"1\",\"itemCategory\":\"1\",\"itemDateCreated\":\"1\",\"itemHits\":\"1\",\"itemReadMore\":\"1\",\"itemExtraFields\":\"0\",\"itemCommentsCounter\":\"1\",\"feed\":\"1\",\"itemPreText\":\"\",\"itemCustomLink\":\"0\",\"itemCustomLinkTitle\":\"\",\"itemCustomLinkURL\":\"http:\\/\\/\",\"itemCustomLinkMenuItem\":\"\",\"K2Plugins\":\"1\",\"JPlugins\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10006,'K2 Tools','module','mod_k2_tools','',0,1,0,0,'{\"name\":\"K2 Tools\",\"type\":\"module\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"K2_TOOLS\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"module_usage\":\"0\",\"\":\"K2_CUSTOM_CODE_SETTINGS\",\"archiveItemsCounter\":\"1\",\"archiveCategory\":\"\",\"authors_module_category\":\"\",\"authorItemsCounter\":\"1\",\"authorAvatar\":\"1\",\"authorAvatarWidthSelect\":\"custom\",\"authorAvatarWidth\":\"50\",\"authorLatestItem\":\"1\",\"calendarCategory\":\"\",\"home\":\"\",\"seperator\":\"\",\"root_id\":\"\",\"end_level\":\"\",\"categoriesListOrdering\":\"\",\"categoriesListItemsCounter\":\"1\",\"root_id2\":\"\",\"catfilter\":\"0\",\"category_id\":\"\",\"getChildren\":\"0\",\"liveSearch\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"imagebutton\":\"\",\"button_text\":\"\",\"min_size\":\"75\",\"max_size\":\"300\",\"cloud_limit\":\"30\",\"cloud_category\":\"0\",\"cloud_category_recursive\":\"0\",\"customCode\":\"\",\"parsePhp\":\"0\",\"K2Plugins\":\"0\",\"JPlugins\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10007,'K2 Users','module','mod_k2_users','',0,1,0,0,'{\"name\":\"K2 Users\",\"type\":\"module\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"K2_MOD_K2_USERS_DESCRTIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"getTemplate\":\"Default\",\"source\":\"0\",\"\":\"K2_DISPLAY_OPTIONS\",\"filter\":\"1\",\"K2UserGroup\":\"\",\"ordering\":\"1\",\"limit\":\"4\",\"userIDs\":\"\",\"userName\":\"1\",\"userAvatar\":\"1\",\"userAvatarWidthSelect\":\"custom\",\"userAvatarWidth\":\"50\",\"userDescription\":\"1\",\"userDescriptionWordLimit\":\"\",\"userURL\":\"1\",\"userEmail\":\"0\",\"userFeed\":\"1\",\"userItemCount\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10008,'K2 User','module','mod_k2_user','',0,1,0,0,'{\"name\":\"K2 User\",\"type\":\"module\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"K2_MOD_K2_USER_DESCRIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"pretext\":\"\",\"\":\"K2_LOGIN_LOGOUT_REDIRECTION\",\"name\":\"1\",\"userAvatar\":\"1\",\"userAvatarWidthSelect\":\"custom\",\"userAvatarWidth\":\"50\",\"menu\":\"\",\"login\":\"\",\"logout\":\"\",\"usesecure\":\"0\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10009,'K2 Quick Icons (admin)','module','mod_k2_quickicons','',1,1,2,0,'{\"name\":\"K2 Quick Icons (admin)\",\"type\":\"module\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"K2_QUICKICONS_FOR_USE_IN_THE_JOOMLA_CONTROL_PANEL_DASHBOARD_PAGE\",\"group\":\"\"}','{\"modCSSStyling\":\"1\",\"modLogo\":\"1\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10010,'K2 Stats (admin)','module','mod_k2_stats','',1,1,2,0,'{\"name\":\"K2 Stats (admin)\",\"type\":\"module\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"K2_STATS_FOR_USE_IN_THE_K2_DASHBOARD_PAGE\",\"group\":\"\"}','{\"latestItems\":\"1\",\"popularItems\":\"1\",\"mostCommentedItems\":\"1\",\"latestComments\":\"1\",\"statistics\":\"1\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10011,'plg_finder_k2','plugin','k2','finder',0,1,1,0,'{\"name\":\"plg_finder_k2\",\"type\":\"plugin\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"PLG_FINDER_K2_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10012,'Search - K2','plugin','k2','search',0,1,1,0,'{\"name\":\"Search - K2\",\"type\":\"plugin\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"K2_THIS_PLUGIN_EXTENDS_THE_DEFAULT_JOOMLA_SEARCH_FUNCTIONALITY_TO_K2_CONTENT\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_tags\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(10013,'System - K2','plugin','k2','system',0,1,1,0,'{\"name\":\"System - K2\",\"type\":\"plugin\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"K2_THE_K2_SYSTEM_PLUGIN_IS_USED_TO_ASSIST_THE_PROPER_FUNCTIONALITY_OF_THE_K2_COMPONENT_SITE_WIDE_MAKE_SURE_ITS_ALWAYS_PUBLISHED_WHEN_THE_K2_COMPONENT_IS_INSTALLED\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10014,'User - K2','plugin','k2','user',0,1,1,0,'{\"name\":\"User - K2\",\"type\":\"plugin\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"K2_A_USER_SYNCHRONIZATION_PLUGIN_FOR_K2\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10015,'Josetta - K2 Categories','plugin','k2category','josetta_ext',0,1,1,0,'{\"name\":\"Josetta - K2 Categories\",\"type\":\"plugin\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10016,'Josetta - K2 Items','plugin','k2item','josetta_ext',0,1,1,0,'{\"name\":\"Josetta - K2 Items\",\"type\":\"plugin\",\"creationDate\":\"June 7th, 2012\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10017,'mod_gk_register','module','mod_gk_register','',0,1,0,0,'{\"name\":\"mod_gk_register\",\"type\":\"module\",\"creationDate\":\"14\\/02\\/2011\",\"author\":\"Gavick.com\",\"copyright\":\"(C) 2009-2011 Gavick.com\",\"authorEmail\":\"info@gavick.com\",\"authorUrl\":\"www.gavick.com\",\"version\":\"GK4 1.0\",\"description\":\"GavickPro register form\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10018,'Authentication - Facebook','plugin','facebook','authentication',0,1,1,0,'{\"name\":\"Authentication - Facebook\",\"type\":\"plugin\",\"creationDate\":\"31 December 2011\",\"author\":\"GavickPro\",\"copyright\":\"Copyright (C) 2010 - 2011 GavickPro. All rights reserved.\",\"authorEmail\":\"support@gavick.com\",\"authorUrl\":\"http:\\/\\/gavick.com\",\"version\":\"GK4 1.2\",\"description\":\"GavickPro Facebook authentication plugin\",\"group\":\"\"}','{\"auto_register\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(10019,'System - GK Extended Cache','plugin','gavickExtCache','system',0,0,1,0,'{\"name\":\"System - GK Extended Cache\",\"type\":\"plugin\",\"creationDate\":\"25 August 2011\",\"author\":\"www.gavick.com\",\"copyright\":\"All Rights Reserved.\",\"authorEmail\":\"test@gavick.com\",\"authorUrl\":\"http:\\/\\/www.gavick.com\",\"version\":\"1.0\",\"description\":\"Alternative for system cache plugin for GavickPro templates\",\"group\":\"\"}','[]','','',0,'0000-00-00 00:00:00',0,0),(10020,'System - GK Open Graph Article Parameters','plugin','plg_gk_opengraph','system',0,0,1,0,'{\"name\":\"System - GK Open Graph Article Parameters\",\"type\":\"plugin\",\"creationDate\":\"01 May 2010\",\"author\":\"www.gavick.com\",\"copyright\":\"All Rights Reserved.\",\"authorEmail\":\"test@gavick.com\",\"authorUrl\":\"http:\\/\\/www.gavick.com\",\"version\":\"1.0\",\"description\":\"Plugin which adds additional article options for GavickPro templates\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10021,'Button - GK Typography','plugin','gk_typography','editors-xtd',0,1,1,0,'{\"name\":\"Button - GK Typography\",\"type\":\"plugin\",\"creationDate\":\"08\\/01\\/2011\",\"author\":\"Robert Gavick - GavickPro\",\"copyright\":\"Copyrighted Commercial Software\",\"authorEmail\":\"info@gavick.com\",\"authorUrl\":\"http:\\/\\/www.gavick.com\",\"version\":\"1.0.2\",\"description\":\"Plugin to easier typography using in Joomla WYSIWYG editors.\",\"group\":\"\"}','{\"typo_override\":\"gk_magazine:full.xml\"}','','',0,'0000-00-00 00:00:00',0,0),(10022,'System - GK Cache','plugin','plg_gkcache','system',0,0,1,0,'{\"name\":\"System - GK Cache\",\"type\":\"plugin\",\"creationDate\":\"25 August 2011\",\"author\":\"www.gavick.com\",\"copyright\":\"All Rights Reserved.\",\"authorEmail\":\"test@gavick.com\",\"authorUrl\":\"http:\\/\\/www.gavick.com\",\"version\":\"1.0\",\"description\":\"Plugin necessary if you\'re using Joomla! cache for GavickPro templates\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10023,'GK Menu Extended Parameters','plugin','gkextmenu','system',0,1,1,0,'{\"name\":\"GK Menu Extended Parameters\",\"type\":\"plugin\",\"creationDate\":\"29 December 2010\",\"author\":\"www.gavick.com\",\"copyright\":\"All Rights Reserved.\",\"authorEmail\":\"support@gavick.com\",\"authorUrl\":\"http:\\/\\/www.gavick.com\",\"version\":\"1.0\",\"description\":\"Plugin which adds additional menu options for GavickPro templates\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10024,'GK Module Title Links','plugin','plg_gkmodulelinks','system',0,0,1,0,'{\"name\":\"GK Module Title Links\",\"type\":\"plugin\",\"creationDate\":\"29 July 2012\",\"author\":\"www.gavick.com\",\"copyright\":\"All Rights Reserved.\",\"authorEmail\":\"test@gavick.com\",\"authorUrl\":\"http:\\/\\/www.gavick.com\",\"version\":\"1.0\",\"description\":\"Plugin which adds additional module options for module titles in GavickPRO Templates.\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10025,'Tabs GK5','module','mod_tabs_gk5','',0,1,0,0,'{\"name\":\"Tabs GK5\",\"type\":\"module\",\"creationDate\":\"19\\/10\\/2012\",\"author\":\"GavickPro\",\"copyright\":\"Copyright (C) 2011-2012 GavickPro. All rights reserved.\",\"authorEmail\":\"info@gavick.com\",\"authorUrl\":\"www.gavickpro.com\",\"version\":\"GK5 1.2\",\"description\":\"\\n\\t\\t<style type=\\\"text\\/css\\\">\\n\\t\\t\\tspan.readonly { padding: 10px; font-family: Arial; font-size:13px !important; font-weight: normal !important; text-align: justify; color: #4d4d4d; line-height: 24px; }\\n\\t\\t\\tspan.readonly h1 { clear:both; font-family: Georgia, sans-serif; font-size:38px; margin:30px 20px 23px; padding:0px 0px 24px 10px; color:#333; border-bottom: 1px solid #eee; font-weight: normal; }\\n\\t\\t\\tspan.readonly p { margin: 0 26px 10px }\\n\\t\\t\\tspan.readonly p a { color: #2F4C6D }\\n\\t\\t\\tspan.readonly p.homepage { margin-top: 30px }\\n\\t\\t\\tspan.readonly p.license { border-top: 1px solid #eee; font-size: 11px; margin: 30px 26px 0; padding: 6px 0; }\\n\\t\\t<\\/style>\\n\\t\\t\\n\\t\\t<span class=\\\"readonly\\\"><h1>Tabs GK5<small>ver. 1.2<\\/small><\\/h1><p>GK5 is one product of the next generation of GavickPro extensions designed exclusively for Joomla 2.5+.<\\/p><p>With the Tabs GK5 module, you can implement space-saving tabs on websites and incorporate a variety of content types via modules or user-defined custom HTML code.  Thanks to the tab management system we\'ve integrated into the module, Tabs GK5 remains easy, intuitive and quick to configure.  With built-in support for external data sources, the possibilities for implementing this new release are unlimited!<\\/p> <p class=\'homepage\'><a href=\'https:\\/\\/www.gavick.com\\/best-free-joomla-tab-module.html\' target=\'_blank\'>Learn more at the Tabs GK5 project website.<\\/a><\\/p><p class=\'license\'>Tabs GK5 is released under the <a target=\\\"_blank\\\" href=\\\"http:\\/\\/www.gnu.org\\/licenses\\/gpl-2.0.html\\\">GNU\\/GPL v2 license.<\\/a><\\/p><\\/span>\\n\\t\",\"group\":\"\"}','{\"automatic_module_id\":\"1\",\"module_id\":\"gk-tab-1\",\"moduleclass_sfx\":\"\",\"module_data_source\":\"tabsmanager\",\"external_source\":\"\",\"styleCSS\":\"style1\",\"module_auto_height\":\"1\",\"module_height\":\"200\",\"tabs_position\":\"top\",\"tabs_width\":\"200\",\"tabs_spans\":\"0\",\"buttons\":\"1\",\"activator\":\"click\",\"animation\":\"1\",\"animation_speed\":\"250\",\"animation_interval\":\"5000\",\"animation_type\":\"opacity\",\"animation_function\":\"Fx.Transitions.linear\",\"url_tab_selection\":\"1\",\"cookie_tab_selection\":\"0\",\"parse_plugins\":\"1\",\"useCSS\":\"1\",\"useScript\":\"1\",\"engine_mode\":\"mootools\",\"include_jquery\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(10028,'gk_magazine','template','gk_magazine','',0,1,1,0,'{\"name\":\"gk_magazine\",\"type\":\"template\",\"creationDate\":\"08 February 2013\",\"author\":\"GavickPro\",\"copyright\":\"Copyright (C) 2007 - 2013 GavickPro. All rights reserved.\",\"authorEmail\":\"support@gavick.com\",\"authorUrl\":\"http:\\/\\/gavick.com\",\"version\":\"3.8\",\"description\":\"\\n\\t\\t\\t\\t\\t\\t<link rel=\\\"stylesheet\\\" type=\\\"text\\/css\\\" href=\\\"..\\/templates\\/gk_magazine\\/admin\\/style.css\\\" \\/>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<style type=\\\"text\\/css\\\" media=\\\"all\\\">\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<!--\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t#wrap1 {padding:0px 0px 4px 0px;}\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t#wrap1 h1 {clear:both;font-family: Georgia, sans-serif;font-size:38px;margin:30px 20px 12px ;padding:0px 0px 24px 10px;color:#333; border-bottom: 1px solid #ccc; font-weight: normal;}\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t#wrap1 h4 { border: none;  margin: 0 0 12px; padding:0; font: italic 20px\\/32px Georgia, sans-serif; color: #333; }\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t#wrap1 sup { font-style: italic; font-size: }\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t#wrap1 .wrap2 {background:#fff;padding: 20px; font-family: Arial; font-size:13px; text-align: justify; color: #4d4d4d; line-height: 24px;}\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t#wrap1 .leftart {margin: 16px 0 0 176px; font-weight:normal!important; }\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t#wrap1 .livedemo { margin-top: 28px; }\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t-->\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<\\/style>\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<div id=\\\"wrap1\\\">    \\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<h1><em>Magazine<\\/em><\\/h1>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<div class=\\\"wrap2\\\">                    \\n\\t\\t\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<a title=\\\"Visit the official website!\\\" href=\\\"http:\\/\\/demo.gavick.com\\/joomla25\\/magazine\\/\\\" target=\\\"_blank\\\"> <img style=\\\"padding-left: 10px;float: left; background-color: #fff;\\\" src=\\\"..\\/templates\\/gk_magazine\\/images\\/template_image.jpg\\\" border=\\\"0\\\" alt=\\\"Logo\\\" \\/><\\/a>       \\n\\t\\t\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<div class=\\\"leftart\\\">            \\n\\t\\t\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<h4>Joomla! Blog \\/ Magazine Template  <\\/h4>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<p>\\tCome out of the shadow, present your online identity by creating your blog or other personal website with Magazine Joomla! template.<\\/p><p>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\tIt catches visitors attention by its simplicity and, at the same time, advanced and sophisticated look. <\\/p><p>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\tYour blog can be unique thanks to this Joomla! template that has Responsive Web Design support and tile-like interface use; inspired by Windows 8. Metro style makes this Joomla template a desirable product as itdisplays perfectly on Windows tablets and other mobile devices.  <\\/p><p>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\tIs unimaginable how easy a website\'s navigation can be! With this Joomla template it really is! Clickable tiles look not only attractive and stylish but they are also extremely useful!<\\/p><p>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\tThe template also uses the following extensions: K2, News Show Pro GK4 prepared with special modes and Tabs GK5. Content management on your website is easier as never before. It is done thanks to GavickPro products, their possibilities and improvements implemented.<\\/p><p>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\tStill considering what to do? Make up your mind and click \\\"buy now\\\" button. It\'s so easy...  \\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<\\/p>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<p class=\\\"livedemo\\\">View Magazine template in action <a href=\\\"http:\\/\\/demo.gavick.com\\/joomla25\\/magazine\\/\\\" target=\\\"_blank\\\">here<\\/a>...<\\/p><small>Gavern v.3.8<\\/small><\\/div>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<\\/div>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<\\/div>\\n\\t\\t\\t\",\"group\":\"\"}','{\"template_color\":\"1\",\"default_layout\":\"default\",\"layout_position\":\"left\",\"template_width\":\"1230\",\"tablet_width\":\"1024\",\"tablet_small_width\":\"820\",\"mobile_width\":\"580\",\"sidebar_position\":\"right\",\"sidebar_width\":\"30\",\"inset_position\":\"right\",\"inset_width\":\"30\",\"login_url\":\"\",\"rss_link\":\"1\",\"rss_url\":\"\",\"mail_link\":\"1\",\"mail_url\":\"\",\"reg_link\":\"1\",\"reg_url\":\"\",\"logo_type\":\"image\",\"logo_image\":\"\",\"logo_text\":\"\",\"logo_slogan\":\"\",\"print_logo\":\"\",\"print_behaviour\":\"1\",\"favicon_image\":\"\",\"stylearea\":\"1\",\"framework_logo\":\"1\",\"webmaster_contact_type\":\"1\",\"webmaster_contact\":\"webmaster@gavick.com\",\"typography\":\"0\",\"typo_iconset\":\"0\",\"tools\":\"1\",\"show_menu\":\"1\",\"startlevel\":\"0\",\"endlevel\":\"-1\",\"menu_animation\":\"slide\",\"menu_height\":\"0\",\"menu_width\":\"0\",\"menu_col_width\":\"200\",\"menu_duration\":\"500\",\"fb_api_id\":\"\",\"fb_lang\":\"en_US\",\"fb_login\":\"0\",\"fb_like\":\"0\",\"fb_like_send\":\"0\",\"fb_like_layout\":\"standard\",\"fb_like_show_faces\":\"true\",\"fb_like_width\":\"500\",\"fb_like_action\":\"like\",\"fb_like_font\":\"arial\",\"fb_like_colorscheme\":\"light\",\"google_plus\":\"1\",\"google_plus_count\":\"1\",\"google_plus_size\":\"medium\",\"google_plus_lang\":\"en-GB\",\"google_plus_share\":\"1\",\"google_plus_share_annotation\":\"vertical-bubble\",\"google_plus_share_size\":\"20\",\"tweet_btn\":\"0\",\"tweet_btn_data_count\":\"vertical\",\"tweet_btn_data_via\":\"\",\"tweet_btn_data_lang\":\"en\",\"pinterest_btn\":\"0\",\"pinterest_btn_style\":\"horizontal\",\"excluded_cats\":\"\",\"cookie_consent\":\"0\",\"consenttype\":\"explicit\",\"cookie_latest_version\":\"0\",\"cookie_use_ssl\":\"0\",\"banner_position\":\"bottom\",\"banner_tag_placement\":\"bottom-right\",\"cookie_style\":\"light\",\"refreshOnConsent\":\"0\",\"cookiecss\":\"1\",\"use_gk_cache\":\"0\",\"css_cache\":\"0\",\"css_compression\":\"0\",\"css_override\":\"0\",\"css_prefixer\":\"0\",\"js_compression\":\"0\",\"chrome_frame_support\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0);


--
-- Table structure for table `#__finder_filters`
--



CREATE TABLE `#__finder_filters` (
  `filter_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '1',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL,
  `created_by_alias` varchar(255) NOT NULL,
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `map_count` int(10) unsigned NOT NULL DEFAULT '0',
  `data` text NOT NULL,
  `params` mediumtext,
  PRIMARY KEY (`filter_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_filters`
--




--
-- Table structure for table `#__finder_links`
--



CREATE TABLE `#__finder_links` (
  `link_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `url` varchar(255) NOT NULL,
  `route` varchar(255) NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `indexdate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `md5sum` varchar(32) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '1',
  `state` int(5) DEFAULT '1',
  `access` int(5) DEFAULT '0',
  `language` varchar(8) NOT NULL,
  `publish_start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `list_price` double unsigned NOT NULL DEFAULT '0',
  `sale_price` double unsigned NOT NULL DEFAULT '0',
  `type_id` int(11) NOT NULL,
  `object` mediumblob NOT NULL,
  PRIMARY KEY (`link_id`),
  KEY `idx_type` (`type_id`),
  KEY `idx_title` (`title`),
  KEY `idx_md5` (`md5sum`),
  KEY `idx_url` (`url`(75)),
  KEY `idx_published_list` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`list_price`),
  KEY `idx_published_sale` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`sale_price`)
) ENGINE=InnoDB AUTO_INCREMENT=55 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links`
--


INSERT INTO `#__finder_links` (`link_id`, `url`, `route`, `title`, `description`, `indexdate`, `md5sum`, `published`, `state`, `access`, `language`, `publish_start_date`, `publish_end_date`, `start_date`, `end_date`, `list_price`, `sale_price`, `type_id`, `object`) VALUES (1,'index.php?option=com_k2&view=item&id=1','index.php?option=com_k2&view=item&id=1:macbook-air-models-200-off-at-best-buy-for-2-days&Itemid=133','MacBook Air models $200 off at best buy for 2 days','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-07 16:56:48','826a68522437cbc6ac5484bc3d969cbf',1,1,1,'*','2012-11-06 12:40:30','0000-00-00 00:00:00','2012-11-06 12:40:30','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":19:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"1\";s:5:\"alias\";s:49:\"macbook-air-models-200-off-at-best-buy-for-2-days\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1062:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n\r\n\r\n<ul>\r\n<li>Lorem Ipsum</li>\r\n<li>Lorem Ipsum</li>\r\n<li>Lorem Ipsum</li>\r\n</ul>\r\n<ol>\r\n<li>Lorem Ipsum</li>\r\n<li>Lorem Ipsum</li>\r\n<li>Lorem Ipsum</li>\r\n</ol>\";s:5:\"catid\";s:1:\"4\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-07 15:56:48\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":138:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"1\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:10:\"Ultrabooks\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:51:\"1:macbook-air-models-200-off-at-best-buy-for-2-days\";s:7:\"catslug\";s:12:\"4:ultrabooks\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:79:\"index.php/home/k2-item/item/1-macbook-air-models-200-off-at-best-buy-for-2-days\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:10:\"Ultrabooks\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Ultrabooks\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:38:\"index.php?option=com_k2&view=item&id=1\";s:5:\"route\";s:99:\"index.php?option=com_k2&view=item&id=1:macbook-air-models-200-off-at-best-buy-for-2-days&Itemid=133\";s:5:\"title\";s:50:\"MacBook Air models $200 off at best buy for 2 days\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-11-06 12:40:30\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-11-06 12:40:30\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;s:15:\"defaultLanguage\";s:5:\"en-GB\";}'),(2,'index.php?option=com_k2&view=item&id=2','index.php?option=com_k2&view=item&id=2:the-xperia-tablet-s-is-a-touchscreen-android-tablet-designed-by-sony&Itemid=164','The Xperia Tablet S is a touchscreen Android tablet designed by Sony','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-04 09:06:29','100b67e23c10e7349b7e3eebbfc15975',1,1,1,'*','2012-11-06 12:42:22','0000-00-00 00:00:00','2012-11-06 12:42:22','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"2\";s:5:\"alias\";s:68:\"the-xperia-tablet-s-is-a-touchscreen-android-tablet-designed-by-sony\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1611:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>\";s:5:\"catid\";s:1:\"2\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-04 08:06:26\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":241:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"2\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:6:\"Medium\";s:17:\"num_primary_items\";s:1:\"2\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:6:\"Medium\";s:19:\"num_secondary_items\";s:1:\"0\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:6:\"Medium\";s:9:\"num_links\";s:1:\"0\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:6:\"XSmall\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"1\";s:13:\"subCatColumns\";s:1:\"1\";s:11:\"subCatTitle\";s:1:\"1\";s:22:\"subCatTitleItemCounter\";s:1:\"1\";s:17:\"subCatDescription\";s:1:\"1\";s:11:\"subCatImage\";s:1:\"1\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"1\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"0\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"0\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"0\";s:16:\"itemDateModified\";s:1:\"0\";s:8:\"itemHits\";s:1:\"0\";s:12:\"itemCategory\";s:1:\"0\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"0\";s:22:\"itemAttachmentsCounter\";s:1:\"0\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"0\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"0\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"2\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:8:\"Tablet\'s\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:70:\"2:the-xperia-tablet-s-is-a-touchscreen-android-tablet-designed-by-sony\";s:7:\"catslug\";s:9:\"2:tablets\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:105:\"index.php/k2/categories/world/item/2-the-xperia-tablet-s-is-a-touchscreen-android-tablet-designed-by-sony\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:8:\"Tablet\'s\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Tablet\'s\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:38:\"index.php?option=com_k2&view=item&id=2\";s:5:\"route\";s:118:\"index.php?option=com_k2&view=item&id=2:the-xperia-tablet-s-is-a-touchscreen-android-tablet-designed-by-sony&Itemid=164\";s:5:\"title\";s:68:\"The Xperia Tablet S is a touchscreen Android tablet designed by Sony\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-11-06 12:42:22\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-11-06 12:42:22\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(3,'index.php?option=com_k2&view=item&id=3','index.php?option=com_k2&view=item&id=3:samsung-has-redesigned-its-smart-hub-tv-system&Itemid=165','Samsung has redesigned its Smart Hub TV system','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-04 09:08:21','a62bd6d173d6d83bb47c5eff4f49c039',1,1,1,'*','2012-11-06 12:44:09','0000-00-00 00:00:00','2012-11-06 12:44:09','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"3\";s:5:\"alias\";s:46:\"samsung-has-redesigned-its-smart-hub-tv-system\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1611:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>\";s:5:\"catid\";s:1:\"3\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-04 08:08:17\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":241:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"2\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:6:\"Medium\";s:17:\"num_primary_items\";s:1:\"2\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:6:\"Medium\";s:19:\"num_secondary_items\";s:1:\"0\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:6:\"Medium\";s:9:\"num_links\";s:1:\"0\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:6:\"XSmall\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"1\";s:13:\"subCatColumns\";s:1:\"1\";s:11:\"subCatTitle\";s:1:\"1\";s:22:\"subCatTitleItemCounter\";s:1:\"1\";s:17:\"subCatDescription\";s:1:\"1\";s:11:\"subCatImage\";s:1:\"1\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"1\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"0\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"0\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"0\";s:16:\"itemDateModified\";s:1:\"0\";s:8:\"itemHits\";s:1:\"0\";s:12:\"itemCategory\";s:1:\"0\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"0\";s:22:\"itemAttachmentsCounter\";s:1:\"0\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"0\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"0\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"2\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:3:\"TVs\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:48:\"3:samsung-has-redesigned-its-smart-hub-tv-system\";s:7:\"catslug\";s:5:\"3:tvs\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:81:\"index.php/k2/categories/u-s/item/3-samsung-has-redesigned-its-smart-hub-tv-system\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:3:\"TVs\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:3:\"TVs\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:38:\"index.php?option=com_k2&view=item&id=3\";s:5:\"route\";s:96:\"index.php?option=com_k2&view=item&id=3:samsung-has-redesigned-its-smart-hub-tv-system&Itemid=165\";s:5:\"title\";s:46:\"Samsung has redesigned its Smart Hub TV system\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-11-06 12:44:09\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-11-06 12:44:09\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(4,'index.php?option=com_k2&view=item&id=4','index.php?option=com_k2&view=item&id=4:kevin-durant-has-oklahoma-city-thunder-ing-along-at-the-top&Itemid=165','Kevin Durant has Oklahoma City Thunder-ing along at the top','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-04 09:09:37','5e1a17305e2530434cfa6fb5490440cc',1,1,1,'*','2012-11-06 12:45:42','0000-00-00 00:00:00','2012-11-06 12:45:42','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"4\";s:5:\"alias\";s:59:\"kevin-durant-has-oklahoma-city-thunder-ing-along-at-the-top\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1611:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>\";s:5:\"catid\";s:1:\"3\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-04 08:09:34\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":241:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"2\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:6:\"Medium\";s:17:\"num_primary_items\";s:1:\"2\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:6:\"Medium\";s:19:\"num_secondary_items\";s:1:\"0\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:6:\"Medium\";s:9:\"num_links\";s:1:\"0\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:6:\"XSmall\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"1\";s:13:\"subCatColumns\";s:1:\"1\";s:11:\"subCatTitle\";s:1:\"1\";s:22:\"subCatTitleItemCounter\";s:1:\"1\";s:17:\"subCatDescription\";s:1:\"1\";s:11:\"subCatImage\";s:1:\"1\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"1\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"0\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"0\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"0\";s:16:\"itemDateModified\";s:1:\"0\";s:8:\"itemHits\";s:1:\"0\";s:12:\"itemCategory\";s:1:\"0\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"0\";s:22:\"itemAttachmentsCounter\";s:1:\"0\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"0\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"0\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"1\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:3:\"TVs\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:61:\"4:kevin-durant-has-oklahoma-city-thunder-ing-along-at-the-top\";s:7:\"catslug\";s:5:\"3:tvs\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:94:\"index.php/k2/categories/u-s/item/4-kevin-durant-has-oklahoma-city-thunder-ing-along-at-the-top\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:3:\"TVs\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:3:\"TVs\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:38:\"index.php?option=com_k2&view=item&id=4\";s:5:\"route\";s:109:\"index.php?option=com_k2&view=item&id=4:kevin-durant-has-oklahoma-city-thunder-ing-along-at-the-top&Itemid=165\";s:5:\"title\";s:59:\"Kevin Durant has Oklahoma City Thunder-ing along at the top\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-11-06 12:45:42\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-11-06 12:45:42\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(5,'index.php?option=com_k2&view=item&id=5','index.php?option=com_k2&view=item&id=5:what-does-3d-ready-tv-mean-3d-ready-television-explained&Itemid=165','What does 3D Ready TV Mean? – 3D Ready Television Explained','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-04 09:12:06','14c4cbaa6240ea9a16b24b1dda17fc7d',1,1,1,'*','2012-11-06 12:47:31','0000-00-00 00:00:00','2012-11-06 12:47:31','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"5\";s:5:\"alias\";s:56:\"what-does-3d-ready-tv-mean-3d-ready-television-explained\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1611:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>\";s:5:\"catid\";s:1:\"3\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-04 08:12:02\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":241:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"2\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:6:\"Medium\";s:17:\"num_primary_items\";s:1:\"2\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:6:\"Medium\";s:19:\"num_secondary_items\";s:1:\"0\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:6:\"Medium\";s:9:\"num_links\";s:1:\"0\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:6:\"XSmall\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"1\";s:13:\"subCatColumns\";s:1:\"1\";s:11:\"subCatTitle\";s:1:\"1\";s:22:\"subCatTitleItemCounter\";s:1:\"1\";s:17:\"subCatDescription\";s:1:\"1\";s:11:\"subCatImage\";s:1:\"1\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"1\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"0\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"0\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"0\";s:16:\"itemDateModified\";s:1:\"0\";s:8:\"itemHits\";s:1:\"0\";s:12:\"itemCategory\";s:1:\"0\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"0\";s:22:\"itemAttachmentsCounter\";s:1:\"0\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"0\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"0\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"4\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:3:\"TVs\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:58:\"5:what-does-3d-ready-tv-mean-3d-ready-television-explained\";s:7:\"catslug\";s:5:\"3:tvs\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:91:\"index.php/k2/categories/u-s/item/5-what-does-3d-ready-tv-mean-3d-ready-television-explained\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:3:\"TVs\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:3:\"TVs\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:38:\"index.php?option=com_k2&view=item&id=5\";s:5:\"route\";s:106:\"index.php?option=com_k2&view=item&id=5:what-does-3d-ready-tv-mean-3d-ready-television-explained&Itemid=165\";s:5:\"title\";s:61:\"What does 3D Ready TV Mean? – 3D Ready Television Explained\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-11-06 12:47:31\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-11-06 12:47:31\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(6,'index.php?option=com_k2&view=item&id=6','index.php?option=com_k2&view=item&id=6:google-nexus-7-offers-a-pure-android-user-experience&Itemid=120','Google Nexus 7 offers a \"pure Android\" user experience','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-04 09:15:21','a9e18f869c74bcb894e9be5c3bcc1a87',1,1,1,'*','2012-11-06 12:49:33','0000-00-00 00:00:00','2012-11-06 12:49:33','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"6\";s:5:\"alias\";s:52:\"google-nexus-7-offers-a-pure-android-user-experience\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1611:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>\";s:5:\"catid\";s:1:\"2\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-04 08:15:17\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":241:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"2\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:6:\"Medium\";s:17:\"num_primary_items\";s:1:\"2\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:6:\"Medium\";s:19:\"num_secondary_items\";s:1:\"0\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:6:\"Medium\";s:9:\"num_links\";s:1:\"0\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:6:\"XSmall\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"1\";s:13:\"subCatColumns\";s:1:\"1\";s:11:\"subCatTitle\";s:1:\"1\";s:22:\"subCatTitleItemCounter\";s:1:\"1\";s:17:\"subCatDescription\";s:1:\"1\";s:11:\"subCatImage\";s:1:\"1\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"1\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"0\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"0\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"0\";s:16:\"itemDateModified\";s:1:\"0\";s:8:\"itemHits\";s:1:\"0\";s:12:\"itemCategory\";s:1:\"0\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"0\";s:22:\"itemAttachmentsCounter\";s:1:\"0\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"0\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"0\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"2\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:8:\"Tablet\'s\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:54:\"6:google-nexus-7-offers-a-pure-android-user-experience\";s:7:\"catslug\";s:9:\"2:tablets\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:72:\"index.php/k2/item/6-google-nexus-7-offers-a-pure-android-user-experience\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:8:\"Tablet\'s\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Tablet\'s\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:38:\"index.php?option=com_k2&view=item&id=6\";s:5:\"route\";s:102:\"index.php?option=com_k2&view=item&id=6:google-nexus-7-offers-a-pure-android-user-experience&Itemid=120\";s:5:\"title\";s:54:\"Google Nexus 7 offers a \"pure Android\" user experience\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-11-06 12:49:33\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-11-06 12:49:33\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(7,'index.php?option=com_k2&view=item&id=7','index.php?option=com_k2&view=item&id=7:head-to-head-samsung-galaxy-note-10-3-vs-apple-ipad-4&Itemid=164','Head-to-Head: Samsung Galaxy Note 10.3 vs. Apple iPad 4','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-04 09:18:21','7a86b1eb6f0938982dcbc6557f640760',1,1,1,'*','2012-11-06 12:51:54','0000-00-00 00:00:00','2012-11-06 12:51:54','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"7\";s:5:\"alias\";s:53:\"head-to-head-samsung-galaxy-note-10-3-vs-apple-ipad-4\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1611:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>\";s:5:\"catid\";s:1:\"2\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-04 08:18:18\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":241:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"2\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:6:\"Medium\";s:17:\"num_primary_items\";s:1:\"2\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:6:\"Medium\";s:19:\"num_secondary_items\";s:1:\"0\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:6:\"Medium\";s:9:\"num_links\";s:1:\"0\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:6:\"XSmall\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"1\";s:13:\"subCatColumns\";s:1:\"1\";s:11:\"subCatTitle\";s:1:\"1\";s:22:\"subCatTitleItemCounter\";s:1:\"1\";s:17:\"subCatDescription\";s:1:\"1\";s:11:\"subCatImage\";s:1:\"1\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"1\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"0\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"0\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"0\";s:16:\"itemDateModified\";s:1:\"0\";s:8:\"itemHits\";s:1:\"0\";s:12:\"itemCategory\";s:1:\"0\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"0\";s:22:\"itemAttachmentsCounter\";s:1:\"0\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"0\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"0\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"3\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:8:\"Tablet\'s\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:55:\"7:head-to-head-samsung-galaxy-note-10-3-vs-apple-ipad-4\";s:7:\"catslug\";s:9:\"2:tablets\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:90:\"index.php/k2/categories/world/item/7-head-to-head-samsung-galaxy-note-10-3-vs-apple-ipad-4\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:8:\"Tablet\'s\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Tablet\'s\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:38:\"index.php?option=com_k2&view=item&id=7\";s:5:\"route\";s:103:\"index.php?option=com_k2&view=item&id=7:head-to-head-samsung-galaxy-note-10-3-vs-apple-ipad-4&Itemid=164\";s:5:\"title\";s:55:\"Head-to-Head: Samsung Galaxy Note 10.3 vs. Apple iPad 4\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-11-06 12:51:54\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-11-06 12:51:54\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(8,'index.php?option=com_k2&view=item&id=8','index.php?option=com_k2&view=item&id=8:apple-to-update-macbook-pro-and-macbook-air-in-june-2013&Itemid=167','Apple to Update MacBook Pro and MacBook Air in June 2013','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-04 09:21:04','9deec3e631dbc6aae15d280820ccf04b',1,1,1,'*','2012-11-06 12:53:19','0000-00-00 00:00:00','2012-11-06 12:53:19','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"8\";s:5:\"alias\";s:56:\"apple-to-update-macbook-pro-and-macbook-air-in-june-2013\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1611:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>\";s:5:\"catid\";s:1:\"4\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-04 08:20:59\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":241:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"2\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:6:\"Medium\";s:17:\"num_primary_items\";s:1:\"2\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:6:\"Medium\";s:19:\"num_secondary_items\";s:1:\"0\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:6:\"Medium\";s:9:\"num_links\";s:1:\"0\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:6:\"XSmall\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"1\";s:13:\"subCatColumns\";s:1:\"1\";s:11:\"subCatTitle\";s:1:\"1\";s:22:\"subCatTitleItemCounter\";s:1:\"1\";s:17:\"subCatDescription\";s:1:\"1\";s:11:\"subCatImage\";s:1:\"1\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"1\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"0\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"0\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"0\";s:16:\"itemDateModified\";s:1:\"0\";s:8:\"itemHits\";s:1:\"0\";s:12:\"itemCategory\";s:1:\"0\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"0\";s:22:\"itemAttachmentsCounter\";s:1:\"0\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"0\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"0\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"4\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:10:\"Ultrabooks\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:58:\"8:apple-to-update-macbook-pro-and-macbook-air-in-june-2013\";s:7:\"catslug\";s:12:\"4:ultrabooks\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:96:\"index.php/k2/categories/economic/item/8-apple-to-update-macbook-pro-and-macbook-air-in-june-2013\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:10:\"Ultrabooks\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Ultrabooks\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:38:\"index.php?option=com_k2&view=item&id=8\";s:5:\"route\";s:106:\"index.php?option=com_k2&view=item&id=8:apple-to-update-macbook-pro-and-macbook-air-in-june-2013&Itemid=167\";s:5:\"title\";s:56:\"Apple to Update MacBook Pro and MacBook Air in June 2013\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-11-06 12:53:19\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-11-06 12:53:19\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(9,'index.php?option=com_k2&view=item&id=9','index.php?option=com_k2&view=item&id=9:dell-s-xps-12-from-an-ultrabook-to-a-tablet-with-a-flip-of-the-display&Itemid=167','Dell\'s XPS 12 from an ultrabook to a tablet with a flip of the display','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-04 09:24:09','c5de118ee618be1ae204e4e9b99463e8',1,1,1,'*','2012-11-06 12:54:57','0000-00-00 00:00:00','2012-11-06 12:54:57','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"9\";s:5:\"alias\";s:70:\"dell-s-xps-12-from-an-ultrabook-to-a-tablet-with-a-flip-of-the-display\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1611:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>\";s:5:\"catid\";s:1:\"4\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-04 08:24:06\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":241:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"2\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:6:\"Medium\";s:17:\"num_primary_items\";s:1:\"2\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:6:\"Medium\";s:19:\"num_secondary_items\";s:1:\"0\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:6:\"Medium\";s:9:\"num_links\";s:1:\"0\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:6:\"XSmall\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"1\";s:13:\"subCatColumns\";s:1:\"1\";s:11:\"subCatTitle\";s:1:\"1\";s:22:\"subCatTitleItemCounter\";s:1:\"1\";s:17:\"subCatDescription\";s:1:\"1\";s:11:\"subCatImage\";s:1:\"1\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"1\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"0\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"0\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"0\";s:16:\"itemDateModified\";s:1:\"0\";s:8:\"itemHits\";s:1:\"0\";s:12:\"itemCategory\";s:1:\"0\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"0\";s:22:\"itemAttachmentsCounter\";s:1:\"0\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"0\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"0\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"6\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:10:\"Ultrabooks\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:72:\"9:dell-s-xps-12-from-an-ultrabook-to-a-tablet-with-a-flip-of-the-display\";s:7:\"catslug\";s:12:\"4:ultrabooks\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:110:\"index.php/k2/categories/economic/item/9-dell-s-xps-12-from-an-ultrabook-to-a-tablet-with-a-flip-of-the-display\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:10:\"Ultrabooks\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Ultrabooks\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:38:\"index.php?option=com_k2&view=item&id=9\";s:5:\"route\";s:120:\"index.php?option=com_k2&view=item&id=9:dell-s-xps-12-from-an-ultrabook-to-a-tablet-with-a-flip-of-the-display&Itemid=167\";s:5:\"title\";s:70:\"Dell\'s XPS 12 from an ultrabook to a tablet with a flip of the display\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-11-06 12:54:57\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-11-06 12:54:57\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(10,'index.php?option=com_k2&view=item&id=10','index.php?option=com_k2&view=item&id=10:the-new-ultra-thin-ux-series-ultra-portable-from-asus&Itemid=167','The new ultra-thin, UX Series ultra-portable from ASUS','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-04 09:26:24','b78eacde7d266451816bc8d45581280c',1,1,1,'*','2012-11-06 12:56:41','0000-00-00 00:00:00','2012-11-06 12:56:41','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"10\";s:5:\"alias\";s:53:\"the-new-ultra-thin-ux-series-ultra-portable-from-asus\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1611:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>\";s:5:\"catid\";s:1:\"4\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-04 08:26:21\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":241:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"2\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:6:\"Medium\";s:17:\"num_primary_items\";s:1:\"2\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:6:\"Medium\";s:19:\"num_secondary_items\";s:1:\"0\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:6:\"Medium\";s:9:\"num_links\";s:1:\"0\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:6:\"XSmall\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"1\";s:13:\"subCatColumns\";s:1:\"1\";s:11:\"subCatTitle\";s:1:\"1\";s:22:\"subCatTitleItemCounter\";s:1:\"1\";s:17:\"subCatDescription\";s:1:\"1\";s:11:\"subCatImage\";s:1:\"1\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"1\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"0\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"0\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"0\";s:16:\"itemDateModified\";s:1:\"0\";s:8:\"itemHits\";s:1:\"0\";s:12:\"itemCategory\";s:1:\"0\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"0\";s:22:\"itemAttachmentsCounter\";s:1:\"0\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"0\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"0\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"7\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:10:\"Ultrabooks\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:56:\"10:the-new-ultra-thin-ux-series-ultra-portable-from-asus\";s:7:\"catslug\";s:12:\"4:ultrabooks\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:94:\"index.php/k2/categories/economic/item/10-the-new-ultra-thin-ux-series-ultra-portable-from-asus\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:10:\"Ultrabooks\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Ultrabooks\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:39:\"index.php?option=com_k2&view=item&id=10\";s:5:\"route\";s:104:\"index.php?option=com_k2&view=item&id=10:the-new-ultra-thin-ux-series-ultra-portable-from-asus&Itemid=167\";s:5:\"title\";s:54:\"The new ultra-thin, UX Series ultra-portable from ASUS\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-11-06 12:56:41\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-11-06 12:56:41\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(11,'index.php?option=com_k2&view=item&id=11','index.php?option=com_k2&view=item&id=11:the-asus-taichi-21-is-innovation-at-its-finest-with-surface-interface&Itemid=167','The ASUS TAICHI 21 is innovation at its finest with surface interface','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-04 09:29:09','ccf1661162850a15027b04c7a7d278f9',1,1,1,'*','2012-11-06 12:58:42','0000-00-00 00:00:00','2012-11-06 12:58:42','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"11\";s:5:\"alias\";s:69:\"the-asus-taichi-21-is-innovation-at-its-finest-with-surface-interface\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1611:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>\";s:5:\"catid\";s:1:\"4\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-04 08:29:05\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":241:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"2\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:6:\"Medium\";s:17:\"num_primary_items\";s:1:\"2\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:6:\"Medium\";s:19:\"num_secondary_items\";s:1:\"0\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:6:\"Medium\";s:9:\"num_links\";s:1:\"0\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:6:\"XSmall\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"1\";s:13:\"subCatColumns\";s:1:\"1\";s:11:\"subCatTitle\";s:1:\"1\";s:22:\"subCatTitleItemCounter\";s:1:\"1\";s:17:\"subCatDescription\";s:1:\"1\";s:11:\"subCatImage\";s:1:\"1\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"1\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"0\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"0\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"0\";s:16:\"itemDateModified\";s:1:\"0\";s:8:\"itemHits\";s:1:\"0\";s:12:\"itemCategory\";s:1:\"0\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"0\";s:22:\"itemAttachmentsCounter\";s:1:\"0\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"0\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"0\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"2\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:10:\"Ultrabooks\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:72:\"11:the-asus-taichi-21-is-innovation-at-its-finest-with-surface-interface\";s:7:\"catslug\";s:12:\"4:ultrabooks\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:110:\"index.php/k2/categories/economic/item/11-the-asus-taichi-21-is-innovation-at-its-finest-with-surface-interface\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:10:\"Ultrabooks\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Ultrabooks\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:39:\"index.php?option=com_k2&view=item&id=11\";s:5:\"route\";s:120:\"index.php?option=com_k2&view=item&id=11:the-asus-taichi-21-is-innovation-at-its-finest-with-surface-interface&Itemid=167\";s:5:\"title\";s:69:\"The ASUS TAICHI 21 is innovation at its finest with surface interface\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-11-06 12:58:42\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-11-06 12:58:42\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(12,'index.php?option=com_k2&view=item&id=12','index.php?option=com_k2&view=item&id=12:lenovo-ideapad-a-great-windows-8-laptop-with-a-side-of-tablet&Itemid=167','Lenovo Ideapad - A Great Windows 8 Laptop with a Side of Tablet','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-04 09:31:05','7581ea10cfdb17f4ce2821c67f530f8b',1,1,1,'*','2012-11-06 13:00:02','0000-00-00 00:00:00','2012-11-06 13:00:02','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"12\";s:5:\"alias\";s:61:\"lenovo-ideapad-a-great-windows-8-laptop-with-a-side-of-tablet\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1611:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>\";s:5:\"catid\";s:1:\"4\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-04 08:31:01\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":241:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"2\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:6:\"Medium\";s:17:\"num_primary_items\";s:1:\"2\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:6:\"Medium\";s:19:\"num_secondary_items\";s:1:\"0\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:6:\"Medium\";s:9:\"num_links\";s:1:\"0\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:6:\"XSmall\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"1\";s:13:\"subCatColumns\";s:1:\"1\";s:11:\"subCatTitle\";s:1:\"1\";s:22:\"subCatTitleItemCounter\";s:1:\"1\";s:17:\"subCatDescription\";s:1:\"1\";s:11:\"subCatImage\";s:1:\"1\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"1\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"0\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"0\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"0\";s:16:\"itemDateModified\";s:1:\"0\";s:8:\"itemHits\";s:1:\"0\";s:12:\"itemCategory\";s:1:\"0\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"0\";s:22:\"itemAttachmentsCounter\";s:1:\"0\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"0\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"0\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"3\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:10:\"Ultrabooks\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:64:\"12:lenovo-ideapad-a-great-windows-8-laptop-with-a-side-of-tablet\";s:7:\"catslug\";s:12:\"4:ultrabooks\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:102:\"index.php/k2/categories/economic/item/12-lenovo-ideapad-a-great-windows-8-laptop-with-a-side-of-tablet\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:10:\"Ultrabooks\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Ultrabooks\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:39:\"index.php?option=com_k2&view=item&id=12\";s:5:\"route\";s:112:\"index.php?option=com_k2&view=item&id=12:lenovo-ideapad-a-great-windows-8-laptop-with-a-side-of-tablet&Itemid=167\";s:5:\"title\";s:63:\"Lenovo Ideapad - A Great Windows 8 Laptop with a Side of Tablet\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-11-06 13:00:02\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-11-06 13:00:02\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(13,'index.php?option=com_k2&view=item&id=13','index.php?option=com_k2&view=item&id=13:samsung-galaxy-tab-10-1-1-tablet-android-com-display-wide-10-1&Itemid=164','Samsung Galaxy Tab 10.1 1. Tablet Android com Display Wide 10.1\"','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-04 09:33:10','9c8e8d935d25f19d24e7f405280390b7',1,1,1,'*','2012-11-06 13:01:51','0000-00-00 00:00:00','2012-11-06 13:01:51','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"13\";s:5:\"alias\";s:62:\"samsung-galaxy-tab-10-1-1-tablet-android-com-display-wide-10-1\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1611:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>\";s:5:\"catid\";s:1:\"2\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-04 08:33:06\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":241:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"2\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:6:\"Medium\";s:17:\"num_primary_items\";s:1:\"2\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:6:\"Medium\";s:19:\"num_secondary_items\";s:1:\"0\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:6:\"Medium\";s:9:\"num_links\";s:1:\"0\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:6:\"XSmall\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"1\";s:13:\"subCatColumns\";s:1:\"1\";s:11:\"subCatTitle\";s:1:\"1\";s:22:\"subCatTitleItemCounter\";s:1:\"1\";s:17:\"subCatDescription\";s:1:\"1\";s:11:\"subCatImage\";s:1:\"1\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"1\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"0\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"0\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"0\";s:16:\"itemDateModified\";s:1:\"0\";s:8:\"itemHits\";s:1:\"0\";s:12:\"itemCategory\";s:1:\"0\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"0\";s:22:\"itemAttachmentsCounter\";s:1:\"0\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"0\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"0\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"5\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:8:\"Tablet\'s\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:65:\"13:samsung-galaxy-tab-10-1-1-tablet-android-com-display-wide-10-1\";s:7:\"catslug\";s:9:\"2:tablets\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:100:\"index.php/k2/categories/world/item/13-samsung-galaxy-tab-10-1-1-tablet-android-com-display-wide-10-1\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:8:\"Tablet\'s\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Tablet\'s\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:39:\"index.php?option=com_k2&view=item&id=13\";s:5:\"route\";s:113:\"index.php?option=com_k2&view=item&id=13:samsung-galaxy-tab-10-1-1-tablet-android-com-display-wide-10-1&Itemid=164\";s:5:\"title\";s:64:\"Samsung Galaxy Tab 10.1 1. Tablet Android com Display Wide 10.1\"\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-11-06 13:01:51\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-11-06 13:01:51\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(14,'index.php?option=com_k2&view=item&id=14','index.php?option=com_k2&view=item&id=14:nokia-to-launch-new-smartphone-with-windows-phone-8-in-2013&Itemid=166','Nokia to launch new smartphone with Windows Phone 8 in 2013','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-04 09:35:44','9d3928dcf9d7f9951bf99f7d617847f3',1,1,1,'*','2012-11-06 13:03:46','0000-00-00 00:00:00','2012-11-06 13:03:46','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"14\";s:5:\"alias\";s:59:\"nokia-to-launch-new-smartphone-with-windows-phone-8-in-2013\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1611:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>\";s:5:\"catid\";s:1:\"1\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-04 08:35:40\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":241:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"2\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:6:\"Medium\";s:17:\"num_primary_items\";s:1:\"2\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:6:\"Medium\";s:19:\"num_secondary_items\";s:1:\"0\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:6:\"Medium\";s:9:\"num_links\";s:1:\"0\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:6:\"XSmall\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"1\";s:13:\"subCatColumns\";s:1:\"1\";s:11:\"subCatTitle\";s:1:\"1\";s:22:\"subCatTitleItemCounter\";s:1:\"1\";s:17:\"subCatDescription\";s:1:\"1\";s:11:\"subCatImage\";s:1:\"1\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"1\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"0\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"0\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"0\";s:16:\"itemDateModified\";s:1:\"0\";s:8:\"itemHits\";s:1:\"0\";s:12:\"itemCategory\";s:1:\"0\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"0\";s:22:\"itemAttachmentsCounter\";s:1:\"0\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"0\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"0\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"1\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:12:\"SmartPhone\'s\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:62:\"14:nokia-to-launch-new-smartphone-with-windows-phone-8-in-2013\";s:7:\"catslug\";s:13:\"1:smartphones\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:100:\"index.php/k2/categories/politics/item/14-nokia-to-launch-new-smartphone-with-windows-phone-8-in-2013\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:12:\"SmartPhone\'s\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:12:\"SmartPhone\'s\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:39:\"index.php?option=com_k2&view=item&id=14\";s:5:\"route\";s:110:\"index.php?option=com_k2&view=item&id=14:nokia-to-launch-new-smartphone-with-windows-phone-8-in-2013&Itemid=166\";s:5:\"title\";s:59:\"Nokia to launch new smartphone with Windows Phone 8 in 2013\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-11-06 13:03:46\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-11-06 13:03:46\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(15,'index.php?option=com_k2&view=item&id=15','index.php?option=com_k2&view=item&id=15:the-blackberry-z10-is-more-than-just-a-new-blackberry&Itemid=166','The BlackBerry Z10 is more than just a new BlackBerry','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-04 09:37:48','136aeca56c2e3c2b73e270b0ba0920d6',1,1,1,'*','2012-11-06 13:05:30','0000-00-00 00:00:00','2012-11-06 13:05:30','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"15\";s:5:\"alias\";s:53:\"the-blackberry-z10-is-more-than-just-a-new-blackberry\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1611:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>\";s:5:\"catid\";s:1:\"1\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-04 08:37:44\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":241:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"2\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:6:\"Medium\";s:17:\"num_primary_items\";s:1:\"2\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:6:\"Medium\";s:19:\"num_secondary_items\";s:1:\"0\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:6:\"Medium\";s:9:\"num_links\";s:1:\"0\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:6:\"XSmall\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"1\";s:13:\"subCatColumns\";s:1:\"1\";s:11:\"subCatTitle\";s:1:\"1\";s:22:\"subCatTitleItemCounter\";s:1:\"1\";s:17:\"subCatDescription\";s:1:\"1\";s:11:\"subCatImage\";s:1:\"1\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"1\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"0\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"0\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"0\";s:16:\"itemDateModified\";s:1:\"0\";s:8:\"itemHits\";s:1:\"0\";s:12:\"itemCategory\";s:1:\"0\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"0\";s:22:\"itemAttachmentsCounter\";s:1:\"0\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"0\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"0\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"2\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:12:\"SmartPhone\'s\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:56:\"15:the-blackberry-z10-is-more-than-just-a-new-blackberry\";s:7:\"catslug\";s:13:\"1:smartphones\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:94:\"index.php/k2/categories/politics/item/15-the-blackberry-z10-is-more-than-just-a-new-blackberry\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:12:\"SmartPhone\'s\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:12:\"SmartPhone\'s\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:39:\"index.php?option=com_k2&view=item&id=15\";s:5:\"route\";s:104:\"index.php?option=com_k2&view=item&id=15:the-blackberry-z10-is-more-than-just-a-new-blackberry&Itemid=166\";s:5:\"title\";s:53:\"The BlackBerry Z10 is more than just a new BlackBerry\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-11-06 13:05:30\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-11-06 13:05:30\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(16,'index.php?option=com_k2&view=item&id=16','index.php?option=com_k2&view=item&id=16:galaxy-s-iii-designed-for-humans-inspired-by-nature&Itemid=166','Galaxy S III: Designed for humans, inspired by nature!','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-04 09:40:02','070daba81c7630f89c39e135b680ec65',1,1,1,'*','2012-11-06 13:07:05','0000-00-00 00:00:00','2012-11-06 13:07:05','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"16\";s:5:\"alias\";s:51:\"galaxy-s-iii-designed-for-humans-inspired-by-nature\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1611:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>\";s:5:\"catid\";s:1:\"1\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-04 08:39:58\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":241:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"2\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:6:\"Medium\";s:17:\"num_primary_items\";s:1:\"2\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:6:\"Medium\";s:19:\"num_secondary_items\";s:1:\"0\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:6:\"Medium\";s:9:\"num_links\";s:1:\"0\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:6:\"XSmall\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"1\";s:13:\"subCatColumns\";s:1:\"1\";s:11:\"subCatTitle\";s:1:\"1\";s:22:\"subCatTitleItemCounter\";s:1:\"1\";s:17:\"subCatDescription\";s:1:\"1\";s:11:\"subCatImage\";s:1:\"1\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"1\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"0\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"0\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"0\";s:16:\"itemDateModified\";s:1:\"0\";s:8:\"itemHits\";s:1:\"0\";s:12:\"itemCategory\";s:1:\"0\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"0\";s:22:\"itemAttachmentsCounter\";s:1:\"0\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"0\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"0\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"3\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:12:\"SmartPhone\'s\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:54:\"16:galaxy-s-iii-designed-for-humans-inspired-by-nature\";s:7:\"catslug\";s:13:\"1:smartphones\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:92:\"index.php/k2/categories/politics/item/16-galaxy-s-iii-designed-for-humans-inspired-by-nature\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:12:\"SmartPhone\'s\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:12:\"SmartPhone\'s\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:39:\"index.php?option=com_k2&view=item&id=16\";s:5:\"route\";s:102:\"index.php?option=com_k2&view=item&id=16:galaxy-s-iii-designed-for-humans-inspired-by-nature&Itemid=166\";s:5:\"title\";s:54:\"Galaxy S III: Designed for humans, inspired by nature!\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-11-06 13:07:05\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-11-06 13:07:05\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(17,'index.php?option=com_k2&view=item&id=17','index.php?option=com_k2&view=item&id=17:it-s-so-thin-and-so-light-yet-iphone-5-features-latest-technology&Itemid=166','It\'s so thin and so light, yet iPhone 5 features latest technology','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-04 09:42:01','fc8c07e892834a964b12967c37187378',1,1,1,'*','2012-11-06 13:08:43','0000-00-00 00:00:00','2012-11-06 13:08:43','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"17\";s:5:\"alias\";s:65:\"it-s-so-thin-and-so-light-yet-iphone-5-features-latest-technology\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1611:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>\";s:5:\"catid\";s:1:\"1\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-04 08:41:58\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":241:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"2\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:6:\"Medium\";s:17:\"num_primary_items\";s:1:\"2\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:6:\"Medium\";s:19:\"num_secondary_items\";s:1:\"0\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:6:\"Medium\";s:9:\"num_links\";s:1:\"0\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:6:\"XSmall\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"1\";s:13:\"subCatColumns\";s:1:\"1\";s:11:\"subCatTitle\";s:1:\"1\";s:22:\"subCatTitleItemCounter\";s:1:\"1\";s:17:\"subCatDescription\";s:1:\"1\";s:11:\"subCatImage\";s:1:\"1\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"1\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"0\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"0\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"0\";s:16:\"itemDateModified\";s:1:\"0\";s:8:\"itemHits\";s:1:\"0\";s:12:\"itemCategory\";s:1:\"0\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"0\";s:22:\"itemAttachmentsCounter\";s:1:\"0\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"0\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"0\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"4\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:12:\"SmartPhone\'s\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:68:\"17:it-s-so-thin-and-so-light-yet-iphone-5-features-latest-technology\";s:7:\"catslug\";s:13:\"1:smartphones\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:106:\"index.php/k2/categories/politics/item/17-it-s-so-thin-and-so-light-yet-iphone-5-features-latest-technology\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:12:\"SmartPhone\'s\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:12:\"SmartPhone\'s\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:39:\"index.php?option=com_k2&view=item&id=17\";s:5:\"route\";s:116:\"index.php?option=com_k2&view=item&id=17:it-s-so-thin-and-so-light-yet-iphone-5-features-latest-technology&Itemid=166\";s:5:\"title\";s:66:\"It\'s so thin and so light, yet iPhone 5 features latest technology\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-11-06 13:08:43\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-11-06 13:08:43\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(18,'index.php?option=com_k2&view=item&id=18','index.php?option=com_k2&view=item&id=18:interesting-combination-of-samsung-galaxy-camera-gc100-android&Itemid=166','Interesting combination of Samsung Galaxy Camera GC100 Android','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-04 09:44:28','184b6a158f68862c0dc5ff5b9a8e9da9',1,1,1,'*','2012-11-06 13:10:08','0000-00-00 00:00:00','2012-11-06 13:10:08','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"18\";s:5:\"alias\";s:62:\"interesting-combination-of-samsung-galaxy-camera-gc100-android\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1611:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>\";s:5:\"catid\";s:1:\"1\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-04 08:44:25\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":241:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"2\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:6:\"Medium\";s:17:\"num_primary_items\";s:1:\"2\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:6:\"Medium\";s:19:\"num_secondary_items\";s:1:\"0\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:6:\"Medium\";s:9:\"num_links\";s:1:\"0\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:6:\"XSmall\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"1\";s:13:\"subCatColumns\";s:1:\"1\";s:11:\"subCatTitle\";s:1:\"1\";s:22:\"subCatTitleItemCounter\";s:1:\"1\";s:17:\"subCatDescription\";s:1:\"1\";s:11:\"subCatImage\";s:1:\"1\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"1\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"0\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"0\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"0\";s:16:\"itemDateModified\";s:1:\"0\";s:8:\"itemHits\";s:1:\"0\";s:12:\"itemCategory\";s:1:\"0\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"0\";s:22:\"itemAttachmentsCounter\";s:1:\"0\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"0\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"0\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"5\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:12:\"SmartPhone\'s\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:65:\"18:interesting-combination-of-samsung-galaxy-camera-gc100-android\";s:7:\"catslug\";s:13:\"1:smartphones\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:103:\"index.php/k2/categories/politics/item/18-interesting-combination-of-samsung-galaxy-camera-gc100-android\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:12:\"SmartPhone\'s\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:12:\"SmartPhone\'s\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:39:\"index.php?option=com_k2&view=item&id=18\";s:5:\"route\";s:113:\"index.php?option=com_k2&view=item&id=18:interesting-combination-of-samsung-galaxy-camera-gc100-android&Itemid=166\";s:5:\"title\";s:62:\"Interesting combination of Samsung Galaxy Camera GC100 Android\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-11-06 13:10:08\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-11-06 13:10:08\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(19,'index.php?option=com_k2&view=item&id=19','index.php?option=com_k2&view=item&id=19:samsung-oled-tv-brings-new-1ghz-dual-core-chipset&Itemid=165','Samsung OLED TV brings new 1GHz dual-core chipset','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-04 09:46:07','57c17d4dd65271b4f9758641db9d72b0',1,1,1,'*','2012-11-06 13:11:38','0000-00-00 00:00:00','2012-11-06 13:11:38','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"19\";s:5:\"alias\";s:49:\"samsung-oled-tv-brings-new-1ghz-dual-core-chipset\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1611:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>\";s:5:\"catid\";s:1:\"3\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-04 08:46:03\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":241:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"2\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:6:\"Medium\";s:17:\"num_primary_items\";s:1:\"2\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:6:\"Medium\";s:19:\"num_secondary_items\";s:1:\"0\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:6:\"Medium\";s:9:\"num_links\";s:1:\"0\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:6:\"XSmall\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"1\";s:13:\"subCatColumns\";s:1:\"1\";s:11:\"subCatTitle\";s:1:\"1\";s:22:\"subCatTitleItemCounter\";s:1:\"1\";s:17:\"subCatDescription\";s:1:\"1\";s:11:\"subCatImage\";s:1:\"1\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"1\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"0\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"0\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"0\";s:16:\"itemDateModified\";s:1:\"0\";s:8:\"itemHits\";s:1:\"0\";s:12:\"itemCategory\";s:1:\"0\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"0\";s:22:\"itemAttachmentsCounter\";s:1:\"0\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"0\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"0\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"4\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:3:\"TVs\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:52:\"19:samsung-oled-tv-brings-new-1ghz-dual-core-chipset\";s:7:\"catslug\";s:5:\"3:tvs\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:85:\"index.php/k2/categories/u-s/item/19-samsung-oled-tv-brings-new-1ghz-dual-core-chipset\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:3:\"TVs\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:3:\"TVs\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:39:\"index.php?option=com_k2&view=item&id=19\";s:5:\"route\";s:100:\"index.php?option=com_k2&view=item&id=19:samsung-oled-tv-brings-new-1ghz-dual-core-chipset&Itemid=165\";s:5:\"title\";s:49:\"Samsung OLED TV brings new 1GHz dual-core chipset\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-11-06 13:11:38\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-11-06 13:11:38\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(20,'index.php?option=com_k2&view=item&id=20','index.php?option=com_k2&view=item&id=20:samsung-has-put-a-75-inch-lcd-tv-up-for-sale-in-south-korea&Itemid=165','Samsung has put a 75-inch LCD TV up for sale in South Korea','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-04 09:48:08','32ebc41020252ddcea2e165ecd3a2161',1,1,1,'*','2012-11-06 13:16:39','0000-00-00 00:00:00','2012-11-06 13:16:39','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"20\";s:5:\"alias\";s:59:\"samsung-has-put-a-75-inch-lcd-tv-up-for-sale-in-south-korea\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1611:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>\";s:5:\"catid\";s:1:\"3\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-04 08:48:05\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":241:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"2\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:6:\"Medium\";s:17:\"num_primary_items\";s:1:\"2\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:6:\"Medium\";s:19:\"num_secondary_items\";s:1:\"0\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:6:\"Medium\";s:9:\"num_links\";s:1:\"0\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:6:\"XSmall\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"1\";s:13:\"subCatColumns\";s:1:\"1\";s:11:\"subCatTitle\";s:1:\"1\";s:22:\"subCatTitleItemCounter\";s:1:\"1\";s:17:\"subCatDescription\";s:1:\"1\";s:11:\"subCatImage\";s:1:\"1\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"1\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"0\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"0\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"0\";s:16:\"itemDateModified\";s:1:\"0\";s:8:\"itemHits\";s:1:\"0\";s:12:\"itemCategory\";s:1:\"0\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"0\";s:22:\"itemAttachmentsCounter\";s:1:\"0\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"0\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"0\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"5\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:3:\"TVs\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:62:\"20:samsung-has-put-a-75-inch-lcd-tv-up-for-sale-in-south-korea\";s:7:\"catslug\";s:5:\"3:tvs\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:95:\"index.php/k2/categories/u-s/item/20-samsung-has-put-a-75-inch-lcd-tv-up-for-sale-in-south-korea\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:3:\"TVs\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:3:\"TVs\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:39:\"index.php?option=com_k2&view=item&id=20\";s:5:\"route\";s:110:\"index.php?option=com_k2&view=item&id=20:samsung-has-put-a-75-inch-lcd-tv-up-for-sale-in-south-korea&Itemid=165\";s:5:\"title\";s:59:\"Samsung has put a 75-inch LCD TV up for sale in South Korea\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-11-06 13:16:39\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-11-06 13:16:39\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(21,'index.php?option=com_k2&view=item&id=21','index.php?option=com_k2&view=item&id=21:apple-announces-128gb-ipad-4-with-retina-display&Itemid=164','Apple announces 128GB iPad 4 with Retina Display','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-04 09:49:58','ad170a50a5f95b3a66ab011841f40144',1,1,1,'*','2012-12-31 13:07:12','0000-00-00 00:00:00','2012-12-31 13:07:12','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"21\";s:5:\"alias\";s:48:\"apple-announces-128gb-ipad-4-with-retina-display\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:1611:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>\";s:5:\"catid\";s:1:\"2\";s:10:\"created_by\";s:3:\"572\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-04 08:49:54\";s:11:\"modified_by\";s:3:\"572\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":241:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"0\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"3\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"80\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"746\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"659\";s:13:\"catImageWidth\";s:3:\"659\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"60\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:11:\"K2UserGroup\";s:1:\"1\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:22:\"enforceSEFReplacements\";s:1:\"0\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"2\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:6:\"Medium\";s:17:\"num_primary_items\";s:1:\"2\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:6:\"Medium\";s:19:\"num_secondary_items\";s:1:\"0\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:6:\"Medium\";s:9:\"num_links\";s:1:\"0\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:6:\"XSmall\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"1\";s:13:\"subCatColumns\";s:1:\"1\";s:11:\"subCatTitle\";s:1:\"1\";s:22:\"subCatTitleItemCounter\";s:1:\"1\";s:17:\"subCatDescription\";s:1:\"1\";s:11:\"subCatImage\";s:1:\"1\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"1\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"0\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"0\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"0\";s:16:\"itemDateModified\";s:1:\"0\";s:8:\"itemHits\";s:1:\"0\";s:12:\"itemCategory\";s:1:\"0\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"0\";s:22:\"itemAttachmentsCounter\";s:1:\"0\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"0\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"0\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"2\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:8:\"Tablet\'s\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:51:\"21:apple-announces-128gb-ipad-4-with-retina-display\";s:7:\"catslug\";s:9:\"2:tablets\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:86:\"index.php/k2/categories/world/item/21-apple-announces-128gb-ipad-4-with-retina-display\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:8:\"Tablet\'s\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Tablet\'s\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:39:\"index.php?option=com_k2&view=item&id=21\";s:5:\"route\";s:99:\"index.php?option=com_k2&view=item&id=21:apple-announces-128gb-ipad-4-with-retina-display&Itemid=164\";s:5:\"title\";s:48:\"Apple announces 128GB iPad 4 with Retina Display\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-12-31 13:07:12\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-12-31 13:07:12\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}');


--
-- Table structure for table `#__finder_links_terms0`
--



CREATE TABLE `#__finder_links_terms0` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms0`
--


INSERT INTO `#__finder_links_terms0` (`link_id`, `term_id`, `weight`) VALUES (1,3,0.14007),(3,3,0.18676),(4,3,0.18676),(5,3,0.18676),(7,3,0.18676),(8,3,0.18676),(10,3,0.18676),(11,3,0.18676),(13,3,0.18676),(14,3,0.18676),(16,3,0.18676),(17,3,0.18676),(18,3,0.18676),(19,3,0.18676),(21,3,0.18676),(2,3,0.43355),(6,3,0.43355),(15,3,0.43355),(20,3,0.43355),(9,3,0.68034),(12,3,0.68034),(1,4,0.86331),(2,4,0.86331),(3,4,0.86331),(4,4,0.86331),(5,4,0.86331),(6,4,0.86331),(7,4,0.86331),(8,4,0.86331),(9,4,0.86331),(10,4,0.86331),(11,4,0.86331),(12,4,0.86331),(13,4,0.86331),(14,4,0.86331),(15,4,0.86331),(16,4,0.86331),(17,4,0.86331),(18,4,0.86331),(19,4,0.86331),(20,4,0.86331),(21,4,0.86331),(1,5,0.95669),(2,5,0.95669),(3,5,0.95669),(4,5,0.95669),(5,5,0.95669),(6,5,0.95669),(7,5,0.95669),(8,5,0.95669),(9,5,0.95669),(10,5,0.95669),(11,5,0.95669),(12,5,0.95669),(13,5,0.95669),(14,5,0.95669),(15,5,0.95669),(16,5,0.95669),(17,5,0.95669),(18,5,0.95669),(19,5,0.95669),(20,5,0.95669),(21,5,0.95669),(1,6,0.86331),(2,6,0.86331),(3,6,0.86331),(4,6,0.86331),(5,6,0.86331),(6,6,0.86331),(7,6,0.86331),(8,6,0.86331),(9,6,0.86331),(10,6,0.86331),(11,6,0.86331),(12,6,0.86331),(13,6,0.86331),(14,6,0.86331),(15,6,0.86331),(16,6,0.86331),(17,6,0.86331),(18,6,0.86331),(19,6,0.86331),(20,6,0.86331),(21,6,0.86331),(1,7,1.00331),(2,7,1.00331),(3,7,1.00331),(4,7,1.00331),(5,7,1.00331),(6,7,1.00331),(7,7,1.00331),(8,7,1.00331),(9,7,1.00331),(10,7,1.00331),(11,7,1.00331),(12,7,1.00331),(13,7,1.00331),(14,7,1.00331),(15,7,1.00331),(16,7,1.00331),(17,7,1.00331),(18,7,1.00331),(19,7,1.00331),(20,7,1.00331),(21,7,1.00331),(1,8,0.28),(2,8,0.56),(3,8,0.56),(4,8,0.56),(5,8,0.56),(6,8,0.56),(7,8,0.56),(8,8,0.56),(9,8,0.56),(10,8,0.56),(11,8,0.56),(12,8,0.56),(13,8,0.56),(14,8,0.56),(15,8,0.56),(16,8,0.56),(17,8,0.56),(18,8,0.56),(19,8,0.56),(20,8,0.56),(21,8,0.56),(1,9,0.91),(2,9,0.91),(3,9,0.91),(4,9,0.91),(5,9,0.91),(6,9,0.91),(7,9,0.91),(8,9,0.91),(9,9,0.91),(10,9,0.91),(11,9,0.91),(12,9,0.91),(13,9,0.91),(14,9,0.91),(15,9,0.91),(16,9,0.91),(17,9,0.91),(18,9,0.91),(19,9,0.91),(20,9,0.91),(21,9,0.91),(1,10,1.00331),(2,10,1.00331),(3,10,1.00331),(4,10,1.00331),(5,10,1.00331),(6,10,1.00331),(7,10,1.00331),(8,10,1.00331),(9,10,1.00331),(10,10,1.00331),(11,10,1.00331),(12,10,1.00331),(13,10,1.00331),(14,10,1.00331),(15,10,1.00331),(16,10,1.00331),(17,10,1.00331),(18,10,1.00331),(19,10,1.00331),(20,10,1.00331),(21,10,1.00331),(1,11,0.32669),(2,11,1.30676),(3,11,1.30676),(4,11,1.30676),(5,11,1.30676),(6,11,1.30676),(7,11,1.30676),(8,11,1.30676),(9,11,1.30676),(10,11,1.30676),(11,11,1.30676),(12,11,1.30676),(13,11,1.30676),(14,11,1.30676),(15,11,1.30676),(16,11,1.30676),(17,11,1.30676),(18,11,1.30676),(19,11,1.30676),(20,11,1.30676),(21,11,1.30676),(1,12,1.02669),(2,12,1.02669),(3,12,1.02669),(4,12,1.02669),(5,12,1.02669),(6,12,1.02669),(7,12,1.02669),(8,12,1.02669),(9,12,1.02669),(10,12,1.02669),(11,12,1.02669),(12,12,1.02669),(13,12,1.02669),(14,12,1.02669),(15,12,1.02669),(16,12,1.02669),(17,12,1.02669),(18,12,1.02669),(19,12,1.02669),(20,12,1.02669),(21,12,1.02669),(1,13,1.19),(2,13,1.19),(3,13,1.19),(4,13,1.19),(5,13,1.19),(6,13,1.19),(7,13,1.19),(8,13,1.19),(9,13,1.19),(10,13,1.19),(11,13,1.19),(12,13,1.19),(13,13,1.19),(14,13,1.19),(15,13,1.19),(16,13,1.19),(17,13,1.19),(18,13,1.19),(19,13,1.19),(20,13,1.19),(21,13,1.19),(1,14,0.37338),(2,14,0.56007),(3,14,0.56007),(4,14,0.56007),(5,14,0.56007),(6,14,0.56007),(7,14,0.56007),(8,14,0.56007),(9,14,0.56007),(10,14,0.56007),(11,14,0.56007),(12,14,0.56007),(13,14,0.56007),(14,14,0.56007),(15,14,0.56007),(16,14,0.56007),(17,14,0.56007),(18,14,0.56007),(19,14,0.56007),(20,14,0.56007),(21,14,0.56007),(1,15,2.05338),(2,15,2.05338),(3,15,2.05338),(4,15,2.05338),(5,15,2.05338),(6,15,2.05338),(7,15,2.05338),(8,15,2.05338),(9,15,2.05338),(10,15,2.05338),(11,15,2.05338),(12,15,2.05338),(13,15,2.05338),(14,15,2.05338),(15,15,2.05338),(16,15,2.05338),(17,15,2.05338),(18,15,2.05338),(19,15,2.05338),(20,15,2.05338),(21,15,2.05338),(1,16,1.16669),(2,16,1.16669),(3,16,1.16669),(4,16,1.16669),(5,16,1.16669),(6,16,1.16669),(7,16,1.16669),(8,16,1.16669),(9,16,1.16669),(10,16,1.16669),(11,16,1.16669),(12,16,1.16669),(13,16,1.16669),(14,16,1.16669),(15,16,1.16669),(16,16,1.16669),(17,16,1.16669),(18,16,1.16669),(19,16,1.16669),(20,16,1.16669),(21,16,1.16669),(1,17,1.19),(2,17,1.19),(3,17,1.19),(4,17,1.19),(5,17,1.19),(6,17,1.19),(7,17,1.19),(8,17,1.19),(9,17,1.19),(10,17,1.19),(11,17,1.19),(12,17,1.19),(13,17,1.19),(14,17,1.19),(15,17,1.19),(16,17,1.19),(17,17,1.19),(18,17,1.19),(19,17,1.19),(20,17,1.19),(21,17,1.19),(2,18,0.27993),(3,18,0.27993),(5,18,0.27993),(6,18,0.27993),(7,18,0.27993),(8,18,0.27993),(9,18,0.27993),(10,18,0.27993),(12,18,0.27993),(13,18,0.27993),(14,18,0.27993),(15,18,0.27993),(16,18,0.27993),(17,18,0.27993),(18,18,0.27993),(19,18,0.27993),(20,18,0.27993),(21,18,0.27993),(1,18,0.67983),(4,18,0.77314),(11,18,0.77314),(1,19,0.95669),(2,19,0.95669),(3,19,0.95669),(4,19,0.95669),(5,19,0.95669),(6,19,0.95669),(7,19,0.95669),(8,19,0.95669),(9,19,0.95669),(10,19,0.95669),(11,19,0.95669),(12,19,0.95669),(13,19,0.95669),(14,19,0.95669),(15,19,0.95669),(16,19,0.95669),(17,19,0.95669),(18,19,0.95669),(19,19,0.95669),(20,19,0.95669),(21,19,0.95669),(1,20,1.09669),(2,20,1.09669),(3,20,1.09669),(4,20,1.09669),(5,20,1.09669),(6,20,1.09669),(7,20,1.09669),(8,20,1.09669),(9,20,1.09669),(10,20,1.09669),(11,20,1.09669),(12,20,1.09669),(13,20,1.09669),(14,20,1.09669),(15,20,1.09669),(16,20,1.09669),(17,20,1.09669),(18,20,1.09669),(19,20,1.09669),(20,20,1.09669),(21,20,1.09669),(1,21,0.56),(2,21,0.84),(3,21,0.84),(4,21,0.84),(5,21,0.84),(6,21,0.84),(7,21,0.84),(8,21,0.84),(9,21,0.84),(10,21,0.84),(11,21,0.84),(12,21,0.84),(13,21,0.84),(14,21,0.84),(15,21,0.84),(16,21,0.84),(17,21,0.84),(18,21,0.84),(19,21,0.84),(20,21,0.84),(21,21,0.84),(1,22,2.14662),(2,22,2.14662),(3,22,2.14662),(4,22,2.14662),(5,22,2.14662),(6,22,2.14662),(7,22,2.14662),(8,22,2.14662),(9,22,2.14662),(10,22,2.14662),(11,22,2.14662),(12,22,2.14662),(13,22,2.14662),(14,22,2.14662),(15,22,2.14662),(16,22,2.14662),(17,22,2.14662),(18,22,2.14662),(19,22,2.14662),(20,22,2.14662),(21,22,2.14662),(1,23,1.19),(2,23,1.19),(3,23,1.19),(4,23,1.19),(5,23,1.19),(6,23,1.19),(7,23,1.19),(8,23,1.19),(9,23,1.19),(10,23,1.19),(11,23,1.19),(12,23,1.19),(13,23,1.19),(14,23,1.19),(15,23,1.19),(16,23,1.19),(17,23,1.19),(18,23,1.19),(19,23,1.19),(20,23,1.19),(21,23,1.19),(1,197,0.84),(2,197,0.98),(3,197,0.98),(4,197,0.98),(5,197,0.98),(6,197,0.98),(7,197,0.98),(8,197,0.98),(9,197,0.98),(10,197,0.98),(11,197,0.98),(12,197,0.98),(13,197,0.98),(14,197,0.98),(15,197,0.98),(16,197,0.98),(17,197,0.98),(18,197,0.98),(19,197,0.98),(20,197,0.98),(21,197,0.98),(1,198,0.81669),(2,198,0.81669),(3,198,0.81669),(4,198,0.81669),(5,198,0.81669),(6,198,0.81669),(7,198,0.81669),(8,198,0.81669),(9,198,0.81669),(10,198,0.81669),(11,198,0.81669),(12,198,0.81669),(13,198,0.81669),(14,198,0.81669),(15,198,0.81669),(16,198,0.81669),(17,198,0.81669),(18,198,0.81669),(19,198,0.81669),(20,198,0.81669),(21,198,0.81669),(1,199,0.95669),(2,199,0.95669),(3,199,0.95669),(4,199,0.95669),(5,199,0.95669),(6,199,0.95669),(7,199,0.95669),(8,199,0.95669),(9,199,0.95669),(10,199,0.95669),(11,199,0.95669),(12,199,0.95669),(13,199,0.95669),(14,199,0.95669),(15,199,0.95669),(16,199,0.95669),(17,199,0.95669),(18,199,0.95669),(19,199,0.95669),(20,199,0.95669),(21,199,0.95669),(1,200,0.95669),(2,200,0.95669),(3,200,0.95669),(4,200,0.95669),(5,200,0.95669),(6,200,0.95669),(7,200,0.95669),(8,200,0.95669),(9,200,0.95669),(10,200,0.95669),(11,200,0.95669),(12,200,0.95669),(13,200,0.95669),(14,200,0.95669),(15,200,0.95669),(16,200,0.95669),(17,200,0.95669),(18,200,0.95669),(19,200,0.95669),(20,200,0.95669),(21,200,0.95669),(1,201,1.05),(2,201,1.05),(3,201,1.05),(4,201,1.05),(5,201,1.05),(6,201,1.05),(7,201,1.05),(8,201,1.05),(9,201,1.05),(10,201,1.05),(11,201,1.05),(12,201,1.05),(13,201,1.05),(14,201,1.05),(15,201,1.05),(16,201,1.05),(17,201,1.05),(18,201,1.05),(19,201,1.05),(20,201,1.05),(21,201,1.05),(1,202,0.95669),(2,202,0.95669),(3,202,0.95669),(4,202,0.95669),(5,202,0.95669),(6,202,0.95669),(7,202,0.95669),(8,202,0.95669),(9,202,0.95669),(10,202,0.95669),(11,202,0.95669),(12,202,0.95669),(13,202,0.95669),(14,202,0.95669),(15,202,0.95669),(16,202,0.95669),(17,202,0.95669),(18,202,0.95669),(19,202,0.95669),(20,202,0.95669),(21,202,0.95669),(1,203,1.23669),(2,203,1.23669),(3,203,1.23669),(4,203,1.23669),(5,203,1.23669),(6,203,1.23669),(7,203,1.23669),(8,203,1.23669),(9,203,1.23669),(10,203,1.23669),(11,203,1.23669),(12,203,1.23669),(13,203,1.23669),(14,203,1.23669),(15,203,1.23669),(16,203,1.23669),(17,203,1.23669),(18,203,1.23669),(19,203,1.23669),(20,203,1.23669),(21,203,1.23669),(1,204,0.28),(2,204,0.42),(3,204,0.42),(4,204,0.42),(5,204,0.42),(6,204,0.42),(7,204,0.42),(8,204,0.42),(9,204,0.42),(10,204,0.42),(11,204,0.42),(12,204,0.42),(13,204,0.42),(14,204,0.42),(15,204,0.42),(16,204,0.42),(17,204,0.42),(18,204,0.42),(19,204,0.42),(20,204,0.42),(21,204,0.42),(1,205,0.95669),(2,205,0.95669),(3,205,0.95669),(4,205,0.95669),(5,205,0.95669),(6,205,0.95669),(7,205,0.95669),(8,205,0.95669),(9,205,0.95669),(10,205,0.95669),(11,205,0.95669),(12,205,0.95669),(13,205,0.95669),(14,205,0.95669),(15,205,0.95669),(16,205,0.95669),(17,205,0.95669),(18,205,0.95669),(19,205,0.95669),(20,205,0.95669),(21,205,0.95669),(1,206,1.07331),(2,206,1.07331),(3,206,1.07331),(4,206,1.07331),(5,206,1.07331),(6,206,1.07331),(7,206,1.07331),(8,206,1.07331),(9,206,1.07331),(10,206,1.07331),(11,206,1.07331),(12,206,1.07331),(13,206,1.07331),(14,206,1.07331),(15,206,1.07331),(16,206,1.07331),(17,206,1.07331),(18,206,1.07331),(19,206,1.07331),(20,206,1.07331),(21,206,1.07331),(1,207,1.00331),(2,207,1.00331),(3,207,1.00331),(4,207,1.00331),(5,207,1.00331),(6,207,1.00331),(7,207,1.00331),(8,207,1.00331),(9,207,1.00331),(10,207,1.00331),(11,207,1.00331),(12,207,1.00331),(13,207,1.00331),(14,207,1.00331),(15,207,1.00331),(16,207,1.00331),(17,207,1.00331),(18,207,1.00331),(19,207,1.00331),(20,207,1.00331),(21,207,1.00331),(1,208,1.14331),(2,208,1.14331),(3,208,1.14331),(4,208,1.14331),(5,208,1.14331),(6,208,1.14331),(7,208,1.14331),(8,208,1.14331),(9,208,1.14331),(10,208,1.14331),(11,208,1.14331),(12,208,1.14331),(13,208,1.14331),(14,208,1.14331),(15,208,1.14331),(16,208,1.14331),(17,208,1.14331),(18,208,1.14331),(19,208,1.14331),(20,208,1.14331),(21,208,1.14331),(1,209,0.28),(2,209,0.42),(3,209,0.42),(4,209,0.42),(5,209,0.42),(6,209,0.42),(7,209,0.42),(8,209,0.42),(9,209,0.42),(10,209,0.42),(11,209,0.42),(12,209,0.42),(13,209,0.42),(14,209,0.42),(15,209,0.42),(16,209,0.42),(17,209,0.42),(18,209,0.42),(19,209,0.42),(20,209,0.42),(21,209,0.42),(1,210,1.77338),(2,210,2.66007),(3,210,2.66007),(4,210,2.66007),(5,210,2.66007),(6,210,2.66007),(7,210,2.66007),(8,210,2.66007),(9,210,2.66007),(10,210,2.66007),(11,210,2.66007),(12,210,2.66007),(13,210,2.66007),(14,210,2.66007),(15,210,2.66007),(16,210,2.66007),(17,210,2.66007),(18,210,2.66007),(19,210,2.66007),(20,210,2.66007),(21,210,2.66007),(1,211,2.24),(2,211,2.24),(3,211,2.24),(4,211,2.24),(5,211,2.24),(6,211,2.24),(7,211,2.24),(8,211,2.24),(9,211,2.24),(10,211,2.24),(11,211,2.24),(12,211,2.24),(13,211,2.24),(14,211,2.24),(15,211,2.24),(16,211,2.24),(17,211,2.24),(18,211,2.24),(19,211,2.24),(20,211,2.24),(21,211,2.24),(1,212,0.79992),(2,212,0.79992),(3,212,0.79992),(4,212,0.79992),(5,212,0.79992),(6,212,0.79992),(7,212,0.79992),(8,212,0.79992),(9,212,0.79992),(10,212,0.79992),(11,212,0.79992),(12,212,0.79992),(13,212,0.79992),(14,212,0.79992),(15,212,0.79992),(16,212,0.79992),(17,212,0.79992),(18,212,0.79992),(19,212,0.79992),(20,212,0.79992),(21,212,0.79992),(1,213,3.19992),(2,213,3.19992),(3,213,3.19992),(4,213,3.19992),(5,213,3.19992),(6,213,3.19992),(7,213,3.19992),(8,213,3.19992),(9,213,3.19992),(10,213,3.19992),(11,213,3.19992),(12,213,3.19992),(13,213,3.19992),(14,213,3.19992),(15,213,3.19992),(16,213,3.19992),(17,213,3.19992),(18,213,3.19992),(19,213,3.19992),(20,213,3.19992),(21,213,3.19992),(8,513,0.74),(17,513,0.74),(3,633,1.23321),(2,668,0.27993),(3,668,0.27993),(4,668,0.27993),(5,668,0.27993),(6,668,0.27993),(7,668,0.27993),(8,668,0.27993),(9,668,0.27993),(10,668,0.27993),(11,668,0.27993),(12,668,0.27993),(13,668,0.27993),(14,668,0.27993),(15,668,0.27993),(16,668,0.27993),(17,668,0.27993),(18,668,0.27993),(19,668,0.27993),(20,668,0.27993),(21,668,0.27993),(1,677,0.23331),(2,677,0.23331),(3,677,0.23331),(4,677,0.23331),(5,677,0.23331),(6,677,0.23331),(7,677,0.23331),(8,677,0.23331),(9,677,0.23331),(10,677,0.23331),(11,677,0.23331),(12,677,0.23331),(13,677,0.23331),(14,677,0.23331),(15,677,0.23331),(16,677,0.23331),(17,677,0.23331),(18,677,0.23331),(19,677,0.23331),(20,677,0.23331),(21,677,0.23331),(10,756,1.48),(9,900,0.49321),(9,1005,0.1334),(17,1005,0.1334),(2,1005,0.24679),(16,1005,0.24679),(4,1540,1.23321),(4,1541,4.68679),(4,1542,5.18),(4,1543,4.44),(4,1544,4.93321),(14,3103,0.96),(15,3103,0.96),(16,3103,0.96),(17,3103,0.96),(18,3103,0.96),(1,3109,0.88669),(2,3109,0.88669),(3,3109,0.88669),(4,3109,0.88669),(5,3109,0.88669),(6,3109,0.88669),(7,3109,0.88669),(8,3109,0.88669),(9,3109,0.88669),(10,3109,0.88669),(11,3109,0.88669),(12,3109,0.88669),(13,3109,0.88669),(14,3109,0.88669),(15,3109,0.88669),(16,3109,0.88669),(17,3109,0.88669),(18,3109,0.88669),(19,3109,0.88669),(20,3109,0.88669),(21,3109,0.88669),(1,3110,1.00331),(2,3110,1.00331),(3,3110,1.00331),(4,3110,1.00331),(5,3110,1.00331),(6,3110,1.00331),(7,3110,1.00331),(8,3110,1.00331),(9,3110,1.00331),(10,3110,1.00331),(11,3110,1.00331),(12,3110,1.00331),(13,3110,1.00331),(14,3110,1.00331),(15,3110,1.00331),(16,3110,1.00331),(17,3110,1.00331),(18,3110,1.00331),(19,3110,1.00331),(20,3110,1.00331),(21,3110,1.00331),(1,3111,0.74),(8,3111,0.74),(1,3112,4.93321),(1,3113,5.42679),(1,3114,0.18669),(2,3114,0.18669),(3,3114,0.18669),(4,3114,0.18669),(5,3114,0.18669),(6,3114,0.18669),(7,3114,0.18669),(8,3114,0.18669),(9,3114,0.18669),(10,3114,0.18669),(11,3114,0.18669),(12,3114,0.18669),(13,3114,0.18669),(14,3114,0.18669),(15,3114,0.18669),(16,3114,0.18669),(17,3114,0.18669),(18,3114,0.18669),(19,3114,0.18669),(20,3114,0.18669),(21,3114,0.18669),(1,3115,1.09669),(2,3115,1.09669),(3,3115,1.09669),(4,3115,1.09669),(5,3115,1.09669),(6,3115,1.09669),(7,3115,1.09669),(8,3115,1.09669),(9,3115,1.09669),(10,3115,1.09669),(11,3115,1.09669),(12,3115,1.09669),(13,3115,1.09669),(14,3115,1.09669),(15,3115,1.09669),(16,3115,1.09669),(17,3115,1.09669),(18,3115,1.09669),(19,3115,1.09669),(20,3115,1.09669),(21,3115,1.09669),(1,3116,1.16669),(2,3116,1.16669),(3,3116,1.16669),(4,3116,1.16669),(5,3116,1.16669),(6,3116,1.16669),(7,3116,1.16669),(8,3116,1.16669),(9,3116,1.16669),(10,3116,1.16669),(11,3116,1.16669),(12,3116,1.16669),(13,3116,1.16669),(14,3116,1.16669),(15,3116,1.16669),(16,3116,1.16669),(17,3116,1.16669),(18,3116,1.16669),(19,3116,1.16669),(20,3116,1.16669),(21,3116,1.16669),(1,3117,0.88669),(2,3117,0.88669),(3,3117,0.88669),(4,3117,0.88669),(5,3117,0.88669),(6,3117,0.88669),(7,3117,0.88669),(8,3117,0.88669),(9,3117,0.88669),(10,3117,0.88669),(11,3117,0.88669),(12,3117,0.88669),(13,3117,0.88669),(14,3117,0.88669),(15,3117,0.88669),(16,3117,0.88669),(17,3117,0.88669),(18,3117,0.88669),(19,3117,0.88669),(20,3117,0.88669),(21,3117,0.88669),(1,3118,1.02669),(2,3118,1.02669),(3,3118,1.02669),(4,3118,1.02669),(5,3118,1.02669),(6,3118,1.02669),(7,3118,1.02669),(8,3118,1.02669),(9,3118,1.02669),(10,3118,1.02669),(11,3118,1.02669),(12,3118,1.02669),(13,3118,1.02669),(14,3118,1.02669),(15,3118,1.02669),(16,3118,1.02669),(17,3118,1.02669),(18,3118,1.02669),(19,3118,1.02669),(20,3118,1.02669),(21,3118,1.02669),(1,3119,4.56321),(1,3120,5.05679),(2,3121,1.30669),(3,3121,1.30669),(4,3121,1.30669),(5,3121,1.30669),(6,3121,1.30669),(7,3121,1.30669),(8,3121,1.30669),(9,3121,1.30669),(10,3121,1.30669),(11,3121,1.30669),(12,3121,1.30669),(13,3121,1.30669),(14,3121,1.30669),(15,3121,1.30669),(16,3121,1.30669),(17,3121,1.30669),(18,3121,1.30669),(19,3121,1.30669),(20,3121,1.30669),(21,3121,1.30669),(1,3121,1.30669),(1,3122,0.95669),(2,3122,0.95669),(3,3122,0.95669),(4,3122,0.95669),(5,3122,0.95669),(6,3122,0.95669),(7,3122,0.95669),(8,3122,0.95669),(9,3122,0.95669),(10,3122,0.95669),(11,3122,0.95669),(12,3122,0.95669),(13,3122,0.95669),(14,3122,0.95669),(15,3122,0.95669),(16,3122,0.95669),(17,3122,0.95669),(18,3122,0.95669),(19,3122,0.95669),(20,3122,0.95669),(21,3122,0.95669),(1,3123,1.05),(2,3123,1.05),(3,3123,1.05),(4,3123,1.05),(5,3123,1.05),(6,3123,1.05),(7,3123,1.05),(8,3123,1.05),(9,3123,1.05),(10,3123,1.05),(11,3123,1.05),(12,3123,1.05),(13,3123,1.05),(14,3123,1.05),(15,3123,1.05),(16,3123,1.05),(17,3123,1.05),(18,3123,1.05),(19,3123,1.05),(20,3123,1.05),(21,3123,1.05),(1,3222,0.37331),(2,3222,0.37331),(3,3222,0.37331),(4,3222,0.37331),(5,3222,0.37331),(6,3222,0.37331),(7,3222,0.37331),(8,3222,0.37331),(9,3222,0.37331),(10,3222,0.37331),(11,3222,0.37331),(12,3222,0.37331),(13,3222,0.37331),(14,3222,0.37331),(15,3222,0.37331),(16,3222,0.37331),(17,3222,0.37331),(18,3222,0.37331),(19,3222,0.37331),(20,3222,0.37331),(21,3222,0.37331),(1,3223,0.93331),(2,3223,0.93331),(3,3223,0.93331),(4,3223,0.93331),(5,3223,0.93331),(6,3223,0.93331),(7,3223,0.93331),(8,3223,0.93331),(9,3223,0.93331),(10,3223,0.93331),(11,3223,0.93331),(12,3223,0.93331),(13,3223,0.93331),(14,3223,0.93331),(15,3223,0.93331),(16,3223,0.93331),(17,3223,0.93331),(18,3223,0.93331),(19,3223,0.93331),(20,3223,0.93331),(21,3223,0.93331),(1,3224,1.09669),(2,3224,1.09669),(3,3224,1.09669),(4,3224,1.09669),(5,3224,1.09669),(6,3224,1.09669),(7,3224,1.09669),(8,3224,1.09669),(9,3224,1.09669),(10,3224,1.09669),(11,3224,1.09669),(12,3224,1.09669),(13,3224,1.09669),(14,3224,1.09669),(15,3224,1.09669),(16,3224,1.09669),(17,3224,1.09669),(18,3224,1.09669),(19,3224,1.09669),(20,3224,1.09669),(21,3224,1.09669),(1,3225,0.28),(2,3225,0.28),(3,3225,0.28),(4,3225,0.28),(5,3225,0.28),(6,3225,0.28),(7,3225,0.28),(8,3225,0.28),(9,3225,0.28),(10,3225,0.28),(11,3225,0.28),(12,3225,0.28),(13,3225,0.28),(14,3225,0.28),(15,3225,0.28),(16,3225,0.28),(17,3225,0.28),(18,3225,0.28),(19,3225,0.28),(20,3225,0.28),(21,3225,0.28),(1,3226,1.02669),(2,3226,1.02669),(3,3226,1.02669),(4,3226,1.02669),(5,3226,1.02669),(6,3226,1.02669),(7,3226,1.02669),(8,3226,1.02669),(9,3226,1.02669),(10,3226,1.02669),(11,3226,1.02669),(12,3226,1.02669),(13,3226,1.02669),(14,3226,1.02669),(15,3226,1.02669),(16,3226,1.02669),(17,3226,1.02669),(18,3226,1.02669),(19,3226,1.02669),(20,3226,1.02669),(21,3226,1.02669),(1,3227,1.14331),(2,3227,1.14331),(3,3227,1.14331),(4,3227,1.14331),(5,3227,1.14331),(6,3227,1.14331),(7,3227,1.14331),(8,3227,1.14331),(9,3227,1.14331),(10,3227,1.14331),(11,3227,1.14331),(12,3227,1.14331),(13,3227,1.14331),(14,3227,1.14331),(15,3227,1.14331),(16,3227,1.14331),(17,3227,1.14331),(18,3227,1.14331),(19,3227,1.14331),(20,3227,1.14331),(21,3227,1.14331),(1,3228,0.98),(2,3228,0.98),(3,3228,0.98),(4,3228,0.98),(5,3228,0.98),(6,3228,0.98),(7,3228,0.98),(8,3228,0.98),(9,3228,0.98),(10,3228,0.98),(11,3228,0.98),(12,3228,0.98),(13,3228,0.98),(14,3228,0.98),(15,3228,0.98),(16,3228,0.98),(17,3228,0.98),(18,3228,0.98),(19,3228,0.98),(20,3228,0.98),(21,3228,0.98),(1,3229,1.09669),(2,3229,1.09669),(3,3229,1.09669),(4,3229,1.09669),(5,3229,1.09669),(6,3229,1.09669),(7,3229,1.09669),(8,3229,1.09669),(9,3229,1.09669),(10,3229,1.09669),(11,3229,1.09669),(12,3229,1.09669),(13,3229,1.09669),(14,3229,1.09669),(15,3229,1.09669),(16,3229,1.09669),(17,3229,1.09669),(18,3229,1.09669),(19,3229,1.09669),(20,3229,1.09669),(21,3229,1.09669),(1,3230,0.93331),(2,3230,0.93331),(3,3230,0.93331),(4,3230,0.93331),(5,3230,0.93331),(6,3230,0.93331),(7,3230,0.93331),(8,3230,0.93331),(9,3230,0.93331),(10,3230,0.93331),(11,3230,0.93331),(12,3230,0.93331),(13,3230,0.93331),(14,3230,0.93331),(15,3230,0.93331),(16,3230,0.93331),(17,3230,0.93331),(18,3230,0.93331),(19,3230,0.93331),(20,3230,0.93331),(21,3230,0.93331),(1,3231,1.05),(2,3231,1.05),(3,3231,1.05),(4,3231,1.05),(5,3231,1.05),(6,3231,1.05),(7,3231,1.05),(8,3231,1.05),(9,3231,1.05),(10,3231,1.05),(11,3231,1.05),(12,3231,1.05),(13,3231,1.05),(14,3231,1.05),(15,3231,1.05),(16,3231,1.05),(17,3231,1.05),(18,3231,1.05),(19,3231,1.05),(20,3231,1.05),(21,3231,1.05),(2,3232,0.84),(3,3232,0.84),(4,3232,0.84),(5,3232,0.84),(6,3232,0.84),(7,3232,0.84),(8,3232,0.84),(9,3232,0.84),(10,3232,0.84),(11,3232,0.84),(12,3232,0.84),(13,3232,0.84),(14,3232,0.84),(15,3232,0.84),(16,3232,0.84),(17,3232,0.84),(18,3232,0.84),(19,3232,0.84),(20,3232,0.84),(21,3232,0.84),(1,3232,0.84),(1,3233,0.98),(2,3233,0.98),(3,3233,0.98),(4,3233,0.98),(5,3233,0.98),(6,3233,0.98),(7,3233,0.98),(8,3233,0.98),(9,3233,0.98),(10,3233,0.98),(11,3233,0.98),(12,3233,0.98),(13,3233,0.98),(14,3233,0.98),(15,3233,0.98),(16,3233,0.98),(17,3233,0.98),(18,3233,0.98),(19,3233,0.98),(20,3233,0.98),(21,3233,0.98),(1,3234,0.28),(2,3234,0.56),(3,3234,0.56),(4,3234,0.56),(5,3234,0.56),(6,3234,0.56),(7,3234,0.56),(8,3234,0.56),(9,3234,0.56),(10,3234,0.56),(11,3234,0.56),(12,3234,0.56),(13,3234,0.56),(14,3234,0.56),(15,3234,0.56),(16,3234,0.56),(17,3234,0.56),(18,3234,0.56),(19,3234,0.56),(20,3234,0.56),(21,3234,0.56),(1,3235,0.95669),(2,3235,0.95669),(3,3235,0.95669),(4,3235,0.95669),(5,3235,0.95669),(6,3235,0.95669),(7,3235,0.95669),(8,3235,0.95669),(9,3235,0.95669),(10,3235,0.95669),(11,3235,0.95669),(12,3235,0.95669),(13,3235,0.95669),(14,3235,0.95669),(15,3235,0.95669),(16,3235,0.95669),(17,3235,0.95669),(18,3235,0.95669),(19,3235,0.95669),(20,3235,0.95669),(21,3235,0.95669),(1,3236,1.07331),(2,3236,1.07331),(3,3236,1.07331),(4,3236,1.07331),(5,3236,1.07331),(6,3236,1.07331),(7,3236,1.07331),(8,3236,1.07331),(9,3236,1.07331),(10,3236,1.07331),(11,3236,1.07331),(12,3236,1.07331),(13,3236,1.07331),(14,3236,1.07331),(15,3236,1.07331),(16,3236,1.07331),(17,3236,1.07331),(18,3236,1.07331),(19,3236,1.07331),(20,3236,1.07331),(21,3236,1.07331),(2,3360,0.81669),(3,3360,0.81669),(4,3360,0.81669),(5,3360,0.81669),(6,3360,0.81669),(7,3360,0.81669),(8,3360,0.81669),(9,3360,0.81669),(10,3360,0.81669),(11,3360,0.81669),(12,3360,0.81669),(13,3360,0.81669),(14,3360,0.81669),(15,3360,0.81669),(16,3360,0.81669),(17,3360,0.81669),(18,3360,0.81669),(19,3360,0.81669),(20,3360,0.81669),(21,3360,0.81669),(2,3361,0.93331),(3,3361,0.93331),(4,3361,0.93331),(5,3361,0.93331),(6,3361,0.93331),(7,3361,0.93331),(8,3361,0.93331),(9,3361,0.93331),(10,3361,0.93331),(11,3361,0.93331),(12,3361,0.93331),(13,3361,0.93331),(14,3361,0.93331),(15,3361,0.93331),(16,3361,0.93331),(17,3361,0.93331),(18,3361,0.93331),(19,3361,0.93331),(20,3361,0.93331),(21,3361,0.93331),(2,3362,5.30321),(2,3363,6.29),(2,3364,0.88669),(3,3364,0.88669),(4,3364,0.88669),(5,3364,0.88669),(6,3364,0.88669),(7,3364,0.88669),(8,3364,0.88669),(9,3364,0.88669),(10,3364,0.88669),(11,3364,0.88669),(12,3364,0.88669),(13,3364,0.88669),(14,3364,0.88669),(15,3364,0.88669),(16,3364,0.88669),(17,3364,0.88669),(18,3364,0.88669),(19,3364,0.88669),(20,3364,0.88669),(21,3364,0.88669),(2,3365,0.95669),(3,3365,0.95669),(4,3365,0.95669),(5,3365,0.95669),(6,3365,0.95669),(7,3365,0.95669),(8,3365,0.95669),(9,3365,0.95669),(10,3365,0.95669),(11,3365,0.95669),(12,3365,0.95669),(13,3365,0.95669),(14,3365,0.95669),(15,3365,0.95669),(16,3365,0.95669),(17,3365,0.95669),(18,3365,0.95669),(19,3365,0.95669),(20,3365,0.95669),(21,3365,0.95669),(2,3366,0.91),(3,3366,0.91),(4,3366,0.91),(5,3366,0.91),(6,3366,0.91),(7,3366,0.91),(8,3366,0.91),(9,3366,0.91),(10,3366,0.91),(11,3366,0.91),(12,3366,0.91),(13,3366,0.91),(14,3366,0.91),(15,3366,0.91),(16,3366,0.91),(17,3366,0.91),(18,3366,0.91),(19,3366,0.91),(20,3366,0.91),(21,3366,0.91),(2,3367,1.05),(3,3367,1.05),(4,3367,1.05),(5,3367,1.05),(6,3367,1.05),(7,3367,1.05),(8,3367,1.05),(9,3367,1.05),(10,3367,1.05),(11,3367,1.05),(12,3367,1.05),(13,3367,1.05),(14,3367,1.05),(15,3367,1.05),(16,3367,1.05),(17,3367,1.05),(18,3367,1.05),(19,3367,1.05),(20,3367,1.05),(21,3367,1.05),(2,3368,0.95669),(3,3368,0.95669),(4,3368,0.95669),(5,3368,0.95669),(6,3368,0.95669),(7,3368,0.95669),(8,3368,0.95669),(9,3368,0.95669),(10,3368,0.95669),(11,3368,0.95669),(12,3368,0.95669),(13,3368,0.95669),(14,3368,0.95669),(15,3368,0.95669),(16,3368,0.95669),(17,3368,0.95669),(18,3368,0.95669),(19,3368,0.95669),(20,3368,0.95669),(21,3368,0.95669),(2,3369,1.02669),(3,3369,1.02669),(4,3369,1.02669),(5,3369,1.02669),(6,3369,1.02669),(7,3369,1.02669),(8,3369,1.02669),(9,3369,1.02669),(10,3369,1.02669),(11,3369,1.02669),(12,3369,1.02669),(13,3369,1.02669),(14,3369,1.02669),(15,3369,1.02669),(16,3369,1.02669),(17,3369,1.02669),(18,3369,1.02669),(19,3369,1.02669),(20,3369,1.02669),(21,3369,1.02669),(2,3370,0.93338),(3,3370,0.93338),(4,3370,0.93338),(5,3370,0.93338),(6,3370,0.93338),(7,3370,0.93338),(8,3370,0.93338),(9,3370,0.93338),(10,3370,0.93338),(11,3370,0.93338),(12,3370,0.93338),(13,3370,0.93338),(14,3370,0.93338),(15,3370,0.93338),(16,3370,0.93338),(17,3370,0.93338),(18,3370,0.93338),(19,3370,0.93338),(20,3370,0.93338),(21,3370,0.93338),(2,3371,1.14331),(3,3371,1.14331),(4,3371,1.14331),(5,3371,1.14331),(6,3371,1.14331),(7,3371,1.14331),(8,3371,1.14331),(9,3371,1.14331),(10,3371,1.14331),(11,3371,1.14331),(12,3371,1.14331),(13,3371,1.14331),(14,3371,1.14331),(15,3371,1.14331),(16,3371,1.14331),(17,3371,1.14331),(18,3371,1.14331),(19,3371,1.14331),(20,3371,1.14331),(21,3371,1.14331),(2,3372,1.23669),(3,3372,1.23669),(4,3372,1.23669),(5,3372,1.23669),(6,3372,1.23669),(7,3372,1.23669),(8,3372,1.23669),(9,3372,1.23669),(10,3372,1.23669),(11,3372,1.23669),(12,3372,1.23669),(13,3372,1.23669),(14,3372,1.23669),(15,3372,1.23669),(16,3372,1.23669),(17,3372,1.23669),(18,3372,1.23669),(19,3372,1.23669),(20,3372,1.23669),(21,3372,1.23669),(2,3373,1.12),(3,3373,1.12),(4,3373,1.12),(5,3373,1.12),(6,3373,1.12),(7,3373,1.12),(8,3373,1.12),(9,3373,1.12),(10,3373,1.12),(11,3373,1.12),(12,3373,1.12),(13,3373,1.12),(14,3373,1.12),(15,3373,1.12),(16,3373,1.12),(17,3373,1.12),(18,3373,1.12),(19,3373,1.12),(20,3373,1.12),(21,3373,1.12),(2,3374,1.30669),(3,3374,1.30669),(4,3374,1.30669),(5,3374,1.30669),(6,3374,1.30669),(7,3374,1.30669),(8,3374,1.30669),(9,3374,1.30669),(10,3374,1.30669),(11,3374,1.30669),(12,3374,1.30669),(13,3374,1.30669),(14,3374,1.30669),(15,3374,1.30669),(16,3374,1.30669),(17,3374,1.30669),(18,3374,1.30669),(19,3374,1.30669),(20,3374,1.30669),(21,3374,1.30669),(2,3375,1.02669),(3,3375,1.02669),(4,3375,1.02669),(5,3375,1.02669),(6,3375,1.02669),(7,3375,1.02669),(8,3375,1.02669),(9,3375,1.02669),(10,3375,1.02669),(11,3375,1.02669),(12,3375,1.02669),(13,3375,1.02669),(14,3375,1.02669),(15,3375,1.02669),(16,3375,1.02669),(17,3375,1.02669),(18,3375,1.02669),(19,3375,1.02669),(20,3375,1.02669),(21,3375,1.02669),(2,3376,1.14331),(3,3376,1.14331),(4,3376,1.14331),(5,3376,1.14331),(6,3376,1.14331),(7,3376,1.14331),(8,3376,1.14331),(9,3376,1.14331),(10,3376,1.14331),(11,3376,1.14331),(12,3376,1.14331),(13,3376,1.14331),(14,3376,1.14331),(15,3376,1.14331),(16,3376,1.14331),(17,3376,1.14331),(18,3376,1.14331),(19,3376,1.14331),(20,3376,1.14331),(21,3376,1.14331),(2,3377,0.95669),(3,3377,0.95669),(4,3377,0.95669),(5,3377,0.95669),(6,3377,0.95669),(7,3377,0.95669),(8,3377,0.95669),(9,3377,0.95669),(10,3377,0.95669),(11,3377,0.95669),(12,3377,0.95669),(13,3377,0.95669),(14,3377,0.95669),(15,3377,0.95669),(16,3377,0.95669),(17,3377,0.95669),(18,3377,0.95669),(19,3377,0.95669),(20,3377,0.95669),(21,3377,0.95669),(2,3378,1.05),(3,3378,1.05),(4,3378,1.05),(5,3378,1.05),(6,3378,1.05),(7,3378,1.05),(8,3378,1.05),(9,3378,1.05),(10,3378,1.05),(11,3378,1.05),(12,3378,1.05),(13,3378,1.05),(14,3378,1.05),(15,3378,1.05),(16,3378,1.05),(17,3378,1.05),(18,3378,1.05),(19,3378,1.05),(20,3378,1.05),(21,3378,1.05),(2,3379,0.95669),(3,3379,0.95669),(4,3379,0.95669),(5,3379,0.95669),(6,3379,0.95669),(7,3379,0.95669),(8,3379,0.95669),(9,3379,0.95669),(10,3379,0.95669),(11,3379,0.95669),(12,3379,0.95669),(13,3379,0.95669),(14,3379,0.95669),(15,3379,0.95669),(16,3379,0.95669),(17,3379,0.95669),(18,3379,0.95669),(19,3379,0.95669),(20,3379,0.95669),(21,3379,0.95669),(2,3380,1.07331),(3,3380,1.07331),(4,3380,1.07331),(5,3380,1.07331),(6,3380,1.07331),(7,3380,1.07331),(8,3380,1.07331),(9,3380,1.07331),(10,3380,1.07331),(11,3380,1.07331),(12,3380,1.07331),(13,3380,1.07331),(14,3380,1.07331),(15,3380,1.07331),(16,3380,1.07331),(17,3380,1.07331),(18,3380,1.07331),(19,3380,1.07331),(20,3380,1.07331),(21,3380,1.07331),(2,3381,1.14331),(3,3381,1.14331),(4,3381,1.14331),(5,3381,1.14331),(6,3381,1.14331),(7,3381,1.14331),(8,3381,1.14331),(9,3381,1.14331),(10,3381,1.14331),(11,3381,1.14331),(12,3381,1.14331),(13,3381,1.14331),(14,3381,1.14331),(15,3381,1.14331),(16,3381,1.14331),(17,3381,1.14331),(18,3381,1.14331),(19,3381,1.14331),(20,3381,1.14331),(21,3381,1.14331),(2,3382,1.33),(3,3382,1.33),(4,3382,1.33),(5,3382,1.33),(6,3382,1.33),(7,3382,1.33),(8,3382,1.33),(9,3382,1.33),(10,3382,1.33),(11,3382,1.33),(12,3382,1.33),(13,3382,1.33),(14,3382,1.33),(15,3382,1.33),(16,3382,1.33),(17,3382,1.33),(18,3382,1.33),(19,3382,1.33),(20,3382,1.33),(21,3382,1.33),(2,3383,0.95669),(3,3383,0.95669),(4,3383,0.95669),(5,3383,0.95669),(6,3383,0.95669),(7,3383,0.95669),(8,3383,0.95669),(9,3383,0.95669),(10,3383,0.95669),(11,3383,0.95669),(12,3383,0.95669),(13,3383,0.95669),(14,3383,0.95669),(15,3383,0.95669),(16,3383,0.95669),(17,3383,0.95669),(18,3383,0.95669),(19,3383,0.95669),(20,3383,0.95669),(21,3383,0.95669),(2,3384,1.09669),(3,3384,1.09669),(4,3384,1.09669),(5,3384,1.09669),(6,3384,1.09669),(7,3384,1.09669),(8,3384,1.09669),(9,3384,1.09669),(10,3384,1.09669),(11,3384,1.09669),(12,3384,1.09669),(13,3384,1.09669),(14,3384,1.09669),(15,3384,1.09669),(16,3384,1.09669),(17,3384,1.09669),(18,3384,1.09669),(19,3384,1.09669),(20,3384,1.09669),(21,3384,1.09669),(2,3385,1.72679),(6,3385,1.72679),(13,3385,1.72679),(18,3385,1.72679),(2,3386,5.42679),(2,3387,6.53679),(2,3388,0.93331),(3,3388,0.93331),(4,3388,0.93331),(5,3388,0.93331),(6,3388,0.93331),(7,3388,0.93331),(8,3388,0.93331),(9,3388,0.93331),(10,3388,0.93331),(11,3388,0.93331),(12,3388,0.93331),(13,3388,0.93331),(14,3388,0.93331),(15,3388,0.93331),(16,3388,0.93331),(17,3388,0.93331),(18,3388,0.93331),(19,3388,0.93331),(20,3388,0.93331),(21,3388,0.93331),(2,3389,1.02669),(3,3389,1.02669),(4,3389,1.02669),(5,3389,1.02669),(6,3389,1.02669),(7,3389,1.02669),(8,3389,1.02669),(9,3389,1.02669),(10,3389,1.02669),(11,3389,1.02669),(12,3389,1.02669),(13,3389,1.02669),(14,3389,1.02669),(15,3389,1.02669),(16,3389,1.02669),(17,3389,1.02669),(18,3389,1.02669),(19,3389,1.02669),(20,3389,1.02669),(21,3389,1.02669),(2,3390,0.91),(3,3390,0.91),(4,3390,0.91),(5,3390,0.91),(6,3390,0.91),(7,3390,0.91),(8,3390,0.91),(9,3390,0.91),(10,3390,0.91),(11,3390,0.91),(12,3390,0.91),(13,3390,0.91),(14,3390,0.91),(15,3390,0.91),(16,3390,0.91),(17,3390,0.91),(18,3390,0.91),(19,3390,0.91),(20,3390,0.91),(21,3390,0.91),(2,3391,1.09669),(3,3391,1.09669),(4,3391,1.09669),(5,3391,1.09669),(6,3391,1.09669),(7,3391,1.09669),(8,3391,1.09669),(9,3391,1.09669),(10,3391,1.09669),(11,3391,1.09669),(12,3391,1.09669),(13,3391,1.09669),(14,3391,1.09669),(15,3391,1.09669),(16,3391,1.09669),(17,3391,1.09669),(18,3391,1.09669),(19,3391,1.09669),(20,3391,1.09669),(21,3391,1.09669),(2,3548,4.19321),(2,3549,4.44),(2,3550,0.86331),(3,3550,0.86331),(4,3550,0.86331),(5,3550,0.86331),(6,3550,0.86331),(7,3550,0.86331),(8,3550,0.86331),(9,3550,0.86331),(10,3550,0.86331),(11,3550,0.86331),(12,3550,0.86331),(13,3550,0.86331),(14,3550,0.86331),(15,3550,0.86331),(16,3550,0.86331),(17,3550,0.86331),(18,3550,0.86331),(19,3550,0.86331),(20,3550,0.86331),(21,3550,0.86331),(2,3551,1.02669),(3,3551,1.02669),(4,3551,1.02669),(5,3551,1.02669),(6,3551,1.02669),(7,3551,1.02669),(8,3551,1.02669),(9,3551,1.02669),(10,3551,1.02669),(11,3551,1.02669),(12,3551,1.02669),(13,3551,1.02669),(14,3551,1.02669),(15,3551,1.02669),(16,3551,1.02669),(17,3551,1.02669),(18,3551,1.02669),(19,3551,1.02669),(20,3551,1.02669),(21,3551,1.02669),(2,3552,0.88669),(3,3552,0.88669),(4,3552,0.88669),(5,3552,0.88669),(6,3552,0.88669),(7,3552,0.88669),(8,3552,0.88669),(9,3552,0.88669),(10,3552,0.88669),(11,3552,0.88669),(12,3552,0.88669),(13,3552,0.88669),(14,3552,0.88669),(15,3552,0.88669),(16,3552,0.88669),(17,3552,0.88669),(18,3552,0.88669),(19,3552,0.88669),(20,3552,0.88669),(21,3552,0.88669),(2,3553,1.00331),(3,3553,1.00331),(4,3553,1.00331),(5,3553,1.00331),(6,3553,1.00331),(7,3553,1.00331),(8,3553,1.00331),(9,3553,1.00331),(10,3553,1.00331),(11,3553,1.00331),(12,3553,1.00331),(13,3553,1.00331),(14,3553,1.00331),(15,3553,1.00331),(16,3553,1.00331),(17,3553,1.00331),(18,3553,1.00331),(19,3553,1.00331),(20,3553,1.00331),(21,3553,1.00331),(2,3554,0.98),(3,3554,0.98),(4,3554,0.98),(5,3554,0.98),(6,3554,0.98),(7,3554,0.98),(8,3554,0.98),(9,3554,0.98),(10,3554,0.98),(11,3554,0.98),(12,3554,0.98),(13,3554,0.98),(14,3554,0.98),(15,3554,0.98),(16,3554,0.98),(17,3554,0.98),(18,3554,0.98),(19,3554,0.98),(20,3554,0.98),(21,3554,0.98),(2,3555,1.19),(3,3555,1.19),(4,3555,1.19),(5,3555,1.19),(6,3555,1.19),(7,3555,1.19),(8,3555,1.19),(9,3555,1.19),(10,3555,1.19),(11,3555,1.19),(12,3555,1.19),(13,3555,1.19),(14,3555,1.19),(15,3555,1.19),(16,3555,1.19),(17,3555,1.19),(18,3555,1.19),(19,3555,1.19),(20,3555,1.19),(21,3555,1.19),(2,3556,1.05),(3,3556,1.05),(4,3556,1.05),(5,3556,1.05),(6,3556,1.05),(7,3556,1.05),(8,3556,1.05),(9,3556,1.05),(10,3556,1.05),(11,3556,1.05),(12,3556,1.05),(13,3556,1.05),(14,3556,1.05),(15,3556,1.05),(16,3556,1.05),(17,3556,1.05),(18,3556,1.05),(19,3556,1.05),(20,3556,1.05),(21,3556,1.05),(2,3557,0.98679),(2,3558,0.37331),(3,3558,0.37331),(4,3558,0.37331),(5,3558,0.37331),(6,3558,0.37331),(7,3558,0.37331),(8,3558,0.37331),(9,3558,0.37331),(10,3558,0.37331),(11,3558,0.37331),(12,3558,0.37331),(13,3558,0.37331),(14,3558,0.37331),(15,3558,0.37331),(16,3558,0.37331),(17,3558,0.37331),(18,3558,0.37331),(19,3558,0.37331),(20,3558,0.37331),(21,3558,0.37331),(2,3559,0.95669),(3,3559,0.95669),(4,3559,0.95669),(5,3559,0.95669),(6,3559,0.95669),(7,3559,0.95669),(8,3559,0.95669),(9,3559,0.95669),(10,3559,0.95669),(11,3559,0.95669),(12,3559,0.95669),(13,3559,0.95669),(14,3559,0.95669),(15,3559,0.95669),(16,3559,0.95669),(17,3559,0.95669),(18,3559,0.95669),(19,3559,0.95669),(20,3559,0.95669),(21,3559,0.95669),(2,3560,1.16669),(3,3560,1.16669),(4,3560,1.16669),(5,3560,1.16669),(6,3560,1.16669),(7,3560,1.16669),(8,3560,1.16669),(9,3560,1.16669),(10,3560,1.16669),(11,3560,1.16669),(12,3560,1.16669),(13,3560,1.16669),(14,3560,1.16669),(15,3560,1.16669),(16,3560,1.16669),(17,3560,1.16669),(18,3560,1.16669),(19,3560,1.16669),(20,3560,1.16669),(21,3560,1.16669),(3,3626,1.72679),(7,3626,1.72679),(13,3626,1.72679),(18,3626,1.72679),(19,3626,1.72679),(20,3626,1.72679),(3,3627,5.05679),(20,3627,5.05679),(3,3628,6.41321),(3,3629,4.81),(3,3630,5.18),(3,3631,1.48),(6,3679,4.44),(6,3680,5.42679),(6,3681,5.18),(6,3682,6.53679),(7,3715,1.23321),(8,3715,1.23321),(21,3715,1.23321),(7,3716,4.93321),(7,3717,5.18),(7,3737,5.42679),(13,3737,5.42679),(18,3737,5.42679),(7,3738,6.04321),(8,3771,4.44),(8,3772,5.05679),(8,3773,5.05679),(8,3774,5.55),(8,3775,4.68679),(8,3776,5.55),(9,3804,4.44),(9,3805,4.81),(9,3806,4.68679),(9,3807,5.30321),(9,3808,5.18),(9,3809,5.55),(9,3823,2.3334),(9,3824,2.5334),(10,3865,0.98679),(11,3865,0.98679),(10,3874,2.8),(10,3875,3.4),(10,3876,2.89),(10,3877,3.17339),(11,3930,5.05679),(11,3931,5.42679),(11,3932,4.44),(11,3933,5.30321),(11,3945,1.72679),(11,3946,5.79679),(12,3961,4.56321),(12,3962,5.55),(12,3963,4.44),(12,3964,4.81),(12,3978,0.98679),(12,3979,4.56321),(12,3980,5.42679),(13,3999,5.05679),(13,4000,6.04321),(13,4010,5.92),(14,4066,2.46679),(14,4067,5.55),(14,4068,6.53679),(15,4084,4.31679),(15,4085,5.67321),(16,4126,4.31679),(16,4127,5.42679),(17,4132,4.44),(17,4133,5.18),(17,4150,2.2666),(17,4151,2.6),(17,4152,0.98642),(17,4153,4.68679),(17,4154,5.18),(17,4155,4.56321),(17,4156,5.05679),(18,4208,6.29),(19,4246,5.18),(19,4247,5.55),(20,4261,2.2666),(20,4262,2.6),(20,4263,2.21),(20,4264,2.43661),(20,4282,0.98679),(20,4283,4.56321),(20,4284,5.30321),(20,4285,5.55),(20,4286,1.23321),(20,4287,5.05679),(21,4323,2.22),(21,4324,5.55),(21,4325,6.16679),(21,4326,5.55),(21,4327,6.29);


--
-- Table structure for table `#__finder_links_terms1`
--



CREATE TABLE `#__finder_links_terms1` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms1`
--


INSERT INTO `#__finder_links_terms1` (`link_id`, `term_id`, `weight`) VALUES (6,620,0.17);


--
-- Table structure for table `#__finder_links_terms2`
--



CREATE TABLE `#__finder_links_terms2` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms2`
--


INSERT INTO `#__finder_links_terms2` (`link_id`, `term_id`, `weight`) VALUES (1,98,0.32669),(2,98,0.65338),(3,98,0.65338),(4,98,0.65338),(5,98,0.65338),(6,98,0.65338),(7,98,0.65338),(8,98,0.65338),(9,98,0.65338),(10,98,0.65338),(11,98,0.65338),(12,98,0.65338),(13,98,0.65338),(14,98,0.65338),(15,98,0.65338),(16,98,0.65338),(17,98,0.65338),(18,98,0.65338),(19,98,0.65338),(20,98,0.65338),(21,98,0.65338),(1,99,0.98),(2,99,0.98),(3,99,0.98),(4,99,0.98),(5,99,0.98),(6,99,0.98),(7,99,0.98),(8,99,0.98),(9,99,0.98),(10,99,0.98),(11,99,0.98),(12,99,0.98),(13,99,0.98),(14,99,0.98),(15,99,0.98),(16,99,0.98),(17,99,0.98),(18,99,0.98),(19,99,0.98),(20,99,0.98),(21,99,0.98),(1,100,1.21331),(2,100,1.21331),(3,100,1.21331),(4,100,1.21331),(5,100,1.21331),(6,100,1.21331),(7,100,1.21331),(8,100,1.21331),(9,100,1.21331),(10,100,1.21331),(11,100,1.21331),(12,100,1.21331),(13,100,1.21331),(14,100,1.21331),(15,100,1.21331),(16,100,1.21331),(17,100,1.21331),(18,100,1.21331),(19,100,1.21331),(20,100,1.21331),(21,100,1.21331),(1,101,0.32669),(2,101,0.98007),(3,101,0.98007),(4,101,0.98007),(5,101,0.98007),(6,101,0.98007),(7,101,0.98007),(8,101,0.98007),(9,101,0.98007),(10,101,0.98007),(11,101,0.98007),(12,101,0.98007),(13,101,0.98007),(14,101,0.98007),(15,101,0.98007),(16,101,0.98007),(17,101,0.98007),(18,101,0.98007),(19,101,0.98007),(20,101,0.98007),(21,101,0.98007),(1,102,0.95669),(2,102,0.95669),(3,102,0.95669),(4,102,0.95669),(5,102,0.95669),(6,102,0.95669),(7,102,0.95669),(8,102,0.95669),(9,102,0.95669),(10,102,0.95669),(11,102,0.95669),(12,102,0.95669),(13,102,0.95669),(14,102,0.95669),(15,102,0.95669),(16,102,0.95669),(17,102,0.95669),(18,102,0.95669),(19,102,0.95669),(20,102,0.95669),(21,102,0.95669),(1,103,1.07331),(2,103,1.07331),(3,103,1.07331),(4,103,1.07331),(5,103,1.07331),(6,103,1.07331),(7,103,1.07331),(8,103,1.07331),(9,103,1.07331),(10,103,1.07331),(11,103,1.07331),(12,103,1.07331),(13,103,1.07331),(14,103,1.07331),(15,103,1.07331),(16,103,1.07331),(17,103,1.07331),(18,103,1.07331),(19,103,1.07331),(20,103,1.07331),(21,103,1.07331),(2,104,0.42),(3,104,0.42),(4,104,0.42),(5,104,0.42),(6,104,0.42),(7,104,0.42),(8,104,0.42),(9,104,0.42),(10,104,0.42),(11,104,0.42),(12,104,0.42),(13,104,0.42),(14,104,0.42),(15,104,0.42),(16,104,0.42),(17,104,0.42),(18,104,0.42),(19,104,0.42),(20,104,0.42),(21,104,0.42),(1,104,0.42),(1,105,0.91),(2,105,0.91),(3,105,0.91),(4,105,0.91),(5,105,0.91),(6,105,0.91),(7,105,0.91),(8,105,0.91),(9,105,0.91),(10,105,0.91),(11,105,0.91),(12,105,0.91),(13,105,0.91),(14,105,0.91),(15,105,0.91),(16,105,0.91),(17,105,0.91),(18,105,0.91),(19,105,0.91),(20,105,0.91),(21,105,0.91),(1,106,1.19),(2,106,1.19),(3,106,1.19),(4,106,1.19),(5,106,1.19),(6,106,1.19),(7,106,1.19),(8,106,1.19),(9,106,1.19),(10,106,1.19),(11,106,1.19),(12,106,1.19),(13,106,1.19),(14,106,1.19),(15,106,1.19),(16,106,1.19),(17,106,1.19),(18,106,1.19),(19,106,1.19),(20,106,1.19),(21,106,1.19),(1,107,0.93331),(2,107,0.93331),(3,107,0.93331),(4,107,0.93331),(5,107,0.93331),(6,107,0.93331),(7,107,0.93331),(8,107,0.93331),(9,107,0.93331),(10,107,0.93331),(11,107,0.93331),(12,107,0.93331),(13,107,0.93331),(14,107,0.93331),(15,107,0.93331),(16,107,0.93331),(17,107,0.93331),(18,107,0.93331),(19,107,0.93331),(20,107,0.93331),(21,107,0.93331),(1,108,1.05),(2,108,1.05),(3,108,1.05),(4,108,1.05),(5,108,1.05),(6,108,1.05),(7,108,1.05),(8,108,1.05),(9,108,1.05),(10,108,1.05),(11,108,1.05),(12,108,1.05),(13,108,1.05),(14,108,1.05),(15,108,1.05),(16,108,1.05),(17,108,1.05),(18,108,1.05),(19,108,1.05),(20,108,1.05),(21,108,1.05),(1,109,0.88669),(2,109,0.88669),(3,109,0.88669),(4,109,0.88669),(5,109,0.88669),(6,109,0.88669),(7,109,0.88669),(8,109,0.88669),(9,109,0.88669),(10,109,0.88669),(11,109,0.88669),(12,109,0.88669),(13,109,0.88669),(14,109,0.88669),(15,109,0.88669),(16,109,0.88669),(17,109,0.88669),(18,109,0.88669),(19,109,0.88669),(20,109,0.88669),(21,109,0.88669),(1,110,1.19),(2,110,1.19),(3,110,1.19),(4,110,1.19),(5,110,1.19),(6,110,1.19),(7,110,1.19),(8,110,1.19),(9,110,1.19),(10,110,1.19),(11,110,1.19),(12,110,1.19),(13,110,1.19),(14,110,1.19),(15,110,1.19),(16,110,1.19),(17,110,1.19),(18,110,1.19),(19,110,1.19),(20,110,1.19),(21,110,1.19),(1,111,0.37331),(2,111,0.37331),(3,111,0.37331),(4,111,0.37331),(5,111,0.37331),(6,111,0.37331),(7,111,0.37331),(8,111,0.37331),(9,111,0.37331),(10,111,0.37331),(11,111,0.37331),(12,111,0.37331),(13,111,0.37331),(14,111,0.37331),(15,111,0.37331),(16,111,0.37331),(17,111,0.37331),(18,111,0.37331),(19,111,0.37331),(20,111,0.37331),(21,111,0.37331),(1,112,1.02669),(2,112,1.02669),(3,112,1.02669),(4,112,1.02669),(5,112,1.02669),(6,112,1.02669),(7,112,1.02669),(8,112,1.02669),(9,112,1.02669),(10,112,1.02669),(11,112,1.02669),(12,112,1.02669),(13,112,1.02669),(14,112,1.02669),(15,112,1.02669),(16,112,1.02669),(17,112,1.02669),(18,112,1.02669),(19,112,1.02669),(20,112,1.02669),(21,112,1.02669),(2,113,1.30669),(3,113,1.30669),(4,113,1.30669),(5,113,1.30669),(6,113,1.30669),(7,113,1.30669),(8,113,1.30669),(9,113,1.30669),(10,113,1.30669),(11,113,1.30669),(12,113,1.30669),(13,113,1.30669),(14,113,1.30669),(15,113,1.30669),(16,113,1.30669),(17,113,1.30669),(18,113,1.30669),(19,113,1.30669),(20,113,1.30669),(21,113,1.30669),(1,113,1.30669),(1,114,0.28),(2,114,0.56),(3,114,0.56),(4,114,0.56),(5,114,0.56),(6,114,0.56),(7,114,0.56),(8,114,0.56),(9,114,0.56),(10,114,0.56),(11,114,0.56),(12,114,0.56),(13,114,0.56),(14,114,0.56),(15,114,0.56),(16,114,0.56),(17,114,0.56),(18,114,0.56),(19,114,0.56),(20,114,0.56),(21,114,0.56),(1,115,0.98),(2,115,0.98),(3,115,0.98),(4,115,0.98),(5,115,0.98),(6,115,0.98),(7,115,0.98),(8,115,0.98),(9,115,0.98),(10,115,0.98),(11,115,0.98),(12,115,0.98),(13,115,0.98),(14,115,0.98),(15,115,0.98),(16,115,0.98),(17,115,0.98),(18,115,0.98),(19,115,0.98),(20,115,0.98),(21,115,0.98),(1,116,1.19),(2,116,1.19),(3,116,1.19),(4,116,1.19),(5,116,1.19),(6,116,1.19),(7,116,1.19),(8,116,1.19),(9,116,1.19),(10,116,1.19),(11,116,1.19),(12,116,1.19),(13,116,1.19),(14,116,1.19),(15,116,1.19),(16,116,1.19),(17,116,1.19),(18,116,1.19),(19,116,1.19),(20,116,1.19),(21,116,1.19),(1,716,0.28),(2,716,0.56),(3,716,0.56),(4,716,0.56),(5,716,0.56),(6,716,0.56),(7,716,0.56),(8,716,0.56),(9,716,0.56),(10,716,0.56),(11,716,0.56),(12,716,0.56),(13,716,0.56),(14,716,0.56),(15,716,0.56),(16,716,0.56),(17,716,0.56),(18,716,0.56),(19,716,0.56),(20,716,0.56),(21,716,0.56),(3,1017,0.74),(4,1017,0.74),(20,1017,0.74),(4,1553,5.18),(4,1554,5.79679),(17,1777,1.23321),(1,3173,0.28),(2,3173,0.28),(3,3173,0.28),(4,3173,0.28),(5,3173,0.28),(6,3173,0.28),(7,3173,0.28),(8,3173,0.28),(9,3173,0.28),(10,3173,0.28),(11,3173,0.28),(12,3173,0.28),(13,3173,0.28),(14,3173,0.28),(15,3173,0.28),(16,3173,0.28),(17,3173,0.28),(18,3173,0.28),(19,3173,0.28),(20,3173,0.28),(21,3173,0.28),(1,3174,1.00331),(2,3174,1.00331),(3,3174,1.00331),(4,3174,1.00331),(5,3174,1.00331),(6,3174,1.00331),(7,3174,1.00331),(8,3174,1.00331),(9,3174,1.00331),(10,3174,1.00331),(11,3174,1.00331),(12,3174,1.00331),(13,3174,1.00331),(14,3174,1.00331),(15,3174,1.00331),(16,3174,1.00331),(17,3174,1.00331),(18,3174,1.00331),(19,3174,1.00331),(20,3174,1.00331),(21,3174,1.00331),(1,3175,1.16669),(2,3175,1.16669),(3,3175,1.16669),(4,3175,1.16669),(5,3175,1.16669),(6,3175,1.16669),(7,3175,1.16669),(8,3175,1.16669),(9,3175,1.16669),(10,3175,1.16669),(11,3175,1.16669),(12,3175,1.16669),(13,3175,1.16669),(14,3175,1.16669),(15,3175,1.16669),(16,3175,1.16669),(17,3175,1.16669),(18,3175,1.16669),(19,3175,1.16669),(20,3175,1.16669),(21,3175,1.16669),(1,3176,1.00331),(2,3176,1.00331),(3,3176,1.00331),(4,3176,1.00331),(5,3176,1.00331),(6,3176,1.00331),(7,3176,1.00331),(8,3176,1.00331),(9,3176,1.00331),(10,3176,1.00331),(11,3176,1.00331),(12,3176,1.00331),(13,3176,1.00331),(14,3176,1.00331),(15,3176,1.00331),(16,3176,1.00331),(17,3176,1.00331),(18,3176,1.00331),(19,3176,1.00331),(20,3176,1.00331),(21,3176,1.00331),(1,3177,1.12),(2,3177,1.12),(3,3177,1.12),(4,3177,1.12),(5,3177,1.12),(6,3177,1.12),(7,3177,1.12),(8,3177,1.12),(9,3177,1.12),(10,3177,1.12),(11,3177,1.12),(12,3177,1.12),(13,3177,1.12),(14,3177,1.12),(15,3177,1.12),(16,3177,1.12),(17,3177,1.12),(18,3177,1.12),(19,3177,1.12),(20,3177,1.12),(21,3177,1.12),(2,3178,0.23331),(3,3178,0.23331),(4,3178,0.23331),(5,3178,0.23331),(6,3178,0.23331),(7,3178,0.23331),(8,3178,0.23331),(9,3178,0.23331),(10,3178,0.23331),(11,3178,0.23331),(12,3178,0.23331),(13,3178,0.23331),(14,3178,0.23331),(15,3178,0.23331),(16,3178,0.23331),(17,3178,0.23331),(18,3178,0.23331),(19,3178,0.23331),(20,3178,0.23331),(21,3178,0.23331),(1,3178,1.63317),(1,3179,0.91),(2,3179,0.91),(3,3179,0.91),(4,3179,0.91),(5,3179,0.91),(6,3179,0.91),(7,3179,0.91),(8,3179,0.91),(9,3179,0.91),(10,3179,0.91),(11,3179,0.91),(12,3179,0.91),(13,3179,0.91),(14,3179,0.91),(15,3179,0.91),(16,3179,0.91),(17,3179,0.91),(18,3179,0.91),(19,3179,0.91),(20,3179,0.91),(21,3179,0.91),(1,3180,0.98),(2,3180,0.98),(3,3180,0.98),(4,3180,0.98),(5,3180,0.98),(6,3180,0.98),(7,3180,0.98),(8,3180,0.98),(9,3180,0.98),(10,3180,0.98),(11,3180,0.98),(12,3180,0.98),(13,3180,0.98),(14,3180,0.98),(15,3180,0.98),(16,3180,0.98),(17,3180,0.98),(18,3180,0.98),(19,3180,0.98),(20,3180,0.98),(21,3180,0.98),(2,3458,0.84),(3,3458,0.84),(4,3458,0.84),(5,3458,0.84),(6,3458,0.84),(7,3458,0.84),(8,3458,0.84),(9,3458,0.84),(10,3458,0.84),(11,3458,0.84),(12,3458,0.84),(13,3458,0.84),(14,3458,0.84),(15,3458,0.84),(16,3458,0.84),(17,3458,0.84),(18,3458,0.84),(19,3458,0.84),(20,3458,0.84),(21,3458,0.84),(2,3459,1.09669),(3,3459,1.09669),(4,3459,1.09669),(5,3459,1.09669),(6,3459,1.09669),(7,3459,1.09669),(8,3459,1.09669),(9,3459,1.09669),(10,3459,1.09669),(11,3459,1.09669),(12,3459,1.09669),(13,3459,1.09669),(14,3459,1.09669),(15,3459,1.09669),(16,3459,1.09669),(17,3459,1.09669),(18,3459,1.09669),(19,3459,1.09669),(20,3459,1.09669),(21,3459,1.09669),(2,3460,1.21331),(3,3460,1.21331),(4,3460,1.21331),(5,3460,1.21331),(6,3460,1.21331),(7,3460,1.21331),(8,3460,1.21331),(9,3460,1.21331),(10,3460,1.21331),(11,3460,1.21331),(12,3460,1.21331),(13,3460,1.21331),(14,3460,1.21331),(15,3460,1.21331),(16,3460,1.21331),(17,3460,1.21331),(18,3460,1.21331),(19,3460,1.21331),(20,3460,1.21331),(21,3460,1.21331),(2,3461,1.12),(3,3461,1.12),(4,3461,1.12),(5,3461,1.12),(6,3461,1.12),(7,3461,1.12),(8,3461,1.12),(9,3461,1.12),(10,3461,1.12),(11,3461,1.12),(12,3461,1.12),(13,3461,1.12),(14,3461,1.12),(15,3461,1.12),(16,3461,1.12),(17,3461,1.12),(18,3461,1.12),(19,3461,1.12),(20,3461,1.12),(21,3461,1.12),(2,3462,1.19),(3,3462,1.19),(4,3462,1.19),(5,3462,1.19),(6,3462,1.19),(7,3462,1.19),(8,3462,1.19),(9,3462,1.19),(10,3462,1.19),(11,3462,1.19),(12,3462,1.19),(13,3462,1.19),(14,3462,1.19),(15,3462,1.19),(16,3462,1.19),(17,3462,1.19),(18,3462,1.19),(19,3462,1.19),(20,3462,1.19),(21,3462,1.19),(2,3472,1.02669),(3,3472,1.02669),(4,3472,1.02669),(5,3472,1.02669),(6,3472,1.02669),(7,3472,1.02669),(8,3472,1.02669),(9,3472,1.02669),(10,3472,1.02669),(11,3472,1.02669),(12,3472,1.02669),(13,3472,1.02669),(14,3472,1.02669),(15,3472,1.02669),(16,3472,1.02669),(17,3472,1.02669),(18,3472,1.02669),(19,3472,1.02669),(20,3472,1.02669),(21,3472,1.02669),(2,3473,1.23669),(3,3473,1.23669),(4,3473,1.23669),(5,3473,1.23669),(6,3473,1.23669),(7,3473,1.23669),(8,3473,1.23669),(9,3473,1.23669),(10,3473,1.23669),(11,3473,1.23669),(12,3473,1.23669),(13,3473,1.23669),(14,3473,1.23669),(15,3473,1.23669),(16,3473,1.23669),(17,3473,1.23669),(18,3473,1.23669),(19,3473,1.23669),(20,3473,1.23669),(21,3473,1.23669),(2,3474,0.23331),(3,3474,0.23331),(4,3474,0.23331),(5,3474,0.23331),(6,3474,0.23331),(7,3474,0.23331),(8,3474,0.23331),(9,3474,0.23331),(10,3474,0.23331),(11,3474,0.23331),(12,3474,0.23331),(13,3474,0.23331),(14,3474,0.23331),(15,3474,0.23331),(16,3474,0.23331),(17,3474,0.23331),(18,3474,0.23331),(19,3474,0.23331),(20,3474,0.23331),(21,3474,0.23331),(2,3475,1.05),(3,3475,1.05),(4,3475,1.05),(5,3475,1.05),(6,3475,1.05),(7,3475,1.05),(8,3475,1.05),(9,3475,1.05),(10,3475,1.05),(11,3475,1.05),(12,3475,1.05),(13,3475,1.05),(14,3475,1.05),(15,3475,1.05),(16,3475,1.05),(17,3475,1.05),(18,3475,1.05),(19,3475,1.05),(20,3475,1.05),(21,3475,1.05),(2,3476,1.19),(3,3476,1.19),(4,3476,1.19),(5,3476,1.19),(6,3476,1.19),(7,3476,1.19),(8,3476,1.19),(9,3476,1.19),(10,3476,1.19),(11,3476,1.19),(12,3476,1.19),(13,3476,1.19),(14,3476,1.19),(15,3476,1.19),(16,3476,1.19),(17,3476,1.19),(18,3476,1.19),(19,3476,1.19),(20,3476,1.19),(21,3476,1.19),(2,3477,0.98),(3,3477,0.98),(4,3477,0.98),(5,3477,0.98),(6,3477,0.98),(7,3477,0.98),(8,3477,0.98),(9,3477,0.98),(10,3477,0.98),(11,3477,0.98),(12,3477,0.98),(13,3477,0.98),(14,3477,0.98),(15,3477,0.98),(16,3477,0.98),(17,3477,0.98),(18,3477,0.98),(19,3477,0.98),(20,3477,0.98),(21,3477,0.98),(2,3478,1.09669),(3,3478,1.09669),(4,3478,1.09669),(5,3478,1.09669),(6,3478,1.09669),(7,3478,1.09669),(8,3478,1.09669),(9,3478,1.09669),(10,3478,1.09669),(11,3478,1.09669),(12,3478,1.09669),(13,3478,1.09669),(14,3478,1.09669),(15,3478,1.09669),(16,3478,1.09669),(17,3478,1.09669),(18,3478,1.09669),(19,3478,1.09669),(20,3478,1.09669),(21,3478,1.09669),(2,3479,0.98),(3,3479,0.98),(4,3479,0.98),(5,3479,0.98),(6,3479,0.98),(7,3479,0.98),(8,3479,0.98),(9,3479,0.98),(10,3479,0.98),(11,3479,0.98),(12,3479,0.98),(13,3479,0.98),(14,3479,0.98),(15,3479,0.98),(16,3479,0.98),(17,3479,0.98),(18,3479,0.98),(19,3479,0.98),(20,3479,0.98),(21,3479,0.98),(2,3480,1.12),(3,3480,1.12),(4,3480,1.12),(5,3480,1.12),(6,3480,1.12),(7,3480,1.12),(8,3480,1.12),(9,3480,1.12),(10,3480,1.12),(11,3480,1.12),(12,3480,1.12),(13,3480,1.12),(14,3480,1.12),(15,3480,1.12),(16,3480,1.12),(17,3480,1.12),(18,3480,1.12),(19,3480,1.12),(20,3480,1.12),(21,3480,1.12),(2,3481,1.02669),(3,3481,1.02669),(4,3481,1.02669),(5,3481,1.02669),(6,3481,1.02669),(7,3481,1.02669),(8,3481,1.02669),(9,3481,1.02669),(10,3481,1.02669),(11,3481,1.02669),(12,3481,1.02669),(13,3481,1.02669),(14,3481,1.02669),(15,3481,1.02669),(16,3481,1.02669),(17,3481,1.02669),(18,3481,1.02669),(19,3481,1.02669),(20,3481,1.02669),(21,3481,1.02669),(2,3482,1.09669),(3,3482,1.09669),(4,3482,1.09669),(5,3482,1.09669),(6,3482,1.09669),(7,3482,1.09669),(8,3482,1.09669),(9,3482,1.09669),(10,3482,1.09669),(11,3482,1.09669),(12,3482,1.09669),(13,3482,1.09669),(14,3482,1.09669),(15,3482,1.09669),(16,3482,1.09669),(17,3482,1.09669),(18,3482,1.09669),(19,3482,1.09669),(20,3482,1.09669),(21,3482,1.09669),(2,3483,1.02669),(3,3483,1.02669),(4,3483,1.02669),(5,3483,1.02669),(6,3483,1.02669),(7,3483,1.02669),(8,3483,1.02669),(9,3483,1.02669),(10,3483,1.02669),(11,3483,1.02669),(12,3483,1.02669),(13,3483,1.02669),(14,3483,1.02669),(15,3483,1.02669),(16,3483,1.02669),(17,3483,1.02669),(18,3483,1.02669),(19,3483,1.02669),(20,3483,1.02669),(21,3483,1.02669),(2,3484,1.07331),(3,3484,1.07331),(4,3484,1.07331),(5,3484,1.07331),(6,3484,1.07331),(7,3484,1.07331),(8,3484,1.07331),(9,3484,1.07331),(10,3484,1.07331),(11,3484,1.07331),(12,3484,1.07331),(13,3484,1.07331),(14,3484,1.07331),(15,3484,1.07331),(16,3484,1.07331),(17,3484,1.07331),(18,3484,1.07331),(19,3484,1.07331),(20,3484,1.07331),(21,3484,1.07331),(3,3615,5.42679),(3,3616,5.92),(3,3617,0.74),(3,3618,4.44),(3,3619,5.30321),(7,3722,1.0668),(7,3723,2.8),(7,3724,3.2666),(7,3725,2.4666),(7,3726,2.8),(7,3727,1.36),(7,3728,2.83339),(7,3729,3.23),(12,3971,1.48),(12,3972,5.05679),(12,3973,5.30321),(12,3974,1.48),(12,3975,5.42679),(12,3976,5.67321),(14,4055,1.48),(14,4056,4.93321),(14,4057,6.29),(16,4121,1.48),(16,4122,5.55),(16,4123,5.92),(17,4146,1.48),(17,4147,5.79679),(17,4148,4.81),(17,4149,5.67321),(20,4267,4.56321),(20,4268,4.81),(20,4275,0.74),(20,4276,4.44),(20,4277,4.81),(1,4339,5.74014),(1,4340,5.48345);


--
-- Table structure for table `#__finder_links_terms3`
--



CREATE TABLE `#__finder_links_terms3` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms3`
--


INSERT INTO `#__finder_links_terms3` (`link_id`, `term_id`, `weight`) VALUES (8,3779,0.98679),(8,3780,4.81),(15,4091,0.98679),(15,4092,4.44),(15,4093,4.93321);


--
-- Table structure for table `#__finder_links_terms4`
--



CREATE TABLE `#__finder_links_terms4` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms4`
--


INSERT INTO `#__finder_links_terms4` (`link_id`, `term_id`, `weight`) VALUES (1,26,1.53993),(2,26,1.53993),(3,26,1.53993),(4,26,1.53993),(5,26,1.53993),(6,26,1.53993),(7,26,1.53993),(8,26,1.53993),(9,26,1.53993),(10,26,1.53993),(11,26,1.53993),(12,26,1.53993),(13,26,1.53993),(14,26,1.53993),(15,26,1.53993),(16,26,1.53993),(17,26,1.53993),(18,26,1.53993),(19,26,1.53993),(20,26,1.53993),(21,26,1.53993),(1,27,1.05),(2,27,1.05),(3,27,1.05),(4,27,1.05),(5,27,1.05),(6,27,1.05),(7,27,1.05),(8,27,1.05),(9,27,1.05),(10,27,1.05),(11,27,1.05),(12,27,1.05),(13,27,1.05),(14,27,1.05),(15,27,1.05),(16,27,1.05),(17,27,1.05),(18,27,1.05),(19,27,1.05),(20,27,1.05),(21,27,1.05),(1,28,1.12),(2,28,1.12),(3,28,1.12),(4,28,1.12),(5,28,1.12),(6,28,1.12),(7,28,1.12),(8,28,1.12),(9,28,1.12),(10,28,1.12),(11,28,1.12),(12,28,1.12),(13,28,1.12),(14,28,1.12),(15,28,1.12),(16,28,1.12),(17,28,1.12),(18,28,1.12),(19,28,1.12),(20,28,1.12),(21,28,1.12),(1,29,2.19338),(2,29,2.19338),(3,29,2.19338),(4,29,2.19338),(5,29,2.19338),(6,29,2.19338),(7,29,2.19338),(8,29,2.19338),(9,29,2.19338),(10,29,2.19338),(11,29,2.19338),(12,29,2.19338),(13,29,2.19338),(14,29,2.19338),(15,29,2.19338),(16,29,2.19338),(17,29,2.19338),(18,29,2.19338),(19,29,2.19338),(20,29,2.19338),(21,29,2.19338),(1,30,2.38),(2,30,2.38),(3,30,2.38),(4,30,2.38),(5,30,2.38),(6,30,2.38),(7,30,2.38),(8,30,2.38),(9,30,2.38),(10,30,2.38),(11,30,2.38),(12,30,2.38),(13,30,2.38),(14,30,2.38),(15,30,2.38),(16,30,2.38),(17,30,2.38),(18,30,2.38),(19,30,2.38),(20,30,2.38),(21,30,2.38),(1,31,0.56007),(2,31,0.56007),(3,31,0.56007),(4,31,0.56007),(5,31,0.56007),(6,31,0.56007),(7,31,0.56007),(8,31,0.56007),(9,31,0.56007),(10,31,0.56007),(11,31,0.56007),(12,31,0.56007),(13,31,0.56007),(14,31,0.56007),(15,31,0.56007),(16,31,0.56007),(17,31,0.56007),(18,31,0.56007),(19,31,0.56007),(20,31,0.56007),(21,31,0.56007),(1,32,0.88669),(2,32,0.88669),(3,32,0.88669),(4,32,0.88669),(5,32,0.88669),(6,32,0.88669),(7,32,0.88669),(8,32,0.88669),(9,32,0.88669),(10,32,0.88669),(11,32,0.88669),(12,32,0.88669),(13,32,0.88669),(14,32,0.88669),(15,32,0.88669),(16,32,0.88669),(17,32,0.88669),(18,32,0.88669),(19,32,0.88669),(20,32,0.88669),(21,32,0.88669),(1,33,1.02669),(2,33,1.02669),(3,33,1.02669),(4,33,1.02669),(5,33,1.02669),(6,33,1.02669),(7,33,1.02669),(8,33,1.02669),(9,33,1.02669),(10,33,1.02669),(11,33,1.02669),(12,33,1.02669),(13,33,1.02669),(14,33,1.02669),(15,33,1.02669),(16,33,1.02669),(17,33,1.02669),(18,33,1.02669),(19,33,1.02669),(20,33,1.02669),(21,33,1.02669),(1,34,1.91338),(2,34,1.91338),(3,34,1.91338),(4,34,1.91338),(5,34,1.91338),(6,34,1.91338),(7,34,1.91338),(8,34,1.91338),(9,34,1.91338),(10,34,1.91338),(11,34,1.91338),(12,34,1.91338),(13,34,1.91338),(14,34,1.91338),(15,34,1.91338),(16,34,1.91338),(17,34,1.91338),(18,34,1.91338),(19,34,1.91338),(20,34,1.91338),(21,34,1.91338),(1,35,2.47338),(2,35,2.47338),(3,35,2.47338),(4,35,2.47338),(5,35,2.47338),(6,35,2.47338),(7,35,2.47338),(8,35,2.47338),(9,35,2.47338),(10,35,2.47338),(11,35,2.47338),(12,35,2.47338),(13,35,2.47338),(14,35,2.47338),(15,35,2.47338),(16,35,2.47338),(17,35,2.47338),(18,35,2.47338),(19,35,2.47338),(20,35,2.47338),(21,35,2.47338),(1,189,0.69993),(2,189,1.16655),(3,189,1.16655),(4,189,1.16655),(5,189,1.16655),(6,189,1.16655),(7,189,1.16655),(8,189,1.16655),(9,189,1.16655),(10,189,1.16655),(11,189,1.16655),(12,189,1.16655),(13,189,1.16655),(14,189,1.16655),(15,189,1.16655),(16,189,1.16655),(17,189,1.16655),(18,189,1.16655),(19,189,1.16655),(20,189,1.16655),(21,189,1.16655),(1,190,1.86662),(2,190,1.86662),(3,190,1.86662),(4,190,1.86662),(5,190,1.86662),(6,190,1.86662),(7,190,1.86662),(8,190,1.86662),(9,190,1.86662),(10,190,1.86662),(11,190,1.86662),(12,190,1.86662),(13,190,1.86662),(14,190,1.86662),(15,190,1.86662),(16,190,1.86662),(17,190,1.86662),(18,190,1.86662),(19,190,1.86662),(20,190,1.86662),(21,190,1.86662),(1,191,2.1),(2,191,2.1),(3,191,2.1),(4,191,2.1),(5,191,2.1),(6,191,2.1),(7,191,2.1),(8,191,2.1),(9,191,2.1),(10,191,2.1),(11,191,2.1),(12,191,2.1),(13,191,2.1),(14,191,2.1),(15,191,2.1),(16,191,2.1),(17,191,2.1),(18,191,2.1),(19,191,2.1),(20,191,2.1),(21,191,2.1),(1,192,0.91),(2,192,0.91),(3,192,0.91),(4,192,0.91),(5,192,0.91),(6,192,0.91),(7,192,0.91),(8,192,0.91),(9,192,0.91),(10,192,0.91),(11,192,0.91),(12,192,0.91),(13,192,0.91),(14,192,0.91),(15,192,0.91),(16,192,0.91),(17,192,0.91),(18,192,0.91),(19,192,0.91),(20,192,0.91),(21,192,0.91),(1,193,1.02669),(2,193,1.02669),(3,193,1.02669),(4,193,1.02669),(5,193,1.02669),(6,193,1.02669),(7,193,1.02669),(8,193,1.02669),(9,193,1.02669),(10,193,1.02669),(11,193,1.02669),(12,193,1.02669),(13,193,1.02669),(14,193,1.02669),(15,193,1.02669),(16,193,1.02669),(17,193,1.02669),(18,193,1.02669),(19,193,1.02669),(20,193,1.02669),(21,193,1.02669),(1,194,0.28),(2,194,0.84),(3,194,0.84),(4,194,0.84),(5,194,0.84),(6,194,0.84),(7,194,0.84),(8,194,0.84),(9,194,0.84),(10,194,0.84),(11,194,0.84),(12,194,0.84),(13,194,0.84),(14,194,0.84),(15,194,0.84),(16,194,0.84),(17,194,0.84),(18,194,0.84),(19,194,0.84),(20,194,0.84),(21,194,0.84),(1,195,0.95669),(2,195,0.95669),(3,195,0.95669),(4,195,0.95669),(5,195,0.95669),(6,195,0.95669),(7,195,0.95669),(8,195,0.95669),(9,195,0.95669),(10,195,0.95669),(11,195,0.95669),(12,195,0.95669),(13,195,0.95669),(14,195,0.95669),(15,195,0.95669),(16,195,0.95669),(17,195,0.95669),(18,195,0.95669),(19,195,0.95669),(20,195,0.95669),(21,195,0.95669),(1,196,1.05),(2,196,1.05),(3,196,1.05),(4,196,1.05),(5,196,1.05),(6,196,1.05),(7,196,1.05),(8,196,1.05),(9,196,1.05),(10,196,1.05),(11,196,1.05),(12,196,1.05),(13,196,1.05),(14,196,1.05),(15,196,1.05),(16,196,1.05),(17,196,1.05),(18,196,1.05),(19,196,1.05),(20,196,1.05),(21,196,1.05),(9,665,0.17),(4,1545,0.98679),(4,1546,2.8),(4,1547,3.0666),(4,1548,2.60661),(4,1549,2.94661),(1,3133,0.42),(2,3133,0.84),(3,3133,0.84),(4,3133,0.84),(5,3133,0.84),(6,3133,0.84),(7,3133,0.84),(8,3133,0.84),(9,3133,0.84),(10,3133,0.84),(11,3133,0.84),(12,3133,0.84),(13,3133,0.84),(14,3133,0.84),(15,3133,0.84),(16,3133,0.84),(17,3133,0.84),(18,3133,0.84),(19,3133,0.84),(20,3133,0.84),(21,3133,0.84),(1,3134,1.05),(2,3134,1.05),(3,3134,1.05),(4,3134,1.05),(5,3134,1.05),(6,3134,1.05),(7,3134,1.05),(8,3134,1.05),(9,3134,1.05),(10,3134,1.05),(11,3134,1.05),(12,3134,1.05),(13,3134,1.05),(14,3134,1.05),(15,3134,1.05),(16,3134,1.05),(17,3134,1.05),(18,3134,1.05),(19,3134,1.05),(20,3134,1.05),(21,3134,1.05),(1,3135,1.28331),(2,3135,1.28331),(3,3135,1.28331),(4,3135,1.28331),(5,3135,1.28331),(6,3135,1.28331),(7,3135,1.28331),(8,3135,1.28331),(9,3135,1.28331),(10,3135,1.28331),(11,3135,1.28331),(12,3135,1.28331),(13,3135,1.28331),(14,3135,1.28331),(15,3135,1.28331),(16,3135,1.28331),(17,3135,1.28331),(18,3135,1.28331),(19,3135,1.28331),(20,3135,1.28331),(21,3135,1.28331),(1,3136,0.84),(2,3136,1.12),(3,3136,1.12),(4,3136,1.12),(5,3136,1.12),(6,3136,1.12),(7,3136,1.12),(8,3136,1.12),(9,3136,1.12),(10,3136,1.12),(11,3136,1.12),(12,3136,1.12),(13,3136,1.12),(14,3136,1.12),(15,3136,1.12),(16,3136,1.12),(17,3136,1.12),(18,3136,1.12),(19,3136,1.12),(20,3136,1.12),(21,3136,1.12),(1,3137,1.00331),(2,3137,1.00331),(3,3137,1.00331),(4,3137,1.00331),(5,3137,1.00331),(6,3137,1.00331),(7,3137,1.00331),(8,3137,1.00331),(9,3137,1.00331),(10,3137,1.00331),(11,3137,1.00331),(12,3137,1.00331),(13,3137,1.00331),(14,3137,1.00331),(15,3137,1.00331),(16,3137,1.00331),(17,3137,1.00331),(18,3137,1.00331),(19,3137,1.00331),(20,3137,1.00331),(21,3137,1.00331),(1,3138,0.98),(2,3138,0.98),(3,3138,0.98),(4,3138,0.98),(5,3138,0.98),(6,3138,0.98),(7,3138,0.98),(8,3138,0.98),(9,3138,0.98),(10,3138,0.98),(11,3138,0.98),(12,3138,0.98),(13,3138,0.98),(14,3138,0.98),(15,3138,0.98),(16,3138,0.98),(17,3138,0.98),(18,3138,0.98),(19,3138,0.98),(20,3138,0.98),(21,3138,0.98),(1,3139,1.09669),(2,3139,1.09669),(3,3139,1.09669),(4,3139,1.09669),(5,3139,1.09669),(6,3139,1.09669),(7,3139,1.09669),(8,3139,1.09669),(9,3139,1.09669),(10,3139,1.09669),(11,3139,1.09669),(12,3139,1.09669),(13,3139,1.09669),(14,3139,1.09669),(15,3139,1.09669),(16,3139,1.09669),(17,3139,1.09669),(18,3139,1.09669),(19,3139,1.09669),(20,3139,1.09669),(21,3139,1.09669),(2,3395,0.65338),(3,3395,0.65338),(4,3395,0.65338),(5,3395,0.65338),(6,3395,0.65338),(7,3395,0.65338),(8,3395,0.65338),(9,3395,0.65338),(10,3395,0.65338),(11,3395,0.65338),(12,3395,0.65338),(13,3395,0.65338),(14,3395,0.65338),(15,3395,0.65338),(16,3395,0.65338),(17,3395,0.65338),(18,3395,0.65338),(19,3395,0.65338),(20,3395,0.65338),(21,3395,0.65338),(2,3396,1.00331),(3,3396,1.00331),(4,3396,1.00331),(5,3396,1.00331),(6,3396,1.00331),(7,3396,1.00331),(8,3396,1.00331),(9,3396,1.00331),(10,3396,1.00331),(11,3396,1.00331),(12,3396,1.00331),(13,3396,1.00331),(14,3396,1.00331),(15,3396,1.00331),(16,3396,1.00331),(17,3396,1.00331),(18,3396,1.00331),(19,3396,1.00331),(20,3396,1.00331),(21,3396,1.00331),(2,3397,1.07331),(3,3397,1.07331),(4,3397,1.07331),(5,3397,1.07331),(6,3397,1.07331),(7,3397,1.07331),(8,3397,1.07331),(9,3397,1.07331),(10,3397,1.07331),(11,3397,1.07331),(12,3397,1.07331),(13,3397,1.07331),(14,3397,1.07331),(15,3397,1.07331),(16,3397,1.07331),(17,3397,1.07331),(18,3397,1.07331),(19,3397,1.07331),(20,3397,1.07331),(21,3397,1.07331),(2,3398,0.98),(3,3398,0.98),(4,3398,0.98),(5,3398,0.98),(6,3398,0.98),(7,3398,0.98),(8,3398,0.98),(9,3398,0.98),(10,3398,0.98),(11,3398,0.98),(12,3398,0.98),(13,3398,0.98),(14,3398,0.98),(15,3398,0.98),(16,3398,0.98),(17,3398,0.98),(18,3398,0.98),(19,3398,0.98),(20,3398,0.98),(21,3398,0.98),(2,3399,1.07331),(3,3399,1.07331),(4,3399,1.07331),(5,3399,1.07331),(6,3399,1.07331),(7,3399,1.07331),(8,3399,1.07331),(9,3399,1.07331),(10,3399,1.07331),(11,3399,1.07331),(12,3399,1.07331),(13,3399,1.07331),(14,3399,1.07331),(15,3399,1.07331),(16,3399,1.07331),(17,3399,1.07331),(18,3399,1.07331),(19,3399,1.07331),(20,3399,1.07331),(21,3399,1.07331),(2,3400,0.51331),(3,3400,0.51331),(4,3400,0.51331),(5,3400,0.51331),(6,3400,0.51331),(7,3400,0.51331),(8,3400,0.51331),(9,3400,0.51331),(10,3400,0.51331),(11,3400,0.51331),(12,3400,0.51331),(13,3400,0.51331),(14,3400,0.51331),(15,3400,0.51331),(16,3400,0.51331),(17,3400,0.51331),(18,3400,0.51331),(19,3400,0.51331),(20,3400,0.51331),(21,3400,0.51331),(2,3401,1.16669),(3,3401,1.16669),(4,3401,1.16669),(5,3401,1.16669),(6,3401,1.16669),(7,3401,1.16669),(8,3401,1.16669),(9,3401,1.16669),(10,3401,1.16669),(11,3401,1.16669),(12,3401,1.16669),(13,3401,1.16669),(14,3401,1.16669),(15,3401,1.16669),(16,3401,1.16669),(17,3401,1.16669),(18,3401,1.16669),(19,3401,1.16669),(20,3401,1.16669),(21,3401,1.16669),(2,3402,1.26),(3,3402,1.26),(4,3402,1.26),(5,3402,1.26),(6,3402,1.26),(7,3402,1.26),(8,3402,1.26),(9,3402,1.26),(10,3402,1.26),(11,3402,1.26),(12,3402,1.26),(13,3402,1.26),(14,3402,1.26),(15,3402,1.26),(16,3402,1.26),(17,3402,1.26),(18,3402,1.26),(19,3402,1.26),(20,3402,1.26),(21,3402,1.26),(2,3403,1.12),(3,3403,1.12),(4,3403,1.12),(5,3403,1.12),(6,3403,1.12),(7,3403,1.12),(8,3403,1.12),(9,3403,1.12),(10,3403,1.12),(11,3403,1.12),(12,3403,1.12),(13,3403,1.12),(14,3403,1.12),(15,3403,1.12),(16,3403,1.12),(17,3403,1.12),(18,3403,1.12),(19,3403,1.12),(20,3403,1.12),(21,3403,1.12),(2,3404,1.30669),(3,3404,1.30669),(4,3404,1.30669),(5,3404,1.30669),(6,3404,1.30669),(7,3404,1.30669),(8,3404,1.30669),(9,3404,1.30669),(10,3404,1.30669),(11,3404,1.30669),(12,3404,1.30669),(13,3404,1.30669),(14,3404,1.30669),(15,3404,1.30669),(16,3404,1.30669),(17,3404,1.30669),(18,3404,1.30669),(19,3404,1.30669),(20,3404,1.30669),(21,3404,1.30669),(2,3405,1.07331),(3,3405,1.07331),(4,3405,1.07331),(5,3405,1.07331),(6,3405,1.07331),(7,3405,1.07331),(8,3405,1.07331),(9,3405,1.07331),(10,3405,1.07331),(11,3405,1.07331),(12,3405,1.07331),(13,3405,1.07331),(14,3405,1.07331),(15,3405,1.07331),(16,3405,1.07331),(17,3405,1.07331),(18,3405,1.07331),(19,3405,1.07331),(20,3405,1.07331),(21,3405,1.07331),(2,3406,1.28331),(3,3406,1.28331),(4,3406,1.28331),(5,3406,1.28331),(6,3406,1.28331),(7,3406,1.28331),(8,3406,1.28331),(9,3406,1.28331),(10,3406,1.28331),(11,3406,1.28331),(12,3406,1.28331),(13,3406,1.28331),(14,3406,1.28331),(15,3406,1.28331),(16,3406,1.28331),(17,3406,1.28331),(18,3406,1.28331),(19,3406,1.28331),(20,3406,1.28331),(21,3406,1.28331),(2,3407,1.23669),(3,3407,1.23669),(4,3407,1.23669),(5,3407,1.23669),(6,3407,1.23669),(7,3407,1.23669),(8,3407,1.23669),(9,3407,1.23669),(10,3407,1.23669),(11,3407,1.23669),(12,3407,1.23669),(13,3407,1.23669),(14,3407,1.23669),(15,3407,1.23669),(16,3407,1.23669),(17,3407,1.23669),(18,3407,1.23669),(19,3407,1.23669),(20,3407,1.23669),(21,3407,1.23669),(2,3535,0.65338),(3,3535,0.65338),(4,3535,0.65338),(5,3535,0.65338),(6,3535,0.65338),(7,3535,0.65338),(8,3535,0.65338),(9,3535,0.65338),(10,3535,0.65338),(11,3535,0.65338),(12,3535,0.65338),(13,3535,0.65338),(14,3535,0.65338),(15,3535,0.65338),(16,3535,0.65338),(17,3535,0.65338),(18,3535,0.65338),(19,3535,0.65338),(20,3535,0.65338),(21,3535,0.65338),(2,3536,0.91),(3,3536,0.91),(4,3536,0.91),(5,3536,0.91),(6,3536,0.91),(7,3536,0.91),(8,3536,0.91),(9,3536,0.91),(10,3536,0.91),(11,3536,0.91),(12,3536,0.91),(13,3536,0.91),(14,3536,0.91),(15,3536,0.91),(16,3536,0.91),(17,3536,0.91),(18,3536,0.91),(19,3536,0.91),(20,3536,0.91),(21,3536,0.91),(2,3537,1.00331),(3,3537,1.00331),(4,3537,1.00331),(5,3537,1.00331),(6,3537,1.00331),(7,3537,1.00331),(8,3537,1.00331),(9,3537,1.00331),(10,3537,1.00331),(11,3537,1.00331),(12,3537,1.00331),(13,3537,1.00331),(14,3537,1.00331),(15,3537,1.00331),(16,3537,1.00331),(17,3537,1.00331),(18,3537,1.00331),(19,3537,1.00331),(20,3537,1.00331),(21,3537,1.00331),(2,3538,1.05),(3,3538,1.05),(4,3538,1.05),(5,3538,1.05),(6,3538,1.05),(7,3538,1.05),(8,3538,1.05),(9,3538,1.05),(10,3538,1.05),(11,3538,1.05),(12,3538,1.05),(13,3538,1.05),(14,3538,1.05),(15,3538,1.05),(16,3538,1.05),(17,3538,1.05),(18,3538,1.05),(19,3538,1.05),(20,3538,1.05),(21,3538,1.05),(2,3539,1.33),(3,3539,1.33),(4,3539,1.33),(5,3539,1.33),(6,3539,1.33),(7,3539,1.33),(8,3539,1.33),(9,3539,1.33),(10,3539,1.33),(11,3539,1.33),(12,3539,1.33),(13,3539,1.33),(14,3539,1.33),(15,3539,1.33),(16,3539,1.33),(17,3539,1.33),(18,3539,1.33),(19,3539,1.33),(20,3539,1.33),(21,3539,1.33),(2,3540,1.02669),(3,3540,1.02669),(4,3540,1.02669),(5,3540,1.02669),(6,3540,1.02669),(7,3540,1.02669),(8,3540,1.02669),(9,3540,1.02669),(10,3540,1.02669),(11,3540,1.02669),(12,3540,1.02669),(13,3540,1.02669),(14,3540,1.02669),(15,3540,1.02669),(16,3540,1.02669),(17,3540,1.02669),(18,3540,1.02669),(19,3540,1.02669),(20,3540,1.02669),(21,3540,1.02669),(2,3541,1.28331),(3,3541,1.28331),(4,3541,1.28331),(5,3541,1.28331),(6,3541,1.28331),(7,3541,1.28331),(8,3541,1.28331),(9,3541,1.28331),(10,3541,1.28331),(11,3541,1.28331),(12,3541,1.28331),(13,3541,1.28331),(14,3541,1.28331),(15,3541,1.28331),(16,3541,1.28331),(17,3541,1.28331),(18,3541,1.28331),(19,3541,1.28331),(20,3541,1.28331),(21,3541,1.28331),(2,3542,1.00331),(3,3542,1.00331),(4,3542,1.00331),(5,3542,1.00331),(6,3542,1.00331),(7,3542,1.00331),(8,3542,1.00331),(9,3542,1.00331),(10,3542,1.00331),(11,3542,1.00331),(12,3542,1.00331),(13,3542,1.00331),(14,3542,1.00331),(15,3542,1.00331),(16,3542,1.00331),(17,3542,1.00331),(18,3542,1.00331),(19,3542,1.00331),(20,3542,1.00331),(21,3542,1.00331),(2,3543,1.09669),(3,3543,1.09669),(4,3543,1.09669),(5,3543,1.09669),(6,3543,1.09669),(7,3543,1.09669),(8,3543,1.09669),(9,3543,1.09669),(10,3543,1.09669),(11,3543,1.09669),(12,3543,1.09669),(13,3543,1.09669),(14,3543,1.09669),(15,3543,1.09669),(16,3543,1.09669),(17,3543,1.09669),(18,3543,1.09669),(19,3543,1.09669),(20,3543,1.09669),(21,3543,1.09669),(2,3544,0.91),(3,3544,0.91),(4,3544,0.91),(5,3544,0.91),(6,3544,0.91),(7,3544,0.91),(8,3544,0.91),(9,3544,0.91),(10,3544,0.91),(11,3544,0.91),(12,3544,0.91),(13,3544,0.91),(14,3544,0.91),(15,3544,0.91),(16,3544,0.91),(17,3544,0.91),(18,3544,0.91),(19,3544,0.91),(20,3544,0.91),(21,3544,0.91),(2,3545,1.12),(3,3545,1.12),(4,3545,1.12),(5,3545,1.12),(6,3545,1.12),(7,3545,1.12),(8,3545,1.12),(9,3545,1.12),(10,3545,1.12),(11,3545,1.12),(12,3545,1.12),(13,3545,1.12),(14,3545,1.12),(15,3545,1.12),(16,3545,1.12),(17,3545,1.12),(18,3545,1.12),(19,3545,1.12),(20,3545,1.12),(21,3545,1.12),(2,3546,0.98),(3,3546,0.98),(4,3546,0.98),(5,3546,0.98),(6,3546,0.98),(7,3546,0.98),(8,3546,0.98),(9,3546,0.98),(10,3546,0.98),(11,3546,0.98),(12,3546,0.98),(13,3546,0.98),(14,3546,0.98),(15,3546,0.98),(16,3546,0.98),(17,3546,0.98),(18,3546,0.98),(19,3546,0.98),(20,3546,0.98),(21,3546,0.98),(2,3547,1.09669),(3,3547,1.09669),(4,3547,1.09669),(5,3547,1.09669),(6,3547,1.09669),(7,3547,1.09669),(8,3547,1.09669),(9,3547,1.09669),(10,3547,1.09669),(11,3547,1.09669),(12,3547,1.09669),(13,3547,1.09669),(14,3547,1.09669),(15,3547,1.09669),(16,3547,1.09669),(17,3547,1.09669),(18,3547,1.09669),(19,3547,1.09669),(20,3547,1.09669),(21,3547,1.09669),(3,3623,2.46679),(3,3624,5.42679),(3,3625,6.16679),(5,3657,2.46642),(5,3658,5.67321),(5,3659,6.90679),(5,3660,4.68679),(5,3661,5.30321),(13,4001,0.74),(13,4002,5.05679),(13,4003,5.67321),(17,4160,0.74),(17,4161,4.93321),(17,4162,5.18),(18,4193,1.48),(18,4194,5.18),(18,4195,6.16679),(18,4196,2.71321),(18,4197,5.42679),(18,4198,6.41321),(19,4232,1.72679),(19,4233,0.5334),(19,4234,2.8),(21,4329,1.48),(21,4330,5.42679),(1,4333,1.14331),(1,4334,0.98),(1,4335,1.12);


--
-- Table structure for table `#__finder_links_terms5`
--



CREATE TABLE `#__finder_links_terms5` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms5`
--




--
-- Table structure for table `#__finder_links_terms6`
--



CREATE TABLE `#__finder_links_terms6` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms6`
--


INSERT INTO `#__finder_links_terms6` (`link_id`, `term_id`, `weight`) VALUES (1,117,0.23331),(2,117,0.69993),(3,117,0.69993),(4,117,0.69993),(5,117,0.69993),(6,117,0.69993),(7,117,0.69993),(8,117,0.69993),(9,117,0.69993),(10,117,0.69993),(11,117,0.69993),(12,117,0.69993),(13,117,0.69993),(14,117,0.69993),(15,117,0.69993),(16,117,0.69993),(17,117,0.69993),(18,117,0.69993),(19,117,0.69993),(20,117,0.69993),(21,117,0.69993),(1,118,0.98),(2,118,0.98),(3,118,0.98),(4,118,0.98),(5,118,0.98),(6,118,0.98),(7,118,0.98),(8,118,0.98),(9,118,0.98),(10,118,0.98),(11,118,0.98),(12,118,0.98),(13,118,0.98),(14,118,0.98),(15,118,0.98),(16,118,0.98),(17,118,0.98),(18,118,0.98),(19,118,0.98),(20,118,0.98),(21,118,0.98),(1,119,1.16669),(2,119,1.16669),(3,119,1.16669),(4,119,1.16669),(5,119,1.16669),(6,119,1.16669),(7,119,1.16669),(8,119,1.16669),(9,119,1.16669),(10,119,1.16669),(11,119,1.16669),(12,119,1.16669),(13,119,1.16669),(14,119,1.16669),(15,119,1.16669),(16,119,1.16669),(17,119,1.16669),(18,119,1.16669),(19,119,1.16669),(20,119,1.16669),(21,119,1.16669),(2,120,0.42),(3,120,0.42),(4,120,0.42),(5,120,0.42),(6,120,0.42),(7,120,0.42),(8,120,0.42),(9,120,0.42),(10,120,0.42),(11,120,0.42),(12,120,0.42),(13,120,0.42),(14,120,0.42),(15,120,0.42),(16,120,0.42),(17,120,0.42),(18,120,0.42),(19,120,0.42),(20,120,0.42),(21,120,0.42),(1,120,0.42),(1,121,1.05),(2,121,1.05),(3,121,1.05),(4,121,1.05),(5,121,1.05),(6,121,1.05),(7,121,1.05),(8,121,1.05),(9,121,1.05),(10,121,1.05),(11,121,1.05),(12,121,1.05),(13,121,1.05),(14,121,1.05),(15,121,1.05),(16,121,1.05),(17,121,1.05),(18,121,1.05),(19,121,1.05),(20,121,1.05),(21,121,1.05),(1,122,1.21331),(2,122,1.21331),(3,122,1.21331),(4,122,1.21331),(5,122,1.21331),(6,122,1.21331),(7,122,1.21331),(8,122,1.21331),(9,122,1.21331),(10,122,1.21331),(11,122,1.21331),(12,122,1.21331),(13,122,1.21331),(14,122,1.21331),(15,122,1.21331),(16,122,1.21331),(17,122,1.21331),(18,122,1.21331),(19,122,1.21331),(20,122,1.21331),(21,122,1.21331),(1,123,0.56),(2,123,0.56),(3,123,0.56),(4,123,0.56),(5,123,0.56),(6,123,0.56),(7,123,0.56),(8,123,0.56),(9,123,0.56),(10,123,0.56),(11,123,0.56),(12,123,0.56),(13,123,0.56),(14,123,0.56),(15,123,0.56),(16,123,0.56),(17,123,0.56),(18,123,0.56),(19,123,0.56),(20,123,0.56),(21,123,0.56),(1,124,2.24),(2,124,2.24),(3,124,2.24),(4,124,2.24),(5,124,2.24),(6,124,2.24),(7,124,2.24),(8,124,2.24),(9,124,2.24),(10,124,2.24),(11,124,2.24),(12,124,2.24),(13,124,2.24),(14,124,2.24),(15,124,2.24),(16,124,2.24),(17,124,2.24),(18,124,2.24),(19,124,2.24),(20,124,2.24),(21,124,2.24),(1,125,2.52),(2,125,2.52),(3,125,2.52),(4,125,2.52),(5,125,2.52),(6,125,2.52),(7,125,2.52),(8,125,2.52),(9,125,2.52),(10,125,2.52),(11,125,2.52),(12,125,2.52),(13,125,2.52),(14,125,2.52),(15,125,2.52),(16,125,2.52),(17,125,2.52),(18,125,2.52),(19,125,2.52),(20,125,2.52),(21,125,2.52),(1,126,0.69993),(2,126,0.69993),(3,126,0.69993),(4,126,0.69993),(5,126,0.69993),(6,126,0.69993),(7,126,0.69993),(8,126,0.69993),(9,126,0.69993),(10,126,0.69993),(11,126,0.69993),(12,126,0.69993),(13,126,0.69993),(14,126,0.69993),(15,126,0.69993),(16,126,0.69993),(17,126,0.69993),(18,126,0.69993),(19,126,0.69993),(20,126,0.69993),(21,126,0.69993),(1,127,1.96),(2,127,1.96),(3,127,1.96),(4,127,1.96),(5,127,1.96),(6,127,1.96),(7,127,1.96),(8,127,1.96),(9,127,1.96),(10,127,1.96),(11,127,1.96),(12,127,1.96),(13,127,1.96),(14,127,1.96),(15,127,1.96),(16,127,1.96),(17,127,1.96),(18,127,1.96),(19,127,1.96),(20,127,1.96),(21,127,1.96),(1,128,2.42662),(2,128,2.42662),(3,128,2.42662),(4,128,2.42662),(5,128,2.42662),(6,128,2.42662),(7,128,2.42662),(8,128,2.42662),(9,128,2.42662),(10,128,2.42662),(11,128,2.42662),(12,128,2.42662),(13,128,2.42662),(14,128,2.42662),(15,128,2.42662),(16,128,2.42662),(17,128,2.42662),(18,128,2.42662),(19,128,2.42662),(20,128,2.42662),(21,128,2.42662),(1,129,0.84),(2,129,1.12),(3,129,1.12),(4,129,1.12),(5,129,1.12),(6,129,1.12),(7,129,1.12),(8,129,1.12),(9,129,1.12),(10,129,1.12),(11,129,1.12),(12,129,1.12),(13,129,1.12),(14,129,1.12),(15,129,1.12),(16,129,1.12),(17,129,1.12),(18,129,1.12),(19,129,1.12),(20,129,1.12),(21,129,1.12),(1,130,1.02669),(2,130,1.02669),(3,130,1.02669),(4,130,1.02669),(5,130,1.02669),(6,130,1.02669),(7,130,1.02669),(8,130,1.02669),(9,130,1.02669),(10,130,1.02669),(11,130,1.02669),(12,130,1.02669),(13,130,1.02669),(14,130,1.02669),(15,130,1.02669),(16,130,1.02669),(17,130,1.02669),(18,130,1.02669),(19,130,1.02669),(20,130,1.02669),(21,130,1.02669),(1,131,1.19),(2,131,1.19),(3,131,1.19),(4,131,1.19),(5,131,1.19),(6,131,1.19),(7,131,1.19),(8,131,1.19),(9,131,1.19),(10,131,1.19),(11,131,1.19),(12,131,1.19),(13,131,1.19),(14,131,1.19),(15,131,1.19),(16,131,1.19),(17,131,1.19),(18,131,1.19),(19,131,1.19),(20,131,1.19),(21,131,1.19),(1,132,2.00662),(2,132,2.00662),(3,132,2.00662),(4,132,2.00662),(5,132,2.00662),(6,132,2.00662),(7,132,2.00662),(8,132,2.00662),(9,132,2.00662),(10,132,2.00662),(11,132,2.00662),(12,132,2.00662),(13,132,2.00662),(14,132,2.00662),(15,132,2.00662),(16,132,2.00662),(17,132,2.00662),(18,132,2.00662),(19,132,2.00662),(20,132,2.00662),(21,132,2.00662),(1,133,2.19338),(2,133,2.19338),(3,133,2.19338),(4,133,2.19338),(5,133,2.19338),(6,133,2.19338),(7,133,2.19338),(8,133,2.19338),(9,133,2.19338),(10,133,2.19338),(11,133,2.19338),(12,133,2.19338),(13,133,2.19338),(14,133,2.19338),(15,133,2.19338),(16,133,2.19338),(17,133,2.19338),(18,133,2.19338),(19,133,2.19338),(20,133,2.19338),(21,133,2.19338),(2,719,0.74662),(3,719,0.74662),(4,719,0.74662),(5,719,0.74662),(6,719,0.74662),(7,719,0.74662),(8,719,0.74662),(9,719,0.74662),(10,719,0.74662),(11,719,0.74662),(12,719,0.74662),(13,719,0.74662),(14,719,0.74662),(15,719,0.74662),(16,719,0.74662),(17,719,0.74662),(18,719,0.74662),(19,719,0.74662),(20,719,0.74662),(21,719,0.74662),(15,1123,0.98679),(1,3181,1.72679),(8,3181,3.45358),(1,3182,5.05679),(8,3182,5.05679),(1,3183,5.92),(1,3184,0.91),(2,3184,0.91),(3,3184,0.91),(4,3184,0.91),(5,3184,0.91),(6,3184,0.91),(7,3184,0.91),(8,3184,0.91),(9,3184,0.91),(10,3184,0.91),(11,3184,0.91),(12,3184,0.91),(13,3184,0.91),(14,3184,0.91),(15,3184,0.91),(16,3184,0.91),(17,3184,0.91),(18,3184,0.91),(19,3184,0.91),(20,3184,0.91),(21,3184,0.91),(1,3185,1.14331),(2,3185,1.14331),(3,3185,1.14331),(4,3185,1.14331),(5,3185,1.14331),(6,3185,1.14331),(7,3185,1.14331),(8,3185,1.14331),(9,3185,1.14331),(10,3185,1.14331),(11,3185,1.14331),(12,3185,1.14331),(13,3185,1.14331),(14,3185,1.14331),(15,3185,1.14331),(16,3185,1.14331),(17,3185,1.14331),(18,3185,1.14331),(19,3185,1.14331),(20,3185,1.14331),(21,3185,1.14331),(1,3186,1.48),(1,3187,4.93321),(1,3188,5.42679),(2,3485,1.12),(3,3485,1.12),(4,3485,1.12),(5,3485,1.12),(6,3485,1.12),(7,3485,1.12),(8,3485,1.12),(9,3485,1.12),(10,3485,1.12),(11,3485,1.12),(12,3485,1.12),(13,3485,1.12),(14,3485,1.12),(15,3485,1.12),(16,3485,1.12),(17,3485,1.12),(18,3485,1.12),(19,3485,1.12),(20,3485,1.12),(21,3485,1.12),(2,3486,1.26),(3,3486,1.26),(4,3486,1.26),(5,3486,1.26),(6,3486,1.26),(7,3486,1.26),(8,3486,1.26),(9,3486,1.26),(10,3486,1.26),(11,3486,1.26),(12,3486,1.26),(13,3486,1.26),(14,3486,1.26),(15,3486,1.26),(16,3486,1.26),(17,3486,1.26),(18,3486,1.26),(19,3486,1.26),(20,3486,1.26),(21,3486,1.26),(2,3487,0.95669),(3,3487,0.95669),(4,3487,0.95669),(5,3487,0.95669),(6,3487,0.95669),(7,3487,0.95669),(8,3487,0.95669),(9,3487,0.95669),(10,3487,0.95669),(11,3487,0.95669),(12,3487,0.95669),(13,3487,0.95669),(14,3487,0.95669),(15,3487,0.95669),(16,3487,0.95669),(17,3487,0.95669),(18,3487,0.95669),(19,3487,0.95669),(20,3487,0.95669),(21,3487,0.95669),(2,3488,1.09669),(3,3488,1.09669),(4,3488,1.09669),(5,3488,1.09669),(6,3488,1.09669),(7,3488,1.09669),(8,3488,1.09669),(9,3488,1.09669),(10,3488,1.09669),(11,3488,1.09669),(12,3488,1.09669),(13,3488,1.09669),(14,3488,1.09669),(15,3488,1.09669),(16,3488,1.09669),(17,3488,1.09669),(18,3488,1.09669),(19,3488,1.09669),(20,3488,1.09669),(21,3488,1.09669),(2,3489,0.88669),(3,3489,0.88669),(4,3489,0.88669),(5,3489,0.88669),(6,3489,0.88669),(7,3489,0.88669),(8,3489,0.88669),(9,3489,0.88669),(10,3489,0.88669),(11,3489,0.88669),(12,3489,0.88669),(13,3489,0.88669),(14,3489,0.88669),(15,3489,0.88669),(16,3489,0.88669),(17,3489,0.88669),(18,3489,0.88669),(19,3489,0.88669),(20,3489,0.88669),(21,3489,0.88669),(2,3490,1.05),(3,3490,1.05),(4,3490,1.05),(5,3490,1.05),(6,3490,1.05),(7,3490,1.05),(8,3490,1.05),(9,3490,1.05),(10,3490,1.05),(11,3490,1.05),(12,3490,1.05),(13,3490,1.05),(14,3490,1.05),(15,3490,1.05),(16,3490,1.05),(17,3490,1.05),(18,3490,1.05),(19,3490,1.05),(20,3490,1.05),(21,3490,1.05),(2,3491,0.91),(3,3491,0.91),(4,3491,0.91),(5,3491,0.91),(6,3491,0.91),(7,3491,0.91),(8,3491,0.91),(9,3491,0.91),(10,3491,0.91),(11,3491,0.91),(12,3491,0.91),(13,3491,0.91),(14,3491,0.91),(15,3491,0.91),(16,3491,0.91),(17,3491,0.91),(18,3491,0.91),(19,3491,0.91),(20,3491,0.91),(21,3491,0.91),(2,3492,1.02669),(3,3492,1.02669),(4,3492,1.02669),(5,3492,1.02669),(6,3492,1.02669),(7,3492,1.02669),(8,3492,1.02669),(9,3492,1.02669),(10,3492,1.02669),(11,3492,1.02669),(12,3492,1.02669),(13,3492,1.02669),(14,3492,1.02669),(15,3492,1.02669),(16,3492,1.02669),(17,3492,1.02669),(18,3492,1.02669),(19,3492,1.02669),(20,3492,1.02669),(21,3492,1.02669),(2,3493,0.74662),(3,3493,0.74662),(4,3493,0.74662),(5,3493,0.74662),(6,3493,0.74662),(7,3493,0.74662),(8,3493,0.74662),(9,3493,0.74662),(10,3493,0.74662),(11,3493,0.74662),(12,3493,0.74662),(13,3493,0.74662),(14,3493,0.74662),(15,3493,0.74662),(16,3493,0.74662),(17,3493,0.74662),(18,3493,0.74662),(19,3493,0.74662),(20,3493,0.74662),(21,3493,0.74662),(2,3494,0.95669),(3,3494,0.95669),(4,3494,0.95669),(5,3494,0.95669),(6,3494,0.95669),(7,3494,0.95669),(8,3494,0.95669),(9,3494,0.95669),(10,3494,0.95669),(11,3494,0.95669),(12,3494,0.95669),(13,3494,0.95669),(14,3494,0.95669),(15,3494,0.95669),(16,3494,0.95669),(17,3494,0.95669),(18,3494,0.95669),(19,3494,0.95669),(20,3494,0.95669),(21,3494,0.95669),(2,3495,1.07331),(3,3495,1.07331),(4,3495,1.07331),(5,3495,1.07331),(6,3495,1.07331),(7,3495,1.07331),(8,3495,1.07331),(9,3495,1.07331),(10,3495,1.07331),(11,3495,1.07331),(12,3495,1.07331),(13,3495,1.07331),(14,3495,1.07331),(15,3495,1.07331),(16,3495,1.07331),(17,3495,1.07331),(18,3495,1.07331),(19,3495,1.07331),(20,3495,1.07331),(21,3495,1.07331),(2,3496,1.14331),(3,3496,1.14331),(4,3496,1.14331),(5,3496,1.14331),(6,3496,1.14331),(7,3496,1.14331),(8,3496,1.14331),(9,3496,1.14331),(10,3496,1.14331),(11,3496,1.14331),(12,3496,1.14331),(13,3496,1.14331),(14,3496,1.14331),(15,3496,1.14331),(16,3496,1.14331),(17,3496,1.14331),(18,3496,1.14331),(19,3496,1.14331),(20,3496,1.14331),(21,3496,1.14331),(2,3497,1.30669),(3,3497,1.30669),(4,3497,1.30669),(5,3497,1.30669),(6,3497,1.30669),(7,3497,1.30669),(8,3497,1.30669),(9,3497,1.30669),(10,3497,1.30669),(11,3497,1.30669),(12,3497,1.30669),(13,3497,1.30669),(14,3497,1.30669),(15,3497,1.30669),(16,3497,1.30669),(17,3497,1.30669),(18,3497,1.30669),(19,3497,1.30669),(20,3497,1.30669),(21,3497,1.30669),(2,3498,1.05),(3,3498,1.05),(4,3498,1.05),(5,3498,1.05),(6,3498,1.05),(7,3498,1.05),(8,3498,1.05),(9,3498,1.05),(10,3498,1.05),(11,3498,1.05),(12,3498,1.05),(13,3498,1.05),(14,3498,1.05),(15,3498,1.05),(16,3498,1.05),(17,3498,1.05),(18,3498,1.05),(19,3498,1.05),(20,3498,1.05),(21,3498,1.05),(2,3499,1.12),(3,3499,1.12),(4,3499,1.12),(5,3499,1.12),(6,3499,1.12),(7,3499,1.12),(8,3499,1.12),(9,3499,1.12),(10,3499,1.12),(11,3499,1.12),(12,3499,1.12),(13,3499,1.12),(14,3499,1.12),(15,3499,1.12),(16,3499,1.12),(17,3499,1.12),(18,3499,1.12),(19,3499,1.12),(20,3499,1.12),(21,3499,1.12),(5,3654,0.98679),(5,3655,4.56321),(5,3656,5.30321),(8,3781,5.42679),(8,3782,5.05679),(8,3783,5.55),(15,4094,4.81),(15,4095,5.42679);


--
-- Table structure for table `#__finder_links_terms7`
--



CREATE TABLE `#__finder_links_terms7` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms7`
--


INSERT INTO `#__finder_links_terms7` (`link_id`, `term_id`, `weight`) VALUES (1,134,0.14),(2,134,0.28),(3,134,0.28),(4,134,0.28),(5,134,0.28),(6,134,0.28),(7,134,0.28),(8,134,0.28),(9,134,0.28),(10,134,0.28),(11,134,0.28),(12,134,0.28),(13,134,0.28),(14,134,0.28),(15,134,0.28),(16,134,0.28),(17,134,0.28),(18,134,0.28),(19,134,0.28),(20,134,0.28),(21,134,0.28),(1,135,0.88669),(2,135,0.88669),(3,135,0.88669),(4,135,0.88669),(5,135,0.88669),(6,135,0.88669),(7,135,0.88669),(8,135,0.88669),(9,135,0.88669),(10,135,0.88669),(11,135,0.88669),(12,135,0.88669),(13,135,0.88669),(14,135,0.88669),(15,135,0.88669),(16,135,0.88669),(17,135,0.88669),(18,135,0.88669),(19,135,0.88669),(20,135,0.88669),(21,135,0.88669),(1,136,1.12),(2,136,1.12),(3,136,1.12),(4,136,1.12),(5,136,1.12),(6,136,1.12),(7,136,1.12),(8,136,1.12),(9,136,1.12),(10,136,1.12),(11,136,1.12),(12,136,1.12),(13,136,1.12),(14,136,1.12),(15,136,1.12),(16,136,1.12),(17,136,1.12),(18,136,1.12),(19,136,1.12),(20,136,1.12),(21,136,1.12),(1,137,0.56),(2,137,1.26),(3,137,1.26),(4,137,1.26),(5,137,1.26),(6,137,1.26),(7,137,1.26),(8,137,1.26),(9,137,1.26),(10,137,1.26),(11,137,1.26),(12,137,1.26),(13,137,1.26),(14,137,1.26),(15,137,1.26),(16,137,1.26),(17,137,1.26),(18,137,1.26),(19,137,1.26),(20,137,1.26),(21,137,1.26),(1,138,1.82),(2,138,1.82),(3,138,1.82),(4,138,1.82),(5,138,1.82),(6,138,1.82),(7,138,1.82),(8,138,1.82),(9,138,1.82),(10,138,1.82),(11,138,1.82),(12,138,1.82),(13,138,1.82),(14,138,1.82),(15,138,1.82),(16,138,1.82),(17,138,1.82),(18,138,1.82),(19,138,1.82),(20,138,1.82),(21,138,1.82),(1,139,2.14662),(2,139,2.14662),(3,139,2.14662),(4,139,2.14662),(5,139,2.14662),(6,139,2.14662),(7,139,2.14662),(8,139,2.14662),(9,139,2.14662),(10,139,2.14662),(11,139,2.14662),(12,139,2.14662),(13,139,2.14662),(14,139,2.14662),(15,139,2.14662),(16,139,2.14662),(17,139,2.14662),(18,139,2.14662),(19,139,2.14662),(20,139,2.14662),(21,139,2.14662),(1,140,1.00331),(2,140,1.00331),(3,140,1.00331),(4,140,1.00331),(5,140,1.00331),(6,140,1.00331),(7,140,1.00331),(8,140,1.00331),(9,140,1.00331),(10,140,1.00331),(11,140,1.00331),(12,140,1.00331),(13,140,1.00331),(14,140,1.00331),(15,140,1.00331),(16,140,1.00331),(17,140,1.00331),(18,140,1.00331),(19,140,1.00331),(20,140,1.00331),(21,140,1.00331),(1,141,1.12),(2,141,1.12),(3,141,1.12),(4,141,1.12),(5,141,1.12),(6,141,1.12),(7,141,1.12),(8,141,1.12),(9,141,1.12),(10,141,1.12),(11,141,1.12),(12,141,1.12),(13,141,1.12),(14,141,1.12),(15,141,1.12),(16,141,1.12),(17,141,1.12),(18,141,1.12),(19,141,1.12),(20,141,1.12),(21,141,1.12),(1,142,0.69993),(2,142,0.93324),(3,142,0.93324),(4,142,0.93324),(5,142,0.93324),(6,142,0.93324),(7,142,0.93324),(8,142,0.93324),(9,142,0.93324),(10,142,0.93324),(11,142,0.93324),(12,142,0.93324),(13,142,0.93324),(14,142,0.93324),(15,142,0.93324),(16,142,0.93324),(17,142,0.93324),(18,142,0.93324),(19,142,0.93324),(20,142,0.93324),(21,142,0.93324),(1,143,1.02669),(2,143,1.02669),(3,143,1.02669),(4,143,1.02669),(5,143,1.02669),(6,143,1.02669),(7,143,1.02669),(8,143,1.02669),(9,143,1.02669),(10,143,1.02669),(11,143,1.02669),(12,143,1.02669),(13,143,1.02669),(14,143,1.02669),(15,143,1.02669),(16,143,1.02669),(17,143,1.02669),(18,143,1.02669),(19,143,1.02669),(20,143,1.02669),(21,143,1.02669),(1,144,1.14331),(2,144,1.14331),(3,144,1.14331),(4,144,1.14331),(5,144,1.14331),(6,144,1.14331),(7,144,1.14331),(8,144,1.14331),(9,144,1.14331),(10,144,1.14331),(11,144,1.14331),(12,144,1.14331),(13,144,1.14331),(14,144,1.14331),(15,144,1.14331),(16,144,1.14331),(17,144,1.14331),(18,144,1.14331),(19,144,1.14331),(20,144,1.14331),(21,144,1.14331),(1,145,1.82),(2,145,1.82),(3,145,1.82),(4,145,1.82),(5,145,1.82),(6,145,1.82),(7,145,1.82),(8,145,1.82),(9,145,1.82),(10,145,1.82),(11,145,1.82),(12,145,1.82),(13,145,1.82),(14,145,1.82),(15,145,1.82),(16,145,1.82),(17,145,1.82),(18,145,1.82),(19,145,1.82),(20,145,1.82),(21,145,1.82),(1,146,2.1),(2,146,2.1),(3,146,2.1),(4,146,2.1),(5,146,2.1),(6,146,2.1),(7,146,2.1),(8,146,2.1),(9,146,2.1),(10,146,2.1),(11,146,2.1),(12,146,2.1),(13,146,2.1),(14,146,2.1),(15,146,2.1),(16,146,2.1),(17,146,2.1),(18,146,2.1),(19,146,2.1),(20,146,2.1),(21,146,2.1),(1,147,0.56),(2,147,0.56),(3,147,0.56),(4,147,0.56),(5,147,0.56),(6,147,0.56),(7,147,0.56),(8,147,0.56),(9,147,0.56),(10,147,0.56),(11,147,0.56),(12,147,0.56),(13,147,0.56),(14,147,0.56),(15,147,0.56),(16,147,0.56),(17,147,0.56),(18,147,0.56),(19,147,0.56),(20,147,0.56),(21,147,0.56),(1,148,1.91338),(2,148,1.91338),(3,148,1.91338),(4,148,1.91338),(5,148,1.91338),(6,148,1.91338),(7,148,1.91338),(8,148,1.91338),(9,148,1.91338),(10,148,1.91338),(11,148,1.91338),(12,148,1.91338),(13,148,1.91338),(14,148,1.91338),(15,148,1.91338),(16,148,1.91338),(17,148,1.91338),(18,148,1.91338),(19,148,1.91338),(20,148,1.91338),(21,148,1.91338),(1,149,2.19338),(2,149,2.19338),(3,149,2.19338),(4,149,2.19338),(5,149,2.19338),(6,149,2.19338),(7,149,2.19338),(8,149,2.19338),(9,149,2.19338),(10,149,2.19338),(11,149,2.19338),(12,149,2.19338),(13,149,2.19338),(14,149,2.19338),(15,149,2.19338),(16,149,2.19338),(17,149,2.19338),(18,149,2.19338),(19,149,2.19338),(20,149,2.19338),(21,149,2.19338),(1,150,0.37338),(2,150,0.37338),(3,150,0.37338),(4,150,0.37338),(5,150,0.37338),(6,150,0.37338),(7,150,0.37338),(8,150,0.37338),(9,150,0.37338),(10,150,0.37338),(11,150,0.37338),(12,150,0.37338),(13,150,0.37338),(14,150,0.37338),(15,150,0.37338),(16,150,0.37338),(17,150,0.37338),(18,150,0.37338),(19,150,0.37338),(20,150,0.37338),(21,150,0.37338),(1,151,0.93331),(2,151,0.93331),(3,151,0.93331),(4,151,0.93331),(5,151,0.93331),(6,151,0.93331),(7,151,0.93331),(8,151,0.93331),(9,151,0.93331),(10,151,0.93331),(11,151,0.93331),(12,151,0.93331),(13,151,0.93331),(14,151,0.93331),(15,151,0.93331),(16,151,0.93331),(17,151,0.93331),(18,151,0.93331),(19,151,0.93331),(20,151,0.93331),(21,151,0.93331),(1,152,1.12),(2,152,1.12),(3,152,1.12),(4,152,1.12),(5,152,1.12),(6,152,1.12),(7,152,1.12),(8,152,1.12),(9,152,1.12),(10,152,1.12),(11,152,1.12),(12,152,1.12),(13,152,1.12),(14,152,1.12),(15,152,1.12),(16,152,1.12),(17,152,1.12),(18,152,1.12),(19,152,1.12),(20,152,1.12),(21,152,1.12),(1,181,0.37338),(2,181,0.56007),(3,181,0.56007),(4,181,0.56007),(5,181,0.56007),(6,181,0.56007),(7,181,0.56007),(8,181,0.56007),(9,181,0.56007),(10,181,0.56007),(11,181,0.56007),(12,181,0.56007),(13,181,0.56007),(14,181,0.56007),(15,181,0.56007),(16,181,0.56007),(17,181,0.56007),(18,181,0.56007),(19,181,0.56007),(20,181,0.56007),(21,181,0.56007),(1,182,1.09669),(2,182,1.09669),(3,182,1.09669),(4,182,1.09669),(5,182,1.09669),(6,182,1.09669),(7,182,1.09669),(8,182,1.09669),(9,182,1.09669),(10,182,1.09669),(11,182,1.09669),(12,182,1.09669),(13,182,1.09669),(14,182,1.09669),(15,182,1.09669),(16,182,1.09669),(17,182,1.09669),(18,182,1.09669),(19,182,1.09669),(20,182,1.09669),(21,182,1.09669),(1,183,1.26),(2,183,1.26),(3,183,1.26),(4,183,1.26),(5,183,1.26),(6,183,1.26),(7,183,1.26),(8,183,1.26),(9,183,1.26),(10,183,1.26),(11,183,1.26),(12,183,1.26),(13,183,1.26),(14,183,1.26),(15,183,1.26),(16,183,1.26),(17,183,1.26),(18,183,1.26),(19,183,1.26),(20,183,1.26),(21,183,1.26),(1,184,1.02669),(2,184,1.02669),(3,184,1.02669),(4,184,1.02669),(5,184,1.02669),(6,184,1.02669),(7,184,1.02669),(8,184,1.02669),(9,184,1.02669),(10,184,1.02669),(11,184,1.02669),(12,184,1.02669),(13,184,1.02669),(14,184,1.02669),(15,184,1.02669),(16,184,1.02669),(17,184,1.02669),(18,184,1.02669),(19,184,1.02669),(20,184,1.02669),(21,184,1.02669),(1,185,1.28331),(2,185,1.28331),(3,185,1.28331),(4,185,1.28331),(5,185,1.28331),(6,185,1.28331),(7,185,1.28331),(8,185,1.28331),(9,185,1.28331),(10,185,1.28331),(11,185,1.28331),(12,185,1.28331),(13,185,1.28331),(14,185,1.28331),(15,185,1.28331),(16,185,1.28331),(17,185,1.28331),(18,185,1.28331),(19,185,1.28331),(20,185,1.28331),(21,185,1.28331),(1,186,0.56007),(2,186,0.74676),(3,186,0.74676),(4,186,0.74676),(5,186,0.74676),(6,186,0.74676),(7,186,0.74676),(8,186,0.74676),(9,186,0.74676),(10,186,0.74676),(11,186,0.74676),(12,186,0.74676),(13,186,0.74676),(14,186,0.74676),(15,186,0.74676),(16,186,0.74676),(17,186,0.74676),(18,186,0.74676),(19,186,0.74676),(20,186,0.74676),(21,186,0.74676),(1,187,1.86662),(2,187,1.86662),(3,187,1.86662),(4,187,1.86662),(5,187,1.86662),(6,187,1.86662),(7,187,1.86662),(8,187,1.86662),(9,187,1.86662),(10,187,1.86662),(11,187,1.86662),(12,187,1.86662),(13,187,1.86662),(14,187,1.86662),(15,187,1.86662),(16,187,1.86662),(17,187,1.86662),(18,187,1.86662),(19,187,1.86662),(20,187,1.86662),(21,187,1.86662),(1,188,2.1),(2,188,2.1),(3,188,2.1),(4,188,2.1),(5,188,2.1),(6,188,2.1),(7,188,2.1),(8,188,2.1),(9,188,2.1),(10,188,2.1),(11,188,2.1),(12,188,2.1),(13,188,2.1),(14,188,2.1),(15,188,2.1),(16,188,2.1),(17,188,2.1),(18,188,2.1),(19,188,2.1),(20,188,2.1),(21,188,2.1),(1,225,1.02662),(2,225,1.53993),(3,225,1.53993),(4,225,1.53993),(5,225,1.53993),(6,225,1.53993),(7,225,1.53993),(8,225,1.53993),(9,225,1.53993),(10,225,1.53993),(11,225,1.53993),(12,225,1.53993),(13,225,1.53993),(14,225,1.53993),(15,225,1.53993),(16,225,1.53993),(17,225,1.53993),(18,225,1.53993),(19,225,1.53993),(20,225,1.53993),(21,225,1.53993),(1,226,2.19338),(2,226,2.19338),(3,226,2.19338),(4,226,2.19338),(5,226,2.19338),(6,226,2.19338),(7,226,2.19338),(8,226,2.19338),(9,226,2.19338),(10,226,2.19338),(11,226,2.19338),(12,226,2.19338),(13,226,2.19338),(14,226,2.19338),(15,226,2.19338),(16,226,2.19338),(17,226,2.19338),(18,226,2.19338),(19,226,2.19338),(20,226,2.19338),(21,226,2.19338),(1,227,2.38),(2,227,2.38),(3,227,2.38),(4,227,2.38),(5,227,2.38),(6,227,2.38),(7,227,2.38),(8,227,2.38),(9,227,2.38),(10,227,2.38),(11,227,2.38),(12,227,2.38),(13,227,2.38),(14,227,2.38),(15,227,2.38),(16,227,2.38),(17,227,2.38),(18,227,2.38),(19,227,2.38),(20,227,2.38),(21,227,2.38),(1,228,0.37338),(2,228,0.56007),(3,228,0.56007),(4,228,0.56007),(5,228,0.56007),(6,228,0.56007),(7,228,0.56007),(8,228,0.56007),(9,228,0.56007),(10,228,0.56007),(11,228,0.56007),(12,228,0.56007),(13,228,0.56007),(14,228,0.56007),(15,228,0.56007),(16,228,0.56007),(17,228,0.56007),(18,228,0.56007),(19,228,0.56007),(20,228,0.56007),(21,228,0.56007),(1,229,1.91338),(2,229,1.91338),(3,229,1.91338),(4,229,1.91338),(5,229,1.91338),(6,229,1.91338),(7,229,1.91338),(8,229,1.91338),(9,229,1.91338),(10,229,1.91338),(11,229,1.91338),(12,229,1.91338),(13,229,1.91338),(14,229,1.91338),(15,229,1.91338),(16,229,1.91338),(17,229,1.91338),(18,229,1.91338),(19,229,1.91338),(20,229,1.91338),(21,229,1.91338),(1,230,2.24),(2,230,2.24),(3,230,2.24),(4,230,2.24),(5,230,2.24),(6,230,2.24),(7,230,2.24),(8,230,2.24),(9,230,2.24),(10,230,2.24),(11,230,2.24),(12,230,2.24),(13,230,2.24),(14,230,2.24),(15,230,2.24),(16,230,2.24),(17,230,2.24),(18,230,2.24),(19,230,2.24),(20,230,2.24),(21,230,2.24),(1,231,0.64008),(2,231,0.64008),(3,231,0.64008),(4,231,0.64008),(5,231,0.64008),(7,231,0.64008),(8,231,0.64008),(9,231,0.64008),(10,231,0.64008),(11,231,0.64008),(12,231,0.64008),(13,231,0.64008),(14,231,0.64008),(15,231,0.64008),(16,231,0.64008),(17,231,0.64008),(18,231,0.64008),(19,231,0.64008),(20,231,0.64008),(21,231,0.64008),(6,231,1.62687),(16,524,1.48),(10,1658,0.74),(14,1658,0.74),(15,1658,0.74),(19,1658,0.74),(1,3104,0.80004),(8,3104,0.80004),(9,3104,0.80004),(10,3104,0.80004),(11,3104,0.80004),(12,3104,0.80004),(1,3189,0.18669),(2,3189,0.37338),(3,3189,0.37338),(4,3189,0.37338),(5,3189,0.37338),(6,3189,0.37338),(7,3189,0.37338),(8,3189,0.37338),(9,3189,0.37338),(10,3189,0.37338),(11,3189,0.37338),(12,3189,0.37338),(13,3189,0.37338),(14,3189,0.37338),(15,3189,0.37338),(16,3189,0.37338),(17,3189,0.37338),(18,3189,0.37338),(19,3189,0.37338),(20,3189,0.37338),(21,3189,0.37338),(1,3190,1.00331),(2,3190,1.00331),(3,3190,1.00331),(4,3190,1.00331),(5,3190,1.00331),(6,3190,1.00331),(7,3190,1.00331),(8,3190,1.00331),(9,3190,1.00331),(10,3190,1.00331),(11,3190,1.00331),(12,3190,1.00331),(13,3190,1.00331),(14,3190,1.00331),(15,3190,1.00331),(16,3190,1.00331),(17,3190,1.00331),(18,3190,1.00331),(19,3190,1.00331),(20,3190,1.00331),(21,3190,1.00331),(1,3191,1.05),(2,3191,1.05),(3,3191,1.05),(4,3191,1.05),(5,3191,1.05),(6,3191,1.05),(7,3191,1.05),(8,3191,1.05),(9,3191,1.05),(10,3191,1.05),(11,3191,1.05),(12,3191,1.05),(13,3191,1.05),(14,3191,1.05),(15,3191,1.05),(16,3191,1.05),(17,3191,1.05),(18,3191,1.05),(19,3191,1.05),(20,3191,1.05),(21,3191,1.05),(1,3192,1.00331),(2,3192,1.00331),(3,3192,1.00331),(4,3192,1.00331),(5,3192,1.00331),(6,3192,1.00331),(7,3192,1.00331),(8,3192,1.00331),(9,3192,1.00331),(10,3192,1.00331),(11,3192,1.00331),(12,3192,1.00331),(13,3192,1.00331),(14,3192,1.00331),(15,3192,1.00331),(16,3192,1.00331),(17,3192,1.00331),(18,3192,1.00331),(19,3192,1.00331),(20,3192,1.00331),(21,3192,1.00331),(1,3193,1.09669),(2,3193,1.09669),(3,3193,1.09669),(4,3193,1.09669),(5,3193,1.09669),(6,3193,1.09669),(7,3193,1.09669),(8,3193,1.09669),(9,3193,1.09669),(10,3193,1.09669),(11,3193,1.09669),(12,3193,1.09669),(13,3193,1.09669),(14,3193,1.09669),(15,3193,1.09669),(16,3193,1.09669),(17,3193,1.09669),(18,3193,1.09669),(19,3193,1.09669),(20,3193,1.09669),(21,3193,1.09669),(1,3194,0.86331),(2,3194,0.86331),(3,3194,0.86331),(4,3194,0.86331),(5,3194,0.86331),(6,3194,0.86331),(7,3194,0.86331),(8,3194,0.86331),(9,3194,0.86331),(10,3194,0.86331),(11,3194,0.86331),(12,3194,0.86331),(13,3194,0.86331),(14,3194,0.86331),(15,3194,0.86331),(16,3194,0.86331),(17,3194,0.86331),(18,3194,0.86331),(19,3194,0.86331),(20,3194,0.86331),(21,3194,0.86331),(1,3195,1.02669),(2,3195,1.02669),(3,3195,1.02669),(4,3195,1.02669),(5,3195,1.02669),(6,3195,1.02669),(7,3195,1.02669),(8,3195,1.02669),(9,3195,1.02669),(10,3195,1.02669),(11,3195,1.02669),(12,3195,1.02669),(13,3195,1.02669),(14,3195,1.02669),(15,3195,1.02669),(16,3195,1.02669),(17,3195,1.02669),(18,3195,1.02669),(19,3195,1.02669),(20,3195,1.02669),(21,3195,1.02669),(1,3220,0.95669),(2,3220,0.95669),(3,3220,0.95669),(4,3220,0.95669),(5,3220,0.95669),(6,3220,0.95669),(7,3220,0.95669),(8,3220,0.95669),(9,3220,0.95669),(10,3220,0.95669),(11,3220,0.95669),(12,3220,0.95669),(13,3220,0.95669),(14,3220,0.95669),(15,3220,0.95669),(16,3220,0.95669),(17,3220,0.95669),(18,3220,0.95669),(19,3220,0.95669),(20,3220,0.95669),(21,3220,0.95669),(1,3221,1.09669),(2,3221,1.09669),(3,3221,1.09669),(4,3221,1.09669),(5,3221,1.09669),(6,3221,1.09669),(7,3221,1.09669),(8,3221,1.09669),(9,3221,1.09669),(10,3221,1.09669),(11,3221,1.09669),(12,3221,1.09669),(13,3221,1.09669),(14,3221,1.09669),(15,3221,1.09669),(16,3221,1.09669),(17,3221,1.09669),(18,3221,1.09669),(19,3221,1.09669),(20,3221,1.09669),(21,3221,1.09669),(1,3240,1.26),(2,3240,1.26),(3,3240,1.26),(4,3240,1.26),(5,3240,1.26),(6,3240,1.26),(7,3240,1.26),(8,3240,1.26),(9,3240,1.26),(10,3240,1.26),(11,3240,1.26),(12,3240,1.26),(13,3240,1.26),(14,3240,1.26),(15,3240,1.26),(16,3240,1.26),(17,3240,1.26),(18,3240,1.26),(19,3240,1.26),(20,3240,1.26),(21,3240,1.26),(1,3241,1.05),(2,3241,1.05),(3,3241,1.05),(4,3241,1.05),(5,3241,1.05),(6,3241,1.05),(7,3241,1.05),(8,3241,1.05),(9,3241,1.05),(10,3241,1.05),(11,3241,1.05),(12,3241,1.05),(13,3241,1.05),(14,3241,1.05),(15,3241,1.05),(16,3241,1.05),(17,3241,1.05),(18,3241,1.05),(19,3241,1.05),(20,3241,1.05),(21,3241,1.05),(1,3242,1.23669),(2,3242,1.23669),(3,3242,1.23669),(4,3242,1.23669),(5,3242,1.23669),(6,3242,1.23669),(7,3242,1.23669),(8,3242,1.23669),(9,3242,1.23669),(10,3242,1.23669),(11,3242,1.23669),(12,3242,1.23669),(13,3242,1.23669),(14,3242,1.23669),(15,3242,1.23669),(16,3242,1.23669),(17,3242,1.23669),(18,3242,1.23669),(19,3242,1.23669),(20,3242,1.23669),(21,3242,1.23669),(1,3243,1.00331),(2,3243,1.00331),(3,3243,1.00331),(4,3243,1.00331),(5,3243,1.00331),(6,3243,1.00331),(7,3243,1.00331),(8,3243,1.00331),(9,3243,1.00331),(10,3243,1.00331),(11,3243,1.00331),(12,3243,1.00331),(13,3243,1.00331),(14,3243,1.00331),(15,3243,1.00331),(16,3243,1.00331),(17,3243,1.00331),(18,3243,1.00331),(19,3243,1.00331),(20,3243,1.00331),(21,3243,1.00331),(1,3244,1.23669),(2,3244,1.23669),(3,3244,1.23669),(4,3244,1.23669),(5,3244,1.23669),(6,3244,1.23669),(7,3244,1.23669),(8,3244,1.23669),(9,3244,1.23669),(10,3244,1.23669),(11,3244,1.23669),(12,3244,1.23669),(13,3244,1.23669),(14,3244,1.23669),(15,3244,1.23669),(16,3244,1.23669),(17,3244,1.23669),(18,3244,1.23669),(19,3244,1.23669),(20,3244,1.23669),(21,3244,1.23669),(1,3245,1.02669),(2,3245,1.02669),(3,3245,1.02669),(4,3245,1.02669),(5,3245,1.02669),(6,3245,1.02669),(7,3245,1.02669),(8,3245,1.02669),(9,3245,1.02669),(10,3245,1.02669),(11,3245,1.02669),(12,3245,1.02669),(13,3245,1.02669),(14,3245,1.02669),(15,3245,1.02669),(16,3245,1.02669),(17,3245,1.02669),(18,3245,1.02669),(19,3245,1.02669),(20,3245,1.02669),(21,3245,1.02669),(1,3246,1.09669),(2,3246,1.09669),(3,3246,1.09669),(4,3246,1.09669),(5,3246,1.09669),(6,3246,1.09669),(7,3246,1.09669),(8,3246,1.09669),(9,3246,1.09669),(10,3246,1.09669),(11,3246,1.09669),(12,3246,1.09669),(13,3246,1.09669),(14,3246,1.09669),(15,3246,1.09669),(16,3246,1.09669),(17,3246,1.09669),(18,3246,1.09669),(19,3246,1.09669),(20,3246,1.09669),(21,3246,1.09669),(1,3247,0.09331),(2,3247,0.37324),(3,3247,0.37324),(4,3247,0.37324),(5,3247,0.37324),(6,3247,0.37324),(7,3247,0.37324),(8,3247,0.37324),(9,3247,0.37324),(10,3247,0.37324),(11,3247,0.37324),(12,3247,0.37324),(13,3247,0.37324),(14,3247,0.37324),(15,3247,0.37324),(16,3247,0.37324),(17,3247,0.37324),(18,3247,0.37324),(19,3247,0.37324),(20,3247,0.37324),(21,3247,0.37324),(1,3248,0.88669),(2,3248,0.88669),(3,3248,0.88669),(4,3248,0.88669),(5,3248,0.88669),(6,3248,0.88669),(7,3248,0.88669),(8,3248,0.88669),(9,3248,0.88669),(10,3248,0.88669),(11,3248,0.88669),(12,3248,0.88669),(13,3248,0.88669),(14,3248,0.88669),(15,3248,0.88669),(16,3248,0.88669),(17,3248,0.88669),(18,3248,0.88669),(19,3248,0.88669),(20,3248,0.88669),(21,3248,0.88669),(1,3249,1.05),(2,3249,1.05),(3,3249,1.05),(4,3249,1.05),(5,3249,1.05),(6,3249,1.05),(7,3249,1.05),(8,3249,1.05),(9,3249,1.05),(10,3249,1.05),(11,3249,1.05),(12,3249,1.05),(13,3249,1.05),(14,3249,1.05),(15,3249,1.05),(16,3249,1.05),(17,3249,1.05),(18,3249,1.05),(19,3249,1.05),(20,3249,1.05),(21,3249,1.05),(2,3500,0.88669),(3,3500,0.88669),(4,3500,0.88669),(5,3500,0.88669),(6,3500,0.88669),(7,3500,0.88669),(8,3500,0.88669),(9,3500,0.88669),(10,3500,0.88669),(11,3500,0.88669),(12,3500,0.88669),(13,3500,0.88669),(14,3500,0.88669),(15,3500,0.88669),(16,3500,0.88669),(17,3500,0.88669),(18,3500,0.88669),(19,3500,0.88669),(20,3500,0.88669),(21,3500,0.88669),(2,3501,1.02669),(3,3501,1.02669),(4,3501,1.02669),(5,3501,1.02669),(6,3501,1.02669),(7,3501,1.02669),(8,3501,1.02669),(9,3501,1.02669),(10,3501,1.02669),(11,3501,1.02669),(12,3501,1.02669),(13,3501,1.02669),(14,3501,1.02669),(15,3501,1.02669),(16,3501,1.02669),(17,3501,1.02669),(18,3501,1.02669),(19,3501,1.02669),(20,3501,1.02669),(21,3501,1.02669),(2,3502,0.46662),(3,3502,0.46662),(4,3502,0.46662),(5,3502,0.46662),(6,3502,0.46662),(7,3502,0.46662),(8,3502,0.46662),(9,3502,0.46662),(10,3502,0.46662),(11,3502,0.46662),(12,3502,0.46662),(13,3502,0.46662),(14,3502,0.46662),(15,3502,0.46662),(16,3502,0.46662),(17,3502,0.46662),(18,3502,0.46662),(19,3502,0.46662),(20,3502,0.46662),(21,3502,0.46662),(2,3503,0.98),(3,3503,0.98),(4,3503,0.98),(5,3503,0.98),(6,3503,0.98),(7,3503,0.98),(8,3503,0.98),(9,3503,0.98),(10,3503,0.98),(11,3503,0.98),(12,3503,0.98),(13,3503,0.98),(14,3503,0.98),(15,3503,0.98),(16,3503,0.98),(17,3503,0.98),(18,3503,0.98),(19,3503,0.98),(20,3503,0.98),(21,3503,0.98),(2,3504,1.16669),(3,3504,1.16669),(4,3504,1.16669),(5,3504,1.16669),(6,3504,1.16669),(7,3504,1.16669),(8,3504,1.16669),(9,3504,1.16669),(10,3504,1.16669),(11,3504,1.16669),(12,3504,1.16669),(13,3504,1.16669),(14,3504,1.16669),(15,3504,1.16669),(16,3504,1.16669),(17,3504,1.16669),(18,3504,1.16669),(19,3504,1.16669),(20,3504,1.16669),(21,3504,1.16669),(2,3505,0.98),(3,3505,0.98),(4,3505,0.98),(5,3505,0.98),(6,3505,0.98),(7,3505,0.98),(8,3505,0.98),(9,3505,0.98),(10,3505,0.98),(11,3505,0.98),(12,3505,0.98),(13,3505,0.98),(14,3505,0.98),(15,3505,0.98),(16,3505,0.98),(17,3505,0.98),(18,3505,0.98),(19,3505,0.98),(20,3505,0.98),(21,3505,0.98),(2,3506,1.05),(3,3506,1.05),(4,3506,1.05),(5,3506,1.05),(6,3506,1.05),(7,3506,1.05),(8,3506,1.05),(9,3506,1.05),(10,3506,1.05),(11,3506,1.05),(12,3506,1.05),(13,3506,1.05),(14,3506,1.05),(15,3506,1.05),(16,3506,1.05),(17,3506,1.05),(18,3506,1.05),(19,3506,1.05),(20,3506,1.05),(21,3506,1.05),(2,3507,0.37338),(3,3507,0.37338),(4,3507,0.37338),(5,3507,0.37338),(6,3507,0.37338),(7,3507,0.37338),(8,3507,0.37338),(9,3507,0.37338),(10,3507,0.37338),(11,3507,0.37338),(12,3507,0.37338),(13,3507,0.37338),(14,3507,0.37338),(15,3507,0.37338),(16,3507,0.37338),(17,3507,0.37338),(18,3507,0.37338),(19,3507,0.37338),(20,3507,0.37338),(21,3507,0.37338),(2,3508,0.88669),(3,3508,0.88669),(4,3508,0.88669),(5,3508,0.88669),(6,3508,0.88669),(7,3508,0.88669),(8,3508,0.88669),(9,3508,0.88669),(10,3508,0.88669),(11,3508,0.88669),(12,3508,0.88669),(13,3508,0.88669),(14,3508,0.88669),(15,3508,0.88669),(16,3508,0.88669),(17,3508,0.88669),(18,3508,0.88669),(19,3508,0.88669),(20,3508,0.88669),(21,3508,0.88669),(2,3509,0.98),(3,3509,0.98),(4,3509,0.98),(5,3509,0.98),(6,3509,0.98),(7,3509,0.98),(8,3509,0.98),(9,3509,0.98),(10,3509,0.98),(11,3509,0.98),(12,3509,0.98),(13,3509,0.98),(14,3509,0.98),(15,3509,0.98),(16,3509,0.98),(17,3509,0.98),(18,3509,0.98),(19,3509,0.98),(20,3509,0.98),(21,3509,0.98),(2,3510,0.93331),(3,3510,0.93331),(4,3510,0.93331),(5,3510,0.93331),(6,3510,0.93331),(7,3510,0.93331),(8,3510,0.93331),(9,3510,0.93331),(10,3510,0.93331),(11,3510,0.93331),(12,3510,0.93331),(13,3510,0.93331),(14,3510,0.93331),(15,3510,0.93331),(16,3510,0.93331),(17,3510,0.93331),(18,3510,0.93331),(19,3510,0.93331),(20,3510,0.93331),(21,3510,0.93331),(2,3511,1.05),(3,3511,1.05),(4,3511,1.05),(5,3511,1.05),(6,3511,1.05),(7,3511,1.05),(8,3511,1.05),(9,3511,1.05),(10,3511,1.05),(11,3511,1.05),(12,3511,1.05),(13,3511,1.05),(14,3511,1.05),(15,3511,1.05),(16,3511,1.05),(17,3511,1.05),(18,3511,1.05),(19,3511,1.05),(20,3511,1.05),(21,3511,1.05),(2,3512,1.05),(3,3512,1.05),(4,3512,1.05),(5,3512,1.05),(6,3512,1.05),(7,3512,1.05),(8,3512,1.05),(9,3512,1.05),(10,3512,1.05),(11,3512,1.05),(12,3512,1.05),(13,3512,1.05),(14,3512,1.05),(15,3512,1.05),(16,3512,1.05),(17,3512,1.05),(18,3512,1.05),(19,3512,1.05),(20,3512,1.05),(21,3512,1.05),(2,3513,1.26),(3,3513,1.26),(4,3513,1.26),(5,3513,1.26),(6,3513,1.26),(7,3513,1.26),(8,3513,1.26),(9,3513,1.26),(10,3513,1.26),(11,3513,1.26),(12,3513,1.26),(13,3513,1.26),(14,3513,1.26),(15,3513,1.26),(16,3513,1.26),(17,3513,1.26),(18,3513,1.26),(19,3513,1.26),(20,3513,1.26),(21,3513,1.26),(2,3514,0.86331),(3,3514,0.86331),(4,3514,0.86331),(5,3514,0.86331),(6,3514,0.86331),(7,3514,0.86331),(8,3514,0.86331),(9,3514,0.86331),(10,3514,0.86331),(11,3514,0.86331),(12,3514,0.86331),(13,3514,0.86331),(14,3514,0.86331),(15,3514,0.86331),(16,3514,0.86331),(17,3514,0.86331),(18,3514,0.86331),(19,3514,0.86331),(20,3514,0.86331),(21,3514,0.86331),(2,3515,1.12),(3,3515,1.12),(4,3515,1.12),(5,3515,1.12),(6,3515,1.12),(7,3515,1.12),(8,3515,1.12),(9,3515,1.12),(10,3515,1.12),(11,3515,1.12),(12,3515,1.12),(13,3515,1.12),(14,3515,1.12),(15,3515,1.12),(16,3515,1.12),(17,3515,1.12),(18,3515,1.12),(19,3515,1.12),(20,3515,1.12),(21,3515,1.12),(2,3516,1.77338),(3,3516,1.77338),(4,3516,1.77338),(5,3516,1.77338),(6,3516,1.77338),(7,3516,1.77338),(8,3516,1.77338),(9,3516,1.77338),(10,3516,1.77338),(11,3516,1.77338),(12,3516,1.77338),(13,3516,1.77338),(14,3516,1.77338),(15,3516,1.77338),(16,3516,1.77338),(17,3516,1.77338),(18,3516,1.77338),(19,3516,1.77338),(20,3516,1.77338),(21,3516,1.77338),(2,3517,1.07331),(3,3517,1.07331),(4,3517,1.07331),(5,3517,1.07331),(6,3517,1.07331),(7,3517,1.07331),(8,3517,1.07331),(9,3517,1.07331),(10,3517,1.07331),(11,3517,1.07331),(12,3517,1.07331),(13,3517,1.07331),(14,3517,1.07331),(15,3517,1.07331),(16,3517,1.07331),(17,3517,1.07331),(18,3517,1.07331),(19,3517,1.07331),(20,3517,1.07331),(21,3517,1.07331),(2,3518,1.07331),(3,3518,1.07331),(4,3518,1.07331),(5,3518,1.07331),(6,3518,1.07331),(7,3518,1.07331),(8,3518,1.07331),(9,3518,1.07331),(10,3518,1.07331),(11,3518,1.07331),(12,3518,1.07331),(13,3518,1.07331),(14,3518,1.07331),(15,3518,1.07331),(16,3518,1.07331),(17,3518,1.07331),(18,3518,1.07331),(19,3518,1.07331),(20,3518,1.07331),(21,3518,1.07331),(2,3519,0.93331),(3,3519,0.93331),(4,3519,0.93331),(5,3519,0.93331),(6,3519,0.93331),(7,3519,0.93331),(8,3519,0.93331),(9,3519,0.93331),(10,3519,0.93331),(11,3519,0.93331),(12,3519,0.93331),(13,3519,0.93331),(14,3519,0.93331),(15,3519,0.93331),(16,3519,0.93331),(17,3519,0.93331),(18,3519,0.93331),(19,3519,0.93331),(20,3519,0.93331),(21,3519,0.93331),(2,3520,1.12),(3,3520,1.12),(4,3520,1.12),(5,3520,1.12),(6,3520,1.12),(7,3520,1.12),(8,3520,1.12),(9,3520,1.12),(10,3520,1.12),(11,3520,1.12),(12,3520,1.12),(13,3520,1.12),(14,3520,1.12),(15,3520,1.12),(16,3520,1.12),(17,3520,1.12),(18,3520,1.12),(19,3520,1.12),(20,3520,1.12),(21,3520,1.12),(2,3521,0.86331),(3,3521,0.86331),(4,3521,0.86331),(5,3521,0.86331),(6,3521,0.86331),(7,3521,0.86331),(8,3521,0.86331),(9,3521,0.86331),(10,3521,0.86331),(11,3521,0.86331),(12,3521,0.86331),(13,3521,0.86331),(14,3521,0.86331),(15,3521,0.86331),(16,3521,0.86331),(17,3521,0.86331),(18,3521,0.86331),(19,3521,0.86331),(20,3521,0.86331),(21,3521,0.86331),(2,3522,0.98),(3,3522,0.98),(4,3522,0.98),(5,3522,0.98),(6,3522,0.98),(7,3522,0.98),(8,3522,0.98),(9,3522,0.98),(10,3522,0.98),(11,3522,0.98),(12,3522,0.98),(13,3522,0.98),(14,3522,0.98),(15,3522,0.98),(16,3522,0.98),(17,3522,0.98),(18,3522,0.98),(19,3522,0.98),(20,3522,0.98),(21,3522,0.98),(2,3523,0.93331),(3,3523,0.93331),(4,3523,0.93331),(5,3523,0.93331),(6,3523,0.93331),(7,3523,0.93331),(8,3523,0.93331),(9,3523,0.93331),(10,3523,0.93331),(11,3523,0.93331),(12,3523,0.93331),(13,3523,0.93331),(14,3523,0.93331),(15,3523,0.93331),(16,3523,0.93331),(17,3523,0.93331),(18,3523,0.93331),(19,3523,0.93331),(20,3523,0.93331),(21,3523,0.93331),(2,3524,1.05),(3,3524,1.05),(4,3524,1.05),(5,3524,1.05),(6,3524,1.05),(7,3524,1.05),(8,3524,1.05),(9,3524,1.05),(10,3524,1.05),(11,3524,1.05),(12,3524,1.05),(13,3524,1.05),(14,3524,1.05),(15,3524,1.05),(16,3524,1.05),(17,3524,1.05),(18,3524,1.05),(19,3524,1.05),(20,3524,1.05),(21,3524,1.05),(2,3531,0.91),(3,3531,0.91),(4,3531,0.91),(5,3531,0.91),(6,3531,0.91),(7,3531,0.91),(8,3531,0.91),(9,3531,0.91),(10,3531,0.91),(11,3531,0.91),(12,3531,0.91),(13,3531,0.91),(14,3531,0.91),(15,3531,0.91),(16,3531,0.91),(17,3531,0.91),(18,3531,0.91),(19,3531,0.91),(20,3531,0.91),(21,3531,0.91),(2,3532,1.00331),(3,3532,1.00331),(4,3532,1.00331),(5,3532,1.00331),(6,3532,1.00331),(7,3532,1.00331),(8,3532,1.00331),(9,3532,1.00331),(10,3532,1.00331),(11,3532,1.00331),(12,3532,1.00331),(13,3532,1.00331),(14,3532,1.00331),(15,3532,1.00331),(16,3532,1.00331),(17,3532,1.00331),(18,3532,1.00331),(19,3532,1.00331),(20,3532,1.00331),(21,3532,1.00331),(2,3533,0.95669),(3,3533,0.95669),(4,3533,0.95669),(5,3533,0.95669),(6,3533,0.95669),(7,3533,0.95669),(8,3533,0.95669),(9,3533,0.95669),(10,3533,0.95669),(11,3533,0.95669),(12,3533,0.95669),(13,3533,0.95669),(14,3533,0.95669),(15,3533,0.95669),(16,3533,0.95669),(17,3533,0.95669),(18,3533,0.95669),(19,3533,0.95669),(20,3533,0.95669),(21,3533,0.95669),(2,3534,1.14331),(3,3534,1.14331),(4,3534,1.14331),(5,3534,1.14331),(6,3534,1.14331),(7,3534,1.14331),(8,3534,1.14331),(9,3534,1.14331),(10,3534,1.14331),(11,3534,1.14331),(12,3534,1.14331),(13,3534,1.14331),(14,3534,1.14331),(15,3534,1.14331),(16,3534,1.14331),(17,3534,1.14331),(18,3534,1.14331),(19,3534,1.14331),(20,3534,1.14331),(21,3534,1.14331),(2,3578,1.14331),(3,3578,1.14331),(4,3578,1.14331),(5,3578,1.14331),(6,3578,1.14331),(7,3578,1.14331),(8,3578,1.14331),(9,3578,1.14331),(10,3578,1.14331),(11,3578,1.14331),(12,3578,1.14331),(13,3578,1.14331),(14,3578,1.14331),(15,3578,1.14331),(16,3578,1.14331),(17,3578,1.14331),(18,3578,1.14331),(19,3578,1.14331),(20,3578,1.14331),(21,3578,1.14331),(2,3579,1.30669),(3,3579,1.30669),(4,3579,1.30669),(5,3579,1.30669),(6,3579,1.30669),(7,3579,1.30669),(8,3579,1.30669),(9,3579,1.30669),(10,3579,1.30669),(11,3579,1.30669),(12,3579,1.30669),(13,3579,1.30669),(14,3579,1.30669),(15,3579,1.30669),(16,3579,1.30669),(17,3579,1.30669),(18,3579,1.30669),(19,3579,1.30669),(20,3579,1.30669),(21,3579,1.30669),(2,3580,0.37331),(3,3580,0.37331),(4,3580,0.37331),(5,3580,0.37331),(6,3580,0.37331),(7,3580,0.37331),(8,3580,0.37331),(9,3580,0.37331),(10,3580,0.37331),(11,3580,0.37331),(12,3580,0.37331),(13,3580,0.37331),(14,3580,0.37331),(15,3580,0.37331),(16,3580,0.37331),(17,3580,0.37331),(18,3580,0.37331),(19,3580,0.37331),(20,3580,0.37331),(21,3580,0.37331),(2,3581,1.07331),(3,3581,1.07331),(4,3581,1.07331),(5,3581,1.07331),(6,3581,1.07331),(7,3581,1.07331),(8,3581,1.07331),(9,3581,1.07331),(10,3581,1.07331),(11,3581,1.07331),(12,3581,1.07331),(13,3581,1.07331),(14,3581,1.07331),(15,3581,1.07331),(16,3581,1.07331),(17,3581,1.07331),(18,3581,1.07331),(19,3581,1.07331),(20,3581,1.07331),(21,3581,1.07331),(2,3582,1.21331),(3,3582,1.21331),(4,3582,1.21331),(5,3582,1.21331),(6,3582,1.21331),(7,3582,1.21331),(8,3582,1.21331),(9,3582,1.21331),(10,3582,1.21331),(11,3582,1.21331),(12,3582,1.21331),(13,3582,1.21331),(14,3582,1.21331),(15,3582,1.21331),(16,3582,1.21331),(17,3582,1.21331),(18,3582,1.21331),(19,3582,1.21331),(20,3582,1.21331),(21,3582,1.21331),(2,3583,0.95669),(3,3583,0.95669),(4,3583,0.95669),(5,3583,0.95669),(6,3583,0.95669),(7,3583,0.95669),(8,3583,0.95669),(9,3583,0.95669),(10,3583,0.95669),(11,3583,0.95669),(12,3583,0.95669),(13,3583,0.95669),(14,3583,0.95669),(15,3583,0.95669),(16,3583,0.95669),(17,3583,0.95669),(18,3583,0.95669),(19,3583,0.95669),(20,3583,0.95669),(21,3583,0.95669),(2,3584,1.02669),(3,3584,1.02669),(4,3584,1.02669),(5,3584,1.02669),(6,3584,1.02669),(7,3584,1.02669),(8,3584,1.02669),(9,3584,1.02669),(10,3584,1.02669),(11,3584,1.02669),(12,3584,1.02669),(13,3584,1.02669),(14,3584,1.02669),(15,3584,1.02669),(16,3584,1.02669),(17,3584,1.02669),(18,3584,1.02669),(19,3584,1.02669),(20,3584,1.02669),(21,3584,1.02669),(2,3585,0.86331),(3,3585,0.86331),(4,3585,0.86331),(5,3585,0.86331),(6,3585,0.86331),(7,3585,0.86331),(8,3585,0.86331),(9,3585,0.86331),(10,3585,0.86331),(11,3585,0.86331),(12,3585,0.86331),(13,3585,0.86331),(14,3585,0.86331),(15,3585,0.86331),(16,3585,0.86331),(17,3585,0.86331),(18,3585,0.86331),(19,3585,0.86331),(20,3585,0.86331),(21,3585,0.86331),(2,3586,1.09669),(3,3586,1.09669),(4,3586,1.09669),(5,3586,1.09669),(6,3586,1.09669),(7,3586,1.09669),(8,3586,1.09669),(9,3586,1.09669),(10,3586,1.09669),(11,3586,1.09669),(12,3586,1.09669),(13,3586,1.09669),(14,3586,1.09669),(15,3586,1.09669),(16,3586,1.09669),(17,3586,1.09669),(18,3586,1.09669),(19,3586,1.09669),(20,3586,1.09669),(21,3586,1.09669),(2,3587,0.86331),(3,3587,0.86331),(4,3587,0.86331),(5,3587,0.86331),(6,3587,0.86331),(7,3587,0.86331),(8,3587,0.86331),(9,3587,0.86331),(10,3587,0.86331),(11,3587,0.86331),(12,3587,0.86331),(13,3587,0.86331),(14,3587,0.86331),(15,3587,0.86331),(16,3587,0.86331),(17,3587,0.86331),(18,3587,0.86331),(19,3587,0.86331),(20,3587,0.86331),(21,3587,0.86331),(2,3588,1.02669),(3,3588,1.02669),(4,3588,1.02669),(5,3588,1.02669),(6,3588,1.02669),(7,3588,1.02669),(8,3588,1.02669),(9,3588,1.02669),(10,3588,1.02669),(11,3588,1.02669),(12,3588,1.02669),(13,3588,1.02669),(14,3588,1.02669),(15,3588,1.02669),(16,3588,1.02669),(17,3588,1.02669),(18,3588,1.02669),(19,3588,1.02669),(20,3588,1.02669),(21,3588,1.02669),(2,3589,0.88669),(3,3589,0.88669),(4,3589,0.88669),(5,3589,0.88669),(6,3589,0.88669),(7,3589,0.88669),(8,3589,0.88669),(9,3589,0.88669),(10,3589,0.88669),(11,3589,0.88669),(12,3589,0.88669),(13,3589,0.88669),(14,3589,0.88669),(15,3589,0.88669),(16,3589,0.88669),(17,3589,0.88669),(18,3589,0.88669),(19,3589,0.88669),(20,3589,0.88669),(21,3589,0.88669),(2,3590,1.00331),(3,3590,1.00331),(4,3590,1.00331),(5,3590,1.00331),(6,3590,1.00331),(7,3590,1.00331),(8,3590,1.00331),(9,3590,1.00331),(10,3590,1.00331),(11,3590,1.00331),(12,3590,1.00331),(13,3590,1.00331),(14,3590,1.00331),(15,3590,1.00331),(16,3590,1.00331),(17,3590,1.00331),(18,3590,1.00331),(19,3590,1.00331),(20,3590,1.00331),(21,3590,1.00331),(6,3687,1.23321),(6,3688,4.56321),(6,3689,5.42679),(6,3696,5.55),(7,3732,0.98679),(7,3733,2.4666),(7,3734,2.6),(7,3735,2.21),(7,3736,2.38),(8,3789,1.48),(8,3790,5.42679),(8,3791,5.92),(9,3830,2.22),(9,3831,5.18),(9,3832,5.42679),(10,3867,2.6),(10,3868,2.9334),(10,3869,2.49339),(10,3870,2.66339),(10,3884,1.3332),(10,3885,2.9334),(10,3886,3.2666),(10,3887,2.6666),(10,3888,2.8666),(10,3889,1.58661),(10,3890,2.77661),(10,3891,3.06),(10,3892,1.13339),(10,3893,2.43661),(10,3894,2.83339),(10,3895,0.49321),(10,3896,4.81),(10,3897,3),(10,3898,3.06),(14,4058,5.42679),(14,4059,6.04321),(14,4060,1.23321),(14,4061,4.68679),(14,4062,5.55),(15,4096,5.42679),(19,4240,4.68679),(19,4241,2.8666),(19,4242,2.72),(20,4290,0.49321),(20,4291,4.44),(20,4292,5.05679);


--
-- Table structure for table `#__finder_links_terms8`
--



CREATE TABLE `#__finder_links_terms8` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms8`
--


INSERT INTO `#__finder_links_terms8` (`link_id`, `term_id`, `weight`) VALUES (1,37,0.18669),(2,37,0.56007),(3,37,0.56007),(4,37,0.56007),(5,37,0.56007),(6,37,0.56007),(7,37,0.56007),(8,37,0.56007),(9,37,0.56007),(10,37,0.56007),(11,37,0.56007),(12,37,0.56007),(13,37,0.56007),(14,37,0.56007),(15,37,0.56007),(16,37,0.56007),(17,37,0.56007),(18,37,0.56007),(19,37,0.56007),(20,37,0.56007),(21,37,0.56007),(1,38,0.88669),(2,38,0.88669),(3,38,0.88669),(4,38,0.88669),(5,38,0.88669),(6,38,0.88669),(7,38,0.88669),(8,38,0.88669),(9,38,0.88669),(10,38,0.88669),(11,38,0.88669),(12,38,0.88669),(13,38,0.88669),(14,38,0.88669),(15,38,0.88669),(16,38,0.88669),(17,38,0.88669),(18,38,0.88669),(19,38,0.88669),(20,38,0.88669),(21,38,0.88669),(1,39,1.12),(2,39,1.12),(3,39,1.12),(4,39,1.12),(5,39,1.12),(6,39,1.12),(7,39,1.12),(8,39,1.12),(9,39,1.12),(10,39,1.12),(11,39,1.12),(12,39,1.12),(13,39,1.12),(14,39,1.12),(15,39,1.12),(16,39,1.12),(17,39,1.12),(18,39,1.12),(19,39,1.12),(20,39,1.12),(21,39,1.12),(1,40,0.69993),(2,40,0.93324),(3,40,0.93324),(4,40,0.93324),(5,40,0.93324),(6,40,0.93324),(7,40,0.93324),(8,40,0.93324),(9,40,0.93324),(10,40,0.93324),(11,40,0.93324),(12,40,0.93324),(13,40,0.93324),(14,40,0.93324),(15,40,0.93324),(16,40,0.93324),(17,40,0.93324),(18,40,0.93324),(19,40,0.93324),(20,40,0.93324),(21,40,0.93324),(1,41,2.19338),(2,41,2.19338),(3,41,2.19338),(4,41,2.19338),(5,41,2.19338),(6,41,2.19338),(7,41,2.19338),(8,41,2.19338),(9,41,2.19338),(10,41,2.19338),(11,41,2.19338),(12,41,2.19338),(13,41,2.19338),(14,41,2.19338),(15,41,2.19338),(16,41,2.19338),(17,41,2.19338),(18,41,2.19338),(19,41,2.19338),(20,41,2.19338),(21,41,2.19338),(1,42,2.47338),(2,42,2.47338),(3,42,2.47338),(4,42,2.47338),(5,42,2.47338),(6,42,2.47338),(7,42,2.47338),(8,42,2.47338),(9,42,2.47338),(10,42,2.47338),(11,42,2.47338),(12,42,2.47338),(13,42,2.47338),(14,42,2.47338),(15,42,2.47338),(16,42,2.47338),(17,42,2.47338),(18,42,2.47338),(19,42,2.47338),(20,42,2.47338),(21,42,2.47338),(1,43,0.42),(2,43,0.7),(3,43,0.7),(4,43,0.7),(5,43,0.7),(6,43,0.7),(7,43,0.7),(8,43,0.7),(9,43,0.7),(10,43,0.7),(11,43,0.7),(12,43,0.7),(13,43,0.7),(14,43,0.7),(15,43,0.7),(16,43,0.7),(17,43,0.7),(18,43,0.7),(19,43,0.7),(20,43,0.7),(21,43,0.7),(1,44,0.88669),(2,44,0.88669),(3,44,0.88669),(4,44,0.88669),(5,44,0.88669),(6,44,0.88669),(7,44,0.88669),(8,44,0.88669),(9,44,0.88669),(10,44,0.88669),(11,44,0.88669),(12,44,0.88669),(13,44,0.88669),(14,44,0.88669),(15,44,0.88669),(16,44,0.88669),(17,44,0.88669),(18,44,0.88669),(19,44,0.88669),(20,44,0.88669),(21,44,0.88669),(1,45,0.93331),(2,45,0.93331),(3,45,0.93331),(4,45,0.93331),(5,45,0.93331),(6,45,0.93331),(7,45,0.93331),(8,45,0.93331),(9,45,0.93331),(10,45,0.93331),(11,45,0.93331),(12,45,0.93331),(13,45,0.93331),(14,45,0.93331),(15,45,0.93331),(16,45,0.93331),(17,45,0.93331),(18,45,0.93331),(19,45,0.93331),(20,45,0.93331),(21,45,0.93331),(1,46,0.91),(2,46,0.91),(3,46,0.91),(4,46,0.91),(5,46,0.91),(6,46,0.91),(7,46,0.91),(8,46,0.91),(9,46,0.91),(10,46,0.91),(11,46,0.91),(12,46,0.91),(13,46,0.91),(14,46,0.91),(15,46,0.91),(16,46,0.91),(17,46,0.91),(18,46,0.91),(19,46,0.91),(20,46,0.91),(21,46,0.91),(1,47,1.07331),(2,47,1.07331),(3,47,1.07331),(4,47,1.07331),(5,47,1.07331),(6,47,1.07331),(7,47,1.07331),(8,47,1.07331),(9,47,1.07331),(10,47,1.07331),(11,47,1.07331),(12,47,1.07331),(13,47,1.07331),(14,47,1.07331),(15,47,1.07331),(16,47,1.07331),(17,47,1.07331),(18,47,1.07331),(19,47,1.07331),(20,47,1.07331),(21,47,1.07331),(1,48,0.74676),(2,48,1.12014),(3,48,1.12014),(4,48,1.12014),(5,48,1.12014),(6,48,1.12014),(7,48,1.12014),(8,48,1.12014),(9,48,1.12014),(10,48,1.12014),(11,48,1.12014),(12,48,1.12014),(13,48,1.12014),(14,48,1.12014),(15,48,1.12014),(16,48,1.12014),(17,48,1.12014),(18,48,1.12014),(19,48,1.12014),(20,48,1.12014),(21,48,1.12014),(2,49,0.84),(3,49,0.84),(4,49,0.84),(5,49,0.84),(6,49,0.84),(7,49,0.84),(8,49,0.84),(9,49,0.84),(10,49,0.84),(11,49,0.84),(12,49,0.84),(13,49,0.84),(14,49,0.84),(15,49,0.84),(16,49,0.84),(17,49,0.84),(18,49,0.84),(19,49,0.84),(20,49,0.84),(21,49,0.84),(1,49,0.84),(1,50,0.98),(2,50,0.98),(3,50,0.98),(4,50,0.98),(5,50,0.98),(6,50,0.98),(7,50,0.98),(8,50,0.98),(9,50,0.98),(10,50,0.98),(11,50,0.98),(12,50,0.98),(13,50,0.98),(14,50,0.98),(15,50,0.98),(16,50,0.98),(17,50,0.98),(18,50,0.98),(19,50,0.98),(20,50,0.98),(21,50,0.98),(1,51,1.77338),(2,51,1.77338),(3,51,1.77338),(4,51,1.77338),(5,51,1.77338),(6,51,1.77338),(7,51,1.77338),(8,51,1.77338),(9,51,1.77338),(10,51,1.77338),(11,51,1.77338),(12,51,1.77338),(13,51,1.77338),(14,51,1.77338),(15,51,1.77338),(16,51,1.77338),(17,51,1.77338),(18,51,1.77338),(19,51,1.77338),(20,51,1.77338),(21,51,1.77338),(1,52,1.07331),(2,52,1.07331),(3,52,1.07331),(4,52,1.07331),(5,52,1.07331),(6,52,1.07331),(7,52,1.07331),(8,52,1.07331),(9,52,1.07331),(10,52,1.07331),(11,52,1.07331),(12,52,1.07331),(13,52,1.07331),(14,52,1.07331),(15,52,1.07331),(16,52,1.07331),(17,52,1.07331),(18,52,1.07331),(19,52,1.07331),(20,52,1.07331),(21,52,1.07331),(1,73,0.37331),(2,73,0.37331),(3,73,0.37331),(4,73,0.37331),(5,73,0.37331),(6,73,0.37331),(7,73,0.37331),(8,73,0.37331),(9,73,0.37331),(10,73,0.37331),(11,73,0.37331),(12,73,0.37331),(13,73,0.37331),(14,73,0.37331),(15,73,0.37331),(16,73,0.37331),(17,73,0.37331),(18,73,0.37331),(19,73,0.37331),(20,73,0.37331),(21,73,0.37331),(1,74,1.00331),(2,74,1.00331),(3,74,1.00331),(4,74,1.00331),(5,74,1.00331),(6,74,1.00331),(7,74,1.00331),(8,74,1.00331),(9,74,1.00331),(10,74,1.00331),(11,74,1.00331),(12,74,1.00331),(13,74,1.00331),(14,74,1.00331),(15,74,1.00331),(16,74,1.00331),(17,74,1.00331),(18,74,1.00331),(19,74,1.00331),(20,74,1.00331),(21,74,1.00331),(1,75,1.09669),(2,75,1.09669),(3,75,1.09669),(4,75,1.09669),(5,75,1.09669),(6,75,1.09669),(7,75,1.09669),(8,75,1.09669),(9,75,1.09669),(10,75,1.09669),(11,75,1.09669),(12,75,1.09669),(13,75,1.09669),(14,75,1.09669),(15,75,1.09669),(16,75,1.09669),(17,75,1.09669),(18,75,1.09669),(19,75,1.09669),(20,75,1.09669),(21,75,1.09669),(1,76,0.84),(2,76,1.26),(3,76,1.26),(4,76,1.26),(5,76,1.26),(6,76,1.26),(7,76,1.26),(8,76,1.26),(9,76,1.26),(10,76,1.26),(11,76,1.26),(12,76,1.26),(13,76,1.26),(14,76,1.26),(15,76,1.26),(16,76,1.26),(17,76,1.26),(18,76,1.26),(19,76,1.26),(20,76,1.26),(21,76,1.26),(1,77,1.05),(2,77,1.05),(3,77,1.05),(4,77,1.05),(5,77,1.05),(6,77,1.05),(7,77,1.05),(8,77,1.05),(9,77,1.05),(10,77,1.05),(11,77,1.05),(12,77,1.05),(13,77,1.05),(14,77,1.05),(15,77,1.05),(16,77,1.05),(17,77,1.05),(18,77,1.05),(19,77,1.05),(20,77,1.05),(21,77,1.05),(1,78,1.19),(2,78,1.19),(3,78,1.19),(4,78,1.19),(5,78,1.19),(6,78,1.19),(7,78,1.19),(8,78,1.19),(9,78,1.19),(10,78,1.19),(11,78,1.19),(12,78,1.19),(13,78,1.19),(14,78,1.19),(15,78,1.19),(16,78,1.19),(17,78,1.19),(18,78,1.19),(19,78,1.19),(20,78,1.19),(21,78,1.19),(1,79,1.07331),(2,79,1.07331),(3,79,1.07331),(4,79,1.07331),(5,79,1.07331),(6,79,1.07331),(7,79,1.07331),(8,79,1.07331),(9,79,1.07331),(10,79,1.07331),(11,79,1.07331),(12,79,1.07331),(13,79,1.07331),(14,79,1.07331),(15,79,1.07331),(16,79,1.07331),(17,79,1.07331),(18,79,1.07331),(19,79,1.07331),(20,79,1.07331),(21,79,1.07331),(1,80,1.19),(2,80,1.19),(3,80,1.19),(4,80,1.19),(5,80,1.19),(6,80,1.19),(7,80,1.19),(8,80,1.19),(9,80,1.19),(10,80,1.19),(11,80,1.19),(12,80,1.19),(13,80,1.19),(14,80,1.19),(15,80,1.19),(16,80,1.19),(17,80,1.19),(18,80,1.19),(19,80,1.19),(20,80,1.19),(21,80,1.19),(1,81,0.32669),(2,81,0.65338),(3,81,0.65338),(4,81,0.65338),(5,81,0.65338),(6,81,0.65338),(7,81,0.65338),(8,81,0.65338),(9,81,0.65338),(10,81,0.65338),(11,81,0.65338),(12,81,0.65338),(13,81,0.65338),(14,81,0.65338),(15,81,0.65338),(16,81,0.65338),(17,81,0.65338),(18,81,0.65338),(19,81,0.65338),(20,81,0.65338),(21,81,0.65338),(1,82,0.98),(2,82,0.98),(3,82,0.98),(4,82,0.98),(5,82,0.98),(6,82,0.98),(7,82,0.98),(8,82,0.98),(9,82,0.98),(10,82,0.98),(11,82,0.98),(12,82,0.98),(13,82,0.98),(14,82,0.98),(15,82,0.98),(16,82,0.98),(17,82,0.98),(18,82,0.98),(19,82,0.98),(20,82,0.98),(21,82,0.98),(1,83,1.07331),(2,83,1.07331),(3,83,1.07331),(4,83,1.07331),(5,83,1.07331),(6,83,1.07331),(7,83,1.07331),(8,83,1.07331),(9,83,1.07331),(10,83,1.07331),(11,83,1.07331),(12,83,1.07331),(13,83,1.07331),(14,83,1.07331),(15,83,1.07331),(16,83,1.07331),(17,83,1.07331),(18,83,1.07331),(19,83,1.07331),(20,83,1.07331),(21,83,1.07331),(2,84,0.84),(3,84,0.84),(4,84,0.84),(5,84,0.84),(6,84,0.84),(7,84,0.84),(8,84,0.84),(9,84,0.84),(10,84,0.84),(11,84,0.84),(12,84,0.84),(13,84,0.84),(14,84,0.84),(15,84,0.84),(16,84,0.84),(17,84,0.84),(18,84,0.84),(19,84,0.84),(20,84,0.84),(21,84,0.84),(1,84,0.84),(1,85,1.02669),(2,85,1.02669),(3,85,1.02669),(4,85,1.02669),(5,85,1.02669),(6,85,1.02669),(7,85,1.02669),(8,85,1.02669),(9,85,1.02669),(10,85,1.02669),(11,85,1.02669),(12,85,1.02669),(13,85,1.02669),(14,85,1.02669),(15,85,1.02669),(16,85,1.02669),(17,85,1.02669),(18,85,1.02669),(19,85,1.02669),(20,85,1.02669),(21,85,1.02669),(1,86,1.19),(2,86,1.19),(3,86,1.19),(4,86,1.19),(5,86,1.19),(6,86,1.19),(7,86,1.19),(8,86,1.19),(9,86,1.19),(10,86,1.19),(11,86,1.19),(12,86,1.19),(13,86,1.19),(14,86,1.19),(15,86,1.19),(16,86,1.19),(17,86,1.19),(18,86,1.19),(19,86,1.19),(20,86,1.19),(21,86,1.19),(1,87,0.32669),(2,87,0.32669),(3,87,0.32669),(4,87,0.32669),(5,87,0.32669),(6,87,0.32669),(7,87,0.32669),(8,87,0.32669),(9,87,0.32669),(10,87,0.32669),(11,87,0.32669),(12,87,0.32669),(13,87,0.32669),(14,87,0.32669),(15,87,0.32669),(16,87,0.32669),(17,87,0.32669),(18,87,0.32669),(19,87,0.32669),(20,87,0.32669),(21,87,0.32669),(1,88,1.05),(2,88,1.05),(3,88,1.05),(4,88,1.05),(5,88,1.05),(6,88,1.05),(7,88,1.05),(8,88,1.05),(9,88,1.05),(10,88,1.05),(11,88,1.05),(12,88,1.05),(13,88,1.05),(14,88,1.05),(15,88,1.05),(16,88,1.05),(17,88,1.05),(18,88,1.05),(19,88,1.05),(20,88,1.05),(21,88,1.05),(1,89,1.21331),(2,89,1.21331),(3,89,1.21331),(4,89,1.21331),(5,89,1.21331),(6,89,1.21331),(7,89,1.21331),(8,89,1.21331),(9,89,1.21331),(10,89,1.21331),(11,89,1.21331),(12,89,1.21331),(13,89,1.21331),(14,89,1.21331),(15,89,1.21331),(16,89,1.21331),(17,89,1.21331),(18,89,1.21331),(19,89,1.21331),(20,89,1.21331),(21,89,1.21331),(16,90,0.74),(1,94,0.6666),(2,94,0.6666),(3,94,0.6666),(4,94,0.6666),(5,94,0.6666),(6,94,0.6666),(7,94,0.6666),(8,94,0.6666),(9,94,0.6666),(10,94,0.6666),(11,94,0.6666),(12,94,0.6666),(13,94,0.6666),(14,94,0.6666),(15,94,0.6666),(16,94,0.6666),(17,94,0.6666),(18,94,0.6666),(19,94,0.6666),(20,94,0.6666),(21,94,0.6666),(1,95,0.32004),(2,95,0.32004),(3,95,0.32004),(4,95,0.32004),(5,95,0.32004),(6,95,0.32004),(7,95,0.32004),(8,95,0.32004),(9,95,0.32004),(10,95,0.32004),(11,95,0.32004),(12,95,0.32004),(13,95,0.32004),(14,95,0.32004),(15,95,0.32004),(16,95,0.32004),(17,95,0.32004),(18,95,0.32004),(19,95,0.32004),(20,95,0.32004),(21,95,0.32004),(2,96,0.15996),(3,96,0.15996),(4,96,0.15996),(5,96,0.15996),(6,96,0.15996),(7,96,0.15996),(8,96,0.15996),(9,96,0.15996),(10,96,0.15996),(11,96,0.15996),(12,96,0.15996),(13,96,0.15996),(14,96,0.15996),(15,96,0.15996),(16,96,0.15996),(17,96,0.15996),(18,96,0.15996),(19,96,0.15996),(20,96,0.15996),(21,96,0.15996),(1,96,0.15996),(1,97,1.47996),(2,97,1.47996),(3,97,1.47996),(4,97,1.47996),(5,97,1.47996),(6,97,1.47996),(7,97,1.47996),(8,97,1.47996),(9,97,1.47996),(10,97,1.47996),(11,97,1.47996),(12,97,1.47996),(13,97,1.47996),(14,97,1.47996),(15,97,1.47996),(16,97,1.47996),(17,97,1.47996),(18,97,1.47996),(19,97,1.47996),(20,97,1.47996),(21,97,1.47996),(2,164,1.68),(3,164,1.68),(4,164,1.68),(5,164,1.68),(6,164,1.68),(7,164,1.68),(8,164,1.68),(9,164,1.68),(10,164,1.68),(11,164,1.68),(12,164,1.68),(13,164,1.68),(14,164,1.68),(15,164,1.68),(16,164,1.68),(17,164,1.68),(18,164,1.68),(19,164,1.68),(20,164,1.68),(21,164,1.68),(1,164,1.68),(1,165,1.14331),(2,165,1.14331),(3,165,1.14331),(4,165,1.14331),(5,165,1.14331),(6,165,1.14331),(7,165,1.14331),(8,165,1.14331),(9,165,1.14331),(10,165,1.14331),(11,165,1.14331),(12,165,1.14331),(13,165,1.14331),(14,165,1.14331),(15,165,1.14331),(16,165,1.14331),(17,165,1.14331),(18,165,1.14331),(19,165,1.14331),(20,165,1.14331),(21,165,1.14331),(1,166,1.23669),(2,166,1.23669),(3,166,1.23669),(4,166,1.23669),(5,166,1.23669),(6,166,1.23669),(7,166,1.23669),(8,166,1.23669),(9,166,1.23669),(10,166,1.23669),(11,166,1.23669),(12,166,1.23669),(13,166,1.23669),(14,166,1.23669),(15,166,1.23669),(16,166,1.23669),(17,166,1.23669),(18,166,1.23669),(19,166,1.23669),(20,166,1.23669),(21,166,1.23669),(1,167,0.37331),(2,167,0.37331),(3,167,0.37331),(4,167,0.37331),(5,167,0.37331),(6,167,0.37331),(7,167,0.37331),(8,167,0.37331),(9,167,0.37331),(10,167,0.37331),(11,167,0.37331),(12,167,0.37331),(13,167,0.37331),(14,167,0.37331),(15,167,0.37331),(16,167,0.37331),(17,167,0.37331),(18,167,0.37331),(19,167,0.37331),(20,167,0.37331),(21,167,0.37331),(1,168,1.02669),(2,168,1.02669),(3,168,1.02669),(4,168,1.02669),(5,168,1.02669),(6,168,1.02669),(7,168,1.02669),(8,168,1.02669),(9,168,1.02669),(10,168,1.02669),(11,168,1.02669),(12,168,1.02669),(13,168,1.02669),(14,168,1.02669),(15,168,1.02669),(16,168,1.02669),(17,168,1.02669),(18,168,1.02669),(19,168,1.02669),(20,168,1.02669),(21,168,1.02669),(1,169,1.16669),(2,169,1.16669),(3,169,1.16669),(4,169,1.16669),(5,169,1.16669),(6,169,1.16669),(7,169,1.16669),(8,169,1.16669),(9,169,1.16669),(10,169,1.16669),(11,169,1.16669),(12,169,1.16669),(13,169,1.16669),(14,169,1.16669),(15,169,1.16669),(16,169,1.16669),(17,169,1.16669),(18,169,1.16669),(19,169,1.16669),(20,169,1.16669),(21,169,1.16669),(1,170,0.69993),(2,170,0.69993),(3,170,0.69993),(4,170,0.69993),(5,170,0.69993),(6,170,0.69993),(7,170,0.69993),(8,170,0.69993),(9,170,0.69993),(10,170,0.69993),(11,170,0.69993),(12,170,0.69993),(13,170,0.69993),(14,170,0.69993),(15,170,0.69993),(16,170,0.69993),(17,170,0.69993),(18,170,0.69993),(19,170,0.69993),(20,170,0.69993),(21,170,0.69993),(1,171,1.00331),(2,171,1.00331),(3,171,1.00331),(4,171,1.00331),(5,171,1.00331),(6,171,1.00331),(7,171,1.00331),(8,171,1.00331),(9,171,1.00331),(10,171,1.00331),(11,171,1.00331),(12,171,1.00331),(13,171,1.00331),(14,171,1.00331),(15,171,1.00331),(16,171,1.00331),(17,171,1.00331),(18,171,1.00331),(19,171,1.00331),(20,171,1.00331),(21,171,1.00331),(1,172,1.19),(2,172,1.19),(3,172,1.19),(4,172,1.19),(5,172,1.19),(6,172,1.19),(7,172,1.19),(8,172,1.19),(9,172,1.19),(10,172,1.19),(11,172,1.19),(12,172,1.19),(13,172,1.19),(14,172,1.19),(15,172,1.19),(16,172,1.19),(17,172,1.19),(18,172,1.19),(19,172,1.19),(20,172,1.19),(21,172,1.19),(1,173,0.91),(2,173,0.91),(3,173,0.91),(4,173,0.91),(5,173,0.91),(6,173,0.91),(7,173,0.91),(8,173,0.91),(9,173,0.91),(10,173,0.91),(11,173,0.91),(12,173,0.91),(13,173,0.91),(14,173,0.91),(15,173,0.91),(16,173,0.91),(17,173,0.91),(18,173,0.91),(19,173,0.91),(20,173,0.91),(21,173,0.91),(1,174,1.14331),(2,174,1.14331),(3,174,1.14331),(4,174,1.14331),(5,174,1.14331),(6,174,1.14331),(7,174,1.14331),(8,174,1.14331),(9,174,1.14331),(10,174,1.14331),(11,174,1.14331),(12,174,1.14331),(13,174,1.14331),(14,174,1.14331),(15,174,1.14331),(16,174,1.14331),(17,174,1.14331),(18,174,1.14331),(19,174,1.14331),(20,174,1.14331),(21,174,1.14331),(1,175,0.65338),(2,175,1.30676),(3,175,1.30676),(4,175,1.30676),(5,175,1.30676),(6,175,1.30676),(7,175,1.30676),(8,175,1.30676),(9,175,1.30676),(10,175,1.30676),(11,175,1.30676),(12,175,1.30676),(13,175,1.30676),(14,175,1.30676),(15,175,1.30676),(16,175,1.30676),(17,175,1.30676),(18,175,1.30676),(19,175,1.30676),(20,175,1.30676),(21,175,1.30676),(1,176,1.14331),(2,176,1.14331),(3,176,1.14331),(4,176,1.14331),(5,176,1.14331),(6,176,1.14331),(7,176,1.14331),(8,176,1.14331),(9,176,1.14331),(10,176,1.14331),(11,176,1.14331),(12,176,1.14331),(13,176,1.14331),(14,176,1.14331),(15,176,1.14331),(16,176,1.14331),(17,176,1.14331),(18,176,1.14331),(19,176,1.14331),(20,176,1.14331),(21,176,1.14331),(1,177,1.23669),(2,177,1.23669),(3,177,1.23669),(4,177,1.23669),(5,177,1.23669),(6,177,1.23669),(7,177,1.23669),(8,177,1.23669),(9,177,1.23669),(10,177,1.23669),(11,177,1.23669),(12,177,1.23669),(13,177,1.23669),(14,177,1.23669),(15,177,1.23669),(16,177,1.23669),(17,177,1.23669),(18,177,1.23669),(19,177,1.23669),(20,177,1.23669),(21,177,1.23669),(1,178,0.46662),(2,178,0.46662),(3,178,0.46662),(4,178,0.46662),(5,178,0.46662),(6,178,0.46662),(7,178,0.46662),(8,178,0.46662),(9,178,0.46662),(10,178,0.46662),(11,178,0.46662),(12,178,0.46662),(13,178,0.46662),(14,178,0.46662),(15,178,0.46662),(16,178,0.46662),(17,178,0.46662),(18,178,0.46662),(19,178,0.46662),(20,178,0.46662),(21,178,0.46662),(1,179,1.82),(2,179,1.82),(3,179,1.82),(4,179,1.82),(5,179,1.82),(6,179,1.82),(7,179,1.82),(8,179,1.82),(9,179,1.82),(10,179,1.82),(11,179,1.82),(12,179,1.82),(13,179,1.82),(14,179,1.82),(15,179,1.82),(16,179,1.82),(17,179,1.82),(18,179,1.82),(19,179,1.82),(20,179,1.82),(21,179,1.82),(1,180,2.05338),(2,180,2.05338),(3,180,2.05338),(4,180,2.05338),(5,180,2.05338),(6,180,2.05338),(7,180,2.05338),(8,180,2.05338),(9,180,2.05338),(10,180,2.05338),(11,180,2.05338),(12,180,2.05338),(13,180,2.05338),(14,180,2.05338),(15,180,2.05338),(16,180,2.05338),(17,180,2.05338),(18,180,2.05338),(19,180,2.05338),(20,180,2.05338),(21,180,2.05338),(1,624,0.09331),(2,624,0.18662),(3,624,0.18662),(4,624,0.18662),(5,624,0.18662),(6,624,0.18662),(7,624,0.18662),(9,624,0.18662),(10,624,0.18662),(11,624,0.18662),(12,624,0.18662),(13,624,0.18662),(15,624,0.18662),(16,624,0.18662),(17,624,0.18662),(18,624,0.18662),(19,624,0.18662),(21,624,0.18662),(8,624,0.67983),(14,624,0.67983),(20,624,0.67983),(2,627,0.49321),(11,627,0.49321),(15,627,0.49321),(7,635,0.17),(6,635,0.37),(1,654,0.74),(16,654,0.74),(20,654,0.74),(16,811,1.97321),(16,812,5.05679),(16,813,5.92),(9,833,0.98679),(10,833,0.98679),(14,1116,4.56321),(1,1326,0.98679),(4,1550,1.48),(4,1551,4.93321),(4,1552,6.04321),(4,1555,0.4),(4,1556,2.6),(4,1557,2.8),(4,1558,1.23321),(4,1559,5.18),(4,1560,5.67321),(1,3140,0.28),(2,3140,0.28),(3,3140,0.28),(4,3140,0.28),(5,3140,0.28),(6,3140,0.28),(7,3140,0.28),(8,3140,0.28),(9,3140,0.28),(10,3140,0.28),(11,3140,0.28),(12,3140,0.28),(13,3140,0.28),(14,3140,0.28),(15,3140,0.28),(16,3140,0.28),(17,3140,0.28),(18,3140,0.28),(19,3140,0.28),(20,3140,0.28),(21,3140,0.28),(1,3141,1.05),(2,3141,1.05),(3,3141,1.05),(4,3141,1.05),(5,3141,1.05),(6,3141,1.05),(7,3141,1.05),(8,3141,1.05),(9,3141,1.05),(10,3141,1.05),(11,3141,1.05),(12,3141,1.05),(13,3141,1.05),(14,3141,1.05),(15,3141,1.05),(16,3141,1.05),(17,3141,1.05),(18,3141,1.05),(19,3141,1.05),(20,3141,1.05),(21,3141,1.05),(1,3142,1.35331),(2,3142,1.35331),(3,3142,1.35331),(4,3142,1.35331),(5,3142,1.35331),(6,3142,1.35331),(7,3142,1.35331),(8,3142,1.35331),(9,3142,1.35331),(10,3142,1.35331),(11,3142,1.35331),(12,3142,1.35331),(13,3142,1.35331),(14,3142,1.35331),(15,3142,1.35331),(16,3142,1.35331),(17,3142,1.35331),(18,3142,1.35331),(19,3142,1.35331),(20,3142,1.35331),(21,3142,1.35331),(1,3143,0.23331),(2,3143,0.46662),(3,3143,0.46662),(4,3143,0.46662),(5,3143,0.46662),(6,3143,0.46662),(7,3143,0.46662),(8,3143,0.46662),(9,3143,0.46662),(10,3143,0.46662),(11,3143,0.46662),(12,3143,0.46662),(13,3143,0.46662),(14,3143,0.46662),(15,3143,0.46662),(16,3143,0.46662),(17,3143,0.46662),(18,3143,0.46662),(19,3143,0.46662),(20,3143,0.46662),(21,3143,0.46662),(1,3144,1.00331),(2,3144,1.00331),(3,3144,1.00331),(4,3144,1.00331),(5,3144,1.00331),(6,3144,1.00331),(7,3144,1.00331),(8,3144,1.00331),(9,3144,1.00331),(10,3144,1.00331),(11,3144,1.00331),(12,3144,1.00331),(13,3144,1.00331),(14,3144,1.00331),(15,3144,1.00331),(16,3144,1.00331),(17,3144,1.00331),(18,3144,1.00331),(19,3144,1.00331),(20,3144,1.00331),(21,3144,1.00331),(1,3145,1.23669),(2,3145,1.23669),(3,3145,1.23669),(4,3145,1.23669),(5,3145,1.23669),(6,3145,1.23669),(7,3145,1.23669),(8,3145,1.23669),(9,3145,1.23669),(10,3145,1.23669),(11,3145,1.23669),(12,3145,1.23669),(13,3145,1.23669),(14,3145,1.23669),(15,3145,1.23669),(16,3145,1.23669),(17,3145,1.23669),(18,3145,1.23669),(19,3145,1.23669),(20,3145,1.23669),(21,3145,1.23669),(1,3146,0.95669),(2,3146,0.95669),(3,3146,0.95669),(4,3146,0.95669),(5,3146,0.95669),(6,3146,0.95669),(7,3146,0.95669),(8,3146,0.95669),(9,3146,0.95669),(10,3146,0.95669),(11,3146,0.95669),(12,3146,0.95669),(13,3146,0.95669),(14,3146,0.95669),(15,3146,0.95669),(16,3146,0.95669),(17,3146,0.95669),(18,3146,0.95669),(19,3146,0.95669),(20,3146,0.95669),(21,3146,0.95669),(1,3147,1.05),(2,3147,1.05),(3,3147,1.05),(4,3147,1.05),(5,3147,1.05),(6,3147,1.05),(7,3147,1.05),(8,3147,1.05),(9,3147,1.05),(10,3147,1.05),(11,3147,1.05),(12,3147,1.05),(13,3147,1.05),(14,3147,1.05),(15,3147,1.05),(16,3147,1.05),(17,3147,1.05),(18,3147,1.05),(19,3147,1.05),(20,3147,1.05),(21,3147,1.05),(1,3148,1.00331),(2,3148,1.00331),(3,3148,1.00331),(4,3148,1.00331),(5,3148,1.00331),(6,3148,1.00331),(7,3148,1.00331),(8,3148,1.00331),(9,3148,1.00331),(10,3148,1.00331),(11,3148,1.00331),(12,3148,1.00331),(13,3148,1.00331),(14,3148,1.00331),(15,3148,1.00331),(16,3148,1.00331),(17,3148,1.00331),(18,3148,1.00331),(19,3148,1.00331),(20,3148,1.00331),(21,3148,1.00331),(1,3149,1.09669),(2,3149,1.09669),(3,3149,1.09669),(4,3149,1.09669),(5,3149,1.09669),(6,3149,1.09669),(7,3149,1.09669),(8,3149,1.09669),(9,3149,1.09669),(10,3149,1.09669),(11,3149,1.09669),(12,3149,1.09669),(13,3149,1.09669),(14,3149,1.09669),(15,3149,1.09669),(16,3149,1.09669),(17,3149,1.09669),(18,3149,1.09669),(19,3149,1.09669),(20,3149,1.09669),(21,3149,1.09669),(1,3150,1.09669),(2,3150,1.09669),(3,3150,1.09669),(4,3150,1.09669),(5,3150,1.09669),(6,3150,1.09669),(7,3150,1.09669),(8,3150,1.09669),(9,3150,1.09669),(10,3150,1.09669),(11,3150,1.09669),(12,3150,1.09669),(13,3150,1.09669),(14,3150,1.09669),(15,3150,1.09669),(16,3150,1.09669),(17,3150,1.09669),(18,3150,1.09669),(19,3150,1.09669),(20,3150,1.09669),(21,3150,1.09669),(1,3151,1.00331),(2,3151,1.00331),(3,3151,1.00331),(4,3151,1.00331),(5,3151,1.00331),(6,3151,1.00331),(7,3151,1.00331),(8,3151,1.00331),(9,3151,1.00331),(10,3151,1.00331),(11,3151,1.00331),(12,3151,1.00331),(13,3151,1.00331),(14,3151,1.00331),(15,3151,1.00331),(16,3151,1.00331),(17,3151,1.00331),(18,3151,1.00331),(19,3151,1.00331),(20,3151,1.00331),(21,3151,1.00331),(1,3152,1.16669),(2,3152,1.16669),(3,3152,1.16669),(4,3152,1.16669),(5,3152,1.16669),(6,3152,1.16669),(7,3152,1.16669),(8,3152,1.16669),(9,3152,1.16669),(10,3152,1.16669),(11,3152,1.16669),(12,3152,1.16669),(13,3152,1.16669),(14,3152,1.16669),(15,3152,1.16669),(16,3152,1.16669),(17,3152,1.16669),(18,3152,1.16669),(19,3152,1.16669),(20,3152,1.16669),(21,3152,1.16669),(1,3164,4.31679),(1,3165,4.93321),(1,3166,1.14331),(2,3166,1.14331),(3,3166,1.14331),(4,3166,1.14331),(5,3166,1.14331),(6,3166,1.14331),(7,3166,1.14331),(8,3166,1.14331),(9,3166,1.14331),(10,3166,1.14331),(11,3166,1.14331),(12,3166,1.14331),(13,3166,1.14331),(14,3166,1.14331),(15,3166,1.14331),(16,3166,1.14331),(17,3166,1.14331),(18,3166,1.14331),(19,3166,1.14331),(20,3166,1.14331),(21,3166,1.14331),(2,3167,1.30669),(3,3167,1.30669),(4,3167,1.30669),(5,3167,1.30669),(6,3167,1.30669),(7,3167,1.30669),(8,3167,1.30669),(9,3167,1.30669),(10,3167,1.30669),(11,3167,1.30669),(12,3167,1.30669),(13,3167,1.30669),(14,3167,1.30669),(15,3167,1.30669),(16,3167,1.30669),(17,3167,1.30669),(18,3167,1.30669),(19,3167,1.30669),(20,3167,1.30669),(21,3167,1.30669),(1,3167,1.30669),(1,3168,0.91),(2,3168,0.91),(3,3168,0.91),(4,3168,0.91),(5,3168,0.91),(6,3168,0.91),(7,3168,0.91),(8,3168,0.91),(9,3168,0.91),(10,3168,0.91),(11,3168,0.91),(12,3168,0.91),(13,3168,0.91),(14,3168,0.91),(15,3168,0.91),(16,3168,0.91),(17,3168,0.91),(18,3168,0.91),(19,3168,0.91),(20,3168,0.91),(21,3168,0.91),(1,3169,1.07331),(2,3169,1.07331),(3,3169,1.07331),(4,3169,1.07331),(5,3169,1.07331),(6,3169,1.07331),(7,3169,1.07331),(8,3169,1.07331),(9,3169,1.07331),(10,3169,1.07331),(11,3169,1.07331),(12,3169,1.07331),(13,3169,1.07331),(14,3169,1.07331),(15,3169,1.07331),(16,3169,1.07331),(17,3169,1.07331),(18,3169,1.07331),(19,3169,1.07331),(20,3169,1.07331),(21,3169,1.07331),(1,3170,0.32669),(2,3170,0.65338),(3,3170,0.65338),(4,3170,0.65338),(5,3170,0.65338),(6,3170,0.65338),(7,3170,0.65338),(8,3170,0.65338),(9,3170,0.65338),(10,3170,0.65338),(11,3170,0.65338),(12,3170,0.65338),(13,3170,0.65338),(14,3170,0.65338),(15,3170,0.65338),(16,3170,0.65338),(17,3170,0.65338),(18,3170,0.65338),(19,3170,0.65338),(20,3170,0.65338),(21,3170,0.65338),(1,3171,0.98),(2,3171,0.98),(3,3171,0.98),(4,3171,0.98),(5,3171,0.98),(6,3171,0.98),(7,3171,0.98),(8,3171,0.98),(9,3171,0.98),(10,3171,0.98),(11,3171,0.98),(12,3171,0.98),(13,3171,0.98),(14,3171,0.98),(15,3171,0.98),(16,3171,0.98),(17,3171,0.98),(18,3171,0.98),(19,3171,0.98),(20,3171,0.98),(21,3171,0.98),(1,3172,1.14331),(2,3172,1.14331),(3,3172,1.14331),(4,3172,1.14331),(5,3172,1.14331),(6,3172,1.14331),(7,3172,1.14331),(8,3172,1.14331),(9,3172,1.14331),(10,3172,1.14331),(11,3172,1.14331),(12,3172,1.14331),(13,3172,1.14331),(14,3172,1.14331),(15,3172,1.14331),(16,3172,1.14331),(17,3172,1.14331),(18,3172,1.14331),(19,3172,1.14331),(20,3172,1.14331),(21,3172,1.14331),(1,3203,1.05),(2,3203,1.05),(3,3203,1.05),(4,3203,1.05),(5,3203,1.05),(6,3203,1.05),(7,3203,1.05),(8,3203,1.05),(9,3203,1.05),(10,3203,1.05),(11,3203,1.05),(12,3203,1.05),(13,3203,1.05),(14,3203,1.05),(15,3203,1.05),(16,3203,1.05),(17,3203,1.05),(18,3203,1.05),(19,3203,1.05),(20,3203,1.05),(21,3203,1.05),(1,3204,1.19),(2,3204,1.19),(3,3204,1.19),(4,3204,1.19),(5,3204,1.19),(6,3204,1.19),(7,3204,1.19),(8,3204,1.19),(9,3204,1.19),(10,3204,1.19),(11,3204,1.19),(12,3204,1.19),(13,3204,1.19),(14,3204,1.19),(15,3204,1.19),(16,3204,1.19),(17,3204,1.19),(18,3204,1.19),(19,3204,1.19),(20,3204,1.19),(21,3204,1.19),(1,3205,1.09669),(2,3205,1.09669),(3,3205,1.09669),(4,3205,1.09669),(5,3205,1.09669),(6,3205,1.09669),(7,3205,1.09669),(8,3205,1.09669),(9,3205,1.09669),(10,3205,1.09669),(11,3205,1.09669),(12,3205,1.09669),(13,3205,1.09669),(14,3205,1.09669),(15,3205,1.09669),(16,3205,1.09669),(17,3205,1.09669),(18,3205,1.09669),(19,3205,1.09669),(20,3205,1.09669),(21,3205,1.09669),(2,3206,1.30669),(3,3206,1.30669),(4,3206,1.30669),(5,3206,1.30669),(6,3206,1.30669),(7,3206,1.30669),(8,3206,1.30669),(9,3206,1.30669),(10,3206,1.30669),(11,3206,1.30669),(12,3206,1.30669),(13,3206,1.30669),(14,3206,1.30669),(15,3206,1.30669),(16,3206,1.30669),(17,3206,1.30669),(18,3206,1.30669),(19,3206,1.30669),(20,3206,1.30669),(21,3206,1.30669),(1,3206,1.30669),(2,3207,0.42),(3,3207,0.42),(4,3207,0.42),(5,3207,0.42),(6,3207,0.42),(7,3207,0.42),(8,3207,0.42),(9,3207,0.42),(10,3207,0.42),(11,3207,0.42),(12,3207,0.42),(13,3207,0.42),(14,3207,0.42),(15,3207,0.42),(16,3207,0.42),(17,3207,0.42),(18,3207,0.42),(19,3207,0.42),(20,3207,0.42),(21,3207,0.42),(1,3207,0.42),(1,3208,1.07331),(2,3208,1.07331),(3,3208,1.07331),(4,3208,1.07331),(5,3208,1.07331),(6,3208,1.07331),(7,3208,1.07331),(8,3208,1.07331),(9,3208,1.07331),(10,3208,1.07331),(11,3208,1.07331),(12,3208,1.07331),(13,3208,1.07331),(14,3208,1.07331),(15,3208,1.07331),(16,3208,1.07331),(17,3208,1.07331),(18,3208,1.07331),(19,3208,1.07331),(20,3208,1.07331),(21,3208,1.07331),(1,3209,1.28331),(2,3209,1.28331),(3,3209,1.28331),(4,3209,1.28331),(5,3209,1.28331),(6,3209,1.28331),(7,3209,1.28331),(8,3209,1.28331),(9,3209,1.28331),(10,3209,1.28331),(11,3209,1.28331),(12,3209,1.28331),(13,3209,1.28331),(14,3209,1.28331),(15,3209,1.28331),(16,3209,1.28331),(17,3209,1.28331),(18,3209,1.28331),(19,3209,1.28331),(20,3209,1.28331),(21,3209,1.28331),(1,3210,0.37331),(2,3210,0.37331),(3,3210,0.37331),(4,3210,0.37331),(5,3210,0.37331),(6,3210,0.37331),(7,3210,0.37331),(8,3210,0.37331),(9,3210,0.37331),(10,3210,0.37331),(11,3210,0.37331),(12,3210,0.37331),(13,3210,0.37331),(14,3210,0.37331),(15,3210,0.37331),(16,3210,0.37331),(17,3210,0.37331),(18,3210,0.37331),(19,3210,0.37331),(20,3210,0.37331),(21,3210,0.37331),(1,3211,1.19),(2,3211,1.19),(3,3211,1.19),(4,3211,1.19),(5,3211,1.19),(6,3211,1.19),(7,3211,1.19),(8,3211,1.19),(9,3211,1.19),(10,3211,1.19),(11,3211,1.19),(12,3211,1.19),(13,3211,1.19),(14,3211,1.19),(15,3211,1.19),(16,3211,1.19),(17,3211,1.19),(18,3211,1.19),(19,3211,1.19),(20,3211,1.19),(21,3211,1.19),(2,3212,1.30669),(3,3212,1.30669),(4,3212,1.30669),(5,3212,1.30669),(6,3212,1.30669),(7,3212,1.30669),(8,3212,1.30669),(9,3212,1.30669),(10,3212,1.30669),(11,3212,1.30669),(12,3212,1.30669),(13,3212,1.30669),(14,3212,1.30669),(15,3212,1.30669),(16,3212,1.30669),(17,3212,1.30669),(18,3212,1.30669),(19,3212,1.30669),(20,3212,1.30669),(21,3212,1.30669),(1,3212,1.30669),(1,3213,0.98),(2,3213,0.98),(3,3213,0.98),(4,3213,0.98),(5,3213,0.98),(6,3213,0.98),(7,3213,0.98),(8,3213,0.98),(9,3213,0.98),(10,3213,0.98),(11,3213,0.98),(12,3213,0.98),(13,3213,0.98),(14,3213,0.98),(15,3213,0.98),(16,3213,0.98),(17,3213,0.98),(18,3213,0.98),(19,3213,0.98),(20,3213,0.98),(21,3213,0.98),(1,3214,1.16669),(2,3214,1.16669),(3,3214,1.16669),(4,3214,1.16669),(5,3214,1.16669),(6,3214,1.16669),(7,3214,1.16669),(8,3214,1.16669),(9,3214,1.16669),(10,3214,1.16669),(11,3214,1.16669),(12,3214,1.16669),(13,3214,1.16669),(14,3214,1.16669),(15,3214,1.16669),(16,3214,1.16669),(17,3214,1.16669),(18,3214,1.16669),(19,3214,1.16669),(20,3214,1.16669),(21,3214,1.16669),(2,3215,0.42),(3,3215,0.42),(4,3215,0.42),(5,3215,0.42),(6,3215,0.42),(7,3215,0.42),(8,3215,0.42),(9,3215,0.42),(10,3215,0.42),(11,3215,0.42),(12,3215,0.42),(13,3215,0.42),(14,3215,0.42),(15,3215,0.42),(16,3215,0.42),(17,3215,0.42),(18,3215,0.42),(19,3215,0.42),(20,3215,0.42),(21,3215,0.42),(1,3215,0.42),(1,3216,1.00331),(2,3216,1.00331),(3,3216,1.00331),(4,3216,1.00331),(5,3216,1.00331),(6,3216,1.00331),(7,3216,1.00331),(8,3216,1.00331),(9,3216,1.00331),(10,3216,1.00331),(11,3216,1.00331),(12,3216,1.00331),(13,3216,1.00331),(14,3216,1.00331),(15,3216,1.00331),(16,3216,1.00331),(17,3216,1.00331),(18,3216,1.00331),(19,3216,1.00331),(20,3216,1.00331),(21,3216,1.00331),(1,3217,1.16669),(2,3217,1.16669),(3,3217,1.16669),(4,3217,1.16669),(5,3217,1.16669),(6,3217,1.16669),(7,3217,1.16669),(8,3217,1.16669),(9,3217,1.16669),(10,3217,1.16669),(11,3217,1.16669),(12,3217,1.16669),(13,3217,1.16669),(14,3217,1.16669),(15,3217,1.16669),(16,3217,1.16669),(17,3217,1.16669),(18,3217,1.16669),(19,3217,1.16669),(20,3217,1.16669),(21,3217,1.16669),(1,3218,1.00331),(2,3218,1.00331),(3,3218,1.00331),(4,3218,1.00331),(5,3218,1.00331),(6,3218,1.00331),(7,3218,1.00331),(8,3218,1.00331),(9,3218,1.00331),(10,3218,1.00331),(11,3218,1.00331),(12,3218,1.00331),(13,3218,1.00331),(14,3218,1.00331),(15,3218,1.00331),(16,3218,1.00331),(17,3218,1.00331),(18,3218,1.00331),(19,3218,1.00331),(20,3218,1.00331),(21,3218,1.00331),(1,3219,1.14331),(2,3219,1.14331),(3,3219,1.14331),(4,3219,1.14331),(5,3219,1.14331),(6,3219,1.14331),(7,3219,1.14331),(8,3219,1.14331),(9,3219,1.14331),(10,3219,1.14331),(11,3219,1.14331),(12,3219,1.14331),(13,3219,1.14331),(14,3219,1.14331),(15,3219,1.14331),(16,3219,1.14331),(17,3219,1.14331),(18,3219,1.14331),(19,3219,1.14331),(20,3219,1.14331),(21,3219,1.14331),(2,3408,1.97321),(16,3408,1.97321),(2,3409,5.05679),(2,3410,5.67321),(2,3411,0.91),(3,3411,0.91),(4,3411,0.91),(5,3411,0.91),(6,3411,0.91),(7,3411,0.91),(8,3411,0.91),(9,3411,0.91),(10,3411,0.91),(11,3411,0.91),(12,3411,0.91),(13,3411,0.91),(14,3411,0.91),(15,3411,0.91),(16,3411,0.91),(17,3411,0.91),(18,3411,0.91),(19,3411,0.91),(20,3411,0.91),(21,3411,0.91),(2,3412,1.07331),(3,3412,1.07331),(4,3412,1.07331),(5,3412,1.07331),(6,3412,1.07331),(7,3412,1.07331),(8,3412,1.07331),(9,3412,1.07331),(10,3412,1.07331),(11,3412,1.07331),(12,3412,1.07331),(13,3412,1.07331),(14,3412,1.07331),(15,3412,1.07331),(16,3412,1.07331),(17,3412,1.07331),(18,3412,1.07331),(19,3412,1.07331),(20,3412,1.07331),(21,3412,1.07331),(2,3413,1.00331),(3,3413,1.00331),(4,3413,1.00331),(5,3413,1.00331),(6,3413,1.00331),(7,3413,1.00331),(8,3413,1.00331),(9,3413,1.00331),(10,3413,1.00331),(11,3413,1.00331),(12,3413,1.00331),(13,3413,1.00331),(14,3413,1.00331),(15,3413,1.00331),(16,3413,1.00331),(17,3413,1.00331),(18,3413,1.00331),(19,3413,1.00331),(20,3413,1.00331),(21,3413,1.00331),(2,3414,1.23669),(3,3414,1.23669),(4,3414,1.23669),(5,3414,1.23669),(6,3414,1.23669),(7,3414,1.23669),(8,3414,1.23669),(9,3414,1.23669),(10,3414,1.23669),(11,3414,1.23669),(12,3414,1.23669),(13,3414,1.23669),(14,3414,1.23669),(15,3414,1.23669),(16,3414,1.23669),(17,3414,1.23669),(18,3414,1.23669),(19,3414,1.23669),(20,3414,1.23669),(21,3414,1.23669),(2,3415,0.91),(3,3415,0.91),(4,3415,0.91),(5,3415,0.91),(6,3415,0.91),(7,3415,0.91),(8,3415,0.91),(9,3415,0.91),(10,3415,0.91),(11,3415,0.91),(12,3415,0.91),(13,3415,0.91),(14,3415,0.91),(15,3415,0.91),(16,3415,0.91),(17,3415,0.91),(18,3415,0.91),(19,3415,0.91),(20,3415,0.91),(21,3415,0.91),(2,3416,1.05),(3,3416,1.05),(4,3416,1.05),(5,3416,1.05),(6,3416,1.05),(7,3416,1.05),(8,3416,1.05),(9,3416,1.05),(10,3416,1.05),(11,3416,1.05),(12,3416,1.05),(13,3416,1.05),(14,3416,1.05),(15,3416,1.05),(16,3416,1.05),(17,3416,1.05),(18,3416,1.05),(19,3416,1.05),(20,3416,1.05),(21,3416,1.05),(2,3417,1.05),(3,3417,1.05),(4,3417,1.05),(5,3417,1.05),(6,3417,1.05),(7,3417,1.05),(8,3417,1.05),(9,3417,1.05),(10,3417,1.05),(11,3417,1.05),(12,3417,1.05),(13,3417,1.05),(14,3417,1.05),(15,3417,1.05),(16,3417,1.05),(17,3417,1.05),(18,3417,1.05),(19,3417,1.05),(20,3417,1.05),(21,3417,1.05),(2,3418,1.19),(3,3418,1.19),(4,3418,1.19),(5,3418,1.19),(6,3418,1.19),(7,3418,1.19),(8,3418,1.19),(9,3418,1.19),(10,3418,1.19),(11,3418,1.19),(12,3418,1.19),(13,3418,1.19),(14,3418,1.19),(15,3418,1.19),(16,3418,1.19),(17,3418,1.19),(18,3418,1.19),(19,3418,1.19),(20,3418,1.19),(21,3418,1.19),(2,3419,1.02669),(3,3419,1.02669),(4,3419,1.02669),(5,3419,1.02669),(6,3419,1.02669),(7,3419,1.02669),(8,3419,1.02669),(9,3419,1.02669),(10,3419,1.02669),(11,3419,1.02669),(12,3419,1.02669),(13,3419,1.02669),(14,3419,1.02669),(15,3419,1.02669),(16,3419,1.02669),(17,3419,1.02669),(18,3419,1.02669),(19,3419,1.02669),(20,3419,1.02669),(21,3419,1.02669),(2,3420,1.21331),(3,3420,1.21331),(4,3420,1.21331),(5,3420,1.21331),(6,3420,1.21331),(7,3420,1.21331),(8,3420,1.21331),(9,3420,1.21331),(10,3420,1.21331),(11,3420,1.21331),(12,3420,1.21331),(13,3420,1.21331),(14,3420,1.21331),(15,3420,1.21331),(16,3420,1.21331),(17,3420,1.21331),(18,3420,1.21331),(19,3420,1.21331),(20,3420,1.21331),(21,3420,1.21331),(2,3421,1.00331),(3,3421,1.00331),(4,3421,1.00331),(5,3421,1.00331),(6,3421,1.00331),(7,3421,1.00331),(8,3421,1.00331),(9,3421,1.00331),(10,3421,1.00331),(11,3421,1.00331),(12,3421,1.00331),(13,3421,1.00331),(14,3421,1.00331),(15,3421,1.00331),(16,3421,1.00331),(17,3421,1.00331),(18,3421,1.00331),(19,3421,1.00331),(20,3421,1.00331),(21,3421,1.00331),(2,3422,1.21331),(3,3422,1.21331),(4,3422,1.21331),(5,3422,1.21331),(6,3422,1.21331),(7,3422,1.21331),(8,3422,1.21331),(9,3422,1.21331),(10,3422,1.21331),(11,3422,1.21331),(12,3422,1.21331),(13,3422,1.21331),(14,3422,1.21331),(15,3422,1.21331),(16,3422,1.21331),(17,3422,1.21331),(18,3422,1.21331),(19,3422,1.21331),(20,3422,1.21331),(21,3422,1.21331),(2,3423,0.95669),(3,3423,0.95669),(4,3423,0.95669),(5,3423,0.95669),(6,3423,0.95669),(7,3423,0.95669),(8,3423,0.95669),(9,3423,0.95669),(10,3423,0.95669),(11,3423,0.95669),(12,3423,0.95669),(13,3423,0.95669),(14,3423,0.95669),(15,3423,0.95669),(16,3423,0.95669),(17,3423,0.95669),(18,3423,0.95669),(19,3423,0.95669),(20,3423,0.95669),(21,3423,0.95669),(2,3424,0.93331),(3,3424,0.93331),(4,3424,0.93331),(5,3424,0.93331),(6,3424,0.93331),(7,3424,0.93331),(8,3424,0.93331),(9,3424,0.93331),(10,3424,0.93331),(11,3424,0.93331),(12,3424,0.93331),(13,3424,0.93331),(14,3424,0.93331),(15,3424,0.93331),(16,3424,0.93331),(17,3424,0.93331),(18,3424,0.93331),(19,3424,0.93331),(20,3424,0.93331),(21,3424,0.93331),(2,3425,1.07331),(3,3425,1.07331),(4,3425,1.07331),(5,3425,1.07331),(6,3425,1.07331),(7,3425,1.07331),(8,3425,1.07331),(9,3425,1.07331),(10,3425,1.07331),(11,3425,1.07331),(12,3425,1.07331),(13,3425,1.07331),(14,3425,1.07331),(15,3425,1.07331),(16,3425,1.07331),(17,3425,1.07331),(18,3425,1.07331),(19,3425,1.07331),(20,3425,1.07331),(21,3425,1.07331),(2,3449,0.46662),(3,3449,0.46662),(4,3449,0.46662),(5,3449,0.46662),(6,3449,0.46662),(7,3449,0.46662),(8,3449,0.46662),(9,3449,0.46662),(10,3449,0.46662),(11,3449,0.46662),(12,3449,0.46662),(13,3449,0.46662),(14,3449,0.46662),(15,3449,0.46662),(16,3449,0.46662),(17,3449,0.46662),(18,3449,0.46662),(19,3449,0.46662),(20,3449,0.46662),(21,3449,0.46662),(2,3450,1.05),(3,3450,1.05),(4,3450,1.05),(5,3450,1.05),(6,3450,1.05),(7,3450,1.05),(8,3450,1.05),(9,3450,1.05),(10,3450,1.05),(11,3450,1.05),(12,3450,1.05),(13,3450,1.05),(14,3450,1.05),(15,3450,1.05),(16,3450,1.05),(17,3450,1.05),(18,3450,1.05),(19,3450,1.05),(20,3450,1.05),(21,3450,1.05),(2,3451,1.23669),(3,3451,1.23669),(4,3451,1.23669),(5,3451,1.23669),(6,3451,1.23669),(7,3451,1.23669),(8,3451,1.23669),(9,3451,1.23669),(10,3451,1.23669),(11,3451,1.23669),(12,3451,1.23669),(13,3451,1.23669),(14,3451,1.23669),(15,3451,1.23669),(16,3451,1.23669),(17,3451,1.23669),(18,3451,1.23669),(19,3451,1.23669),(20,3451,1.23669),(21,3451,1.23669),(2,3452,0.88669),(3,3452,0.88669),(4,3452,0.88669),(5,3452,0.88669),(6,3452,0.88669),(7,3452,0.88669),(8,3452,0.88669),(9,3452,0.88669),(10,3452,0.88669),(11,3452,0.88669),(12,3452,0.88669),(13,3452,0.88669),(14,3452,0.88669),(15,3452,0.88669),(16,3452,0.88669),(17,3452,0.88669),(18,3452,0.88669),(19,3452,0.88669),(20,3452,0.88669),(21,3452,0.88669),(2,3453,1.00331),(3,3453,1.00331),(4,3453,1.00331),(5,3453,1.00331),(6,3453,1.00331),(7,3453,1.00331),(8,3453,1.00331),(9,3453,1.00331),(10,3453,1.00331),(11,3453,1.00331),(12,3453,1.00331),(13,3453,1.00331),(14,3453,1.00331),(15,3453,1.00331),(16,3453,1.00331),(17,3453,1.00331),(18,3453,1.00331),(19,3453,1.00331),(20,3453,1.00331),(21,3453,1.00331),(2,3454,1.05),(3,3454,1.05),(4,3454,1.05),(5,3454,1.05),(6,3454,1.05),(7,3454,1.05),(8,3454,1.05),(9,3454,1.05),(10,3454,1.05),(11,3454,1.05),(12,3454,1.05),(13,3454,1.05),(14,3454,1.05),(15,3454,1.05),(16,3454,1.05),(17,3454,1.05),(18,3454,1.05),(19,3454,1.05),(20,3454,1.05),(21,3454,1.05),(2,3455,1.14331),(3,3455,1.14331),(4,3455,1.14331),(5,3455,1.14331),(6,3455,1.14331),(7,3455,1.14331),(8,3455,1.14331),(9,3455,1.14331),(10,3455,1.14331),(11,3455,1.14331),(12,3455,1.14331),(13,3455,1.14331),(14,3455,1.14331),(15,3455,1.14331),(16,3455,1.14331),(17,3455,1.14331),(18,3455,1.14331),(19,3455,1.14331),(20,3455,1.14331),(21,3455,1.14331),(2,3456,1.00331),(3,3456,1.00331),(4,3456,1.00331),(5,3456,1.00331),(6,3456,1.00331),(7,3456,1.00331),(8,3456,1.00331),(9,3456,1.00331),(10,3456,1.00331),(11,3456,1.00331),(12,3456,1.00331),(13,3456,1.00331),(14,3456,1.00331),(15,3456,1.00331),(16,3456,1.00331),(17,3456,1.00331),(18,3456,1.00331),(19,3456,1.00331),(20,3456,1.00331),(21,3456,1.00331),(2,3457,1.19),(3,3457,1.19),(4,3457,1.19),(5,3457,1.19),(6,3457,1.19),(7,3457,1.19),(8,3457,1.19),(9,3457,1.19),(10,3457,1.19),(11,3457,1.19),(12,3457,1.19),(13,3457,1.19),(14,3457,1.19),(15,3457,1.19),(16,3457,1.19),(17,3457,1.19),(18,3457,1.19),(19,3457,1.19),(20,3457,1.19),(21,3457,1.19),(2,3463,0.09331),(3,3463,0.09331),(4,3463,0.09331),(5,3463,0.09331),(6,3463,0.09331),(7,3463,0.09331),(8,3463,0.09331),(9,3463,0.09331),(10,3463,0.09331),(11,3463,0.09331),(12,3463,0.09331),(13,3463,0.09331),(14,3463,0.09331),(15,3463,0.09331),(16,3463,0.09331),(17,3463,0.09331),(18,3463,0.09331),(19,3463,0.09331),(20,3463,0.09331),(21,3463,0.09331),(2,3464,0.95669),(3,3464,0.95669),(4,3464,0.95669),(5,3464,0.95669),(6,3464,0.95669),(7,3464,0.95669),(8,3464,0.95669),(9,3464,0.95669),(10,3464,0.95669),(11,3464,0.95669),(12,3464,0.95669),(13,3464,0.95669),(14,3464,0.95669),(15,3464,0.95669),(16,3464,0.95669),(17,3464,0.95669),(18,3464,0.95669),(19,3464,0.95669),(20,3464,0.95669),(21,3464,0.95669),(2,3465,1.05),(3,3465,1.05),(4,3465,1.05),(5,3465,1.05),(6,3465,1.05),(7,3465,1.05),(8,3465,1.05),(9,3465,1.05),(10,3465,1.05),(11,3465,1.05),(12,3465,1.05),(13,3465,1.05),(14,3465,1.05),(15,3465,1.05),(16,3465,1.05),(17,3465,1.05),(18,3465,1.05),(19,3465,1.05),(20,3465,1.05),(21,3465,1.05),(2,3466,0.93331),(3,3466,0.93331),(4,3466,0.93331),(5,3466,0.93331),(6,3466,0.93331),(7,3466,0.93331),(8,3466,0.93331),(9,3466,0.93331),(10,3466,0.93331),(11,3466,0.93331),(12,3466,0.93331),(13,3466,0.93331),(14,3466,0.93331),(15,3466,0.93331),(16,3466,0.93331),(17,3466,0.93331),(18,3466,0.93331),(19,3466,0.93331),(20,3466,0.93331),(21,3466,0.93331),(2,3467,1.07331),(3,3467,1.07331),(4,3467,1.07331),(5,3467,1.07331),(6,3467,1.07331),(7,3467,1.07331),(8,3467,1.07331),(9,3467,1.07331),(10,3467,1.07331),(11,3467,1.07331),(12,3467,1.07331),(13,3467,1.07331),(14,3467,1.07331),(15,3467,1.07331),(16,3467,1.07331),(17,3467,1.07331),(18,3467,1.07331),(19,3467,1.07331),(20,3467,1.07331),(21,3467,1.07331),(2,3468,0.93331),(3,3468,0.93331),(4,3468,0.93331),(5,3468,0.93331),(6,3468,0.93331),(7,3468,0.93331),(8,3468,0.93331),(9,3468,0.93331),(10,3468,0.93331),(11,3468,0.93331),(12,3468,0.93331),(13,3468,0.93331),(14,3468,0.93331),(15,3468,0.93331),(16,3468,0.93331),(17,3468,0.93331),(18,3468,0.93331),(19,3468,0.93331),(20,3468,0.93331),(21,3468,0.93331),(2,3469,1.07331),(3,3469,1.07331),(4,3469,1.07331),(5,3469,1.07331),(6,3469,1.07331),(7,3469,1.07331),(8,3469,1.07331),(9,3469,1.07331),(10,3469,1.07331),(11,3469,1.07331),(12,3469,1.07331),(13,3469,1.07331),(14,3469,1.07331),(15,3469,1.07331),(16,3469,1.07331),(17,3469,1.07331),(18,3469,1.07331),(19,3469,1.07331),(20,3469,1.07331),(21,3469,1.07331),(2,3470,4.19321),(2,3471,5.67321),(2,3527,1.02669),(3,3527,1.02669),(4,3527,1.02669),(5,3527,1.02669),(6,3527,1.02669),(7,3527,1.02669),(8,3527,1.02669),(9,3527,1.02669),(10,3527,1.02669),(11,3527,1.02669),(12,3527,1.02669),(13,3527,1.02669),(14,3527,1.02669),(15,3527,1.02669),(16,3527,1.02669),(17,3527,1.02669),(18,3527,1.02669),(19,3527,1.02669),(20,3527,1.02669),(21,3527,1.02669),(2,3528,1.09669),(3,3528,1.09669),(4,3528,1.09669),(5,3528,1.09669),(6,3528,1.09669),(7,3528,1.09669),(8,3528,1.09669),(9,3528,1.09669),(10,3528,1.09669),(11,3528,1.09669),(12,3528,1.09669),(13,3528,1.09669),(14,3528,1.09669),(15,3528,1.09669),(16,3528,1.09669),(17,3528,1.09669),(18,3528,1.09669),(19,3528,1.09669),(20,3528,1.09669),(21,3528,1.09669),(2,3529,0.95669),(3,3529,0.95669),(4,3529,0.95669),(5,3529,0.95669),(6,3529,0.95669),(7,3529,0.95669),(8,3529,0.95669),(9,3529,0.95669),(10,3529,0.95669),(11,3529,0.95669),(12,3529,0.95669),(13,3529,0.95669),(14,3529,0.95669),(15,3529,0.95669),(16,3529,0.95669),(17,3529,0.95669),(18,3529,0.95669),(19,3529,0.95669),(20,3529,0.95669),(21,3529,0.95669),(2,3530,1.02669),(3,3530,1.02669),(4,3530,1.02669),(5,3530,1.02669),(6,3530,1.02669),(7,3530,1.02669),(8,3530,1.02669),(9,3530,1.02669),(10,3530,1.02669),(11,3530,1.02669),(12,3530,1.02669),(13,3530,1.02669),(14,3530,1.02669),(15,3530,1.02669),(16,3530,1.02669),(17,3530,1.02669),(18,3530,1.02669),(19,3530,1.02669),(20,3530,1.02669),(21,3530,1.02669),(3,3620,0.74),(11,3620,0.74),(3,3621,4.81),(3,3622,5.30321),(5,3650,0.98679),(5,3651,4.56321),(5,3652,5.30321),(6,3677,4.68679),(6,3678,4.93321),(6,3693,0.98679),(6,3694,5.18),(6,3695,5.79679),(7,3730,0.98679),(21,3730,0.98679),(7,3731,4.44),(21,3731,4.44),(8,3777,4.56321),(8,3778,5.18),(8,3784,0.74),(8,3785,4.56321),(8,3786,5.55),(9,3810,0.5334),(9,3811,2.4),(9,3812,2.6666),(9,3813,0.68),(9,3814,2.26661),(9,3815,2.43661),(9,3816,1.72679),(13,3816,1.72679),(21,3816,1.72679),(9,3817,0.98679),(9,3818,4.56321),(9,3819,5.05679),(9,3820,4.56321),(9,3821,5.79679),(10,3866,4.81),(10,3871,1.0666),(10,3872,2.8666),(10,3873,3.2),(11,3934,1.48),(11,3935,5.05679),(11,3936,6.04321),(11,3937,2.46679),(11,3938,5.30321),(11,3939,5.79679),(11,3940,2.22),(11,3941,5.30321),(11,3942,5.67321),(11,3943,4.93321),(11,3944,5.55),(12,3968,1.72679),(12,3969,4.81),(12,3970,5.55),(13,4004,5.18),(13,4005,3),(13,4006,2.66339),(14,4063,1.23321),(14,4064,4.56321),(14,4065,4.93321),(15,4089,4.56321),(15,4090,5.18),(16,4115,5.18),(16,4116,6.04321),(16,4117,4.93321),(16,4118,6.04321),(16,4124,5.18),(16,4125,5.67321),(17,4134,1.97321),(17,4135,5.55),(17,4136,6.90679),(17,4137,1.48),(17,4138,4.68679),(17,4139,5.79679),(17,4140,0.2666),(17,4141,2.2666),(17,4142,2.4666),(17,4143,0.45339),(17,4144,2.09661),(17,4145,2.38),(18,4203,2.71321),(18,4204,6.53679),(18,4205,6.90679),(19,4235,0.5334),(19,4236,2.6),(19,4237,3.1334),(19,4238,1.02),(19,4239,2.66339),(20,4255,0.4),(20,4256,2.4666),(20,4257,2.7334),(20,4258,0.79339),(20,4259,2.32339),(20,4260,2.49339),(20,4265,4.68679),(20,4266,5.05679),(20,4269,4.68679),(20,4270,5.42679),(20,4271,0.5334),(20,4272,2.5334),(20,4273,2.7334),(20,4274,1.23321),(20,4278,0.74),(20,4279,4.31679),(20,4280,2.5334),(20,4281,2.43661),(21,4328,5.05679),(1,4336,1.39986),(1,4337,4.78345),(1,4338,5.48345);


--
-- Table structure for table `#__finder_links_terms9`
--



CREATE TABLE `#__finder_links_terms9` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms9`
--


INSERT INTO `#__finder_links_terms9` (`link_id`, `term_id`, `weight`) VALUES (1,232,0.28),(2,232,0.7),(3,232,0.7),(4,232,0.7),(5,232,0.7),(6,232,0.7),(7,232,0.7),(8,232,0.7),(9,232,0.7),(10,232,0.7),(11,232,0.7),(12,232,0.7),(13,232,0.7),(14,232,0.7),(15,232,0.7),(16,232,0.7),(17,232,0.7),(18,232,0.7),(19,232,0.7),(20,232,0.7),(21,232,0.7),(2,233,1.68),(3,233,1.68),(4,233,1.68),(5,233,1.68),(6,233,1.68),(7,233,1.68),(8,233,1.68),(9,233,1.68),(10,233,1.68),(11,233,1.68),(12,233,1.68),(13,233,1.68),(14,233,1.68),(15,233,1.68),(16,233,1.68),(17,233,1.68),(18,233,1.68),(19,233,1.68),(20,233,1.68),(21,233,1.68),(1,233,1.68),(1,234,1.86662),(2,234,1.86662),(3,234,1.86662),(4,234,1.86662),(5,234,1.86662),(6,234,1.86662),(7,234,1.86662),(8,234,1.86662),(9,234,1.86662),(10,234,1.86662),(11,234,1.86662),(12,234,1.86662),(13,234,1.86662),(14,234,1.86662),(15,234,1.86662),(16,234,1.86662),(17,234,1.86662),(18,234,1.86662),(19,234,1.86662),(20,234,1.86662),(21,234,1.86662),(1,235,0.46662),(2,235,0.93324),(3,235,0.93324),(4,235,0.93324),(5,235,0.93324),(6,235,0.93324),(7,235,0.93324),(8,235,0.93324),(9,235,0.93324),(10,235,0.93324),(11,235,0.93324),(12,235,0.93324),(13,235,0.93324),(14,235,0.93324),(15,235,0.93324),(16,235,0.93324),(17,235,0.93324),(18,235,0.93324),(19,235,0.93324),(20,235,0.93324),(21,235,0.93324),(1,236,0.98),(2,236,0.98),(3,236,0.98),(4,236,0.98),(5,236,0.98),(6,236,0.98),(7,236,0.98),(8,236,0.98),(9,236,0.98),(10,236,0.98),(11,236,0.98),(12,236,0.98),(13,236,0.98),(14,236,0.98),(15,236,0.98),(16,236,0.98),(17,236,0.98),(18,236,0.98),(19,236,0.98),(20,236,0.98),(21,236,0.98),(1,237,1.12),(2,237,1.12),(3,237,1.12),(4,237,1.12),(5,237,1.12),(6,237,1.12),(7,237,1.12),(8,237,1.12),(9,237,1.12),(10,237,1.12),(11,237,1.12),(12,237,1.12),(13,237,1.12),(14,237,1.12),(15,237,1.12),(16,237,1.12),(17,237,1.12),(18,237,1.12),(19,237,1.12),(20,237,1.12),(21,237,1.12),(1,238,0.95669),(2,238,0.95669),(3,238,0.95669),(4,238,0.95669),(5,238,0.95669),(6,238,0.95669),(7,238,0.95669),(8,238,0.95669),(9,238,0.95669),(10,238,0.95669),(11,238,0.95669),(12,238,0.95669),(13,238,0.95669),(14,238,0.95669),(15,238,0.95669),(16,238,0.95669),(17,238,0.95669),(18,238,0.95669),(19,238,0.95669),(20,238,0.95669),(21,238,0.95669),(1,239,1.07331),(2,239,1.07331),(3,239,1.07331),(4,239,1.07331),(5,239,1.07331),(6,239,1.07331),(7,239,1.07331),(8,239,1.07331),(9,239,1.07331),(10,239,1.07331),(11,239,1.07331),(12,239,1.07331),(13,239,1.07331),(14,239,1.07331),(15,239,1.07331),(16,239,1.07331),(17,239,1.07331),(18,239,1.07331),(19,239,1.07331),(20,239,1.07331),(21,239,1.07331),(1,240,0.84),(2,240,1.26),(3,240,1.26),(4,240,1.26),(5,240,1.26),(6,240,1.26),(7,240,1.26),(8,240,1.26),(9,240,1.26),(10,240,1.26),(11,240,1.26),(12,240,1.26),(13,240,1.26),(14,240,1.26),(15,240,1.26),(16,240,1.26),(17,240,1.26),(18,240,1.26),(19,240,1.26),(20,240,1.26),(21,240,1.26),(1,241,1.16669),(2,241,1.16669),(3,241,1.16669),(4,241,1.16669),(5,241,1.16669),(6,241,1.16669),(7,241,1.16669),(8,241,1.16669),(9,241,1.16669),(10,241,1.16669),(11,241,1.16669),(12,241,1.16669),(13,241,1.16669),(14,241,1.16669),(15,241,1.16669),(16,241,1.16669),(17,241,1.16669),(18,241,1.16669),(19,241,1.16669),(20,241,1.16669),(21,241,1.16669),(1,242,1.26),(2,242,1.26),(3,242,1.26),(4,242,1.26),(5,242,1.26),(6,242,1.26),(7,242,1.26),(8,242,1.26),(9,242,1.26),(10,242,1.26),(11,242,1.26),(12,242,1.26),(13,242,1.26),(14,242,1.26),(15,242,1.26),(16,242,1.26),(17,242,1.26),(18,242,1.26),(19,242,1.26),(20,242,1.26),(21,242,1.26),(1,243,0.93338),(2,243,1.40007),(3,243,1.40007),(4,243,1.40007),(5,243,1.40007),(6,243,1.40007),(7,243,1.40007),(8,243,1.40007),(9,243,1.40007),(10,243,1.40007),(11,243,1.40007),(12,243,1.40007),(13,243,1.40007),(14,243,1.40007),(15,243,1.40007),(16,243,1.40007),(17,243,1.40007),(18,243,1.40007),(19,243,1.40007),(20,243,1.40007),(21,243,1.40007),(1,244,1.02669),(2,244,1.02669),(3,244,1.02669),(4,244,1.02669),(5,244,1.02669),(6,244,1.02669),(7,244,1.02669),(8,244,1.02669),(9,244,1.02669),(10,244,1.02669),(11,244,1.02669),(12,244,1.02669),(13,244,1.02669),(14,244,1.02669),(15,244,1.02669),(16,244,1.02669),(17,244,1.02669),(18,244,1.02669),(19,244,1.02669),(20,244,1.02669),(21,244,1.02669),(1,245,1.21331),(2,245,1.21331),(3,245,1.21331),(4,245,1.21331),(5,245,1.21331),(6,245,1.21331),(7,245,1.21331),(8,245,1.21331),(9,245,1.21331),(10,245,1.21331),(11,245,1.21331),(12,245,1.21331),(13,245,1.21331),(14,245,1.21331),(15,245,1.21331),(16,245,1.21331),(17,245,1.21331),(18,245,1.21331),(19,245,1.21331),(20,245,1.21331),(21,245,1.21331),(1,246,1.07331),(2,246,1.07331),(3,246,1.07331),(4,246,1.07331),(5,246,1.07331),(6,246,1.07331),(7,246,1.07331),(8,246,1.07331),(9,246,1.07331),(10,246,1.07331),(11,246,1.07331),(12,246,1.07331),(13,246,1.07331),(14,246,1.07331),(15,246,1.07331),(16,246,1.07331),(17,246,1.07331),(18,246,1.07331),(19,246,1.07331),(20,246,1.07331),(21,246,1.07331),(1,247,1.19),(2,247,1.19),(3,247,1.19),(4,247,1.19),(5,247,1.19),(6,247,1.19),(7,247,1.19),(8,247,1.19),(9,247,1.19),(10,247,1.19),(11,247,1.19),(12,247,1.19),(13,247,1.19),(14,247,1.19),(15,247,1.19),(16,247,1.19),(17,247,1.19),(18,247,1.19),(19,247,1.19),(20,247,1.19),(21,247,1.19),(1,248,1.63317),(2,248,1.86648),(3,248,1.86648),(4,248,1.86648),(5,248,1.86648),(6,248,1.86648),(7,248,1.86648),(8,248,1.86648),(9,248,1.86648),(10,248,1.86648),(11,248,1.86648),(12,248,1.86648),(13,248,1.86648),(14,248,1.86648),(15,248,1.86648),(16,248,1.86648),(17,248,1.86648),(18,248,1.86648),(19,248,1.86648),(20,248,1.86648),(21,248,1.86648),(1,249,0.95669),(2,249,0.95669),(3,249,0.95669),(4,249,0.95669),(5,249,0.95669),(6,249,0.95669),(7,249,0.95669),(8,249,0.95669),(9,249,0.95669),(10,249,0.95669),(11,249,0.95669),(12,249,0.95669),(13,249,0.95669),(14,249,0.95669),(15,249,0.95669),(16,249,0.95669),(17,249,0.95669),(18,249,0.95669),(19,249,0.95669),(20,249,0.95669),(21,249,0.95669),(1,250,1.16669),(2,250,1.16669),(3,250,1.16669),(4,250,1.16669),(5,250,1.16669),(6,250,1.16669),(7,250,1.16669),(8,250,1.16669),(9,250,1.16669),(10,250,1.16669),(11,250,1.16669),(12,250,1.16669),(13,250,1.16669),(14,250,1.16669),(15,250,1.16669),(16,250,1.16669),(17,250,1.16669),(18,250,1.16669),(19,250,1.16669),(20,250,1.16669),(21,250,1.16669),(1,251,0.93331),(2,251,0.93331),(3,251,0.93331),(4,251,0.93331),(5,251,0.93331),(6,251,0.93331),(7,251,0.93331),(8,251,0.93331),(9,251,0.93331),(10,251,0.93331),(11,251,0.93331),(12,251,0.93331),(13,251,0.93331),(14,251,0.93331),(15,251,0.93331),(16,251,0.93331),(17,251,0.93331),(18,251,0.93331),(19,251,0.93331),(20,251,0.93331),(21,251,0.93331),(1,252,1.07331),(2,252,1.07331),(3,252,1.07331),(4,252,1.07331),(5,252,1.07331),(6,252,1.07331),(7,252,1.07331),(8,252,1.07331),(9,252,1.07331),(10,252,1.07331),(11,252,1.07331),(12,252,1.07331),(13,252,1.07331),(14,252,1.07331),(15,252,1.07331),(16,252,1.07331),(17,252,1.07331),(18,252,1.07331),(19,252,1.07331),(20,252,1.07331),(21,252,1.07331),(1,253,1.86662),(2,253,1.86662),(3,253,1.86662),(4,253,1.86662),(5,253,1.86662),(6,253,1.86662),(7,253,1.86662),(8,253,1.86662),(9,253,1.86662),(10,253,1.86662),(11,253,1.86662),(12,253,1.86662),(13,253,1.86662),(14,253,1.86662),(15,253,1.86662),(16,253,1.86662),(17,253,1.86662),(18,253,1.86662),(19,253,1.86662),(20,253,1.86662),(21,253,1.86662),(1,254,1.07331),(2,254,1.07331),(3,254,1.07331),(4,254,1.07331),(5,254,1.07331),(6,254,1.07331),(7,254,1.07331),(8,254,1.07331),(9,254,1.07331),(10,254,1.07331),(11,254,1.07331),(12,254,1.07331),(13,254,1.07331),(14,254,1.07331),(15,254,1.07331),(16,254,1.07331),(17,254,1.07331),(18,254,1.07331),(19,254,1.07331),(20,254,1.07331),(21,254,1.07331),(1,255,1.21331),(2,255,1.21331),(3,255,1.21331),(4,255,1.21331),(5,255,1.21331),(6,255,1.21331),(7,255,1.21331),(8,255,1.21331),(9,255,1.21331),(10,255,1.21331),(11,255,1.21331),(12,255,1.21331),(13,255,1.21331),(14,255,1.21331),(15,255,1.21331),(16,255,1.21331),(17,255,1.21331),(18,255,1.21331),(19,255,1.21331),(20,255,1.21331),(21,255,1.21331),(1,256,1.02669),(2,256,1.02669),(3,256,1.02669),(4,256,1.02669),(5,256,1.02669),(6,256,1.02669),(7,256,1.02669),(8,256,1.02669),(9,256,1.02669),(10,256,1.02669),(11,256,1.02669),(12,256,1.02669),(13,256,1.02669),(14,256,1.02669),(15,256,1.02669),(16,256,1.02669),(17,256,1.02669),(18,256,1.02669),(19,256,1.02669),(20,256,1.02669),(21,256,1.02669),(1,257,1.16669),(2,257,1.16669),(3,257,1.16669),(4,257,1.16669),(5,257,1.16669),(6,257,1.16669),(7,257,1.16669),(8,257,1.16669),(9,257,1.16669),(10,257,1.16669),(11,257,1.16669),(12,257,1.16669),(13,257,1.16669),(14,257,1.16669),(15,257,1.16669),(16,257,1.16669),(17,257,1.16669),(18,257,1.16669),(19,257,1.16669),(20,257,1.16669),(21,257,1.16669),(1,258,0.37331),(2,258,0.37331),(3,258,0.37331),(4,258,0.37331),(5,258,0.37331),(6,258,0.37331),(7,258,0.37331),(8,258,0.37331),(9,258,0.37331),(10,258,0.37331),(11,258,0.37331),(12,258,0.37331),(13,258,0.37331),(14,258,0.37331),(15,258,0.37331),(16,258,0.37331),(17,258,0.37331),(18,258,0.37331),(19,258,0.37331),(20,258,0.37331),(21,258,0.37331),(1,259,1.02669),(2,259,1.02669),(3,259,1.02669),(4,259,1.02669),(5,259,1.02669),(6,259,1.02669),(7,259,1.02669),(8,259,1.02669),(9,259,1.02669),(10,259,1.02669),(11,259,1.02669),(12,259,1.02669),(13,259,1.02669),(14,259,1.02669),(15,259,1.02669),(16,259,1.02669),(17,259,1.02669),(18,259,1.02669),(19,259,1.02669),(20,259,1.02669),(21,259,1.02669),(1,260,1.28331),(2,260,1.28331),(3,260,1.28331),(4,260,1.28331),(5,260,1.28331),(6,260,1.28331),(7,260,1.28331),(8,260,1.28331),(9,260,1.28331),(10,260,1.28331),(11,260,1.28331),(12,260,1.28331),(13,260,1.28331),(14,260,1.28331),(15,260,1.28331),(16,260,1.28331),(17,260,1.28331),(18,260,1.28331),(19,260,1.28331),(20,260,1.28331),(21,260,1.28331),(1,767,0.56),(2,767,0.56),(3,767,0.56),(4,767,0.56),(5,767,0.56),(6,767,0.56),(7,767,0.56),(8,767,0.56),(9,767,0.56),(10,767,0.56),(11,767,0.56),(12,767,0.56),(13,767,0.56),(14,767,0.56),(15,767,0.56),(16,767,0.56),(17,767,0.56),(18,767,0.56),(19,767,0.56),(20,767,0.56),(21,767,0.56),(2,808,0.49321),(16,808,0.49321),(16,809,4.81),(1,3124,0.98679),(1,3125,4.68679),(1,3126,5.18),(1,3127,0.37331),(2,3127,0.74662),(3,3127,0.74662),(4,3127,0.74662),(5,3127,0.74662),(6,3127,0.74662),(7,3127,0.74662),(8,3127,0.74662),(9,3127,0.74662),(10,3127,0.74662),(11,3127,0.74662),(12,3127,0.74662),(13,3127,0.74662),(14,3127,0.74662),(15,3127,0.74662),(16,3127,0.74662),(17,3127,0.74662),(18,3127,0.74662),(19,3127,0.74662),(20,3127,0.74662),(21,3127,0.74662),(1,3128,1.00331),(2,3128,1.00331),(3,3128,1.00331),(4,3128,1.00331),(5,3128,1.00331),(6,3128,1.00331),(7,3128,1.00331),(8,3128,1.00331),(9,3128,1.00331),(10,3128,1.00331),(11,3128,1.00331),(12,3128,1.00331),(13,3128,1.00331),(14,3128,1.00331),(15,3128,1.00331),(16,3128,1.00331),(17,3128,1.00331),(18,3128,1.00331),(19,3128,1.00331),(20,3128,1.00331),(21,3128,1.00331),(2,3129,1.30669),(3,3129,1.30669),(4,3129,1.30669),(5,3129,1.30669),(6,3129,1.30669),(7,3129,1.30669),(8,3129,1.30669),(9,3129,1.30669),(10,3129,1.30669),(11,3129,1.30669),(12,3129,1.30669),(13,3129,1.30669),(14,3129,1.30669),(15,3129,1.30669),(16,3129,1.30669),(17,3129,1.30669),(18,3129,1.30669),(19,3129,1.30669),(20,3129,1.30669),(21,3129,1.30669),(1,3129,1.30669),(1,3130,0.74),(1,3131,4.56321),(1,3132,4.81),(1,3250,0.95669),(2,3250,0.95669),(3,3250,0.95669),(4,3250,0.95669),(5,3250,0.95669),(6,3250,0.95669),(7,3250,0.95669),(8,3250,0.95669),(9,3250,0.95669),(10,3250,0.95669),(11,3250,0.95669),(12,3250,0.95669),(13,3250,0.95669),(14,3250,0.95669),(15,3250,0.95669),(16,3250,0.95669),(17,3250,0.95669),(18,3250,0.95669),(19,3250,0.95669),(20,3250,0.95669),(21,3250,0.95669),(1,3251,1.19),(2,3251,1.19),(3,3251,1.19),(4,3251,1.19),(5,3251,1.19),(6,3251,1.19),(7,3251,1.19),(8,3251,1.19),(9,3251,1.19),(10,3251,1.19),(11,3251,1.19),(12,3251,1.19),(13,3251,1.19),(14,3251,1.19),(15,3251,1.19),(16,3251,1.19),(17,3251,1.19),(18,3251,1.19),(19,3251,1.19),(20,3251,1.19),(21,3251,1.19),(1,3252,0.95669),(2,3252,0.95669),(3,3252,0.95669),(4,3252,0.95669),(5,3252,0.95669),(6,3252,0.95669),(7,3252,0.95669),(8,3252,0.95669),(9,3252,0.95669),(10,3252,0.95669),(11,3252,0.95669),(12,3252,0.95669),(13,3252,0.95669),(14,3252,0.95669),(15,3252,0.95669),(16,3252,0.95669),(17,3252,0.95669),(18,3252,0.95669),(19,3252,0.95669),(20,3252,0.95669),(21,3252,0.95669),(1,3253,1.14331),(2,3253,1.14331),(3,3253,1.14331),(4,3253,1.14331),(5,3253,1.14331),(6,3253,1.14331),(7,3253,1.14331),(8,3253,1.14331),(9,3253,1.14331),(10,3253,1.14331),(11,3253,1.14331),(12,3253,1.14331),(13,3253,1.14331),(14,3253,1.14331),(15,3253,1.14331),(16,3253,1.14331),(17,3253,1.14331),(18,3253,1.14331),(19,3253,1.14331),(20,3253,1.14331),(21,3253,1.14331),(1,3254,0.37331),(2,3254,0.74662),(3,3254,0.74662),(4,3254,0.74662),(5,3254,0.74662),(6,3254,0.74662),(7,3254,0.74662),(8,3254,0.74662),(9,3254,0.74662),(10,3254,0.74662),(11,3254,0.74662),(12,3254,0.74662),(13,3254,0.74662),(14,3254,0.74662),(15,3254,0.74662),(16,3254,0.74662),(17,3254,0.74662),(18,3254,0.74662),(19,3254,0.74662),(20,3254,0.74662),(21,3254,0.74662),(1,3255,1.05),(2,3255,1.05),(3,3255,1.05),(4,3255,1.05),(5,3255,1.05),(6,3255,1.05),(7,3255,1.05),(8,3255,1.05),(9,3255,1.05),(10,3255,1.05),(11,3255,1.05),(12,3255,1.05),(13,3255,1.05),(14,3255,1.05),(15,3255,1.05),(16,3255,1.05),(17,3255,1.05),(18,3255,1.05),(19,3255,1.05),(20,3255,1.05),(21,3255,1.05),(1,3256,1.12),(2,3256,1.12),(3,3256,1.12),(4,3256,1.12),(5,3256,1.12),(6,3256,1.12),(7,3256,1.12),(8,3256,1.12),(9,3256,1.12),(10,3256,1.12),(11,3256,1.12),(12,3256,1.12),(13,3256,1.12),(14,3256,1.12),(15,3256,1.12),(16,3256,1.12),(17,3256,1.12),(18,3256,1.12),(19,3256,1.12),(20,3256,1.12),(21,3256,1.12),(1,3257,1.02669),(2,3257,1.02669),(3,3257,1.02669),(4,3257,1.02669),(5,3257,1.02669),(6,3257,1.02669),(7,3257,1.02669),(8,3257,1.02669),(9,3257,1.02669),(10,3257,1.02669),(11,3257,1.02669),(12,3257,1.02669),(13,3257,1.02669),(14,3257,1.02669),(15,3257,1.02669),(16,3257,1.02669),(17,3257,1.02669),(18,3257,1.02669),(19,3257,1.02669),(20,3257,1.02669),(21,3257,1.02669),(1,3258,1.19),(2,3258,1.19),(3,3258,1.19),(4,3258,1.19),(5,3258,1.19),(6,3258,1.19),(7,3258,1.19),(8,3258,1.19),(9,3258,1.19),(10,3258,1.19),(11,3258,1.19),(12,3258,1.19),(13,3258,1.19),(14,3258,1.19),(15,3258,1.19),(16,3258,1.19),(17,3258,1.19),(18,3258,1.19),(19,3258,1.19),(20,3258,1.19),(21,3258,1.19),(1,3259,1.16669),(2,3259,1.16669),(3,3259,1.16669),(4,3259,1.16669),(5,3259,1.16669),(6,3259,1.16669),(7,3259,1.16669),(8,3259,1.16669),(9,3259,1.16669),(10,3259,1.16669),(11,3259,1.16669),(12,3259,1.16669),(13,3259,1.16669),(14,3259,1.16669),(15,3259,1.16669),(16,3259,1.16669),(17,3259,1.16669),(18,3259,1.16669),(19,3259,1.16669),(20,3259,1.16669),(21,3259,1.16669),(1,3260,1.05),(2,3260,1.05),(3,3260,1.05),(4,3260,1.05),(5,3260,1.05),(6,3260,1.05),(7,3260,1.05),(8,3260,1.05),(9,3260,1.05),(10,3260,1.05),(11,3260,1.05),(12,3260,1.05),(13,3260,1.05),(14,3260,1.05),(15,3260,1.05),(16,3260,1.05),(17,3260,1.05),(18,3260,1.05),(19,3260,1.05),(20,3260,1.05),(21,3260,1.05),(1,3261,1.19),(2,3261,1.19),(3,3261,1.19),(4,3261,1.19),(5,3261,1.19),(6,3261,1.19),(7,3261,1.19),(8,3261,1.19),(9,3261,1.19),(10,3261,1.19),(11,3261,1.19),(12,3261,1.19),(13,3261,1.19),(14,3261,1.19),(15,3261,1.19),(16,3261,1.19),(17,3261,1.19),(18,3261,1.19),(19,3261,1.19),(20,3261,1.19),(21,3261,1.19),(1,3262,0.32669),(2,3262,0.65338),(3,3262,0.65338),(4,3262,0.65338),(5,3262,0.65338),(6,3262,0.65338),(7,3262,0.65338),(8,3262,0.65338),(9,3262,0.65338),(10,3262,0.65338),(11,3262,0.65338),(12,3262,0.65338),(13,3262,0.65338),(14,3262,0.65338),(15,3262,0.65338),(16,3262,0.65338),(17,3262,0.65338),(18,3262,0.65338),(19,3262,0.65338),(20,3262,0.65338),(21,3262,0.65338),(1,3263,1.09669),(2,3263,1.09669),(3,3263,1.09669),(4,3263,1.09669),(5,3263,1.09669),(6,3263,1.09669),(7,3263,1.09669),(8,3263,1.09669),(9,3263,1.09669),(10,3263,1.09669),(11,3263,1.09669),(12,3263,1.09669),(13,3263,1.09669),(14,3263,1.09669),(15,3263,1.09669),(16,3263,1.09669),(17,3263,1.09669),(18,3263,1.09669),(19,3263,1.09669),(20,3263,1.09669),(21,3263,1.09669),(1,3264,1.21331),(2,3264,1.21331),(3,3264,1.21331),(4,3264,1.21331),(5,3264,1.21331),(6,3264,1.21331),(7,3264,1.21331),(8,3264,1.21331),(9,3264,1.21331),(10,3264,1.21331),(11,3264,1.21331),(12,3264,1.21331),(13,3264,1.21331),(14,3264,1.21331),(15,3264,1.21331),(16,3264,1.21331),(17,3264,1.21331),(18,3264,1.21331),(19,3264,1.21331),(20,3264,1.21331),(21,3264,1.21331),(2,3392,0.98),(3,3392,0.98),(4,3392,0.98),(5,3392,0.98),(6,3392,0.98),(7,3392,0.98),(8,3392,0.98),(9,3392,0.98),(10,3392,0.98),(11,3392,0.98),(12,3392,0.98),(13,3392,0.98),(14,3392,0.98),(15,3392,0.98),(16,3392,0.98),(17,3392,0.98),(18,3392,0.98),(19,3392,0.98),(20,3392,0.98),(21,3392,0.98),(2,3393,1.09669),(3,3393,1.09669),(4,3393,1.09669),(5,3393,1.09669),(6,3393,1.09669),(7,3393,1.09669),(8,3393,1.09669),(9,3393,1.09669),(10,3393,1.09669),(11,3393,1.09669),(12,3393,1.09669),(13,3393,1.09669),(14,3393,1.09669),(15,3393,1.09669),(16,3393,1.09669),(17,3393,1.09669),(18,3393,1.09669),(19,3393,1.09669),(20,3393,1.09669),(21,3393,1.09669),(2,3394,4.56321),(2,3591,0.98),(3,3591,0.98),(4,3591,0.98),(5,3591,0.98),(6,3591,0.98),(7,3591,0.98),(8,3591,0.98),(9,3591,0.98),(10,3591,0.98),(11,3591,0.98),(12,3591,0.98),(13,3591,0.98),(14,3591,0.98),(15,3591,0.98),(16,3591,0.98),(17,3591,0.98),(18,3591,0.98),(19,3591,0.98),(20,3591,0.98),(21,3591,0.98),(2,3592,1.09669),(3,3592,1.09669),(4,3592,1.09669),(5,3592,1.09669),(6,3592,1.09669),(7,3592,1.09669),(8,3592,1.09669),(9,3592,1.09669),(10,3592,1.09669),(11,3592,1.09669),(12,3592,1.09669),(13,3592,1.09669),(14,3592,1.09669),(15,3592,1.09669),(16,3592,1.09669),(17,3592,1.09669),(18,3592,1.09669),(19,3592,1.09669),(20,3592,1.09669),(21,3592,1.09669),(2,3593,0.91),(3,3593,0.91),(4,3593,0.91),(5,3593,0.91),(6,3593,0.91),(7,3593,0.91),(8,3593,0.91),(9,3593,0.91),(10,3593,0.91),(11,3593,0.91),(12,3593,0.91),(13,3593,0.91),(14,3593,0.91),(15,3593,0.91),(16,3593,0.91),(17,3593,0.91),(18,3593,0.91),(19,3593,0.91),(20,3593,0.91),(21,3593,0.91),(2,3594,1.14331),(3,3594,1.14331),(4,3594,1.14331),(5,3594,1.14331),(6,3594,1.14331),(7,3594,1.14331),(8,3594,1.14331),(9,3594,1.14331),(10,3594,1.14331),(11,3594,1.14331),(12,3594,1.14331),(13,3594,1.14331),(14,3594,1.14331),(15,3594,1.14331),(16,3594,1.14331),(17,3594,1.14331),(18,3594,1.14331),(19,3594,1.14331),(20,3594,1.14331),(21,3594,1.14331),(2,3595,0.88669),(3,3595,0.88669),(4,3595,0.88669),(5,3595,0.88669),(6,3595,0.88669),(7,3595,0.88669),(8,3595,0.88669),(9,3595,0.88669),(10,3595,0.88669),(11,3595,0.88669),(12,3595,0.88669),(13,3595,0.88669),(14,3595,0.88669),(15,3595,0.88669),(16,3595,0.88669),(17,3595,0.88669),(18,3595,0.88669),(19,3595,0.88669),(20,3595,0.88669),(21,3595,0.88669),(2,3596,1.02669),(3,3596,1.02669),(4,3596,1.02669),(5,3596,1.02669),(6,3596,1.02669),(7,3596,1.02669),(8,3596,1.02669),(9,3596,1.02669),(10,3596,1.02669),(11,3596,1.02669),(12,3596,1.02669),(13,3596,1.02669),(14,3596,1.02669),(15,3596,1.02669),(16,3596,1.02669),(17,3596,1.02669),(18,3596,1.02669),(19,3596,1.02669),(20,3596,1.02669),(21,3596,1.02669),(2,3597,0.84),(3,3597,0.84),(4,3597,0.84),(5,3597,0.84),(6,3597,0.84),(7,3597,0.84),(8,3597,0.84),(9,3597,0.84),(10,3597,0.84),(11,3597,0.84),(12,3597,0.84),(13,3597,0.84),(14,3597,0.84),(15,3597,0.84),(16,3597,0.84),(17,3597,0.84),(18,3597,0.84),(19,3597,0.84),(20,3597,0.84),(21,3597,0.84),(2,3598,0.98),(3,3598,0.98),(4,3598,0.98),(5,3598,0.98),(6,3598,0.98),(7,3598,0.98),(8,3598,0.98),(9,3598,0.98),(10,3598,0.98),(11,3598,0.98),(12,3598,0.98),(13,3598,0.98),(14,3598,0.98),(15,3598,0.98),(16,3598,0.98),(17,3598,0.98),(18,3598,0.98),(19,3598,0.98),(20,3598,0.98),(21,3598,0.98),(2,3599,0.95669),(3,3599,0.95669),(4,3599,0.95669),(5,3599,0.95669),(6,3599,0.95669),(7,3599,0.95669),(8,3599,0.95669),(9,3599,0.95669),(10,3599,0.95669),(11,3599,0.95669),(12,3599,0.95669),(13,3599,0.95669),(14,3599,0.95669),(15,3599,0.95669),(16,3599,0.95669),(17,3599,0.95669),(18,3599,0.95669),(19,3599,0.95669),(20,3599,0.95669),(21,3599,0.95669),(2,3600,1.12),(3,3600,1.12),(4,3600,1.12),(5,3600,1.12),(6,3600,1.12),(7,3600,1.12),(8,3600,1.12),(9,3600,1.12),(10,3600,1.12),(11,3600,1.12),(12,3600,1.12),(13,3600,1.12),(14,3600,1.12),(15,3600,1.12),(16,3600,1.12),(17,3600,1.12),(18,3600,1.12),(19,3600,1.12),(20,3600,1.12),(21,3600,1.12),(2,3601,0.93331),(3,3601,0.93331),(4,3601,0.93331),(5,3601,0.93331),(6,3601,0.93331),(7,3601,0.93331),(8,3601,0.93331),(9,3601,0.93331),(10,3601,0.93331),(11,3601,0.93331),(12,3601,0.93331),(13,3601,0.93331),(14,3601,0.93331),(15,3601,0.93331),(16,3601,0.93331),(17,3601,0.93331),(18,3601,0.93331),(19,3601,0.93331),(20,3601,0.93331),(21,3601,0.93331),(2,3602,1.09669),(3,3602,1.09669),(4,3602,1.09669),(5,3602,1.09669),(6,3602,1.09669),(7,3602,1.09669),(8,3602,1.09669),(9,3602,1.09669),(10,3602,1.09669),(11,3602,1.09669),(12,3602,1.09669),(13,3602,1.09669),(14,3602,1.09669),(15,3602,1.09669),(16,3602,1.09669),(17,3602,1.09669),(18,3602,1.09669),(19,3602,1.09669),(20,3602,1.09669),(21,3602,1.09669),(2,3603,1.19),(3,3603,1.19),(4,3603,1.19),(5,3603,1.19),(6,3603,1.19),(7,3603,1.19),(8,3603,1.19),(9,3603,1.19),(10,3603,1.19),(11,3603,1.19),(12,3603,1.19),(13,3603,1.19),(14,3603,1.19),(15,3603,1.19),(16,3603,1.19),(17,3603,1.19),(18,3603,1.19),(19,3603,1.19),(20,3603,1.19),(21,3603,1.19),(2,3604,1.4),(3,3604,1.4),(4,3604,1.4),(5,3604,1.4),(6,3604,1.4),(7,3604,1.4),(8,3604,1.4),(9,3604,1.4),(10,3604,1.4),(11,3604,1.4),(12,3604,1.4),(13,3604,1.4),(14,3604,1.4),(15,3604,1.4),(16,3604,1.4),(17,3604,1.4),(18,3604,1.4),(19,3604,1.4),(20,3604,1.4),(21,3604,1.4),(2,3605,1.09669),(3,3605,1.09669),(4,3605,1.09669),(5,3605,1.09669),(6,3605,1.09669),(7,3605,1.09669),(8,3605,1.09669),(9,3605,1.09669),(10,3605,1.09669),(11,3605,1.09669),(12,3605,1.09669),(13,3605,1.09669),(14,3605,1.09669),(15,3605,1.09669),(16,3605,1.09669),(17,3605,1.09669),(18,3605,1.09669),(19,3605,1.09669),(20,3605,1.09669),(21,3605,1.09669),(2,3606,1.28331),(3,3606,1.28331),(4,3606,1.28331),(5,3606,1.28331),(6,3606,1.28331),(7,3606,1.28331),(8,3606,1.28331),(9,3606,1.28331),(10,3606,1.28331),(11,3606,1.28331),(12,3606,1.28331),(13,3606,1.28331),(14,3606,1.28331),(15,3606,1.28331),(16,3606,1.28331),(17,3606,1.28331),(18,3606,1.28331),(19,3606,1.28331),(20,3606,1.28331),(21,3606,1.28331),(2,3607,0.93331),(3,3607,0.93331),(4,3607,0.93331),(5,3607,0.93331),(6,3607,0.93331),(7,3607,0.93331),(8,3607,0.93331),(9,3607,0.93331),(10,3607,0.93331),(11,3607,0.93331),(12,3607,0.93331),(13,3607,0.93331),(14,3607,0.93331),(15,3607,0.93331),(16,3607,0.93331),(17,3607,0.93331),(18,3607,0.93331),(19,3607,0.93331),(20,3607,0.93331),(21,3607,0.93331),(2,3608,1.14331),(3,3608,1.14331),(4,3608,1.14331),(5,3608,1.14331),(6,3608,1.14331),(7,3608,1.14331),(8,3608,1.14331),(9,3608,1.14331),(10,3608,1.14331),(11,3608,1.14331),(12,3608,1.14331),(13,3608,1.14331),(14,3608,1.14331),(15,3608,1.14331),(16,3608,1.14331),(17,3608,1.14331),(18,3608,1.14331),(19,3608,1.14331),(20,3608,1.14331),(21,3608,1.14331),(2,3609,0.93331),(3,3609,0.93331),(4,3609,0.93331),(5,3609,0.93331),(6,3609,0.93331),(7,3609,0.93331),(8,3609,0.93331),(9,3609,0.93331),(10,3609,0.93331),(11,3609,0.93331),(12,3609,0.93331),(13,3609,0.93331),(14,3609,0.93331),(15,3609,0.93331),(16,3609,0.93331),(17,3609,0.93331),(18,3609,0.93331),(19,3609,0.93331),(20,3609,0.93331),(21,3609,0.93331),(2,3610,1.12),(3,3610,1.12),(4,3610,1.12),(5,3610,1.12),(6,3610,1.12),(7,3610,1.12),(8,3610,1.12),(9,3610,1.12),(10,3610,1.12),(11,3610,1.12),(12,3610,1.12),(13,3610,1.12),(14,3610,1.12),(15,3610,1.12),(16,3610,1.12),(17,3610,1.12),(18,3610,1.12),(19,3610,1.12),(20,3610,1.12),(21,3610,1.12),(2,3611,1.48),(2,3612,5.30321),(2,3613,5.55),(7,3741,0.49321),(7,3742,4.68679),(7,3743,5.30321),(9,3835,0.74),(9,3836,4.44),(9,3837,5.05679),(15,4086,4.93358),(15,4087,5.42679),(15,4088,5.79679),(19,4229,1.48),(19,4230,4.93321),(19,4231,5.55);


--
-- Table structure for table `#__finder_links_termsa`
--



CREATE TABLE `#__finder_links_termsa` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_termsa`
--


INSERT INTO `#__finder_links_termsa` (`link_id`, `term_id`, `weight`) VALUES (4,574,0.17),(7,574,0.37),(21,574,0.37),(21,4321,4.44),(21,4322,5.30321);


--
-- Table structure for table `#__finder_links_termsb`
--



CREATE TABLE `#__finder_links_termsb` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_termsb`
--


INSERT INTO `#__finder_links_termsb` (`link_id`, `term_id`, `weight`) VALUES (6,3684,1.48),(6,3685,5.18),(6,3686,5.42679),(7,3718,1.48),(13,3718,1.48),(16,3718,1.48),(18,3718,1.48),(7,3719,5.05679),(7,3720,2.9334),(7,3721,2.60661),(12,3965,1.23321),(12,3966,5.30321),(12,3967,5.55),(13,4007,4.93321),(13,4008,2.8666),(13,4009,2.55),(16,4119,4.68679),(16,4120,5.18),(18,4199,5.30321),(18,4200,6.04321),(18,4201,1.23321),(18,4202,5.30321);


--
-- Table structure for table `#__finder_links_termsc`
--



CREATE TABLE `#__finder_links_termsc` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_termsc`
--


INSERT INTO `#__finder_links_termsc` (`link_id`, `term_id`, `weight`) VALUES (1,2,0.17),(13,2,0.77),(2,512,0.17),(1,512,0.37),(8,650,0.17),(12,650,0.37),(14,650,0.37),(10,792,0.34),(7,792,0.4),(13,792,0.8),(11,807,0.34),(12,822,0.34),(9,822,0.74),(13,853,0.34),(14,868,0.34),(15,883,0.34),(16,898,0.34),(17,929,0.34),(18,944,0.34),(19,975,0.34),(20,990,0.34),(8,1104,1.48),(14,1104,1.48),(21,1355,0.34),(11,1355,0.74),(1,3105,4.44),(1,3106,1.11),(1,3107,4.56321),(1,3108,4.93321),(7,3708,2.2666),(7,3709,2.4666),(7,3710,0.68),(7,3711,2.09661),(7,3712,2.43661),(9,3802,4.56321),(9,3803,4.93321),(11,3928,4.31679),(11,3929,5.67321),(12,3959,4.68679),(12,3960,5.30321),(13,3990,2.2),(13,3991,2.6666),(13,3992,4.68679),(13,3993,5.67321),(13,3994,4.5332),(13,3995,2.4),(13,3996,1.36),(13,3997,2.04),(13,3998,2.43661),(14,4053,4.19321),(14,4054,4.81),(19,4224,0.98679),(19,4225,2.6),(19,4226,2.9334),(19,4227,2.49339),(19,4228,2.94661),(21,4318,1.23321),(21,4319,4.93321),(21,4320,5.18);


--
-- Table structure for table `#__finder_links_termsd`
--



CREATE TABLE `#__finder_links_termsd` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_termsd`
--


INSERT INTO `#__finder_links_termsd` (`link_id`, `term_id`, `weight`) VALUES (1,1,0),(2,1,0),(3,1,0),(4,1,0),(5,1,0),(6,1,0),(7,1,0),(8,1,0),(9,1,0),(10,1,0),(11,1,0),(12,1,0),(13,1,0),(14,1,0),(15,1,0),(16,1,0),(17,1,0),(18,1,0),(19,1,0),(20,1,0),(21,1,0),(1,153,0.18669),(2,153,0.37338),(3,153,0.37338),(4,153,0.37338),(5,153,0.37338),(6,153,0.37338),(7,153,0.37338),(8,153,0.37338),(9,153,0.37338),(10,153,0.37338),(11,153,0.37338),(12,153,0.37338),(13,153,0.37338),(14,153,0.37338),(15,153,0.37338),(16,153,0.37338),(17,153,0.37338),(18,153,0.37338),(19,153,0.37338),(20,153,0.37338),(21,153,0.37338),(1,154,1.00331),(2,154,1.00331),(3,154,1.00331),(4,154,1.00331),(5,154,1.00331),(6,154,1.00331),(7,154,1.00331),(8,154,1.00331),(9,154,1.00331),(10,154,1.00331),(11,154,1.00331),(12,154,1.00331),(13,154,1.00331),(14,154,1.00331),(15,154,1.00331),(16,154,1.00331),(17,154,1.00331),(18,154,1.00331),(19,154,1.00331),(20,154,1.00331),(21,154,1.00331),(1,155,1.14331),(2,155,1.14331),(3,155,1.14331),(4,155,1.14331),(5,155,1.14331),(6,155,1.14331),(7,155,1.14331),(8,155,1.14331),(9,155,1.14331),(10,155,1.14331),(11,155,1.14331),(12,155,1.14331),(13,155,1.14331),(14,155,1.14331),(15,155,1.14331),(16,155,1.14331),(17,155,1.14331),(18,155,1.14331),(19,155,1.14331),(20,155,1.14331),(21,155,1.14331),(9,156,0.49321),(12,156,0.49321),(18,156,0.49321),(1,158,0.56007),(2,158,0.56007),(3,158,0.56007),(4,158,0.56007),(5,158,0.56007),(6,158,0.56007),(7,158,0.56007),(8,158,0.56007),(9,158,0.56007),(10,158,0.56007),(11,158,0.56007),(12,158,0.56007),(13,158,0.56007),(14,158,0.56007),(15,158,0.56007),(16,158,0.56007),(17,158,0.56007),(18,158,0.56007),(19,158,0.56007),(20,158,0.56007),(21,158,0.56007),(2,159,0.84),(3,159,0.84),(4,159,0.84),(5,159,0.84),(6,159,0.84),(7,159,0.84),(8,159,0.84),(9,159,0.84),(10,159,0.84),(11,159,0.84),(12,159,0.84),(13,159,0.84),(14,159,0.84),(15,159,0.84),(16,159,0.84),(17,159,0.84),(18,159,0.84),(19,159,0.84),(20,159,0.84),(21,159,0.84),(1,159,0.84),(1,160,0.93331),(2,160,0.93331),(3,160,0.93331),(4,160,0.93331),(5,160,0.93331),(6,160,0.93331),(7,160,0.93331),(8,160,0.93331),(9,160,0.93331),(10,160,0.93331),(11,160,0.93331),(12,160,0.93331),(13,160,0.93331),(14,160,0.93331),(15,160,0.93331),(16,160,0.93331),(17,160,0.93331),(18,160,0.93331),(19,160,0.93331),(20,160,0.93331),(21,160,0.93331),(1,161,1.12),(2,161,1.12),(3,161,1.12),(4,161,1.12),(5,161,1.12),(6,161,1.12),(7,161,1.12),(8,161,1.12),(9,161,1.12),(10,161,1.12),(11,161,1.12),(12,161,1.12),(13,161,1.12),(14,161,1.12),(15,161,1.12),(16,161,1.12),(17,161,1.12),(18,161,1.12),(19,161,1.12),(20,161,1.12),(21,161,1.12),(1,162,1.86662),(2,162,1.86662),(3,162,1.86662),(4,162,1.86662),(5,162,1.86662),(6,162,1.86662),(7,162,1.86662),(8,162,1.86662),(9,162,1.86662),(10,162,1.86662),(11,162,1.86662),(12,162,1.86662),(13,162,1.86662),(14,162,1.86662),(15,162,1.86662),(16,162,1.86662),(17,162,1.86662),(18,162,1.86662),(19,162,1.86662),(20,162,1.86662),(21,162,1.86662),(1,163,2.00662),(2,163,2.00662),(3,163,2.00662),(4,163,2.00662),(5,163,2.00662),(6,163,2.00662),(7,163,2.00662),(8,163,2.00662),(9,163,2.00662),(10,163,2.00662),(11,163,2.00662),(12,163,2.00662),(13,163,2.00662),(14,163,2.00662),(15,163,2.00662),(16,163,2.00662),(17,163,2.00662),(18,163,2.00662),(19,163,2.00662),(20,163,2.00662),(21,163,2.00662),(9,740,4.44),(4,1561,1.97321),(4,1562,5.30321),(4,1563,3.4),(4,1564,3.11661),(1,3196,0.74),(1,3197,4.44),(1,3198,5.05679),(1,3199,1.02669),(2,3199,1.02669),(3,3199,1.02669),(4,3199,1.02669),(5,3199,1.02669),(6,3199,1.02669),(7,3199,1.02669),(8,3199,1.02669),(9,3199,1.02669),(10,3199,1.02669),(11,3199,1.02669),(12,3199,1.02669),(13,3199,1.02669),(14,3199,1.02669),(15,3199,1.02669),(16,3199,1.02669),(17,3199,1.02669),(18,3199,1.02669),(19,3199,1.02669),(20,3199,1.02669),(21,3199,1.02669),(1,3200,1.16669),(2,3200,1.16669),(3,3200,1.16669),(4,3200,1.16669),(5,3200,1.16669),(6,3200,1.16669),(7,3200,1.16669),(8,3200,1.16669),(9,3200,1.16669),(10,3200,1.16669),(11,3200,1.16669),(12,3200,1.16669),(13,3200,1.16669),(14,3200,1.16669),(15,3200,1.16669),(16,3200,1.16669),(17,3200,1.16669),(18,3200,1.16669),(19,3200,1.16669),(20,3200,1.16669),(21,3200,1.16669),(1,3201,0.95669),(2,3201,0.95669),(3,3201,0.95669),(4,3201,0.95669),(5,3201,0.95669),(6,3201,0.95669),(7,3201,0.95669),(8,3201,0.95669),(9,3201,0.95669),(10,3201,0.95669),(11,3201,0.95669),(12,3201,0.95669),(13,3201,0.95669),(14,3201,0.95669),(15,3201,0.95669),(16,3201,0.95669),(17,3201,0.95669),(18,3201,0.95669),(19,3201,0.95669),(20,3201,0.95669),(21,3201,0.95669),(1,3202,1.12),(2,3202,1.12),(3,3202,1.12),(4,3202,1.12),(5,3202,1.12),(6,3202,1.12),(7,3202,1.12),(8,3202,1.12),(9,3202,1.12),(10,3202,1.12),(11,3202,1.12),(12,3202,1.12),(13,3202,1.12),(14,3202,1.12),(15,3202,1.12),(16,3202,1.12),(17,3202,1.12),(18,3202,1.12),(19,3202,1.12),(20,3202,1.12),(21,3202,1.12),(2,3525,1.02669),(3,3525,1.02669),(4,3525,1.02669),(5,3525,1.02669),(6,3525,1.02669),(7,3525,1.02669),(8,3525,1.02669),(9,3525,1.02669),(10,3525,1.02669),(11,3525,1.02669),(12,3525,1.02669),(13,3525,1.02669),(14,3525,1.02669),(15,3525,1.02669),(16,3525,1.02669),(17,3525,1.02669),(18,3525,1.02669),(19,3525,1.02669),(20,3525,1.02669),(21,3525,1.02669),(2,3526,1.30669),(3,3526,1.30669),(4,3526,1.30669),(5,3526,1.30669),(6,3526,1.30669),(7,3526,1.30669),(8,3526,1.30669),(9,3526,1.30669),(10,3526,1.30669),(11,3526,1.30669),(12,3526,1.30669),(13,3526,1.30669),(14,3526,1.30669),(15,3526,1.30669),(16,3526,1.30669),(17,3526,1.30669),(18,3526,1.30669),(19,3526,1.30669),(20,3526,1.30669),(21,3526,1.30669),(6,3690,1.48),(6,3691,4.68679),(6,3692,5.30321),(9,3822,5.42679),(12,3977,4.81),(18,4206,4.93321),(18,4207,5.79679),(19,4243,0.98679),(19,4244,4.56321),(19,4245,5.42679);


--
-- Table structure for table `#__finder_links_termse`
--



CREATE TABLE `#__finder_links_termse` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_termse`
--


INSERT INTO `#__finder_links_termse` (`link_id`, `term_id`, `weight`) VALUES (1,53,0.74676),(2,53,1.30683),(3,53,1.30683),(4,53,1.30683),(5,53,1.30683),(6,53,1.30683),(7,53,1.30683),(8,53,1.30683),(9,53,1.30683),(10,53,1.30683),(11,53,1.30683),(12,53,1.30683),(13,53,1.30683),(14,53,1.30683),(15,53,1.30683),(16,53,1.30683),(17,53,1.30683),(18,53,1.30683),(19,53,1.30683),(20,53,1.30683),(21,53,1.30683),(1,54,1.82),(2,54,1.82),(3,54,1.82),(4,54,1.82),(5,54,1.82),(6,54,1.82),(7,54,1.82),(8,54,1.82),(9,54,1.82),(10,54,1.82),(11,54,1.82),(12,54,1.82),(13,54,1.82),(14,54,1.82),(15,54,1.82),(16,54,1.82),(17,54,1.82),(18,54,1.82),(19,54,1.82),(20,54,1.82),(21,54,1.82),(1,55,2.14662),(2,55,2.14662),(3,55,2.14662),(4,55,2.14662),(5,55,2.14662),(6,55,2.14662),(7,55,2.14662),(8,55,2.14662),(9,55,2.14662),(10,55,2.14662),(11,55,2.14662),(12,55,2.14662),(13,55,2.14662),(14,55,2.14662),(15,55,2.14662),(16,55,2.14662),(17,55,2.14662),(18,55,2.14662),(19,55,2.14662),(20,55,2.14662),(21,55,2.14662),(1,56,0.18669),(2,56,0.18669),(3,56,0.18669),(4,56,0.18669),(5,56,0.18669),(6,56,0.18669),(7,56,0.18669),(8,56,0.18669),(9,56,0.18669),(10,56,0.18669),(11,56,0.18669),(12,56,0.18669),(13,56,0.18669),(14,56,0.18669),(15,56,0.18669),(16,56,0.18669),(17,56,0.18669),(18,56,0.18669),(19,56,0.18669),(20,56,0.18669),(21,56,0.18669),(1,57,1.02669),(2,57,1.02669),(3,57,1.02669),(4,57,1.02669),(5,57,1.02669),(6,57,1.02669),(7,57,1.02669),(8,57,1.02669),(9,57,1.02669),(10,57,1.02669),(11,57,1.02669),(12,57,1.02669),(13,57,1.02669),(14,57,1.02669),(15,57,1.02669),(16,57,1.02669),(17,57,1.02669),(18,57,1.02669),(19,57,1.02669),(20,57,1.02669),(21,57,1.02669),(1,58,1.21331),(2,58,1.21331),(3,58,1.21331),(4,58,1.21331),(5,58,1.21331),(6,58,1.21331),(7,58,1.21331),(8,58,1.21331),(9,58,1.21331),(10,58,1.21331),(11,58,1.21331),(12,58,1.21331),(13,58,1.21331),(14,58,1.21331),(15,58,1.21331),(16,58,1.21331),(17,58,1.21331),(18,58,1.21331),(19,58,1.21331),(20,58,1.21331),(21,58,1.21331),(1,59,0.14),(2,59,0.14),(3,59,0.14),(4,59,0.14),(5,59,0.14),(6,59,0.14),(7,59,0.14),(8,59,0.14),(9,59,0.14),(10,59,0.14),(11,59,0.14),(12,59,0.14),(13,59,0.14),(14,59,0.14),(15,59,0.14),(16,59,0.14),(17,59,0.14),(18,59,0.14),(19,59,0.14),(20,59,0.14),(21,59,0.14),(2,60,0.84),(3,60,0.84),(4,60,0.84),(5,60,0.84),(6,60,0.84),(7,60,0.84),(8,60,0.84),(9,60,0.84),(10,60,0.84),(11,60,0.84),(12,60,0.84),(13,60,0.84),(14,60,0.84),(15,60,0.84),(16,60,0.84),(17,60,0.84),(18,60,0.84),(19,60,0.84),(20,60,0.84),(21,60,0.84),(1,60,0.84),(1,61,1.05),(2,61,1.05),(3,61,1.05),(4,61,1.05),(5,61,1.05),(6,61,1.05),(7,61,1.05),(8,61,1.05),(9,61,1.05),(10,61,1.05),(11,61,1.05),(12,61,1.05),(13,61,1.05),(14,61,1.05),(15,61,1.05),(16,61,1.05),(17,61,1.05),(18,61,1.05),(19,61,1.05),(20,61,1.05),(21,61,1.05),(1,62,0.23331),(2,62,0.23331),(3,62,0.23331),(4,62,0.23331),(5,62,0.23331),(6,62,0.23331),(7,62,0.23331),(8,62,0.23331),(9,62,0.23331),(10,62,0.23331),(11,62,0.23331),(12,62,0.23331),(13,62,0.23331),(14,62,0.23331),(15,62,0.23331),(16,62,0.23331),(17,62,0.23331),(18,62,0.23331),(19,62,0.23331),(20,62,0.23331),(21,62,0.23331),(1,63,0.95669),(2,63,0.95669),(3,63,0.95669),(4,63,0.95669),(5,63,0.95669),(6,63,0.95669),(7,63,0.95669),(8,63,0.95669),(9,63,0.95669),(10,63,0.95669),(11,63,0.95669),(12,63,0.95669),(13,63,0.95669),(14,63,0.95669),(15,63,0.95669),(16,63,0.95669),(17,63,0.95669),(18,63,0.95669),(19,63,0.95669),(20,63,0.95669),(21,63,0.95669),(1,64,1.05),(2,64,1.05),(3,64,1.05),(4,64,1.05),(5,64,1.05),(6,64,1.05),(7,64,1.05),(8,64,1.05),(9,64,1.05),(10,64,1.05),(11,64,1.05),(12,64,1.05),(13,64,1.05),(14,64,1.05),(15,64,1.05),(16,64,1.05),(17,64,1.05),(18,64,1.05),(19,64,1.05),(20,64,1.05),(21,64,1.05),(1,65,0.37324),(2,65,0.46655),(3,65,0.46655),(4,65,0.46655),(5,65,0.46655),(6,65,0.46655),(7,65,0.46655),(8,65,0.46655),(9,65,0.46655),(10,65,0.46655),(11,65,0.46655),(12,65,0.46655),(13,65,0.46655),(14,65,0.46655),(15,65,0.46655),(16,65,0.46655),(17,65,0.46655),(18,65,0.46655),(19,65,0.46655),(20,65,0.46655),(21,65,0.46655),(1,66,2.52),(2,66,2.52),(3,66,2.52),(4,66,2.52),(5,66,2.52),(6,66,2.52),(7,66,2.52),(8,66,2.52),(9,66,2.52),(10,66,2.52),(11,66,2.52),(12,66,2.52),(13,66,2.52),(14,66,2.52),(15,66,2.52),(16,66,2.52),(17,66,2.52),(18,66,2.52),(19,66,2.52),(20,66,2.52),(21,66,2.52),(1,67,0.98),(2,67,0.98),(3,67,0.98),(4,67,0.98),(5,67,0.98),(6,67,0.98),(7,67,0.98),(8,67,0.98),(9,67,0.98),(10,67,0.98),(11,67,0.98),(12,67,0.98),(13,67,0.98),(14,67,0.98),(15,67,0.98),(16,67,0.98),(17,67,0.98),(18,67,0.98),(19,67,0.98),(20,67,0.98),(21,67,0.98),(1,68,1.00331),(2,68,1.00331),(3,68,1.00331),(4,68,1.00331),(5,68,1.00331),(6,68,1.00331),(7,68,1.00331),(8,68,1.00331),(9,68,1.00331),(10,68,1.00331),(11,68,1.00331),(12,68,1.00331),(13,68,1.00331),(14,68,1.00331),(15,68,1.00331),(16,68,1.00331),(17,68,1.00331),(18,68,1.00331),(19,68,1.00331),(20,68,1.00331),(21,68,1.00331),(1,69,0.95669),(2,69,0.95669),(3,69,0.95669),(4,69,0.95669),(5,69,0.95669),(6,69,0.95669),(7,69,0.95669),(8,69,0.95669),(9,69,0.95669),(10,69,0.95669),(11,69,0.95669),(12,69,0.95669),(13,69,0.95669),(14,69,0.95669),(15,69,0.95669),(16,69,0.95669),(17,69,0.95669),(18,69,0.95669),(19,69,0.95669),(20,69,0.95669),(21,69,0.95669),(1,70,0.32669),(2,70,0.32669),(3,70,0.32669),(4,70,0.32669),(5,70,0.32669),(6,70,0.32669),(7,70,0.32669),(8,70,0.32669),(9,70,0.32669),(10,70,0.32669),(11,70,0.32669),(12,70,0.32669),(13,70,0.32669),(14,70,0.32669),(15,70,0.32669),(16,70,0.32669),(17,70,0.32669),(18,70,0.32669),(19,70,0.32669),(20,70,0.32669),(21,70,0.32669),(1,71,1.02669),(2,71,1.02669),(3,71,1.02669),(4,71,1.02669),(5,71,1.02669),(6,71,1.02669),(7,71,1.02669),(8,71,1.02669),(9,71,1.02669),(10,71,1.02669),(11,71,1.02669),(12,71,1.02669),(13,71,1.02669),(14,71,1.02669),(15,71,1.02669),(16,71,1.02669),(17,71,1.02669),(18,71,1.02669),(19,71,1.02669),(20,71,1.02669),(21,71,1.02669),(1,72,1.09669),(2,72,1.09669),(3,72,1.09669),(4,72,1.09669),(5,72,1.09669),(6,72,1.09669),(7,72,1.09669),(8,72,1.09669),(9,72,1.09669),(10,72,1.09669),(11,72,1.09669),(12,72,1.09669),(13,72,1.09669),(14,72,1.09669),(15,72,1.09669),(16,72,1.09669),(17,72,1.09669),(18,72,1.09669),(19,72,1.09669),(20,72,1.09669),(21,72,1.09669),(1,214,0.28),(2,214,0.28),(3,214,0.28),(4,214,0.28),(5,214,0.28),(6,214,0.28),(7,214,0.28),(8,214,0.28),(9,214,0.28),(10,214,0.28),(11,214,0.28),(12,214,0.28),(13,214,0.28),(14,214,0.28),(15,214,0.28),(16,214,0.28),(17,214,0.28),(18,214,0.28),(19,214,0.28),(20,214,0.28),(21,214,0.28),(1,215,1.00331),(2,215,1.00331),(3,215,1.00331),(4,215,1.00331),(5,215,1.00331),(6,215,1.00331),(7,215,1.00331),(8,215,1.00331),(9,215,1.00331),(10,215,1.00331),(11,215,1.00331),(12,215,1.00331),(13,215,1.00331),(14,215,1.00331),(15,215,1.00331),(16,215,1.00331),(17,215,1.00331),(18,215,1.00331),(19,215,1.00331),(20,215,1.00331),(21,215,1.00331),(1,216,1.12),(2,216,1.12),(3,216,1.12),(4,216,1.12),(5,216,1.12),(6,216,1.12),(7,216,1.12),(8,216,1.12),(9,216,1.12),(10,216,1.12),(11,216,1.12),(12,216,1.12),(13,216,1.12),(14,216,1.12),(15,216,1.12),(16,216,1.12),(17,216,1.12),(18,216,1.12),(19,216,1.12),(20,216,1.12),(21,216,1.12),(2,217,0.74),(4,217,0.74),(9,217,0.74),(10,217,0.74),(11,217,0.74),(15,217,0.74),(1,220,0.84),(2,220,1.26),(3,220,1.26),(4,220,1.26),(5,220,1.26),(6,220,1.26),(7,220,1.26),(8,220,1.26),(9,220,1.26),(10,220,1.26),(11,220,1.26),(12,220,1.26),(13,220,1.26),(14,220,1.26),(15,220,1.26),(16,220,1.26),(17,220,1.26),(18,220,1.26),(19,220,1.26),(20,220,1.26),(21,220,1.26),(1,221,1.09669),(2,221,1.09669),(3,221,1.09669),(4,221,1.09669),(5,221,1.09669),(6,221,1.09669),(7,221,1.09669),(8,221,1.09669),(9,221,1.09669),(10,221,1.09669),(11,221,1.09669),(12,221,1.09669),(13,221,1.09669),(14,221,1.09669),(15,221,1.09669),(16,221,1.09669),(17,221,1.09669),(18,221,1.09669),(19,221,1.09669),(20,221,1.09669),(21,221,1.09669),(1,222,1.21331),(2,222,1.21331),(3,222,1.21331),(4,222,1.21331),(5,222,1.21331),(6,222,1.21331),(7,222,1.21331),(8,222,1.21331),(9,222,1.21331),(10,222,1.21331),(11,222,1.21331),(12,222,1.21331),(13,222,1.21331),(14,222,1.21331),(15,222,1.21331),(16,222,1.21331),(17,222,1.21331),(18,222,1.21331),(19,222,1.21331),(20,222,1.21331),(21,222,1.21331),(1,223,1.02669),(2,223,1.02669),(3,223,1.02669),(4,223,1.02669),(5,223,1.02669),(6,223,1.02669),(7,223,1.02669),(8,223,1.02669),(9,223,1.02669),(10,223,1.02669),(11,223,1.02669),(12,223,1.02669),(13,223,1.02669),(14,223,1.02669),(15,223,1.02669),(16,223,1.02669),(17,223,1.02669),(18,223,1.02669),(19,223,1.02669),(20,223,1.02669),(21,223,1.02669),(1,224,1.23669),(2,224,1.23669),(3,224,1.23669),(4,224,1.23669),(5,224,1.23669),(6,224,1.23669),(7,224,1.23669),(8,224,1.23669),(9,224,1.23669),(10,224,1.23669),(11,224,1.23669),(12,224,1.23669),(13,224,1.23669),(14,224,1.23669),(15,224,1.23669),(16,224,1.23669),(17,224,1.23669),(18,224,1.23669),(19,224,1.23669),(20,224,1.23669),(21,224,1.23669),(3,543,0.17),(7,543,0.2),(5,605,0.17),(17,605,0.37),(1,689,0.18669),(2,689,0.74676),(3,689,0.74676),(4,689,0.74676),(5,689,0.74676),(6,689,0.74676),(7,689,0.74676),(8,689,0.74676),(9,689,0.74676),(10,689,0.74676),(11,689,0.74676),(12,689,0.74676),(13,689,0.74676),(14,689,0.74676),(15,689,0.74676),(16,689,0.74676),(17,689,0.74676),(18,689,0.74676),(19,689,0.74676),(20,689,0.74676),(21,689,0.74676),(4,856,0.74),(7,1064,0.2666),(8,1064,0.49321),(9,1064,0.49321),(14,1064,0.49321),(4,1565,4.56321),(4,1566,0.9334),(4,1567,2.7334),(4,1568,3.1334),(4,1569,1.24661),(4,1570,2.66339),(4,1571,2.83339),(2,3101,0.63996),(6,3101,0.63996),(7,3101,0.63996),(13,3101,0.63996),(21,3101,0.63996),(3,3102,0.24),(4,3102,0.24),(5,3102,0.24),(19,3102,0.24),(20,3102,0.24),(1,3153,0.91),(2,3153,0.91),(3,3153,0.91),(4,3153,0.91),(5,3153,0.91),(6,3153,0.91),(7,3153,0.91),(8,3153,0.91),(9,3153,0.91),(10,3153,0.91),(11,3153,0.91),(12,3153,0.91),(13,3153,0.91),(14,3153,0.91),(15,3153,0.91),(16,3153,0.91),(17,3153,0.91),(18,3153,0.91),(19,3153,0.91),(20,3153,0.91),(21,3153,0.91),(1,3154,1.02669),(2,3154,1.02669),(3,3154,1.02669),(4,3154,1.02669),(5,3154,1.02669),(6,3154,1.02669),(7,3154,1.02669),(8,3154,1.02669),(9,3154,1.02669),(10,3154,1.02669),(11,3154,1.02669),(12,3154,1.02669),(13,3154,1.02669),(14,3154,1.02669),(15,3154,1.02669),(16,3154,1.02669),(17,3154,1.02669),(18,3154,1.02669),(19,3154,1.02669),(20,3154,1.02669),(21,3154,1.02669),(1,3155,1.02669),(2,3155,1.02669),(3,3155,1.02669),(4,3155,1.02669),(5,3155,1.02669),(6,3155,1.02669),(7,3155,1.02669),(8,3155,1.02669),(9,3155,1.02669),(10,3155,1.02669),(11,3155,1.02669),(12,3155,1.02669),(13,3155,1.02669),(14,3155,1.02669),(15,3155,1.02669),(16,3155,1.02669),(17,3155,1.02669),(18,3155,1.02669),(19,3155,1.02669),(20,3155,1.02669),(21,3155,1.02669),(1,3156,1.14331),(2,3156,1.14331),(3,3156,1.14331),(4,3156,1.14331),(5,3156,1.14331),(6,3156,1.14331),(7,3156,1.14331),(8,3156,1.14331),(9,3156,1.14331),(10,3156,1.14331),(11,3156,1.14331),(12,3156,1.14331),(13,3156,1.14331),(14,3156,1.14331),(15,3156,1.14331),(16,3156,1.14331),(17,3156,1.14331),(18,3156,1.14331),(19,3156,1.14331),(20,3156,1.14331),(21,3156,1.14331),(1,3157,0.18669),(2,3157,0.18669),(3,3157,0.18669),(4,3157,0.18669),(5,3157,0.18669),(6,3157,0.18669),(7,3157,0.18669),(8,3157,0.18669),(9,3157,0.18669),(10,3157,0.18669),(11,3157,0.18669),(12,3157,0.18669),(13,3157,0.18669),(14,3157,0.18669),(15,3157,0.18669),(16,3157,0.18669),(17,3157,0.18669),(18,3157,0.18669),(19,3157,0.18669),(20,3157,0.18669),(21,3157,0.18669),(1,3158,0.91),(2,3158,0.91),(3,3158,0.91),(4,3158,0.91),(5,3158,0.91),(6,3158,0.91),(7,3158,0.91),(8,3158,0.91),(9,3158,0.91),(10,3158,0.91),(11,3158,0.91),(12,3158,0.91),(13,3158,0.91),(14,3158,0.91),(15,3158,0.91),(16,3158,0.91),(17,3158,0.91),(18,3158,0.91),(19,3158,0.91),(20,3158,0.91),(21,3158,0.91),(1,3159,1.00331),(2,3159,1.00331),(3,3159,1.00331),(4,3159,1.00331),(5,3159,1.00331),(6,3159,1.00331),(7,3159,1.00331),(8,3159,1.00331),(9,3159,1.00331),(10,3159,1.00331),(11,3159,1.00331),(12,3159,1.00331),(13,3159,1.00331),(14,3159,1.00331),(15,3159,1.00331),(16,3159,1.00331),(17,3159,1.00331),(18,3159,1.00331),(19,3159,1.00331),(20,3159,1.00331),(21,3159,1.00331),(1,3160,0.98),(2,3160,0.98),(3,3160,0.98),(4,3160,0.98),(5,3160,0.98),(6,3160,0.98),(7,3160,0.98),(8,3160,0.98),(9,3160,0.98),(10,3160,0.98),(11,3160,0.98),(12,3160,0.98),(13,3160,0.98),(14,3160,0.98),(15,3160,0.98),(16,3160,0.98),(17,3160,0.98),(18,3160,0.98),(19,3160,0.98),(20,3160,0.98),(21,3160,0.98),(1,3161,1.12),(2,3161,1.12),(3,3161,1.12),(4,3161,1.12),(5,3161,1.12),(6,3161,1.12),(7,3161,1.12),(8,3161,1.12),(9,3161,1.12),(10,3161,1.12),(11,3161,1.12),(12,3161,1.12),(13,3161,1.12),(14,3161,1.12),(15,3161,1.12),(16,3161,1.12),(17,3161,1.12),(18,3161,1.12),(19,3161,1.12),(20,3161,1.12),(21,3161,1.12),(1,3162,0.86331),(2,3162,0.86331),(3,3162,0.86331),(4,3162,0.86331),(5,3162,0.86331),(6,3162,0.86331),(7,3162,0.86331),(8,3162,0.86331),(9,3162,0.86331),(10,3162,0.86331),(11,3162,0.86331),(12,3162,0.86331),(13,3162,0.86331),(14,3162,0.86331),(15,3162,0.86331),(16,3162,0.86331),(17,3162,0.86331),(18,3162,0.86331),(19,3162,0.86331),(20,3162,0.86331),(21,3162,0.86331),(1,3163,1.07331),(2,3163,1.07331),(3,3163,1.07331),(4,3163,1.07331),(5,3163,1.07331),(6,3163,1.07331),(7,3163,1.07331),(8,3163,1.07331),(9,3163,1.07331),(10,3163,1.07331),(11,3163,1.07331),(12,3163,1.07331),(13,3163,1.07331),(14,3163,1.07331),(15,3163,1.07331),(16,3163,1.07331),(17,3163,1.07331),(18,3163,1.07331),(19,3163,1.07331),(20,3163,1.07331),(21,3163,1.07331),(1,3237,0.28),(2,3237,0.28),(3,3237,0.28),(4,3237,0.28),(5,3237,0.28),(6,3237,0.28),(7,3237,0.28),(8,3237,0.28),(9,3237,0.28),(10,3237,0.28),(11,3237,0.28),(12,3237,0.28),(13,3237,0.28),(14,3237,0.28),(15,3237,0.28),(16,3237,0.28),(17,3237,0.28),(18,3237,0.28),(19,3237,0.28),(20,3237,0.28),(21,3237,0.28),(1,3238,0.91),(2,3238,0.91),(3,3238,0.91),(4,3238,0.91),(5,3238,0.91),(6,3238,0.91),(7,3238,0.91),(8,3238,0.91),(9,3238,0.91),(10,3238,0.91),(11,3238,0.91),(12,3238,0.91),(13,3238,0.91),(14,3238,0.91),(15,3238,0.91),(16,3238,0.91),(17,3238,0.91),(18,3238,0.91),(19,3238,0.91),(20,3238,0.91),(21,3238,0.91),(1,3239,1.02669),(2,3239,1.02669),(3,3239,1.02669),(4,3239,1.02669),(5,3239,1.02669),(6,3239,1.02669),(7,3239,1.02669),(8,3239,1.02669),(9,3239,1.02669),(10,3239,1.02669),(11,3239,1.02669),(12,3239,1.02669),(13,3239,1.02669),(14,3239,1.02669),(15,3239,1.02669),(16,3239,1.02669),(17,3239,1.02669),(18,3239,1.02669),(19,3239,1.02669),(20,3239,1.02669),(21,3239,1.02669),(2,3426,0.88669),(3,3426,0.88669),(4,3426,0.88669),(5,3426,0.88669),(6,3426,0.88669),(7,3426,0.88669),(8,3426,0.88669),(9,3426,0.88669),(10,3426,0.88669),(11,3426,0.88669),(12,3426,0.88669),(13,3426,0.88669),(14,3426,0.88669),(15,3426,0.88669),(16,3426,0.88669),(17,3426,0.88669),(18,3426,0.88669),(19,3426,0.88669),(20,3426,0.88669),(21,3426,0.88669),(2,3427,1.12),(3,3427,1.12),(4,3427,1.12),(5,3427,1.12),(6,3427,1.12),(7,3427,1.12),(8,3427,1.12),(9,3427,1.12),(10,3427,1.12),(11,3427,1.12),(12,3427,1.12),(13,3427,1.12),(14,3427,1.12),(15,3427,1.12),(16,3427,1.12),(17,3427,1.12),(18,3427,1.12),(19,3427,1.12),(20,3427,1.12),(21,3427,1.12),(2,3428,0.91),(3,3428,0.91),(4,3428,0.91),(5,3428,0.91),(6,3428,0.91),(7,3428,0.91),(8,3428,0.91),(9,3428,0.91),(10,3428,0.91),(11,3428,0.91),(12,3428,0.91),(13,3428,0.91),(14,3428,0.91),(15,3428,0.91),(16,3428,0.91),(17,3428,0.91),(18,3428,0.91),(19,3428,0.91),(20,3428,0.91),(21,3428,0.91),(2,3429,1.16669),(3,3429,1.16669),(4,3429,1.16669),(5,3429,1.16669),(6,3429,1.16669),(7,3429,1.16669),(8,3429,1.16669),(9,3429,1.16669),(10,3429,1.16669),(11,3429,1.16669),(12,3429,1.16669),(13,3429,1.16669),(14,3429,1.16669),(15,3429,1.16669),(16,3429,1.16669),(17,3429,1.16669),(18,3429,1.16669),(19,3429,1.16669),(20,3429,1.16669),(21,3429,1.16669),(2,3430,0.91),(3,3430,0.91),(4,3430,0.91),(5,3430,0.91),(6,3430,0.91),(7,3430,0.91),(8,3430,0.91),(9,3430,0.91),(10,3430,0.91),(11,3430,0.91),(12,3430,0.91),(13,3430,0.91),(14,3430,0.91),(15,3430,0.91),(16,3430,0.91),(17,3430,0.91),(18,3430,0.91),(19,3430,0.91),(20,3430,0.91),(21,3430,0.91),(2,3431,1.02669),(3,3431,1.02669),(4,3431,1.02669),(5,3431,1.02669),(6,3431,1.02669),(7,3431,1.02669),(8,3431,1.02669),(9,3431,1.02669),(10,3431,1.02669),(11,3431,1.02669),(12,3431,1.02669),(13,3431,1.02669),(14,3431,1.02669),(15,3431,1.02669),(16,3431,1.02669),(17,3431,1.02669),(18,3431,1.02669),(19,3431,1.02669),(20,3431,1.02669),(21,3431,1.02669),(2,3432,0.37331),(3,3432,0.37331),(4,3432,0.37331),(5,3432,0.37331),(6,3432,0.37331),(7,3432,0.37331),(8,3432,0.37331),(9,3432,0.37331),(10,3432,0.37331),(11,3432,0.37331),(12,3432,0.37331),(13,3432,0.37331),(14,3432,0.37331),(15,3432,0.37331),(16,3432,0.37331),(17,3432,0.37331),(18,3432,0.37331),(19,3432,0.37331),(20,3432,0.37331),(21,3432,0.37331),(2,3433,0.98),(3,3433,0.98),(4,3433,0.98),(5,3433,0.98),(6,3433,0.98),(7,3433,0.98),(8,3433,0.98),(9,3433,0.98),(10,3433,0.98),(11,3433,0.98),(12,3433,0.98),(13,3433,0.98),(14,3433,0.98),(15,3433,0.98),(16,3433,0.98),(17,3433,0.98),(18,3433,0.98),(19,3433,0.98),(20,3433,0.98),(21,3433,0.98),(2,3434,1.07331),(3,3434,1.07331),(4,3434,1.07331),(5,3434,1.07331),(6,3434,1.07331),(7,3434,1.07331),(8,3434,1.07331),(9,3434,1.07331),(10,3434,1.07331),(11,3434,1.07331),(12,3434,1.07331),(13,3434,1.07331),(14,3434,1.07331),(15,3434,1.07331),(16,3434,1.07331),(17,3434,1.07331),(18,3434,1.07331),(19,3434,1.07331),(20,3434,1.07331),(21,3434,1.07331),(2,3435,0.42),(3,3435,0.42),(4,3435,0.42),(5,3435,0.42),(6,3435,0.42),(7,3435,0.42),(8,3435,0.42),(9,3435,0.42),(10,3435,0.42),(11,3435,0.42),(12,3435,0.42),(13,3435,0.42),(14,3435,0.42),(15,3435,0.42),(16,3435,0.42),(17,3435,0.42),(18,3435,0.42),(19,3435,0.42),(20,3435,0.42),(21,3435,0.42),(2,3436,1.05),(3,3436,1.05),(4,3436,1.05),(5,3436,1.05),(6,3436,1.05),(7,3436,1.05),(8,3436,1.05),(9,3436,1.05),(10,3436,1.05),(11,3436,1.05),(12,3436,1.05),(13,3436,1.05),(14,3436,1.05),(15,3436,1.05),(16,3436,1.05),(17,3436,1.05),(18,3436,1.05),(19,3436,1.05),(20,3436,1.05),(21,3436,1.05),(2,3437,1.28331),(3,3437,1.28331),(4,3437,1.28331),(5,3437,1.28331),(6,3437,1.28331),(7,3437,1.28331),(8,3437,1.28331),(9,3437,1.28331),(10,3437,1.28331),(11,3437,1.28331),(12,3437,1.28331),(13,3437,1.28331),(14,3437,1.28331),(15,3437,1.28331),(16,3437,1.28331),(17,3437,1.28331),(18,3437,1.28331),(19,3437,1.28331),(20,3437,1.28331),(21,3437,1.28331),(2,3438,0.93331),(3,3438,0.93331),(4,3438,0.93331),(5,3438,0.93331),(6,3438,0.93331),(7,3438,0.93331),(8,3438,0.93331),(9,3438,0.93331),(10,3438,0.93331),(11,3438,0.93331),(12,3438,0.93331),(13,3438,0.93331),(14,3438,0.93331),(15,3438,0.93331),(16,3438,0.93331),(17,3438,0.93331),(18,3438,0.93331),(19,3438,0.93331),(20,3438,0.93331),(21,3438,0.93331),(2,3439,1.16669),(3,3439,1.16669),(4,3439,1.16669),(5,3439,1.16669),(6,3439,1.16669),(7,3439,1.16669),(8,3439,1.16669),(9,3439,1.16669),(10,3439,1.16669),(11,3439,1.16669),(12,3439,1.16669),(13,3439,1.16669),(14,3439,1.16669),(15,3439,1.16669),(16,3439,1.16669),(17,3439,1.16669),(18,3439,1.16669),(19,3439,1.16669),(20,3439,1.16669),(21,3439,1.16669),(2,3440,0.98),(3,3440,0.98),(4,3440,0.98),(5,3440,0.98),(6,3440,0.98),(7,3440,0.98),(8,3440,0.98),(9,3440,0.98),(10,3440,0.98),(11,3440,0.98),(12,3440,0.98),(13,3440,0.98),(14,3440,0.98),(15,3440,0.98),(16,3440,0.98),(17,3440,0.98),(18,3440,0.98),(19,3440,0.98),(20,3440,0.98),(21,3440,0.98),(2,3441,1.14331),(3,3441,1.14331),(4,3441,1.14331),(5,3441,1.14331),(6,3441,1.14331),(7,3441,1.14331),(8,3441,1.14331),(9,3441,1.14331),(10,3441,1.14331),(11,3441,1.14331),(12,3441,1.14331),(13,3441,1.14331),(14,3441,1.14331),(15,3441,1.14331),(16,3441,1.14331),(17,3441,1.14331),(18,3441,1.14331),(19,3441,1.14331),(20,3441,1.14331),(21,3441,1.14331),(2,3442,0.98),(3,3442,0.98),(4,3442,0.98),(5,3442,0.98),(6,3442,0.98),(7,3442,0.98),(8,3442,0.98),(9,3442,0.98),(10,3442,0.98),(11,3442,0.98),(12,3442,0.98),(13,3442,0.98),(14,3442,0.98),(15,3442,0.98),(16,3442,0.98),(17,3442,0.98),(18,3442,0.98),(19,3442,0.98),(20,3442,0.98),(21,3442,0.98),(2,3443,1.05),(3,3443,1.05),(4,3443,1.05),(5,3443,1.05),(6,3443,1.05),(7,3443,1.05),(8,3443,1.05),(9,3443,1.05),(10,3443,1.05),(11,3443,1.05),(12,3443,1.05),(13,3443,1.05),(14,3443,1.05),(15,3443,1.05),(16,3443,1.05),(17,3443,1.05),(18,3443,1.05),(19,3443,1.05),(20,3443,1.05),(21,3443,1.05),(2,3444,0.09331),(3,3444,0.09331),(4,3444,0.09331),(5,3444,0.09331),(6,3444,0.09331),(7,3444,0.09331),(8,3444,0.09331),(9,3444,0.09331),(10,3444,0.09331),(11,3444,0.09331),(12,3444,0.09331),(13,3444,0.09331),(14,3444,0.09331),(15,3444,0.09331),(16,3444,0.09331),(17,3444,0.09331),(18,3444,0.09331),(19,3444,0.09331),(20,3444,0.09331),(21,3444,0.09331),(2,3445,0.88669),(3,3445,0.88669),(4,3445,0.88669),(5,3445,0.88669),(6,3445,0.88669),(7,3445,0.88669),(8,3445,0.88669),(9,3445,0.88669),(10,3445,0.88669),(11,3445,0.88669),(12,3445,0.88669),(13,3445,0.88669),(14,3445,0.88669),(15,3445,0.88669),(16,3445,0.88669),(17,3445,0.88669),(18,3445,0.88669),(19,3445,0.88669),(20,3445,0.88669),(21,3445,0.88669),(2,3446,0.98),(3,3446,0.98),(4,3446,0.98),(5,3446,0.98),(6,3446,0.98),(7,3446,0.98),(8,3446,0.98),(9,3446,0.98),(10,3446,0.98),(11,3446,0.98),(12,3446,0.98),(13,3446,0.98),(14,3446,0.98),(15,3446,0.98),(16,3446,0.98),(17,3446,0.98),(18,3446,0.98),(19,3446,0.98),(20,3446,0.98),(21,3446,0.98),(2,3447,0.93331),(3,3447,0.93331),(4,3447,0.93331),(5,3447,0.93331),(6,3447,0.93331),(7,3447,0.93331),(8,3447,0.93331),(9,3447,0.93331),(10,3447,0.93331),(11,3447,0.93331),(12,3447,0.93331),(13,3447,0.93331),(14,3447,0.93331),(15,3447,0.93331),(16,3447,0.93331),(17,3447,0.93331),(18,3447,0.93331),(19,3447,0.93331),(20,3447,0.93331),(21,3447,0.93331),(2,3448,1.05),(3,3448,1.05),(4,3448,1.05),(5,3448,1.05),(6,3448,1.05),(7,3448,1.05),(8,3448,1.05),(9,3448,1.05),(10,3448,1.05),(11,3448,1.05),(12,3448,1.05),(13,3448,1.05),(14,3448,1.05),(15,3448,1.05),(16,3448,1.05),(17,3448,1.05),(18,3448,1.05),(19,3448,1.05),(20,3448,1.05),(21,3448,1.05),(9,3561,1.48),(12,3561,1.48),(13,3561,1.48),(2,3561,2.96),(2,3562,5.55),(2,3563,5.92),(2,3564,4.68679),(2,3565,5.05679),(2,3566,4.93321),(2,3567,5.79679),(2,3568,1.05),(3,3568,1.05),(4,3568,1.05),(5,3568,1.05),(6,3568,1.05),(7,3568,1.05),(8,3568,1.05),(9,3568,1.05),(10,3568,1.05),(11,3568,1.05),(12,3568,1.05),(13,3568,1.05),(14,3568,1.05),(15,3568,1.05),(16,3568,1.05),(17,3568,1.05),(18,3568,1.05),(19,3568,1.05),(20,3568,1.05),(21,3568,1.05),(2,3569,1.21331),(3,3569,1.21331),(4,3569,1.21331),(5,3569,1.21331),(6,3569,1.21331),(7,3569,1.21331),(8,3569,1.21331),(9,3569,1.21331),(10,3569,1.21331),(11,3569,1.21331),(12,3569,1.21331),(13,3569,1.21331),(14,3569,1.21331),(15,3569,1.21331),(16,3569,1.21331),(17,3569,1.21331),(18,3569,1.21331),(19,3569,1.21331),(20,3569,1.21331),(21,3569,1.21331),(2,3570,2.71321),(2,3571,6.04321),(2,3572,6.90679),(2,3573,0.56),(3,3573,0.56),(4,3573,0.56),(5,3573,0.56),(6,3573,0.56),(7,3573,0.56),(8,3573,0.56),(9,3573,0.56),(10,3573,0.56),(11,3573,0.56),(12,3573,0.56),(13,3573,0.56),(14,3573,0.56),(15,3573,0.56),(16,3573,0.56),(17,3573,0.56),(18,3573,0.56),(19,3573,0.56),(20,3573,0.56),(21,3573,0.56),(2,3574,1.02669),(3,3574,1.02669),(4,3574,1.02669),(5,3574,1.02669),(6,3574,1.02669),(7,3574,1.02669),(8,3574,1.02669),(9,3574,1.02669),(10,3574,1.02669),(11,3574,1.02669),(12,3574,1.02669),(13,3574,1.02669),(14,3574,1.02669),(15,3574,1.02669),(16,3574,1.02669),(17,3574,1.02669),(18,3574,1.02669),(19,3574,1.02669),(20,3574,1.02669),(21,3574,1.02669),(2,3575,1.12),(3,3575,1.12),(4,3575,1.12),(5,3575,1.12),(6,3575,1.12),(7,3575,1.12),(8,3575,1.12),(9,3575,1.12),(10,3575,1.12),(11,3575,1.12),(12,3575,1.12),(13,3575,1.12),(14,3575,1.12),(15,3575,1.12),(16,3575,1.12),(17,3575,1.12),(18,3575,1.12),(19,3575,1.12),(20,3575,1.12),(21,3575,1.12),(2,3576,0.91),(3,3576,0.91),(4,3576,0.91),(5,3576,0.91),(6,3576,0.91),(7,3576,0.91),(8,3576,0.91),(9,3576,0.91),(10,3576,0.91),(11,3576,0.91),(12,3576,0.91),(13,3576,0.91),(14,3576,0.91),(15,3576,0.91),(16,3576,0.91),(17,3576,0.91),(18,3576,0.91),(19,3576,0.91),(20,3576,0.91),(21,3576,0.91),(2,3577,1.09669),(3,3577,1.09669),(4,3577,1.09669),(5,3577,1.09669),(6,3577,1.09669),(7,3577,1.09669),(8,3577,1.09669),(9,3577,1.09669),(10,3577,1.09669),(11,3577,1.09669),(12,3577,1.09669),(13,3577,1.09669),(14,3577,1.09669),(15,3577,1.09669),(16,3577,1.09669),(17,3577,1.09669),(18,3577,1.09669),(19,3577,1.09669),(20,3577,1.09669),(21,3577,1.09669),(3,3632,0.49321),(5,3632,0.49321),(19,3632,0.49321),(20,3632,0.49321),(3,3633,4.81),(5,3646,0.98642),(5,3647,9.37358),(5,3648,6.04321),(5,3649,5.05679),(5,3653,2.22),(5,3662,2.46679),(5,3663,6.16679),(5,3664,4.56321),(5,3665,4.93321),(6,3683,2.46679),(7,3713,2.2666),(7,3714,2.6666),(7,3739,2.4666),(7,3740,3),(8,3787,4.81),(8,3788,5.79679),(9,3825,5.05679),(9,3826,5.30321),(9,3827,5.05679),(9,3828,4.19321),(9,3829,5.05679),(10,3878,4.56321),(10,3879,2.8666),(10,3880,2.72),(10,3881,0.5334),(17,3881,0.98679),(10,3882,2.4666),(10,3883,2.9334),(11,3947,1.48),(11,3948,4.81),(11,3949,5.18),(11,3950,4.68679),(11,3951,5.55),(13,4011,0.74),(13,4012,2.4),(13,4013,2.5334),(13,4014,2.15339),(13,4015,2.26661),(13,4016,5.42679),(13,4017,5.92),(14,4069,4.81),(14,4070,5.30321),(15,4097,0.98679),(15,4098,4.81),(15,4099,5.05679),(15,4100,5.42679),(15,4101,5.92),(17,4130,4.93321),(17,4131,5.79679),(17,4157,2.46679),(17,4158,4.68679),(17,4159,5.05679),(19,4248,4.81),(19,4249,5.30321),(20,4288,4.31679),(20,4289,4.81);


--
-- Table structure for table `#__finder_links_termsf`
--



CREATE TABLE `#__finder_links_termsf` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_termsf`
--


INSERT INTO `#__finder_links_termsf` (`link_id`, `term_id`, `weight`) VALUES (9,1191,0.98679),(11,1191,0.98679),(12,1191,0.98679),(14,1191,0.98679),(21,1191,0.98679),(5,3666,0.98679),(5,3667,4.81),(5,3668,5.18),(9,3833,4.44),(12,3833,4.44),(9,3834,5.05679),(11,3952,5.18),(11,3953,6.41321),(12,3981,1.72679),(14,3981,1.72679),(12,3982,4.81),(12,3983,5.67321),(12,3984,5.05679),(13,4018,0.98679),(13,4019,2.4666),(13,4020,2.6),(13,4021,2.21),(14,4071,5.30321),(14,4072,5.55),(14,4073,5.18),(14,4074,5.92),(15,4102,0.74),(15,4103,4.44),(15,4104,5.05679),(21,4331,5.05679),(21,4332,6.04321);


--
-- Table structure for table `#__finder_taxonomy`
--



CREATE TABLE `#__finder_taxonomy` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL,
  `state` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `access` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `parent_id` (`parent_id`),
  KEY `state` (`state`),
  KEY `ordering` (`ordering`),
  KEY `access` (`access`),
  KEY `idx_parent_published` (`parent_id`,`state`,`access`)
) ENGINE=InnoDB AUTO_INCREMENT=27 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_taxonomy`
--


INSERT INTO `#__finder_taxonomy` (`id`, `parent_id`, `title`, `state`, `access`, `ordering`) VALUES (1,0,'ROOT',0,0,0),(2,1,'Type',1,1,0),(3,2,'K2 Item',1,1,0),(4,1,'Author',1,1,0),(5,4,'Super User',1,1,0),(6,1,'K2 Category',1,1,0),(8,1,'Language',1,1,0),(9,8,'*',1,1,0),(14,6,'World',1,1,0),(15,6,'U.S.',1,1,0),(16,6,'Politics',1,1,0),(17,6,'Economic',1,1,0),(18,6,'Sports',1,1,0),(19,6,'Health',1,1,0),(23,6,'Tablet\'s',1,1,0),(24,6,'TVs',1,1,0),(25,6,'SmartPhone\'s',1,1,0),(26,6,'Ultrabooks',1,1,0);


--
-- Table structure for table `#__finder_taxonomy_map`
--



CREATE TABLE `#__finder_taxonomy_map` (
  `link_id` int(10) unsigned NOT NULL,
  `node_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`node_id`),
  KEY `link_id` (`link_id`),
  KEY `node_id` (`node_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_taxonomy_map`
--


INSERT INTO `#__finder_taxonomy_map` (`link_id`, `node_id`) VALUES (1,3),(1,5),(1,9),(1,26),(2,3),(2,5),(2,9),(2,23),(3,3),(3,5),(3,9),(3,24),(4,3),(4,5),(4,9),(4,24),(5,3),(5,5),(5,9),(5,24),(6,3),(6,5),(6,9),(6,23),(7,3),(7,5),(7,9),(7,23),(8,3),(8,5),(8,9),(8,26),(9,3),(9,5),(9,9),(9,26),(10,3),(10,5),(10,9),(10,26),(11,3),(11,5),(11,9),(11,26),(12,3),(12,5),(12,9),(12,26),(13,3),(13,5),(13,9),(13,23),(14,3),(14,5),(14,9),(14,25),(15,3),(15,5),(15,9),(15,25),(16,3),(16,5),(16,9),(16,25),(17,3),(17,5),(17,9),(17,25),(18,3),(18,5),(18,9),(18,25),(19,3),(19,5),(19,9),(19,24),(20,3),(20,5),(20,9),(20,24),(21,3),(21,5),(21,9),(21,23);


--
-- Table structure for table `#__finder_terms`
--



CREATE TABLE `#__finder_terms` (
  `term_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '0',
  `soundex` varchar(75) NOT NULL,
  `links` int(10) NOT NULL DEFAULT '0',
  `language` char(3) NOT NULL DEFAULT '',
  PRIMARY KEY (`term_id`),
  UNIQUE KEY `idx_term` (`term`),
  KEY `idx_term_phrase` (`term`,`phrase`),
  KEY `idx_stem_phrase` (`stem`,`phrase`),
  KEY `idx_soundex_phrase` (`soundex`,`phrase`)
) ENGINE=InnoDB AUTO_INCREMENT=4348 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_terms`
--


INSERT INTO `#__finder_terms` (`term_id`, `term`, `stem`, `common`, `phrase`, `weight`, `soundex`, `links`, `language`) VALUES (1,'','',0,0,0,'',104,'*'),(2,'1','1',0,0,0.1,'',9,'*'),(3,'a','a',0,0,0.0667,'A000',104,'*'),(4,'a risus','a risus',0,1,1.2333,'A620',98,'*'),(5,'a risus nec','a risus nec',0,1,1.3667,'A6252',98,'*'),(6,'a velit','a velit',0,1,1.2333,'A143',98,'*'),(7,'a velit vitae','a velit vitae',0,1,1.4333,'A14313',98,'*'),(8,'aenean','aenean',0,0,0.4,'A500',104,'*'),(9,'aenean eu','aenean eu',0,1,1.3,'A500',104,'*'),(10,'aenean eu leo','aenean eu leo',0,1,1.4333,'A540',104,'*'),(11,'aliquam','aliquam',0,0,0.4667,'A425',98,'*'),(12,'aliquam tempus','aliquam tempus',0,1,1.4667,'A4253512',98,'*'),(13,'aliquam tempus rutrum','aliquam tempus rutrum',0,1,1.7,'A42535126365',98,'*'),(14,'amet','amet',0,0,0.2667,'A530',104,'*'),(15,'amet fermentum','amet fermentum',0,1,1.4667,'A5316535',104,'*'),(16,'amet fermentum etiam','amet fermentum etiam',0,1,1.6667,'A531653535',104,'*'),(17,'amet fermentum nullam','amet fermentum nullam',0,1,1.7,'A531653545',104,'*'),(18,'at','at',0,0,0.1333,'A300',104,'*'),(19,'at lobortis','at lobortis',0,1,1.3667,'A341632',104,'*'),(20,'at lobortis donec','at lobortis donec',0,1,1.5667,'A341632352',104,'*'),(21,'auctor','auctor',0,0,0.4,'A236',104,'*'),(22,'auctor fringilla','auctor fringilla',0,1,1.5333,'A23616524',104,'*'),(23,'auctor fringilla cras','auctor fringilla cras',0,1,1.7,'A23616524262',104,'*'),(24,'categorie','categorie',0,0,0.6,'C326',20,'*'),(25,'categorie iii','categorie iii',0,1,1.4333,'C326',4,'*'),(26,'consectetur','consectetur',0,0,0.7333,'C5236',104,'*'),(27,'consectetur est','consectetur est',0,1,1.5,'C523623',104,'*'),(28,'consectetur est at','consectetur est at',0,1,1.6,'C523623',104,'*'),(29,'consectetur purus','consectetur purus',0,1,1.5667,'C5236162',104,'*'),(30,'consectetur purus sit','consectetur purus sit',0,1,1.7,'C52361623',104,'*'),(31,'cras','cras',0,0,0.2667,'C620',104,'*'),(32,'cras dui','cras dui',0,1,1.2667,'C623',98,'*'),(33,'cras dui velit','cras dui velit',0,1,1.4667,'C623143',98,'*'),(34,'cras mattis','cras mattis',0,1,1.3667,'C62532',104,'*'),(35,'cras mattis consectetur','cras mattis consectetur',0,1,1.7667,'C625325236',104,'*'),(36,'design','design',0,0,0.4,'D250',28,'*'),(37,'diam','diam',0,0,0.2667,'D500',102,'*'),(38,'diam non','diam non',0,1,1.2667,'D500',98,'*'),(39,'diam non tincidunt','diam non tincidunt',0,1,1.6,'D5352353',98,'*'),(40,'donec','donec',0,0,0.3333,'D520',104,'*'),(41,'donec ullamcorper','donec ullamcorper',0,1,1.5667,'D52452616',104,'*'),(42,'donec ullamcorper nulla','donec ullamcorper nulla',0,1,1.7667,'D5245261654',104,'*'),(43,'dui','dui',0,0,0.2,'D000',98,'*'),(44,'dui duis','dui duis',0,1,1.2667,'D200',98,'*'),(45,'dui duis a','dui duis a',0,1,1.3333,'D200',98,'*'),(46,'dui velit','dui velit',0,1,1.3,'D143',98,'*'),(47,'dui velit luctus','dui velit luctus',0,1,1.5333,'D1434232',98,'*'),(48,'duis','duis',0,0,0.2667,'D200',98,'*'),(49,'duis a','duis a',0,1,1.2,'D200',98,'*'),(50,'duis a risus','duis a risus',0,1,1.4,'D262',98,'*'),(51,'duis sed','duis sed',0,1,1.2667,'D230',98,'*'),(52,'duis sed laoreet','duis sed laoreet',0,1,1.5333,'D23463',98,'*'),(53,'eget','eget',0,0,0.2667,'E230',104,'*'),(54,'eget urna','eget urna',0,1,1.3,'E2365',104,'*'),(55,'eget urna mollis','eget urna mollis',0,1,1.5333,'E236542',104,'*'),(56,'erat','erat',0,0,0.2667,'E630',98,'*'),(57,'erat tincidunt','erat tincidunt',0,1,1.4667,'E6352353',98,'*'),(58,'erat tincidunt feugiat','erat tincidunt feugiat',0,1,1.7333,'E6352353123',98,'*'),(59,'est','est',0,0,0.2,'E230',104,'*'),(60,'est at','est at',0,1,1.2,'E230',104,'*'),(61,'est at lobortis','est at lobortis',0,1,1.5,'E2341632',104,'*'),(62,'etiam','etiam',0,0,0.3333,'E350',104,'*'),(63,'etiam porta','etiam porta',0,1,1.3667,'E35163',104,'*'),(64,'etiam porta sem','etiam porta sem',0,1,1.5,'E3516325',104,'*'),(65,'eu','eu',0,0,0.1333,'E000',104,'*'),(66,'eu leo','eu leo',0,1,1.2,'E400',104,'*'),(67,'eu leo donec','eu leo donec',0,1,1.4,'E4352',104,'*'),(68,'eu leo nullam','eu leo nullam',0,1,1.4333,'E4545',104,'*'),(69,'eu leo quam','eu leo quam',0,1,1.3667,'E425',104,'*'),(70,'euismod','euismod',0,0,0.4667,'E253',104,'*'),(71,'euismod aenean','euismod aenean',0,1,1.4667,'E2535',104,'*'),(72,'euismod aenean eu','euismod aenean eu',0,1,1.5667,'E2535',104,'*'),(73,'facilisi','facilisi',0,0,0.5333,'F242',98,'*'),(74,'facilisi duis','facilisi duis',0,1,1.4333,'F24232',98,'*'),(75,'facilisi duis sed','facilisi duis sed',0,1,1.5667,'F242323',98,'*'),(76,'fermentum','fermentum',0,0,0.6,'F6535',104,'*'),(77,'fermentum etiam','fermentum etiam',0,1,1.5,'F653535',104,'*'),(78,'fermentum etiam porta','fermentum etiam porta',0,1,1.7,'F653535163',104,'*'),(79,'fermentum nullam','fermentum nullam',0,1,1.5333,'F653545',104,'*'),(80,'fermentum nullam quis','fermentum nullam quis',0,1,1.7,'F6535452',104,'*'),(81,'feugiat','feugiat',0,0,0.4667,'F230',98,'*'),(82,'feugiat cras','feugiat cras',0,1,1.4,'F23262',98,'*'),(83,'feugiat cras dui','feugiat cras dui',0,1,1.5333,'F232623',98,'*'),(84,'fringilla','fringilla',0,0,0.6,'F6524',104,'*'),(85,'fringilla cras','fringilla cras',0,1,1.4667,'F6524262',104,'*'),(86,'fringilla cras mattis','fringilla cras mattis',0,1,1.7,'F6524262532',104,'*'),(87,'iaculis','iaculis',0,0,0.4667,'I242',98,'*'),(88,'iaculis aliquam','iaculis aliquam',0,1,1.5,'I242425',98,'*'),(89,'iaculis aliquam tempus','iaculis aliquam tempus',0,1,1.7333,'I2424253512',98,'*'),(90,'iii','iii',0,0,0.2,'I000',5,'*'),(91,'illusion','illusion',0,0,0.5333,'I425',2,'*'),(92,'illusion of','illusion of',0,1,1.3667,'I4251',2,'*'),(93,'illusion of design','illusion of design',0,1,1.6,'I4251325',2,'*'),(94,'index','index',0,0,0.3333,'I532',104,'*'),(95,'item','item',0,0,0.2667,'I350',104,'*'),(96,'k2','k2',0,0,0.1333,'K000',104,'*'),(97,'k2 item','k2 item',0,1,1.2333,'K350',104,'*'),(98,'lacinia','lacinia',0,0,0.4667,'L250',104,'*'),(99,'lacinia quam','lacinia quam',0,1,1.4,'L2525',104,'*'),(100,'lacinia quam venenatis','lacinia quam venenatis',0,1,1.7333,'L25251532',104,'*'),(101,'laoreet','laoreet',0,0,0.4667,'L630',98,'*'),(102,'laoreet dui','laoreet dui',0,1,1.3667,'L630',98,'*'),(103,'laoreet dui duis','laoreet dui duis',0,1,1.5333,'L632',98,'*'),(104,'leo','leo',0,0,0.2,'L000',104,'*'),(105,'leo donec','leo donec',0,1,1.3,'L352',104,'*'),(106,'leo donec ullamcorper','leo donec ullamcorper',0,1,1.7,'L352452616',104,'*'),(107,'leo nullam','leo nullam',0,1,1.3333,'L545',104,'*'),(108,'leo nullam quis','leo nullam quis',0,1,1.5,'L5452',104,'*'),(109,'leo quam','leo quam',0,1,1.2667,'L250',104,'*'),(110,'leo quam pellentesque','leo quam pellentesque',0,1,1.7,'L2514532',104,'*'),(111,'lobortis','lobortis',0,0,0.5333,'L1632',104,'*'),(112,'lobortis donec','lobortis donec',0,1,1.4667,'L1632352',104,'*'),(113,'lobortis donec ullamcorper','lobortis donec ullamcorper',0,1,1.8667,'L1632352452616',104,'*'),(114,'luctus','luctus',0,0,0.4,'L232',98,'*'),(115,'luctus vitae','luctus vitae',0,1,1.4,'L23213',98,'*'),(116,'luctus vitae volutpat','luctus vitae volutpat',0,1,1.7,'L2321314313',98,'*'),(117,'magna','magna',0,0,0.3333,'M250',104,'*'),(118,'magna mollis','magna mollis',0,1,1.4,'M2542',104,'*'),(119,'magna mollis euismod','magna mollis euismod',0,1,1.6667,'M254253',104,'*'),(120,'malesuada','malesuada',0,0,0.6,'M423',104,'*'),(121,'malesuada magna','malesuada magna',0,1,1.5,'M423525',104,'*'),(122,'malesuada magna mollis','malesuada magna mollis',0,1,1.7333,'M42352542',104,'*'),(123,'mattis','mattis',0,0,0.4,'M320',104,'*'),(124,'mattis consectetur','mattis consectetur',0,1,1.6,'M325236',104,'*'),(125,'mattis consectetur purus','mattis consectetur purus',0,1,1.8,'M325236162',104,'*'),(126,'metus','metus',0,0,0.3333,'M320',104,'*'),(127,'metus auctor','metus auctor',0,1,1.4,'M3236',104,'*'),(128,'metus auctor fringilla','metus auctor fringilla',0,1,1.7333,'M323616524',104,'*'),(129,'mollis','mollis',0,0,0.4,'M420',104,'*'),(130,'mollis euismod','mollis euismod',0,1,1.4667,'M4253',104,'*'),(131,'mollis euismod aenean','mollis euismod aenean',0,1,1.7,'M42535',104,'*'),(132,'mollis ornare','mollis ornare',0,1,1.4333,'M42656',104,'*'),(133,'mollis ornare vel','mollis ornare vel',0,1,1.5667,'M4265614',104,'*'),(134,'nec','nec',0,0,0.2,'N200',98,'*'),(135,'nec erat','nec erat',0,1,1.2667,'N263',98,'*'),(136,'nec erat tincidunt','nec erat tincidunt',0,1,1.6,'N26352353',98,'*'),(137,'non','non',0,0,0.2,'N000',104,'*'),(138,'non metus','non metus',0,1,1.3,'N320',104,'*'),(139,'non metus auctor','non metus auctor',0,1,1.5333,'N3236',104,'*'),(140,'non tincidunt','non tincidunt',0,1,1.4333,'N352353',98,'*'),(141,'non tincidunt odio','non tincidunt odio',0,1,1.6,'N352353',98,'*'),(142,'nulla','nulla',0,0,0.3333,'N400',104,'*'),(143,'nulla facilisi','nulla facilisi',0,1,1.4667,'N41242',98,'*'),(144,'nulla facilisi duis','nulla facilisi duis',0,1,1.6333,'N4124232',98,'*'),(145,'nulla non','nulla non',0,1,1.3,'N450',104,'*'),(146,'nulla non metus','nulla non metus',0,1,1.5,'N4532',104,'*'),(147,'nullam','nullam',0,0,0.4,'N450',104,'*'),(148,'nullam quis','nullam quis',0,1,1.3667,'N452',104,'*'),(149,'nullam quis risus','nullam quis risus',0,1,1.5667,'N45262',104,'*'),(150,'nunc','nunc',0,0,0.2667,'N200',98,'*'),(151,'nunc porta','nunc porta',0,1,1.3333,'N2163',98,'*'),(152,'nunc porta iaculis','nunc porta iaculis',0,1,1.6,'N2163242',98,'*'),(153,'odio','odio',0,0,0.2667,'O300',98,'*'),(154,'odio pharetra','odio pharetra',0,1,1.4333,'O31636',98,'*'),(155,'odio pharetra vitae','odio pharetra vitae',0,1,1.6333,'O3163613',98,'*'),(156,'of','of',0,0,0.1333,'O100',23,'*'),(157,'of design','of design',0,1,1.3,'O1325',2,'*'),(158,'orci','orci',0,0,0.2667,'O620',98,'*'),(159,'ornare','ornare',0,0,0.4,'O656',104,'*'),(160,'ornare sem','ornare sem',0,1,1.3333,'O65625',104,'*'),(161,'ornare sem lacinia','ornare sem lacinia',0,1,1.6,'O65625425',104,'*'),(162,'ornare vel','ornare vel',0,1,1.3333,'O65614',104,'*'),(163,'ornare vel eu','ornare vel eu',0,1,1.4333,'O65614',104,'*'),(164,'pellentesque','pellentesque',0,0,0.8,'P4532',104,'*'),(165,'pellentesque ornare','pellentesque ornare',0,1,1.6333,'P4532656',104,'*'),(166,'pellentesque ornare sem','pellentesque ornare sem',0,1,1.7667,'P453265625',104,'*'),(167,'pharetra','pharetra',0,0,0.5333,'P636',104,'*'),(168,'pharetra vitae','pharetra vitae',0,1,1.4667,'P63613',98,'*'),(169,'pharetra vitae nulla','pharetra vitae nulla',0,1,1.6667,'P6361354',98,'*'),(170,'porta','porta',0,0,0.3333,'P630',104,'*'),(171,'porta iaculis','porta iaculis',0,1,1.4333,'P63242',98,'*'),(172,'porta iaculis aliquam','porta iaculis aliquam',0,1,1.7,'P63242425',98,'*'),(173,'porta sem','porta sem',0,1,1.3,'P6325',104,'*'),(174,'porta sem malesuada','porta sem malesuada',0,1,1.6333,'P6325423',104,'*'),(175,'posuere','posuere',0,0,0.4667,'P260',104,'*'),(176,'posuere consectetur','posuere consectetur',0,1,1.6333,'P2625236',104,'*'),(177,'posuere consectetur est','posuere consectetur est',0,1,1.7667,'P262523623',104,'*'),(178,'purus','purus',0,0,0.3333,'P620',104,'*'),(179,'purus sit','purus sit',0,1,1.3,'P623',104,'*'),(180,'purus sit amet','purus sit amet',0,1,1.4667,'P62353',104,'*'),(181,'quam','quam',0,0,0.2667,'Q500',104,'*'),(182,'quam pellentesque','quam pellentesque',0,1,1.5667,'Q514532',104,'*'),(183,'quam pellentesque ornare','quam pellentesque ornare',0,1,1.8,'Q514532656',104,'*'),(184,'quam venenatis','quam venenatis',0,1,1.4667,'Q51532',104,'*'),(185,'quam venenatis vestibulum','quam venenatis vestibulum',0,1,1.8333,'Q51532123145',104,'*'),(186,'quis','quis',0,0,0.2667,'Q000',104,'*'),(187,'quis risus','quis risus',0,1,1.3333,'Q620',104,'*'),(188,'quis risus eget','quis risus eget',0,1,1.5,'Q623',104,'*'),(189,'risus','risus',0,0,0.3333,'R200',104,'*'),(190,'risus eget','risus eget',0,1,1.3333,'R230',104,'*'),(191,'risus eget urna','risus eget urna',0,1,1.5,'R2365',104,'*'),(192,'risus nec','risus nec',0,1,1.3,'R252',98,'*'),(193,'risus nec erat','risus nec erat',0,1,1.4667,'R25263',98,'*'),(194,'rutrum','rutrum',0,0,0.4,'R365',98,'*'),(195,'rutrum diam','rutrum diam',0,1,1.3667,'R36535',98,'*'),(196,'rutrum diam non','rutrum diam non',0,1,1.5,'R36535',98,'*'),(197,'sed','sed',0,0,0.2,'S300',104,'*'),(198,'sed a','sed a',0,1,1.1667,'S300',98,'*'),(199,'sed a velit','sed a velit',0,1,1.3667,'S3143',98,'*'),(200,'sed laoreet','sed laoreet',0,1,1.3667,'S3463',98,'*'),(201,'sed laoreet dui','sed laoreet dui',0,1,1.5,'S3463',98,'*'),(202,'sed posuere','sed posuere',0,1,1.3667,'S3126',104,'*'),(203,'sed posuere consectetur','sed posuere consectetur',0,1,1.7667,'S312625236',104,'*'),(204,'sem','sem',0,0,0.2,'S500',104,'*'),(205,'sem lacinia','sem lacinia',0,1,1.3667,'S5425',104,'*'),(206,'sem lacinia quam','sem lacinia quam',0,1,1.5333,'S542525',104,'*'),(207,'sem malesuada','sem malesuada',0,1,1.4333,'S5423',104,'*'),(208,'sem malesuada magna','sem malesuada magna',0,1,1.6333,'S5423525',104,'*'),(209,'sit','sit',0,0,0.2,'S300',104,'*'),(210,'sit amet','sit amet',0,1,1.2667,'S353',104,'*'),(211,'sit amet fermentum','sit amet fermentum',0,1,1.6,'S35316535',104,'*'),(212,'super','super',0,0,0.3333,'S160',79,'*'),(213,'super user','super user',0,1,1.3333,'S1626',79,'*'),(214,'tempus','tempus',0,0,0.4,'T512',98,'*'),(215,'tempus rutrum','tempus rutrum',0,1,1.4333,'T5126365',98,'*'),(216,'tempus rutrum diam','tempus rutrum diam',0,1,1.6,'T512636535',98,'*'),(217,'the','the',0,0,0.2,'T000',35,'*'),(218,'the illusion','the illusion',0,1,1.4,'T425',2,'*'),(219,'the illusion of','the illusion of',0,1,1.5,'T4251',2,'*'),(220,'tincidunt','tincidunt',0,0,0.6,'T52353',98,'*'),(221,'tincidunt feugiat','tincidunt feugiat',0,1,1.5667,'T52353123',98,'*'),(222,'tincidunt feugiat cras','tincidunt feugiat cras',0,1,1.7333,'T52353123262',98,'*'),(223,'tincidunt odio','tincidunt odio',0,1,1.4667,'T52353',98,'*'),(224,'tincidunt odio pharetra','tincidunt odio pharetra',0,1,1.7667,'T523531636',98,'*'),(225,'ullamcorper','ullamcorper',0,0,0.7333,'U452616',104,'*'),(226,'ullamcorper nulla','ullamcorper nulla',0,1,1.5667,'U45261654',104,'*'),(227,'ullamcorper nulla non','ullamcorper nulla non',0,1,1.7,'U452616545',104,'*'),(228,'urna','urna',0,0,0.2667,'U650',104,'*'),(229,'urna mollis','urna mollis',0,1,1.3667,'U6542',104,'*'),(230,'urna mollis ornare','urna mollis ornare',0,1,1.6,'U6542656',104,'*'),(231,'user','user',0,0,0.2667,'U260',79,'*'),(232,'vel','vel',0,0,0.2,'V400',104,'*'),(233,'vel eu','vel eu',0,1,1.2,'V400',104,'*'),(234,'vel eu leo','vel eu leo',0,1,1.3333,'V400',104,'*'),(235,'velit','velit',0,0,0.3333,'V430',98,'*'),(236,'velit luctus','velit luctus',0,1,1.4,'V434232',98,'*'),(237,'velit luctus vitae','velit luctus vitae',0,1,1.6,'V43423213',98,'*'),(238,'velit vitae','velit vitae',0,1,1.3667,'V4313',98,'*'),(239,'velit vitae nunc','velit vitae nunc',0,1,1.5333,'V431352',98,'*'),(240,'venenatis','venenatis',0,0,0.6,'V532',104,'*'),(241,'venenatis vestibulum','venenatis vestibulum',0,1,1.6667,'V532123145',104,'*'),(242,'venenatis vestibulum sed','venenatis vestibulum sed',0,1,1.8,'V53212314523',104,'*'),(243,'vestibulum','vestibulum',0,0,0.6667,'V23145',104,'*'),(244,'vestibulum sed','vestibulum sed',0,1,1.4667,'V2314523',104,'*'),(245,'vestibulum sed posuere','vestibulum sed posuere',0,1,1.7333,'V2314523126',104,'*'),(246,'vestibulum vitae','vestibulum vitae',0,1,1.5333,'V2314513',98,'*'),(247,'vestibulum vitae orci','vestibulum vitae orci',0,1,1.7,'V231451362',98,'*'),(248,'vitae','vitae',0,0,0.3333,'V300',104,'*'),(249,'vitae nulla','vitae nulla',0,1,1.3667,'V354',98,'*'),(250,'vitae nulla facilisi','vitae nulla facilisi',0,1,1.6667,'V3541242',98,'*'),(251,'vitae nunc','vitae nunc',0,1,1.3333,'V352',98,'*'),(252,'vitae nunc porta','vitae nunc porta',0,1,1.5333,'V352163',98,'*'),(253,'vitae orci','vitae orci',0,1,1.3333,'V362',98,'*'),(254,'vitae vestibulum','vitae vestibulum',0,1,1.5333,'V3123145',98,'*'),(255,'vitae vestibulum vitae','vitae vestibulum vitae',0,1,1.7333,'V312314513',98,'*'),(256,'vitae volutpat','vitae volutpat',0,1,1.4667,'V314313',98,'*'),(257,'vitae volutpat vitae','vitae volutpat vitae',0,1,1.6667,'V31431313',98,'*'),(258,'volutpat','volutpat',0,0,0.5333,'V4313',98,'*'),(259,'volutpat vitae','volutpat vitae',0,1,1.4667,'V431313',98,'*'),(260,'volutpat vitae vestibulum','volutpat vitae vestibulum',0,1,1.8333,'V431313123145',98,'*'),(512,'2','2',0,0,0.1,'',7,'*'),(513,'and','and',0,0,0.2,'A530',23,'*'),(514,'and human','and human',0,1,1.3,'A535',2,'*'),(515,'and human design','and human design',0,1,1.5333,'A535325',2,'*'),(516,'garden','garden',0,0,0.4,'G635',2,'*'),(517,'garden urban','garden urban',0,1,1.4,'G635615',2,'*'),(518,'garden urban nature','garden urban nature',0,1,1.6333,'G63561536',2,'*'),(519,'granite','granite',0,0,0.4667,'G653',2,'*'),(520,'granite garden','granite garden',0,1,1.4667,'G6532635',2,'*'),(521,'granite garden urban','granite garden urban',0,1,1.6667,'G6532635615',2,'*'),(522,'human','human',0,0,0.3333,'H500',2,'*'),(523,'human design','human design',0,1,1.4,'H5325',2,'*'),(524,'nature','nature',0,0,0.4,'N360',5,'*'),(525,'nature and','nature and',0,1,1.3333,'N3653',2,'*'),(526,'nature and human','nature and human',0,1,1.5333,'N36535',2,'*'),(527,'the granite','the granite',0,1,1.3667,'T2653',2,'*'),(528,'the granite garden','the granite garden',0,1,1.6,'T26532635',2,'*'),(529,'urban','urban',0,0,0.3333,'U615',2,'*'),(530,'urban nature','urban nature',0,1,1.4,'U61536',2,'*'),(531,'urban nature and','urban nature and',0,1,1.5333,'U6153653',2,'*'),(543,'3','3',0,0,0.1,'',6,'*'),(544,'categorie iv','categorie iv',0,1,1.4,'C3261',4,'*'),(545,'concept','concept',0,0,0.4667,'C5213',6,'*'),(546,'concept ontwikkeling','concept ontwikkeling',0,1,1.6667,'C5213532452',2,'*'),(547,'creatief','creatief',0,0,0.5333,'C631',2,'*'),(548,'creatief design','creatief design',0,1,1.5,'C631325',2,'*'),(549,'creatief design en','creatief design en',0,1,1.6,'C631325',2,'*'),(550,'design en','design en',0,1,1.3,'D250',2,'*'),(551,'design en interactief','design en interactief',0,1,1.7,'D2536231',2,'*'),(552,'en','en',0,0,0.1333,'E500',2,'*'),(553,'en interactief','en interactief',0,1,1.4667,'E536231',2,'*'),(554,'en interactief concept','en interactief concept',0,1,1.7333,'E53623125213',2,'*'),(555,'interactief','interactief',0,0,0.7333,'I536231',2,'*'),(556,'interactief concept','interactief concept',0,1,1.6333,'I53623125213',2,'*'),(557,'interactief concept ontwikkeling','interactief concept ontwikkeling',0,1,2,'I53623125213532452',2,'*'),(558,'iv','iv',0,0,0.1333,'I100',4,'*'),(559,'ontwikkeling','ontwikkeling',0,0,0.8,'O532452',2,'*'),(574,'4','4',0,0,0.1,'',7,'*'),(575,'categorie i','categorie i',0,1,1.3667,'C326',4,'*'),(576,'design our','design our',0,1,1.3333,'D256',2,'*'),(577,'design our ideas','design our ideas',0,1,1.5333,'D25632',2,'*'),(578,'dreams','dreams',0,0,0.4,'D652',2,'*'),(579,'i','i',0,0,0.0667,'I000',4,'*'),(580,'ideas','ideas',0,0,0.3333,'I320',8,'*'),(581,'ideas your','ideas your',0,1,1.3333,'I326',2,'*'),(582,'ideas your dreams','ideas your dreams',0,1,1.5667,'I3263652',2,'*'),(583,'our','our',0,0,0.2,'O600',2,'*'),(584,'our ideas','our ideas',0,1,1.3,'O632',2,'*'),(585,'our ideas your','our ideas your',0,1,1.4667,'O6326',2,'*'),(586,'we','we',0,0,0.1333,'W000',2,'*'),(587,'we design','we design',0,1,1.3,'W325',2,'*'),(588,'we design our','we design our',0,1,1.4333,'W3256',2,'*'),(589,'your','your',0,0,0.2667,'Y600',2,'*'),(590,'your dreams','your dreams',0,1,1.3667,'Y63652',2,'*'),(605,'5','5',0,0,0.1,'',6,'*'),(606,'artist','artist',0,0,0.4,'A6323',2,'*'),(607,'ideas sparkle','ideas sparkle',0,1,1.4333,'I321624',2,'*'),(608,'ideas sparkle on','ideas sparkle on',0,1,1.5333,'I3216245',2,'*'),(609,'on','on',0,0,0.1333,'O500',9,'*'),(610,'on paper','on paper',0,1,1.2667,'O516',2,'*'),(611,'on paper artist','on paper artist',0,1,1.5,'O516323',2,'*'),(612,'paper','paper',0,0,0.3333,'P600',2,'*'),(613,'paper artist','paper artist',0,1,1.4,'P6323',2,'*'),(614,'sparkle','sparkle',0,0,0.4667,'S1624',2,'*'),(615,'sparkle on','sparkle on',0,1,1.3333,'S16245',2,'*'),(616,'sparkle on paper','sparkle on paper',0,1,1.5333,'S1624516',2,'*'),(617,'when','when',0,0,0.2667,'W500',2,'*'),(618,'when ideas','when ideas',0,1,1.3333,'W532',2,'*'),(619,'when ideas sparkle','when ideas sparkle',0,1,1.6,'W5321624',2,'*'),(620,'6','6',0,0,0.1,'',6,'*'),(621,'everything','everything',0,0,0.6667,'E16352',2,'*'),(622,'everything is','everything is',0,1,1.4333,'E16352',2,'*'),(623,'everything is possible','everything is possible',0,1,1.7333,'E163521214',2,'*'),(624,'in','in',0,0,0.1333,'I500',46,'*'),(625,'in smart','in smart',0,1,1.2667,'I52563',2,'*'),(626,'in smart design','in smart design',0,1,1.5,'I5256325',2,'*'),(627,'is','is',0,0,0.1333,'I200',9,'*'),(628,'is possible','is possible',0,1,1.3667,'I21214',2,'*'),(629,'is possible in','is possible in',0,1,1.4667,'I212145',2,'*'),(630,'possible','possible',0,0,0.5333,'P214',2,'*'),(631,'possible in','possible in',0,1,1.3667,'P2145',2,'*'),(632,'possible in smart','possible in smart',0,1,1.5667,'P21452563',2,'*'),(633,'smart','smart',0,0,0.3333,'S563',3,'*'),(634,'smart design','smart design',0,1,1.4,'S56325',2,'*'),(635,'7','7',0,0,0.1,'',7,'*'),(636,'and the','and the',0,1,1.2333,'A530',4,'*'),(637,'and the cat','and the cat',0,1,1.3667,'A5323',2,'*'),(638,'beauty','beauty',0,0,0.4,'B300',2,'*'),(639,'beauty and','beauty and',0,1,1.3333,'B353',2,'*'),(640,'beauty and the','beauty and the',0,1,1.4667,'B353',2,'*'),(641,'bound','bound',0,0,0.3333,'B530',2,'*'),(642,'cat','cat',0,0,0.2,'C300',2,'*'),(643,'cat bound','cat bound',0,1,1.3,'C3153',2,'*'),(644,'categorie ii','categorie ii',0,1,1.4,'C326',4,'*'),(645,'ii','ii',0,0,0.1333,'I000',4,'*'),(646,'the beauty','the beauty',0,1,1.3333,'T130',2,'*'),(647,'the beauty and','the beauty and',0,1,1.4667,'T1353',2,'*'),(648,'the cat','the cat',0,1,1.2333,'T230',2,'*'),(649,'the cat bound','the cat bound',0,1,1.4333,'T23153',2,'*'),(650,'8','8',0,0,0.1,'',7,'*'),(651,'design tips','design tips',0,1,1.3667,'D25312',2,'*'),(652,'design tips for','design tips for',0,1,1.5,'D2531216',2,'*'),(653,'development','development',0,0,0.7333,'D14153',2,'*'),(654,'for','for',0,0,0.2,'F600',8,'*'),(655,'for web','for web',0,1,1.2333,'F610',2,'*'),(656,'for web site','for web site',0,1,1.4,'F6123',2,'*'),(657,'site','site',0,0,0.2667,'S300',2,'*'),(658,'site development','site development',0,1,1.5333,'S314153',2,'*'),(659,'tips','tips',0,0,0.2667,'T120',2,'*'),(660,'tips for','tips for',0,1,1.2667,'T1216',2,'*'),(661,'tips for web','tips for web',0,1,1.4,'T12161',2,'*'),(662,'web','web',0,0,0.2,'W100',2,'*'),(663,'web site','web site',0,1,1.2667,'W123',2,'*'),(664,'web site development','web site development',0,1,1.6667,'W12314153',2,'*'),(665,'9','9',0,0,0.1,'',5,'*'),(666,'a pharetra','a pharetra',0,1,1.3333,'A1636',6,'*'),(667,'a pharetra augue','a pharetra augue',0,1,1.5333,'A16362',6,'*'),(668,'ac','ac',0,0,0.1333,'A200',26,'*'),(669,'ac consectetur','ac consectetur',0,1,1.4667,'A25236',6,'*'),(670,'ac consectetur ac','ac consectetur ac',0,1,1.5667,'A252362',6,'*'),(671,'ac vestibulum','ac vestibulum',0,1,1.4333,'A2123145',6,'*'),(672,'ac vestibulum at','ac vestibulum at',0,1,1.5333,'A21231453',6,'*'),(673,'amet non','amet non',0,1,1.2667,'A535',6,'*'),(674,'amet non magna','amet non magna',0,1,1.4667,'A53525',6,'*'),(675,'at eros','at eros',0,1,1.2333,'A362',6,'*'),(676,'at eros nulla','at eros nulla',0,1,1.4333,'A36254',6,'*'),(677,'augue','augue',0,0,0.3333,'A200',28,'*'),(678,'blandit','blandit',0,0,0.4667,'B453',6,'*'),(679,'blandit sit','blandit sit',0,1,1.3667,'B45323',6,'*'),(680,'blandit sit amet','blandit sit amet',0,1,1.5333,'B4532353',6,'*'),(681,'consectetur ac','consectetur ac',0,1,1.4667,'C52362',6,'*'),(682,'consectetur ac vestibulum','consectetur ac vestibulum',0,1,1.8333,'C52362123145',6,'*'),(683,'deep','deep',0,0,0.2667,'D100',2,'*'),(684,'deep my','deep my',0,1,1.2333,'D150',2,'*'),(685,'deep my pleasure','deep my pleasure',0,1,1.5333,'D151426',2,'*'),(686,'elit','elit',0,0,0.2667,'E430',6,'*'),(687,'elit libero','elit libero',0,1,1.3667,'E43416',6,'*'),(688,'elit libero a','elit libero a',0,1,1.4333,'E43416',6,'*'),(689,'eros','eros',0,0,0.2667,'E620',28,'*'),(690,'eros nulla','eros nulla',0,1,1.3333,'E6254',6,'*'),(691,'eros nulla vitae','eros nulla vitae',0,1,1.5333,'E625413',6,'*'),(692,'faucibus','faucibus',0,0,0.5333,'F212',6,'*'),(693,'faucibus mollis','faucibus mollis',0,1,1.5,'F212542',6,'*'),(694,'faucibus mollis interdum','faucibus mollis interdum',0,1,1.8,'F21254253635',6,'*'),(695,'games','games',0,0,0.3333,'G520',2,'*'),(696,'games tomb','games tomb',0,1,1.3333,'G52351',2,'*'),(697,'games tomb raider','games tomb raider',0,1,1.5667,'G52351636',2,'*'),(698,'history','history',0,0,0.4667,'H236',3,'*'),(699,'history of','history of',0,1,1.3333,'H2361',2,'*'),(700,'history of games','history of games',0,1,1.5333,'H2361252',2,'*'),(701,'how','how',0,0,0.2,'H000',2,'*'),(702,'how deep','how deep',0,1,1.2667,'H310',2,'*'),(703,'how deep my','how deep my',0,1,1.3667,'H315',2,'*'),(704,'iconic','iconic',0,0,0.4,'I252',2,'*'),(705,'iconic series','iconic series',0,1,1.4333,'I25262',2,'*'),(706,'iconic series in','iconic series in',0,1,1.5333,'I252625',2,'*'),(707,'in the','in the',0,1,1.2,'I530',2,'*'),(708,'in the history','in the history',0,1,1.4667,'I53236',2,'*'),(709,'interdum','interdum',0,0,0.5333,'I53635',6,'*'),(710,'interdum morbi','interdum morbi',0,1,1.4667,'I5363561',6,'*'),(711,'interdum morbi leo','interdum morbi leo',0,1,1.6,'I53635614',6,'*'),(712,'is risus','is risus',0,1,1.2667,'I262',2,'*'),(713,'is risus varius','is risus varius',0,1,1.5,'I262162',2,'*'),(714,'leo risus','leo risus',0,1,1.3,'L620',6,'*'),(715,'leo risus porta','leo risus porta',0,1,1.5,'L62163',6,'*'),(716,'libero','libero',0,0,0.4,'L160',28,'*'),(717,'libero a','libero a',0,1,1.2667,'L160',6,'*'),(718,'libero a pharetra','libero a pharetra',0,1,1.5667,'L161636',6,'*'),(719,'maecenas','maecenas',0,0,0.5333,'M252',26,'*'),(720,'maecenas faucibus','maecenas faucibus',0,1,1.5667,'M2521212',6,'*'),(721,'maecenas faucibus mollis','maecenas faucibus mollis',0,1,1.8,'M2521212542',6,'*'),(722,'magna maecenas','magna maecenas',0,1,1.4667,'M25252',6,'*'),(723,'magna maecenas faucibus','magna maecenas faucibus',0,1,1.7667,'M252521212',6,'*'),(724,'mollis interdum','mollis interdum',0,1,1.5,'M4253635',6,'*'),(725,'mollis interdum morbi','mollis interdum morbi',0,1,1.7,'M425363561',6,'*'),(726,'morbi','morbi',0,0,0.3333,'M610',6,'*'),(727,'morbi leo','morbi leo',0,1,1.3,'M614',6,'*'),(728,'morbi leo risus','morbi leo risus',0,1,1.5,'M61462',6,'*'),(729,'most','most',0,0,0.2667,'M230',3,'*'),(730,'most iconic','most iconic',0,1,1.3667,'M23252',2,'*'),(731,'most iconic series','most iconic series',0,1,1.6,'M2325262',2,'*'),(732,'my','my',0,0,0.1333,'M000',4,'*'),(733,'my pleasure','my pleasure',0,1,1.3667,'M1426',2,'*'),(734,'non magna','non magna',0,1,1.3,'N250',6,'*'),(735,'non magna maecenas','non magna maecenas',0,1,1.6,'N25252',6,'*'),(736,'nulla vitae','nulla vitae',0,1,1.3667,'N413',6,'*'),(737,'nulla vitae elit','nulla vitae elit',0,1,1.5333,'N41343',6,'*'),(738,'of games','of games',0,1,1.2667,'O1252',2,'*'),(739,'of games tomb','of games tomb',0,1,1.4333,'O1252351',2,'*'),(740,'of the','of the',0,1,1.2,'O130',4,'*'),(741,'of the most','of the most',0,1,1.3667,'O13523',3,'*'),(742,'one','one',0,0,0.2,'O500',3,'*'),(743,'one of','one of',0,1,1.2,'O510',3,'*'),(744,'one of the','one of the',0,1,1.3333,'O513',3,'*'),(745,'pharetra augue','pharetra augue',0,1,1.4667,'P6362',6,'*'),(746,'pleasure','pleasure',0,0,0.5333,'P426',2,'*'),(747,'porta ac','porta ac',0,1,1.2667,'P632',6,'*'),(748,'porta ac consectetur','porta ac consectetur',0,1,1.6667,'P6325236',6,'*'),(749,'raider','raider',0,0,0.4,'R360',2,'*'),(750,'raider is','raider is',0,1,1.3,'R362',2,'*'),(751,'raider is risus','raider is risus',0,1,1.5,'R36262',2,'*'),(752,'risus porta','risus porta',0,1,1.3667,'R2163',6,'*'),(753,'risus porta ac','risus porta ac',0,1,1.4667,'R21632',6,'*'),(754,'risus varius','risus varius',0,1,1.4,'R2162',6,'*'),(755,'risus varius blandit','risus varius blandit',0,1,1.6667,'R21621453',6,'*'),(756,'series','series',0,0,0.4,'S620',3,'*'),(757,'series in','series in',0,1,1.3,'S625',2,'*'),(758,'series in the','series in the',0,1,1.4333,'S6253',2,'*'),(759,'sit amet non','sit amet non',0,1,1.4,'S3535',6,'*'),(760,'the history','the history',0,1,1.3667,'T236',2,'*'),(761,'the history of','the history of',0,1,1.4667,'T2361',2,'*'),(762,'the most','the most',0,1,1.2667,'T523',3,'*'),(763,'the most iconic','the most iconic',0,1,1.5,'T523252',2,'*'),(764,'tomb','tomb',0,0,0.2667,'T510',2,'*'),(765,'tomb raider','tomb raider',0,1,1.3667,'T51636',2,'*'),(766,'tomb raider is','tomb raider is',0,1,1.4667,'T516362',2,'*'),(767,'varius','varius',0,0,0.4,'V620',28,'*'),(768,'varius blandit','varius blandit',0,1,1.4667,'V621453',6,'*'),(769,'varius blandit sit','varius blandit sit',0,1,1.6,'V62145323',6,'*'),(770,'vestibulum at','vestibulum at',0,1,1.4333,'V231453',6,'*'),(771,'vestibulum at eros','vestibulum at eros',0,1,1.6,'V23145362',6,'*'),(772,'vitae elit','vitae elit',0,1,1.3333,'V343',6,'*'),(773,'vitae elit libero','vitae elit libero',0,1,1.5667,'V343416',6,'*'),(792,'10','10',0,0,0.2,'',7,'*'),(793,'concept of','concept of',0,1,1.3333,'C52131',2,'*'),(794,'concept of pictures','concept of pictures',0,1,1.6333,'C521312362',2,'*'),(795,'figures','figures',0,0,0.4667,'F262',2,'*'),(796,'in terms','in terms',0,1,1.2667,'I53652',2,'*'),(797,'in terms of','in terms of',0,1,1.3667,'I536521',2,'*'),(798,'of figures','of figures',0,1,1.3333,'O1262',2,'*'),(799,'of pictures','of pictures',0,1,1.3667,'O12362',2,'*'),(800,'of pictures in','of pictures in',0,1,1.4667,'O123625',2,'*'),(801,'pictures','pictures',0,0,0.5333,'P2362',2,'*'),(802,'pictures in','pictures in',0,1,1.3667,'P23625',2,'*'),(803,'pictures in terms','pictures in terms',0,1,1.5667,'P236253652',2,'*'),(804,'terms','terms',0,0,0.3333,'T652',2,'*'),(805,'terms of','terms of',0,1,1.2667,'T6521',2,'*'),(806,'terms of figures','terms of figures',0,1,1.5333,'T6521262',2,'*'),(807,'11','11',0,0,0.2,'',5,'*'),(808,'by','by',0,0,0.1333,'B000',4,'*'),(809,'by nature','by nature',0,1,1.3,'B536',3,'*'),(810,'by nature design','by nature design',0,1,1.5333,'B536325',2,'*'),(811,'inspired','inspired',0,0,0.5333,'I52163',3,'*'),(812,'inspired by','inspired by',0,1,1.3667,'I521631',3,'*'),(813,'inspired by nature','inspired by nature',0,1,1.6,'I521631536',3,'*'),(814,'nature design','nature design',0,1,1.4333,'N36325',2,'*'),(815,'stretch','stretch',0,0,0.4667,'S3632',2,'*'),(816,'stretch inspired','stretch inspired',0,1,1.5333,'S363252163',2,'*'),(817,'stretch inspired by','stretch inspired by',0,1,1.6333,'S3632521631',2,'*'),(822,'12','12',0,0,0.2,'',7,'*'),(823,'casual','casual',0,0,0.4,'C400',2,'*'),(824,'casual mind','casual mind',0,1,1.3667,'C453',2,'*'),(825,'casual mind shot','casual mind shot',0,1,1.5333,'C45323',2,'*'),(826,'diam eget','diam eget',0,1,1.3,'D523',4,'*'),(827,'diam eget risus','diam eget risus',0,1,1.5,'D52362',4,'*'),(828,'dream','dream',0,0,0.3333,'D650',2,'*'),(829,'eget risus','eget risus',0,1,1.3333,'E2362',4,'*'),(830,'eget risus varius','eget risus varius',0,1,1.5667,'E2362162',4,'*'),(831,'euismod maecenas','euismod maecenas',0,1,1.5333,'E2535252',4,'*'),(832,'euismod maecenas sed','euismod maecenas sed',0,1,1.6667,'E25352523',4,'*'),(833,'from','from',0,0,0.2667,'F650',5,'*'),(834,'from my','from my',0,1,1.2333,'F650',2,'*'),(835,'from my dream','from my dream',0,1,1.4333,'F65365',2,'*'),(836,'maecenas sed','maecenas sed',0,1,1.4,'M2523',4,'*'),(837,'maecenas sed diam','maecenas sed diam',0,1,1.5667,'M25235',4,'*'),(838,'mind','mind',0,0,0.2667,'M300',2,'*'),(839,'mind shot','mind shot',0,1,1.3,'M323',2,'*'),(840,'mind shot from','mind shot from',0,1,1.4667,'M323165',2,'*'),(841,'mollis euismod maecenas','mollis euismod maecenas',0,1,1.7667,'M42535252',4,'*'),(842,'my dream','my dream',0,1,1.2667,'M365',2,'*'),(843,'sed diam','sed diam',0,1,1.2667,'S350',4,'*'),(844,'sed diam eget','sed diam eget',0,1,1.4333,'S3523',4,'*'),(845,'shot','shot',0,0,0.2667,'S300',2,'*'),(846,'shot from','shot from',0,1,1.3,'S3165',2,'*'),(847,'shot from my','shot from my',0,1,1.4,'S3165',2,'*'),(853,'13','13',0,0,0.2,'',5,'*'),(854,'professional','professional',0,0,0.8,'P61254',2,'*'),(855,'professional design','professional design',0,1,1.6333,'P61254325',2,'*'),(856,'top','top',0,0,0.2,'T100',4,'*'),(857,'top professional','top professional',0,1,1.5333,'T161254',2,'*'),(858,'top professional design','top professional design',0,1,1.7667,'T161254325',2,'*'),(859,'wordpress','wordpress',0,0,0.6,'W63162',2,'*'),(860,'wordpress top','wordpress top',0,1,1.4333,'W6316231',2,'*'),(861,'wordpress top professional','wordpress top professional',0,1,1.8667,'W631623161254',2,'*'),(868,'14','14',0,0,0.2,'',5,'*'),(869,'and sketch','and sketch',0,1,1.3333,'A53232',2,'*'),(870,'and sketch compelling','and sketch compelling',0,1,1.7,'A5323251452',2,'*'),(871,'categorie v','categorie v',0,1,1.3667,'C3261',4,'*'),(872,'compelling','compelling',0,0,0.6667,'C51452',2,'*'),(873,'design ideas','design ideas',0,1,1.4,'D2532',2,'*'),(874,'design ideas and','design ideas and',0,1,1.5333,'D253253',2,'*'),(875,'explore','explore',0,0,0.4667,'E2146',2,'*'),(876,'explore design','explore design',0,1,1.4667,'E2146325',2,'*'),(877,'explore design ideas','explore design ideas',0,1,1.6667,'E214632532',2,'*'),(878,'ideas and','ideas and',0,1,1.3,'I3253',2,'*'),(879,'ideas and sketch','ideas and sketch',0,1,1.5333,'I3253232',2,'*'),(880,'sketch','sketch',0,0,0.4,'S320',2,'*'),(881,'sketch compelling','sketch compelling',0,1,1.5667,'S3251452',2,'*'),(882,'v','v',0,0,0.0667,'V000',4,'*'),(883,'15','15',0,0,0.2,'',4,'*'),(884,'advertising','advertising',0,0,0.7333,'A3163252',2,'*'),(885,'advertising marketing','advertising marketing',0,1,1.7,'A3163252562352',2,'*'),(886,'advertising marketing and','advertising marketing and',0,1,1.8333,'A316325256235253',2,'*'),(887,'agency','agency',0,0,0.4,'A252',4,'*'),(888,'and design','and design',0,1,1.3333,'A5325',2,'*'),(889,'and design agency','and design agency',0,1,1.5667,'A5325252',2,'*'),(890,'design agency','design agency',0,1,1.4333,'D25252',4,'*'),(891,'marketing','marketing',0,0,0.6,'M62352',2,'*'),(892,'marketing and','marketing and',0,1,1.4333,'M6235253',2,'*'),(893,'marketing and design','marketing and design',0,1,1.6667,'M623525325',2,'*'),(898,'16','16',0,0,0.2,'',4,'*'),(899,'a design','a design',0,1,1.2667,'A325',2,'*'),(900,'an','an',0,0,0.1333,'A500',3,'*'),(901,'an idea','an idea',0,1,1.2333,'A530',2,'*'),(902,'an idea for','an idea for',0,1,1.3667,'A5316',2,'*'),(903,'concept is','concept is',0,1,1.3333,'C52132',2,'*'),(904,'concept is an','concept is an',0,1,1.4333,'C521325',2,'*'),(905,'design concept','design concept',0,1,1.4667,'D2525213',2,'*'),(906,'design concept is','design concept is',0,1,1.5667,'D25252132',2,'*'),(907,'for a','for a',0,1,1.1667,'F600',2,'*'),(908,'for a design','for a design',0,1,1.4,'F6325',2,'*'),(909,'idea','idea',0,0,0.2667,'I300',2,'*'),(910,'idea for','idea for',0,1,1.2667,'I316',2,'*'),(911,'idea for a','idea for a',0,1,1.3333,'I316',2,'*'),(912,'is an','is an',0,1,1.1667,'I250',2,'*'),(913,'is an idea','is an idea',0,1,1.3333,'I253',2,'*'),(929,'17','17',0,0,0.2,'',4,'*'),(930,'create','create',0,0,0.4,'C630',2,'*'),(931,'create until','create until',0,1,1.4,'C63534',2,'*'),(932,'create until the','create until the',0,1,1.5333,'C635343',2,'*'),(933,'ends','ends',0,0,0.2667,'E532',2,'*'),(934,'ends inspiration','ends inspiration',0,1,1.5333,'E532521635',2,'*'),(935,'inspiration','inspiration',0,0,0.7333,'I521635',2,'*'),(936,'the world','the world',0,1,1.3,'T643',2,'*'),(937,'the world ends','the world ends',0,1,1.4667,'T643532',2,'*'),(938,'until','until',0,0,0.3333,'U534',2,'*'),(939,'until the','until the',0,1,1.3,'U5343',2,'*'),(940,'until the world','until the world',0,1,1.5,'U5343643',2,'*'),(941,'world','world',0,0,0.3333,'W643',10,'*'),(942,'world ends','world ends',0,1,1.3333,'W643532',2,'*'),(943,'world ends inspiration','world ends inspiration',0,1,1.7333,'W643532521635',2,'*'),(944,'18','18',0,0,0.2,'',5,'*'),(945,'and power','and power',0,1,1.3,'A5316',2,'*'),(946,'and power of','and power of',0,1,1.4,'A53161',2,'*'),(947,'art','art',0,0,0.2,'A630',2,'*'),(948,'art direction','art direction',0,1,1.4333,'A636235',2,'*'),(949,'art direction and','art direction and',0,1,1.5667,'A6362353',2,'*'),(950,'craft','craft',0,0,0.3333,'C613',2,'*'),(951,'craft of','craft of',0,1,1.2667,'C6131',2,'*'),(952,'craft of art','craft of art',0,1,1.4,'C613163',2,'*'),(953,'direction','direction',0,0,0.6,'D6235',2,'*'),(954,'direction and','direction and',0,1,1.4333,'D62353',2,'*'),(955,'direction and power','direction and power',0,1,1.6333,'D6235316',2,'*'),(956,'of art','of art',0,1,1.2,'O163',2,'*'),(957,'of art direction','of art direction',0,1,1.5333,'O1636235',2,'*'),(958,'of ideas','of ideas',0,1,1.2667,'O132',2,'*'),(959,'power','power',0,0,0.3333,'P600',2,'*'),(960,'power of','power of',0,1,1.2667,'P610',2,'*'),(961,'power of ideas','power of ideas',0,1,1.4667,'P6132',2,'*'),(962,'the craft','the craft',0,1,1.3,'T2613',2,'*'),(963,'the craft of','the craft of',0,1,1.4,'T26131',2,'*'),(975,'19','19',0,0,0.2,'',6,'*'),(976,'and website','and website',0,1,1.3667,'A53123',2,'*'),(977,'and website design','and website design',0,1,1.6,'A5312325',2,'*'),(978,'design and','design and',0,1,1.3333,'D253',4,'*'),(979,'design and website','design and website',0,1,1.6,'D253123',2,'*'),(980,'graphic','graphic',0,0,0.4667,'G612',2,'*'),(981,'graphic design','graphic design',0,1,1.4667,'G612325',2,'*'),(982,'graphic design and','graphic design and',0,1,1.6,'G6123253',2,'*'),(983,'website','website',0,0,0.4667,'W123',2,'*'),(984,'website design','website design',0,1,1.4667,'W12325',2,'*'),(985,'website design agency','website design agency',0,1,1.7,'W12325252',2,'*'),(990,'20','20',0,0,0.2,'',5,'*'),(991,'artistic','artistic',0,0,0.5333,'A63232',2,'*'),(992,'artistic rendering','artistic rendering',0,1,1.6,'A63232653652',2,'*'),(993,'artistic rendering combines','artistic rendering combines',0,1,1.9,'A632326536525152',2,'*'),(994,'combines','combines',0,0,0.5333,'C5152',2,'*'),(995,'combines design','combines design',0,1,1.5,'C5152325',2,'*'),(996,'rendering','rendering',0,0,0.6,'R53652',2,'*'),(997,'rendering combines','rendering combines',0,1,1.6,'R536525152',2,'*'),(998,'rendering combines design','rendering combines design',0,1,1.8333,'R536525152325',2,'*'),(999,'the artistic','the artistic',0,1,1.4,'T63232',2,'*'),(1000,'the artistic rendering','the artistic rendering',0,1,1.7333,'T63232653652',2,'*'),(1005,'s','s',0,0,0.0667,'S000',16,'*'),(1006,'u','u',0,0,0.0667,'U000',12,'*'),(1007,'u s','u s',0,1,1.1,'U200',12,'*'),(1008,'politics','politics',0,0,0.5333,'P432',10,'*'),(1009,'economic','economic',0,0,0.5333,'E252',9,'*'),(1010,'sports','sports',0,0,0.4,'S1632',9,'*'),(1011,'a national','a national',0,1,1.3333,'A5354',3,'*'),(1012,'a national crisis','a national crisis',0,1,1.5667,'A5354262',3,'*'),(1013,'become','become',0,0,0.4,'B250',3,'*'),(1014,'become a','become a',0,1,1.2667,'B250',3,'*'),(1015,'become a national','become a national',0,1,1.5667,'B25354',3,'*'),(1016,'crisis','crisis',0,0,0.4,'C620',3,'*'),(1017,'has','has',0,0,0.2,'H200',10,'*'),(1018,'has become','has become',0,1,1.3333,'H2125',3,'*'),(1019,'has become a','has become a',0,1,1.4,'H2125',3,'*'),(1020,'in iraq','in iraq',0,1,1.2333,'I562',3,'*'),(1021,'in iraq has','in iraq has',0,1,1.3667,'I562',3,'*'),(1022,'iraq','iraq',0,0,0.2667,'I620',3,'*'),(1023,'iraq has','iraq has',0,1,1.2667,'I620',3,'*'),(1024,'iraq has become','iraq has become',0,1,1.5,'I62125',3,'*'),(1025,'national','national',0,0,0.5333,'N354',3,'*'),(1026,'national crisis','national crisis',0,1,1.5,'N354262',3,'*'),(1027,'of women','of women',0,1,1.2667,'O150',3,'*'),(1028,'of women in','of women in',0,1,1.3667,'O150',3,'*'),(1029,'role','role',0,0,0.2667,'R400',3,'*'),(1030,'role of','role of',0,1,1.2333,'R410',3,'*'),(1031,'role of women','role of women',0,1,1.4333,'R415',3,'*'),(1032,'status','status',0,0,0.4,'S320',3,'*'),(1033,'status role','status role',0,1,1.3667,'S3264',3,'*'),(1034,'status role of','status role of',0,1,1.4667,'S32641',3,'*'),(1035,'the status','the status',0,1,1.3333,'T232',3,'*'),(1036,'the status role','the status role',0,1,1.5,'T23264',3,'*'),(1037,'women','women',0,0,0.3333,'W500',3,'*'),(1038,'women in','women in',0,1,1.2667,'W500',3,'*'),(1039,'women in iraq','women in iraq',0,1,1.4333,'W562',3,'*'),(1042,'cameron','cameron',0,0,0.4667,'C565',2,'*'),(1043,'cameron\'s','cameron',0,0,0.6,'C5652',2,'*'),(1044,'cameron\'s personal','cameron personal',0,1,1.6,'C565216254',2,'*'),(1045,'cameron\'s personal popularity','cameron personal popularity',0,1,1.9667,'C5652162541463',2,'*'),(1046,'david','david',0,0,0.3333,'D130',2,'*'),(1047,'david cameron','david cameron',0,1,1.4333,'D132565',2,'*'),(1048,'david cameron\'s','david cameron',0,1,1.5,'D1325652',2,'*'),(1049,'david cameron\'s personal','david cameron personal',0,1,1.8,'D132565216254',2,'*'),(1050,'dropped','dropped',0,0,0.4667,'D613',2,'*'),(1051,'dropped to','dropped to',0,1,1.3333,'D613',2,'*'),(1052,'dropped to lowest','dropped to lowest',0,1,1.5667,'D613423',2,'*'),(1053,'has dropped','has dropped',0,1,1.3667,'H23613',2,'*'),(1054,'has dropped to','has dropped to',0,1,1.4667,'H23613',2,'*'),(1055,'lowest','lowest',0,0,0.4,'L230',2,'*'),(1056,'lowest rate','lowest rate',0,1,1.3667,'L2363',2,'*'),(1057,'personal','personal',0,0,0.5333,'P6254',2,'*'),(1058,'personal popularity','personal popularity',0,1,1.6333,'P62541463',2,'*'),(1059,'personal popularity has','personal popularity has',0,1,1.7667,'P625414632',2,'*'),(1060,'popularity','popularity',0,0,0.6667,'P463',2,'*'),(1061,'popularity has','popularity has',0,1,1.4667,'P4632',2,'*'),(1062,'popularity has dropped','popularity has dropped',0,1,1.7333,'P46323613',2,'*'),(1063,'rate','rate',0,0,0.2667,'R300',2,'*'),(1064,'to','to',0,0,0.1333,'T000',11,'*'),(1065,'to lowest','to lowest',0,1,1.3,'T423',2,'*'),(1066,'to lowest rate','to lowest rate',0,1,1.4667,'T42363',2,'*'),(1073,'2012','2012',0,0,0.4,'',3,'*'),(1074,'economy','economy',0,0,0.4667,'E250',2,'*'),(1075,'economy grew','economy grew',0,1,1.4,'E2526',2,'*'),(1076,'economy grew faster','economy grew faster',0,1,1.6333,'E25261236',2,'*'),(1077,'faster','faster',0,0,0.4,'F236',2,'*'),(1078,'faster in','faster in',0,1,1.3,'F2365',2,'*'),(1079,'faster in third','faster in third',0,1,1.5,'F2365363',2,'*'),(1080,'grew','grew',0,0,0.2667,'G600',2,'*'),(1081,'grew faster','grew faster',0,1,1.3667,'G61236',2,'*'),(1082,'grew faster in','grew faster in',0,1,1.4667,'G612365',2,'*'),(1083,'in third','in third',0,1,1.2667,'I5363',2,'*'),(1084,'in third quarter','in third quarter',0,1,1.5333,'I53632636',2,'*'),(1085,'of 2012','of 2012',0,1,1.2333,'O100',2,'*'),(1086,'quarter','quarter',0,0,0.4667,'Q636',2,'*'),(1087,'quarter of','quarter of',0,1,1.3333,'Q6361',2,'*'),(1088,'quarter of 2012','quarter of 2012',0,1,1.5,'Q6361',2,'*'),(1089,'s economy','s economy',0,1,1.3,'S500',2,'*'),(1090,'s economy grew','s economy grew',0,1,1.4667,'S526',2,'*'),(1091,'third','third',0,0,0.3333,'T630',2,'*'),(1092,'third quarter','third quarter',0,1,1.4333,'T632636',2,'*'),(1093,'third quarter of','third quarter of',0,1,1.5333,'T6326361',2,'*'),(1094,'u s economy','u s economy',0,1,1.3667,'U250',2,'*'),(1095,'us','us',0,0,0.1333,'U200',6,'*'),(1096,'us economy','us economy',0,1,1.3333,'U250',2,'*'),(1097,'us economy grew','us economy grew',0,1,1.5,'U2526',2,'*'),(1104,'2013','2013',0,0,0.4,'',4,'*'),(1105,'a million','a million',0,1,1.3,'A545',2,'*'),(1106,'a million more','a million more',0,1,1.4667,'A5456',2,'*'),(1107,'assange','assange',0,0,0.4667,'A252',2,'*'),(1108,'assange expect','assange expect',0,1,1.4667,'A252123',2,'*'),(1109,'assange expect a','assange expect a',0,1,1.5333,'A252123',2,'*'),(1110,'docs','docs',0,0,0.2667,'D200',2,'*'),(1111,'docs in','docs in',0,1,1.2333,'D250',2,'*'),(1112,'docs in 2013','docs in 2013',0,1,1.4,'D250',2,'*'),(1113,'expect','expect',0,0,0.4,'E2123',2,'*'),(1114,'expect a','expect a',0,1,1.2667,'E2123',2,'*'),(1115,'expect a million','expect a million',0,1,1.5333,'E2123545',2,'*'),(1116,'in 2013','in 2013',0,1,1.2333,'I500',3,'*'),(1117,'julian','julian',0,0,0.4,'J450',2,'*'),(1118,'julian assange','julian assange',0,1,1.4667,'J45252',2,'*'),(1119,'julian assange expect','julian assange expect',0,1,1.7,'J45252123',2,'*'),(1120,'million','million',0,0,0.4667,'M450',2,'*'),(1121,'million more','million more',0,1,1.4,'M456',2,'*'),(1122,'million more wikileaks','million more wikileaks',0,1,1.7333,'M456242',2,'*'),(1123,'more','more',0,0,0.2667,'M600',3,'*'),(1124,'more wikileaks','more wikileaks',0,1,1.4667,'M6242',2,'*'),(1125,'more wikileaks docs','more wikileaks docs',0,1,1.6333,'M624232',2,'*'),(1126,'wikileaks','wikileaks',0,0,0.6,'W242',2,'*'),(1127,'wikileaks docs','wikileaks docs',0,1,1.4667,'W24232',2,'*'),(1128,'wikileaks docs in','wikileaks docs in',0,1,1.5667,'W242325',2,'*'),(1135,'and iran','and iran',0,1,1.2667,'A5365',2,'*'),(1136,'and iran to','and iran to',0,1,1.3667,'A53653',2,'*'),(1137,'bring','bring',0,0,0.3333,'B652',2,'*'),(1138,'bring russia','bring russia',0,1,1.4,'B65262',2,'*'),(1139,'bring russia and','bring russia and',0,1,1.5333,'B6526253',2,'*'),(1140,'discussion','discussion',0,0,0.6667,'D250',7,'*'),(1141,'international','international',0,0,0.8667,'I5365354',2,'*'),(1142,'international discussion','international discussion',0,1,1.8,'I5365354325',2,'*'),(1143,'iran','iran',0,0,0.2667,'I650',2,'*'),(1144,'iran to','iran to',0,1,1.2333,'I653',2,'*'),(1145,'iran to the','iran to the',0,1,1.3667,'I653',2,'*'),(1146,'russia','russia',0,0,0.4,'R200',2,'*'),(1147,'russia and','russia and',0,1,1.3333,'R253',2,'*'),(1148,'russia and iran','russia and iran',0,1,1.5,'R25365',2,'*'),(1149,'save','save',0,0,0.2667,'S100',2,'*'),(1150,'save syria','save syria',0,1,1.3333,'S126',2,'*'),(1151,'save syria bring','save syria bring',0,1,1.5333,'S1261652',2,'*'),(1152,'syria','syria',0,0,0.3333,'S600',2,'*'),(1153,'syria bring','syria bring',0,1,1.3667,'S61652',2,'*'),(1154,'syria bring russia','syria bring russia',0,1,1.6,'S6165262',2,'*'),(1155,'the international','the international',0,1,1.5667,'T5365354',2,'*'),(1156,'the international discussion','the international discussion',0,1,1.9333,'T5365354325',2,'*'),(1157,'to save','to save',0,1,1.2333,'T210',2,'*'),(1158,'to save syria','to save syria',0,1,1.4333,'T2126',2,'*'),(1159,'to the','to the',0,1,1.2,'T000',2,'*'),(1160,'to the international','to the international',0,1,1.6667,'T5365354',2,'*'),(1166,'and portugal','and portugal',0,1,1.4,'A5316324',2,'*'),(1167,'clashed','clashed',0,0,0.4667,'C423',2,'*'),(1168,'clashed with','clashed with',0,1,1.4,'C423',2,'*'),(1169,'clashed with protesters','clashed with protesters',0,1,1.7667,'C4231632362',2,'*'),(1170,'have','have',0,0,0.2667,'H100',2,'*'),(1171,'have clashed','have clashed',0,1,1.4,'H12423',2,'*'),(1172,'have clashed with','have clashed with',0,1,1.5667,'H12423',2,'*'),(1173,'in spain','in spain',0,1,1.2667,'I5215',2,'*'),(1174,'in spain italy','in spain italy',0,1,1.4667,'I521534',2,'*'),(1175,'italy','italy',0,0,0.3333,'I340',2,'*'),(1176,'italy and','italy and',0,1,1.3,'I3453',2,'*'),(1177,'italy and portugal','italy and portugal',0,1,1.6,'I345316324',2,'*'),(1178,'police','police',0,0,0.4,'P420',2,'*'),(1179,'police have','police have',0,1,1.3667,'P421',2,'*'),(1180,'police have clashed','police have clashed',0,1,1.6333,'P4212423',2,'*'),(1181,'portugal','portugal',0,0,0.5333,'P6324',2,'*'),(1182,'protesters','protesters',0,0,0.6667,'P632362',2,'*'),(1183,'protesters in','protesters in',0,1,1.4333,'P6323625',2,'*'),(1184,'protesters in spain','protesters in spain',0,1,1.6333,'P6323625215',2,'*'),(1185,'riot','riot',0,0,0.2667,'R300',2,'*'),(1186,'riot police','riot police',0,1,1.3667,'R3142',2,'*'),(1187,'riot police have','riot police have',0,1,1.5333,'R31421',2,'*'),(1188,'spain','spain',0,0,0.3333,'S150',2,'*'),(1189,'spain italy','spain italy',0,1,1.3667,'S1534',2,'*'),(1190,'spain italy and','spain italy and',0,1,1.5,'S153453',2,'*'),(1191,'with','with',0,0,0.2667,'W300',7,'*'),(1192,'with protesters','with protesters',0,1,1.5,'W31632362',2,'*'),(1193,'with protesters in','with protesters in',0,1,1.6,'W316323625',2,'*'),(1197,'after','after',0,0,0.3333,'A136',5,'*'),(1198,'after school','after school',0,1,1.4,'A13624',3,'*'),(1199,'after school shooting','after school shooting',0,1,1.7,'A136242352',3,'*'),(1200,'community','community',0,0,0.6,'C530',3,'*'),(1201,'community in','community in',0,1,1.4,'C535',3,'*'),(1202,'community in shock','community in shock',0,1,1.6,'C5352',3,'*'),(1203,'in shock','in shock',0,1,1.2667,'I520',3,'*'),(1204,'in shock after','in shock after',0,1,1.4667,'I52136',3,'*'),(1205,'newtown','newtown',0,0,0.4667,'N350',5,'*'),(1206,'newtown community','newtown community',0,1,1.5667,'N35253',3,'*'),(1207,'newtown community in','newtown community in',0,1,1.6667,'N352535',3,'*'),(1208,'school','school',0,0,0.4,'S400',3,'*'),(1209,'school shooting','school shooting',0,1,1.5,'S42352',3,'*'),(1210,'shock','shock',0,0,0.3333,'S000',3,'*'),(1211,'shock after','shock after',0,1,1.3667,'S136',3,'*'),(1212,'shock after school','shock after school',0,1,1.6,'S13624',3,'*'),(1213,'shooting','shooting',0,0,0.5333,'S352',5,'*'),(1228,'armed','armed',0,0,0.3333,'A653',2,'*'),(1229,'armed insurgents','armed insurgents',0,1,1.5333,'A6535262532',2,'*'),(1230,'armed insurgents attacked','armed insurgents attacked',0,1,1.8333,'A6535262532323',2,'*'),(1231,'attacked','attacked',0,0,0.5333,'A323',2,'*'),(1232,'attacked u','attacked u',0,1,1.3333,'A323',2,'*'),(1233,'attacked u s','attacked u s',0,1,1.4,'A3232',2,'*'),(1234,'attacked us','attacked us',0,1,1.3667,'A3232',2,'*'),(1235,'attacked us marines','attacked us marines',0,1,1.6333,'A32325652',2,'*'),(1236,'heavily','heavily',0,0,0.4667,'H140',2,'*'),(1237,'heavily armed','heavily armed',0,1,1.4333,'H14653',2,'*'),(1238,'heavily armed insurgents','heavily armed insurgents',0,1,1.8,'H146535262532',2,'*'),(1239,'insurgents','insurgents',0,0,0.6667,'I5262532',2,'*'),(1240,'insurgents attacked','insurgents attacked',0,1,1.6333,'I5262532323',2,'*'),(1241,'insurgents attacked u','insurgents attacked u',0,1,1.7,'I5262532323',2,'*'),(1242,'insurgents attacked us','insurgents attacked us',0,1,1.7333,'I52625323232',2,'*'),(1243,'marines','marines',0,0,0.4667,'M652',2,'*'),(1244,'s marines','s marines',0,1,1.3,'S5652',2,'*'),(1245,'u s marines','u s marines',0,1,1.3667,'U25652',2,'*'),(1246,'us marines','us marines',0,1,1.3333,'U25652',2,'*'),(1259,'a big','a big',0,1,1.1667,'A120',2,'*'),(1260,'a big step','a big step',0,1,1.3333,'A1231',2,'*'),(1261,'arnold','arnold',0,0,0.4,'A6543',2,'*'),(1262,'arnold schwarzenegger','arnold schwarzenegger',0,1,1.7,'A6543262526',2,'*'),(1263,'arnold schwarzenegger took','arnold schwarzenegger took',0,1,1.8667,'A654326252632',2,'*'),(1264,'back','back',0,0,0.2667,'B200',2,'*'),(1265,'big','big',0,0,0.2,'B200',2,'*'),(1266,'big step','big step',0,1,1.2667,'B231',2,'*'),(1267,'big step back','big step back',0,1,1.4333,'B2312',2,'*'),(1268,'california','california',0,0,0.6667,'C4165',2,'*'),(1269,'california governor','california governor',0,1,1.6333,'C416521656',2,'*'),(1270,'california governor arnold','california governor arnold',0,1,1.8667,'C416521656543',2,'*'),(1271,'former','former',0,0,0.4,'F656',2,'*'),(1272,'former california','former california',0,1,1.5667,'F65624165',2,'*'),(1273,'former california governor','former california governor',0,1,1.8667,'F6562416521656',2,'*'),(1274,'governor','governor',0,0,0.5333,'G1656',2,'*'),(1275,'governor arnold','governor arnold',0,1,1.5,'G1656543',2,'*'),(1276,'governor arnold schwarzenegger','governor arnold schwarzenegger',0,1,2,'G1656543262526',2,'*'),(1277,'schwarzenegger','schwarzenegger',0,0,0.9333,'S62526',2,'*'),(1278,'schwarzenegger took','schwarzenegger took',0,1,1.6333,'S6252632',2,'*'),(1279,'schwarzenegger took a','schwarzenegger took a',0,1,1.7,'S6252632',2,'*'),(1280,'step','step',0,0,0.2667,'S310',2,'*'),(1281,'step back','step back',0,1,1.3,'S312',2,'*'),(1282,'took','took',0,0,0.2667,'T200',2,'*'),(1283,'took a','took a',0,1,1.2,'T200',2,'*'),(1284,'took a big','took a big',0,1,1.3333,'T212',2,'*'),(1290,'control','control',0,0,0.4667,'C5364',2,'*'),(1291,'discussion on','discussion on',0,1,1.4333,'D250',5,'*'),(1292,'discussion on us','discussion on us',0,1,1.5333,'D252',2,'*'),(1293,'gun','gun',0,0,0.2,'G500',2,'*'),(1294,'gun control','gun control',0,1,1.3667,'G525364',2,'*'),(1295,'media','media',0,0,0.3333,'M300',2,'*'),(1296,'media discussion','media discussion',0,1,1.5333,'M325',2,'*'),(1297,'media discussion on','media discussion on',0,1,1.6333,'M325',2,'*'),(1298,'of media','of media',0,1,1.2667,'O153',2,'*'),(1299,'of media discussion','of media discussion',0,1,1.6333,'O15325',2,'*'),(1300,'on us','on us',0,1,1.1667,'O520',2,'*'),(1301,'on us gun','on us gun',0,1,1.3,'O525',2,'*'),(1302,'unprecedented','unprecedented',0,0,0.8667,'U5162353',2,'*'),(1303,'unprecedented wave','unprecedented wave',0,1,1.6,'U51623531',2,'*'),(1304,'unprecedented wave of','unprecedented wave of',0,1,1.7,'U51623531',2,'*'),(1305,'us gun','us gun',0,1,1.2,'U250',2,'*'),(1306,'us gun control','us gun control',0,1,1.4667,'U2525364',2,'*'),(1307,'wave','wave',0,0,0.2667,'W100',2,'*'),(1308,'wave of','wave of',0,1,1.2333,'W100',2,'*'),(1309,'wave of media','wave of media',0,1,1.4333,'W153',2,'*'),(1321,'after newtown','after newtown',0,1,1.4333,'A136535',2,'*'),(1322,'after newtown shooting','after newtown shooting',0,1,1.7333,'A1365352352',2,'*'),(1323,'cashed','cashed',0,0,0.4,'C300',2,'*'),(1324,'cashed in','cashed in',0,1,1.3,'C350',2,'*'),(1325,'cashed in three','cashed in three',0,1,1.5,'C3536',2,'*'),(1326,'days','days',0,0,0.2667,'D200',4,'*'),(1327,'days after','days after',0,1,1.3333,'D2136',2,'*'),(1328,'days after newtown','days after newtown',0,1,1.6,'D2136535',2,'*'),(1329,'in three','in three',0,1,1.2667,'I536',2,'*'),(1330,'in three days','in three days',0,1,1.4333,'I53632',2,'*'),(1331,'newtown shooting','newtown shooting',0,1,1.5333,'N352352',2,'*'),(1332,'nra','nra',0,0,0.2,'N600',2,'*'),(1333,'nra cashed','nra cashed',0,1,1.3333,'N623',2,'*'),(1334,'nra cashed in','nra cashed in',0,1,1.4333,'N6235',2,'*'),(1335,'the nra','the nra',0,1,1.2333,'T560',2,'*'),(1336,'the nra cashed','the nra cashed',0,1,1.4667,'T5623',2,'*'),(1337,'three','three',0,0,0.3333,'T600',4,'*'),(1338,'three days','three days',0,1,1.3333,'T632',2,'*'),(1339,'three days after','three days after',0,1,1.5333,'T632136',2,'*'),(1352,'2.1','2.1',0,0,0.3,'',3,'*'),(1353,'2.1 billion','2.1 billion',0,1,1.3667,'B450',3,'*'),(1354,'2.1 billion loss','2.1 billion loss',0,1,1.5333,'B4542',3,'*'),(1355,'21','21',0,0,0.2,'',6,'*'),(1356,'21 billion','21 billion',0,1,1.3333,'B450',3,'*'),(1357,'21 billion loss','21 billion loss',0,1,1.5,'B4542',3,'*'),(1358,'billion','billion',0,0,0.4667,'B450',3,'*'),(1359,'billion loss','billion loss',0,1,1.4,'B4542',3,'*'),(1360,'business','business',0,0,0.5333,'B252',3,'*'),(1361,'business showed','business showed',0,1,1.5,'B2523',3,'*'),(1362,'business showed 2.1','business showed 2.1',0,1,1.6333,'B2523',3,'*'),(1363,'business showed 21','business showed 21',0,1,1.6,'B2523',3,'*'),(1364,'corp','corp',0,0,0.2667,'C610',3,'*'),(1365,'corp says','corp says',0,1,1.3,'C612',3,'*'),(1366,'corp says publishing','corp says publishing',0,1,1.6667,'C61214252',3,'*'),(1367,'filing','filing',0,0,0.4,'F452',3,'*'),(1368,'filing news','filing news',0,1,1.3667,'F45252',3,'*'),(1369,'filing news corp','filing news corp',0,1,1.5333,'F4525261',3,'*'),(1370,'in filing','in filing',0,1,1.3,'I51452',3,'*'),(1371,'in filing news','in filing news',0,1,1.4667,'I5145252',3,'*'),(1372,'loss','loss',0,0,0.2667,'L200',3,'*'),(1373,'news','news',0,0,0.2667,'N200',4,'*'),(1374,'news corp','news corp',0,1,1.3,'N261',3,'*'),(1375,'news corp says','news corp says',0,1,1.4667,'N2612',3,'*'),(1376,'publishing','publishing',0,0,0.6667,'P4252',3,'*'),(1377,'publishing business','publishing business',0,1,1.6333,'P42521252',3,'*'),(1378,'publishing business showed','publishing business showed',0,1,1.8667,'P425212523',3,'*'),(1379,'says','says',0,0,0.2667,'S000',3,'*'),(1380,'says publishing','says publishing',0,1,1.5,'S14252',3,'*'),(1381,'says publishing business','says publishing business',0,1,1.8,'S142521252',3,'*'),(1382,'showed','showed',0,0,0.4,'S300',3,'*'),(1383,'showed 2.1','showed 2.1',0,1,1.3333,'S300',3,'*'),(1384,'showed 2.1 billion','showed 2.1 billion',0,1,1.6,'S3145',3,'*'),(1385,'showed 21','showed 21',0,1,1.3,'S300',3,'*'),(1386,'showed 21 billion','showed 21 billion',0,1,1.5667,'S3145',3,'*'),(1415,'a nearly','a nearly',0,1,1.2667,'A564',2,'*'),(1416,'a nearly three','a nearly three',0,1,1.4667,'A56436',2,'*'),(1417,'a nearly three-point','a nearly three-point',0,1,1.6667,'A56436153',2,'*'),(1418,'aia','aia',0,0,0.2,'A000',2,'*'),(1419,'aia announced','aia announced',0,1,1.4333,'A523',2,'*'),(1420,'aia announced that','aia announced that',0,1,1.6,'A523',2,'*'),(1421,'announced','announced',0,0,0.6,'A523',2,'*'),(1422,'announced that','announced that',0,1,1.4667,'A523',2,'*'),(1423,'announced that on','announced that on',0,1,1.5667,'A5235',2,'*'),(1424,'heels','heels',0,0,0.3333,'H420',2,'*'),(1425,'heels of','heels of',0,1,1.2667,'H421',2,'*'),(1426,'heels of a','heels of a',0,1,1.3333,'H421',2,'*'),(1427,'increased','increased',0,0,0.6,'I52623',2,'*'),(1428,'nearly','nearly',0,0,0.4,'N640',2,'*'),(1429,'nearly three','nearly three',0,1,1.4,'N6436',2,'*'),(1430,'nearly three point','nearly three point',0,1,1.6,'N6436153',2,'*'),(1431,'nearly three-point','nearly three-point',0,1,1.6,'N6436153',2,'*'),(1432,'nearly three-point increased','nearly three-point increased',0,1,1.9333,'N643615352623',2,'*'),(1433,'of a','of a',0,1,1.1333,'O100',2,'*'),(1434,'of a nearly','of a nearly',0,1,1.3667,'O1564',2,'*'),(1435,'on the','on the',0,1,1.2,'O530',2,'*'),(1436,'on the heels','on the heels',0,1,1.4,'O5342',2,'*'),(1437,'point','point',0,0,0.3333,'P530',2,'*'),(1438,'point increased','point increased',0,1,1.5,'P5352623',2,'*'),(1439,'that','that',0,0,0.2667,'T000',2,'*'),(1440,'that on','that on',0,1,1.2333,'T500',2,'*'),(1441,'that on the','that on the',0,1,1.3667,'T530',2,'*'),(1442,'the heels','the heels',0,1,1.3,'T420',2,'*'),(1443,'the heels of','the heels of',0,1,1.4,'T421',2,'*'),(1444,'three point','three point',0,1,1.3667,'T6153',2,'*'),(1445,'three point increased','three point increased',0,1,1.7,'T615352623',2,'*'),(1446,'three-point','three-point',0,0,0.7333,'T6153',2,'*'),(1447,'three-point increased','three-point increased',0,1,1.7,'T615352623',2,'*'),(1478,'and input','and input',0,1,1.3,'A53513',2,'*'),(1479,'and input of','and input of',0,1,1.4,'A535131',2,'*'),(1480,'and the expertise','and the expertise',0,1,1.5667,'A5321632',2,'*'),(1481,'center','center',0,0,0.4,'C536',2,'*'),(1482,'center germany','center germany',0,1,1.4667,'C536265',2,'*'),(1483,'design and the','design and the',0,1,1.4667,'D253',2,'*'),(1484,'expertise','expertise',0,0,0.6,'E21632',2,'*'),(1485,'expertise and','expertise and',0,1,1.4333,'E2163253',2,'*'),(1486,'expertise and input','expertise and input',0,1,1.6333,'E2163253513',2,'*'),(1487,'germany','germany',0,0,0.4667,'G650',2,'*'),(1488,'input','input',0,0,0.3333,'I513',2,'*'),(1489,'input of','input of',0,1,1.2667,'I5131',2,'*'),(1490,'input of match','input of match',0,1,1.4667,'I5131532',2,'*'),(1491,'match','match',0,0,0.3333,'M320',2,'*'),(1492,'match center','match center',0,1,1.4,'M32536',2,'*'),(1493,'match center germany','match center germany',0,1,1.6667,'M32536265',2,'*'),(1494,'of match','of match',0,1,1.2667,'O1532',2,'*'),(1495,'of match center','of match center',0,1,1.5,'O1532536',2,'*'),(1496,'the expertise','the expertise',0,1,1.4333,'T21632',2,'*'),(1497,'the expertise and','the expertise and',0,1,1.5667,'T2163253',2,'*'),(1498,'yacht','yacht',0,0,0.3333,'Y230',2,'*'),(1499,'yacht design','yacht design',0,1,1.4,'Y2325',2,'*'),(1500,'yacht design and','yacht design and',0,1,1.5333,'Y23253',2,'*'),(1509,'a hard','a hard',0,1,1.2,'A630',1,'*'),(1510,'a hard challenge','a hard challenge',0,1,1.5333,'A632452',1,'*'),(1511,'at a','at a',0,1,1.1333,'A300',1,'*'),(1512,'at a hard','at a hard',0,1,1.3,'A363',1,'*'),(1513,'baulked','baulked',0,0,0.4667,'B423',1,'*'),(1514,'baulked at','baulked at',0,1,1.3333,'B423',1,'*'),(1515,'baulked at a','baulked at a',0,1,1.4,'B423',1,'*'),(1516,'challenge','challenge',0,0,0.6,'C452',1,'*'),(1517,'hard','hard',0,0,0.2667,'H630',1,'*'),(1518,'hard challenge','hard challenge',0,1,1.4667,'H632452',1,'*'),(1519,'has never','has never',0,1,1.3,'H2516',1,'*'),(1520,'has never baulked','has never baulked',0,1,1.5667,'H25161423',1,'*'),(1521,'never','never',0,0,0.3333,'N160',1,'*'),(1522,'never baulked','never baulked',0,1,1.4333,'N161423',1,'*'),(1523,'never baulked at','never baulked at',0,1,1.5333,'N161423',1,'*'),(1524,'oscar','oscar',0,0,0.3333,'O260',1,'*'),(1525,'oscar pistorius','oscar pistorius',0,1,1.5,'O2612362',1,'*'),(1526,'oscar pistorius has','oscar pistorius has',0,1,1.6333,'O2612362',1,'*'),(1527,'pistorius','pistorius',0,0,0.6,'P2362',1,'*'),(1528,'pistorius has','pistorius has',0,1,1.4333,'P2362',1,'*'),(1529,'pistorius has never','pistorius has never',0,1,1.6333,'P2362516',1,'*'),(1540,'along','along',0,0,0.3333,'A452',2,'*'),(1541,'along at','along at',0,1,1.2667,'A4523',2,'*'),(1542,'along at the','along at the',0,1,1.4,'A4523',2,'*'),(1543,'at the','at the',0,1,1.2,'A300',2,'*'),(1544,'at the top','at the top',0,1,1.3333,'A310',2,'*'),(1545,'city','city',0,0,0.2667,'C300',2,'*'),(1546,'city thunder','city thunder',0,1,1.4,'C3536',2,'*'),(1547,'city thunder ing','city thunder ing',0,1,1.5333,'C353652',2,'*'),(1548,'city thunder-ing','city thunder-ing',0,1,1.5333,'C353652',2,'*'),(1549,'city thunder-ing along','city thunder-ing along',0,1,1.7333,'C353652452',2,'*'),(1550,'durant','durant',0,0,0.4,'D653',2,'*'),(1551,'durant has','durant has',0,1,1.3333,'D6532',2,'*'),(1552,'durant has oklahoma','durant has oklahoma',0,1,1.6333,'D653245',2,'*'),(1553,'has oklahoma','has oklahoma',0,1,1.4,'H245',2,'*'),(1554,'has oklahoma city','has oklahoma city',0,1,1.5667,'H24523',2,'*'),(1555,'ing','ing',0,0,0.2,'I520',2,'*'),(1556,'ing along','ing along',0,1,1.3,'I52452',2,'*'),(1557,'ing along at','ing along at',0,1,1.4,'I524523',2,'*'),(1558,'kevin','kevin',0,0,0.3333,'K150',2,'*'),(1559,'kevin durant','kevin durant',0,1,1.4,'K153653',2,'*'),(1560,'kevin durant has','kevin durant has',0,1,1.5333,'K1536532',2,'*'),(1561,'oklahoma','oklahoma',0,0,0.5333,'O245',2,'*'),(1562,'oklahoma city','oklahoma city',0,1,1.4333,'O24523',2,'*'),(1563,'oklahoma city thunder','oklahoma city thunder',0,1,1.7,'O24523536',2,'*'),(1564,'oklahoma city thunder-ing','oklahoma city thunder-ing',0,1,1.8333,'O2452353652',2,'*'),(1565,'the top','the top',0,1,1.2333,'T100',2,'*'),(1566,'thunder','thunder',0,0,0.4667,'T536',2,'*'),(1567,'thunder ing','thunder ing',0,1,1.3667,'T53652',2,'*'),(1568,'thunder ing along','thunder ing along',0,1,1.5667,'T53652452',2,'*'),(1569,'thunder-ing','thunder-ing',0,0,0.7333,'T53652',2,'*'),(1570,'thunder-ing along','thunder-ing along',0,1,1.5667,'T53652452',2,'*'),(1571,'thunder-ing along at','thunder-ing along at',0,1,1.6667,'T536524523',2,'*'),(1603,'1 season','1 season',0,1,1.2667,'S500',1,'*'),(1604,'1 season was','1 season was',0,1,1.4,'S520',1,'*'),(1605,'2012 formula','2012 formula',0,1,1.4,'F654',1,'*'),(1606,'2012 formula 1','2012 formula 1',0,1,1.4667,'F654',1,'*'),(1607,'and eventful','and eventful',0,1,1.4,'A5315314',1,'*'),(1608,'and eventful in','and eventful in',0,1,1.5,'A53153145',1,'*'),(1609,'eventful','eventful',0,0,0.5333,'E15314',1,'*'),(1610,'eventful in','eventful in',0,1,1.3667,'E153145',1,'*'),(1611,'eventful in history','eventful in history',0,1,1.6333,'E153145236',1,'*'),(1612,'exciting','exciting',0,0,0.5333,'E2352',1,'*'),(1613,'exciting and','exciting and',0,1,1.4,'E235253',1,'*'),(1614,'exciting and eventful','exciting and eventful',0,1,1.7,'E23525315314',1,'*'),(1615,'formula','formula',0,0,0.4667,'F654',1,'*'),(1616,'formula 1','formula 1',0,1,1.3,'F654',1,'*'),(1617,'formula 1 season','formula 1 season',0,1,1.5333,'F65425',1,'*'),(1618,'in history','in history',0,1,1.3333,'I5236',1,'*'),(1619,'most exciting','most exciting',0,1,1.4333,'M232352',1,'*'),(1620,'most exciting and','most exciting and',0,1,1.5667,'M23235253',1,'*'),(1621,'season','season',0,0,0.4,'S500',1,'*'),(1622,'season was','season was',0,1,1.3333,'S520',1,'*'),(1623,'season was one','season was one',0,1,1.4667,'S525',1,'*'),(1624,'the most exciting','the most exciting',0,1,1.5667,'T5232352',1,'*'),(1625,'was','was',0,0,0.2,'W200',1,'*'),(1626,'was one','was one',0,1,1.2333,'W250',1,'*'),(1627,'was one of','was one of',0,1,1.3333,'W251',1,'*'),(1634,'and public','and public',0,1,1.3333,'A53142',2,'*'),(1635,'and public debt','and public debt',0,1,1.5,'A53142313',2,'*'),(1636,'banking','banking',0,0,0.4667,'B5252',2,'*'),(1637,'banking union','banking union',0,1,1.4333,'B52525',2,'*'),(1638,'banking union will','banking union will',0,1,1.6,'B525254',2,'*'),(1639,'banks','banks',0,0,0.3333,'B520',2,'*'),(1640,'banks and','banks and',0,1,1.3,'B5253',2,'*'),(1641,'banks and public','banks and public',0,1,1.5333,'B5253142',2,'*'),(1642,'between','between',0,0,0.4667,'B350',2,'*'),(1643,'between banks','between banks',0,1,1.4333,'B35152',2,'*'),(1644,'between banks and','between banks and',0,1,1.5667,'B3515253',2,'*'),(1645,'break','break',0,0,0.3333,'B620',2,'*'),(1646,'break the','break the',0,1,1.3,'B623',2,'*'),(1647,'break the link','break the link',0,1,1.4667,'B623452',2,'*'),(1648,'debt','debt',0,0,0.2667,'D130',2,'*'),(1649,'eu\'s','eu',0,0,0.2667,'E200',2,'*'),(1650,'eu\'s new','eu new',0,1,1.2667,'E250',2,'*'),(1651,'eu\'s new banking','eu new banking',0,1,1.5333,'E2515252',2,'*'),(1652,'eus','eus',0,0,0.2,'E200',2,'*'),(1653,'eus new','eus new',0,1,1.2333,'E250',2,'*'),(1654,'eus new banking','eus new banking',0,1,1.5,'E2515252',2,'*'),(1655,'link','link',0,0,0.2667,'L520',2,'*'),(1656,'link between','link between',0,1,1.4,'L52135',2,'*'),(1657,'link between banks','link between banks',0,1,1.6,'L52135152',2,'*'),(1658,'new','new',0,0,0.2,'N000',6,'*'),(1659,'new banking','new banking',0,1,1.3667,'N15252',2,'*'),(1660,'new banking union','new banking union',0,1,1.5667,'N152525',2,'*'),(1661,'public','public',0,0,0.4,'P420',2,'*'),(1662,'public debt','public debt',0,1,1.3667,'P42313',2,'*'),(1663,'the link','the link',0,1,1.2667,'T452',2,'*'),(1664,'the link between','the link between',0,1,1.5333,'T452135',2,'*'),(1665,'union','union',0,0,0.3333,'U500',2,'*'),(1666,'union will','union will',0,1,1.3333,'U540',2,'*'),(1667,'union will break','union will break',0,1,1.5333,'U54162',2,'*'),(1668,'will','will',0,0,0.2667,'W400',2,'*'),(1669,'will break','will break',0,1,1.3333,'W4162',2,'*'),(1670,'will break the','will break the',0,1,1.4667,'W41623',2,'*'),(1697,'discussion on ukraine','discussion on ukraine',0,1,1.7,'D25265',3,'*'),(1698,'discussion on ukraine-eu','discussion on ukraine-eu',0,1,1.8,'D25265',3,'*'),(1699,'eu parliament','eu parliament',0,1,1.4333,'E16453',3,'*'),(1700,'eu parliament to','eu parliament to',0,1,1.5333,'E16453',3,'*'),(1701,'eu relations','eu relations',0,1,1.4,'E64352',3,'*'),(1702,'eu relations on','eu relations on',0,1,1.5,'E643525',3,'*'),(1703,'host','host',0,0,0.2667,'H230',3,'*'),(1704,'host discussion','host discussion',0,1,1.5,'H2325',3,'*'),(1705,'host discussion on','host discussion on',0,1,1.6,'H2325',3,'*'),(1706,'on tuesday','on tuesday',0,1,1.3333,'O5323',3,'*'),(1707,'on ukraine','on ukraine',0,1,1.3333,'O5265',3,'*'),(1708,'on ukraine eu','on ukraine eu',0,1,1.4333,'O5265',3,'*'),(1709,'on ukraine-eu','on ukraine-eu',0,1,1.4333,'O5265',3,'*'),(1710,'on ukraine-eu relations','on ukraine-eu relations',0,1,1.7667,'O526564352',3,'*'),(1711,'parliament','parliament',0,0,0.6667,'P6453',3,'*'),(1712,'parliament to','parliament to',0,1,1.4333,'P6453',3,'*'),(1713,'parliament to host','parliament to host',0,1,1.6,'P645323',3,'*'),(1714,'relations','relations',0,0,0.6,'R4352',3,'*'),(1715,'relations on','relations on',0,1,1.4,'R43525',3,'*'),(1716,'relations on tuesday','relations on tuesday',0,1,1.6667,'R43525323',3,'*'),(1717,'to host','to host',0,1,1.2333,'T230',3,'*'),(1718,'to host discussion','to host discussion',0,1,1.6,'T2325',3,'*'),(1719,'tuesday','tuesday',0,0,0.4667,'T230',3,'*'),(1720,'ukraine','ukraine',0,0,0.4667,'U265',3,'*'),(1721,'ukraine eu','ukraine eu',0,1,1.3333,'U265',3,'*'),(1722,'ukraine eu relations','ukraine eu relations',0,1,1.6667,'U26564352',3,'*'),(1723,'ukraine-eu','ukraine-eu',0,0,0.6667,'U265',3,'*'),(1724,'ukraine-eu relations','ukraine-eu relations',0,1,1.6667,'U26564352',3,'*'),(1725,'ukraine-eu relations on','ukraine-eu relations on',0,1,1.7667,'U265643525',3,'*'),(1728,'government','government',0,0,0.6667,'G1653',2,'*'),(1729,'government upsets','government upsets',0,1,1.5667,'G16531232',2,'*'),(1730,'government upsets traditional','government upsets traditional',0,1,1.9667,'G1653123236354',2,'*'),(1731,'mario','mario',0,0,0.3333,'M600',2,'*'),(1732,'mario monti\'s','mario monti',0,1,1.4333,'M6532',2,'*'),(1733,'mario monti\'s government','mario monti government',0,1,1.8,'M65321653',2,'*'),(1734,'mario montis','mario montis',0,1,1.4,'M6532',2,'*'),(1735,'mario montis government','mario montis government',0,1,1.7667,'M65321653',2,'*'),(1736,'monti\'s','monti',0,0,0.4667,'M320',2,'*'),(1737,'monti\'s government','monti government',0,1,1.6,'M321653',2,'*'),(1738,'monti\'s government upsets','monti government upsets',0,1,1.8333,'M3216531232',2,'*'),(1739,'montis','montis',0,0,0.4,'M320',2,'*'),(1740,'montis government','montis government',0,1,1.5667,'M321653',2,'*'),(1741,'montis government upsets','montis government upsets',0,1,1.8,'M3216531232',2,'*'),(1742,'parties','parties',0,0,0.4667,'P632',2,'*'),(1743,'traditional','traditional',0,0,0.7333,'T6354',2,'*'),(1744,'traditional parties','traditional parties',0,1,1.6333,'T63541632',2,'*'),(1745,'upsets','upsets',0,0,0.4,'U1232',2,'*'),(1746,'upsets traditional','upsets traditional',0,1,1.6,'U123236354',2,'*'),(1747,'upsets traditional parties','upsets traditional parties',0,1,1.8667,'U1232363541632',2,'*'),(1759,'be','be',0,0,0.1333,'B000',1,'*'),(1760,'be light','be light',0,1,1.2667,'B423',1,'*'),(1761,'be light invertertube','be light invertertube',0,1,1.7,'B4235163631',1,'*'),(1762,'binocular','binocular',0,0,0.6,'B5246',1,'*'),(1763,'binocular tube','binocular tube',0,1,1.4667,'B524631',1,'*'),(1764,'binocular tube from','binocular tube from',0,1,1.6333,'B52463165',1,'*'),(1765,'carl','carl',0,0,0.2667,'C640',1,'*'),(1766,'carl zeiss','carl zeiss',0,1,1.3333,'C642',1,'*'),(1767,'carl zeiss meditec','carl zeiss meditec',0,1,1.6,'C642532',1,'*'),(1768,'from carl','from carl',0,1,1.3,'F65264',1,'*'),(1769,'from carl zeiss','from carl zeiss',0,1,1.5,'F652642',1,'*'),(1770,'health','health',0,0,0.4,'H430',1,'*'),(1771,'invertertube','invertertube',0,0,0.8,'I5163631',1,'*'),(1772,'invertertube binocular','invertertube binocular',0,1,1.7333,'I51636315246',1,'*'),(1773,'invertertube binocular tube','invertertube binocular tube',0,1,1.9,'I5163631524631',1,'*'),(1774,'let','let',0,0,0.2,'L300',1,'*'),(1775,'let there','let there',0,1,1.3,'L360',1,'*'),(1776,'let there be','let there be',0,1,1.4,'L361',1,'*'),(1777,'light','light',0,0,0.3333,'L230',2,'*'),(1778,'light invertertube','light invertertube',0,1,1.6,'L235163631',1,'*'),(1779,'light invertertube binocular','light invertertube binocular',0,1,1.9333,'L2351636315246',1,'*'),(1780,'meditec','meditec',0,0,0.4667,'M320',1,'*'),(1781,'news 6','news 6',0,1,1.2,'N200',1,'*'),(1782,'there','there',0,0,0.3333,'T600',1,'*'),(1783,'there be','there be',0,1,1.2667,'T610',1,'*'),(1784,'there be light','there be light',0,1,1.4667,'T61423',1,'*'),(1785,'tube','tube',0,0,0.2667,'T100',1,'*'),(1786,'tube from','tube from',0,1,1.3,'T165',1,'*'),(1787,'tube from carl','tube from carl',0,1,1.4667,'T165264',1,'*'),(1788,'zeiss','zeiss',0,0,0.3333,'Z000',1,'*'),(1789,'zeiss meditec','zeiss meditec',0,1,1.4333,'Z532',1,'*'),(3101,'tablet\'s','tablet',0,0,0.5333,'T1432',9,'*'),(3102,'tvs','tvs',0,0,0.2,'T120',9,'*'),(3103,'smartphone\'s','smartphone',0,0,0.8,'S563152',9,'*'),(3104,'ultrabooks','ultrabooks',0,0,0.6667,'U43612',11,'*'),(3105,'2 days','2 days',0,1,1.2,'D200',2,'*'),(3106,'200','200',0,0,0.3,'',2,'*'),(3107,'200 off','200 off',0,1,1.2333,'O100',2,'*'),(3108,'200 off at','200 off at',0,1,1.3333,'O130',2,'*'),(3109,'a varius','a varius',0,1,1.2667,'A162',22,'*'),(3110,'a varius eros','a varius eros',0,1,1.4333,'A16262',22,'*'),(3111,'air','air',0,0,0.2,'A600',3,'*'),(3112,'air models','air models',0,1,1.3333,'A65342',2,'*'),(3113,'air models 200','air models 200',0,1,1.4667,'A65342',2,'*'),(3114,'ante','ante',0,0,0.2667,'A530',22,'*'),(3115,'ante pellentesque','ante pellentesque',0,1,1.5667,'A5314532',22,'*'),(3116,'ante pellentesque at','ante pellentesque at',0,1,1.6667,'A53145323',22,'*'),(3117,'at augue','at augue',0,1,1.2667,'A320',22,'*'),(3118,'at augue lorem','at augue lorem',0,1,1.4667,'A32465',22,'*'),(3119,'at best','at best',0,1,1.2333,'A3123',2,'*'),(3120,'at best buy','at best buy',0,1,1.3667,'A31231',2,'*'),(3121,'auctor fringilla phasellus','auctor fringilla phasellus',0,1,1.8667,'A236165241242',22,'*'),(3122,'augue lorem','augue lorem',0,1,1.3667,'A2465',22,'*'),(3123,'augue lorem sed','augue lorem sed',0,1,1.5,'A246523',22,'*'),(3124,'best','best',0,0,0.2667,'B230',2,'*'),(3125,'best buy','best buy',0,1,1.2667,'B231',2,'*'),(3126,'best buy for','best buy for',0,1,1.4,'B2316',2,'*'),(3127,'bibendum','bibendum',0,0,0.5333,'B535',22,'*'),(3128,'bibendum ante','bibendum ante',0,1,1.4333,'B5353',22,'*'),(3129,'bibendum ante pellentesque','bibendum ante pellentesque',0,1,1.8667,'B535314532',22,'*'),(3130,'buy','buy',0,0,0.2,'B000',2,'*'),(3131,'buy for','buy for',0,1,1.2333,'B600',2,'*'),(3132,'buy for 2','buy for 2',0,1,1.3,'B600',2,'*'),(3133,'curabitur','curabitur',0,0,0.6,'C6136',22,'*'),(3134,'curabitur vitae','curabitur vitae',0,1,1.5,'C613613',22,'*'),(3135,'curabitur vitae ultricies','curabitur vitae ultricies',0,1,1.8333,'C6136134362',22,'*'),(3136,'cursus','cursus',0,0,0.4,'C620',22,'*'),(3137,'cursus cursus','cursus cursus',0,1,1.4333,'C6262',22,'*'),(3138,'cursus vitae','cursus vitae',0,1,1.4,'C6213',22,'*'),(3139,'cursus vitae orci','cursus vitae orci',0,1,1.5667,'C621362',22,'*'),(3140,'dictum','dictum',0,0,0.4,'D235',22,'*'),(3141,'dictum placerat','dictum placerat',0,1,1.5,'D23514263',22,'*'),(3142,'dictum placerat pellentesque','dictum placerat pellentesque',0,1,1.9333,'D2351426314532',22,'*'),(3143,'dolor','dolor',0,0,0.3333,'D460',22,'*'),(3144,'dolor vivamus','dolor vivamus',0,1,1.4333,'D46152',22,'*'),(3145,'dolor vivamus ultricies','dolor vivamus ultricies',0,1,1.7667,'D461524362',22,'*'),(3146,'donec metus','donec metus',0,1,1.3667,'D52532',22,'*'),(3147,'donec metus dui','donec metus dui',0,1,1.5,'D525323',22,'*'),(3148,'dui ultricies','dui ultricies',0,1,1.4333,'D4362',22,'*'),(3149,'dui ultricies non','dui ultricies non',0,1,1.5667,'D43625',22,'*'),(3150,'duis sed bibendum','duis sed bibendum',0,1,1.5667,'D231535',22,'*'),(3151,'duis vehicula','duis vehicula',0,1,1.4333,'D2124',22,'*'),(3152,'duis vehicula tellus','duis vehicula tellus',0,1,1.6667,'D2124342',22,'*'),(3153,'eget enim','eget enim',0,1,1.3,'E235',22,'*'),(3154,'eget enim duis','eget enim duis',0,1,1.4667,'E23532',22,'*'),(3155,'eget venenatis','eget venenatis',0,1,1.4667,'E231532',22,'*'),(3156,'eget venenatis quis','eget venenatis quis',0,1,1.6333,'E231532',22,'*'),(3157,'enim','enim',0,0,0.2667,'E500',22,'*'),(3158,'enim duis','enim duis',0,1,1.3,'E532',22,'*'),(3159,'enim duis sed','enim duis sed',0,1,1.4333,'E5323',22,'*'),(3160,'eros posuere','eros posuere',0,1,1.4,'E62126',22,'*'),(3161,'eros posuere donec','eros posuere donec',0,1,1.6,'E62126352',22,'*'),(3162,'eu nisi','eu nisi',0,1,1.2333,'E520',22,'*'),(3163,'eu nisi sagittis','eu nisi sagittis',0,1,1.5333,'E5232',22,'*'),(3164,'for 2','for 2',0,1,1.1667,'F600',2,'*'),(3165,'for 2 days','for 2 days',0,1,1.3333,'F632',2,'*'),(3166,'fringilla phasellus','fringilla phasellus',0,1,1.6333,'F65241242',22,'*'),(3167,'fringilla phasellus dictum','fringilla phasellus dictum',0,1,1.8667,'F652412423235',22,'*'),(3168,'in lectus','in lectus',0,1,1.3,'I54232',22,'*'),(3169,'in lectus cursus','in lectus cursus',0,1,1.5333,'I5423262',22,'*'),(3170,'integer','integer',0,0,0.4667,'I5326',22,'*'),(3171,'integer orci','integer orci',0,1,1.4,'I53262',22,'*'),(3172,'integer orci libero','integer orci libero',0,1,1.6333,'I53262416',22,'*'),(3173,'lectus','lectus',0,0,0.4,'L232',22,'*'),(3174,'lectus cursus','lectus cursus',0,1,1.4333,'L23262',22,'*'),(3175,'lectus cursus cursus','lectus cursus cursus',0,1,1.6667,'L2326262',22,'*'),(3176,'libero varius','libero varius',0,1,1.4333,'L16162',22,'*'),(3177,'libero varius eget','libero varius eget',0,1,1.6,'L161623',22,'*'),(3178,'lorem','lorem',0,0,0.3333,'L650',22,'*'),(3179,'lorem sed','lorem sed',0,1,1.3,'L6523',22,'*'),(3180,'lorem sed ut','lorem sed ut',0,1,1.4,'L6523',22,'*'),(3181,'macbook','macbook',0,0,0.4667,'M212',3,'*'),(3182,'macbook air','macbook air',0,1,1.3667,'M2126',3,'*'),(3183,'macbook air models','macbook air models',0,1,1.6,'M21265342',2,'*'),(3184,'metus dui','metus dui',0,1,1.3,'M323',22,'*'),(3185,'metus dui ultricies','metus dui ultricies',0,1,1.6333,'M3234362',22,'*'),(3186,'models','models',0,0,0.4,'M342',2,'*'),(3187,'models 200','models 200',0,1,1.3333,'M342',2,'*'),(3188,'models 200 off','models 200 off',0,1,1.4667,'M3421',2,'*'),(3189,'nisi','nisi',0,0,0.2667,'N200',22,'*'),(3190,'nisi sagittis','nisi sagittis',0,1,1.4333,'N232',22,'*'),(3191,'nisi sagittis a','nisi sagittis a',0,1,1.5,'N232',22,'*'),(3192,'non porttitor','non porttitor',0,1,1.4333,'N1636',22,'*'),(3193,'non porttitor sed','non porttitor sed',0,1,1.5667,'N163623',22,'*'),(3194,'nunc in','nunc in',0,1,1.2333,'N250',22,'*'),(3195,'nunc in lectus','nunc in lectus',0,1,1.4667,'N254232',22,'*'),(3196,'off','off',0,0,0.2,'O100',2,'*'),(3197,'off at','off at',0,1,1.2,'O130',2,'*'),(3198,'off at best','off at best',0,1,1.3667,'O13123',2,'*'),(3199,'orci curabitur','orci curabitur',0,1,1.4667,'O626136',22,'*'),(3200,'orci curabitur vitae','orci curabitur vitae',0,1,1.6667,'O62613613',22,'*'),(3201,'orci libero','orci libero',0,1,1.3667,'O62416',22,'*'),(3202,'orci libero varius','orci libero varius',0,1,1.6,'O62416162',22,'*'),(3203,'pellentesque at','pellentesque at',0,1,1.5,'P45323',22,'*'),(3204,'pellentesque at augue','pellentesque at augue',0,1,1.7,'P453232',22,'*'),(3205,'pellentesque duis','pellentesque duis',0,1,1.5667,'P453232',22,'*'),(3206,'pellentesque duis vehicula','pellentesque duis vehicula',0,1,1.8667,'P453232124',22,'*'),(3207,'phasellus','phasellus',0,0,0.6,'P242',22,'*'),(3208,'phasellus dictum','phasellus dictum',0,1,1.5333,'P2423235',22,'*'),(3209,'phasellus dictum placerat','phasellus dictum placerat',0,1,1.8333,'P242323514263',22,'*'),(3210,'placerat','placerat',0,0,0.5333,'P4263',22,'*'),(3211,'placerat pellentesque','placerat pellentesque',0,1,1.7,'P426314532',22,'*'),(3212,'placerat pellentesque duis','placerat pellentesque duis',0,1,1.8667,'P42631453232',22,'*'),(3213,'porta sapien','porta sapien',0,1,1.4,'P63215',22,'*'),(3214,'porta sapien integer','porta sapien integer',0,1,1.6667,'P63215326',22,'*'),(3215,'porttitor','porttitor',0,0,0.6,'P636',22,'*'),(3216,'porttitor sed','porttitor sed',0,1,1.4333,'P63623',22,'*'),(3217,'porttitor sed semper','porttitor sed semper',0,1,1.6667,'P636232516',22,'*'),(3218,'posuere donec','posuere donec',0,1,1.4333,'P26352',22,'*'),(3219,'posuere donec metus','posuere donec metus',0,1,1.6333,'P26352532',22,'*'),(3220,'quis cursus','quis cursus',0,1,1.3667,'Q620',22,'*'),(3221,'quis cursus vitae','quis cursus vitae',0,1,1.5667,'Q6213',22,'*'),(3222,'sagittis','sagittis',0,0,0.5333,'S320',22,'*'),(3223,'sagittis a','sagittis a',0,1,1.3333,'S320',22,'*'),(3224,'sagittis a varius','sagittis a varius',0,1,1.5667,'S32162',22,'*'),(3225,'sapien','sapien',0,0,0.4,'S150',22,'*'),(3226,'sapien integer','sapien integer',0,1,1.4667,'S15326',22,'*'),(3227,'sapien integer orci','sapien integer orci',0,1,1.6333,'S153262',22,'*'),(3228,'sed bibendum','sed bibendum',0,1,1.4,'S31535',22,'*'),(3229,'sed bibendum ante','sed bibendum ante',0,1,1.5667,'S315353',22,'*'),(3230,'sed semper','sed semper',0,1,1.3333,'S32516',22,'*'),(3231,'sed semper eget','sed semper eget',0,1,1.5,'S3251623',22,'*'),(3232,'sed ut','sed ut',0,1,1.2,'S300',22,'*'),(3233,'sed ut porta','sed ut porta',0,1,1.4,'S3163',22,'*'),(3234,'semper','semper',0,0,0.4,'S516',22,'*'),(3235,'semper eget','semper eget',0,1,1.3667,'S51623',22,'*'),(3236,'semper eget enim','semper eget enim',0,1,1.5333,'S516235',22,'*'),(3237,'tellus','tellus',0,0,0.4,'T420',22,'*'),(3238,'tellus eu','tellus eu',0,1,1.3,'T420',22,'*'),(3239,'tellus eu nisi','tellus eu nisi',0,1,1.4667,'T4252',22,'*'),(3240,'ultricies','ultricies',0,0,0.6,'U4362',22,'*'),(3241,'ultricies dolor','ultricies dolor',0,1,1.5,'U4362346',22,'*'),(3242,'ultricies dolor vivamus','ultricies dolor vivamus',0,1,1.7667,'U4362346152',22,'*'),(3243,'ultricies non','ultricies non',0,1,1.4333,'U43625',22,'*'),(3244,'ultricies non porttitor','ultricies non porttitor',0,1,1.7667,'U436251636',22,'*'),(3245,'ultricies nunc','ultricies nunc',0,1,1.4667,'U436252',22,'*'),(3246,'ultricies nunc in','ultricies nunc in',0,1,1.5667,'U4362525',22,'*'),(3247,'ut','ut',0,0,0.1333,'U300',22,'*'),(3248,'ut porta','ut porta',0,1,1.2667,'U3163',22,'*'),(3249,'ut porta sapien','ut porta sapien',0,1,1.5,'U3163215',22,'*'),(3250,'varius eget','varius eget',0,1,1.3667,'V623',22,'*'),(3251,'varius eget venenatis','varius eget venenatis',0,1,1.7,'V6231532',22,'*'),(3252,'varius eros','varius eros',0,1,1.3667,'V6262',22,'*'),(3253,'varius eros posuere','varius eros posuere',0,1,1.6333,'V6262126',22,'*'),(3254,'vehicula','vehicula',0,0,0.5333,'V240',22,'*'),(3255,'vehicula tellus','vehicula tellus',0,1,1.5,'V24342',22,'*'),(3256,'vehicula tellus eu','vehicula tellus eu',0,1,1.6,'V24342',22,'*'),(3257,'venenatis quis','venenatis quis',0,1,1.4667,'V532',22,'*'),(3258,'venenatis quis cursus','venenatis quis cursus',0,1,1.7,'V53262',22,'*'),(3259,'vitae orci curabitur','vitae orci curabitur',0,1,1.6667,'V3626136',22,'*'),(3260,'vitae ultricies','vitae ultricies',0,1,1.5,'V34362',22,'*'),(3261,'vitae ultricies dolor','vitae ultricies dolor',0,1,1.7,'V34362346',22,'*'),(3262,'vivamus','vivamus',0,0,0.4667,'V520',22,'*'),(3263,'vivamus ultricies','vivamus ultricies',0,1,1.5667,'V524362',22,'*'),(3264,'vivamus ultricies nunc','vivamus ultricies nunc',0,1,1.7333,'V52436252',22,'*'),(3360,'a nec','a nec',0,1,1.1667,'A520',20,'*'),(3361,'a nec eros','a nec eros',0,1,1.3333,'A5262',20,'*'),(3362,'a touchscreen','a touchscreen',0,1,1.4333,'A3265',1,'*'),(3363,'a touchscreen android','a touchscreen android',0,1,1.7,'A3265363',1,'*'),(3364,'ac felis','ac felis',0,1,1.2667,'A2142',20,'*'),(3365,'ac felis ut','ac felis ut',0,1,1.3667,'A21423',20,'*'),(3366,'ac semper','ac semper',0,1,1.3,'A2516',20,'*'),(3367,'ac semper risus','ac semper risus',0,1,1.5,'A25162',20,'*'),(3368,'ac suscipit','ac suscipit',0,1,1.3667,'A213',20,'*'),(3369,'ac suscipit id','ac suscipit id',0,1,1.4667,'A213',20,'*'),(3370,'adipiscing','adipiscing',0,0,0.6667,'A31252',20,'*'),(3371,'adipiscing eleifend','adipiscing eleifend',0,1,1.6333,'A312524153',20,'*'),(3372,'adipiscing eleifend sed','adipiscing eleifend sed',0,1,1.7667,'A31252415323',20,'*'),(3373,'adipiscing rhoncus','adipiscing rhoncus',0,1,1.6,'A31252652',20,'*'),(3374,'adipiscing rhoncus aliquam','adipiscing rhoncus aliquam',0,1,1.8667,'A31252652425',20,'*'),(3375,'aenean commodo','aenean commodo',0,1,1.4667,'A5253',20,'*'),(3376,'aenean commodo nibh','aenean commodo nibh',0,1,1.6333,'A525351',20,'*'),(3377,'aliquam non','aliquam non',0,1,1.3667,'A425',20,'*'),(3378,'aliquam non sem','aliquam non sem',0,1,1.5,'A42525',20,'*'),(3379,'aliquam sit','aliquam sit',0,1,1.3667,'A42523',20,'*'),(3380,'aliquam sit amet','aliquam sit amet',0,1,1.5333,'A4252353',20,'*'),(3381,'aliquam ullamcorper','aliquam ullamcorper',0,1,1.6333,'A425452616',20,'*'),(3382,'aliquam ullamcorper posuere','aliquam ullamcorper posuere',0,1,1.9,'A425452616126',20,'*'),(3383,'amet rutrum','amet rutrum',0,1,1.3667,'A536365',20,'*'),(3384,'amet rutrum vitae','amet rutrum vitae',0,1,1.5667,'A53636513',20,'*'),(3385,'android','android',0,0,0.4667,'A5363',4,'*'),(3386,'android tablet','android tablet',0,1,1.4667,'A5363143',1,'*'),(3387,'android tablet designed','android tablet designed',0,1,1.7667,'A5363143253',1,'*'),(3388,'at aliquam','at aliquam',0,1,1.3333,'A3425',20,'*'),(3389,'at aliquam sit','at aliquam sit',0,1,1.4667,'A342523',20,'*'),(3390,'auctor at','auctor at',0,1,1.3,'A2363',20,'*'),(3391,'auctor at aliquam','auctor at aliquam',0,1,1.5667,'A2363425',20,'*'),(3392,'bibendum non','bibendum non',0,1,1.4,'B535',20,'*'),(3393,'bibendum non eros','bibendum non eros',0,1,1.5667,'B53562',20,'*'),(3394,'by sony','by sony',0,1,1.2333,'B250',1,'*'),(3395,'commodo','commodo',0,0,0.4667,'C530',20,'*'),(3396,'commodo magna','commodo magna',0,1,1.4333,'C53525',20,'*'),(3397,'commodo magna ac','commodo magna ac',0,1,1.5333,'C535252',20,'*'),(3398,'commodo nibh','commodo nibh',0,1,1.4,'C5351',20,'*'),(3399,'commodo nibh non','commodo nibh non',0,1,1.5333,'C53515',20,'*'),(3400,'condimentum','condimentum',0,0,0.7333,'C53535',20,'*'),(3401,'condimentum bibendum','condimentum bibendum',0,1,1.6667,'C535351535',20,'*'),(3402,'condimentum bibendum non','condimentum bibendum non',0,1,1.8,'C535351535',20,'*'),(3403,'curabitur ultrices','curabitur ultrices',0,1,1.6,'C61364362',20,'*'),(3404,'curabitur ultrices commodo','curabitur ultrices commodo',0,1,1.8667,'C6136436253',20,'*'),(3405,'cursus curabitur','cursus curabitur',0,1,1.5333,'C626136',20,'*'),(3406,'cursus curabitur ultrices','cursus curabitur ultrices',0,1,1.8333,'C6261364362',20,'*'),(3407,'cursus cursus curabitur','cursus cursus curabitur',0,1,1.7667,'C62626136',20,'*'),(3408,'designed','designed',0,0,0.5333,'D253',2,'*'),(3409,'designed by','designed by',0,1,1.3667,'D2531',1,'*'),(3410,'designed by sony','designed by sony',0,1,1.5333,'D253125',1,'*'),(3411,'diam duis','diam duis',0,1,1.3,'D532',20,'*'),(3412,'diam duis cursus','diam duis cursus',0,1,1.5333,'D53262',20,'*'),(3413,'diam maecenas','diam maecenas',0,1,1.4333,'D5252',20,'*'),(3414,'diam maecenas elementum','diam maecenas elementum',0,1,1.7667,'D52524535',20,'*'),(3415,'dolor vel','dolor vel',0,1,1.3,'D4614',20,'*'),(3416,'dolor vel felis','dolor vel felis',0,1,1.5,'D4614142',20,'*'),(3417,'donec fermentum','donec fermentum',0,1,1.5,'D5216535',20,'*'),(3418,'donec fermentum magna','donec fermentum magna',0,1,1.7,'D521653525',20,'*'),(3419,'dui adipiscing','dui adipiscing',0,1,1.4667,'D1252',20,'*'),(3420,'dui adipiscing rhoncus','dui adipiscing rhoncus',0,1,1.7333,'D1252652',20,'*'),(3421,'dui hendrerit','dui hendrerit',0,1,1.4333,'D5363',20,'*'),(3422,'dui hendrerit molestie','dui hendrerit molestie',0,1,1.7333,'D53635423',20,'*'),(3423,'duis cursus','duis cursus',0,1,1.3667,'D262',20,'*'),(3424,'duis velit','duis velit',0,1,1.3333,'D2143',20,'*'),(3425,'duis velit neque','duis velit neque',0,1,1.5333,'D214352',20,'*'),(3426,'eget dui','eget dui',0,1,1.2667,'E230',20,'*'),(3427,'eget dui hendrerit','eget dui hendrerit',0,1,1.6,'E235363',20,'*'),(3428,'eget nisi','eget nisi',0,1,1.3,'E2352',20,'*'),(3429,'eget nisi adipiscing','eget nisi adipiscing',0,1,1.6667,'E235231252',20,'*'),(3430,'eget quam','eget quam',0,1,1.3,'E2325',20,'*'),(3431,'eget quam eget','eget quam eget',0,1,1.4667,'E232523',20,'*'),(3432,'eleifend','eleifend',0,0,0.5333,'E4153',20,'*'),(3433,'eleifend sed','eleifend sed',0,1,1.4,'E415323',20,'*'),(3434,'eleifend sed non','eleifend sed non',0,1,1.5333,'E4153235',20,'*'),(3435,'elementum','elementum',0,0,0.6,'E4535',20,'*'),(3436,'elementum lacus','elementum lacus',0,1,1.5,'E453542',20,'*'),(3437,'elementum lacus tincidunt','elementum lacus tincidunt',0,1,1.8333,'E453542352353',20,'*'),(3438,'eros donec','eros donec',0,1,1.3333,'E62352',20,'*'),(3439,'eros donec fermentum','eros donec fermentum',0,1,1.6667,'E6235216535',20,'*'),(3440,'eros lacinia','eros lacinia',0,1,1.4,'E62425',20,'*'),(3441,'eros lacinia mollis','eros lacinia mollis',0,1,1.6333,'E6242542',20,'*'),(3442,'eros vivamus','eros vivamus',0,1,1.4,'E62152',20,'*'),(3443,'eros vivamus eu','eros vivamus eu',0,1,1.5,'E62152',20,'*'),(3444,'et','et',0,0,0.1333,'E300',20,'*'),(3445,'et dolor','et dolor',0,1,1.2667,'E346',20,'*'),(3446,'et dolor vel','et dolor vel',0,1,1.4,'E34614',20,'*'),(3447,'eu laoreet','eu laoreet',0,1,1.3333,'E463',20,'*'),(3448,'eu laoreet diam','eu laoreet diam',0,1,1.5,'E4635',20,'*'),(3449,'felis','felis',0,0,0.3333,'F420',20,'*'),(3450,'felis hendrerit','felis hendrerit',0,1,1.5,'F425363',20,'*'),(3451,'felis hendrerit laoreet','felis hendrerit laoreet',0,1,1.7667,'F425363463',20,'*'),(3452,'felis ut','felis ut',0,1,1.2667,'F423',20,'*'),(3453,'felis ut odio','felis ut odio',0,1,1.4333,'F423',20,'*'),(3454,'fermentum magna','fermentum magna',0,1,1.5,'F653525',20,'*'),(3455,'fermentum magna non','fermentum magna non',0,1,1.6333,'F653525',20,'*'),(3456,'feugiat risus','feugiat risus',0,1,1.4333,'F2362',20,'*'),(3457,'feugiat risus posuere','feugiat risus posuere',0,1,1.7,'F2362126',20,'*'),(3458,'hendrerit','hendrerit',0,0,0.6,'H5363',20,'*'),(3459,'hendrerit laoreet','hendrerit laoreet',0,1,1.5667,'H5363463',20,'*'),(3460,'hendrerit laoreet duis','hendrerit laoreet duis',0,1,1.7333,'H53634632',20,'*'),(3461,'hendrerit molestie','hendrerit molestie',0,1,1.6,'H53635423',20,'*'),(3462,'hendrerit molestie ut','hendrerit molestie ut',0,1,1.7,'H53635423',20,'*'),(3463,'id','id',0,0,0.1333,'I300',20,'*'),(3464,'id vehicula','id vehicula',0,1,1.3667,'I3124',20,'*'),(3465,'id vehicula vel','id vehicula vel',0,1,1.5,'I312414',20,'*'),(3466,'in feugiat','in feugiat',0,1,1.3333,'I5123',20,'*'),(3467,'in feugiat risus','in feugiat risus',0,1,1.5333,'I512362',20,'*'),(3468,'integer ac','integer ac',0,1,1.3333,'I53262',20,'*'),(3469,'integer ac felis','integer ac felis',0,1,1.5333,'I53262142',20,'*'),(3470,'is a','is a',0,1,1.1333,'I200',1,'*'),(3471,'is a touchscreen','is a touchscreen',0,1,1.5333,'I23265',1,'*'),(3472,'lacinia mollis','lacinia mollis',0,1,1.4667,'L2542',20,'*'),(3473,'lacinia mollis maecenas','lacinia mollis maecenas',0,1,1.7667,'L25425252',20,'*'),(3474,'lacus','lacus',0,0,0.3333,'L200',20,'*'),(3475,'lacus tincidunt','lacus tincidunt',0,1,1.5,'L2352353',20,'*'),(3476,'lacus tincidunt neque','lacus tincidunt neque',0,1,1.7,'L235235352',20,'*'),(3477,'laoreet diam','laoreet diam',0,1,1.4,'L635',20,'*'),(3478,'laoreet diam duis','laoreet diam duis',0,1,1.5667,'L63532',20,'*'),(3479,'laoreet duis','laoreet duis',0,1,1.4,'L632',20,'*'),(3480,'laoreet duis velit','laoreet duis velit',0,1,1.6,'L632143',20,'*'),(3481,'libero integer','libero integer',0,1,1.4667,'L165326',20,'*'),(3482,'libero integer ac','libero integer ac',0,1,1.5667,'L1653262',20,'*'),(3483,'luctus rhoncus','luctus rhoncus',0,1,1.4667,'L232652',20,'*'),(3484,'luctus rhoncus a','luctus rhoncus a',0,1,1.5333,'L232652',20,'*'),(3485,'maecenas elementum','maecenas elementum',0,1,1.6,'M2524535',20,'*'),(3486,'maecenas elementum lacus','maecenas elementum lacus',0,1,1.8,'M252453542',20,'*'),(3487,'maecenas et','maecenas et',0,1,1.3667,'M2523',20,'*'),(3488,'maecenas et dolor','maecenas et dolor',0,1,1.5667,'M252346',20,'*'),(3489,'magna ac','magna ac',0,1,1.2667,'M252',20,'*'),(3490,'magna ac semper','magna ac semper',0,1,1.5,'M252516',20,'*'),(3491,'magna non','magna non',0,1,1.3,'M250',20,'*'),(3492,'magna non eros','magna non eros',0,1,1.4667,'M2562',20,'*'),(3493,'molestie','molestie',0,0,0.5333,'M423',20,'*'),(3494,'molestie ut','molestie ut',0,1,1.3667,'M423',20,'*'),(3495,'molestie ut quis','molestie ut quis',0,1,1.5333,'M4232',20,'*'),(3496,'molestie vestibulum','molestie vestibulum',0,1,1.6333,'M423123145',20,'*'),(3497,'molestie vestibulum aenean','molestie vestibulum aenean',0,1,1.8667,'M423123145',20,'*'),(3498,'mollis maecenas','mollis maecenas',0,1,1.5,'M425252',20,'*'),(3499,'mollis maecenas et','mollis maecenas et',0,1,1.6,'M4252523',20,'*'),(3500,'nec eros','nec eros',0,1,1.2667,'N262',20,'*'),(3501,'nec eros donec','nec eros donec',0,1,1.4667,'N262352',20,'*'),(3502,'neque','neque',0,0,0.3333,'N200',20,'*'),(3503,'neque luctus','neque luctus',0,1,1.4,'N24232',20,'*'),(3504,'neque luctus rhoncus','neque luctus rhoncus',0,1,1.6667,'N24232652',20,'*'),(3505,'neque rutrum','neque rutrum',0,1,1.4,'N26365',20,'*'),(3506,'neque rutrum ac','neque rutrum ac',0,1,1.5,'N263652',20,'*'),(3507,'nibh','nibh',0,0,0.2667,'N100',20,'*'),(3508,'nibh non','nibh non',0,1,1.2667,'N150',20,'*'),(3509,'nibh non dui','nibh non dui',0,1,1.4,'N153',20,'*'),(3510,'nibh nulla','nibh nulla',0,1,1.3333,'N154',20,'*'),(3511,'nibh nulla eget','nibh nulla eget',0,1,1.5,'N15423',20,'*'),(3512,'nisi adipiscing','nisi adipiscing',0,1,1.5,'N231252',20,'*'),(3513,'nisi adipiscing eleifend','nisi adipiscing eleifend',0,1,1.8,'N2312524153',20,'*'),(3514,'non dui','non dui',0,1,1.2333,'N300',20,'*'),(3515,'non dui adipiscing','non dui adipiscing',0,1,1.6,'N31252',20,'*'),(3516,'non eros','non eros',0,1,1.2667,'N620',20,'*'),(3517,'non eros lacinia','non eros lacinia',0,1,1.5333,'N62425',20,'*'),(3518,'non eros vivamus','non eros vivamus',0,1,1.5333,'N62152',20,'*'),(3519,'non libero','non libero',0,1,1.3333,'N416',20,'*'),(3520,'non libero integer','non libero integer',0,1,1.6,'N4165326',20,'*'),(3521,'non sem','non sem',0,1,1.2333,'N250',20,'*'),(3522,'non sem eget','non sem eget',0,1,1.4,'N2523',20,'*'),(3523,'nulla eget','nulla eget',0,1,1.3333,'N423',20,'*'),(3524,'nulla eget quam','nulla eget quam',0,1,1.5,'N42325',20,'*'),(3525,'odio venenatis','odio venenatis',0,1,1.4667,'O31532',20,'*'),(3526,'odio venenatis condimentum','odio venenatis condimentum',0,1,1.8667,'O3153253535',20,'*'),(3527,'posuere turpis','posuere turpis',0,1,1.4667,'P263612',20,'*'),(3528,'posuere turpis in','posuere turpis in',0,1,1.5667,'P2636125',20,'*'),(3529,'posuere vel','posuere vel',0,1,1.3667,'P2614',20,'*'),(3530,'posuere vel ut','posuere vel ut',0,1,1.4667,'P26143',20,'*'),(3531,'quam eget','quam eget',0,1,1.3,'Q523',20,'*'),(3532,'quam eget dui','quam eget dui',0,1,1.4333,'Q523',20,'*'),(3533,'quis turpis','quis turpis',0,1,1.3667,'Q3612',20,'*'),(3534,'quis turpis aliquam','quis turpis aliquam',0,1,1.6333,'Q3612425',20,'*'),(3535,'rhoncus','rhoncus',0,0,0.4667,'R520',20,'*'),(3536,'rhoncus a','rhoncus a',0,1,1.3,'R520',20,'*'),(3537,'rhoncus a nec','rhoncus a nec',0,1,1.4333,'R5252',20,'*'),(3538,'rhoncus aliquam','rhoncus aliquam',0,1,1.5,'R52425',20,'*'),(3539,'rhoncus aliquam ullamcorper','rhoncus aliquam ullamcorper',0,1,1.9,'R52425452616',20,'*'),(3540,'risus molestie','risus molestie',0,1,1.4667,'R25423',20,'*'),(3541,'risus molestie vestibulum','risus molestie vestibulum',0,1,1.8333,'R25423123145',20,'*'),(3542,'risus posuere','risus posuere',0,1,1.4333,'R2126',20,'*'),(3543,'risus posuere vel','risus posuere vel',0,1,1.5667,'R212614',20,'*'),(3544,'rutrum ac','rutrum ac',0,1,1.3,'R3652',20,'*'),(3545,'rutrum ac suscipit','rutrum ac suscipit',0,1,1.6,'R365213',20,'*'),(3546,'rutrum vitae','rutrum vitae',0,1,1.4,'R36513',20,'*'),(3547,'rutrum vitae diam','rutrum vitae diam',0,1,1.5667,'R365135',20,'*'),(3548,'s is','s is',0,1,1.1333,'S000',1,'*'),(3549,'s is a','s is a',0,1,1.2,'S000',1,'*'),(3550,'sed non','sed non',0,1,1.2333,'S350',20,'*'),(3551,'sed non libero','sed non libero',0,1,1.4667,'S35416',20,'*'),(3552,'sem eget','sem eget',0,1,1.2667,'S523',20,'*'),(3553,'sem eget nisi','sem eget nisi',0,1,1.4333,'S52352',20,'*'),(3554,'semper risus','semper risus',0,1,1.4,'S5162',20,'*'),(3555,'semper risus molestie','semper risus molestie',0,1,1.7,'S51625423',20,'*'),(3556,'sit amet rutrum','sit amet rutrum',0,1,1.5,'S3536365',20,'*'),(3557,'sony','sony',0,0,0.2667,'S500',1,'*'),(3558,'suscipit','suscipit',0,0,0.5333,'S130',20,'*'),(3559,'suscipit id','suscipit id',0,1,1.3667,'S130',20,'*'),(3560,'suscipit id vehicula','suscipit id vehicula',0,1,1.6667,'S13124',20,'*'),(3561,'tablet','tablet',0,0,0.4,'T143',4,'*'),(3562,'tablet designed','tablet designed',0,1,1.5,'T143253',1,'*'),(3563,'tablet designed by','tablet designed by',0,1,1.6,'T1432531',1,'*'),(3564,'tablet s','tablet s',0,1,1.2667,'T1432',1,'*'),(3565,'tablet s is','tablet s is',0,1,1.3667,'T1432',1,'*'),(3566,'the xperia','the xperia',0,1,1.3333,'T216',1,'*'),(3567,'the xperia tablet','the xperia tablet',0,1,1.5667,'T2163143',1,'*'),(3568,'tincidunt neque','tincidunt neque',0,1,1.5,'T5235352',20,'*'),(3569,'tincidunt neque luctus','tincidunt neque luctus',0,1,1.7333,'T52353524232',20,'*'),(3570,'touchscreen','touchscreen',0,0,0.7333,'T265',1,'*'),(3571,'touchscreen android','touchscreen android',0,1,1.6333,'T265363',1,'*'),(3572,'touchscreen android tablet','touchscreen android tablet',0,1,1.8667,'T265363143',1,'*'),(3573,'turpis','turpis',0,0,0.4,'T612',20,'*'),(3574,'turpis aliquam','turpis aliquam',0,1,1.4667,'T612425',20,'*'),(3575,'turpis aliquam non','turpis aliquam non',0,1,1.6,'T612425',20,'*'),(3576,'turpis in','turpis in',0,1,1.3,'T6125',20,'*'),(3577,'turpis in feugiat','turpis in feugiat',0,1,1.5667,'T6125123',20,'*'),(3578,'ullamcorper posuere','ullamcorper posuere',0,1,1.6333,'U452616126',20,'*'),(3579,'ullamcorper posuere turpis','ullamcorper posuere turpis',0,1,1.8667,'U4526161263612',20,'*'),(3580,'ultrices','ultrices',0,0,0.5333,'U4362',20,'*'),(3581,'ultrices commodo','ultrices commodo',0,1,1.5333,'U436253',20,'*'),(3582,'ultrices commodo magna','ultrices commodo magna',0,1,1.7333,'U436253525',20,'*'),(3583,'urna auctor','urna auctor',0,1,1.3667,'U65236',20,'*'),(3584,'urna auctor at','urna auctor at',0,1,1.4667,'U652363',20,'*'),(3585,'ut odio','ut odio',0,1,1.2333,'U300',20,'*'),(3586,'ut odio venenatis','ut odio venenatis',0,1,1.5667,'U31532',20,'*'),(3587,'ut quis','ut quis',0,1,1.2333,'U320',20,'*'),(3588,'ut quis turpis','ut quis turpis',0,1,1.4667,'U323612',20,'*'),(3589,'ut velit','ut velit',0,1,1.2667,'U3143',20,'*'),(3590,'ut velit urna','ut velit urna',0,1,1.4333,'U314365',20,'*'),(3591,'vehicula vel','vehicula vel',0,1,1.4,'V2414',20,'*'),(3592,'vehicula vel nibh','vehicula vel nibh',0,1,1.5667,'V241451',20,'*'),(3593,'vel felis','vel felis',0,1,1.3,'V4142',20,'*'),(3594,'vel felis hendrerit','vel felis hendrerit',0,1,1.6333,'V41425363',20,'*'),(3595,'vel nibh','vel nibh',0,1,1.2667,'V451',20,'*'),(3596,'vel nibh nulla','vel nibh nulla',0,1,1.4667,'V45154',20,'*'),(3597,'vel ut','vel ut',0,1,1.2,'V430',20,'*'),(3598,'vel ut velit','vel ut velit',0,1,1.4,'V43143',20,'*'),(3599,'velit neque','velit neque',0,1,1.3667,'V4352',20,'*'),(3600,'velit neque rutrum','velit neque rutrum',0,1,1.6,'V43526365',20,'*'),(3601,'velit urna','velit urna',0,1,1.3333,'V4365',20,'*'),(3602,'velit urna auctor','velit urna auctor',0,1,1.5667,'V4365236',20,'*'),(3603,'venenatis condimentum','venenatis condimentum',0,1,1.7,'V53253535',20,'*'),(3604,'venenatis condimentum bibendum','venenatis condimentum bibendum',0,1,2,'V532535351535',20,'*'),(3605,'vestibulum aenean','vestibulum aenean',0,1,1.5667,'V23145',20,'*'),(3606,'vestibulum aenean commodo','vestibulum aenean commodo',0,1,1.8333,'V23145253',20,'*'),(3607,'vitae diam','vitae diam',0,1,1.3333,'V350',20,'*'),(3608,'vitae diam maecenas','vitae diam maecenas',0,1,1.6333,'V35252',20,'*'),(3609,'vivamus eu','vivamus eu',0,1,1.3333,'V520',20,'*'),(3610,'vivamus eu laoreet','vivamus eu laoreet',0,1,1.6,'V52463',20,'*'),(3611,'xperia','xperia',0,0,0.4,'X160',1,'*'),(3612,'xperia tablet','xperia tablet',0,1,1.4333,'X163143',1,'*'),(3613,'xperia tablet s','xperia tablet s',0,1,1.5,'X1631432',1,'*'),(3615,'has redesigned','has redesigned',0,1,1.4667,'H263253',1,'*'),(3616,'has redesigned its','has redesigned its',0,1,1.6,'H2632532',1,'*'),(3617,'hub','hub',0,0,0.2,'H100',1,'*'),(3618,'hub tv','hub tv',0,1,1.2,'H131',1,'*'),(3619,'hub tv system','hub tv system',0,1,1.4333,'H131235',1,'*'),(3620,'its','its',0,0,0.2,'I320',2,'*'),(3621,'its smart','its smart',0,1,1.3,'I32563',1,'*'),(3622,'its smart hub','its smart hub',0,1,1.4333,'I325631',1,'*'),(3623,'redesigned','redesigned',0,0,0.6667,'R3253',1,'*'),(3624,'redesigned its','redesigned its',0,1,1.4667,'R32532',1,'*'),(3625,'redesigned its smart','redesigned its smart',0,1,1.6667,'R32532563',1,'*'),(3626,'samsung','samsung',0,0,0.4667,'S5252',6,'*'),(3627,'samsung has','samsung has',0,1,1.3667,'S5252',2,'*'),(3628,'samsung has redesigned','samsung has redesigned',0,1,1.7333,'S525263253',1,'*'),(3629,'smart hub','smart hub',0,1,1.3,'S5631',1,'*'),(3630,'smart hub tv','smart hub tv',0,1,1.4,'S563131',1,'*'),(3631,'system','system',0,0,0.4,'S350',1,'*'),(3632,'tv','tv',0,0,0.1333,'T100',4,'*'),(3633,'tv system','tv system',0,1,1.3,'T1235',1,'*'),(3646,'3d','3d',0,0,0.1333,'D000',1,'*'),(3647,'3d ready','3d ready',0,1,1.2667,'D630',1,'*'),(3648,'3d ready television','3d ready television',0,1,1.6333,'D634125',1,'*'),(3649,'3d ready tv','3d ready tv',0,1,1.3667,'D631',1,'*'),(3650,'does','does',0,0,0.2667,'D200',1,'*'),(3651,'does 3d','does 3d',0,1,1.2333,'D230',1,'*'),(3652,'does 3d ready','does 3d ready',0,1,1.4333,'D2363',1,'*'),(3653,'explained','explained',0,0,0.6,'E21453',1,'*'),(3654,'mean','mean',0,0,0.2667,'M000',1,'*'),(3655,'mean 3d','mean 3d',0,1,1.2333,'M300',1,'*'),(3656,'mean 3d ready','mean 3d ready',0,1,1.4333,'M363',1,'*'),(3657,'ready','ready',0,0,0.3333,'R300',1,'*'),(3658,'ready television','ready television',0,1,1.5333,'R34125',1,'*'),(3659,'ready television explained','ready television explained',0,1,1.8667,'R3412521453',1,'*'),(3660,'ready tv','ready tv',0,1,1.2667,'R310',1,'*'),(3661,'ready tv mean','ready tv mean',0,1,1.4333,'R315',1,'*'),(3662,'television','television',0,0,0.6667,'T4125',1,'*'),(3663,'television explained','television explained',0,1,1.6667,'T412521453',1,'*'),(3664,'tv mean','tv mean',0,1,1.2333,'T150',1,'*'),(3665,'tv mean 3d','tv mean 3d',0,1,1.3333,'T153',1,'*'),(3666,'what','what',0,0,0.2667,'W300',1,'*'),(3667,'what does','what does',0,1,1.3,'W320',1,'*'),(3668,'what does 3d','what does 3d',0,1,1.4,'W323',1,'*'),(3677,'7 offers','7 offers',0,1,1.2667,'O162',1,'*'),(3678,'7 offers a','7 offers a',0,1,1.3333,'O162',1,'*'),(3679,'a pure','a pure',0,1,1.2,'A160',1,'*'),(3680,'a pure android','a pure android',0,1,1.4667,'A165363',1,'*'),(3681,'android user','android user',0,1,1.4,'A536326',1,'*'),(3682,'android user experience','android user experience',0,1,1.7667,'A53632621652',1,'*'),(3683,'experience','experience',0,0,0.6667,'E21652',1,'*'),(3684,'google','google',0,0,0.4,'G400',1,'*'),(3685,'google nexus','google nexus',0,1,1.4,'G452',1,'*'),(3686,'google nexus 7','google nexus 7',0,1,1.4667,'G452',1,'*'),(3687,'nexus','nexus',0,0,0.3333,'N200',1,'*'),(3688,'nexus 7','nexus 7',0,1,1.2333,'N200',1,'*'),(3689,'nexus 7 offers','nexus 7 offers',0,1,1.4667,'N2162',1,'*'),(3690,'offers','offers',0,0,0.4,'O162',1,'*'),(3691,'offers a','offers a',0,1,1.2667,'O162',1,'*'),(3692,'offers a pure','offers a pure',0,1,1.4333,'O16216',1,'*'),(3693,'pure','pure',0,0,0.2667,'P600',1,'*'),(3694,'pure android','pure android',0,1,1.4,'P65363',1,'*'),(3695,'pure android user','pure android user',0,1,1.5667,'P6536326',1,'*'),(3696,'user experience','user experience',0,1,1.5,'U2621652',1,'*'),(3708,'10 3','10 3',0,1,1.1333,'',1,'*'),(3709,'10 3 vs','10 3 vs',0,1,1.2333,'V200',1,'*'),(3710,'10.3','10.3',0,0,0.4,'',1,'*'),(3711,'10.3 vs','10.3 vs',0,1,1.2333,'V200',1,'*'),(3712,'10.3 vs apple','10.3 vs apple',0,1,1.4333,'V214',1,'*'),(3713,'3 vs','3 vs',0,1,1.1333,'V200',1,'*'),(3714,'3 vs apple','3 vs apple',0,1,1.3333,'V214',1,'*'),(3715,'apple','apple',0,0,0.3333,'A140',3,'*'),(3716,'apple ipad','apple ipad',0,1,1.3333,'A1413',1,'*'),(3717,'apple ipad 4','apple ipad 4',0,1,1.4,'A1413',1,'*'),(3718,'galaxy','galaxy',0,0,0.4,'G420',4,'*'),(3719,'galaxy note','galaxy note',0,1,1.3667,'G4253',1,'*'),(3720,'galaxy note 10','galaxy note 10',0,1,1.4667,'G4253',1,'*'),(3721,'galaxy note 10.3','galaxy note 10.3',0,1,1.5333,'G4253',1,'*'),(3722,'head','head',0,0,0.2667,'H300',1,'*'),(3723,'head samsung','head samsung',0,1,1.4,'H325252',1,'*'),(3724,'head samsung galaxy','head samsung galaxy',0,1,1.6333,'H32525242',1,'*'),(3725,'head to','head to',0,1,1.2333,'H300',1,'*'),(3726,'head to head','head to head',0,1,1.4,'H300',1,'*'),(3727,'head-to-head','head-to-head',0,0,0.8,'H300',1,'*'),(3728,'head-to-head samsung','head-to-head samsung',0,1,1.6667,'H325252',1,'*'),(3729,'head-to-head samsung galaxy','head-to-head samsung galaxy',0,1,1.9,'H32525242',1,'*'),(3730,'ipad','ipad',0,0,0.2667,'I130',2,'*'),(3731,'ipad 4','ipad 4',0,1,1.2,'I130',2,'*'),(3732,'note','note',0,0,0.2667,'N300',1,'*'),(3733,'note 10','note 10',0,1,1.2333,'N300',1,'*'),(3734,'note 10 3','note 10 3',0,1,1.3,'N300',1,'*'),(3735,'note 10.3','note 10.3',0,1,1.3,'N300',1,'*'),(3736,'note 10.3 vs','note 10.3 vs',0,1,1.4,'N312',1,'*'),(3737,'samsung galaxy','samsung galaxy',0,1,1.4667,'S525242',3,'*'),(3738,'samsung galaxy note','samsung galaxy note',0,1,1.6333,'S52524253',1,'*'),(3739,'to head','to head',0,1,1.2333,'T000',1,'*'),(3740,'to head samsung','to head samsung',0,1,1.5,'T25252',1,'*'),(3741,'vs','vs',0,0,0.1333,'V200',1,'*'),(3742,'vs apple','vs apple',0,1,1.2667,'V214',1,'*'),(3743,'vs apple ipad','vs apple ipad',0,1,1.4333,'V21413',1,'*'),(3771,'air in','air in',0,1,1.2,'A650',1,'*'),(3772,'air in june','air in june',0,1,1.3667,'A6525',1,'*'),(3773,'and macbook','and macbook',0,1,1.3667,'A535212',1,'*'),(3774,'and macbook air','and macbook air',0,1,1.5,'A5352126',1,'*'),(3775,'apple to','apple to',0,1,1.2667,'A143',1,'*'),(3776,'apple to update','apple to update',0,1,1.5,'A14313',1,'*'),(3777,'in june','in june',0,1,1.2333,'I525',1,'*'),(3778,'in june 2013','in june 2013',0,1,1.4,'I525',1,'*'),(3779,'june','june',0,0,0.2667,'J500',1,'*'),(3780,'june 2013','june 2013',0,1,1.3,'J500',1,'*'),(3781,'macbook air in','macbook air in',0,1,1.4667,'M21265',1,'*'),(3782,'macbook pro','macbook pro',0,1,1.3667,'M21216',1,'*'),(3783,'macbook pro and','macbook pro and',0,1,1.5,'M2121653',1,'*'),(3784,'pro','pro',0,0,0.2,'P600',1,'*'),(3785,'pro and','pro and',0,1,1.2333,'P653',1,'*'),(3786,'pro and macbook','pro and macbook',0,1,1.5,'P6535212',1,'*'),(3787,'to update','to update',0,1,1.3,'T130',1,'*'),(3788,'to update macbook','to update macbook',0,1,1.5667,'T135212',1,'*'),(3789,'update','update',0,0,0.4,'U130',1,'*'),(3790,'update macbook','update macbook',0,1,1.4667,'U135212',1,'*'),(3791,'update macbook pro','update macbook pro',0,1,1.6,'U13521216',1,'*'),(3802,'12 from','12 from',0,1,1.2333,'F650',1,'*'),(3803,'12 from an','12 from an',0,1,1.3333,'F650',1,'*'),(3804,'a flip','a flip',0,1,1.2,'A141',1,'*'),(3805,'a flip of','a flip of',0,1,1.3,'A141',1,'*'),(3806,'a tablet','a tablet',0,1,1.2667,'A3143',1,'*'),(3807,'a tablet with','a tablet with',0,1,1.4333,'A3143',1,'*'),(3808,'an ultrabook','an ultrabook',0,1,1.4,'A543612',1,'*'),(3809,'an ultrabook to','an ultrabook to',0,1,1.5,'A5436123',1,'*'),(3810,'dell','dell',0,0,0.2667,'D400',1,'*'),(3811,'dell s','dell s',0,1,1.2,'D420',1,'*'),(3812,'dell s xps','dell s xps',0,1,1.3333,'D4212',1,'*'),(3813,'dell\'s','dell',0,0,0.4,'D420',1,'*'),(3814,'dell\'s xps','dell xps',0,1,1.3333,'D4212',1,'*'),(3815,'dell\'s xps 12','dell xps 12',0,1,1.4333,'D4212',1,'*'),(3816,'display','display',0,0,0.4667,'D214',3,'*'),(3817,'flip','flip',0,0,0.2667,'F410',1,'*'),(3818,'flip of','flip of',0,1,1.2333,'F410',1,'*'),(3819,'flip of the','flip of the',0,1,1.3667,'F413',1,'*'),(3820,'from an','from an',0,1,1.2333,'F650',1,'*'),(3821,'from an ultrabook','from an ultrabook',0,1,1.5667,'F6543612',1,'*'),(3822,'of the display','of the display',0,1,1.4667,'O13214',1,'*'),(3823,'s xps','s xps',0,1,1.1667,'S120',1,'*'),(3824,'s xps 12','s xps 12',0,1,1.2667,'S120',1,'*'),(3825,'tablet with','tablet with',0,1,1.3667,'T143',1,'*'),(3826,'tablet with a','tablet with a',0,1,1.4333,'T143',1,'*'),(3827,'the display','the display',0,1,1.3667,'T214',1,'*'),(3828,'to a','to a',0,1,1.1333,'T000',1,'*'),(3829,'to a tablet','to a tablet',0,1,1.3667,'T143',1,'*'),(3830,'ultrabook','ultrabook',0,0,0.6,'U43612',1,'*'),(3831,'ultrabook to','ultrabook to',0,1,1.4,'U436123',1,'*'),(3832,'ultrabook to a','ultrabook to a',0,1,1.4667,'U436123',1,'*'),(3833,'with a','with a',0,1,1.2,'W300',2,'*'),(3834,'with a flip','with a flip',0,1,1.3667,'W3141',1,'*'),(3835,'xps','xps',0,0,0.2,'X120',1,'*'),(3836,'xps 12','xps 12',0,1,1.2,'X120',1,'*'),(3837,'xps 12 from','xps 12 from',0,1,1.3667,'X12165',1,'*'),(3865,'asus','asus',0,0,0.2667,'A200',2,'*'),(3866,'from asus','from asus',0,1,1.3,'F652',1,'*'),(3867,'new ultra','new ultra',0,1,1.3,'N436',1,'*'),(3868,'new ultra thin','new ultra thin',0,1,1.4667,'N43635',1,'*'),(3869,'new ultra-thin','new ultra-thin',0,1,1.4667,'N43635',1,'*'),(3870,'new ultra-thin ux','new ultra-thin ux',0,1,1.5667,'N436352',1,'*'),(3871,'portable','portable',0,0,0.5333,'P6314',1,'*'),(3872,'portable from','portable from',0,1,1.4333,'P6314165',1,'*'),(3873,'portable from asus','portable from asus',0,1,1.6,'P63141652',1,'*'),(3874,'series ultra','series ultra',0,1,1.4,'S62436',1,'*'),(3875,'series ultra portable','series ultra portable',0,1,1.7,'S6243616314',1,'*'),(3876,'series ultra-portable','series ultra-portable',0,1,1.7,'S6243616314',1,'*'),(3877,'series ultra-portable from','series ultra-portable from',0,1,1.8667,'S6243616314165',1,'*'),(3878,'the new','the new',0,1,1.2333,'T500',1,'*'),(3879,'the new ultra','the new ultra',0,1,1.4333,'T5436',1,'*'),(3880,'the new ultra-thin','the new ultra-thin',0,1,1.6,'T543635',1,'*'),(3881,'thin','thin',0,0,0.2667,'T500',2,'*'),(3882,'thin ux','thin ux',0,1,1.2333,'T520',1,'*'),(3883,'thin ux series','thin ux series',0,1,1.4667,'T5262',1,'*'),(3884,'ultra','ultra',0,0,0.3333,'U436',1,'*'),(3885,'ultra portable','ultra portable',0,1,1.4667,'U43616314',1,'*'),(3886,'ultra portable from','ultra portable from',0,1,1.6333,'U43616314165',1,'*'),(3887,'ultra thin','ultra thin',0,1,1.3333,'U43635',1,'*'),(3888,'ultra thin ux','ultra thin ux',0,1,1.4333,'U436352',1,'*'),(3889,'ultra-portable','ultra-portable',0,0,0.9333,'U43616314',1,'*'),(3890,'ultra-portable from','ultra-portable from',0,1,1.6333,'U43616314165',1,'*'),(3891,'ultra-portable from asus','ultra-portable from asus',0,1,1.8,'U436163141652',1,'*'),(3892,'ultra-thin','ultra-thin',0,0,0.6667,'U43635',1,'*'),(3893,'ultra-thin ux','ultra-thin ux',0,1,1.4333,'U436352',1,'*'),(3894,'ultra-thin ux series','ultra-thin ux series',0,1,1.6667,'U43635262',1,'*'),(3895,'ux','ux',0,0,0.1333,'U200',1,'*'),(3896,'ux series','ux series',0,1,1.3,'U262',1,'*'),(3897,'ux series ultra','ux series ultra',0,1,1.5,'U262436',1,'*'),(3898,'ux series ultra-portable','ux series ultra-portable',0,1,1.8,'U26243616314',1,'*'),(3928,'21 is','21 is',0,1,1.1667,'I200',1,'*'),(3929,'21 is innovation','21 is innovation',0,1,1.5333,'I25135',1,'*'),(3930,'asus taichi','asus taichi',0,1,1.3667,'A232',1,'*'),(3931,'asus taichi 21','asus taichi 21',0,1,1.4667,'A232',1,'*'),(3932,'at its','at its',0,1,1.2,'A320',1,'*'),(3933,'at its finest','at its finest',0,1,1.4333,'A321523',1,'*'),(3934,'finest','finest',0,0,0.4,'F523',1,'*'),(3935,'finest with','finest with',0,1,1.3667,'F523',1,'*'),(3936,'finest with surface','finest with surface',0,1,1.6333,'F5232612',1,'*'),(3937,'innovation','innovation',0,0,0.6667,'I5135',1,'*'),(3938,'innovation at','innovation at',0,1,1.4333,'I51353',1,'*'),(3939,'innovation at its','innovation at its',0,1,1.5667,'I513532',1,'*'),(3940,'interface','interface',0,0,0.6,'I53612',1,'*'),(3941,'is innovation','is innovation',0,1,1.4333,'I25135',1,'*'),(3942,'is innovation at','is innovation at',0,1,1.5333,'I251353',1,'*'),(3943,'its finest','its finest',0,1,1.3333,'I321523',1,'*'),(3944,'its finest with','its finest with',0,1,1.5,'I321523',1,'*'),(3945,'surface','surface',0,0,0.4667,'S612',1,'*'),(3946,'surface interface','surface interface',0,1,1.5667,'S61253612',1,'*'),(3947,'taichi','taichi',0,0,0.4,'T200',1,'*'),(3948,'taichi 21','taichi 21',0,1,1.3,'T200',1,'*'),(3949,'taichi 21 is','taichi 21 is',0,1,1.4,'T200',1,'*'),(3950,'the asus','the asus',0,1,1.2667,'T200',1,'*'),(3951,'the asus taichi','the asus taichi',0,1,1.5,'T232',1,'*'),(3952,'with surface','with surface',0,1,1.4,'W32612',1,'*'),(3953,'with surface interface','with surface interface',0,1,1.7333,'W3261253612',1,'*'),(3959,'8 laptop','8 laptop',0,1,1.2667,'L131',1,'*'),(3960,'8 laptop with','8 laptop with',0,1,1.4333,'L1313',1,'*'),(3961,'a great','a great',0,1,1.2333,'A263',1,'*'),(3962,'a great windows','a great windows',0,1,1.5,'A263532',1,'*'),(3963,'a side','a side',0,1,1.2,'A230',1,'*'),(3964,'a side of','a side of',0,1,1.3,'A231',1,'*'),(3965,'great','great',0,0,0.3333,'G630',1,'*'),(3966,'great windows','great windows',0,1,1.4333,'G63532',1,'*'),(3967,'great windows 8','great windows 8',0,1,1.5,'G63532',1,'*'),(3968,'ideapad','ideapad',0,0,0.4667,'I313',1,'*'),(3969,'ideapad a','ideapad a',0,1,1.3,'I313',1,'*'),(3970,'ideapad a great','ideapad a great',0,1,1.5,'I313263',1,'*'),(3971,'laptop','laptop',0,0,0.4,'L131',1,'*'),(3972,'laptop with','laptop with',0,1,1.3667,'L1313',1,'*'),(3973,'laptop with a','laptop with a',0,1,1.4333,'L1313',1,'*'),(3974,'lenovo','lenovo',0,0,0.4,'L510',1,'*'),(3975,'lenovo ideapad','lenovo ideapad',0,1,1.4667,'L51313',1,'*'),(3976,'lenovo ideapad a','lenovo ideapad a',0,1,1.5333,'L51313',1,'*'),(3977,'of tablet','of tablet',0,1,1.3,'O13143',1,'*'),(3978,'side','side',0,0,0.2667,'S300',1,'*'),(3979,'side of','side of',0,1,1.2333,'S310',1,'*'),(3980,'side of tablet','side of tablet',0,1,1.4667,'S313143',1,'*'),(3981,'windows','windows',0,0,0.4667,'W532',2,'*'),(3982,'windows 8','windows 8',0,1,1.3,'W532',1,'*'),(3983,'windows 8 laptop','windows 8 laptop',0,1,1.5333,'W5324131',1,'*'),(3984,'with a side','with a side',0,1,1.3667,'W323',1,'*'),(3990,'1 1','1 1',0,1,1.1,'',1,'*'),(3991,'1 1 tablet','1 1 tablet',0,1,1.3333,'T143',1,'*'),(3992,'1 tablet','1 tablet',0,1,1.2667,'T143',1,'*'),(3993,'1 tablet android','1 tablet android',0,1,1.5333,'T1435363',1,'*'),(3994,'10 1','10 1',0,1,1.1333,'',1,'*'),(3995,'10 1 1','10 1 1',0,1,1.2,'',1,'*'),(3996,'10.1','10.1',0,0,0.4,'',1,'*'),(3997,'10.1 1','10.1 1',0,1,1.2,'',1,'*'),(3998,'10.1 1 tablet','10.1 1 tablet',0,1,1.4333,'T143',1,'*'),(3999,'android com','android com',0,1,1.3667,'A536325',1,'*'),(4000,'android com display','android com display',0,1,1.6333,'A5363253214',1,'*'),(4001,'com','com',0,0,0.2,'C500',1,'*'),(4002,'com display','com display',0,1,1.3667,'C53214',1,'*'),(4003,'com display wide','com display wide',0,1,1.5333,'C532143',1,'*'),(4004,'display wide','display wide',0,1,1.4,'D2143',1,'*'),(4005,'display wide 10','display wide 10',0,1,1.5,'D2143',1,'*'),(4006,'display wide 10.1','display wide 10.1',0,1,1.5667,'D2143',1,'*'),(4007,'galaxy tab','galaxy tab',0,1,1.3333,'G4231',1,'*'),(4008,'galaxy tab 10','galaxy tab 10',0,1,1.4333,'G4231',1,'*'),(4009,'galaxy tab 10.1','galaxy tab 10.1',0,1,1.5,'G4231',1,'*'),(4010,'samsung galaxy tab','samsung galaxy tab',0,1,1.6,'S52524231',1,'*'),(4011,'tab','tab',0,0,0.2,'T100',1,'*'),(4012,'tab 10','tab 10',0,1,1.2,'T100',1,'*'),(4013,'tab 10 1','tab 10 1',0,1,1.2667,'T100',1,'*'),(4014,'tab 10.1','tab 10.1',0,1,1.2667,'T100',1,'*'),(4015,'tab 10.1 1','tab 10.1 1',0,1,1.3333,'T100',1,'*'),(4016,'tablet android','tablet android',0,1,1.4667,'T1435363',1,'*'),(4017,'tablet android com','tablet android com',0,1,1.6,'T143536325',1,'*'),(4018,'wide','wide',0,0,0.2667,'W300',1,'*'),(4019,'wide 10','wide 10',0,1,1.2333,'W300',1,'*'),(4020,'wide 10 1','wide 10 1',0,1,1.3,'W300',1,'*'),(4021,'wide 10.1','wide 10.1',0,1,1.3,'W300',1,'*'),(4053,'8 in','8 in',0,1,1.1333,'I500',1,'*'),(4054,'8 in 2013','8 in 2013',0,1,1.3,'I500',1,'*'),(4055,'launch','launch',0,0,0.4,'L520',1,'*'),(4056,'launch new','launch new',0,1,1.3333,'L525',1,'*'),(4057,'launch new smartphone','launch new smartphone',0,1,1.7,'L525256315',1,'*'),(4058,'new smartphone','new smartphone',0,1,1.4667,'N256315',1,'*'),(4059,'new smartphone with','new smartphone with',0,1,1.6333,'N2563153',1,'*'),(4060,'nokia','nokia',0,0,0.3333,'N200',1,'*'),(4061,'nokia to','nokia to',0,1,1.2667,'N230',1,'*'),(4062,'nokia to launch','nokia to launch',0,1,1.5,'N23452',1,'*'),(4063,'phone','phone',0,0,0.3333,'P500',1,'*'),(4064,'phone 8','phone 8',0,1,1.2333,'P500',1,'*'),(4065,'phone 8 in','phone 8 in',0,1,1.3333,'P500',1,'*'),(4066,'smartphone','smartphone',0,0,0.6667,'S56315',1,'*'),(4067,'smartphone with','smartphone with',0,1,1.5,'S563153',1,'*'),(4068,'smartphone with windows','smartphone with windows',0,1,1.7667,'S563153532',1,'*'),(4069,'to launch','to launch',0,1,1.3,'T452',1,'*'),(4070,'to launch new','to launch new',0,1,1.4333,'T4525',1,'*'),(4071,'windows phone','windows phone',0,1,1.4333,'W53215',1,'*'),(4072,'windows phone 8','windows phone 8',0,1,1.5,'W53215',1,'*'),(4073,'with windows','with windows',0,1,1.4,'W3532',1,'*'),(4074,'with windows phone','with windows phone',0,1,1.6,'W353215',1,'*'),(4084,'a new','a new',0,1,1.1667,'A500',1,'*'),(4085,'a new blackberry','a new blackberry',0,1,1.5333,'A514216',1,'*'),(4086,'blackberry','blackberry',0,0,0.6667,'B4216',1,'*'),(4087,'blackberry z10','blackberry z10',0,1,1.4667,'B42162',1,'*'),(4088,'blackberry z10 is','blackberry z10 is',0,1,1.5667,'B42162',1,'*'),(4089,'is more','is more',0,1,1.2333,'I256',1,'*'),(4090,'is more than','is more than',0,1,1.4,'I25635',1,'*'),(4091,'just','just',0,0,0.2667,'J300',1,'*'),(4092,'just a','just a',0,1,1.2,'J300',1,'*'),(4093,'just a new','just a new',0,1,1.3333,'J350',1,'*'),(4094,'more than','more than',0,1,1.3,'M635',1,'*'),(4095,'more than just','more than just',0,1,1.4667,'M63523',1,'*'),(4096,'new blackberry','new blackberry',0,1,1.4667,'N14216',1,'*'),(4097,'than','than',0,0,0.2667,'T500',1,'*'),(4098,'than just','than just',0,1,1.3,'T523',1,'*'),(4099,'than just a','than just a',0,1,1.3667,'T523',1,'*'),(4100,'the blackberry','the blackberry',0,1,1.4667,'T14216',1,'*'),(4101,'the blackberry z10','the blackberry z10',0,1,1.6,'T142162',1,'*'),(4102,'z10','z10',0,0,0.2,'Z000',1,'*'),(4103,'z10 is','z10 is',0,1,1.2,'Z000',1,'*'),(4104,'z10 is more','z10 is more',0,1,1.3667,'Z560',1,'*'),(4115,'designed for','designed for',0,1,1.4,'D25316',1,'*'),(4116,'designed for humans','designed for humans',0,1,1.6333,'D2531652',1,'*'),(4117,'for humans','for humans',0,1,1.3333,'F652',1,'*'),(4118,'for humans inspired','for humans inspired',0,1,1.6333,'F65252163',1,'*'),(4119,'galaxy s','galaxy s',0,1,1.2667,'G420',1,'*'),(4120,'galaxy s iii','galaxy s iii',0,1,1.4,'G420',1,'*'),(4121,'humans','humans',0,0,0.4,'H520',1,'*'),(4122,'humans inspired','humans inspired',0,1,1.5,'H5252163',1,'*'),(4123,'humans inspired by','humans inspired by',0,1,1.6,'H52521631',1,'*'),(4124,'iii designed','iii designed',0,1,1.4,'I3253',1,'*'),(4125,'iii designed for','iii designed for',0,1,1.5333,'I325316',1,'*'),(4126,'s iii','s iii',0,1,1.1667,'S000',1,'*'),(4127,'s iii designed','s iii designed',0,1,1.4667,'S3253',1,'*'),(4130,'5 features','5 features',0,1,1.3333,'F362',1,'*'),(4131,'5 features latest','5 features latest',0,1,1.5667,'F3624323',1,'*'),(4132,'and so','and so',0,1,1.2,'A532',1,'*'),(4133,'and so light','and so light',0,1,1.4,'A532423',1,'*'),(4134,'features','features',0,0,0.5333,'F362',1,'*'),(4135,'features latest','features latest',0,1,1.5,'F3624323',1,'*'),(4136,'features latest technology','features latest technology',0,1,1.8667,'F36243232542',1,'*'),(4137,'iphone','iphone',0,0,0.4,'I150',1,'*'),(4138,'iphone 5','iphone 5',0,1,1.2667,'I150',1,'*'),(4139,'iphone 5 features','iphone 5 features',0,1,1.5667,'I151362',1,'*'),(4140,'it','it',0,0,0.1333,'I300',1,'*'),(4141,'it s','it s',0,1,1.1333,'I320',1,'*'),(4142,'it s so','it s so',0,1,1.2333,'I320',1,'*'),(4143,'it\'s','it',0,0,0.2667,'I320',1,'*'),(4144,'it\'s so','it so',0,1,1.2333,'I320',1,'*'),(4145,'it\'s so thin','it so thin',0,1,1.4,'I3235',1,'*'),(4146,'latest','latest',0,0,0.4,'L323',1,'*'),(4147,'latest technology','latest technology',0,1,1.5667,'L3232542',1,'*'),(4148,'light yet','light yet',0,1,1.3,'L230',1,'*'),(4149,'light yet iphone','light yet iphone',0,1,1.5333,'L2315',1,'*'),(4150,'s so','s so',0,1,1.1333,'S000',1,'*'),(4151,'s so thin','s so thin',0,1,1.3,'S350',1,'*'),(4152,'so','so',0,0,0.1333,'S000',1,'*'),(4153,'so light','so light',0,1,1.2667,'S423',1,'*'),(4154,'so light yet','so light yet',0,1,1.4,'S423',1,'*'),(4155,'so thin','so thin',0,1,1.2333,'S350',1,'*'),(4156,'so thin and','so thin and',0,1,1.3667,'S353',1,'*'),(4157,'technology','technology',0,0,0.6667,'T2542',1,'*'),(4158,'thin and','thin and',0,1,1.2667,'T530',1,'*'),(4159,'thin and so','thin and so',0,1,1.3667,'T532',1,'*'),(4160,'yet','yet',0,0,0.2,'Y300',1,'*'),(4161,'yet iphone','yet iphone',0,1,1.3333,'Y315',1,'*'),(4162,'yet iphone 5','yet iphone 5',0,1,1.4,'Y315',1,'*'),(4193,'camera','camera',0,0,0.4,'C560',1,'*'),(4194,'camera gc100','camera gc100',0,1,1.4,'C562',1,'*'),(4195,'camera gc100 android','camera gc100 android',0,1,1.6667,'C5625363',1,'*'),(4196,'combination','combination',0,0,0.7333,'C51535',1,'*'),(4197,'combination of','combination of',0,1,1.4667,'C515351',1,'*'),(4198,'combination of samsung','combination of samsung',0,1,1.7333,'C51535125252',1,'*'),(4199,'galaxy camera','galaxy camera',0,1,1.4333,'G4256',1,'*'),(4200,'galaxy camera gc100','galaxy camera gc100',0,1,1.6333,'G42562',1,'*'),(4201,'gc100','gc100',0,0,0.3333,'G000',1,'*'),(4202,'gc100 android','gc100 android',0,1,1.4333,'G5363',1,'*'),(4203,'interesting','interesting',0,0,0.7333,'I5362352',1,'*'),(4204,'interesting combination','interesting combination',0,1,1.7667,'I536235251535',1,'*'),(4205,'interesting combination of','interesting combination of',0,1,1.8667,'I5362352515351',1,'*'),(4206,'of samsung','of samsung',0,1,1.3333,'O125252',1,'*'),(4207,'of samsung galaxy','of samsung galaxy',0,1,1.5667,'O12525242',1,'*'),(4208,'samsung galaxy camera','samsung galaxy camera',0,1,1.7,'S52524256',1,'*'),(4224,'1ghz','1ghz',0,0,0.2667,'G000',1,'*'),(4225,'1ghz dual','1ghz dual',0,1,1.3,'G340',1,'*'),(4226,'1ghz dual core','1ghz dual core',0,1,1.4667,'G3426',1,'*'),(4227,'1ghz dual-core','1ghz dual-core',0,1,1.4667,'G3426',1,'*'),(4228,'1ghz dual-core chipset','1ghz dual-core chipset',0,1,1.7333,'G34262123',1,'*'),(4229,'brings','brings',0,0,0.4,'B652',1,'*'),(4230,'brings new','brings new',0,1,1.3333,'B6525',1,'*'),(4231,'brings new 1ghz','brings new 1ghz',0,1,1.5,'B65252',1,'*'),(4232,'chipset','chipset',0,0,0.4667,'C123',1,'*'),(4233,'core','core',0,0,0.2667,'C600',1,'*'),(4234,'core chipset','core chipset',0,1,1.4,'C62123',1,'*'),(4235,'dual','dual',0,0,0.2667,'D400',1,'*'),(4236,'dual core','dual core',0,1,1.3,'D426',1,'*'),(4237,'dual core chipset','dual core chipset',0,1,1.5667,'D4262123',1,'*'),(4238,'dual-core','dual-core',0,0,0.6,'D426',1,'*'),(4239,'dual-core chipset','dual-core chipset',0,1,1.5667,'D4262123',1,'*'),(4240,'new 1ghz','new 1ghz',0,1,1.2667,'N200',1,'*'),(4241,'new 1ghz dual','new 1ghz dual',0,1,1.4333,'N234',1,'*'),(4242,'new 1ghz dual-core','new 1ghz dual-core',0,1,1.6,'N23426',1,'*'),(4243,'oled','oled',0,0,0.2667,'O430',1,'*'),(4244,'oled tv','oled tv',0,1,1.2333,'O431',1,'*'),(4245,'oled tv brings','oled tv brings',0,1,1.4667,'O431652',1,'*'),(4246,'samsung oled','samsung oled',0,1,1.4,'S525243',1,'*'),(4247,'samsung oled tv','samsung oled tv',0,1,1.5,'S5252431',1,'*'),(4248,'tv brings','tv brings',0,1,1.3,'T1652',1,'*'),(4249,'tv brings new','tv brings new',0,1,1.4333,'T16525',1,'*'),(4255,'75','75',0,0,0.2,'',1,'*'),(4256,'75 inch','75 inch',0,1,1.2333,'I520',1,'*'),(4257,'75 inch lcd','75 inch lcd',0,1,1.3667,'I52423',1,'*'),(4258,'75-inch','75-inch',0,0,0.4667,'I520',1,'*'),(4259,'75-inch lcd','75-inch lcd',0,1,1.3667,'I52423',1,'*'),(4260,'75-inch lcd tv','75-inch lcd tv',0,1,1.4667,'I524231',1,'*'),(4261,'a 75','a 75',0,1,1.1333,'A000',1,'*'),(4262,'a 75 inch','a 75 inch',0,1,1.3,'A520',1,'*'),(4263,'a 75-inch','a 75-inch',0,1,1.3,'A520',1,'*'),(4264,'a 75-inch lcd','a 75-inch lcd',0,1,1.4333,'A52423',1,'*'),(4265,'for sale','for sale',0,1,1.2667,'F624',1,'*'),(4266,'for sale in','for sale in',0,1,1.3667,'F6245',1,'*'),(4267,'has put','has put',0,1,1.2333,'H213',1,'*'),(4268,'has put a','has put a',0,1,1.3,'H213',1,'*'),(4269,'in south','in south',0,1,1.2667,'I523',1,'*'),(4270,'in south korea','in south korea',0,1,1.4667,'I52326',1,'*'),(4271,'inch','inch',0,0,0.2667,'I520',1,'*'),(4272,'inch lcd','inch lcd',0,1,1.2667,'I52423',1,'*'),(4273,'inch lcd tv','inch lcd tv',0,1,1.3667,'I524231',1,'*'),(4274,'korea','korea',0,0,0.3333,'K600',1,'*'),(4275,'lcd','lcd',0,0,0.2,'L230',1,'*'),(4276,'lcd tv','lcd tv',0,1,1.2,'L231',1,'*'),(4277,'lcd tv up','lcd tv up',0,1,1.3,'L231',1,'*'),(4278,'put','put',0,0,0.2,'P300',1,'*'),(4279,'put a','put a',0,1,1.1667,'P300',1,'*'),(4280,'put a 75','put a 75',0,1,1.2667,'P300',1,'*'),(4281,'put a 75-inch','put a 75-inch',0,1,1.4333,'P352',1,'*'),(4282,'sale','sale',0,0,0.2667,'S400',1,'*'),(4283,'sale in','sale in',0,1,1.2333,'S450',1,'*'),(4284,'sale in south','sale in south',0,1,1.4333,'S4523',1,'*'),(4285,'samsung has put','samsung has put',0,1,1.5,'S525213',1,'*'),(4286,'south','south',0,0,0.3333,'S300',1,'*'),(4287,'south korea','south korea',0,1,1.3667,'S326',1,'*'),(4288,'tv up','tv up',0,1,1.1667,'T100',1,'*'),(4289,'tv up for','tv up for',0,1,1.3,'T160',1,'*'),(4290,'up','up',0,0,0.1333,'U100',1,'*'),(4291,'up for','up for',0,1,1.2,'U160',1,'*'),(4292,'up for sale','up for sale',0,1,1.3667,'U1624',1,'*'),(4318,'128gb','128gb',0,0,0.3333,'G100',1,'*'),(4319,'128gb ipad','128gb ipad',0,1,1.3333,'G130',1,'*'),(4320,'128gb ipad 4','128gb ipad 4',0,1,1.4,'G130',1,'*'),(4321,'4 with','4 with',0,1,1.2,'W300',1,'*'),(4322,'4 with retina','4 with retina',0,1,1.4333,'W3635',1,'*'),(4323,'announces','announces',0,0,0.6,'A520',1,'*'),(4324,'announces 128gb','announces 128gb',0,1,1.5,'A521',1,'*'),(4325,'announces 128gb ipad','announces 128gb ipad',0,1,1.6667,'A5213',1,'*'),(4326,'apple announces','apple announces',0,1,1.5,'A1452',1,'*'),(4327,'apple announces 128gb','apple announces 128gb',0,1,1.7,'A14521',1,'*'),(4328,'ipad 4 with','ipad 4 with',0,1,1.3667,'I130',1,'*'),(4329,'retina','retina',0,0,0.4,'R350',1,'*'),(4330,'retina display','retina display',0,1,1.4667,'R353214',1,'*'),(4331,'with retina','with retina',0,1,1.3667,'W3635',1,'*'),(4332,'with retina display','with retina display',0,1,1.6333,'W36353214',1,'*'),(4333,'cursus cursus lorem','cursus cursus lorem',0,1,1.6333,'C6262465',1,'*'),(4334,'cursus lorem','cursus lorem',0,1,1.4,'C62465',1,'*'),(4335,'cursus lorem ipsum','cursus lorem ipsum',0,1,1.6,'C62465125',1,'*'),(4336,'ipsum','ipsum',0,0,0.3333,'I125',1,'*'),(4337,'ipsum lorem','ipsum lorem',0,1,1.3667,'I125465',1,'*'),(4338,'ipsum lorem ipsum','ipsum lorem ipsum',0,1,1.5667,'I125465125',1,'*'),(4339,'lorem ipsum','lorem ipsum',0,1,1.3667,'L65125',1,'*'),(4340,'lorem ipsum lorem','lorem ipsum lorem',0,1,1.5667,'L65125465',1,'*');


--
-- Table structure for table `#__finder_terms_common`
--



CREATE TABLE `#__finder_terms_common` (
  `term` varchar(75) NOT NULL,
  `language` varchar(3) NOT NULL,
  KEY `idx_word_lang` (`term`,`language`),
  KEY `idx_lang` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_terms_common`
--


INSERT INTO `#__finder_terms_common` (`term`, `language`) VALUES ('a','en'),('about','en'),('after','en'),('ago','en'),('all','en'),('am','en'),('an','en'),('and','en'),('ani','en'),('any','en'),('are','en'),('aren\'t','en'),('as','en'),('at','en'),('be','en'),('but','en'),('by','en'),('for','en'),('from','en'),('get','en'),('go','en'),('how','en'),('if','en'),('in','en'),('into','en'),('is','en'),('isn\'t','en'),('it','en'),('its','en'),('me','en'),('more','en'),('most','en'),('must','en'),('my','en'),('new','en'),('no','en'),('none','en'),('not','en'),('noth','en'),('nothing','en'),('of','en'),('off','en'),('often','en'),('old','en'),('on','en'),('onc','en'),('once','en'),('onli','en'),('only','en'),('or','en'),('other','en'),('our','en'),('ours','en'),('out','en'),('over','en'),('page','en'),('she','en'),('should','en'),('small','en'),('so','en'),('some','en'),('than','en'),('thank','en'),('that','en'),('the','en'),('their','en'),('theirs','en'),('them','en'),('then','en'),('there','en'),('these','en'),('they','en'),('this','en'),('those','en'),('thus','en'),('time','en'),('times','en'),('to','en'),('too','en'),('true','en'),('under','en'),('until','en'),('up','en'),('upon','en'),('use','en'),('user','en'),('users','en'),('veri','en'),('version','en'),('very','en'),('via','en'),('want','en'),('was','en'),('way','en'),('were','en'),('what','en'),('when','en'),('where','en'),('whi','en'),('which','en'),('who','en'),('whom','en'),('whose','en'),('why','en'),('wide','en'),('will','en'),('with','en'),('within','en'),('without','en'),('would','en'),('yes','en'),('yet','en'),('you','en'),('your','en'),('yours','en');


--
-- Table structure for table `#__finder_tokens`
--



CREATE TABLE `#__finder_tokens` (
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '1',
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  `language` char(3) NOT NULL DEFAULT '',
  KEY `idx_word` (`term`),
  KEY `idx_context` (`context`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_tokens`
--




--
-- Table structure for table `#__finder_tokens_aggregate`
--



CREATE TABLE `#__finder_tokens_aggregate` (
  `term_id` int(10) unsigned NOT NULL,
  `map_suffix` char(1) NOT NULL,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `term_weight` float unsigned NOT NULL,
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  `context_weight` float unsigned NOT NULL,
  `total_weight` float unsigned NOT NULL,
  `language` char(3) NOT NULL DEFAULT '',
  KEY `token` (`term`),
  KEY `keyword_id` (`term_id`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_tokens_aggregate`
--




--
-- Table structure for table `#__finder_types`
--



CREATE TABLE `#__finder_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL,
  `mime` varchar(100) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `title` (`title`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_types`
--


INSERT INTO `#__finder_types` (`id`, `title`, `mime`) VALUES (1,'K2 Item',''),(2,'Category',''),(3,'Contact',''),(4,'Article',''),(5,'News Feed',''),(6,'Web Link','');


--
-- Table structure for table `#__k2_attachments`
--



CREATE TABLE `#__k2_attachments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `itemID` int(11) NOT NULL,
  `filename` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `titleAttribute` text NOT NULL,
  `hits` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `itemID` (`itemID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_attachments`
--




--
-- Table structure for table `#__k2_categories`
--



CREATE TABLE `#__k2_categories` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `parent` int(11) DEFAULT '0',
  `extraFieldsGroup` int(11) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `image` varchar(255) NOT NULL,
  `params` text NOT NULL,
  `trash` smallint(6) NOT NULL DEFAULT '0',
  `plugins` text NOT NULL,
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `category` (`published`,`access`,`trash`),
  KEY `parent` (`parent`),
  KEY `ordering` (`ordering`),
  KEY `published` (`published`),
  KEY `access` (`access`),
  KEY `trash` (`trash`),
  KEY `language` (`language`)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_categories`
--


INSERT INTO `#__k2_categories` (`id`, `name`, `alias`, `description`, `parent`, `extraFieldsGroup`, `published`, `access`, `ordering`, `image`, `params`, `trash`, `plugins`, `language`) VALUES (1,'SmartPhone\'s','smartphones','',0,1,1,1,3,'','{\"inheritFrom\":\"2\",\"theme\":\"\",\"num_leading_items\":\"1\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Medium\",\"num_primary_items\":\"2\",\"num_primary_columns\":\"1\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"0\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Medium\",\"num_links\":\"0\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"1\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"0\",\"catTitleItemCounter\":\"0\",\"catDescription\":\"0\",\"catImage\":\"0\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"1\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"0\",\"catItemTags\":\"0\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"0\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"0\",\"itemDateModified\":\"0\",\"itemHits\":\"0\",\"itemCategory\":\"0\",\"itemTags\":\"1\",\"itemAttachments\":\"0\",\"itemAttachmentsCounter\":\"0\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"0\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"0\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"0\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"0\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',0,'','*'),(2,'Tablet\'s','tablets','',0,1,1,1,1,'','{\"inheritFrom\":\"0\",\"theme\":\"\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Medium\",\"num_primary_items\":\"2\",\"num_primary_columns\":\"1\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"0\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Medium\",\"num_links\":\"0\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"1\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"0\",\"catTitleItemCounter\":\"0\",\"catDescription\":\"0\",\"catImage\":\"0\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"1\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"1\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"0\",\"catItemTags\":\"0\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"0\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"0\",\"itemDateModified\":\"0\",\"itemHits\":\"0\",\"itemCategory\":\"0\",\"itemTags\":\"1\",\"itemAttachments\":\"0\",\"itemAttachmentsCounter\":\"0\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"0\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"0\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',0,'','*'),(3,'TVs','tvs','',0,1,1,1,2,'','{\"inheritFrom\":\"2\",\"theme\":\"\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',0,'','*'),(4,'Ultrabooks','ultrabooks','',0,1,1,1,4,'','{\"inheritFrom\":\"2\",\"theme\":\"\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',0,'','*');


--
-- Table structure for table `#__k2_comments`
--



CREATE TABLE `#__k2_comments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `itemID` int(11) NOT NULL,
  `userID` int(11) NOT NULL,
  `userName` varchar(255) NOT NULL,
  `commentDate` datetime NOT NULL,
  `commentText` text NOT NULL,
  `commentEmail` varchar(255) NOT NULL,
  `commentURL` varchar(255) NOT NULL,
  `published` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `itemID` (`itemID`),
  KEY `userID` (`userID`),
  KEY `published` (`published`),
  KEY `latestComments` (`published`,`commentDate`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_comments`
--


INSERT INTO `#__k2_comments` (`id`, `itemID`, `userID`, `userName`, `commentDate`, `commentText`, `commentEmail`, `commentURL`, `published`) VALUES (3,1,572,'Super User','2013-01-03 12:30:55','Mauris ac purus eros, ac lobortis tortor. Maecenas sed interdum turpis! Donec ac libero nisl. Etiam ornare sollicitudin ultricies. Duis.','blank@gavick.com','',1),(2,1,0,'Paulo','2012-11-06 17:15:49','With its lightweight, stiff and smooth-riding Giant Composite material, engineered and shaped to slice through the wind, the all-new Trinity','paulo@aaaa.ef','',1),(4,1,572,'Super User','2013-01-03 12:31:07','Mauris ac purus eros, ac lobortis tortor. Maecenas sed interdum turpis! Donec ac libero nisl. Etiam ornare sollicitudin ultricies. Duis.','blank@gavick.com','',1);


--
-- Table structure for table `#__k2_extra_fields`
--



CREATE TABLE `#__k2_extra_fields` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  `type` varchar(255) NOT NULL,
  `group` int(11) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `ordering` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `group` (`group`),
  KEY `published` (`published`),
  KEY `ordering` (`ordering`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_extra_fields`
--


INSERT INTO `#__k2_extra_fields` (`id`, `name`, `value`, `type`, `group`, `published`, `ordering`) VALUES (1,'Frame','[{\"name\":null,\"value\":\"\",\"editor\":null,\"target\":null}]','textarea',1,1,1),(2,'Fork','[{\"name\":null,\"value\":\"\",\"editor\":null,\"target\":null}]','textarea',1,1,2),(3,'Gears','[{\"name\":null,\"value\":\"\",\"editor\":null,\"target\":null}]','textarea',1,1,3);


--
-- Table structure for table `#__k2_extra_fields_groups`
--



CREATE TABLE `#__k2_extra_fields_groups` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_extra_fields_groups`
--


INSERT INTO `#__k2_extra_fields_groups` (`id`, `name`) VALUES (1,'Extra fields group');


--
-- Table structure for table `#__k2_items`
--



CREATE TABLE `#__k2_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) DEFAULT NULL,
  `catid` int(11) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `video` text,
  `gallery` varchar(255) DEFAULT NULL,
  `extra_fields` text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
  `extra_fields_search` text NOT NULL,
  `created` datetime NOT NULL,
  `created_by` int(11) NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL,
  `checked_out` int(10) unsigned NOT NULL,
  `checked_out_time` datetime NOT NULL,
  `modified` datetime NOT NULL,
  `modified_by` int(11) NOT NULL DEFAULT '0',
  `publish_up` datetime NOT NULL,
  `publish_down` datetime NOT NULL,
  `trash` smallint(6) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `featured` smallint(6) NOT NULL DEFAULT '0',
  `featured_ordering` int(11) NOT NULL DEFAULT '0',
  `image_caption` text NOT NULL,
  `image_credits` varchar(255) NOT NULL,
  `video_caption` text NOT NULL,
  `video_credits` varchar(255) NOT NULL,
  `hits` int(10) unsigned NOT NULL,
  `params` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `metakey` text NOT NULL,
  `plugins` text NOT NULL,
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `item` (`published`,`publish_up`,`publish_down`,`trash`,`access`),
  KEY `catid` (`catid`),
  KEY `created_by` (`created_by`),
  KEY `ordering` (`ordering`),
  KEY `featured` (`featured`),
  KEY `featured_ordering` (`featured_ordering`),
  KEY `hits` (`hits`),
  KEY `created` (`created`),
  KEY `language` (`language`),
  FULLTEXT KEY `search` (`title`,`introtext`,`fulltext`,`extra_fields_search`,`image_caption`,`image_credits`,`video_caption`,`video_credits`,`metadesc`,`metakey`),
  FULLTEXT KEY `title` (`title`)
) ENGINE=MyISAM AUTO_INCREMENT=55 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_items`
--


INSERT INTO `#__k2_items` (`id`, `title`, `alias`, `catid`, `published`, `introtext`, `fulltext`, `video`, `gallery`, `extra_fields`, `extra_fields_search`, `created`, `created_by`, `created_by_alias`, `checked_out`, `checked_out_time`, `modified`, `modified_by`, `publish_up`, `publish_down`, `trash`, `access`, `ordering`, `featured`, `featured_ordering`, `image_caption`, `image_credits`, `video_caption`, `video_credits`, `hits`, `params`, `metadesc`, `metadata`, `metakey`, `plugins`, `language`) VALUES (1,'MacBook Air models $200 off at best buy for 2 days','macbook-air-models-200-off-at-best-buy-for-2-days',4,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n\r\n\r\n<ul>\r\n<li>Lorem Ipsum</li>\r\n<li>Lorem Ipsum</li>\r\n<li>Lorem Ipsum</li>\r\n</ul>\r\n<ol>\r\n<li>Lorem Ipsum</li>\r\n<li>Lorem Ipsum</li>\r\n<li>Lorem Ipsum</li>\r\n</ol>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-11-06 12:40:30',572,'',0,'0000-00-00 00:00:00','2013-02-07 15:56:48',572,'2012-11-06 12:40:30','0000-00-00 00:00:00',0,1,1,1,1,'MacBook Air models $200 off at best buy for 2 days','','','',69,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(2,'The Xperia Tablet S is a touchscreen Android tablet designed by Sony','the-xperia-tablet-s-is-a-touchscreen-android-tablet-designed-by-sony',2,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-11-06 12:42:22',572,'',0,'0000-00-00 00:00:00','2013-02-04 08:06:26',572,'2012-11-06 12:42:22','0000-00-00 00:00:00',0,1,1,0,1,'The Xperia Tablet S is a touchscreen Android tablet designed by Sony.','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(3,'Samsung has redesigned its Smart Hub TV system','samsung-has-redesigned-its-smart-hub-tv-system',3,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-11-06 12:44:09',572,'',0,'0000-00-00 00:00:00','2013-02-04 08:08:17',572,'2012-11-06 12:44:09','0000-00-00 00:00:00',0,1,2,1,0,'Samsung has redesigned its Smart Hub system to now have dynamic panels to offer better recommendations','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(4,'Kevin Durant has Oklahoma City Thunder-ing along at the top','kevin-durant-has-oklahoma-city-thunder-ing-along-at-the-top',3,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-11-06 12:45:42',572,'',0,'0000-00-00 00:00:00','2013-02-04 08:09:34',572,'2012-11-06 12:45:42','0000-00-00 00:00:00',0,1,1,0,4,'NBA Power Rankings: Kevin Durant has Oklahoma City Thunder-ing along at the top','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(5,'What does 3D Ready TV Mean? – 3D Ready Television Explained','what-does-3d-ready-tv-mean-3d-ready-television-explained',3,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-11-06 12:47:31',572,'',0,'0000-00-00 00:00:00','2013-02-04 08:12:02',572,'2012-11-06 12:47:31','0000-00-00 00:00:00',0,1,3,1,0,'Wondering What is a 3D Ready TV? Read on to learn everything you need to know about 3D Ready Televisions.','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(6,'Google Nexus 7 offers a \"pure Android\" user experience','google-nexus-7-offers-a-pure-android-user-experience',2,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-11-06 12:49:33',572,'',0,'0000-00-00 00:00:00','2013-02-04 08:15:17',572,'2012-11-06 12:49:33','0000-00-00 00:00:00',0,1,3,1,4,'As a Google Nexus device, the Nexus 7 offers a \"pure Android\" experience','','','',9,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(7,'Head-to-Head: Samsung Galaxy Note 10.3 vs. Apple iPad 4','head-to-head-samsung-galaxy-note-10-3-vs-apple-ipad-4',2,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-11-06 12:51:54',572,'',0,'0000-00-00 00:00:00','2013-02-04 08:18:18',572,'2012-11-06 12:51:54','0000-00-00 00:00:00',0,1,4,0,5,'Head-to-Head: Samsung Galaxy Note 10.3 vs. Apple iPad 4','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(8,'Apple to Update MacBook Pro and MacBook Air in June 2013','apple-to-update-macbook-pro-and-macbook-air-in-june-2013',4,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-11-06 12:53:19',572,'',0,'0000-00-00 00:00:00','2013-02-04 08:20:59',572,'2012-11-06 12:53:19','0000-00-00 00:00:00',0,1,4,1,0,'Apple to Update MacBook Pro and MacBook Air in June 2013','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(9,'Dell\'s XPS 12 from an ultrabook to a tablet with a flip of the display','dell-s-xps-12-from-an-ultrabook-to-a-tablet-with-a-flip-of-the-display',4,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-11-06 12:54:57',572,'',0,'0000-00-00 00:00:00','2013-02-04 08:24:06',572,'2012-11-06 12:54:57','0000-00-00 00:00:00',0,1,5,0,7,'Dell\'s XPS 12 can convert from an ultrabook to a tablet with a flip of the display','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(10,'The new ultra-thin, UX Series ultra-portable from ASUS','the-new-ultra-thin-ux-series-ultra-portable-from-asus',4,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-11-06 12:56:41',572,'',0,'0000-00-00 00:00:00','2013-02-04 08:26:21',572,'2012-11-06 12:56:41','0000-00-00 00:00:00',0,1,6,1,0,'The new ultra-thin, UX Series ultra-portable from ASUS','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(11,'The ASUS TAICHI 21 is innovation at its finest with surface interface','the-asus-taichi-21-is-innovation-at-its-finest-with-surface-interface',4,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-11-06 12:58:42',572,'',0,'0000-00-00 00:00:00','2013-02-04 08:29:05',572,'2012-11-06 12:58:42','0000-00-00 00:00:00',0,1,2,0,0,'The ASUS TAICHI 21 is innovation at its finest hour','','','',1,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(12,'Lenovo Ideapad - A Great Windows 8 Laptop with a Side of Tablet','lenovo-ideapad-a-great-windows-8-laptop-with-a-side-of-tablet',4,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-11-06 13:00:02',572,'',0,'0000-00-00 00:00:00','2013-02-04 08:31:01',572,'2012-11-06 13:00:02','0000-00-00 00:00:00',0,1,3,1,3,'Lenovo Ideapad - Great Windows 8 Laptop with a Side of Tablet','','','',6,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(13,'Samsung Galaxy Tab 10.1 1. Tablet Android com Display Wide 10.1\"','samsung-galaxy-tab-10-1-1-tablet-android-com-display-wide-10-1',2,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-11-06 13:01:51',572,'',0,'0000-00-00 00:00:00','2013-02-04 08:33:06',572,'2012-11-06 13:01:51','0000-00-00 00:00:00',0,1,5,1,7,'Samsung Galaxy Tab 10.1 1. Tablet Android com Display Wide 10.1\"','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(14,'Nokia to launch new smartphone with Windows Phone 8 in 2013','nokia-to-launch-new-smartphone-with-windows-phone-8-in-2013',1,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-11-06 13:03:46',572,'',0,'0000-00-00 00:00:00','2013-02-04 08:35:40',572,'2012-11-06 13:03:46','0000-00-00 00:00:00',0,1,1,0,0,'Rumour: Nokia to launch new smartphone with Windows Phone 8 in 2013','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(15,'The BlackBerry Z10 is more than just a new BlackBerry','the-blackberry-z10-is-more-than-just-a-new-blackberry',1,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-11-06 13:05:30',572,'',0,'0000-00-00 00:00:00','2013-02-04 08:37:44',572,'2012-11-06 13:05:30','0000-00-00 00:00:00',0,1,2,1,5,'The BlackBerry Z10 is more than just a new BlackBerry. It\'s the first BlackBerry that runs on the all-new BlackBerry 10 mobile computing platform.','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(16,'Galaxy S III: Designed for humans, inspired by nature!','galaxy-s-iii-designed-for-humans-inspired-by-nature',1,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-11-06 13:07:05',572,'',0,'0000-00-00 00:00:00','2013-02-04 08:39:58',572,'2012-11-06 13:07:05','0000-00-00 00:00:00',0,1,3,0,0,'Galaxy S III: Designed for humans, inspired by nature! ','','','',4,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(17,'It\'s so thin and so light, yet iPhone 5 features latest technology','it-s-so-thin-and-so-light-yet-iphone-5-features-latest-technology',1,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-11-06 13:08:43',572,'',0,'0000-00-00 00:00:00','2013-02-04 08:41:58',572,'2012-11-06 13:08:43','0000-00-00 00:00:00',0,1,4,1,6,'It\'s so thin and so light, yet iPhone 5 features a larger display, a faster chip, the latest wireless technology','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(18,'Interesting combination of Samsung Galaxy Camera GC100 Android','interesting-combination-of-samsung-galaxy-camera-gc100-android',1,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-11-06 13:10:08',572,'',0,'0000-00-00 00:00:00','2013-02-04 08:44:25',572,'2012-11-06 13:10:08','0000-00-00 00:00:00',0,1,5,1,2,'Samsung Galaxy Camera GC100 Android smartphone','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(19,'Samsung OLED TV brings new 1GHz dual-core chipset','samsung-oled-tv-brings-new-1ghz-dual-core-chipset',3,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-11-06 13:11:38',572,'',0,'0000-00-00 00:00:00','2013-02-04 08:46:03',572,'2012-11-06 13:11:38','0000-00-00 00:00:00',0,1,4,0,2,'Samsung OLED TV brings new 1GHz dual-core chipset','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(20,'Samsung has put a 75-inch LCD TV up for sale in South Korea','samsung-has-put-a-75-inch-lcd-tv-up-for-sale-in-south-korea',3,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-11-06 13:16:39',572,'',0,'0000-00-00 00:00:00','2013-02-04 08:48:05',572,'2012-11-06 13:16:39','0000-00-00 00:00:00',0,1,5,1,0,'Samsung has put a 75-inch LCD TV up for sale in South Korea','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(21,'Apple announces 128GB iPad 4 with Retina Display','apple-announces-128gb-ipad-4-with-retina-display',2,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Phasellus dictum placerat pellentesque. Duis vehicula tellus eu nisi sagittis a varius eros posuere. Donec metus dui, ultricies non porttitor sed, semper eget enim. Duis sed bibendum ante. Pellentesque at augue lorem!</p>\r\n<p>Sed ut porta sapien. Integer orci libero, varius eget venenatis quis, cursus vitae orci? Curabitur vitae ultricies dolor! Vivamus ultricies nunc in lectus cursus cursus.</p>\r\n<p>Curabitur ultrices commodo magna, ac semper risus molestie vestibulum. Aenean commodo nibh non dui adipiscing rhoncus. Aliquam ullamcorper posuere turpis, in feugiat risus posuere vel. Ut velit urna, auctor at aliquam sit amet, rutrum vitae diam. Maecenas elementum lacus tincidunt neque luctus rhoncus a nec eros. Donec fermentum magna non eros lacinia mollis. Maecenas et dolor vel felis hendrerit laoreet.</p>\r\n<p>Duis velit neque, rutrum ac suscipit id; vehicula vel nibh! Nulla eget quam eget dui hendrerit molestie ut quis turpis. Aliquam non sem eget nisi adipiscing eleifend sed non libero. Integer ac felis ut odio venenatis condimentum bibendum non eros. Vivamus eu laoreet diam. Duis cursus.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-12-31 13:07:12',572,'',0,'0000-00-00 00:00:00','2013-02-04 08:49:54',572,'2012-12-31 13:07:12','0000-00-00 00:00:00',0,1,2,1,8,'Apple announces 128GB iPad 4 with Retina Display','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*');


--
-- Table structure for table `#__k2_rating`
--



CREATE TABLE `#__k2_rating` (
  `itemID` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(11) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(11) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`itemID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_rating`
--




--
-- Table structure for table `#__k2_tags`
--



CREATE TABLE `#__k2_tags` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `published` (`published`),
  FULLTEXT KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=332 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_tags`
--


INSERT INTO `#__k2_tags` (`id`, `name`, `published`) VALUES (261,'macbook',1),(262,'Apple',1),(263,'Ultrabook',1),(264,'best offer',1),(265,'models',1),(266,'oportunity',1),(267,'Sony',1),(268,'Tablet',1),(269,'Xperia',1),(270,'touchscreen',1),(271,'Android',1),(272,'Samsung',1),(273,'SmartTV',1),(274,'Smart HUB',1),(275,'System',1),(276,'Interface',1),(277,'3D TV',1),(278,'Television',1),(279,'wireless',1),(280,'Google',1),(281,'Nexus 7',1),(282,'experience',1),(283,'device',1),(284,'Galaxy Note 10',1),(285,'iPad 4',1),(286,'HeadtoHead',1),(287,'Review',1),(288,'MacBook Pro',1),(289,'MacBook Air',1),(290,'Laptops',1),(291,'2013',1),(292,'Dell\'s XPS 12',1),(293,'flip',1),(294,'display',1),(295,'Asus',1),(296,'UX Series',1),(297,'ultraportable',1),(298,'autonomy',1),(299,'Taichi',1),(300,'Innovation',1),(301,'Windows 8',1),(302,'Notebook',1),(303,'Lenovo',1),(304,'Ideapad',1),(305,'Galaxy S4',1),(306,'Windows Mobile 8',1),(307,'Smartphone',1),(308,'launch',1),(309,'new model',1),(310,'Nokia',1),(311,'BlackBerry Z10',1),(312,'New',1),(313,'computing',1),(314,'communication',1),(315,'Galaxy S III',1),(316,'Nature',1),(317,'Inspire',1),(318,'technology',1),(319,'iPhone 5',1),(320,'Galaxy',1),(321,'Camera',1),(322,'smartphones',1),(323,'OLED TV',1),(324,'Dualcore',1),(325,'LCD TV',1),(326,'75inch',1),(327,'widescreen',1),(328,'announces',1),(329,'128GB',1),(330,'iPad',1),(331,'Retina display',1);


--
-- Table structure for table `#__k2_tags_xref`
--



CREATE TABLE `#__k2_tags_xref` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `tagID` int(11) NOT NULL,
  `itemID` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `tagID` (`tagID`),
  KEY `itemID` (`itemID`)
) ENGINE=MyISAM AUTO_INCREMENT=526 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_tags_xref`
--


INSERT INTO `#__k2_tags_xref` (`id`, `tagID`, `itemID`) VALUES (525,266,1),(524,265,1),(523,264,1),(522,263,1),(521,262,1),(520,261,1),(427,271,2),(426,270,2),(425,269,2),(424,268,2),(423,267,2),(432,276,3),(431,275,3),(430,274,3),(429,273,3),(428,272,3),(437,279,5),(436,276,5),(435,273,5),(434,278,5),(433,277,5),(443,283,6),(442,282,6),(441,271,6),(440,268,6),(448,287,7),(447,286,7),(446,285,7),(445,284,7),(444,272,7),(453,291,8),(452,290,8),(451,289,8),(450,288,8),(449,262,8),(458,294,9),(457,293,9),(456,268,9),(455,263,9),(454,292,9),(463,298,10),(462,297,10),(461,296,10),(460,263,10),(469,301,11),(468,270,11),(467,300,11),(466,263,11),(465,299,11),(474,304,12),(473,303,12),(472,301,12),(471,268,12),(479,270,13),(478,271,13),(477,268,13),(476,305,13),(475,272,13),(485,310,14),(484,291,14),(483,309,14),(482,308,14),(481,307,14),(490,314,15),(489,313,15),(488,307,15),(487,312,15),(486,311,15),(496,318,16),(495,317,16),(494,316,16),(493,307,16),(492,272,16),(501,279,17),(500,318,17),(499,307,17),(498,262,17),(497,319,17),(506,322,18),(505,271,18),(504,321,18),(503,320,18),(514,327,20),(509,324,19),(508,323,19),(507,272,19),(513,273,20),(512,326,20),(511,325,20),(510,272,20),(439,281,6),(438,280,6),(459,295,10),(464,295,11),(470,302,12),(480,306,14),(491,315,16),(502,272,18),(519,331,21),(518,330,21),(517,329,21),(516,328,21),(515,262,21);


--
-- Table structure for table `#__k2_user_groups`
--



CREATE TABLE `#__k2_user_groups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `permissions` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_user_groups`
--


INSERT INTO `#__k2_user_groups` (`id`, `name`, `permissions`) VALUES (1,'Registered','{\"comment\":\"1\",\"frontEdit\":\"0\",\"add\":\"0\",\"editOwn\":\"0\",\"editAll\":\"0\",\"publish\":\"0\",\"inheritance\":\"0\",\"categories\":\"all\"}'),(2,'Site Owner','{\"comment\":\"1\",\"frontEdit\":\"1\",\"add\":\"1\",\"editOwn\":\"1\",\"editAll\":\"1\",\"publish\":\"1\",\"inheritance\":\"1\",\"categories\":\"all\"}');


--
-- Table structure for table `#__k2_users`
--



CREATE TABLE `#__k2_users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userID` int(11) NOT NULL,
  `userName` varchar(255) DEFAULT NULL,
  `gender` enum('m','f') NOT NULL DEFAULT 'm',
  `description` text NOT NULL,
  `image` varchar(255) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `group` int(11) NOT NULL DEFAULT '0',
  `plugins` text NOT NULL,
  `ip` varchar(15) NOT NULL,
  `hostname` varchar(255) NOT NULL,
  `notes` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `userID` (`userID`),
  KEY `group` (`group`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_users`
--


INSERT INTO `#__k2_users` (`id`, `userID`, `userName`, `gender`, `description`, `image`, `url`, `group`, `plugins`, `ip`, `hostname`, `notes`) VALUES (1,381,'Super User','m','Fusce aliquam suscipit leo, nec tempor arcu tempus in. Suspendisse potenti. Vivamus posuere, turpis vitae egestas imperdiet, urna elit dictum.','1.jpg','http://www.gavick.com',1,'','81.190.86.7','host-81-190-86-7.gdynia.mm.pl',''),(2,572,'Super User','m','<p>Fusce aliquam suscipit leo, nec tempor arcu tempus in. Suspendisse potenti. Vivamus posuere, turpis vitae egestas imperdiet, urna elit dictum.</p>','2.jpg','http://www.gavick.com',1,'','81.190.99.205','host-81-190-99-205.gdynia.mm.pl','');


--
-- Table structure for table `#__languages`
--



CREATE TABLE `#__languages` (
  `lang_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `lang_code` char(7) NOT NULL,
  `title` varchar(50) NOT NULL,
  `title_native` varchar(50) NOT NULL,
  `sef` varchar(50) NOT NULL,
  `image` varchar(50) NOT NULL,
  `description` varchar(512) NOT NULL,
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `sitename` varchar(1024) NOT NULL DEFAULT '',
  `published` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`lang_id`),
  UNIQUE KEY `idx_sef` (`sef`),
  UNIQUE KEY `idx_image` (`image`),
  UNIQUE KEY `idx_langcode` (`lang_code`),
  KEY `idx_access` (`access`),
  KEY `idx_ordering` (`ordering`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__languages`
--


INSERT INTO `#__languages` (`lang_id`, `lang_code`, `title`, `title_native`, `sef`, `image`, `description`, `metakey`, `metadesc`, `sitename`, `published`, `access`, `ordering`) VALUES (1,'en-GB','English (UK)','English (UK)','en','en','','','','',1,0,1);


--
-- Table structure for table `#__menu`
--



CREATE TABLE `#__menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL COMMENT 'The type of menu this item belongs to. FK to #__menu_types.menutype',
  `title` varchar(255) NOT NULL COMMENT 'The display title of the menu item.',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The SEF alias of the menu item.',
  `note` varchar(255) NOT NULL DEFAULT '',
  `path` varchar(1024) NOT NULL COMMENT 'The computed path of the menu item based on the alias field.',
  `link` varchar(1024) NOT NULL COMMENT 'The actually link the menu item refers to.',
  `type` varchar(16) NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator',
  `published` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The published state of the menu link.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The parent menu item in the menu tree.',
  `level` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The relative level in the tree.',
  `component_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__extensions.id',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__users.id',
  `checked_out_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.',
  `browserNav` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The click behaviour of the link.',
  `access` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The access level required to view the menu item.',
  `img` varchar(255) NOT NULL COMMENT 'The image of the menu item.',
  `template_style_id` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL COMMENT 'JSON encoded data for the menu item.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `home` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Indicates if this menu item is the home or default page.',
  `language` char(7) NOT NULL DEFAULT '',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_client_id_parent_id_alias_language` (`client_id`,`parent_id`,`alias`,`language`),
  KEY `idx_componentid` (`component_id`,`menutype`,`published`,`access`),
  KEY `idx_menutype` (`menutype`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_path` (`path`(255)),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB AUTO_INCREMENT=333 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__menu`
--


INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES (1,'','Menu_Item_Root','root','','','','',1,0,0,0,0,'0000-00-00 00:00:00',0,0,'',0,'',0,281,0,'*',0),(2,'menu','com_banners','Banners','','Banners','index.php?option=com_banners','component',0,1,1,4,0,'0000-00-00 00:00:00',0,0,'class:banners',0,'',1,10,0,'*',1),(3,'menu','com_banners','Banners','','Banners/Banners','index.php?option=com_banners','component',0,2,2,4,0,'0000-00-00 00:00:00',0,0,'class:banners',0,'',2,3,0,'*',1),(4,'menu','com_banners_categories','Categories','','Banners/Categories','index.php?option=com_categories&extension=com_banners','component',0,2,2,6,0,'0000-00-00 00:00:00',0,0,'class:banners-cat',0,'',4,5,0,'*',1),(5,'menu','com_banners_clients','Clients','','Banners/Clients','index.php?option=com_banners&view=clients','component',0,2,2,4,0,'0000-00-00 00:00:00',0,0,'class:banners-clients',0,'',6,7,0,'*',1),(6,'menu','com_banners_tracks','Tracks','','Banners/Tracks','index.php?option=com_banners&view=tracks','component',0,2,2,4,0,'0000-00-00 00:00:00',0,0,'class:banners-tracks',0,'',8,9,0,'*',1),(7,'menu','com_contact','Contacts','','Contacts','index.php?option=com_contact','component',0,1,1,8,0,'0000-00-00 00:00:00',0,0,'class:contact',0,'',121,126,0,'*',1),(8,'menu','com_contact','Contacts','','Contacts/Contacts','index.php?option=com_contact','component',0,7,2,8,0,'0000-00-00 00:00:00',0,0,'class:contact',0,'',122,123,0,'*',1),(9,'menu','com_contact_categories','Categories','','Contacts/Categories','index.php?option=com_categories&extension=com_contact','component',0,7,2,6,0,'0000-00-00 00:00:00',0,0,'class:contact-cat',0,'',124,125,0,'*',1),(10,'menu','com_messages','Messaging','','Messaging','index.php?option=com_messages','component',0,1,1,15,0,'0000-00-00 00:00:00',0,0,'class:messages',0,'',127,132,0,'*',1),(11,'menu','com_messages_add','New Private Message','','Messaging/New Private Message','index.php?option=com_messages&task=message.add','component',0,10,2,15,0,'0000-00-00 00:00:00',0,0,'class:messages-add',0,'',128,129,0,'*',1),(12,'menu','com_messages_read','Read Private Message','','Messaging/Read Private Message','index.php?option=com_messages','component',0,10,2,15,0,'0000-00-00 00:00:00',0,0,'class:messages-read',0,'',130,131,0,'*',1),(13,'menu','com_newsfeeds','News Feeds','','News Feeds','index.php?option=com_newsfeeds','component',0,1,1,17,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds',0,'',133,138,0,'*',1),(14,'menu','com_newsfeeds_feeds','Feeds','','News Feeds/Feeds','index.php?option=com_newsfeeds','component',0,13,2,17,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds',0,'',134,135,0,'*',1),(15,'menu','com_newsfeeds_categories','Categories','','News Feeds/Categories','index.php?option=com_categories&extension=com_newsfeeds','component',0,13,2,6,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds-cat',0,'',136,137,0,'*',1),(16,'menu','com_redirect','Redirect','','Redirect','index.php?option=com_redirect','component',0,1,1,24,0,'0000-00-00 00:00:00',0,0,'class:redirect',0,'',149,150,0,'*',1),(17,'menu','com_search','Basic Search','','Basic Search','index.php?option=com_search','component',0,1,1,19,0,'0000-00-00 00:00:00',0,0,'class:search',0,'',141,142,0,'*',1),(18,'menu','com_weblinks','Weblinks','','Weblinks','index.php?option=com_weblinks','component',0,1,1,21,0,'0000-00-00 00:00:00',0,0,'class:weblinks',0,'',143,148,0,'*',1),(19,'menu','com_weblinks_links','Links','','Weblinks/Links','index.php?option=com_weblinks','component',0,18,2,21,0,'0000-00-00 00:00:00',0,0,'class:weblinks',0,'',144,145,0,'*',1),(20,'menu','com_weblinks_categories','Categories','','Weblinks/Categories','index.php?option=com_categories&extension=com_weblinks','component',0,18,2,6,0,'0000-00-00 00:00:00',0,0,'class:weblinks-cat',0,'',146,147,0,'*',1),(21,'menu','com_finder','Smart Search','','Smart Search','index.php?option=com_finder','component',0,1,1,27,0,'0000-00-00 00:00:00',0,0,'class:finder',0,'',139,140,0,'*',1),(22,'menu','com_joomlaupdate','Joomla! Update','','Joomla! Update','index.php?option=com_joomlaupdate','component',0,1,1,28,0,'0000-00-00 00:00:00',0,0,'class:joomlaupdate',0,'',151,152,0,'*',1),(113,'mainmenu','Template','template','','template','index.php?option=com_content&view=category&id=15','component',1,1,1,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',35,118,0,'*',0),(114,'mainmenu','Features','template-articles','','template/template-articles','index.php?option=com_content&view=categories&id=0','component',1,113,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_articles_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',36,49,0,'*',0),(115,'mainmenu','Error page','2012-11-06-14-27-34','','template/template-articles/2012-11-06-14-27-34','?option=non-existing-component','url',1,114,3,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',37,38,0,'*',0),(116,'mainmenu','Offline page','2012-11-06-14-28-13','','template/template-articles/2012-11-06-14-28-13','?tmpl=offline','url',1,114,3,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',39,40,0,'*',0),(117,'mainmenu','Module positions','module-positions','','template/template-articles/module-positions','index.php?option=com_content&view=article&id=2','component',1,114,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"info_block_position\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',41,42,0,'*',0),(118,'mainmenu','Layouts','2012-11-06-14-32-03','','template/2012-11-06-14-32-03','http://www.gavick.com/documentation/joomla-templates/templates-for-joomla-1-6/responsive-layout-2/','url',1,113,2,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',88,89,0,'*',0),(119,'mainmenu','Module variations','module-variations','','template/template-articles/module-variations','index.php?option=com_content&view=article&id=4','component',1,114,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"info_block_position\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',43,44,0,'*',0),(120,'mainmenu','Home','home','','home','index.php?option=com_k2&view=latest&layout=latest','component',1,1,1,10003,0,'0000-00-00 00:00:00',0,1,'',0,'{\"theme\":\"default\",\"source\":\"1\",\"latestItemsCols\":\"1\",\"latestItemsLimit\":\"1\",\"latestItemsDisplayEffect\":\"all\",\"userName\":\"1\",\"userImage\":\"1\",\"userDescription\":\"1\",\"userURL\":\"1\",\"userEmail\":\"0\",\"userFeed\":\"1\",\"categoryIDs\":[\"4\"],\"categoryTitle\":\"0\",\"categoryDescription\":\"0\",\"categoryImage\":\"0\",\"categoryFeed\":\"0\",\"latestItemTitle\":\"1\",\"latestItemTitleLinked\":\"1\",\"latestItemDateCreated\":\"0\",\"latestItemImage\":\"1\",\"latestItemImageSize\":\"Medium\",\"latestItemVideo\":\"1\",\"latestItemVideoWidth\":\"\",\"latestItemVideoHeight\":\"\",\"latestItemAudioWidth\":\"\",\"latestItemAudioHeight\":\"\",\"latestItemVideoAutoPlay\":\"0\",\"latestItemIntroText\":\"1\",\"latestItemCategory\":\"0\",\"latestItemTags\":\"0\",\"latestItemReadMore\":\"1\",\"latestItemCommentsAnchor\":\"0\",\"feedLink\":\"0\",\"latestItemK2Plugins\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',11,34,1,'*',0),(121,'mainmenu','Typography','typography','','typography','index.php?option=com_content&view=article&id=1','component',1,1,1,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',119,120,0,'*',0),(122,'mainmenu','Page breaks','page-breaks','','template/template-articles/page-breaks','index.php?option=com_content&view=article&id=5','component',1,114,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',45,46,0,'*',0),(123,'mainmenu','Articles','articles','','template/articles','index.php?option=com_content&view=category&id=17','component',1,113,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',50,69,0,'*',0),(124,'mainmenu','Archived articles','archived-articles','','template/articles/archived-articles','index.php?option=com_content&view=archive','component',1,123,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"hide\",\"introtext_limit\":\"100\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',51,58,0,'*',0),(125,'mainmenu','by Title','by-title','','template/articles/archived-articles/by-title','index.php?option=com_content&view=archive','component',1,124,4,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"title\",\"introtext_limit\":\"100\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"Archived articles sorted by title\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',52,53,0,'*',0),(126,'mainmenu','by Author','by-author','','template/articles/archived-articles/by-author','index.php?option=com_content&view=archive','component',1,124,4,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"author\",\"introtext_limit\":\"100\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"Archived articles sorted by author\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',54,55,0,'*',0),(127,'mainmenu','by Hits','by-hits','','template/articles/archived-articles/by-hits','index.php?option=com_content&view=archive','component',1,124,4,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"hits\",\"introtext_limit\":\"100\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"Archived articles sorted by hits\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',56,57,0,'*',0),(128,'mainmenu','Single Article','single-article','','template/articles/single-article','index.php?option=com_content&view=article&id=11','component',1,123,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"Example of the single article\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',59,60,0,'*',0),(129,'mainmenu','List All Categories','list-all-categories','','template/articles/list-all-categories','index.php?option=com_content&view=categories&id=0','component',1,123,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"0\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"1\",\"show_subcat_desc_cat\":\"1\",\"show_cat_num_articles_cat\":\"1\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":1,\"page_heading\":\"List of the all categories\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"List of the all categories.\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',61,62,0,'*',0),(130,'mainmenu','Category blog','category-blog','','template/articles/category-blog','index.php?option=com_content&view=category&layout=blog&id=17','component',1,123,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"5\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"1\",\"orderby_pri\":\"\",\"orderby_sec\":\"order\",\"order_date\":\"\",\"show_pagination\":\"1\",\"show_pagination_results\":\"1\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"Category with the blog layout.\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',63,64,0,'*',0),(131,'mainmenu','Category List','category-list','','template/articles/category-list','index.php?option=com_content&view=category&id=17','component',1,123,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"List of the items in the specific category.\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',65,66,0,'*',0),(132,'mainmenu','Featured Articles','featured-articles','','template/articles/featured-articles','index.php?option=com_content&view=featured','component',1,123,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"featured_categories\":[\"\"],\"layout_type\":\"blog\",\"num_leading_articles\":\"2\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"5\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"info_bloc_position\":\"0\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"List of the featured articles\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',67,68,0,'*',0),(133,'mainmenu','Article','k2-item','','home/k2-item','index.php?option=com_k2&view=item&layout=item&id=1','component',1,120,2,10003,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',12,13,0,'*',0),(134,'mainmenu','Categories','k2-categories','','home/k2-categories','index.php?option=com_k2&view=itemlist&layout=category&task=&id=','component',1,120,2,10003,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories\":[\"1\",\"4\"],\"catCatalogMode\":\"0\",\"theme\":\"default\",\"num_leading_items\":\"4\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"0\",\"num_primary_columns\":\"1\",\"primaryImgSize\":\"Large\",\"num_secondary_items\":\"0\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Large\",\"num_links\":\"0\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catFeaturedItems\":\"0\",\"catOrdering\":\"order\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',14,23,0,'*',0),(135,'mainmenu','Contacts','contacts','','template/contacts','index.php?option=com_contact&view=categories&id=0','component',1,113,2,8,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',70,79,0,'*',0),(136,'mainmenu','List All Contact Categories','list-all-contact-categories','','template/contacts/list-all-contact-categories','index.php?option=com_contact&view=categories&id=0','component',1,135,3,8,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"0\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_items_cat\":\"1\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',73,74,0,'*',0),(137,'mainmenu','List Contacts in a Category','list-contacts-in-a-category','','template/contacts/list-contacts-in-a-category','index.php?option=com_contact&view=category&id=9','component',1,135,3,8,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"initial_sort\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',71,72,0,'*',0),(138,'mainmenu','Featured Contacts','featured-contacts','','template/contacts/featured-contacts','index.php?option=com_contact&view=featured','component',1,135,3,8,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',75,76,0,'*',0),(139,'mainmenu','Single Contact','single-contact','','template/contacts/single-contact','index.php?option=com_contact&view=contact&id=1','component',1,135,3,8,0,'0000-00-00 00:00:00',0,1,'',0,'{\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',77,78,0,'*',0),(140,'mainmenu','Newsfeeds','newsfeeds','','template/newsfeeds','index.php?option=com_newsfeeds&view=categories&id=0','component',1,113,2,17,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_articles\":\"\",\"show_link\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',80,87,0,'*',0),(141,'mainmenu','List All News Feed Categories','list-all-news-feed-categories','','template/newsfeeds/list-all-news-feed-categories','index.php?option=com_newsfeeds&view=categories&id=0','component',1,140,3,17,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_articles\":\"\",\"show_link\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',81,82,0,'*',0),(142,'mainmenu','List News Feeds in a Category','list-news-feeds-in-a-category','','template/newsfeeds/list-news-feeds-in-a-category','index.php?option=com_newsfeeds&view=category&id=11','component',1,140,3,17,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_articles\":\"\",\"show_link\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"feed_display_order\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',83,84,0,'*',0),(143,'mainmenu','Single News Feed','single-news-feed','','template/newsfeeds/single-news-feed','index.php?option=com_newsfeeds&view=newsfeed&id=1','component',1,140,3,17,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"feed_display_order\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',85,86,0,'*',0),(144,'mainmenu','Iframe wrapper','iframe-wrapper','','template/template-articles/iframe-wrapper','index.php?option=com_wrapper&view=wrapper','component',1,114,3,2,0,'0000-00-00 00:00:00',0,1,'',0,'{\"url\":\"http:\\/\\/www.gavick.com\",\"scrolling\":\"auto\",\"width\":\"100%\",\"height\":\"500\",\"height_auto\":\"0\",\"add_scheme\":\"1\",\"frameborder\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',47,48,0,'*',0),(145,'mainmenu','Search','search','','template/search','index.php?option=com_search&view=search&searchword=','component',1,113,2,19,0,'0000-00-00 00:00:00',0,1,'',0,'{\"search_areas\":\"\",\"show_date\":\"\",\"searchphrase\":\"0\",\"ordering\":\"newest\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',90,95,0,'*',0),(146,'mainmenu','Search','com-search','','template/search/com-search','index.php?option=com_search&view=search&searchword=Search','component',1,145,3,19,0,'0000-00-00 00:00:00',0,1,'',0,'{\"search_areas\":\"\",\"show_date\":\"\",\"searchphrase\":\"0\",\"ordering\":\"newest\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"com_search component\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',93,94,0,'*',0),(147,'mainmenu','Smart search','smart-search','','template/search/smart-search','index.php?option=com_finder&view=search&q=&f=','component',1,145,3,27,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_date_filters\":\"\",\"show_advanced\":\"\",\"expand_advanced\":\"\",\"show_description\":\"\",\"description_length\":255,\"show_url\":\"\",\"show_pagination_limit\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"allow_empty_query\":\"0\",\"sort_order\":\"\",\"sort_direction\":\"\",\"show_feed\":\"0\",\"show_feed_text\":\"0\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"com_finder component\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',91,92,0,'*',0),(148,'mainmenu','Weblinks','weblinks','','template/weblinks','index.php?option=com_weblinks&view=categories&id=0','component',1,113,2,21,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_links_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',96,103,0,'*',0),(149,'mainmenu','List All Web Link Categories','list-all-web-link-categories','','template/weblinks/list-all-web-link-categories','index.php?option=com_weblinks&view=categories&id=0','component',1,148,3,21,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_links_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',97,98,0,'*',0),(150,'mainmenu','List Web Links in a Category','list-web-links-in-a-category','','template/weblinks/list-web-links-in-a-category','index.php?option=com_weblinks&view=category&id=14','component',1,148,3,21,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',99,100,0,'*',0),(151,'mainmenu','Submit a Web Link','submit-a-web-link','','template/weblinks/submit-a-web-link','index.php?option=com_weblinks&view=form&layout=edit','component',1,148,3,21,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',101,102,0,'*',0),(152,'mainmenu','Users','users','','template/users','index.php?option=com_users&view=login','component',1,113,2,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',104,117,0,'*',0),(153,'mainmenu','Login form','login-form','','template/users/login-form','index.php?option=com_users&view=login','component',1,152,3,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":1,\"page_heading\":\"Sign in\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',105,106,0,'*',0),(154,'mainmenu','User profile','user-profile','','template/users/user-profile','index.php?option=com_users&view=profile','component',1,152,3,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',107,108,0,'*',0),(155,'mainmenu','Edit User Profile','edit-user-profile','','template/users/edit-user-profile','index.php?option=com_users&view=profile&layout=edit','component',1,152,3,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',109,110,0,'*',0),(156,'mainmenu','Registration form','registration-form','','template/users/registration-form','index.php?option=com_users&view=registration','component',1,152,3,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',111,112,0,'*',0),(157,'mainmenu','Username Reminder Request','username-reminder-request','','template/users/username-reminder-request','index.php?option=com_users&view=remind','component',1,152,3,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',113,114,0,'*',0),(158,'mainmenu','Password Reset','password-reset','','template/users/password-reset','index.php?option=com_users&view=reset','component',1,152,3,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',115,116,0,'*',0),(159,'mainmenu','Tags','k2-tag','','home/k2-tag','index.php?option=com_k2&view=itemlist&layout=tag&tag=Samsung&task=tag','component',1,120,2,10003,0,'0000-00-00 00:00:00',0,1,'',0,'{\"theme\":\"default\",\"tagOrdering\":\"\",\"tagFeedLink\":\"1\",\"tagFeedIcon\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',26,27,0,'*',0),(160,'mainmenu','User page','k2-user-page','','home/k2-user-page','index.php?option=com_k2&view=itemlist&layout=user&id=572&task=user','component',1,120,2,10003,0,'0000-00-00 00:00:00',0,1,'',0,'{\"theme\":\"default\",\"userCategoriesFilter\":[\"2\",\"1\"],\"userOrdering\":\"hits\",\"userFeedLink\":\"1\",\"userFeedIcon\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',24,25,0,'*',0),(161,'mainmenu','1 column','k2-items-1-col','','home/k2-items-1-col','index.php?option=com_k2&view=latest&layout=latest','component',1,120,2,10003,0,'0000-00-00 00:00:00',0,1,'',0,'{\"theme\":\"default\",\"source\":\"1\",\"latestItemsCols\":\"1\",\"latestItemsLimit\":\"1\",\"latestItemsDisplayEffect\":\"all\",\"userName\":\"1\",\"userImage\":\"1\",\"userDescription\":\"1\",\"userURL\":\"1\",\"userEmail\":\"0\",\"userFeed\":\"1\",\"categoryIDs\":[\"2\",\"3\",\"1\",\"4\"],\"categoryTitle\":\"0\",\"categoryDescription\":\"0\",\"categoryImage\":\"0\",\"categoryFeed\":\"0\",\"latestItemTitle\":\"1\",\"latestItemTitleLinked\":\"1\",\"latestItemDateCreated\":\"1\",\"latestItemImage\":\"1\",\"latestItemImageSize\":\"Large\",\"latestItemVideo\":\"1\",\"latestItemVideoWidth\":\"\",\"latestItemVideoHeight\":\"\",\"latestItemAudioWidth\":\"\",\"latestItemAudioHeight\":\"\",\"latestItemVideoAutoPlay\":\"0\",\"latestItemIntroText\":\"1\",\"latestItemCategory\":\"1\",\"latestItemTags\":\"0\",\"latestItemReadMore\":\"1\",\"latestItemCommentsAnchor\":\"0\",\"feedLink\":\"1\",\"latestItemK2Plugins\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',28,29,0,'*',0),(162,'mainmenu','2 columns','k2-items-2-cols','','home/k2-items-2-cols','index.php?option=com_k2&view=latest&layout=latest','component',1,120,2,10003,0,'0000-00-00 00:00:00',0,1,'',0,'{\"theme\":\"default\",\"source\":\"1\",\"latestItemsCols\":\"2\",\"latestItemsLimit\":\"4\",\"latestItemsDisplayEffect\":\"all\",\"userName\":\"1\",\"userImage\":\"1\",\"userDescription\":\"1\",\"userURL\":\"1\",\"userEmail\":\"0\",\"userFeed\":\"1\",\"categoryIDs\":[\"2\",\"1\",\"3\",\"4\"],\"categoryTitle\":\"0\",\"categoryDescription\":\"0\",\"categoryImage\":\"0\",\"categoryFeed\":\"0\",\"latestItemTitle\":\"1\",\"latestItemTitleLinked\":\"1\",\"latestItemDateCreated\":\"0\",\"latestItemImage\":\"1\",\"latestItemImageSize\":\"Medium\",\"latestItemVideo\":\"1\",\"latestItemVideoWidth\":\"\",\"latestItemVideoHeight\":\"\",\"latestItemAudioWidth\":\"\",\"latestItemAudioHeight\":\"\",\"latestItemVideoAutoPlay\":\"0\",\"latestItemIntroText\":\"1\",\"latestItemCategory\":\"1\",\"latestItemTags\":\"0\",\"latestItemReadMore\":\"1\",\"latestItemCommentsAnchor\":\"0\",\"feedLink\":\"1\",\"latestItemK2Plugins\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',30,31,0,'*',0),(164,'mainmenu','Tablet\'s','tablet-s','','home/k2-categories/tablet-s','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=2','component',1,134,3,10003,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories\":[\"2\"],\"singleCatOrdering\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',15,16,0,'*',0),(165,'mainmenu','TV\'s','tv-s','','home/k2-categories/tv-s','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=3','component',1,134,3,10003,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories\":[\"3\"],\"singleCatOrdering\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',17,18,0,'*',0),(166,'mainmenu','SmartPhone\'s','smartphone-s','','home/k2-categories/smartphone-s','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=1','component',1,134,3,10003,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories\":[\"1\"],\"singleCatOrdering\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',19,20,0,'*',0),(167,'mainmenu','Ultrabook\'s','ultrabook-s','','home/k2-categories/ultrabook-s','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=4','component',1,134,3,10003,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories\":[\"4\"],\"singleCatOrdering\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',21,22,0,'*',0),(175,'topnav','Home','2012-11-07-10-26-24','','2012-11-07-10-26-24','','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',153,154,0,'*',0),(176,'topnav','Blog','2012-11-07-10-26-43','','2012-11-07-10-26-43','','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',155,156,0,'*',0),(177,'topnav','Download','2012-11-07-10-27-00','','2012-11-07-10-27-00','','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',157,158,0,'*',0),(178,'topnav','About Us','2012-11-07-10-27-25','','2012-11-07-10-27-25','','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',159,160,0,'*',0),(179,'topnav','Contact','2012-11-07-10-27-54','','2012-11-07-10-27-54','','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',161,162,0,'*',0),(200,'mainemu','Wiki','2012-11-07-10-52-57','','2012-11-07-10-52-57','#','url',-2,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',163,170,0,'*',0),(201,'mainemu','Popular Games','2012-11-07-10-53-25','','2012-11-07-10-52-57/2012-11-07-10-53-25','#','url',-2,200,2,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',164,165,0,'*',0),(202,'mainemu','Consoles','2012-11-07-10-53-45','','2012-11-07-10-52-57/2012-11-07-10-53-45','#','url',-2,200,2,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',166,167,0,'*',0),(203,'mainemu','Popular articles','2012-11-07-10-54-09','','2012-11-07-10-52-57/2012-11-07-10-54-09','#','url',-2,200,2,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',168,169,0,'*',0),(204,'mainemu','Log in','log-in','','log-in','index.php?option=com_users&view=login','component',-2,1,1,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',171,172,0,'*',0),(205,'mainemu','Edit Profile','edit-profile','','edit-profile','index.php?option=com_users&view=profile&layout=edit','component',1,1,1,25,0,'0000-00-00 00:00:00',0,2,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',253,254,0,'*',0),(206,'mainemu','Create Article','create-article','','create-article','index.php?option=com_content&view=form&layout=edit','component',1,1,1,22,0,'0000-00-00 00:00:00',0,2,'',0,'{\"enable_category\":\"0\",\"catid\":\"2\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',255,256,0,'*',0),(207,'mainemu','Submit a Web Link','submit-a-web-link','','submit-a-web-link','index.php?option=com_weblinks&view=form&layout=edit','component',1,1,1,21,0,'0000-00-00 00:00:00',0,2,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',257,258,0,'*',0),(208,'mainemu','Your Profile','your-profile','','your-profile','index.php?option=com_users&view=profile','component',1,1,1,25,0,'0000-00-00 00:00:00',0,2,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',251,252,0,'*',0),(209,'mainemu','Sign Up','sign-up','','sign-up','index.php?option=com_users&view=registration','component',-2,1,1,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',173,174,0,'*',0),(210,'mobile-menu','Home','home-2','','home-2','index.php?option=com_content&view=featured','component',1,1,1,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"featured_categories\":[\"\"],\"layout_type\":\"blog\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"3\",\"num_columns\":\"3\",\"num_links\":\"0\",\"multi_column_order\":\"1\",\"orderby_pri\":\"\",\"orderby_sec\":\"front\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"info_bloc_position\":\"0\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":1,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',175,176,0,'*',0),(211,'mobile-menu','Template articles','template-articles','','template-articles','','separator',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',177,186,0,'*',0),(212,'mobile-menu','Typography','typography','','template-articles/typography','index.php?option=com_content&view=article&id=1','component',1,211,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',178,179,0,'*',0),(213,'mobile-menu','Error page','2012-11-06-14-27-34','','template-articles/2012-11-06-14-27-34','?option=non-existing-component','url',1,211,2,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',180,181,0,'*',0),(214,'mobile-menu','Offline page','2012-11-06-14-28-13','','template-articles/2012-11-06-14-28-13','?tmpl=offline','url',1,211,2,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',182,183,0,'*',0),(215,'mobile-menu','Joomla pages I','joomla-pages-i','','joomla-pages-i','','separator',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',187,200,0,'*',0),(216,'mobile-menu','Joomla pages II','joomla-pages-ii','','joomla-pages-ii','','separator',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',201,216,0,'*',0),(217,'mobile-menu','Joomla pages III','joomla-pages-iii','','joomla-pages-iii','','separator',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',217,236,0,'*',0),(218,'mobile-menu','Contact categories','contact-categories','','joomla-pages-i/contact-categories','index.php?option=com_contact&view=categories&id=0','component',1,215,2,8,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"0\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_items_cat\":\"1\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',188,189,0,'*',0),(219,'mobile-menu','Contacts in Category','contacts-in-category','','joomla-pages-i/contacts-in-category','index.php?option=com_contact&view=category&id=9','component',1,215,2,8,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"initial_sort\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',190,191,0,'*',0),(220,'mobile-menu','Single Contact','single-contact','','joomla-pages-i/single-contact','index.php?option=com_contact&view=contact&id=1','component',1,215,2,8,0,'0000-00-00 00:00:00',0,1,'',0,'{\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',192,193,0,'*',0),(221,'mobile-menu','Web Link Categories Link','web-link-categories-link','','joomla-pages-i/web-link-categories-link','index.php?option=com_weblinks&view=categories&id=0','component',1,215,2,21,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_links_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',194,195,0,'*',0),(222,'mobile-menu','Weblink single category','weblink-single-category','','joomla-pages-i/weblink-single-category','index.php?option=com_weblinks&view=category&id=14','component',1,215,2,21,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',196,197,0,'*',0),(223,'mobile-menu','Featured Contacts','featured-contacts','','joomla-pages-i/featured-contacts','index.php?option=com_contact&view=featured','component',1,215,2,8,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',198,199,0,'*',0),(224,'mobile-menu','News feeds categories list','news-feeds-categories-list','','joomla-pages-ii/news-feeds-categories-list','index.php?option=com_newsfeeds&view=categories&id=0','component',1,216,2,17,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_articles\":\"\",\"show_link\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',202,203,0,'*',0),(225,'mobile-menu','News feeds in a category','news-feeds-in-a-category','','joomla-pages-ii/news-feeds-in-a-category','index.php?option=com_newsfeeds&view=category&id=11','component',1,216,2,17,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_articles\":\"\",\"show_link\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"feed_display_order\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',204,205,0,'*',0),(226,'mobile-menu','User login','user-login','','joomla-pages-ii/user-login','index.php?option=com_users&view=login','component',1,216,2,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',206,207,0,'*',0),(227,'mobile-menu','User profile','user-profile','','joomla-pages-ii/user-profile','index.php?option=com_users&view=profile','component',1,216,2,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',208,209,0,'*',0),(228,'mobile-menu','User registration','user-registration','','joomla-pages-ii/user-registration','index.php?option=com_users&view=registration','component',1,216,2,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',210,211,0,'*',0),(229,'mobile-menu','User remind','user-remind','','joomla-pages-ii/user-remind','index.php?option=com_users&view=remind','component',1,216,2,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',212,213,0,'*',0),(230,'mobile-menu','Password reset','password-reset','','joomla-pages-ii/password-reset','index.php?option=com_users&view=reset','component',1,216,2,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',214,215,0,'*',0),(231,'mobile-menu','Archived articles','archived-articles','','joomla-pages-iii/archived-articles','index.php?option=com_content&view=archive','component',1,217,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"hide\",\"introtext_limit\":\"100\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',218,225,0,'*',0),(232,'mobile-menu','Single Article','single-article','','joomla-pages-iii/single-article','index.php?option=com_content&view=article&id=11','component',1,217,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"Example of the single article\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',226,227,0,'*',0),(233,'mobile-menu','Categories List','categories-list','','joomla-pages-iii/categories-list','index.php?option=com_content&view=categories&id=0','component',1,217,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"0\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"1\",\"show_subcat_desc_cat\":\"1\",\"show_cat_num_articles_cat\":\"1\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"List of the all categories.\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',228,229,0,'*',0),(234,'mobile-menu','Blog Layout','blog-layout','','joomla-pages-iii/blog-layout','index.php?option=com_content&view=category&layout=blog&id=17','component',1,217,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"5\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"1\",\"orderby_pri\":\"\",\"orderby_sec\":\"order\",\"order_date\":\"\",\"show_pagination\":\"1\",\"show_pagination_results\":\"1\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"info_bloc_position\":\"0\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"Category with the blog layout.\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',230,231,0,'*',0),(235,'mobile-menu','Category List','category-list','','joomla-pages-iii/category-list','index.php?option=com_content&view=category&id=17','component',1,217,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"List of the items in the specific category.\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',232,233,0,'*',0),(236,'mobile-menu','Featured Articles','featured-articles','','joomla-pages-iii/featured-articles','index.php?option=com_content&view=featured','component',1,217,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"featured_categories\":[\"\"],\"layout_type\":\"blog\",\"num_leading_articles\":\"2\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"5\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"info_bloc_position\":\"0\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"List of the featured articles\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',234,235,0,'*',0),(237,'mobile-menu','by Title','by-title','','joomla-pages-iii/archived-articles/by-title','index.php?option=com_content&view=archive','component',-2,231,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"title\",\"introtext_limit\":\"100\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"Archived articles sorted by title\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',219,220,0,'*',0),(238,'mobile-menu','by Author','by-author','','joomla-pages-iii/archived-articles/by-author','index.php?option=com_content&view=archive','component',-2,231,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"author\",\"introtext_limit\":\"100\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"Archived articles sorted by author\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',221,222,0,'*',0),(239,'mobile-menu','by Hits','by-hits','','joomla-pages-iii/archived-articles/by-hits','index.php?option=com_content&view=archive','component',-2,231,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"hits\",\"introtext_limit\":\"100\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"Archived articles sorted by hits\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',223,224,0,'*',0),(255,'mainmenu','3 columns','k2-items-3-cols','','home/k2-items-3-cols','index.php?option=com_k2&view=latest&layout=latest','component',1,120,2,10003,0,'0000-00-00 00:00:00',0,1,'',0,'{\"theme\":\"default\",\"source\":\"1\",\"latestItemsCols\":\"3\",\"latestItemsLimit\":\"3\",\"latestItemsDisplayEffect\":\"all\",\"userIDs\":[\"572\"],\"userName\":\"0\",\"userImage\":\"0\",\"userDescription\":\"0\",\"userURL\":\"0\",\"userEmail\":\"0\",\"userFeed\":\"1\",\"categoryIDs\":[\"2\",\"3\",\"1\"],\"categoryTitle\":\"0\",\"categoryDescription\":\"0\",\"categoryImage\":\"0\",\"categoryFeed\":\"0\",\"latestItemTitle\":\"1\",\"latestItemTitleLinked\":\"1\",\"latestItemDateCreated\":\"0\",\"latestItemImage\":\"1\",\"latestItemImageSize\":\"Medium\",\"latestItemVideo\":\"1\",\"latestItemVideoWidth\":\"\",\"latestItemVideoHeight\":\"\",\"latestItemAudioWidth\":\"\",\"latestItemAudioHeight\":\"\",\"latestItemVideoAutoPlay\":\"0\",\"latestItemIntroText\":\"1\",\"latestItemCategory\":\"1\",\"latestItemTags\":\"0\",\"latestItemReadMore\":\"1\",\"latestItemCommentsAnchor\":\"0\",\"feedLink\":\"1\",\"latestItemK2Plugins\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',32,33,0,'*',0),(265,'footmenu','Home','home2','','home2','index.php?Itemid=','alias',1,1,1,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"aliasoptions\":\"265\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',237,238,0,'*',0),(266,'footmenu','Terms of Service','2013-01-02-07-43-34','','2013-01-02-07-43-34','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',239,240,0,'*',0),(267,'footmenu','Privacy guidelines','2013-01-02-07-43-55','','2013-01-02-07-43-55','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',241,242,0,'*',0),(268,'footmenu','Contact Us','2013-01-02-07-44-15','','2013-01-02-07-44-15','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',243,244,0,'*',0),(271,'footmenu','Site Map','2013-01-02-07-45-08','','2013-01-02-07-45-08','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',245,246,0,'*',0),(274,'footmenu','Opinions','2013-01-02-07-46-06','','2013-01-02-07-46-06','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',247,248,0,'*',0),(276,'footmenu','Help','2013-01-02-07-46-48','','2013-01-02-07-46-48','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',249,250,0,'*',0),(277,'mobile-menu','Messages','messages','','template-articles/messages','index.php?option=com_content&view=article&id=3','component',1,211,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',184,185,0,'*',0),(322,'main','COM_K2','com-k2','','com-k2','index.php?option=com_k2','component',0,1,1,10003,0,'0000-00-00 00:00:00',0,1,'../media/k2/assets/images/system/k2_16x16.png',0,'',259,280,0,'',1),(323,'main','K2_ITEMS','k2-items','','com-k2/k2-items','index.php?option=com_k2&view=items','component',0,322,2,10003,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',260,261,0,'',1),(324,'main','K2_CATEGORIES','k2-categories','','com-k2/k2-categories','index.php?option=com_k2&view=categories','component',0,322,2,10003,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',262,263,0,'',1),(325,'main','K2_TAGS','k2-tags','','com-k2/k2-tags','index.php?option=com_k2&view=tags','component',0,322,2,10003,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',264,265,0,'',1),(326,'main','K2_COMMENTS','k2-comments','','com-k2/k2-comments','index.php?option=com_k2&view=comments','component',0,322,2,10003,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',266,267,0,'',1),(327,'main','K2_USERS','k2-users','','com-k2/k2-users','index.php?option=com_k2&view=users','component',0,322,2,10003,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',268,269,0,'',1),(328,'main','K2_USER_GROUPS','k2-user-groups','','com-k2/k2-user-groups','index.php?option=com_k2&view=usergroups','component',0,322,2,10003,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',270,271,0,'',1),(329,'main','K2_EXTRA_FIELDS','k2-extra-fields','','com-k2/k2-extra-fields','index.php?option=com_k2&view=extrafields','component',0,322,2,10003,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',272,273,0,'',1),(330,'main','K2_EXTRA_FIELD_GROUPS','k2-extra-field-groups','','com-k2/k2-extra-field-groups','index.php?option=com_k2&view=extrafieldsgroups','component',0,322,2,10003,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',274,275,0,'',1),(331,'main','K2_MEDIA_MANAGER','k2-media-manager','','com-k2/k2-media-manager','index.php?option=com_k2&view=media','component',0,322,2,10003,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',276,277,0,'',1),(332,'main','K2_INFORMATION','k2-information','','com-k2/k2-information','index.php?option=com_k2&view=info','component',0,322,2,10003,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',278,279,0,'',1);


--
-- Table structure for table `#__menu_types`
--



CREATE TABLE `#__menu_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL,
  `title` varchar(48) NOT NULL,
  `description` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_menutype` (`menutype`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__menu_types`
--


INSERT INTO `#__menu_types` (`id`, `menutype`, `title`, `description`) VALUES (1,'mainmenu','Main Menu','The main menu for the site'),(2,'footmenu','Footer menu',''),(3,'mobile-menu','Mobile menu',''),(4,'mainemu','User Menu',''),(5,'topnav','Top nav','');


--
-- Table structure for table `#__messages`
--



CREATE TABLE `#__messages` (
  `message_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id_from` int(10) unsigned NOT NULL DEFAULT '0',
  `user_id_to` int(10) unsigned NOT NULL DEFAULT '0',
  `folder_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `date_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `priority` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(255) NOT NULL DEFAULT '',
  `message` text NOT NULL,
  PRIMARY KEY (`message_id`),
  KEY `useridto_state` (`user_id_to`,`state`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__messages`
--




--
-- Table structure for table `#__messages_cfg`
--



CREATE TABLE `#__messages_cfg` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `cfg_name` varchar(100) NOT NULL DEFAULT '',
  `cfg_value` varchar(255) NOT NULL DEFAULT '',
  UNIQUE KEY `idx_user_var_name` (`user_id`,`cfg_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__messages_cfg`
--




--
-- Table structure for table `#__modules`
--



CREATE TABLE `#__modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) NOT NULL DEFAULT '',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) DEFAULT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `showtitle` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB AUTO_INCREMENT=198 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__modules`
--


INSERT INTO `#__modules` (`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES (1,'Main Menu','','',1,'position-7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_menu',1,1,'{\"menutype\":\"mainmenu\",\"startLevel\":\"0\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),(2,'Login','','',1,'login',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_login',1,1,'',1,'*'),(3,'Popular Articles','','',3,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_popular',3,1,'{\"count\":\"5\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),(4,'Recently Added Articles','','',4,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_latest',3,1,'{\"count\":\"5\",\"ordering\":\"c_dsc\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),(8,'Toolbar','','',1,'toolbar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_toolbar',3,1,'',1,'*'),(9,'Quick Icons','','',1,'icon',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_quickicon',3,1,'',1,'*'),(10,'Logged-in Users','','',2,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_logged',3,1,'{\"count\":\"5\",\"name\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),(12,'Admin Menu','','',1,'menu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',3,1,'{\"layout\":\"\",\"moduleclass_sfx\":\"\",\"shownew\":\"1\",\"showhelp\":\"1\",\"cache\":\"0\"}',1,'*'),(13,'Admin Submenu','','',1,'submenu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_submenu',3,1,'',1,'*'),(14,'User Status','','',2,'status',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_status',3,1,'',1,'*'),(15,'Title','','',1,'title',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_title',3,1,'',1,'*'),(16,'Login','','',1,'login',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_login',1,1,'{\"pretext\":\"\",\"posttext\":\"\",\"login\":\"\",\"logout\":\"\",\"greeting\":\"1\",\"name\":\"0\",\"usesecure\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(17,'Breadcrumbs','','',1,'breadcrumb',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_breadcrumbs',1,0,'{\"showHere\":\"1\",\"showHome\":\"1\",\"homeText\":\"Home\",\"showLast\":\"1\",\"separator\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(79,'Multilanguage status','','',1,'status',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_multilangstatus',3,1,'{\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',1,'*'),(86,'Joomla Version','','',1,'footer',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_version',3,1,'{\"format\":\"short\",\"product\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',1,'*'),(88,'Recent __Work__','','',1,'bottom2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\"nsp vertical smallspaces nspanimate big\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"k2_articles\",\"com_articles\":\"\",\"k2_categories\":[\"2\",\"3\",\"1\",\"4\",\"5\"],\"k2_articles\":\"13,19,18\",\"news_sort_value\":\"created\",\"news_sort_order\":\"ASC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_portal_mode_5_amount\":\"10\",\"news_full_pages\":\"1\",\"news_column\":\"3\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"words\",\"title_limit\":\"5\",\"news_content_image_pos\":\"center\",\"news_content_image_float\":\"none\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE %CATEGORY\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y H:i\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 30px 0 0 \",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"left\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"0\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"0\",\"img_keep_aspect_ratio\":\"1\",\"img_width\":\"220\",\"img_height\":\"180\",\"img_margin\":\"0 0 30px 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(89,'K2 Comments','','',7,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_k2_comments',1,1,'{\"moduleclass_sfx\":\"\",\"module_usage\":\"0\",\"catfilter\":\"0\",\"comments_limit\":\"3\",\"comments_word_limit\":\"9\",\"commenterName\":\"1\",\"commentAvatar\":\"1\",\"commentAvatarWidthSelect\":\"custom\",\"commentAvatarWidth\":\"42\",\"commentDate\":\"1\",\"commentDateFormat\":\"absolute\",\"commentLink\":\"1\",\"itemTitle\":\"0\",\"itemCategory\":\"0\",\"feed\":\"0\",\"commenters_limit\":\"4\",\"commenterNameOrUsername\":\"1\",\"commenterAvatar\":\"1\",\"commenterAvatarWidthSelect\":\"custom\",\"commenterAvatarWidth\":\"50\",\"commenterLink\":\"1\",\"commenterCommentsCounter\":\"1\",\"commenterLatestComment\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(90,'K2 Content','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_k2_content',1,1,'',0,'*'),(91,'Blog Categories','','',1,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_k2_tools',1,1,'{\"moduleclass_sfx\":\"\",\"module_usage\":\"4\",\"archiveItemsCounter\":\"1\",\"archiveCategory\":\"0\",\"authors_module_category\":\"0\",\"authorItemsCounter\":\"0\",\"authorAvatar\":\"1\",\"authorAvatarWidthSelect\":\"custom\",\"authorAvatarWidth\":\"50\",\"authorLatestItem\":\"1\",\"calendarCategory\":\"0\",\"home\":\"\",\"seperator\":\"\",\"root_id\":\"0\",\"end_level\":\"\",\"categoriesListOrdering\":\"alpha\",\"categoriesListItemsCounter\":\"0\",\"root_id2\":\"0\",\"catfilter\":\"0\",\"getChildren\":\"0\",\"liveSearch\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"imagebutton\":\"\",\"button_text\":\"\",\"min_size\":\"75\",\"max_size\":\"300\",\"cloud_limit\":\"30\",\"cloud_category\":[\"0\"],\"cloud_category_recursive\":\"0\",\"customCode\":\"\",\"parsePhp\":\"0\",\"K2Plugins\":\"0\",\"JPlugins\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(92,'K2 Users','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_k2_users',1,1,'',0,'*'),(93,'K2 User','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_k2_user',1,1,'',0,'*'),(94,'K2 Quick Icons (admin)','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_quickicons',1,1,'',1,'*'),(95,'K2 Stats (admin)','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_stats',1,1,'',1,'*'),(96,'mod_gk_register','','',1,'register',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_gk_register',1,1,'{\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(97,'The key __Features__**We design and develop beautiful websites**','','<div class=\"gkFeatures gkPerspective\">\r\n<a href=\"#\" class=\"gkRocket\" data-animation=\"flip\" data-delay=\"0\"><span>Rocket</span>Innovative Design</a>\r\n<a href=\"#\" class=\"gkBadge\" data-animation=\"flip\" data-delay=\"150\"><span>Badge</span>Award-winning Agency</a>\r\n<a href=\"#\" class=\"gkMouse\" data-animation=\"flip\" data-delay=\"300\"><span>Mouse</span>Your ideas, imagination</a>\r\n<a href=\"#\" class=\"gkPiggy\" data-animation=\"flip\" data-delay=\"450\"><span>Piggy</span>Save Your Time &amp; Money</a>\r\n</div>\r\n<a href=\"#\">View Full Features</a>',1,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"smallspaces big\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(98,'Our __Team__**We are creative, innovative people**','','<div class=\"gkTeam\" data-count=\"7\">\r\n<figure data-animation=\"horizontal\" data-delay=\"0\">\r\n<a href=\"#\"><img src=\"images/demo/demo_team.jpg\" alt=\"\" /></a>\r\n<figcaption><a href=\"#\">Mark</a></figcaption>\r\n</figure>\r\n\r\n<figure data-animation=\"horizontal\" data-delay=\"100\">\r\n<a href=\"#\"><img src=\"images/demo/demo_team.jpg\" alt=\"\" /></a>\r\n<figcaption><a href=\"#\">Mikkel</a></figcaption>\r\n</figure>\r\n\r\n<figure data-animation=\"horizontal\" data-delay=\"200\">\r\n<a href=\"#\"><img src=\"images/demo/demo_team.jpg\" alt=\"\" /></a>\r\n<figcaption><a href=\"#\">Donna</a></figcaption>\r\n</figure>\r\n\r\n<figure data-animation=\"horizontal\" data-delay=\"300\">\r\n<a href=\"#\"><img src=\"images/demo/demo_team.jpg\" alt=\"\" /></a>\r\n<figcaption><a href=\"#\">Noemi</a></figcaption>\r\n</figure>\r\n\r\n<figure data-animation=\"horizontal\" data-delay=\"400\">\r\n<a href=\"#\"><img src=\"images/demo/demo_team.jpg\" alt=\"\" /></a>\r\n<figcaption><a href=\"#\">Robert</a></figcaption>\r\n</figure>\r\n\r\n<figure data-animation=\"horizontal\" data-delay=\"500\">\r\n<a href=\"#\"><img src=\"images/demo/demo_team.jpg\" alt=\"\" /></a>\r\n<figcaption><a href=\"#\">Amanda</a></figcaption>\r\n</figure>\r\n\r\n<figure data-animation=\"horizontal\" data-delay=\"600\">\r\n<a href=\"#\"><img src=\"images/demo/demo_team.jpg\" alt=\"\" /></a>\r\n<figcaption><a href=\"#\">Remzi</a></figcaption>\r\n</figure>\r\n\r\n<a href=\"#\">More About Us</a>\r\n</div>',1,'bottom3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"smallspaces big\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(99,'Contact__ US here__','','<div class=\"vertical-column-40\" data-animation=\"vertical\" data-delay=\"0\">\r\n<h3>We are hiring</h3>\r\n<p>We are looking for a talented web designers to join our team full-time in Los Angeles.</p>\r\n</div>\r\n\r\n<div class=\"vertical-column-30\" data-animation=\"vertical\" data-delay=\"200\">\r\n<h3>Chicago</h3>\r\n<p>City Hall 121</p>\r\n<p>N. LaSalle Street</p>\r\n<p>Phone: <strong>+1058961200</strong></p>\r\n</div>\r\n\r\n<div class=\"vertical-column-30\" data-animation=\"vertical\" data-delay=\"400\">\r\n<h3>Los Angeles</h3>\r\n<p>57 Roeland Street</p>\r\n<p>Mota Town, 7689</p>\r\n<p>Phone: <strong>+1058961200</strong></p>\r\n</div>',1,'bottom4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"vertical smallspaces big\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(100,'Mainbody content','','<h2 class=\"gkBigHeader\">Everything you need to create a website</h2>',1,'mainbody',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" bigspaces\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(101,'Mainbody Sidebar','','<h3 class=\"gkSmallHeader\">Create a website quickly & easily</h3>\r\n\r\n<p class=\"gkTimeIcon\">Quisque justo lorem, condimentum condimentum ornare vel, consectetur id justo? Phasellus leo lacus, rhoncus dictum auctor.</p>',1,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"bigspaces\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(102,'Social icons','','<a class=\"gkTwitter\" href=\"#\">Twitter</a><a class=\"gkFb\" href=\"#\">Facebook</a><a class=\"gkPinterest\" href=\"#\">Pinterest</a><a class=\"gkGplus\" href=\"#\">Google+</a>',1,'social',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(103,'NSP GK4 suffix \" nsp clear\"','','',1,'mainbody_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp clear\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"com_all_articles\",\"com_articles\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_portal_mode_5_amount\":\"10\",\"news_full_pages\":\"3\",\"news_column\":\"2\",\"news_rows\":\"2\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"17\",\"news_content_image_pos\":\"center\",\"news_content_image_float\":\"none\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE %CATEGORY\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y H:i\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"4px 16px 0 0 \",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"2\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"0\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"0\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"120\",\"img_height\":\"80\",\"img_margin\":\"0 0 20px\",\"img_bg\":\"#fff\",\"img_stretch\":\"0\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(104,'Banner module','','',9,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_banners',1,1,'{\"target\":\"1\",\"count\":\"4\",\"cid\":\"0\",\"catid\":[\"\"],\"tag_search\":\"0\",\"ordering\":\"0\",\"header_text\":\"Featured links:\",\"footer_text\":\"Ads by Joomla!\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(105,'Suffix \" advertisement\"','','<p>Aenean lacinia bibendum nulla sed consectetur. Etiam porta sem malesuada magna mollis euismod. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum.</p>',1,'mainbody_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" advertisement\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(106,'Menu','','',8,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_menu',1,1,'{\"menutype\":\"footmenu\",\"active\":\"\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(107,'Top I','','<p>Maecenas faucibus mollis interdum. Donec id elit non mi porta gravida at eget metus.</p>',1,'top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(108,'Top II','','<p>Maecenas faucibus mollis interdum. Donec id elit non mi porta gravida at eget metus.</p>',1,'top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(109,'Top III','','<p>Maecenas faucibus mollis interdum. Donec id elit non mi porta gravida at eget metus.</p>',1,'top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(110,'Suffix \" dark\"','','<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Donec id elit non mi porta gravida at eget metus.</p>\r\n<ul>\r\n<li><a href=\"#\">Maecenas faucibus</a></li>\r\n<li><a href=\"#\">Vivamus sagittis.</a></li>\r\n<li><a href=\"#\">Praesent commodo.</a></li>\r\n</ul>',1,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" dark\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(111,'Tag Cloud','','',6,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_k2_tools',1,1,'{\"moduleclass_sfx\":\"\",\"module_usage\":\"7\",\"archiveItemsCounter\":\"1\",\"archiveCategory\":\"0\",\"authors_module_category\":\"0\",\"authorItemsCounter\":\"1\",\"authorAvatar\":\"1\",\"authorAvatarWidthSelect\":\"custom\",\"authorAvatarWidth\":\"50\",\"authorLatestItem\":\"1\",\"calendarCategory\":\"0\",\"home\":\"\",\"seperator\":\"\",\"root_id\":\"0\",\"end_level\":\"\",\"categoriesListOrdering\":\"\",\"categoriesListItemsCounter\":\"1\",\"root_id2\":\"0\",\"catfilter\":\"0\",\"getChildren\":\"0\",\"liveSearch\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"imagebutton\":\"\",\"button_text\":\"\",\"min_size\":\"75\",\"max_size\":\"300\",\"cloud_limit\":\"16\",\"cloud_category\":[\"2\",\"3\",\"1\",\"4\",\"5\"],\"cloud_category_recursive\":\"0\",\"customCode\":\"\",\"parsePhp\":\"0\",\"K2Plugins\":\"0\",\"JPlugins\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(112,'Suffix \" light\"','','<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Donec id elit non mi porta gravida at eget metus.</p>\r\n<ul>\r\n<li><a href=\"#\">Maecenas faucibus</a></li>\r\n<li><a href=\"#\">Vivamus sagittis.</a></li>\r\n<li><a href=\"#\">Praesent commodo.</a></li>\r\n</ul>',1,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" light\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(113,'Suffix \" color\"','','<p>Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Donec id elit non mi porta gravida at eget metus. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor.</p>',1,'mainbody_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" color\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(114,'Archives','','',1,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_k2_tools',1,1,'{\"moduleclass_sfx\":\"\",\"module_usage\":\"0\",\"archiveItemsCounter\":\"1\",\"archiveCategory\":\"0\",\"authors_module_category\":\"0\",\"authorItemsCounter\":\"1\",\"authorAvatar\":\"1\",\"authorAvatarWidthSelect\":\"custom\",\"authorAvatarWidth\":\"50\",\"authorLatestItem\":\"1\",\"calendarCategory\":\"0\",\"home\":\"\",\"seperator\":\"\",\"root_id\":\"0\",\"end_level\":\"\",\"categoriesListOrdering\":\"\",\"categoriesListItemsCounter\":\"1\",\"root_id2\":\"0\",\"catfilter\":\"0\",\"getChildren\":\"0\",\"liveSearch\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"imagebutton\":\"\",\"button_text\":\"\",\"min_size\":\"75\",\"max_size\":\"300\",\"cloud_limit\":\"30\",\"cloud_category\":[\"0\"],\"cloud_category_recursive\":\"0\",\"customCode\":\"\",\"parsePhp\":\"0\",\"K2Plugins\":\"0\",\"JPlugins\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(115,'Lorem ipsum','','<ul>\r\n<li><a href=\"#\">Cras mattis consectetur</a></li>\r\n<li><a href=\"#\">Donec id elit</a></li>\r\n<li><a href=\"#\">Vivamus sagittis lacus</a></li>\r\n<li><a href=\"#\">Vestibulum id ligula</a></li>\r\n</ul>',1,'bottom3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(116,'Lorem ipsum','','<ul>\r\n<li><a href=\"#\">Cras mattis consectetur</a></li>\r\n<li><a href=\"#\">Donec id elit</a></li>\r\n<li><a href=\"#\">Vivamus sagittis lacus</a></li>\r\n<li><a href=\"#\">Vestibulum id ligula</a></li>\r\n</ul>',1,'bottom3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(117,'Lorem ipsum','','<ul>\r\n<li><a href=\"#\">Cras mattis consectetur</a></li>\r\n<li><a href=\"#\">Donec id elit</a></li>\r\n<li><a href=\"#\">Vivamus sagittis lacus</a></li>\r\n<li><a href=\"#\">Vestibulum id ligula</a></li>\r\n</ul>',1,'bottom3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(118,'Lorem ipsum','','<ul>\r\n<li><a href=\"#\">Cras mattis consectetur</a></li>\r\n<li><a href=\"#\">Donec id elit</a></li>\r\n<li><a href=\"#\">Vivamus sagittis lacus</a></li>\r\n<li><a href=\"#\">Vestibulum id ligula</a></li>\r\n</ul>',1,'bottom3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(119,'Lorem ipsum','','<ul>\r\n<li><a href=\"#\">Cras mattis consectetur</a></li>\r\n<li><a href=\"#\">Donec id elit</a></li>\r\n<li><a href=\"#\">Vivamus sagittis lacus</a></li>\r\n<li><a href=\"#\">Vestibulum id ligula</a></li>\r\n</ul>',1,'bottom4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(120,'Lorem ipsum','','<ul>\r\n<li><a href=\"#\">Cras mattis consectetur</a></li>\r\n<li><a href=\"#\">Donec id elit</a></li>\r\n<li><a href=\"#\">Vivamus sagittis lacus</a></li>\r\n<li><a href=\"#\">Vestibulum id ligula</a></li>\r\n</ul>',1,'bottom4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(121,'Lorem ipsum','','<ul>\r\n<li><a href=\"#\">Cras mattis consectetur</a></li>\r\n<li><a href=\"#\">Donec id elit</a></li>\r\n<li><a href=\"#\">Vivamus sagittis lacus</a></li>\r\n<li><a href=\"#\">Vestibulum id ligula</a></li>\r\n</ul>',1,'bottom4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(122,'Lorem ipsum','','<ul>\r\n<li><a href=\"#\">Cras mattis consectetur</a></li>\r\n<li><a href=\"#\">Donec id elit</a></li>\r\n<li><a href=\"#\">Vivamus sagittis lacus</a></li>\r\n<li><a href=\"#\">Vestibulum id ligula</a></li>\r\n</ul>',1,'bottom4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(123,'Suffix \"vertical\"','','<p>Donec sed odio dui. Maecenas sed diam eget risus varius blandit sit amet non magna. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Curabitur blandit tempus porttitor. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla sed consectetur. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>',1,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" vertical\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(124,'Suffix \"vertical big\"','','<p>Donec sed odio dui. Maecenas sed diam eget risus varius blandit sit amet non magna. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Curabitur blandit tempus porttitor. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla sed consectetur. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>',1,'bottom2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"vertical big\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(125,'Breadcrumbs','','',1,'breadcrumb',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_breadcrumbs',1,1,'{\"showHere\":\"1\",\"showHome\":\"1\",\"homeText\":\"Home\",\"showLast\":\"1\",\"separator\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(126,'Footer menu','','',1,'footer_nav',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,0,'{\"menutype\":\"footmenu\",\"active\":\"\",\"startLevel\":\"1\",\"endLevel\":\"1\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(127,'NSP GK4 suffix \" nsp\"','','',1,'mainbody_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"com_all_articles\",\"com_articles\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_amount\":\"10\",\"news_portal_mode_7_width\":\"265\",\"news_full_pages\":\"3\",\"news_column\":\"2\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"17\",\"news_content_image_pos\":\"center\",\"news_content_image_float\":\"none\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE %CATEGORY\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y H:i\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"4px 16px 0 0 \",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"2\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"200\",\"responsive_images\":\"0\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"0\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"120\",\"img_height\":\"80\",\"img_margin\":\"0 0 20px\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(128,'User menu','','',1,'usermenu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_menu',2,1,'{\"menutype\":\"mainemu\",\"active\":\"\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(129,'mod_gk_register','','',1,'register',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_gk_register',1,0,'{\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(130,'Banner module','','',1,'inset',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_banners',1,1,'{\"target\":\"1\",\"count\":\"4\",\"cid\":\"0\",\"catid\":[\"\"],\"tag_search\":\"0\",\"ordering\":\"0\",\"header_text\":\"Featured links:\",\"footer_text\":\"Ads by Joomla!\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(131,'Suffix \" advertisement\"','','<p>Aenean lacinia bibendum nulla sed consectetur. Etiam porta sem malesuada magna mollis euismod. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum.</p>',12,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" advertisement\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(132,'Comments','','',2,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_comments',1,1,'{\"moduleclass_sfx\":\"\",\"module_usage\":\"0\",\"catfilter\":\"0\",\"comments_limit\":\"4\",\"comments_word_limit\":\"7\",\"commenterName\":\"1\",\"commentAvatar\":\"1\",\"commentAvatarWidthSelect\":\"custom\",\"commentAvatarWidth\":\"42\",\"commentDate\":\"0\",\"commentDateFormat\":\"absolute\",\"commentLink\":\"1\",\"itemTitle\":\"0\",\"itemCategory\":\"0\",\"feed\":\"0\",\"commenters_limit\":\"4\",\"commenterNameOrUsername\":\"1\",\"commenterAvatar\":\"1\",\"commenterAvatarWidthSelect\":\"custom\",\"commenterAvatarWidth\":\"50\",\"commenterLink\":\"1\",\"commenterCommentsCounter\":\"1\",\"commenterLatestComment\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(133,'Menu','','',12,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"footmenu\",\"active\":\"\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(134,'Top I','','<p>Maecenas faucibus mollis interdum. Donec id elit non mi porta gravida at eget metus.</p>',1,'top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(135,'Top II','','<p>Maecenas faucibus mollis interdum. Donec id elit non mi porta gravida at eget metus.</p>',1,'top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(136,'Top III','','<p>Maecenas faucibus mollis interdum. Donec id elit non mi porta gravida at eget metus.</p>',1,'top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(137,'Suffix \" color1\"','','<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. </p>\r\n<ul>\r\n<li><a href=\"#\">Maecenas faucibus</a></li>\r\n<li><a href=\"#\">Vivamus sagittis.</a></li>\r\n<li><a href=\"#\">Praesent commodo.</a></li>\r\n</ul>',6,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" color1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(138,'Blog Categories','','',1,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_tools',1,1,'{\"moduleclass_sfx\":\"menu light\",\"module_usage\":\"4\",\"archiveItemsCounter\":\"1\",\"archiveCategory\":\"0\",\"authors_module_category\":\"0\",\"authorItemsCounter\":\"1\",\"authorAvatar\":\"1\",\"authorAvatarWidthSelect\":\"custom\",\"authorAvatarWidth\":\"50\",\"authorLatestItem\":\"1\",\"calendarCategory\":\"0\",\"home\":\"\",\"seperator\":\"\",\"root_id\":\"0\",\"end_level\":\"\",\"categoriesListOrdering\":\"order\",\"categoriesListItemsCounter\":\"0\",\"root_id2\":\"0\",\"catfilter\":\"0\",\"getChildren\":\"0\",\"liveSearch\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"imagebutton\":\"\",\"button_text\":\"\",\"min_size\":\"75\",\"max_size\":\"300\",\"cloud_limit\":\"30\",\"cloud_category\":[\"0\"],\"cloud_category_recursive\":\"0\",\"customCode\":\"\",\"parsePhp\":\"0\",\"K2Plugins\":\"0\",\"JPlugins\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(139,'Tag Cloud','','',10,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_tools',1,1,'{\"moduleclass_sfx\":\"\",\"module_usage\":\"7\",\"archiveItemsCounter\":\"1\",\"archiveCategory\":\"0\",\"authors_module_category\":\"0\",\"authorItemsCounter\":\"1\",\"authorAvatar\":\"1\",\"authorAvatarWidthSelect\":\"custom\",\"authorAvatarWidth\":\"50\",\"authorLatestItem\":\"1\",\"calendarCategory\":\"0\",\"home\":\"\",\"seperator\":\"\",\"root_id\":\"0\",\"end_level\":\"\",\"categoriesListOrdering\":\"order\",\"categoriesListItemsCounter\":\"0\",\"root_id2\":\"0\",\"catfilter\":\"0\",\"getChildren\":\"0\",\"liveSearch\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"imagebutton\":\"\",\"button_text\":\"\",\"min_size\":\"75\",\"max_size\":\"300\",\"cloud_limit\":\"16\",\"cloud_category\":[\"2\",\"3\"],\"cloud_category_recursive\":\"0\",\"customCode\":\"\",\"parsePhp\":\"0\",\"K2Plugins\":\"0\",\"JPlugins\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(140,'Top navigation','','',1,'topnav',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"topnav\",\"active\":\"\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(141,'Social icons','','<a class=\"gkTwitter\" href=\"#\">Twitter</a><a class=\"gkFb\" href=\"#\">Facebook</a><a class=\"gkPinterest\" href=\"#\">Pinterest</a><a class=\"gkGplus\" href=\"#\">Google+</a>',1,'social',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(142,'Search','','',1,'search',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_search',1,1,'{\"label\":\"\",\"width\":\"22\",\"text\":\"\",\"button\":\"\",\"button_pos\":\"right\",\"imagebutton\":\"\",\"button_text\":\"\",\"opensearch\":\"1\",\"opensearch_title\":\"\",\"set_itemid\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(144,' User area','','',1,'usermenu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"mainemu\",\"active\":\"\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"1\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(145,'Suffix \" light\" ','','<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit.</p>\r\n<ul>\r\n<li><a href=\"#\">Maecenas faucibus</a></li>\r\n<li><a href=\"#\">Vivamus sagittis.</a></li>\r\n<li><a href=\"#\">Praesent commodo.</a></li>\r\n</ul>',7,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" light\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(146,'Suffix \" color2\"','','<p>Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Donec id elit non mi porta gravida at eget metus. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor.</p>',2,'mainbody_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"color2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(147,'Login','','',1,'login',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_login',1,1,'{\"pretext\":\"\",\"posttext\":\"\",\"login\":\"\",\"logout\":\"\",\"greeting\":\"1\",\"name\":\"0\",\"usesecure\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(148,'Language Switcher','','',1,'lang',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_languages',1,1,'{\"header_text\":\"pre-text\",\"footer_text\":\"post-text\",\"dropdown\":\"1\",\"image\":\"1\",\"inline\":\"1\",\"show_active\":\"1\",\"full_name\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(149,'Archives','','',8,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_tools',1,1,'{\"moduleclass_sfx\":\"\",\"module_usage\":\"0\",\"archiveItemsCounter\":\"1\",\"archiveCategory\":\"0\",\"authors_module_category\":\"0\",\"authorItemsCounter\":\"1\",\"authorAvatar\":\"1\",\"authorAvatarWidthSelect\":\"custom\",\"authorAvatarWidth\":\"50\",\"authorLatestItem\":\"1\",\"calendarCategory\":\"0\",\"home\":\"\",\"seperator\":\"\",\"root_id\":\"0\",\"end_level\":\"\",\"categoriesListOrdering\":\"order\",\"categoriesListItemsCounter\":\"0\",\"root_id2\":\"0\",\"catfilter\":\"0\",\"getChildren\":\"0\",\"liveSearch\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"imagebutton\":\"\",\"button_text\":\"\",\"min_size\":\"75\",\"max_size\":\"300\",\"cloud_limit\":\"16\",\"cloud_category\":[\"2\",\"3\",\"1\",\"4\"],\"cloud_category_recursive\":\"0\",\"customCode\":\"\",\"parsePhp\":\"0\",\"K2Plugins\":\"0\",\"JPlugins\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(150,'Sections','','<ul>\r\n			<li> <a href=\"#\">U.S.</a></li>\r\n			<li> <a href=\"#\">World</a></li>\r\n			<li> <a href=\"#\">Politics</a></li>\r\n			<li> <a href=\"#\">OTUS</a></li>\r\n			<li> <a href=\"#\">Investigative</a></li>\r\n			<li> <a href=\"#\">Health</a></li>\r\n			<li> <a href=\"#\"> Entertainment</a></li>\r\n			<li> <a href=\"#\"> Money</a></li>\r\n			<li> <a href=\"#\">Technology</a></li>\r\n			<li> <a href=\"#\">Travel</a></li>\r\n			<li> <a href=\"#\">Recipes</a></li>\r\n			<li> <a href=\"#\">News Topics</a></li>\r\n</ul>\r\n',1,'bottom2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(151,'Shows','','<ul>\r\n			<li><a href=\"#\"> NY Med </a></li>\r\n			<li><a href=\"#\"> Good Morning America </a></li>\r\n			<li><a href=\"#\"> World News </a></li>\r\n			<li><a href=\"#\"> Nightline </a></li>\r\n			<li><a href=\"#\"> This Week </a></li>\r\n			<li><a href=\"#\"> Primetime </a></li>\r\n			<li><a href=\"#\"> What Would You Do?</a></li>\r\n			<li><a href=\"#\"> Live Streaming Coverage </a></li>\r\n			<li><a href=\"#\"> News.com</a></li>\r\n\r\n</ul>\r\n   ',1,'bottom2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(152,'Local News','','<ul>\r\n			<li><a href=\"#\"> Los Angeles </a></li>\r\n			<li><a href=\"#\"> San Francisco </a></li>\r\n			<li><a href=\"#\"> Oklahoma City </a></li>\r\n			<li><a href=\"#\"> Colorado Springs </a></li>\r\n			<li><a href=\"#\"> New Orleans </a></li>\r\n			<li><a href=\"#\"> Saint Louis</a></li>\r\n			<li><a href=\"#\"> Saint Petersburg </a></li>\r\n			<li><a href=\"#\"> Berlin </a></li>\r\n			<li><a href=\"#\"> Moscow</a></li>\r\n			<li><a href=\"#\"> Sydney </a></li>\r\n</ul>\r\n',1,'bottom2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(153,'Local News (2)','','<ul>\r\n			<li><a href=\"#\"> Los Angeles </a></li>\r\n			<li><a href=\"#\"> San Francisco </a></li>\r\n			<li><a href=\"#\"> Oklahoma City </a></li>\r\n			<li><a href=\"#\"> Colorado Springs </a></li>\r\n			<li><a href=\"#\"> New Orleans </a></li>\r\n			<li><a href=\"#\"> Saint Louis</a></li>\r\n			<li><a href=\"#\"> Saint Petersburg </a></li>\r\n			<li><a href=\"#\"> Berlin </a></li>\r\n			<li><a href=\"#\"> Moscow</a></li>\r\n			<li><a href=\"#\"> Sydney </a></li>\r\n</ul>\r\n',1,'bottom2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(154,'Tools','','<ul>\r\n			<li><a href=\"#\"> iPad App</a></li>\r\n			<li><a href=\"#\"> Register</a></li>\r\n			<li><a href=\"#\"> Sign In</a></li>\r\n			<li><a href=\"#\"> Blogs</a></li>\r\n			<li><a href=\"#\"> Emails & News Alerts</a></li>\r\n			<li><a href=\"#\"> Message Boards</a></li>\r\n			<li><a href=\"#\"> RSS Headlines</a></li>\r\n</ul>\r\n',1,'bottom2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(155,'Tabs','','',8,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_tabs_gk5',1,0,'{\"automatic_module_id\":\"1\",\"module_id\":\"gk-tab-1\",\"moduleclass_sfx\":\" mobilelayout noborder\",\"module_data_source\":\"tabsmanager\",\"tabs_data\":\"[{\\\"name\\\":\\\"New\\\",\\\"type\\\":\\\"module\\\",\\\"content\\\":\\\"tab1\\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"1\\\",\\\"id\\\":\\\"\\\",\\\"animation\\\":\\\"opacity\\\"},{\\\"name\\\":\\\" Hot\\\",\\\"type\\\":\\\"module\\\",\\\"content\\\":\\\"tab2\\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"1\\\",\\\"id\\\":\\\"\\\",\\\"animation\\\":\\\"default\\\"},{\\\"name\\\":\\\"Featured\\\",\\\"type\\\":\\\"module\\\",\\\"content\\\":\\\"tab3\\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"1\\\",\\\"id\\\":\\\"\\\",\\\"animation\\\":\\\"default\\\"}]\",\"external_source\":\"-1\",\"styleCSS\":\"style1\",\"module_auto_height\":\"1\",\"module_height\":\"200\",\"tabs_position\":\"top\",\"tabs_width\":\"200\",\"tabs_spans\":\"0\",\"buttons\":\"0\",\"activator\":\"click\",\"animation\":\"1\",\"animation_speed\":\"150\",\"animation_interval\":\"7500\",\"animation_type\":\"slide_horizontal\",\"animation_function\":\"Fx.Transitions.Quint.easeInOut\",\"url_tab_selection\":\"1\",\"cookie_tab_selection\":\"0\",\"parse_plugins\":\"1\",\"useCSS\":\"0\",\"useScript\":\"1\",\"engine_mode\":\"mootools\",\"include_jquery\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(156,'About Us','','<ul>\r\n			<li><a href=\"#\"> Contact Us </a></li>\r\n			<li><a href=\"#\"> Feedback </a></li>\r\n			<li><a href=\"#\"> Advertising </a></li>\r\n			<li><a href=\"#\"> Privacy Policy </a></li>\r\n			<li><a href=\"#\"> Interest-Based Ads </a></li>\r\n			<li><a href=\"#\"> Terms of Use </a></li>\r\n			<li><a href=\"#\"> Site Map </a></li>\r\n			<li><a href=\"#\"> Site Index</a> </li>\r\n			<li><a href=\"#\"> Authors List</a> </li>\r\n			<li><a href=\"#\"> News | Univision</a> </li>\r\n			<li><a href=\"#\"> Text Version</a> </li>\r\n</ul>\r\n',1,'bottom2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(157,'Follow Us','','<ul>\r\n			<li> <a href=\"http://www.facebook.com/gavickpro\" target=\"_blank\">Facebook</a></li>\r\n			<li> <a href=\"http://twitter.com/gavickpro\" target=\"_blank\">Twitter</a></li>\r\n			<li> <a href=\"https://plus.google.com/+gavickpro/posts\" target=\"_blank\">Google+</a></li>\r\n			<li> <a href=\"http://www.gavick.com/magazine/index.php?format=feed&amp;type=rss\" target=\"_blank\">RSS</a></li>\r\n			<li> <a href=\"#\">Email Newsletters</a></li>\r\n			<li> <a href=\"#\">YouTube</a></li>\r\n			<li> <a href=\"#\">NEWS. Mobile</a></li>\r\n			<li> <a href=\"#\"> NEWS. Radio News</a></li>\r\n			<li> <a href=\"#\"> NEWS. Local</a></li>\r\n</ul>\r\n',1,'bottom2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(158,'NSP Header','','',1,'mainbody_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,0,'{\"moduleclass_sfx\":\" nsp clear light header\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"all_k2_articles\",\"com_articles\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_amount\":\"10\",\"news_portal_mode_7_width\":\"265\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"words\",\"title_limit\":\"17\",\"news_content_image_pos\":\"center\",\"news_content_image_float\":\"none\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"250\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F j, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 12px 0 0 \",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"4\",\"news_text_enabled\":\"1\",\"news_info_order\":\"3\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"4\",\"links_amount\":\"5\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"pagination\",\"links_margin\":\"0\",\"links_position\":\"right\",\"links_width\":\"40\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"80\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"40\",\"responsive_images\":\"1\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"460\",\"img_height\":\"400\",\"img_margin\":\"0 0 20px\",\"img_bg\":\"#fff\",\"img_stretch\":\"0\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(159,'NSP GK4 suffix \" nsp\" (2)','','',1,'mainbody_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"com_all_articles\",\"com_articles\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_portal_mode_5_amount\":\"10\",\"news_full_pages\":\"3\",\"news_column\":\"2\",\"news_rows\":\"2\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"17\",\"news_content_image_pos\":\"center\",\"news_content_image_float\":\"none\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE %CATEGORY\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y H:i\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"4px 16px 0 0 \",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"2\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"0\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"0\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"120\",\"img_height\":\"80\",\"img_margin\":\"0 0 20px\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(160,'All stories','','',1,'inset',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp color\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"all_k2_articles\",\"com_articles\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"1\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_portal_mode_5_amount\":\"10\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"4\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"40\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F d, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"20px 0 \",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"0\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"3\",\"links_amount\":\"0\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"1\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"80\",\"img_height\":\"68\",\"img_margin\":\"0 10px 0 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"80\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"13\",\"simple_crop_right\":\"13\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(161,'Breaking News','','',3,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"all_k2_articles\",\"com_articles\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"ASC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_portal_mode_5_amount\":\"10\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"4\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"45\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F d, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"20px 0 \",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"0\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"3\",\"links_amount\":\"0\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"1\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"80\",\"img_height\":\"68\",\"img_margin\":\"0 10px 0 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"80\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"15\",\"simple_crop_right\":\"15\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(162,'Videos Tab','','',1,'tab1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp mobilelayout\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"all_k2_articles\",\"com_articles\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_amount\":\"10\",\"news_portal_mode_7_width\":\"265\",\"news_full_pages\":\"1\",\"news_column\":\"4\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"20\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"50\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F d, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 6px 0 0 \",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"3\",\"links_amount\":\"0\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"200\",\"img_height\":\"120\",\"img_margin\":\"0 0 10px 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"80\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(163,'More News Tab','','',1,'tab2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp mobilelayout\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"all_k2_articles\",\"com_articles\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"random\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_amount\":\"10\",\"news_portal_mode_7_width\":\"265\",\"news_full_pages\":\"1\",\"news_column\":\"4\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"20\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"50\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F d, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 6px 0 0 \",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"3\",\"links_amount\":\"0\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"200\",\"img_height\":\"120\",\"img_margin\":\"0 0 10px 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"80\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(164,'Featured Tab','','',1,'tab3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp mobilelayout\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"all_k2_articles\",\"com_articles\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"fordering\",\"news_sort_order\":\"ASC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_amount\":\"10\",\"news_portal_mode_7_width\":\"265\",\"news_full_pages\":\"1\",\"news_column\":\"4\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"20\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"50\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F d, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 6px 0 0 \",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"3\",\"links_amount\":\"0\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"200\",\"img_height\":\"120\",\"img_margin\":\"0 0 10px 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"80\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(165,'Other Top Stories Tab','','',1,'tab4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp mobilelayout\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"all_k2_articles\",\"com_articles\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"ASC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_amount\":\"10\",\"news_portal_mode_7_width\":\"265\",\"news_full_pages\":\"1\",\"news_column\":\"4\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"20\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"50\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F d, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 6px 0 0 \",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"3\",\"links_amount\":\"0\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"200\",\"img_height\":\"120\",\"img_margin\":\"0 0 10px 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"80\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(166,'Top Stories','','',1,'inset',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" arrow badge-top\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"k2_articles\",\"com_articles\":\"\",\"k2_articles\":\"9,53,52,51\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_portal_mode_5_amount\":\"10\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"40\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F d, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"20px 0 5px 0\",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"0\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"1\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"210\",\"img_height\":\"128\",\"img_margin\":\"0 0 20px 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"80\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(167,'Latest News','','',1,'mainbody',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp bigtitle mobilelayout\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"k2_categories\",\"com_articles\":\"\",\"k2_categories\":[\"4\",\"1\"],\"k2_articles\":\"9,53,52,51\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_amount\":\"10\",\"news_portal_mode_7_width\":\"265\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"4\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"28\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d F, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"26px 0 \",\"news_header_order\":\"3\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"4\",\"news_text_enabled\":\"1\",\"news_info_order\":\"2\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"3\",\"links_amount\":\"0\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"1\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"170\",\"img_height\":\"100\",\"img_margin\":\"0 20px 0 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"80\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(168,'More headlines','','',1,'inner_inset',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp headlines\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"all_k2_articles\",\"com_articles\":\"\",\"k2_categories\":[\"4\",\"1\"],\"k2_articles\":\"9,53,52,51\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_amount\":\"10\",\"news_portal_mode_7_width\":\"265\",\"news_full_pages\":\"0\",\"news_column\":\"1\",\"news_rows\":\"0\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"40\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F d, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"20px 0 \",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"0\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"4\",\"links_amount\":\"7\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"pagination\",\"links_margin\":\"0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"0\",\"list_title_limit_type\":\"words\",\"list_title_limit\":\"5\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"1\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"80\",\"img_height\":\"60\",\"img_margin\":\"0 10px 0 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(170,'iReports','','',5,'inset',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp arrow color bigtitle \",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"all_k2_articles\",\"com_articles\":\"\",\"k2_categories\":[\"4\",\"1\"],\"k2_articles\":\"9,53,52,51\",\"news_sort_value\":\"created\",\"news_sort_order\":\"ASC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_portal_mode_5_amount\":\"10\",\"news_full_pages\":\"0\",\"news_column\":\"2\",\"news_rows\":\"0\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"40\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"null\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"null\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"null\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F d, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"20px 0  \",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"0\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"1\",\"links_amount\":\"8\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"pagination\",\"links_margin\":\"26px 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"50\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"35\",\"responsive_images\":\"1\",\"wrap_content\":\"1\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"80\",\"img_height\":\"60\",\"img_margin\":\"0 10px 0 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(171,'Suffix \" pattern\"','','<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Donec id elit non mi porta gravida at eget metus.</p>\r\n<ul>\r\n<li><a href=\"#\">Maecenas faucibus</a></li>\r\n<li><a href=\"#\">Vivamus sagittis.</a></li>\r\n<li><a href=\"#\">Praesent commodo.</a></li>\r\n</ul>',7,'inset',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" pattern\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(172,'Sports tab','','',1,'tab5',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp mobilelayout\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"k2_articles\",\"com_articles\":\"\",\"k2_articles\":\"14,16,17,45\",\"news_sort_value\":\"created\",\"news_sort_order\":\"ASC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_amount\":\"10\",\"news_portal_mode_7_width\":\"265\",\"news_full_pages\":\"1\",\"news_column\":\"4\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"20\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"50\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F d, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 6px 0 0 \",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"3\",\"links_amount\":\"0\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"200\",\"img_height\":\"120\",\"img_margin\":\"0 0 10px 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"80\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(173,'More News','','',1,'mainbody_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp bigtitle nsphover\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"k2_articles\",\"com_articles\":\"\",\"k2_categories\":[\"4\",\"1\"],\"k2_articles\":\"44,48,38,36\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_portal_mode_5_amount\":\"10\",\"news_full_pages\":\"1\",\"news_column\":\"2\",\"news_rows\":\"2\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"50\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE | %HITS\",\"info2_format\":\"%CATEGORY\",\"category_link\":\"1\",\"date_format\":\"d F, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 15px 12px 15px \",\"news_header_order\":\"3\",\"news_header_enabled\":\"1\",\"news_image_order\":\"2\",\"news_image_enabled\":\"1\",\"news_text_order\":\"5\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"1\",\"news_info2_enabled\":\"1\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"3\",\"links_amount\":\"0\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"320\",\"img_height\":\"180\",\"img_margin\":\"0 0 20px 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"80\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(174,'Suffix \" bigtitle\"','','<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Donec id elit non mi porta gravida at eget metus.</p>\r\n<ul>\r\n<li><a href=\"#\">Maecenas faucibus</a></li>\r\n<li><a href=\"#\">Vivamus sagittis.</a></li>\r\n<li><a href=\"#\">Praesent commodo.</a></li>\r\n</ul>',7,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" bigtitle\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(175,'Top banner','','',1,'bannertop',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp color \",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"Portal_Mode_7\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"all_k2_articles\",\"com_categories\":[\"2\",\"15\",\"16\",\"17\"],\"com_articles\":\"\",\"k2_categories\":[\"1\",\"5\"],\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"1\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_amount\":\"10\",\"news_portal_mode_7_width\":\"227\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"4\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"null\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"35\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"null\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"25\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F d, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"15px 18px \",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"3\",\"links_amount\":\"0\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"0\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"60\",\"img_height\":\"60\",\"img_margin\":\"0 16px 0 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"0\",\"img_quality\":\"75\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"13\",\"simple_crop_right\":\"13\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(176,'Calendar','','',9,'inset',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_k2_tools',1,1,'{\"moduleclass_sfx\":\"\",\"module_usage\":\"2\",\"archiveItemsCounter\":\"1\",\"archiveCategory\":\"0\",\"authors_module_category\":\"0\",\"authorItemsCounter\":\"1\",\"authorAvatar\":\"1\",\"authorAvatarWidthSelect\":\"custom\",\"authorAvatarWidth\":\"50\",\"authorLatestItem\":\"1\",\"calendarCategory\":\"0\",\"home\":\"\",\"seperator\":\"\",\"root_id\":\"0\",\"end_level\":\"\",\"categoriesListOrdering\":\"\",\"categoriesListItemsCounter\":\"1\",\"root_id2\":\"0\",\"catfilter\":\"0\",\"getChildren\":\"0\",\"liveSearch\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"imagebutton\":\"\",\"button_text\":\"\",\"min_size\":\"75\",\"max_size\":\"300\",\"cloud_limit\":\"30\",\"cloud_category\":[\"0\"],\"cloud_category_recursive\":\"0\",\"customCode\":\"\",\"parsePhp\":\"0\",\"K2Plugins\":\"0\",\"JPlugins\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(177,'News Gallery','','',11,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp gallery badge-gallery\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"all_k2_articles\",\"com_articles\":\"\",\"k2_categories\":[\"4\",\"1\"],\"k2_articles\":\"44,48,38,36\",\"news_sort_value\":\"created\",\"news_sort_order\":\"ASC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_portal_mode_5_amount\":\"10\",\"news_full_pages\":\"1\",\"news_column\":\"3\",\"news_rows\":\"4\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"45\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"null\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"null\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"null\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F d, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"6px 3px 0\",\"news_header_order\":\"2\",\"news_header_enabled\":\"0\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"0\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"3\",\"links_amount\":\"0\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"none\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"1\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"80\",\"img_height\":\"60\",\"img_margin\":\"0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"80\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"15\",\"simple_crop_right\":\"15\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(178,'Most Popular','','',9,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp badge-popular\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"all_k2_articles\",\"com_articles\":\"\",\"k2_categories\":[\"4\",\"1\"],\"k2_articles\":\"44,48,38,36\",\"news_sort_value\":\"hits\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_portal_mode_5_amount\":\"10\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"words\",\"title_limit\":\"7\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F d, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"20px 0 0\",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"0\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"1\",\"links_amount\":\"4\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"0\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"230\",\"img_height\":\"128\",\"img_margin\":\"0 0 20px\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"80\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(179,'Last Week','','',13,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp arrow pattern badge-video\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"all_k2_articles\",\"com_articles\":\"\",\"k2_categories\":[\"4\",\"1\"],\"k2_articles\":\"44,48,38,36\",\"news_sort_value\":\"created\",\"news_sort_order\":\"ASC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_portal_mode_5_amount\":\"10\",\"news_full_pages\":\"0\",\"news_column\":\"2\",\"news_rows\":\"0\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"40\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"null\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"null\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"null\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F d, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"20px 0 \",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"0\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"1\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"pagination\",\"links_margin\":\"26px 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"50\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"35\",\"responsive_images\":\"1\",\"wrap_content\":\"1\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"80\",\"img_height\":\"60\",\"img_margin\":\"0 10px 0 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(180,'Module on menu','','',1,'menu1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"k2_articles\",\"com_articles\":\"\",\"k2_articles\":\"9,51,52,53\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_portal_mode_5_amount\":\"10\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"40\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F d, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"20px 0 5px 0\",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"0\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"0\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"210\",\"img_height\":\"128\",\"img_margin\":\"0 0 20px 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"80\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(181,'badge-new','','<p>Nullam quis risus eget urna mollis ornare vel eu leo. Curabitur blandit tempus porttitor. Maecenas sed diam eget risus varius blandit sit amet non magna. Aenean eu leo quam.</p>',1,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" badge-new\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(182,'badge-hot','','<p>Nullam quis risus eget urna mollis ornare vel eu leo. Curabitur blandit tempus porttitor. Maecenas sed diam eget risus varius blandit sit amet non magna. Aenean eu leo quam.</p>',2,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" badge-hot\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(183,'badge-top','','<p>Nullam quis risus eget urna mollis ornare vel eu leo. Curabitur blandit tempus porttitor. Maecenas sed diam eget risus varius blandit sit amet non magna. Aenean eu leo quam.</p>',2,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" badge-top\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(184,'badge-popular','','<p>Nullam quis risus eget urna mollis ornare vel eu leo. Curabitur blandit tempus porttitor. Maecenas sed diam eget risus varius blandit sit amet non magna. Aenean eu leo quam.</p>',2,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" badge-popular\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(185,'What\'s hot','','',3,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp headlines\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"k2_articles\",\"com_articles\":\"\",\"k2_articles\":\"1,2,16,11\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_amount\":\"10\",\"news_portal_mode_7_width\":\"265\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"4\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"27\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F d, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"12px 0\",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"0\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"3\",\"links_amount\":\"0\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"1\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"80\",\"img_height\":\"68\",\"img_margin\":\"0 10px 0 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"15\",\"simple_crop_right\":\"15\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(186,'Featured News','','',1,'mainbody_bottom',572,'2013-02-05 12:07:51','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp bigtitle nsphover\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"k2_articles\",\"com_articles\":\"\",\"k2_articles\":\"6,16,10,20\",\"news_sort_value\":\"hits\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_amount\":\"10\",\"news_portal_mode_7_width\":\"265\",\"news_full_pages\":\"1\",\"news_column\":\"2\",\"news_rows\":\"2\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"30\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"90\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"%CATEGORY\",\"category_link\":\"1\",\"date_format\":\"d F, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 3px\",\"news_header_order\":\"3\",\"news_header_enabled\":\"1\",\"news_image_order\":\"2\",\"news_image_enabled\":\"1\",\"news_text_order\":\"5\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"1\",\"news_info2_enabled\":\"1\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"3\",\"links_amount\":\"0\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"400\",\"img_height\":\"280\",\"img_margin\":\"0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"10\",\"simple_crop_right\":\"10\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(187,'Suffix \" bigtitle\"','','<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. </p>\r\n<ul>\r\n<li><a href=\"#\">Maecenas faucibus</a></li>\r\n<li><a href=\"#\">Vivamus sagittis.</a></li>\r\n<li><a href=\"#\">Praesent commodo.</a></li>\r\n</ul>',7,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" bigtitle\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(188,'Most Popular','','',1,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp light badge-popular\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"all_k2_articles\",\"com_articles\":\"\",\"k2_articles\":\"1,2,16,11\",\"news_sort_value\":\"hits\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_amount\":\"10\",\"news_portal_mode_7_width\":\"265\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"words\",\"title_limit\":\"7\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F d, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"20px 0 0\",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"0\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"1\",\"links_amount\":\"2\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"0\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"50\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"230\",\"img_height\":\"128\",\"img_margin\":\"0 0 20px\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(189,'badge-new','','<p>Nullam quis risus eget urna mollis ornare vel eu leo. Curabitur blandit tempus porttitor. Maecenas sed diam eget risus varius blandit sit amet non magna. Aenean eu leo quam.</p>',1,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" badge-new\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(190,'badge-hot','','<p>Nullam quis risus eget urna mollis ornare vel eu leo. Curabitur blandit tempus porttitor. Maecenas sed diam eget risus varius blandit sit amet non magna. Aenean eu leo quam.</p>',1,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" badge-hot\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(191,'badge-popular','','<p>Nullam quis risus eget urna mollis ornare vel eu leo. Curabitur blandit tempus porttitor. Maecenas sed diam eget risus varius blandit sit amet non magna. Aenean eu leo quam.</p>',1,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" badge-popular\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(192,'badge-top','','<p>Nullam quis risus eget urna mollis ornare vel eu leo. Curabitur blandit tempus porttitor. Maecenas sed diam eget risus varius blandit sit amet non magna. Aenean eu leo quam.</p>',1,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" badge-top\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(193,'Tabs GK5','','',1,'mainbody_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_tabs_gk5',1,1,'{\"automatic_module_id\":\"1\",\"module_id\":\"gk-tab-1\",\"moduleclass_sfx\":\"\",\"module_data_source\":\"tabsmanager\",\"tabs_data\":\"[{\\\"name\\\":\\\"Lorem\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"[leftbracket]p[rightbracket]Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Sed posuere consectetur est at lobortis. Nullam id dolor id nibh ultricies vehicula ut id elit. Cras mattis consectetur purus sit amet fermentum.[leftbracket]\\/p[rightbracket]\\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"1\\\",\\\"id\\\":\\\"\\\",\\\"animation\\\":\\\"slide_horizontal\\\"},{\\\"name\\\":\\\"Ipsum\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"[leftbracket]p[rightbracket]Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Sed posuere consectetur est at lobortis. Nullam id dolor id nibh ultricies vehicula ut id elit. Cras mattis consectetur purus sit amet fermentum.[leftbracket]\\/p[rightbracket]\\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"1\\\",\\\"id\\\":\\\"\\\",\\\"animation\\\":\\\"slide_horizontal\\\"},{\\\"name\\\":\\\"Dolor\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. [leftbracket]p[rightbracket]Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Sed posuere consectetur est at lobortis. Nullam id dolor id nibh ultricies vehicula ut id elit. Cras mattis consectetur purus sit amet fermentum.[leftbracket]\\/p[rightbracket]\\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"1\\\",\\\"id\\\":\\\"\\\",\\\"animation\\\":\\\"slide_horizontal\\\"}]\",\"external_source\":\"-1\",\"styleCSS\":\"style1\",\"module_auto_height\":\"1\",\"module_height\":\"200\",\"tabs_position\":\"top\",\"tabs_width\":\"200\",\"tabs_spans\":\"0\",\"buttons\":\"1\",\"activator\":\"click\",\"animation\":\"1\",\"animation_speed\":\"250\",\"animation_interval\":\"5000\",\"animation_type\":\"opacity\",\"animation_function\":\"Fx.Transitions.linear\",\"url_tab_selection\":\"1\",\"cookie_tab_selection\":\"0\",\"parse_plugins\":\"1\",\"useCSS\":\"0\",\"useScript\":\"1\",\"engine_mode\":\"mootools\",\"include_jquery\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(194,'Banner','','<p><em>Put your banner here ...</em></p>',1,'bannertop',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(195,'Hot','','',1,'tab2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp headlines\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"all_k2_articles\",\"com_articles\":\"\",\"k2_articles\":\"1,2,16,11\",\"news_sort_value\":\"ordering\",\"news_sort_order\":\"ASC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_amount\":\"10\",\"news_portal_mode_7_width\":\"265\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"4\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"25\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F d, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"12px 0\",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"0\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"3\",\"links_amount\":\"0\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"1\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"80\",\"img_height\":\"68\",\"img_margin\":\"0 10px 0 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"80\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"15\",\"simple_crop_right\":\"15\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(196,'New','','',1,'tab1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp headlines\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"all_k2_articles\",\"com_articles\":\"\",\"k2_articles\":\"1,2,16,11\",\"news_sort_value\":\"created\",\"news_sort_order\":\"ASC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_amount\":\"10\",\"news_portal_mode_7_width\":\"265\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"4\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"25\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F d, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"12px 0\",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"0\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"3\",\"links_amount\":\"0\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"1\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"80\",\"img_height\":\"68\",\"img_margin\":\"0 10px 0 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"80\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"15\",\"simple_crop_right\":\"15\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(197,'Popular','','',1,'tab3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp headlines\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"all_k2_articles\",\"com_articles\":\"\",\"k2_articles\":\"1,2,16,11\",\"news_sort_value\":\"hits\",\"news_sort_order\":\"ASC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_amount\":\"10\",\"news_portal_mode_7_width\":\"265\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"4\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"25\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F d, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"12px 0\",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"0\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"3\",\"links_amount\":\"0\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"1\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"80\",\"img_height\":\"68\",\"img_margin\":\"0 10px 0 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"80\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"15\",\"simple_crop_right\":\"15\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*');


--
-- Table structure for table `#__modules_menu`
--



CREATE TABLE `#__modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`moduleid`,`menuid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__modules_menu`
--


INSERT INTO `#__modules_menu` (`moduleid`, `menuid`) VALUES (1,0),(2,0),(3,0),(4,0),(6,0),(7,0),(8,0),(9,0),(10,0),(12,0),(13,0),(14,0),(15,0),(16,0),(17,-101),(79,0),(86,0),(88,101),(89,120),(89,133),(89,134),(89,159),(89,160),(89,161),(89,164),(89,165),(89,166),(89,167),(89,168),(91,120),(91,133),(91,134),(91,159),(91,160),(91,161),(91,164),(91,165),(91,166),(91,167),(91,168),(96,0),(97,101),(98,101),(99,101),(100,101),(101,101),(102,0),(103,119),(104,119),(105,119),(106,119),(107,119),(108,119),(109,119),(110,119),(111,120),(111,133),(111,134),(111,159),(111,160),(111,161),(111,164),(111,165),(111,166),(111,167),(111,168),(112,119),(113,119),(114,120),(114,133),(114,134),(114,159),(114,160),(114,161),(114,164),(114,165),(114,166),(114,168),(115,119),(116,119),(117,119),(118,119),(119,119),(120,119),(121,119),(122,119),(123,119),(124,119),(125,-101),(126,0),(127,119),(128,0),(129,0),(130,119),(131,119),(132,133),(132,134),(132,159),(132,160),(132,161),(132,164),(132,165),(132,166),(132,167),(133,119),(134,119),(135,119),(136,119),(137,119),(138,133),(138,134),(138,159),(138,160),(138,161),(138,164),(138,165),(138,166),(138,167),(139,133),(139,134),(139,159),(139,160),(139,161),(139,164),(139,165),(139,166),(139,167),(140,0),(141,0),(142,0),(143,0),(144,0),(145,119),(146,119),(147,0),(148,0),(149,133),(149,134),(149,159),(149,160),(149,161),(149,164),(149,165),(149,166),(149,167),(150,0),(151,0),(152,0),(153,0),(154,0),(155,120),(156,0),(157,0),(158,101),(159,119),(160,101),(161,101),(162,0),(163,0),(164,0),(165,0),(166,101),(167,101),(168,101),(170,101),(171,119),(172,0),(173,101),(174,119),(175,0),(176,-255),(176,-162),(176,-121),(176,-119),(176,-117),(177,101),(178,101),(178,120),(178,133),(178,134),(178,159),(178,160),(178,161),(178,164),(178,165),(178,166),(178,167),(178,168),(178,251),(178,252),(178,253),(178,254),(179,101),(180,0),(181,119),(182,119),(183,119),(184,119),(185,120),(186,120),(187,119),(188,120),(188,160),(188,161),(189,119),(190,119),(191,119),(192,119),(193,119),(194,0),(195,0),(196,0),(197,0);


--
-- Table structure for table `#__newsfeeds`
--



CREATE TABLE `#__newsfeeds` (
  `catid` int(11) NOT NULL DEFAULT '0',
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `link` varchar(200) NOT NULL DEFAULT '',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `numarticles` int(10) unsigned NOT NULL DEFAULT '1',
  `cache_time` int(10) unsigned NOT NULL DEFAULT '3600',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rtl` tinyint(4) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `description` text NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `images` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__newsfeeds`
--


INSERT INTO `#__newsfeeds` (`catid`, `id`, `name`, `alias`, `link`, `published`, `numarticles`, `cache_time`, `checked_out`, `checked_out_time`, `ordering`, `rtl`, `access`, `language`, `params`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `xreference`, `publish_up`, `publish_down`, `description`, `version`, `hits`, `images`) VALUES (11,1,'GavickPro News','gavickpro-news','http://www.gavick.com/magazine/?format=feed&type=rss',1,5,3600,572,'2013-02-05 14:14:02',1,0,1,'*','{\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"newsfeed_layout\":\"\",\"feed_display_order\":\"\"}','2012-11-06 11:27:56',381,'','2013-02-05 14:14:02',572,'','','{\"robots\":\"\",\"rights\":\"\"}','','0000-00-00 00:00:00','0000-00-00 00:00:00','',4,0,'{\"image_first\":\"\",\"float_first\":\"\",\"image_first_alt\":\"\",\"image_first_caption\":\"\",\"image_second\":\"\",\"float_second\":\"\",\"image_second_alt\":\"\",\"image_second_caption\":\"\"}');


--
-- Table structure for table `#__overrider`
--



CREATE TABLE `#__overrider` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `constant` varchar(255) NOT NULL,
  `string` text NOT NULL,
  `file` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__overrider`
--




--
-- Table structure for table `#__redirect_links`
--



CREATE TABLE `#__redirect_links` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `old_url` varchar(255) NOT NULL,
  `new_url` varchar(255) NOT NULL,
  `referer` varchar(150) NOT NULL,
  `comment` varchar(255) NOT NULL,
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(4) NOT NULL,
  `created_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_link_old` (`old_url`),
  KEY `idx_link_modifed` (`modified_date`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__redirect_links`
--


INSERT INTO `#__redirect_links` (`id`, `old_url`, `new_url`, `referer`, `comment`, `hits`, `published`, `created_date`, `modified_date`) VALUES (1,'http://project.gavick.com/_updates/joomla30/startup/?option=non-existing-component','','http://project.gavick.com/_updates/joomla30/startup/index.php/template/articles/archived-articles','',1,0,'2012-11-06 14:40:45','0000-00-00 00:00:00'),(2,'http://project.gavick.com/_updates/joomla30/news/index.php/k2/tag','','http://project.gavick.com/_updates/joomla30/news/','',2,0,'2013-01-02 20:53:49','0000-00-00 00:00:00'),(3,'http://project.gavick.com/_updates/joomla30/news/?option=non-existing-component','','http://project.gavick.com/_updates/joomla30/news/index.php/template/articles/archived-articles/by-title','',2,0,'2013-01-03 11:27:00','0000-00-00 00:00:00'),(4,'http://project.gavick.com/_updates/joomla30/magazine/index.php/k2/k2-categories?format=feed','','http://project.gavick.com/_updates/joomla30/magazine/','',1,0,'2013-02-05 12:29:37','0000-00-00 00:00:00');


--
-- Table structure for table `#__schemas`
--



CREATE TABLE `#__schemas` (
  `extension_id` int(11) NOT NULL,
  `version_id` varchar(20) NOT NULL,
  PRIMARY KEY (`extension_id`,`version_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__schemas`
--





--
-- Table structure for table `#__session`
--



CREATE TABLE `#__session` (
  `session_id` varchar(200) NOT NULL DEFAULT '',
  `client_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `guest` tinyint(4) unsigned DEFAULT '1',
  `time` varchar(14) DEFAULT '',
  `data` mediumtext,
  `userid` int(11) DEFAULT '0',
  `username` varchar(150) DEFAULT '',
  PRIMARY KEY (`session_id`),
  KEY `userid` (`userid`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__session`
--


INSERT INTO `#__session` (`session_id`, `client_id`, `guest`, `time`, `data`, `userid`, `username`) VALUES ('f800fef74e42b34c91b5874a63c95e94',0,1,'1360670228','__default|a:9:{s:15:\"session.counter\";i:6;s:19:\"session.timer.start\";i:1360668197;s:18:\"session.timer.last\";i:1360669621;s:17:\"session.timer.now\";i:1360670227;s:22:\"session.client.browser\";s:119:\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_8_2) AppleWebKit/537.17 (KHTML, like Gecko) Chrome/24.0.1312.57 Safari/537.17\";s:8:\"registry\";O:9:\"JRegistry\":1:{s:7:\"\\0\\0\\0data\";O:8:\"stdClass\":0:{}}s:4:\"user\";O:5:\"JUser\":25:{s:9:\"\\0\\0\\0isRoot\";b:0;s:2:\"id\";i:0;s:4:\"name\";N;s:8:\"username\";N;s:5:\"email\";N;s:8:\"password\";N;s:14:\"password_clear\";s:0:\"\";s:5:\"block\";N;s:9:\"sendEmail\";i:0;s:12:\"registerDate\";N;s:13:\"lastvisitDate\";N;s:10:\"activation\";N;s:6:\"params\";N;s:6:\"groups\";a:1:{i:0;s:1:\"9\";}s:5:\"guest\";i:1;s:13:\"lastResetTime\";N;s:10:\"resetCount\";N;s:10:\"\\0\\0\\0_params\";O:9:\"JRegistry\":1:{s:7:\"\\0\\0\\0data\";O:8:\"stdClass\":0:{}}s:14:\"\\0\\0\\0_authGroups\";a:2:{i:0;i:1;i:1;i:9;}s:14:\"\\0\\0\\0_authLevels\";a:3:{i:0;i:1;i:1;i:1;i:2;i:5;}s:15:\"\\0\\0\\0_authActions\";N;s:12:\"\\0\\0\\0_errorMsg\";N;s:10:\"\\0\\0\\0_errors\";a:0:{}s:3:\"aid\";i:0;s:3:\"gid\";i:1;}s:13:\"session.token\";s:32:\"c1f8f7185af6ee7cabb568bc8a89a268\";s:16:\"com_mailto.links\";a:1:{s:40:\"2e07bc9b3bec132f8cf56bbc20e97775c7f2f597\";O:8:\"stdClass\":2:{s:4:\"link\";s:86:\"http://project.gavick.com/_updates/joomla30/clean_demo/magazine/index.php/home/k2-item\";s:6:\"expiry\";i:1360670227;}}}',0,'');


--
-- Table structure for table `#__template_styles`
--



CREATE TABLE `#__template_styles` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `template` varchar(50) NOT NULL DEFAULT '',
  `client_id` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `home` char(7) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_template` (`template`),
  KEY `idx_home` (`home`)
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__template_styles`
--


INSERT INTO `#__template_styles` (`id`, `template`, `client_id`, `home`, `title`, `params`) VALUES (4,'beez3',0,'0','Beez3 - Default','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"logo\":\"images\\/joomla_black.gif\",\"sitetitle\":\"Joomla!\",\"sitedescription\":\"Open Source Content Management\",\"navposition\":\"left\",\"templatecolor\":\"personal\",\"html5\":\"0\"}'),(5,'hathor',1,'0','Hathor - Default','{\"showSiteName\":\"0\",\"colourChoice\":\"\",\"boldText\":\"0\"}'),(7,'protostar',0,'0','protostar - Default','{\"templateColor\":\"\",\"logoFile\":\"\",\"googleFont\":\"1\",\"googleFontName\":\"Open+Sans\",\"fluidContainer\":\"0\"}'),(8,'isis',1,'1','isis - Default','{\"templateColor\":\"\",\"logoFile\":\"\"}'),(10,'gk_news',0,'0','gk_news - Default','{\"template_color\":\"5\",\"default_layout\":\"default\",\"layout_override\":\"\",\"template_width\":\"1230\",\"tablet_width\":\"1030\",\"tablet_small_width\":\"820\",\"mobile_width\":\"580\",\"sidebar_position\":\"right\",\"sidebar_width\":\"22\",\"sidebar_width_for_pages\":\"\",\"inset_position\":\"right\",\"inset_width\":\"27\",\"inset_width_for_pages\":\"\",\"inner_inset_position\":\"right\",\"inner_inset_width\":\"24\",\"inner_inset_width_for_pages\":\"\",\"font_name_group1\":\"standard;Arial, Helvetica, sans-serif\",\"font_rules_group1\":\"body,\\r\\nh1, h2, h3, h4, h5, h6,\\r\\n.box .header small,\\r\\ndl#tabs dt.tabs span h3, \\r\\ndl.tabs dt.tabs span h3,\\r\\n.gkMenu > ul > li li,\\r\\n.bigtitle h3.header,\\r\\n.box.badge-new .header::after,\\r\\n.box.badge-popular .header::after,\\r\\n.box.badge-top .header::after\",\"font_name_group2\":\"google;own;http:\\/\\/fonts.googleapis.com\\/css?family=Hammersmith+One;Hammersmith One\",\"font_rules_group2\":\"#gkLogo.text,\\r\\n.gkMenu > ul > li,\\r\\n#gkTopMenu,\\r\\n#gkUserArea,\\r\\n.box .header,\\r\\n.itemAuthorContent h3,\\r\\n.gkTabsNav,\\r\\nth,\\r\\n.nsphover .nspInfo2\",\"font_name_group3\":\"standard;Verdana, Geneva, sans-serif\",\"font_rules_group3\":\".blank\",\"font_name_group4\":\"standard;Arial, Helvetica, sans-serif\",\"font_rules_group4\":\".blank\",\"login_url\":\"index.php?option=com_users&view=login\",\"rss_link\":\"1\",\"rss_url\":\"#\",\"logo_type\":\"css\",\"logo_image\":\"\",\"logo_text\":\"News\",\"logo_slogan\":\"News Template\",\"print_logo\":\"\",\"print_behaviour\":\"nothing\",\"favicon_image\":\"\",\"stylearea\":\"1\",\"framework_logo\":\"1\",\"copyrights\":\"Template Design &copy; <a href=\\\"http:\\/\\/www.gavick.com\\\" title=\\\"Joomla Templates\\\">Joomla Templates<\\/a> GavickPro. All rights reserved.\",\"webmaster_contact_type\":\"email\",\"webmaster_contact\":\"webmaster@gavick.com\",\"typography\":\"1\",\"typo_iconset\":\"1\",\"google_analytics\":\"\",\"tools\":\"none\",\"tools_for_pages\":\"com_k2=enabled\\r\\n101=enabled\\r\\n\",\"mootools_for_pages\":\"\",\"suffix_override\":\"\",\"module_override\":\"\",\"show_menu\":\"1\",\"menu_name\":\"mainmenu\",\"startlevel\":\"0\",\"endlevel\":\"-1\",\"menu_animation\":\"slide_fade\",\"menu_height\":\"1\",\"menu_width\":\"1\",\"menu_col_width\":\"220\",\"menu_duration\":\"250\",\"fb_api_id\":\"171342606239806\",\"fb_lang\":\"en_US\",\"fb_login\":\"1\",\"fb_like\":\"1\",\"fb_like_send\":\"1\",\"fb_like_layout\":\"standard\",\"fb_like_show_faces\":\"true\",\"fb_like_width\":\"400\",\"fb_like_action\":\"like\",\"fb_like_font\":\"arial\",\"fb_like_colorscheme\":\"light\",\"google_plus\":\"1\",\"google_plus_count\":\"1\",\"google_plus_size\":\"medium\",\"google_plus_lang\":\"en-GB\",\"google_plus_share\":\"1\",\"google_plus_share_annotation\":\"bubble\",\"google_plus_share_size\":\"20\",\"tweet_btn\":\"1\",\"tweet_btn_data_count\":\"horizontal\",\"tweet_btn_data_via\":\"\",\"tweet_btn_data_lang\":\"en\",\"pinterest_btn\":\"1\",\"pinterest_btn_style\":\"horizontal\",\"excluded_arts\":\"\",\"excluded_cats\":[\"15\"],\"cookie_consent\":\"0\",\"consenttype\":\"explicit\",\"cookie_latest_version\":\"0\",\"cookie_use_ssl\":\"0\",\"banner_position\":\"bottom\",\"banner_tag_placement\":\"bottom-right\",\"cookie_style\":\"light\",\"refreshOnConsent\":\"0\",\"cookiecss\":\"1\",\"use_gk_cache\":\"0\",\"css_cache\":\"0\",\"css_compression\":\"0\",\"css_override\":\"0\",\"css_prefixer\":\"0\",\"js_compression\":\"0\",\"jscss_excluded\":\"\",\"css_custom\":\"\",\"chrome_frame_support\":\"0\"}'),(11,'gk_magazine',0,'1','gk_magazine - Default','{\"template_color\":\"1\",\"default_layout\":\"default\",\"layout_override\":\"\",\"layout_position\":\"left\",\"template_width\":\"1300\",\"tablet_width\":\"1030\",\"tablet_small_width\":\"820\",\"mobile_width\":\"580\",\"sidebar_position\":\"right\",\"sidebar_width\":\"24\",\"sidebar_width_for_pages\":\"\",\"inset_position\":\"left\",\"inset_width\":\"12.5\",\"inset_width_for_pages\":\"\",\"rwd\":\"1\",\"font_name_group1\":\"google;own;http:\\/\\/fonts.googleapis.com\\/css?family=Open+Sans:300,400,600,700;Open Sans\",\"font_rules_group1\":\"body,\\r\\nhtml, \\r\\nbody button, \\r\\nbody input, \\r\\nbody select, \\r\\nbody textarea\",\"font_name_group2\":\"standard;Arial, Helvetica, sans-serif\",\"font_rules_group2\":\".blank\",\"font_name_group3\":\"standard;Arial, Helvetica, sans-serif\",\"font_rules_group3\":\".blank\",\"font_name_group4\":\"standard;Arial, Helvetica, sans-serif\",\"font_rules_group4\":\".blank\",\"login_url\":\"index.php?option=com_users&view=login\",\"rss_link\":\"1\",\"rss_url\":\"index.php\\/k2\\/k2-categories?format=feed\",\"mail_link\":\"1\",\"mail_url\":\"index.php\\/joomla-pages-i\\/contacts-in-category\\/2-our-address\",\"reg_link\":\"1\",\"reg_url\":\"#\",\"logo_type\":\"css\",\"logo_image\":\"\",\"logo_text\":\"Magazine\",\"logo_slogan\":\"Blog Template\",\"print_logo\":\"\",\"print_behaviour\":\"nothing\",\"favicon_image\":\"\",\"stylearea\":\"1\",\"framework_logo\":\"0\",\"copyrights\":\"Template Design &copy; <a href=\\\"http:\\/\\/www.gavick.com\\\" title=\\\"Joomla Templates\\\">Joomla Templates<\\/a> GavickPro. All rights reserved.\",\"webmaster_contact_type\":\"email\",\"webmaster_contact\":\"webmaster@gavick.com\",\"typography\":\"1\",\"typo_iconset\":\"1\",\"google_analytics\":\"\",\"tools\":\"none\",\"tools_for_pages\":\"com_k2=enabled\\r\\n101=enabled\\r\\n\",\"mootools_for_pages\":\"\",\"suffix_override\":\"106=noMainbody\\r\\n107=noMainbody\\r\\n\",\"module_override\":\"\",\"show_menu\":\"1\",\"menu_name\":\"mainmenu\",\"menu_visible_depth\":\"2\",\"startlevel\":\"0\",\"endlevel\":\"-1\",\"menu_animation\":\"slide_fade\",\"menu_height\":\"1\",\"menu_width\":\"1\",\"menu_col_width\":\"220\",\"menu_duration\":\"250\",\"fb_api_id\":\"171342606239806\",\"fb_lang\":\"en_US\",\"fb_login\":\"1\",\"fb_like\":\"1\",\"fb_like_send\":\"1\",\"fb_like_layout\":\"standard\",\"fb_like_show_faces\":\"true\",\"fb_like_width\":\"400\",\"fb_like_action\":\"like\",\"fb_like_font\":\"arial\",\"fb_like_colorscheme\":\"light\",\"google_plus\":\"1\",\"google_plus_count\":\"1\",\"google_plus_size\":\"medium\",\"google_plus_lang\":\"en-GB\",\"google_plus_share\":\"1\",\"google_plus_share_annotation\":\"bubble\",\"google_plus_share_size\":\"20\",\"tweet_btn\":\"1\",\"tweet_btn_data_count\":\"horizontal\",\"tweet_btn_data_via\":\"\",\"tweet_btn_data_lang\":\"en\",\"pinterest_btn\":\"1\",\"pinterest_btn_style\":\"horizontal\",\"excluded_arts\":\"\",\"cookie_consent\":\"0\",\"consenttype\":\"explicit\",\"cookie_latest_version\":\"0\",\"cookie_use_ssl\":\"0\",\"banner_position\":\"bottom\",\"banner_tag_placement\":\"bottom-right\",\"cookie_style\":\"light\",\"refreshOnConsent\":\"0\",\"cookiecss\":\"1\",\"use_gk_cache\":\"0\",\"css_cache\":\"0\",\"css_compression\":\"0\",\"css_override\":\"0\",\"css_prefixer\":\"0\",\"js_compression\":\"0\",\"jscss_excluded\":\"\",\"css_custom\":\"\"}');


--
-- Table structure for table `#__update_sites`
--



CREATE TABLE `#__update_sites` (
  `update_site_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `location` text NOT NULL,
  `enabled` int(11) DEFAULT '0',
  `last_check_timestamp` bigint(20) DEFAULT '0',
  PRIMARY KEY (`update_site_id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COMMENT='Update Sites';


--
-- Dumping data for table `#__update_sites`
--


INSERT INTO `#__update_sites` (`update_site_id`, `name`, `type`, `location`, `enabled`, `last_check_timestamp`) VALUES (1,'Joomla Core','collection','http://update.joomla.org/core/list.xml',1,1360668416),(2,'Joomla Extension Directory','collection','http://update.joomla.org/jed/list.xml',1,1360668416),(3,'Accredited Joomla! Translations','collection','http://update.joomla.org/language/translationlist_3.xml',1,1360668416),(4,'K2 Updates','extension','http://getk2.org/update.xml',1,1360668416);


--
-- Table structure for table `#__update_sites_extensions`
--



CREATE TABLE `#__update_sites_extensions` (
  `update_site_id` int(11) NOT NULL DEFAULT '0',
  `extension_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`update_site_id`,`extension_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Links extensions to update sites';


--
-- Dumping data for table `#__update_sites_extensions`
--


INSERT INTO `#__update_sites_extensions` (`update_site_id`, `extension_id`) VALUES (1,700),(2,700),(3,600),(4,10003);


--
-- Table structure for table `#__updates`
--



CREATE TABLE `#__updates` (
  `update_id` int(11) NOT NULL AUTO_INCREMENT,
  `update_site_id` int(11) DEFAULT '0',
  `extension_id` int(11) DEFAULT '0',
  `name` varchar(100) DEFAULT '',
  `description` text NOT NULL,
  `element` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `folder` varchar(20) DEFAULT '',
  `client_id` tinyint(3) DEFAULT '0',
  `version` varchar(10) DEFAULT '',
  `data` text NOT NULL,
  `detailsurl` text NOT NULL,
  `infourl` text NOT NULL,
  PRIMARY KEY (`update_id`)
) ENGINE=InnoDB AUTO_INCREMENT=325 DEFAULT CHARSET=utf8 COMMENT='Available Updates';


--
-- Dumping data for table `#__updates`
--


INSERT INTO `#__updates` (`update_id`, `update_site_id`, `extension_id`, `name`, `description`, `element`, `type`, `folder`, `client_id`, `version`, `data`, `detailsurl`, `infourl`) VALUES (1,3,0,'Flemish','','pkg_nl-BE','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/nl-BE_details.xml',''),(2,3,0,'French','','pkg_fr-FR','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/fr-FR_details.xml',''),(3,3,0,'Galician','','pkg_gl-ES','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/gl-ES_details.xml',''),(4,3,0,'German','','pkg_de-DE','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/de-DE_details.xml',''),(5,3,0,'Hebrew','','pkg_he-IL','package','',0,'3.0.1.1','','http://update.joomla.org/language/details3/he-IL_details.xml',''),(6,3,0,'Hungarian','','pkg_hu-HU','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/hu-HU_details.xml',''),(7,3,0,'Arabic Unitag','','pkg_ar-AA','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/ar-AA_details.xml',''),(8,3,0,'Belarusian','','pkg_be-BY','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/be-BY_details.xml',''),(9,3,0,'Bulgarian','','pkg_bg-BG','package','',0,'3.0.0.1','','http://update.joomla.org/language/details3/bg-BG_details.xml',''),(10,3,0,'Chinese Simplified','','pkg_zh-CN','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/zh-CN_details.xml',''),(11,3,0,'Chinese-Traditional','','pkg_zh-TW','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/zh-TW_details.xml',''),(12,3,0,'Croatian','','pkg_hr-HR','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/hr-HR_details.xml',''),(13,3,0,'Danish','','pkg_da-DK','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/da-DK_details.xml',''),(14,3,0,'Dutch','','pkg_nl-NL','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/nl-NL_details.xml',''),(15,3,0,'English AU','','pkg_en-AU','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/en-AU_details.xml',''),(16,3,0,'English US','','pkg_en-US','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/en-US_details.xml',''),(17,3,0,'Estonian','','pkg_et-EE','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/et-EE_details.xml',''),(18,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(19,3,0,'Japanese','','pkg_ja-JP','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/ja-JP_details.xml',''),(20,3,0,'Korean','','pkg_ko-KR','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/ko-KR_details.xml',''),(21,3,0,'Kurdish Sorani','','pkg_ckb-IQ','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/ckb-IQ_details.xml',''),(22,3,0,'Latvian','','pkg_lv-LV','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/lv-LV_details.xml',''),(23,3,0,'Macedonian','','pkg_mk-MK','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/mk-MK_details.xml',''),(24,3,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/nb-NO_details.xml',''),(25,3,0,'Persian','','pkg_fa-IR','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/fa-IR_details.xml',''),(26,3,0,'Polish','','pkg_pl-PL','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/pl-PL_details.xml',''),(27,3,0,'Russian','','pkg_ru-RU','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/ru-RU_details.xml',''),(28,3,0,'Slovak','','pkg_sk-SK','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/sk-SK_details.xml',''),(29,3,0,'Swedish','','pkg_sv-SE','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/sv-SE_details.xml',''),(30,3,0,'Syriac','','pkg_sy-IQ','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/sy-IQ_details.xml',''),(31,3,0,'Tamil','','pkg_ta-IN','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/ta-IN_details.xml',''),(32,3,0,'Thai','','pkg_th-TH','package','',0,'3.0.2.3','','http://update.joomla.org/language/details3/th-TH_details.xml',''),(33,3,0,'Turkish','','pkg_tr-TR','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/tr-TR_details.xml',''),(34,3,0,'Ukrainian','','pkg_uk-UA','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/uk-UA_details.xml',''),(35,3,0,'Uyghur','','pkg_ug-CN','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/ug-CN_details.xml',''),(36,3,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/pt-BR_details.xml',''),(37,3,0,'Serbian Latin','','pkg_sr-YU','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/sr-YU_details.xml',''),(38,3,0,'Spanish','','pkg_es-ES','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/es-ES_details.xml',''),(39,3,0,'Bosnian','','pkg_bs-BA','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/bs-BA_details.xml',''),(40,3,0,'Serbian Cyrillic','','pkg_sr-RS','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/sr-RS_details.xml',''),(41,3,0,'Vietnamese','','pkg_vi-VN','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/vi-VN_details.xml',''),(42,3,0,'Finnish','','pkg_fi-FI','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/fi-FI_details.xml',''),(43,3,0,'Swahili','','pkg_sw-KE','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/sw-KE_details.xml',''),(45,3,0,'Catalan','','pkg_ca-ES','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/ca-ES_details.xml',''),(46,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(47,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(48,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(49,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(50,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(51,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(52,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(53,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(54,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(55,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(56,3,0,'French','','pkg_fr-FR','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/fr-FR_details.xml',''),(57,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(58,3,0,'Finnish','','pkg_fi-FI','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/fi-FI_details.xml',''),(59,3,0,'French','','pkg_fr-FR','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/fr-FR_details.xml',''),(60,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(61,3,0,'Finnish','','pkg_fi-FI','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/fi-FI_details.xml',''),(63,3,0,'French','','pkg_fr-FR','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/fr-FR_details.xml',''),(64,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(65,3,0,'Finnish','','pkg_fi-FI','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/fi-FI_details.xml',''),(66,3,0,'French','','pkg_fr-FR','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/fr-FR_details.xml',''),(67,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(68,3,0,'Finnish','','pkg_fi-FI','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/fi-FI_details.xml',''),(69,3,0,'French','','pkg_fr-FR','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/fr-FR_details.xml',''),(70,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(71,3,0,'Finnish','','pkg_fi-FI','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/fi-FI_details.xml',''),(72,3,0,'French','','pkg_fr-FR','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/fr-FR_details.xml',''),(73,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(74,3,0,'Finnish','','pkg_fi-FI','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/fi-FI_details.xml',''),(75,3,0,'French','','pkg_fr-FR','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/fr-FR_details.xml',''),(76,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(77,3,0,'Finnish','','pkg_fi-FI','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/fi-FI_details.xml',''),(78,3,0,'French','','pkg_fr-FR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/fr-FR_details.xml',''),(79,3,0,'German','','pkg_de-DE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/de-DE_details.xml',''),(80,3,0,'Arabic Unitag','','pkg_ar-AA','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ar-AA_details.xml',''),(81,3,0,'Catalan','','pkg_ca-ES','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ca-ES_details.xml',''),(82,3,0,'Chinese Simplified','','pkg_zh-CN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/zh-CN_details.xml',''),(83,3,0,'Croatian','','pkg_hr-HR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/hr-HR_details.xml',''),(84,3,0,'Danish','','pkg_da-DK','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/da-DK_details.xml',''),(85,3,0,'Dutch','','pkg_nl-NL','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nl-NL_details.xml',''),(86,3,0,'English AU','','pkg_en-AU','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/en-AU_details.xml',''),(87,3,0,'English US','','pkg_en-US','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/en-US_details.xml',''),(88,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(89,3,0,'Japanese','','pkg_ja-JP','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ja-JP_details.xml',''),(90,3,0,'Korean','','pkg_ko-KR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ko-KR_details.xml',''),(91,3,0,'Latvian','','pkg_lv-LV','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/lv-LV_details.xml',''),(92,3,0,'Macedonian','','pkg_mk-MK','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/mk-MK_details.xml',''),(93,3,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nb-NO_details.xml',''),(94,3,0,'Polish','','pkg_pl-PL','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/pl-PL_details.xml',''),(95,3,0,'Slovak','','pkg_sk-SK','package','',0,'3.0.3.2','','http://update.joomla.org/language/details3/sk-SK_details.xml',''),(96,3,0,'Swedish','','pkg_sv-SE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sv-SE_details.xml',''),(97,3,0,'Tamil','','pkg_ta-IN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ta-IN_details.xml',''),(98,3,0,'Thai','','pkg_th-TH','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/th-TH_details.xml',''),(99,3,0,'Turkish','','pkg_tr-TR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/tr-TR_details.xml',''),(100,3,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/pt-BR_details.xml',''),(101,3,0,'Serbian Latin','','pkg_sr-YU','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sr-YU_details.xml',''),(102,3,0,'Spanish','','pkg_es-ES','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/es-ES_details.xml',''),(103,3,0,'Serbian Cyrillic','','pkg_sr-RS','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sr-RS_details.xml',''),(104,3,0,'Vietnamese','','pkg_vi-VN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/vi-VN_details.xml',''),(105,3,0,'Finnish','','pkg_fi-FI','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/fi-FI_details.xml',''),(106,3,0,'Indonesian','','pkg_id-ID','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/id-ID_details.xml',''),(107,3,0,'Swahili','','pkg_sw-KE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sw-KE_details.xml',''),(108,3,0,'Flemish','','pkg_nl-BE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nl-BE_details.xml',''),(109,3,0,'French','','pkg_fr-FR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/fr-FR_details.xml',''),(110,3,0,'German','','pkg_de-DE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/de-DE_details.xml',''),(111,3,0,'Arabic Unitag','','pkg_ar-AA','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ar-AA_details.xml',''),(112,3,0,'Catalan','','pkg_ca-ES','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ca-ES_details.xml',''),(113,3,0,'Chinese Simplified','','pkg_zh-CN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/zh-CN_details.xml',''),(114,3,0,'Croatian','','pkg_hr-HR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/hr-HR_details.xml',''),(115,3,0,'Danish','','pkg_da-DK','package','',0,'3.0.3.2','','http://update.joomla.org/language/details3/da-DK_details.xml',''),(116,3,0,'Dutch','','pkg_nl-NL','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nl-NL_details.xml',''),(117,3,0,'English AU','','pkg_en-AU','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/en-AU_details.xml',''),(118,3,0,'English US','','pkg_en-US','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/en-US_details.xml',''),(119,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(120,3,0,'Japanese','','pkg_ja-JP','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ja-JP_details.xml',''),(121,3,0,'Korean','','pkg_ko-KR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ko-KR_details.xml',''),(122,3,0,'Latvian','','pkg_lv-LV','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/lv-LV_details.xml',''),(123,3,0,'Macedonian','','pkg_mk-MK','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/mk-MK_details.xml',''),(124,3,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nb-NO_details.xml',''),(125,3,0,'Polish','','pkg_pl-PL','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/pl-PL_details.xml',''),(126,3,0,'Slovak','','pkg_sk-SK','package','',0,'3.0.3.2','','http://update.joomla.org/language/details3/sk-SK_details.xml',''),(127,3,0,'Swedish','','pkg_sv-SE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sv-SE_details.xml',''),(128,3,0,'Tamil','','pkg_ta-IN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ta-IN_details.xml',''),(129,3,0,'Thai','','pkg_th-TH','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/th-TH_details.xml',''),(130,3,0,'Turkish','','pkg_tr-TR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/tr-TR_details.xml',''),(131,3,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/pt-BR_details.xml',''),(132,3,0,'Serbian Latin','','pkg_sr-YU','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sr-YU_details.xml',''),(133,3,0,'Spanish','','pkg_es-ES','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/es-ES_details.xml',''),(134,3,0,'Serbian Cyrillic','','pkg_sr-RS','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sr-RS_details.xml',''),(135,3,0,'Vietnamese','','pkg_vi-VN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/vi-VN_details.xml',''),(136,3,0,'Finnish','','pkg_fi-FI','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/fi-FI_details.xml',''),(137,3,0,'Swahili','','pkg_sw-KE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sw-KE_details.xml',''),(138,3,0,'Flemish','','pkg_nl-BE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nl-BE_details.xml',''),(139,3,0,'French','','pkg_fr-FR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/fr-FR_details.xml',''),(140,3,0,'German','','pkg_de-DE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/de-DE_details.xml',''),(141,3,0,'Arabic Unitag','','pkg_ar-AA','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ar-AA_details.xml',''),(142,3,0,'Catalan','','pkg_ca-ES','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ca-ES_details.xml',''),(143,3,0,'Chinese Simplified','','pkg_zh-CN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/zh-CN_details.xml',''),(144,3,0,'Croatian','','pkg_hr-HR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/hr-HR_details.xml',''),(145,3,0,'Danish','','pkg_da-DK','package','',0,'3.0.3.2','','http://update.joomla.org/language/details3/da-DK_details.xml',''),(146,3,0,'Dutch','','pkg_nl-NL','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nl-NL_details.xml',''),(147,3,0,'English AU','','pkg_en-AU','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/en-AU_details.xml',''),(148,3,0,'English US','','pkg_en-US','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/en-US_details.xml',''),(149,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(150,3,0,'Japanese','','pkg_ja-JP','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ja-JP_details.xml',''),(151,3,0,'Korean','','pkg_ko-KR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ko-KR_details.xml',''),(152,3,0,'Latvian','','pkg_lv-LV','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/lv-LV_details.xml',''),(153,3,0,'Macedonian','','pkg_mk-MK','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/mk-MK_details.xml',''),(154,3,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nb-NO_details.xml',''),(155,3,0,'Polish','','pkg_pl-PL','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/pl-PL_details.xml',''),(156,3,0,'Slovak','','pkg_sk-SK','package','',0,'3.0.3.2','','http://update.joomla.org/language/details3/sk-SK_details.xml',''),(157,3,0,'Swedish','','pkg_sv-SE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sv-SE_details.xml',''),(158,3,0,'Tamil','','pkg_ta-IN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ta-IN_details.xml',''),(159,3,0,'Thai','','pkg_th-TH','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/th-TH_details.xml',''),(160,3,0,'Turkish','','pkg_tr-TR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/tr-TR_details.xml',''),(161,3,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/pt-BR_details.xml',''),(162,3,0,'Serbian Latin','','pkg_sr-YU','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sr-YU_details.xml',''),(163,3,0,'Spanish','','pkg_es-ES','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/es-ES_details.xml',''),(164,3,0,'Serbian Cyrillic','','pkg_sr-RS','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sr-RS_details.xml',''),(165,3,0,'Vietnamese','','pkg_vi-VN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/vi-VN_details.xml',''),(166,3,0,'Finnish','','pkg_fi-FI','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/fi-FI_details.xml',''),(167,3,0,'Swahili','','pkg_sw-KE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sw-KE_details.xml',''),(168,3,0,'Flemish','','pkg_nl-BE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nl-BE_details.xml',''),(169,3,0,'French','','pkg_fr-FR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/fr-FR_details.xml',''),(170,3,0,'German','','pkg_de-DE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/de-DE_details.xml',''),(171,3,0,'Arabic Unitag','','pkg_ar-AA','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ar-AA_details.xml',''),(172,3,0,'Catalan','','pkg_ca-ES','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ca-ES_details.xml',''),(173,3,0,'Chinese Simplified','','pkg_zh-CN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/zh-CN_details.xml',''),(174,3,0,'Croatian','','pkg_hr-HR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/hr-HR_details.xml',''),(175,3,0,'Danish','','pkg_da-DK','package','',0,'3.0.3.2','','http://update.joomla.org/language/details3/da-DK_details.xml',''),(176,3,0,'Dutch','','pkg_nl-NL','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nl-NL_details.xml',''),(177,3,0,'English AU','','pkg_en-AU','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/en-AU_details.xml',''),(178,3,0,'English US','','pkg_en-US','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/en-US_details.xml',''),(179,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(180,3,0,'Japanese','','pkg_ja-JP','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ja-JP_details.xml',''),(181,3,0,'Korean','','pkg_ko-KR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ko-KR_details.xml',''),(182,3,0,'Latvian','','pkg_lv-LV','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/lv-LV_details.xml',''),(183,3,0,'Macedonian','','pkg_mk-MK','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/mk-MK_details.xml',''),(184,3,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nb-NO_details.xml',''),(185,3,0,'Polish','','pkg_pl-PL','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/pl-PL_details.xml',''),(186,3,0,'Slovak','','pkg_sk-SK','package','',0,'3.0.3.2','','http://update.joomla.org/language/details3/sk-SK_details.xml',''),(187,3,0,'Swedish','','pkg_sv-SE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sv-SE_details.xml',''),(188,3,0,'Tamil','','pkg_ta-IN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ta-IN_details.xml',''),(189,3,0,'Thai','','pkg_th-TH','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/th-TH_details.xml',''),(190,3,0,'Turkish','','pkg_tr-TR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/tr-TR_details.xml',''),(191,3,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/pt-BR_details.xml',''),(192,3,0,'Serbian Latin','','pkg_sr-YU','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sr-YU_details.xml',''),(193,3,0,'Spanish','','pkg_es-ES','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/es-ES_details.xml',''),(194,3,0,'Serbian Cyrillic','','pkg_sr-RS','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sr-RS_details.xml',''),(195,3,0,'Vietnamese','','pkg_vi-VN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/vi-VN_details.xml',''),(196,3,0,'Finnish','','pkg_fi-FI','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/fi-FI_details.xml',''),(197,3,0,'Swahili','','pkg_sw-KE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sw-KE_details.xml',''),(198,3,0,'Flemish','','pkg_nl-BE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nl-BE_details.xml',''),(199,3,0,'French','','pkg_fr-FR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/fr-FR_details.xml',''),(200,3,0,'German','','pkg_de-DE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/de-DE_details.xml',''),(201,3,0,'Arabic Unitag','','pkg_ar-AA','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ar-AA_details.xml',''),(202,3,0,'Catalan','','pkg_ca-ES','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ca-ES_details.xml',''),(203,3,0,'Chinese Simplified','','pkg_zh-CN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/zh-CN_details.xml',''),(204,3,0,'Croatian','','pkg_hr-HR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/hr-HR_details.xml',''),(205,3,0,'Danish','','pkg_da-DK','package','',0,'3.0.3.2','','http://update.joomla.org/language/details3/da-DK_details.xml',''),(206,3,0,'Dutch','','pkg_nl-NL','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nl-NL_details.xml',''),(207,3,0,'English AU','','pkg_en-AU','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/en-AU_details.xml',''),(208,3,0,'English US','','pkg_en-US','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/en-US_details.xml',''),(209,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(210,3,0,'Japanese','','pkg_ja-JP','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ja-JP_details.xml',''),(211,3,0,'Korean','','pkg_ko-KR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ko-KR_details.xml',''),(212,3,0,'Latvian','','pkg_lv-LV','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/lv-LV_details.xml',''),(213,3,0,'Macedonian','','pkg_mk-MK','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/mk-MK_details.xml',''),(214,3,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nb-NO_details.xml',''),(215,3,0,'Polish','','pkg_pl-PL','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/pl-PL_details.xml',''),(216,3,0,'Slovak','','pkg_sk-SK','package','',0,'3.0.3.2','','http://update.joomla.org/language/details3/sk-SK_details.xml',''),(217,3,0,'Swedish','','pkg_sv-SE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sv-SE_details.xml',''),(218,3,0,'Tamil','','pkg_ta-IN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ta-IN_details.xml',''),(219,3,0,'Thai','','pkg_th-TH','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/th-TH_details.xml',''),(220,3,0,'Turkish','','pkg_tr-TR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/tr-TR_details.xml',''),(221,3,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/pt-BR_details.xml',''),(222,3,0,'Serbian Latin','','pkg_sr-YU','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sr-YU_details.xml',''),(223,3,0,'Spanish','','pkg_es-ES','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/es-ES_details.xml',''),(224,3,0,'Serbian Cyrillic','','pkg_sr-RS','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sr-RS_details.xml',''),(225,3,0,'Vietnamese','','pkg_vi-VN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/vi-VN_details.xml',''),(226,3,0,'Finnish','','pkg_fi-FI','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/fi-FI_details.xml',''),(227,3,0,'Swahili','','pkg_sw-KE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sw-KE_details.xml',''),(228,3,0,'Flemish','','pkg_nl-BE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nl-BE_details.xml',''),(229,3,0,'French','','pkg_fr-FR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/fr-FR_details.xml',''),(230,3,0,'German','','pkg_de-DE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/de-DE_details.xml',''),(231,3,0,'Arabic Unitag','','pkg_ar-AA','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ar-AA_details.xml',''),(232,3,0,'Catalan','','pkg_ca-ES','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ca-ES_details.xml',''),(233,3,0,'Chinese Simplified','','pkg_zh-CN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/zh-CN_details.xml',''),(234,3,0,'Croatian','','pkg_hr-HR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/hr-HR_details.xml',''),(235,3,0,'Danish','','pkg_da-DK','package','',0,'3.0.3.2','','http://update.joomla.org/language/details3/da-DK_details.xml',''),(236,3,0,'Dutch','','pkg_nl-NL','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nl-NL_details.xml',''),(237,3,0,'English AU','','pkg_en-AU','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/en-AU_details.xml',''),(238,3,0,'English US','','pkg_en-US','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/en-US_details.xml',''),(239,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(240,3,0,'Japanese','','pkg_ja-JP','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ja-JP_details.xml',''),(241,3,0,'Korean','','pkg_ko-KR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ko-KR_details.xml',''),(242,3,0,'Latvian','','pkg_lv-LV','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/lv-LV_details.xml',''),(243,3,0,'Macedonian','','pkg_mk-MK','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/mk-MK_details.xml',''),(244,3,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nb-NO_details.xml',''),(245,3,0,'Polish','','pkg_pl-PL','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/pl-PL_details.xml',''),(246,3,0,'Slovak','','pkg_sk-SK','package','',0,'3.0.3.2','','http://update.joomla.org/language/details3/sk-SK_details.xml',''),(247,3,0,'Swedish','','pkg_sv-SE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sv-SE_details.xml',''),(248,3,0,'Syriac','','pkg_sy-IQ','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sy-IQ_details.xml',''),(249,3,0,'Tamil','','pkg_ta-IN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ta-IN_details.xml',''),(250,3,0,'Thai','','pkg_th-TH','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/th-TH_details.xml',''),(251,3,0,'Turkish','','pkg_tr-TR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/tr-TR_details.xml',''),(252,3,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/pt-BR_details.xml',''),(253,3,0,'Serbian Latin','','pkg_sr-YU','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sr-YU_details.xml',''),(254,3,0,'Spanish','','pkg_es-ES','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/es-ES_details.xml',''),(255,3,0,'Serbian Cyrillic','','pkg_sr-RS','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sr-RS_details.xml',''),(256,3,0,'Vietnamese','','pkg_vi-VN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/vi-VN_details.xml',''),(257,3,0,'Finnish','','pkg_fi-FI','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/fi-FI_details.xml',''),(258,3,0,'Swahili','','pkg_sw-KE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sw-KE_details.xml',''),(260,3,0,'Flemish','','pkg_nl-BE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nl-BE_details.xml',''),(261,3,0,'French','','pkg_fr-FR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/fr-FR_details.xml',''),(262,3,0,'German','','pkg_de-DE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/de-DE_details.xml',''),(263,3,0,'Afrikaans','','pkg_af-ZA','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/af-ZA_details.xml',''),(264,3,0,'Arabic Unitag','','pkg_ar-AA','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ar-AA_details.xml',''),(265,3,0,'Catalan','','pkg_ca-ES','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ca-ES_details.xml',''),(266,3,0,'Chinese Simplified','','pkg_zh-CN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/zh-CN_details.xml',''),(267,3,0,'Croatian','','pkg_hr-HR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/hr-HR_details.xml',''),(268,3,0,'Danish','','pkg_da-DK','package','',0,'3.0.3.2','','http://update.joomla.org/language/details3/da-DK_details.xml',''),(269,3,0,'Dutch','','pkg_nl-NL','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nl-NL_details.xml',''),(270,3,0,'English AU','','pkg_en-AU','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/en-AU_details.xml',''),(271,3,0,'English US','','pkg_en-US','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/en-US_details.xml',''),(272,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(273,3,0,'Japanese','','pkg_ja-JP','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ja-JP_details.xml',''),(274,3,0,'Korean','','pkg_ko-KR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ko-KR_details.xml',''),(275,3,0,'Latvian','','pkg_lv-LV','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/lv-LV_details.xml',''),(276,3,0,'Macedonian','','pkg_mk-MK','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/mk-MK_details.xml',''),(277,3,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nb-NO_details.xml',''),(278,3,0,'Polish','','pkg_pl-PL','package','',0,'3.0.3.2','','http://update.joomla.org/language/details3/pl-PL_details.xml',''),(279,3,0,'Slovak','','pkg_sk-SK','package','',0,'3.0.3.2','','http://update.joomla.org/language/details3/sk-SK_details.xml',''),(280,3,0,'Swedish','','pkg_sv-SE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sv-SE_details.xml',''),(281,3,0,'Syriac','','pkg_sy-IQ','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sy-IQ_details.xml',''),(282,3,0,'Tamil','','pkg_ta-IN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ta-IN_details.xml',''),(283,3,0,'Thai','','pkg_th-TH','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/th-TH_details.xml',''),(284,3,0,'Turkish','','pkg_tr-TR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/tr-TR_details.xml',''),(285,3,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/pt-BR_details.xml',''),(286,3,0,'Serbian Latin','','pkg_sr-YU','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sr-YU_details.xml',''),(287,3,0,'Spanish','','pkg_es-ES','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/es-ES_details.xml',''),(288,3,0,'Serbian Cyrillic','','pkg_sr-RS','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sr-RS_details.xml',''),(289,3,0,'Vietnamese','','pkg_vi-VN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/vi-VN_details.xml',''),(290,3,0,'Finnish','','pkg_fi-FI','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/fi-FI_details.xml',''),(291,3,0,'Swahili','','pkg_sw-KE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sw-KE_details.xml',''),(293,3,0,'Flemish','','pkg_nl-BE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nl-BE_details.xml',''),(294,3,0,'French','','pkg_fr-FR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/fr-FR_details.xml',''),(295,3,0,'German','','pkg_de-DE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/de-DE_details.xml',''),(296,3,0,'Arabic Unitag','','pkg_ar-AA','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ar-AA_details.xml',''),(297,3,0,'Catalan','','pkg_ca-ES','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ca-ES_details.xml',''),(298,3,0,'Chinese Simplified','','pkg_zh-CN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/zh-CN_details.xml',''),(299,3,0,'Croatian','','pkg_hr-HR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/hr-HR_details.xml',''),(300,3,0,'Danish','','pkg_da-DK','package','',0,'3.0.3.2','','http://update.joomla.org/language/details3/da-DK_details.xml',''),(301,3,0,'Dutch','','pkg_nl-NL','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nl-NL_details.xml',''),(302,3,0,'English AU','','pkg_en-AU','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/en-AU_details.xml',''),(303,3,0,'English US','','pkg_en-US','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/en-US_details.xml',''),(304,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(305,3,0,'Japanese','','pkg_ja-JP','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ja-JP_details.xml',''),(306,3,0,'Korean','','pkg_ko-KR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ko-KR_details.xml',''),(307,3,0,'Latvian','','pkg_lv-LV','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/lv-LV_details.xml',''),(308,3,0,'Macedonian','','pkg_mk-MK','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/mk-MK_details.xml',''),(309,3,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nb-NO_details.xml',''),(310,3,0,'Persian','','pkg_fa-IR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/fa-IR_details.xml',''),(311,3,0,'Polish','','pkg_pl-PL','package','',0,'3.0.3.2','','http://update.joomla.org/language/details3/pl-PL_details.xml',''),(312,3,0,'Slovak','','pkg_sk-SK','package','',0,'3.0.3.2','','http://update.joomla.org/language/details3/sk-SK_details.xml',''),(313,3,0,'Swedish','','pkg_sv-SE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sv-SE_details.xml',''),(314,3,0,'Syriac','','pkg_sy-IQ','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sy-IQ_details.xml',''),(315,3,0,'Tamil','','pkg_ta-IN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ta-IN_details.xml',''),(316,3,0,'Thai','','pkg_th-TH','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/th-TH_details.xml',''),(317,3,0,'Turkish','','pkg_tr-TR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/tr-TR_details.xml',''),(318,3,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/pt-BR_details.xml',''),(319,3,0,'Serbian Latin','','pkg_sr-YU','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sr-YU_details.xml',''),(320,3,0,'Spanish','','pkg_es-ES','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/es-ES_details.xml',''),(321,3,0,'Serbian Cyrillic','','pkg_sr-RS','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sr-RS_details.xml',''),(322,3,0,'Vietnamese','','pkg_vi-VN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/vi-VN_details.xml',''),(323,3,0,'Finnish','','pkg_fi-FI','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/fi-FI_details.xml',''),(324,3,0,'Swahili','','pkg_sw-KE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sw-KE_details.xml','');


--
-- Table structure for table `#__user_notes`
--



CREATE TABLE `#__user_notes` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(100) NOT NULL DEFAULT '',
  `body` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL,
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `review_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`),
  KEY `idx_category_id` (`catid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__user_notes`
--




--
-- Table structure for table `#__user_profiles`
--



CREATE TABLE `#__user_profiles` (
  `user_id` int(11) NOT NULL,
  `profile_key` varchar(100) NOT NULL,
  `profile_value` varchar(255) NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  UNIQUE KEY `idx_user_id_profile_key` (`user_id`,`profile_key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Simple user profile storage table';


--
-- Dumping data for table `#__user_profiles`
--




--
-- Table structure for table `#__user_usergroup_map`
--



CREATE TABLE `#__user_usergroup_map` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to #__users.id',
  `group_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to #__usergroups.id',
  PRIMARY KEY (`user_id`,`group_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__user_usergroup_map`
--


INSERT INTO `#__user_usergroup_map` (`user_id`, `group_id`) VALUES (381,8),(572,8);


--
-- Table structure for table `#__usergroups`
--



CREATE TABLE `#__usergroups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Adjacency List Reference Id',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `title` varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_usergroup_parent_title_lookup` (`parent_id`,`title`),
  KEY `idx_usergroup_title_lookup` (`title`),
  KEY `idx_usergroup_adjacency_lookup` (`parent_id`),
  KEY `idx_usergroup_nested_set_lookup`  USING BTREE (`lft`,`rgt`) 
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__usergroups`
--


INSERT INTO `#__usergroups` (`id`, `parent_id`, `lft`, `rgt`, `title`) VALUES (1,0,1,18,'Public'),(2,1,8,15,'Registered'),(3,2,9,14,'Author'),(4,3,10,13,'Editor'),(5,4,11,12,'Publisher'),(6,1,4,7,'Manager'),(7,6,5,6,'Administrator'),(8,1,16,17,'Super Users'),(9,1,2,3,'Guest');


--
-- Table structure for table `#__users`
--



CREATE TABLE `#__users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `username` varchar(150) NOT NULL DEFAULT '',
  `email` varchar(100) NOT NULL DEFAULT '',
  `password` varchar(100) NOT NULL DEFAULT '',
  `block` tinyint(4) NOT NULL DEFAULT '0',
  `sendEmail` tinyint(4) DEFAULT '0',
  `registerDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `lastvisitDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `activation` varchar(100) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `lastResetTime` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Date of last password reset',
  `resetCount` int(11) NOT NULL DEFAULT '0' COMMENT 'Count of password resets since lastResetTime',
  PRIMARY KEY (`id`),
  KEY `idx_name` (`name`),
  KEY `idx_block` (`block`),
  KEY `username` (`username`),
  KEY `email` (`email`)
) ENGINE=InnoDB AUTO_INCREMENT=573 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__users`
--


INSERT INTO `#__users` (`id`, `name`, `username`, `email`, `password`, `block`, `sendEmail`, `registerDate`, `lastvisitDate`, `activation`, `params`, `lastResetTime`, `resetCount`) VALUES (572,'Super User','gkadmin','blank@gavick.com','34b7de1335b5f65cd4a39eb692b0ed3e:nFqmnKPkzp0Pg1K25pW7MamTb41SpqNi',0,1,'2012-12-31 10:56:25','2013-02-12 11:26:55','0','','0000-00-00 00:00:00',0);


--
-- Table structure for table `#__viewlevels`
--



CREATE TABLE `#__viewlevels` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `title` varchar(100) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_assetgroup_title_lookup` (`title`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__viewlevels`
--


INSERT INTO `#__viewlevels` (`id`, `title`, `ordering`, `rules`) VALUES (1,'Public',0,'[1]'),(2,'Registered',1,'[6,2,8]'),(3,'Special',2,'[6,3,8]'),(5,'Guest',0,'[9]');


--
-- Table structure for table `#__weblinks`
--



CREATE TABLE `#__weblinks` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `hits` int(11) NOT NULL DEFAULT '0',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `images` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__weblinks`
--


INSERT INTO `#__weblinks` (`id`, `catid`, `title`, `alias`, `url`, `description`, `hits`, `state`, `checked_out`, `checked_out_time`, `ordering`, `access`, `params`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`, `version`, `images`) VALUES (1,14,'GavickPro Demo','gavickpro-demo','http://demo.gavick.com','',0,1,0,'0000-00-00 00:00:00',1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2012-11-06 11:29:52',381,'','0000-00-00 00:00:00',0,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'{\"image_first\":\"\",\"float_first\":\"\",\"image_first_alt\":\"\",\"image_first_caption\":\"\",\"image_second\":\"\",\"float_second\":\"\",\"image_second_alt\":\"\",\"image_second_caption\":\"\"}'),(2,14,'GavickPro Facebook','gavickpro-facebook','http://www.facebook.com/gavickpro','',0,1,0,'0000-00-00 00:00:00',2,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2012-11-06 11:30:11',381,'','0000-00-00 00:00:00',0,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'{\"image_first\":\"\",\"float_first\":\"\",\"image_first_alt\":\"\",\"image_first_caption\":\"\",\"image_second\":\"\",\"float_second\":\"\",\"image_second_alt\":\"\",\"image_second_caption\":\"\"}'),(3,14,'GavickPro Homepage','gavickpro-homepage','http://www.gavick.com','',0,1,0,'0000-00-00 00:00:00',3,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2012-11-06 11:30:28',381,'','0000-00-00 00:00:00',0,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'{\"image_first\":\"\",\"float_first\":\"\",\"image_first_alt\":\"\",\"image_first_caption\":\"\",\"image_second\":\"\",\"float_second\":\"\",\"image_second_alt\":\"\",\"image_second_caption\":\"\"}'),(4,14,'GavickPro Magazine','gavickpro-magazine','http://www.gavickmagazine.com','',0,1,0,'0000-00-00 00:00:00',4,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2012-11-06 11:30:44',381,'','0000-00-00 00:00:00',0,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'{\"image_first\":\"\",\"float_first\":\"\",\"image_first_alt\":\"\",\"image_first_caption\":\"\",\"image_second\":\"\",\"float_second\":\"\",\"image_second_alt\":\"\",\"image_second_caption\":\"\"}'),(5,14,'GavickPro RSS & News','gavickpro-rss-news','http://www.gavickmagazine.com/index.php?format=feed&type=rss','',0,1,0,'0000-00-00 00:00:00',5,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2012-11-06 11:30:59',381,'','0000-00-00 00:00:00',0,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'{\"image_first\":\"\",\"float_first\":\"\",\"image_first_alt\":\"\",\"image_first_caption\":\"\",\"image_second\":\"\",\"float_second\":\"\",\"image_second_alt\":\"\",\"image_second_caption\":\"\"}');











-- Dump completed on 2013-02-12 13:18:28
UPDATE `#__users` SET block=1 WHERE block=0
